import { OrgServerEditions, TestAPPHeadRevision } from "../../app/type-definitions/org/org.types";

/**服务端接口地址配置 */
export declare const webApi: {
    /**
     * 是否内网
     */
    isLan: boolean;
    _businessUrl: string;
    /**
     * 业务库api
     * @type {string}
     */
    businessUrl: string;
    manuallyConfBusinessUrl: string;
    
    _apiNetType: number;
    APINetType: number;
    manuallyConfAPINetType: number;
    /**
     *获取机构列表api
     *
     * @type {string}
     */
    orgListUrl: string
    /**
     * 获取医院的大中心api
     *
     * @type {string}
     */
    hospitalOrgUrl: string
    _hospitalOrgUrl: string
    /**
     * 影像文件服务api
     * @type {string}
     */
    pacsUrl: string
    /**
     * orthanc影像下载服务
     * @type {string}
     */
    orthancUrl: string
    /**
     * 同屏服务器端
     * 
     * @type {string}
     */
    syncConsultationServer: string;
    /**
     * 影像文本分析api
     * @type {string}
     */
    pacsAnalyzeUrl: string;
    /**
     * 视频服务地址（deprecated，请使用videoServerUrls）
     *
     * @type {string}
     */
    //videoServerUrl: string;
    /**
     * 视频服务地址列表
     *
     * @type {string}
     */
     videoServerUrls: string[];

     /**
      * 视频ServiceId
      *
      * @type {string}
      */
     videoServiceId: string;
    /**
      * 视频ServiceKey
      *
      * @type {string}
      */
     videoServiceKey: string;
     /**
     * 视频服务地址
     * 
     * @type {string}
     */
    videoServerUrl: string;
    /**
     * 视频服务地址
     * 
     * @type {string}
     */
    videoServerUrl_LAN: string;
     /**
     * 视频服务地址
     * 
     * @type {string}
     */
    videoServerUrl_private: string;
    /**
    * mqtt服务器ip
    * 
    * @type {string}
    */
    notifyServer: string;
    /**
     * 挖掘分析地址
     * 
     * @type {string}
     */
    aiUrl: string;
    /**
     * 随访二维码地址
     *
     * @type {string}
     */
    followUpQRcodeUrl: string;
    /**
     *二维码地址
     *
     * @type {string}
     */
    twoDimensionCodeUrl: string;
    /**
     * 是否使用TLS连接通知服务
     * 
     * @type {boolean}
     */
    notifyIsEncrypt: boolean;
    /**
     * 通知服务端口号
     * 
     * @type {number}
     */
    notifyPort: number;

    /**
     *演示orgid
     *
     * @type {*}
     */
    demoOrgId: any;

    /**
     *演示orgcode
     *
     * @type {string}
     */
    demoOrgCode: string;

    /**
     *演示机构名称
     *
     * @type {string}
     */
    demoOrgName: string;

    /**
     *项目id
     *
     * @type {number}
     */
    projectId: number;
    /**
     *是否是旧版同屏
     *
     * @type {boolean}
     */
    // originalScreen:boolean,
    BaiHuiPlatformOAuthHost: string; // 百惠APP单点登录code的获取域名
    // ssHospitalPlatformOAuthHost: string; // 深汕APP单点登录
    qywxUrl: string;  // 项目默认业务api,一般用于企业微信等
    qywxUrlProjectId: string; // 项目默认业务api所属项目id
    qywxUrlProjectMasterOrgCode: string; // 项目默认业务api所属项目主机构代码
    /**
     * 随访api
     * @type {string}
     */
    followApiUrl: string;
    /**
     * 微信OAuth返回code的重定向域名
     *
     * @type {string}
     */
    wxOAuthCodeRedirectHost: string;
    /**最大视频数 */
    MaxNumOfVideos:number;
    /**视频单张模式 */
    IsSingleSheetModel:boolean;
    testAPPHotUpdateServerHost: string; // 测试app选用的热更新服务地址
}

/**界面入口配置 */
export declare const entrance: {
    /**
     * 影像文本分析入口是否开启
     * @type {boolean}
     */
    pacsAnalyze: boolean,

    /**
     * 影像脱敏是否开启
     * @type {boolean}
     */
    pacsDesensitize: boolean,
    /**
     * 影像加载的最低质量，默认为low,medium,high
     * @type strin
     */
    pacsInitQuality: string,
}


/**关于本项目 */
export declare const about: {
    /**
     * app版本号
     * @type {string}
     */
    version: string
    /**
     * app知识产权所有公司名称
     * @type {string}
     */
    companyName: string
    proName: string
    /**
    * 公司logo
    * @type {string}
    */
    companyLogo: string
    /**
     * 公司描述
     * @type {string}
     */
    companyDesc: string
    /**
     * 公司官网地址
     * @type {string}
     */
    officialWebsite: string
    /**
    * 技术支持
    * @type {string}
    */
    technicalSupport: string
    
    /**
     *版本设置
     *
     * @type {OrgServerEditions}
     */
    apiEdition: OrgServerEditions;

    testAppMode: TestAPPMode;
    testAPPHotUpdateServer: TestAPPHotUpdateServer;
    testAPPHeadRevision: TestAPPHeadRevision; // 最新版本
    testAPPSubVersion: string; // app小版本号
    curUnionLogo: string; // 机构所属联盟的logo
    curUnionName: string; // 机构所属联盟的名字
    curRelatedUnionOrgId: number; // 与联盟相关的机构id
    prodLogo: string; // 产品logo
    isTestApp: boolean; // 是否测试app
    SHOW_SERVER_CONF_ENTRY: boolean;
    isReleaseIMApp: boolean;
}

export declare const setWebApi: ( apiEdition: OrgServerEditions ) => any;

export declare const setTestAPPHotUpdateServer: ( testAPPHotUpdateServer: TestAPPHotUpdateServer ) => any;
export declare const setTestAPPHeadRevision: ( testAPPHeadRevision: TestAPPHeadRevision ) => any;
export declare const setTestAPPSubVersion: ( testAPPSubVersion: string ) => any;
export declare const setTestAppMode: ( testAppMode: string ) => any;

/**
 * 医院大中心api列表
 */
export declare const getHospitalCenterUrlList: () => any[];

/**
 * 获取api流量加密配置
 */
export declare const getEncrypeConfig: () => void;