// import * as envVars from '../../../environment/common.env.json';
var envVars = require('../../../environment/common.env.json');
var serveConf = require('../CMC.config.json');
import { FetchConfigUtils } from "../js-umd/utils.fetch-config/fetch-config";
import { OrgConfig } from '../../../src/app/type-definitions/global/org-config.types'
import { securityService } from '../../../src/app/providers/security/security.service.ts';

// console.log('FetchConfigUtils:', FetchConfigUtils);
var securitySrv = new securityService();

var CMCconfig={
    "webApi": {
        "master": {
            "qywxUrl": serveConf.webApi.master.qywxUrl,
            "qywxUrlProjectId": serveConf.webApi.master.qywxUrlProjectId,
            "qywxUrlProjectMasterOrgCode": serveConf.webApi.master.qywxUrlProjectMasterOrgCode,
            "orgListUrl": serveConf.webApi.master.centerServeAddr,
            // "ssHospitalPlatformOAuthHost": serveConf.webApi.master.ssHospitalPlatformOAuthHost,
            "BaiHuiPlatformOAuthHost": serveConf.webApi.master.BaiHuiPlatformOAuthHost,
            "followApiUrl": serveConf.webApi.master.followApiUrl,
            "wxOAuthCodeRedirectHost": serveConf.webApi.master.wxOAuthCodeRedirectHost,
            "testAPPHotUpdateServerHost":  serveConf.webApi.master.testAPPHotUpdateServerHost,
            "hospitalOrgUrl": "",
        },
        "test": {
            "orgListUrl": serveConf.webApi.test.centerServeAddr,
            "testAPPHotUpdateServerHost": serveConf.webApi.test.testAPPHotUpdateServerHost,
        },
        "dev": {
            "orgListUrl": serveConf.webApi.dev.centerServeAddr,
        },
        "videoServerUrl":"",
        // "videoControlsocketServerUrl":"",
        "syncConsultationServer":"",
        "pacsAnalyzeUrl":"",
        "notifyServer":"",
        "notifyPort":"",
        "notifyIsEncrypt":""
    },
    "entrance": {
        "pacsAnalyze": true,
        "pacsInitQuality":"low"
    },
    "about": {
        "version": envVars.mainVersion,  // NOTE: 请不要写死此处的版本号，这里在编译时会读取配置自动替换
        "apiEdition": 'master', // envVars.isDebug ? "test" : 'master',
        "companyName": "云医创想",
        "proName": "创想医生",
        "companyLogo": "assets/imgs/logo.png",
        "companyDesc": "",
        "officialWebsite": "https://www.yunyi.pro",
        "technicalSupport": "@提供技术支持",
        testAppMode: localStorage.getItem('__testAppMode') || '',
        testAPPHotUpdateServer: 'master',
        testAPPHotUpdateChannel: '',
        testAPPSubVersion: '',
        "prodLogo": "assets/images/logos/logo20200924.png",
        isTestApp: envVars.isDebug,
        SHOW_SERVER_CONF_ENTRY: navigator.userAgent.indexOf('SHOW_SERVER_CONF_ENTRY') > -1,
        isReleaseIMApp: navigator.userAgent.indexOf('buildRelease') > -1,
    }
}
var apiEdition = CMCconfig.about.apiEdition;
export var webApi = Object.assign({}, CMCconfig.webApi[apiEdition]);
export var about = CMCconfig.about;
export var entrance = CMCconfig.entrance;

export var setWebApi = function ( apiEdition ) {
    var envConfs = CMCconfig.webApi[apiEdition];
    
    if( envConfs ) {
        var keyNames = Object.keys( envConfs  );
        
        for( var keyIndex in keyNames ) {
            var keyName = keyNames[ keyIndex ];

            webApi[ keyName ] = envConfs[ keyName ];  // NOTE 主要配置: orgListUrl
        }

        about.apiEdition = apiEdition;

        localStorage.setItem('__apiEdition', apiEdition);
        console.log('setWebApi:', webApi);
    }
}

export var setTestAPPHeadRevision = function ( testAPPHeadRevision ) {
    about.testAPPHeadRevision = testAPPHeadRevision;
    localStorage.setItem('__testAPPHeadRevision', testAPPHeadRevision);
}

export var setTestAPPHotUpdateServer = function ( testAPPHotUpdateServer ) {
    about.testAPPHotUpdateServer = testAPPHotUpdateServer;
    var envConfs = CMCconfig.webApi[about.testAPPHotUpdateServer];

    if( envConfs ) {
        window.codePush_ConfServerHost = envConfs.testAPPHotUpdateServerHost;
        webApi.testAPPHotUpdateServerHost =  window.codePush_ConfServerHost;
    }
   
    localStorage.setItem('__testAPPHotUpdateServer', testAPPHotUpdateServer);
}

export var setTestAPPSubVersion = function ( testAPPSubVersion ) {
    about.testAPPSubVersion = testAPPSubVersion;
    localStorage.setItem('__testAPPSubVersion', testAPPSubVersion);
}

export var setTestAppMode= function ( testAppMode) {
  about.testAppMode = testAppMode;
  localStorage.setItem('__testAppMode', testAppMode);
}

function setSmartApi() {

    webApi._businessUrl = webApi.businessUrl || webApi._businessUrl;
    Object.defineProperty(webApi, 'businessUrl', {
        get: function () {
            if( this.manuallyConfBusinessUrl ) {
                return this.manuallyConfBusinessUrl;
            }
            return this._businessUrl;
        },
        set: function (val) {
            this._businessUrl = val;
        }
    });

    webApi._apiNetType = webApi.APINetType;
    Object.defineProperty(webApi, 'APINetType', {
        get: function () {  // 1内网
            if( this.manuallyConfBusinessUrl && this.manuallyConfAPINetType !== undefined ) {
                return this.manuallyConfAPINetType;
            }
            return this._apiNetType;
        },
        set: function (val) {
            this._apiNetType = val;
        }
    })

    Object.defineProperty(webApi, 'isLan', {
        get: function () {  // 1内网
            return this.APINetType == 1;
        },
        set: function (val) {
        }
    })

    webApi._orgListUrl = webApi.orgListUrl;
    Object.defineProperty(webApi, 'orgListUrl', {
        get: function () {  // NOTE: webapp运行时再确定
            fetchCMCConfig();
            return this._orgListUrl;  // NOTE: 且不需要通过缓存进行恢复
        },
        set: function (val) {
            this._orgListUrl = val;
        }
    })

    webApi._hospitalOrgUrl = webApi.hospitalOrgUrl;
    Object.defineProperty(webApi, 'hospitalOrgUrl', {
      get: function () {  // NOTE: webapp运行时再确定
        return this._hospitalOrgUrl || this.orgListUrl;
      },
      set: function (val) {
        this._hospitalOrgUrl = val;
      }
    })
    console.log( 'setSmartApi', webApi );
}

function dec(encryptedText, needEnc) {
    if (!encryptedText || !needEnc) {
        return encryptedText;
    }
   return atob(atob(atob(encryptedText))) 
}

var deployEnvServeConf;
function fetchCMCConfig() {
    if( typeof cordova === "undefined" && !deployEnvServeConf ) {  // NOTE: webapp环境，获取取部署环境的配置；app端在登录页进行手动切换
        deployEnvServeConf = FetchConfigUtils.getCMCConfig();
            
        if( deployEnvServeConf ) {
            var encrypted = deployEnvServeConf.encrypted;
            webApi.qywxUrl = dec(deployEnvServeConf.webApi.master.qywxUrl, encrypted) || webApi.qywxUrl;
            webApi.qywxUrlProjectId = dec(deployEnvServeConf.webApi.master.qywxUrlProjectId, encrypted) || webApi.qywxUrlProjectId;
            webApi.qywxUrlProjectMasterOrgCode = dec(deployEnvServeConf.webApi.master.qywxUrlProjectMasterOrgCode, encrypted) || webApi.qywxUrlProjectMasterOrgCode;
            webApi.orgListUrl = dec(deployEnvServeConf.webApi.master.centerServeAddr, encrypted) || webApi.orgListUrl;
            webApi.BaiHuiPlatformOAuthHost = dec(deployEnvServeConf.webApi.master.BaiHuiPlatformOAuthHost, encrypted) || webApi.BaiHuiPlatformOAuthHost;
            webApi.followApiUrl = dec(deployEnvServeConf.webApi.master.followApiUrl, encrypted) || webApi.followApiUrl;
            webApi.wxOAuthCodeRedirectHost = dec(deployEnvServeConf.webApi.master.wxOAuthCodeRedirectHost, encrypted) || webApi.wxOAuthCodeRedirectHost;
            console.log('服务端配置大中心地址为：', webApi.orgListUrl );
        } else{
            console.error('FetchConfigUtils.getCMCConfig fail');
        }
    }
}

function base64ToArrayBuffer(base64) {
  var binary_string = window.atob(base64);
  var len = binary_string.length;
  var bytes = new Uint8Array(len);
  for (var i = 0; i < len; i++)        {
      bytes[i] = binary_string.charCodeAt(i);
  }
  return bytes.buffer;
}

export var getEncrypeConfig = async function () {
  let apiServeAddr = webApi.businessUrl;
  if(!apiServeAddr) {
    apiServeAddr = localStorage.getItem("businessUrl_temp"); // 服务配置成功缓存的API
  }
  let configStr = await FetchConfigUtils.getEncrypeConfig(apiServeAddr);
  let encrypeConfig = securitySrv.decryptByAes(base64ToArrayBuffer(configStr));
  if(typeof encrypeConfig == 'string') {
    try {
      encrypeConfig = JSON.parse(encrypeConfig)
    } catch (error) {
      console.error("getEncrypeConfig catch: ", error);
    }
  }
  if(encrypeConfig['errcode'] == "SUCCESS") {
    OrgConfig.enableApiGlobalFlowEncrypt = encrypeConfig['data'];
    console.log("getEncrypeConfig: ", OrgConfig.enableApiGlobalFlowEncrypt);
  }
}

// NOTE: 设置自动选择配置字段
setSmartApi();

fetchCMCConfig(); // NOTE: 首次检查是否需要请求

getEncrypeConfig();

// NOTE: 切换测试大中心的选择记忆功能
if( envVars.isDebug || about.SHOW_SERVER_CONF_ENTRY || about.testAppMode == '1' ) {
  about.SHOW_SERVER_CONF_ENTRY = true;
    var __apiEdition = localStorage.getItem('__apiEdition');

    if( __apiEdition ) {
        setWebApi( __apiEdition );
    }

    var __testAPPHeadRevision = localStorage.getItem('__testAPPHeadRevision');

    if( __testAPPHeadRevision ) {
        setTestAPPHeadRevision( __testAPPHeadRevision );
    }

    var __testAPPHotUpdateServer = localStorage.getItem('__testAPPHotUpdateServer');

    if( __testAPPHotUpdateServer ) {
        setTestAPPHotUpdateServer( __testAPPHotUpdateServer );
    }

    var __testAPPSubVersion = localStorage.getItem('__testAPPSubVersion');

    if( __testAPPSubVersion ) {
        setTestAPPSubVersion( __testAPPSubVersion );
    }
    
}

export var getHospitalCenterUrlList = function () {
  return [
    {
        ApiUrl:"https://hn1dzlfsz8gyy.anti-cancer.com.cn:9443/", // 河南省肿瘤大中心地址
        businessUrl: "https://hn1dzlfsz8gyy.anti-cancer.com.cn:9443/consultationapi/",  // 河南省肿瘤业务api地址
    },
  ]
}

