importScripts('pako_inflate.min.js');

function getPixelDataDeflate(image) {
    // Decompresses the base64 buffer that was compressed with Deflate
    var s = pako.inflate(atob(image.Orthanc.PixelData));
    var pixels = null;

    if (image.color) {
        var buf = new ArrayBuffer(s.length / 3 * 4); // RGB32
        pixels = new Uint8Array(buf);
        var index = 0;
        for (var i = 0, length = s.length; i < length; i += 3) {
            pixels[index++] = s[i];
            pixels[index++] = s[i + 1];
            pixels[index++] = s[i + 2];
            pixels[index++] = 255;  // Alpha channel
        }
    } else {
        var buf = new ArrayBuffer(s.length * 2); // uint16_t or int16_t

        if (image.Orthanc.IsSigned) {
            pixels = new Int16Array(buf);
        } else {
            pixels = new Uint16Array(buf);
        }

        var index = 0;
        for (var i = 0, length = s.length; i < length; i += 2) {
            var lower = s[i];
            var upper = s[i + 1];
            pixels[index] = lower + upper * 256;
            index++;
        }
    }

    image.inflated = true
    return image.Orthanc.PixelData = pixels;
}

onmessage = function (e) {

    var image = e.data
    var compression = e.data.Orthanc.Compression
    
    var result
    if (image.inflated) {
        result = image.Orthanc.PixelData
    } else {
        getPixelDataDeflate(image)
        result = image.Orthanc.PixelData
    }

    postMessage(result)

}