importScripts('jpeg-decoder.js');

function ChangeDynamics(pixels, source1, target1, source2, target2) {
    var scale = (target2 - target1) / (source2 - source1);
    var offset = (target1) - scale * source1;

    for (var i = 0, length = pixels.length; i < length; i++) {
        pixels[i] = scale * pixels[i] + offset;
    }
}

// http://stackoverflow.com/a/11058858/881731
function str2ab(str) {
    var buf = new ArrayBuffer(str.length);
    var pixels = new Uint8Array(buf);
    for (var i = 0, strLen = str.length; i < strLen; i++) {
        pixels[i] = str.charCodeAt(i);
    }
    return pixels;
}

function getPixelDataJpeg(image) {
    var jpegReader = new JpegImage();
    var jpeg = str2ab(atob(image.Orthanc.PixelData));
    jpegReader.parse(jpeg);
    var s = jpegReader.getData(image.width, image.height);
    var pixels = null;

    if (image.color) {
        var buf = new ArrayBuffer(s.length / 3 * 4); // RGB32
        pixels = new Uint8Array(buf);
        var index = 0;
        for (var i = 0, length = s.length; i < length; i += 3) {
            pixels[index++] = s[i];
            pixels[index++] = s[i + 1];
            pixels[index++] = s[i + 2];
            pixels[index++] = 255;  // Alpha channel
        }
    } else {
        var buf = new ArrayBuffer(s.length * 2); // uint16_t or int16_t

        if (image.Orthanc.IsSigned) {
            pixels = new Int16Array(buf);
        } else {
            pixels = new Uint16Array(buf);
        }

        var index = 0;
        for (var i = 0, length = s.length; i < length; i++) {
            pixels[index] = s[i];
            index++;
        }

        if (image.Orthanc.Stretched) {
            ChangeDynamics(pixels, 0, image.Orthanc.StretchLow, 255, image.Orthanc.StretchHigh);
        }
    }

    image.inflated = true
    return image.Orthanc.PixelData = pixels;
}

onmessage = function (e) {

    var image = e.data
    var compression = e.data.Orthanc.Compression

    var result
    if (image.inflated) {
        result = image.Orthanc.PixelData
    } else {
        getPixelDataJpeg(image)
        result = image.Orthanc.PixelData
    }

    postMessage(result)

}