UMDConstructor(
    this,
    'RouteUtils',
    {
    },
    function() {
        var RouteUtils = {
                RegisteredTopRoutePaths: ['tabs', 'guard', 'no-guard'],
                RouteEssentialParamsRegExp: /\.(\-?[\d]*)\.(.*?)\.([a-zA-Z0-9_-]*)/.toString().slice(1).slice(0, -1),
                
                getRouteEssentialParamsRegExp: function ( topRoutePath ) {
                    return new RegExp( `^${topRoutePath}${this.RouteEssentialParamsRegExp}` )
                },
                
                getRouteEssentialParams: function() {
                    var segments = location.pathname.split('/');
                    segments = segments.concat( location.hash.replace('#', '').split('/') ); // NOTE: 支持hash取参
                    var match = null;
                    
                    this.RegisteredTopRoutePaths.some( topRoutePath => {
                        // var maybeSegment = ( segments[1] === 'index.html' ) ? segments[2] : segments[1];
                        //  (segments[0] || maybeSegment || '');
        
                        for( var segmentIndex in segments ) {
                            match = segments[ segmentIndex ].match( this.getRouteEssentialParamsRegExp( topRoutePath ) )
                            if( match ) {
                                break;
                            }
                        }
        
                        return match;
                    });
                    console.log('getRouteEssentialParams:', match);
                
                    return match;
                },
                getRouteEssentialParamsObj: function() {
                    var match = this.getRouteEssentialParams();
                    
                    if( match ) {
                        return {
                            projectid: match[1],
                            appid: match[2],
                            logintype: match[3]
                        };
                    }
                    return null;
                }
        };

        return RouteUtils;
    }
);

// 支持模块化引用
function UMDConstructor(root, exportName, depsMap, factoryFn ) {
    var depPathsRequireds = Object.keys(depsMap).map(function(key) { // NOTE: 企业微信PC端并未支持Object.values
        return depsMap[key];
    });
    var depExportNames = Object.keys( depsMap );
    var getDepsExports = function() {
        return depExportNames.map( function(moduleExportName) { 
            var moduleObj = root[moduleExportName];
            
            if( moduleObj ) {
                return moduleObj
            }
            throw new Error('Cannot find module \'' + moduleExportName + '\'');
         });
    }

    if (typeof module === 'object' && typeof module.exports === 'object') { // commonjs模块规范，nodejs环境
        module.exports = factoryFn.apply(null, depPathsRequireds);
    } else if (typeof define === 'function' && define.amd) { // AMD模块规范，require.js
        define(depPaths, factoryFn);
    } else if (typeof define === 'function' && define.cmd) {  // CMD模块规范，sea.js
        define(function(require, exports, module) {
            module.exports = factoryFn.apply(null, depPathsRequireds);
        })
    } else {
        root[exportName] = factoryFn.apply(null, getDepsExports()); // 没有模块环境，直接挂载在全局对象上
    }
}