
UMDConstructor(
    this,
    'OAuth2CodeGuard',
    {
        'FetchConfigUtils': typeof require !== 'undefined' && require('../utils.fetch-config/fetch-config.es5'),
        'TokenUtils': typeof require !== 'undefined' && require('../utils.oauth2-token-guard/token-utils/token.es5'),
        'UrlParamsUtils': typeof require !== 'undefined' && require('../utils.oauth2-token-guard/url-params-utils/url-params.es5')
    }, 
    function( FetchConfigUtils, TokenUtils, UrlParamsUtils ) {
        // 企业微信登录
        function fetchServeAddrConfFromPrivateHost( callback ) {
            function dec(encryptedText, needEnc) {
                if (!encryptedText || !needEnc) {
                    return encryptedText;
                }
               return atob(atob(atob(encryptedText))) 
            }
            
            var CMCconfig = FetchConfigUtils.getCMCConfig();
            var encrypted = CMCconfig.encrypted;

            if( CMCconfig && CMCconfig.webApi && CMCconfig.webApi.master && CMCconfig.webApi.master.qywxUrl ) {
                OAuth2CodeGuard.centerServeAddr = dec(CMCconfig.webApi.master.centerServeAddr, encrypted);
                OAuth2CodeGuard.serveUrl = dec(CMCconfig.webApi.master.qywxUrl, encrypted);
                // OAuth2CodeGuard.BaiHuiPlatformOAuthHost = CMCconfig.webApi.master.BaiHuiPlatformOAuthHost;
                OAuth2CodeGuard.wxOAuthCodeRedirectHost = dec(CMCconfig.webApi.master.wxOAuthCodeRedirectHost, encrypted);
                callback && callback();
            } else {
                OAuth2CodeGuard.showErrFn('获取服务配置出错，请稍候重试');
            }
        }

        // 微信公众号登录
        function wxgzhFetchOAuth2CodeToLogonOrDirectToWebapp( navInfoObj ) {
    
            if( !TokenUtils.getCacheOAuth2UserInfo() && !TokenUtils.isLogged() ) { // _wxgzhOpenid
                
                // serveUrl在app内进行获取
                // 暂时直接跳转webAppUrl，没有二次中转
                requestWxCommonAuthorize(navInfoObj.appid, OAuth2CodeGuard.recvOAuth2CodeUrl, 'snsapi_userinfo', navInfoObj.state);
            } else {
                chooseEntryToGoTargetPage( navInfoObj );
            }
        }

        function requestWxCommonAuthorize(CORPID, redirect_url, scope, state, agentId) { // 跳到web-app进行登录
            var redirect_url = redirect_url || OAuth2CodeGuard.webAppUrl; // 正常为webAppUrl
            var scope = scope || 'snsapi_base';
            var state = state || '';
            var REDIRECT_URI = encodeURIComponent( redirect_url );

            var wxPullAuthUrl = 'https://open.weixin.qq.com/connect/oauth2/authorize?'
            + 'appid=' + CORPID
            + '&redirect_uri=' + REDIRECT_URI
            + '&response_type=code'
            + '&scope=' + scope
            + '&state=' + state 

            if( agentId ) {
                wxPullAuthUrl += '&agentid=' + agentId;
            }

            wxPullAuthUrl += '#wechat_redirect';

            UrlParamsUtils.goLink( wxPullAuthUrl );

            // console.error('OAuth2Login.html: wxPullAuthUrl end');
        }

        function qywxFetchOAuth2CodeToLogonOrDirectToWebapp( navInfoObj ) {
            if( !TokenUtils.isLogged() ) {

                FetchConfigUtils.xhrGET( OAuth2CodeGuard.serveUrl + 'api/WeChat/GetEnterpriseWeChatSetting', function( err ) {
                    OAuth2CodeGuard.showErrFn( err && err.errmsg || '获取企业信息失败，请稍候重试');
                }, function( rsp ) {
                    if( rsp && rsp.errcode === 'SUCCESS' && rsp.data ) {
                        //  redirect_url 定为recvOAuth2CodeUrl，最后跳转固定地址webAppUrl，否则有可能导致其他地方签名失败，如企业微信无法录音(应已解决)
                        requestWxCommonAuthorize( rsp.data.CorpID, OAuth2CodeGuard.recvOAuth2CodeUrl, 'snsapi_base', navInfoObj.state);
                    }
                });
                
            } else {
                // console.error('OAuth2Login.html: in webAppUrl start');

                UrlParamsUtils.goLink( OAuth2CodeGuard.webAppUrl );

                // console.error('OAuth2Login.html: in webAppUrl end');
            }
            
        }

        function dkfqywxFetchOAuth2CodeToLogonOrDirectToWebapp( navInfoObj ) {
            if( !TokenUtils.isLogged() ) {

                // NOTE: 此处appid为orgcode
                FetchConfigUtils.xhrGET( OAuth2CodeGuard.centerServeAddr + 'api/EnterpriseWeChat/GetAppIdV2/'+ navInfoObj.projectid + '/' + navInfoObj.appid, function( err ) {
                    OAuth2CodeGuard.showErrFn( err && err.errmsg || '获取企业信息失败，请稍候重试');
                }, function( rsp ) {
                    if( rsp && rsp.errcode === 'SUCCESS' && rsp.data ) {
                        //  redirect_url 定为recvOAuth2CodeUrl，最后跳转固定地址webAppUrl，否则有可能导致其他地方签名失败，如企业微信无法录音(应已解决)
                        requestWxCommonAuthorize( rsp.data.AppId, OAuth2CodeGuard.recvOAuth2CodeUrl, 'snsapi_privateinfo', navInfoObj.state, rsp.data.AgentId);
                    }
                }, true);
                
            } else {
                UrlParamsUtils.goLink( OAuth2CodeGuard.webAppUrl );
            }
        }


        function initGoTargetUrlFromPageEntryUrl() {
            if( !OAuth2CodeGuard.webAppUrl ) {
                var indexRoute = '/index.html';
                // NOTE: 2024-12-17确认无跨站执行js风险
                OAuth2CodeGuard.webAppUrl = location.protocol + '//' + location.host + indexRoute;
                OAuth2CodeGuard.sharesPageUrl = location.protocol + '//' + location.host + '/app-shares' + indexRoute;
                var loginInfo = TokenUtils.getLoginInfoFromCache();
                console.log("loginInfo",loginInfo);
                if( loginInfo.projectid && loginInfo.appid && loginInfo.logintype && loginInfo.target_code && loginInfo.state ){
                    OAuth2CodeGuard.sharesPageUrl = `${OAuth2CodeGuard.sharesPageUrl}#/no-guard.${loginInfo.projectid}.${loginInfo.appid}.${loginInfo.logintype}/social-shares/${loginInfo.target_code}/${loginInfo.state}`;
                }
            }
        }

        function initRecvOauth2CodeUrl() {
            var wxOAuthCodeRedirectHost = location.protocol + '//' + location.host;

            if( OAuth2CodeGuard.wxOAuthCodeRedirectHost ) {
                wxOAuthCodeRedirectHost = OAuth2CodeGuard.wxOAuthCodeRedirectHost;
            }
            OAuth2CodeGuard.recvOAuth2CodeUrl = wxOAuthCodeRedirectHost + '/OAuth2Login.html'; // location.pathname
        }

        function detectOAuth2CodeRecv( navInfoObj ) {
            var isRecv = false;
            if( navInfoObj.code ) { // 二次中转，企业微信跳转登录，不带参数，否则语音签名有问题[应已无问题]
                TokenUtils.updateLoginInfoByObj({ "code": navInfoObj.code, "state": navInfoObj.state }); // 仅更新授权code、state参数信息

                // console.error('OAuth2Login.html: get(code) compelete', state);
                chooseEntryToGoTargetPage( navInfoObj );

                // console.error('OAuth2Login.html: get(code) redirect end');
                isRecv = true;
            }
            return isRecv
        }

        function run( loggerUtils ) {
            try{
                // console.error('OAuth2Login.html: first line');
                initGoTargetUrlFromPageEntryUrl();
                
                var cacheLoginInfo = TokenUtils.getLoginInfoFromCache();
                var navInfoUrlObj = UrlParamsUtils.getUrlObjAndCheckPageDefaultLoginTypeConflict(cacheLoginInfo, function( logintype ) {
                    logintype = logintype || OAuth2CodeGuard.pageDefaultLoginType;  // NOTE: 默认nbqywx，最开始企业微信内部应用登录未设置入口参数
                    return TokenUtils.reviseLoginTypeOnFetchOAuth2CodePageDefaultConflict( logintype, OAuth2CodeGuard.pageDefaultLoginType );
                });
                
                var navInfoObj = UrlParamsUtils.getNavInfoObj( navInfoUrlObj );
                OAuth2CodeGuard.renderDomByLoginType( navInfoObj.logintype );

                if( detectOAuth2CodeRecv( navInfoObj ) ) {
                    return;
                } else {
                    TokenUtils.updateLoginInfoByObj( navInfoUrlObj.searchParams );  // 缓存更新后的参数信息
                }
                
                var loggedFlagObj = TokenUtils.readLoggedInfoFromCache();
                TokenUtils.findValidTokenIfCan(navInfoObj, loggedFlagObj);  // NOTE: 主要去清除token

                autoLogonByLoginType( navInfoObj, loggerUtils );
                
            } catch( err ) {
                console.error('OAuth2Login.html: main program err:', err );
                OAuth2CodeGuard.showErrFn('代码异常:' + JSON.stringify(err) );
            }
        }

        function getOrgServeAddrFromCenterServe( navInfoObj, callback ) {
            if( navInfoObj.projectid ) {
                var orgServeAddr = FetchConfigUtils.getOrgServeAddr( OAuth2CodeGuard.centerServeAddr, navInfoObj.projectid );

                if( orgServeAddr ) {
                    OAuth2CodeGuard.serveUrl = orgServeAddr;
                } else {
                    OAuth2CodeGuard.showErrFn('查询当前机构服务地址失败');
                }
            }
            callback && callback();
        }

        function autoLogonByLoginType( navInfoObj, loggerUtils ) {
            // console.error('OAuth2Login.html: logintype', logintype );
            initGoTargetUrlFromPageEntryUrl();
            initRecvOauth2CodeUrl();

            // 切换登录类型
            switch( navInfoObj.logintype ) {
                case 'nbqywx':  // 企业微信内部应用登录
                    fetchAndCacheBaseConf(navInfoObj, loggerUtils, function() {
                        initRecvOauth2CodeUrl();
                        qywxFetchOAuth2CodeToLogonOrDirectToWebapp( navInfoObj );
                    });
                    break;
                case 'yywxgzh':  // 公众号登录
                    wxgzhFetchOAuth2CodeToLogonOrDirectToWebapp( navInfoObj );
                    break;
                case 'dkfqywx':  // 企业微信代开发应用登录
                    fetchAndCacheBaseConf(navInfoObj, loggerUtils, function() {
                        initRecvOauth2CodeUrl();
                        dkfqywxFetchOAuth2CodeToLogonOrDirectToWebapp( navInfoObj );
                    });
                    break;
            }
        }

        function fetchAndCacheBaseConf(navInfoObj, loggerUtils, callback ) {
            fetchServeAddrConfFromPrivateHost(function() {
                getOrgServeAddrFromCenterServe(navInfoObj, function() {
                    if( typeof loggerUtils !== 'undefined' ) {
                        loggerUtils.webApi.businessUrl = OAuth2CodeGuard.serveUrl;
                    }
                    // 预设服务地址
                    FetchConfigUtils.preSetServeUrl(navInfoObj.projectid, TokenUtils.loggedFlagObj.webApi, OAuth2CodeGuard.serveUrl );
                    callback && callback();
                });
            });
        }

        function chooseEntryToGoTargetPage( navInfoObj ) {
            if( navInfoObj.state === 'share' ) {
                console.log("20230517跳转分享");
                UrlParamsUtils.goLink( OAuth2CodeGuard.sharesPageUrl ); // 进入分享独立页，要求进入app-shares入口
            } else {
                UrlParamsUtils.goLink( OAuth2CodeGuard.webAppUrl );
            }
        }

        var OAuth2CodeGuard = {
            centerServeAddr: '',
            serveUrl: '',
            // BaiHuiPlatformOAuthHost: '',
            wxOAuthCodeRedirectHost: '',
            webAppUrl: '',
            sharesPageUrl: '',
            recvOAuth2CodeUrl: '',
            pageDefaultLoginType: 'nbqywx', // 页面默认企业微信登录方式
            run: run,
            showErrFn: function( msg ) {
                console.error('err:', msg);
            },
            renderDomByLoginType: function() {},
            autoLogonByLoginType: autoLogonByLoginType,
            fetchAndCacheBaseConf: fetchAndCacheBaseConf,
            getOrgServeAddrFromCenterServe: getOrgServeAddrFromCenterServe,
            fetchServeAddrConfFromPrivateHost: fetchServeAddrConfFromPrivateHost,
        };

        return OAuth2CodeGuard;
    }
);


// 支持模块化引用
function UMDConstructor(root, exportName, depsMap, factoryFn ) {
    var depPathsRequireds = Object.keys(depsMap).map(function(key) { // NOTE: 企业微信PC端并未支持Object.values
        return depsMap[key];
    });
    var depExportNames = Object.keys( depsMap );
    var getDepsExports = function() {
        return depExportNames.map( function(moduleExportName) { 
            var moduleObj = root[moduleExportName];
            
            if( moduleObj ) {
                return moduleObj
            }
            throw new Error('Cannot find module \'' + moduleExportName + '\'');
         });
    }

    if (typeof module === 'object' && typeof module.exports === 'object') { // commonjs模块规范，nodejs环境
        module.exports = factoryFn.apply(null, depPathsRequireds);
    } else if (typeof define === 'function' && define.amd) { // AMD模块规范，require.js
        define(depPaths, factoryFn);
    } else if (typeof define === 'function' && define.cmd) {  // CMD模块规范，sea.js
        define(function(require, exports, module) {
            module.exports = factoryFn.apply(null, depPathsRequireds);
        })
    } else {
        root[exportName] = factoryFn.apply(null, getDepsExports()); // 没有模块环境，直接挂载在全局对象上
    }
}