var H5lock = function() {
    var H5lockStatus = {
        pwdNotSet: 0,  // 未设置密码
        enterFirstSetPwd: 1, //  进入首次设置密码
        firstSetPwdInconformity: 2, // 首次设置密码未符合要求
        firstSetPwdConformity: 3, // 首次设置密码符合要求
        enterSecondPwdConfirm: 4, //  进入二次确认密码
        secondPwdConfirmFail: 5,  // 二次确认密码失败
        secondPwdConfirmSuccess: 6, // 二次确认密码正确
        enterVerifyExistedPwd: 7, // 进入验证密码
        verifyExistedPwdInconformity: 8, // 验证已有密码时输入不符合
        verifyExistedPwdFail: 9, // 验证已有密码失败
        verifyExistedPwdCorrect: 10, // 验证已有密码正确
        pwdRedraw: 11, // 密码重绘
    };
    var H5lock = function(obj){
        this.height = obj.height;
        this.width = obj.width;
        this.chooseType = obj.chooseType || 3; // 3x3 或 4x4
        this.options = {
            paddingTop: 1,
            paddingLeft: 0,
            paddingRight: 0,
            circleColor: '#E5E5E5',
            circleLineWidth: 1,
            circleEdgeLineWidth: 1,
            trackWidth: 8,
            
            activePointInnerCircleColor: '#1677FF',
            activePointEdgeColor: '#E5E5E5',
            trackColor: '#73ADFF',

            pointInnerCircleColorOnErr: '#FF3A2F',
            pointEdgeColorOnErr: '#FF3A2F',
            trackColorOnErr: '#FF3A2F',

            pointInnerCircleColorOnOk: '#1677FF',
            pointEdgeColorOnOk: '#E5E5E5',
            trackColorOnOk: '#73ADFF',
            encryptMethod: function( pwdStr ) {
                return pwdStr;
            }
        };
        this.options = Object.assign(this.options, obj);
        this.options.minConnectionPoints = this.options.minConnectionPoints || 4;
        this.devicePixelRatio = window.devicePixelRatio || 1;
        return this;
    };

    H5lock.Status = H5lockStatus;

    H5lock.prototype.drawCle = function(x, y) { // 初始化解锁密码面板 小圆圈
        this.ctx.strokeStyle = this.options.circleColor;//密码的点点默认的颜色
        this.ctx.lineWidth = this.options.circleLineWidth * this.devicePixelRatio;
        this.ctx.beginPath();
        this.ctx.arc(x, y, this.r, 0, Math.PI * 2, true);
        this.ctx.closePath();
        this.ctx.stroke();
    }
    H5lock.prototype.drawPoint = function(style) { // 初始化圆心
        for (var i = 0 ; i < this.lastPoint.length ; i++) {
            this.ctx.fillStyle = style;
            this.ctx.beginPath();
            this.ctx.arc(this.lastPoint[i].x, this.lastPoint[i].y, this.r * 17 / 35, 0, Math.PI * 2, true);
            this.ctx.closePath();
            this.ctx.fill();
        }
    }
    H5lock.prototype.drawStatusPoint = function(type) { // 初始化状态线条
        for (var i = 0 ; i < this.lastPoint.length ; i++) {
            this.ctx.strokeStyle = type;
            this.ctx.lineWidth = this.options.circleEdgeLineWidth * this.devicePixelRatio;
            this.ctx.beginPath();
            this.ctx.arc(this.lastPoint[i].x, this.lastPoint[i].y, this.r, 0, Math.PI * 2, true);
            this.ctx.closePath();
            this.ctx.stroke();
        }
    }
    H5lock.prototype.drawLine = function(style, po) {//style:颜色 解锁轨迹
       
        this.ctx.beginPath();
        this.ctx.strokeStyle = style;
        this.ctx.lineWidth = this.options.trackWidth * this.devicePixelRatio;

        this.ctx.moveTo(this.lastPoint[0].x, this.lastPoint[0].y);
       
        for (var i = 1 ; i < this.lastPoint.length ; i++) {
            this.ctx.lineTo(this.lastPoint[i].x, this.lastPoint[i].y);

            if( this.lastPoint.length === (i+1) ) {
                this.ctx.stroke();
                this.ctx.closePath();
                this.ctx.beginPath(); // NOTE: 重新设置闭合起点
                this.ctx.moveTo(this.lastPoint[i].x, this.lastPoint[i].y);
            }
        }
        this.ctx.lineTo(po.x, po.y); // NOTE: 设置闭合重点

        this.ctx.stroke();

        this.ctx.closePath();
    }
    H5lock.prototype.createCircle = function() {// 创建解锁点的坐标，根据canvas的大小来平均分配半径

        var n = this.chooseType;
        var count = 0;
        var blockWidth = n * (2 +  40 / 35 );
        var blankWidth = this.ctx.canvas.width - this.options.paddingLeft * this.devicePixelRatio - this.options.paddingRight * this.devicePixelRatio;
        this.r =  blankWidth / blockWidth;// 公式计算
        this.lastPoint = [];
        this.arr = [];
        this.restPoint = [];
        var lMargin = this.options.paddingLeft * this.devicePixelRatio;
        var tMargin = this.options.paddingTop * this.devicePixelRatio;
        var pointGap = 20 / 35 * this.r;

        if( this.r > this.devicePixelRatio * 35 ) {
            this.r = this.devicePixelRatio * 35;
            pointGap = 20 / 35 * this.r;
            lMargin += (blankWidth - n * ( 2 * this.r + 2 * pointGap ) ) / 2;
        }
        
        
        var r = this.r;
        for (var i = 0 ; i < n ; i++) {
            for (var j = 0 ; j < n ; j++) {
                count++;
                var obj = {
                    x: j * (2 * r + 2 * pointGap ) + lMargin + pointGap + r,
                    y: i * (2 * r + 2 * pointGap ) + tMargin + r,
                    index: count
                };
                this.arr.push(obj);
                this.restPoint.push(obj);
            }
        }
        this.ctx.clearRect(0, 0, this.ctx.canvas.width, this.ctx.canvas.height);
        for (var i = 0 ; i < this.arr.length ; i++) {
            this.drawCle(this.arr[i].x, this.arr[i].y);
        }
        //return arr;
    }
    H5lock.prototype.getPosition = function(e) {// 获取touch点相对于canvas的坐标
        var rect = e.currentTarget.getBoundingClientRect();
        var po = {
            x: (e.touches[0].clientX - rect.left)*this.devicePixelRatio,
            y: (e.touches[0].clientY - rect.top)*this.devicePixelRatio
          };
        return po;
    }

    H5lock.prototype.refreshFrame = function( position ) {
        this.ctx.clearRect(0, 0, this.ctx.canvas.width, this.ctx.canvas.height);

        for (var i = 0 ; i < this.arr.length ; i++) { // 每帧先把面板画出来
            this.drawCle(this.arr[i].x, this.arr[i].y);
        }

        this.drawStatusPoint( this.options.activePointEdgeColor );// 每帧画圆边沿

        if( !position ) {
            this.drawLine( this.options.trackColor, this.lastPoint[this.lastPoint.length-1]); // 每帧画轨迹
        } else {
            this.drawLine( this.options.trackColor, position); // 每帧画轨迹
        }
        
        this.drawPoint( this.options.activePointInnerCircleColor );// 每帧画圆心
    }

    H5lock.prototype.update = function( position ) {// 核心变换方法在touchmove时候调用

        this.refreshFrame( position );

        for (var i = 0 ; i < this.restPoint.length ; i++) {
            if (Math.abs(position.x - this.restPoint[i].x) < this.r && Math.abs(position.y - this.restPoint[i].y) < this.r) {
                // this.drawPoint(this.restPoint[i].x, this.restPoint[i].y);
                this.lastPoint.push(this.restPoint[i]);
                this.restPoint.splice(i, 1);
                break;
            }
        }

    }

    H5lock.prototype.transformPassword = function( pwd ) {
        return String(pwd || '').split('').map( item => Object({ index: item }) );
    }

    H5lock.prototype.passwordToStr = function( pwdArr ) {
        var p1 = '';
        for (var i = 0 ; i < pwdArr.length ; i++) {
            p1 += pwdArr[i].index;
        }
        return p1;
    }

    H5lock.prototype.updateExistedPassword = function( pwd ) {
        // step undefined 为待手势、1为二次确认手势、2为待解锁
        this.pwdObj = pwd ? {
            step: 2,
            existedPassword: pwd,
        } : {};

        this.reset();
    }

    H5lock.prototype.checkPass = function(isEncrypted, existedPassword, pwd2) {// 检测密码
        if( isEncrypted ) {
            // console.log('existedPassword:', existedPassword);
            var encryptedPwd2 = this.options.encryptMethod( pwd2 );
            // console.log('encryptedPwd:', pwd2, encryptedPwd2);
            return existedPassword === encryptedPwd2;
        } else {
            return existedPassword === pwd2;
        }
      
    }
    H5lock.prototype.storePass = function(pwd) {// touchend结束之后对密码和状态的处理
        var pwdStr = this.passwordToStr( pwd );

        if (this.pwdObj.step == 1) {
            if (this.checkPass(false, this.pwdObj.firstPassword, pwdStr)) { // 确认密码
                this.pwdObj.step = 2;
                this.pwdObj.existedPassword = this.options.encryptMethod( pwdStr );
                // document.getElementById('title').innerHTML = '密码保存成功';
                this.passwordUpdateOutput( pwdStr );
                this.statusOutput( H5lockStatus.secondPwdConfirmSuccess, pwdStr );

                this.drawStatusPoint( this.options.pointEdgeColorOnOk );
                this.drawLine(this.options.trackColorOnOk, this.lastPoint[this.lastPoint.length-1]);
                this.drawPoint( this.options.pointInnerCircleColorOnOk );

                this.statusOutput( H5lockStatus.enterVerifyExistedPwd );
            } else {
                // document.getElementById('title').innerHTML = '两次不一致，重新输入';
                this.statusOutput( H5lockStatus.secondPwdConfirmFail, pwdStr );
                this.drawStatusPoint( this.options.pointEdgeColorOnErr );
                this.drawLine(this.options.trackColorOnErr, this.lastPoint[this.lastPoint.length-1]);
                this.drawPoint( this.options.pointInnerCircleColorOnErr ); // 每帧画圆心
                // delete this.pwdObj.step;
            }
        } else if (this.pwdObj.step == 2) {
            if (this.checkPass(true, this.pwdObj.existedPassword, pwdStr)) {
                // var title = document.getElementById("title");
                // title.style.color = "#2CFF26";
                // title.innerHTML = '解锁成功';
                this.statusOutput( H5lockStatus.verifyExistedPwdCorrect, pwdStr );

                this.drawStatusPoint( this.options.pointEdgeColorOnOk );//小点点外圈高亮
                this.drawLine(this.options.trackColorOnOk, this.lastPoint[this.lastPoint.length-1]);// 每帧画圆心
                this.drawPoint( this.options.pointInnerCircleColorOnOk );
                
            } else if (pwd.length < this.options.minConnectionPoints ) {
                
                this.drawStatusPoint( this.options.pointEdgeColorOnErr );
                this.drawLine( this.options.trackColorOnErr, this.lastPoint[this.lastPoint.length-1]);// 每帧画圆心
                this.drawPoint( this.options.pointInnerCircleColorOnErr );

                // var title = document.getElementById("title");
                // title.style.color = "red";
                // title.innerHTML = '请连接4个点';

                this.statusOutput( H5lockStatus.verifyExistedPwdInconformity, pwdStr );

            } else {
                this.drawStatusPoint( this.options.pointEdgeColorOnErr );
                this.drawLine(this.options.trackColorOnErr, this.lastPoint[this.lastPoint.length-1]);
                this.drawPoint( this.options.pointInnerCircleColorOnErr ); // 每帧画圆心


                // var title = document.getElementById("title");
                // title.style.color = "red";
                // title.innerHTML = '密码错误，您还可以输入N次';

                this.statusOutput( H5lockStatus.verifyExistedPwdFail, pwdStr );
            }
        } else {
            if ( pwd.length < this.options.minConnectionPoints ) {
                
                this.drawStatusPoint( this.options.pointEdgeColorOnErr );
                this.drawPoint( this.options.pointInnerCircleColorOnErr );
                this.drawLine(this.options.trackColorOnErr, this.lastPoint[this.lastPoint.length-1]);// 每帧画圆心

                // var title = document.getElementById("title");
                // title.style.color = "red";
                // title.innerHTML = '请连接4个点';

                this.statusOutput( H5lockStatus.firstSetPwdInconformity, pwdStr );

            } else {
                this.pwdObj.step = 1;
                this.pwdObj.firstPassword = pwdStr;
                // document.getElementById('title').innerHTML = '再次输入';
                this.statusOutput( H5lockStatus.firstSetPwdConformity, pwdStr );
                this.statusOutput( H5lockStatus.enterSecondPwdConfirm );
            }
            
        }

    }
    H5lock.prototype.makeState = function() {
        if (this.pwdObj.step == 2) {
            // document.getElementById('updatePassword').style.display = 'block';
            
            // var title = document.getElementById("title");
            // title.style.color = "#87888a";
            // title.innerHTML = '请解锁';

            this.statusOutput( H5lockStatus.enterVerifyExistedPwd );

        } else if (this.pwdObj.step == 1) {
            // document.getElementById('updatePassword').style.display = 'none';
            this.statusOutput( H5lockStatus.enterSecondPwdConfirm );
        } else {
            // document.getElementById('updatePassword').style.display = 'none';
            this.statusOutput( H5lockStatus.pwdNotSet );
            this.statusOutput( H5lockStatus.enterFirstSetPwd );
        }
    }
    H5lock.prototype.setChooseType = function(type){
        chooseType = type;
        init();
    }
    
    // H5lock.prototype.updatePassword = function(){
    //     this.pwdObj = {};
    //     // document.getElementById('title').innerHTML = '绘制解锁图案';
    //     this.reset();
    // }

    H5lock.prototype.resetFirstPwd = function() {
        this.pwdObj = {};
        this.reset();
    }

    H5lock.prototype.initDom = function(){

        var width = this.width || 320;
        var height = this.height || 320;
        var canvas = this.options.canvas;

        if( !canvas ) {
            var wrap = document.createElement('div');
            // var str = '<h4 id="title" class="title" style="color:#87888a">请绘制您的图形密码</h4>'+
            //           '<a id="updatePassword" style="position: absolute;right: 5px;top: 5px;color:#fff;font-size: 10px;display:none;">重置密码</a>';
    
            wrap.setAttribute('style','position: absolute;top:0;left:0;right:0;bottom:0;');
            canvas = document.createElement('canvas');
            canvas.setAttribute('id','canvas');
            canvas.style.cssText = 'background-color: transparent;display: inline-block;margin-top: 76px;';
            canvas.style.width = width + "px";
            canvas.style.height = height + "px";
            // wrap.innerHTML = str;
            wrap.appendChild(canvas);
    
            document.body.appendChild(wrap);
            console.log('H5lock.initDom create:', width, height);
        } else {
            width = canvas.clientWidth || document.body.parentElement.clientWidth; // NOTE: 页面未呈现时，width为0
            height = canvas.clientWidth; // canvas.clientHeight || canvas.clientWidth;
            console.log('H5lock.initDom:', width, height, screen.availWidth, window.innerWidth, document.body.clientWidth);
        }

        if( width == 0 || height == 0) {
            // 目前只有screen.availWidth可用，默认webview没挂载在视图上时，基本没宽度
            width = ( screen.availWidth || window.innerWidth || document.body.clientWidth);
            // height = width;
            // canvas.style.width = width + "px";
            // canvas.style.height = height + "px";
            // 下边有缩放，否则比例不一致
        }
        

        // 高清屏缩放
        canvas.height = Math.min(width - this.options.paddingLeft - this.options.paddingRight , 356 ) * this.devicePixelRatio;
        canvas.width = width * this.devicePixelRatio;
        
        return canvas;
    }
    H5lock.prototype.init = function() {
        this.canvas = this.initDom();
        this.ctx = this.canvas.getContext('2d');
        this.lastPoint = [];
        this.touchFlag = false;
        this.updateExistedPassword( this.options.password );
        this.bindEvent();
        return this;
    }

    
    H5lock.prototype.reset = function() {
        this.makeState();
        this.createCircle();
    }
    H5lock.prototype.bindEvent = function() {
        var self = this;
        this.canvas.addEventListener("touchstart", function (e) {
            e.preventDefault();// 某些android 的 touchmove不宜触发 所以增加此行代码
             var po = self.getPosition(e);

             if( self.resetTimer ) { // 清除未完成的定时
                self.reset();
                clearTimeout( self.resetTimer );
                self.resetTimer = undefined;
             }

             if( !self.touchFlag ) {
                self.statusOutput( H5lockStatus.pwdRedraw );
             }

             for (var i = 0 ; i < self.arr.length ; i++) {
                if (Math.abs(po.x - self.arr[i].x) < self.r && Math.abs(po.y - self.arr[i].y) < self.r) {

                    self.touchFlag = true;
                    self.drawPoint(self.arr[i].x,self.arr[i].y);
                    self.lastPoint.push(self.arr[i]);
                    self.restPoint.splice(i,1);
                    break;
                }
             }
         }, false);
         this.canvas.addEventListener("touchmove", function (e) {
            if (self.touchFlag) {
                self.update(self.getPosition(e));
            }
         }, false);
         this.canvas.addEventListener("touchend", function (e) {
             if (self.touchFlag) {
                 self.touchFlag = false;
                 self.refreshFrame();
                 self.storePass(self.lastPoint);
                 
                 self.resetTimer = setTimeout(function(){

                    self.reset();
                    self.resetTimer = undefined;
                }, 1000);
             }

             var clickEv = new Event( 'click' );
             document.dispatchEvent( clickEv ); // NOTE: 触发外部document事件，以此代表document产生了用户交互
         }, false);

        //  document.getElementById('updatePassword').addEventListener('click', function(){
        //      self.updatePassword();
        //   });
    }

    H5lock.prototype.passwordUpdateOutput = function( pwdStr ) {
        this.options.passwordUpdateOutput && this.options.passwordUpdateOutput( pwdStr );
    }

   
    H5lock.prototype.statusOutput = function( status, pwdOrNull ) {
        this.options.statusOutput && this.options.statusOutput( status, pwdOrNull );
    }

    if (typeof define == 'function') {
        define( function(){ return H5lock; } );
    }else if (typeof module != 'undefined' && module.exports) {
        module.exports = H5lock;
    }
    return H5lock;
}();