~function() {
    wsPlayerPolyfills( H5sPlayerWS );
    wsPlayerPolyfills( H5sPlayerRTC );

    function wsPlayerPolyfills( className ) {
        var prototype = className.prototype;
        
        prototype._connect = prototype.connect;
        prototype.connect = function() {
            this._connect();
            this.isFrameTransmitting = true;
        }

        prototype._pause = prototype.pause;
        prototype.pause = function() {
            this._pause();
            this.isFrameTransmitting = false;
        }


        prototype._start = prototype.start;
        prototype.start = function() {
            this._start();
            this.isFrameTransmitting = true;
        }
        
        prototype._resume = prototype.resume;
        prototype.resume = function() {
            this._resume();
            this.isFrameTransmitting = true;
        }

        prototype._disconnect = prototype.disconnect;
        prototype.disconnect = function() {
            this._disconnect();
            this.isFrameTransmitting = false;
        }
    }

    var clickListenFn = function() {
        window.__hasDocInteracted = true;
        document.body.removeEventListener('click', clickListenFn);
        console.log('已激活当前document');
    };

    document.body.addEventListener('click', clickListenFn);
}();

var VideoJsForH5SPlayer = (function () {
    function VideoJsForH5SPlayer( v5hOptions ) {
        this.strSession = 'c1782caf-b670-42d8-ba90-2244d0b0ee83';
        this.strPbSession;
        this.strToken = '';
        this.h5sPlayProtocol = 'ws';
        this.selfVideo;
        this.begintime = ''; // '2020-07-06T11:30:01+08';  // begintime的下一秒开始的画面
        this.endtime = ''; // '2020-07-06T11:40:01+08'; // endtime的上一秒结束的画面
        this.newlyMouseupEv;
        this.curV5hOptions = {};
        this.curPlayBackIsNone = false;
        this.hintTimer = undefined;

        this.fakePlayStateObj = {
            value: this.begintime,
            curTimestamp: -Infinity,
            duration: 10,
            elapsedTime: 0,
            realBegintime: '',
            realEndtime: '',
            realBeginTimeStamp: 0,
            realEndTimeStamp: 0,
            mistakeTime: 0,  // 开始时间存在的误差
        };

        this.pbconf1 = {
            begintime: '',
            endtime: '',
            autoplay: 'true', // 'true' or 'false' for playback autoplay
            showposter: 'true', //'true' or 'false' show poster
            serverpb: true,
            filename: undefined,
            callback:  this.PlaybackCB.bind( this ), 
            userdata:  this.fakePlayStateObj // user data
        };

        this.conf1 = {
            videoid: null,
            protocol: "http:", //http: or https:
            host: "", //localhost:8080
            rootpath:'/', // '/'
            token: this.strToken,
            pbconf: this.pbconf1, //This is optional, if no pbconf, this will be live.
            hlsver:'v1', //v1 is for ts, v2 is for fmp4
            session: this.strSession //session got from login
        };
        this.h5splayer;

        this.initFn( v5hOptions );

    }

    VideoJsForH5SPlayer.prototype.initFn = function( v5hOptions ) {
        var videoJsForH5SPlayer = this;
        
        if( !this.updateOptions( v5hOptions, true ) ) {
            return null;
        }

        console.log('videojs:', videojs);

        var player = videojs(v5hOptions.videoMountPointId, {
            muted: false,
            controls : true,      
            loop : false,
            width: '100%',
            height: 'auto',
            // liveui: true,
            // seekable: true,
            crossOrigin: 'anonymous',
            autoplay: true,
            responsive: true,
            // children: ["mediaLoader", "posterImage", "textTrackDisplay", "loadingSpinner", "bigPlayButton", "liveTracker", "controlBar", "errorDisplay", "textTrackSettings", "resizeManager"]
            children: {
                mediaLoader: true,  // 在pb_video.html页面无需设置，但在angular组件surgical-video-play-box必须设置否则没法进入ready
                bigPlayButton: true, // 如果video在videojs加载之前就存在，autoSetup会自动加上，否则需要手动设置
                liveTracker: {
                    options: {
                        trackingThreshold: Infinity
                    }
                },
                controlBar: {
                    children: [
                        {name: 'playToggle'}, // 播放按钮
                        {name: 'currentTimeDisplay'}, // 当前已播放时间
                        {name: 'progressControl'}, // 播放进度条
                        {name: 'durationDisplay'}, // 总时间
                        {
                            name: 'volumePanel', // 音量控制
                            inline: false, // 不使用水平方式
                        },
                        {name: 'FullscreenToggle'},
                        {name: 'seekToLive'}
                    ]
                }
            }
        }
        , function onPlayerReady() {
                videojs.log('播放器已经准备好了!');
                videoJsForH5SPlayer.bindVideojsWithFakePlayStateObj( this );

                this.on('ended', function() {
                    videojs.log('播放结束了!');
                });
                
                var selfVideo = videoJsForH5SPlayer.selfVideo = this;

                videoJsForH5SPlayer.videoElIdMaybeChange( v5hOptions ); // 需要 selfVideo, 

                if( window.__hasDocInteracted ) { // 需要设置videoid, 上一步之后才能connection
                    
                    if( v5hOptions.autoplay ) {
                        videoJsForH5SPlayer.Connect();
                        setTimeout(function() {
                            selfVideo.play();
                        }, 0);
                    }
                }

                if( selfVideo.constructor.prototype._seekable === undefined ) {
                    // 设置已缓冲信息等
                    selfVideo.constructor.prototype._seekable = selfVideo.constructor.prototype.seekable;
                    selfVideo.tech().constructor.prototype._seekable = selfVideo.tech().constructor.prototype.seekable;
                    selfVideo.tech().constructor.prototype._buffered = selfVideo.tech().constructor.prototype.buffered;
                    // selfVideo.tech().constructor.prototype._duration = selfVideo.tech().constructor.prototype.duration;

                    selfVideo.constructor.prototype.seekable =
                    selfVideo.tech().constructor.prototype.seekable =
                    selfVideo.tech().constructor.prototype.buffered = function() {
                        var that = this;
                        return new Proxy(this._seekable(), {
                            get: function (target, key, receiver) {
                                
                                if( key == 'end' ) {
                                    return function() { 
                                        return that.fakePlayStateObj.duration
                                    }
                                } else if( typeof target[key] == 'function' ) {
                                    return target[key].bind(target);
                                }
                                // console.log('seekable Proxy key', key );
                                return target[key];
                            },
                            set: function (target, key, value, receiver) {
                                target[key] = value;
                                
                                return true;
                            }
                        });
                    }
                }

                // selfVideo.tech().constructor.prototype.duration = function() {
                //     return this.fakePlayStateObj.duration;
                // }

                // selfVideo.constructor.prototype._getPercent = selfVideo.constructor.prototype.getPercent;
                // video 会将直播流叠加，因为无法提供其所处位置信息。以致设置currentTime无法跳转，而进度条是根据video的currentTime实时刷新的
                // selfVideo.getChild('controlBar').getChild('progressControl').getChild('seekBar').constructor.prototype.getPercent = function() {
                //     return  this.fakePlayStateObj.elapsedTime / this.fakePlayStateObj.duration;
                // }

                if( selfVideo.constructor.prototype._currentTime === undefined ) {
                    selfVideo.constructor.prototype._currentTime = selfVideo.constructor.prototype.currentTime;
                    selfVideo.constructor.prototype.currentTime = function( newTime ) {
                        if( newTime === undefined ) {
                            return  this.fakePlayStateObj.elapsedTime;
                        }
                        console.log( `%c set currentTime ${newTime}`);

                        this._currentTime.apply(this, arguments);
                        // this.updateDisplay();
                    }

                    selfVideo.constructor.prototype._getCache = selfVideo.constructor.prototype.getCache;
                    selfVideo.constructor.prototype.getCache = function() {
                        var cacheInfo = this._getCache();
                        cacheInfo.currentTime =  this.fakePlayStateObj.elapsedTime;
                        return cacheInfo;
                        // {
                        //     currentTime: 0,    // 点击跳转，出现一次跳回原点的问题
                        //     duration: 5626,
                        //     inactivityTimeout: 2000,
                        //     initTime: 0,
                        //     lastPlaybackRate: 1,
                        //     lastVolume: 1,
                        //     media: null,
                        //     source: {},
                        //     sources: [],
                        //     src: "",
                        //     volume: 1,
                        // }
                        //  _proto.getCurrentTime_ = function getCurrentTime_() {
                        //     return this.player_.scrubbing() ? this.player_.getCache().currentTime : this.player_.currentTime();
                        //   }
                    }
                    
                }
               

                // this.on(['tap', 'click'], function(ev) {
                //     console.log('click', ev);
                //     var $findList = $(ev.path);

                //     if( !$findList.hasClass('.vjs-progress-control') ) {
                //         if( $findList.hasClass('vjs-big-play-button') ) {
                //             console.log('开始播放');
                //             videoJsForH5SPlayer.Connect();
                //         } else if( $findList.hasClass('vjs-playing') ) {
                //             console.log('%c暂停', 'color: red');
                //             videoJsForH5SPlayer.Pause();
                //         } else if( $findList.hasClass('vjs-paused') ) {
                //             console.log('继续播放');
                //             videoJsForH5SPlayer.Resume();
                //             selfVideo.tech().el().play();
                //         }
                //     }
                //     return true;
                // });

                selfVideo.getChild('bigPlayButton').on(['tap', 'click'], function() { 
                    console.log('首次播放');
                    videoJsForH5SPlayer.Connect();
                })
                
                
                selfVideo.getChild('controlBar').getChild('playToggle').on(['tap', 'click'],  function( event ) { 
                    if( selfVideo.paused() && !videoJsForH5SPlayer.h5splayer.isFrameTransmitting && videoJsForH5SPlayer.fakePlayStateObj.curTimestamp < videoJsForH5SPlayer.fakePlayStateObj.realEndTimeStamp ) {
                        console.log('检测：当前暂停');
                        console.log('开始播放');
                        videoJsForH5SPlayer.Resume();
                        selfVideo.tech().el().play(); // 实时流需要触发
                        selfVideo.play();
                    } else if( selfVideo.paused() && !videoJsForH5SPlayer.h5splayer.isFrameTransmitting && videoJsForH5SPlayer.fakePlayStateObj.curTimestamp >= videoJsForH5SPlayer.fakePlayStateObj.realEndTimeStamp ) {  // 需要重播
                        console.log('进行重播');
                        videoJsForH5SPlayer.h5splayer.seek( parseInt( videoJsForH5SPlayer.fakePlayStateObj.mistakeTime + 0 ) );  // 相对开始没有录制会跳转失败
                        videoJsForH5SPlayer.h5splayer.resume();
                        selfVideo.liveTracker.seekToLiveEdge(); // 最新流位置
                        selfVideo.tech().el().play(); // seeked前，视频有个播放暂停，实时流需要触发seeked
                        selfVideo.play();
                    }
                    // else {
                    //     console.log('%c暂停', 'color: red; font-size: 36px');
                    //     videoJsForH5SPlayer.Pause();
                    //     selfVideo.pause();
                    // }
                });

                // player.on('play',function() {
                //     console.log('播放中');
                // });

                
                // selfVideo.on('durationchange', function() {
                //     console.log('%c durationchange', 'color: red; font-size: 36px', this.fakePlayStateObj.duration);
                //     selfVideo.duration( this.fakePlayStateObj.duration  );
                // });

                selfVideo.on('pause', function() {
                    console.log('%c暂停', 'color: red; font-size: 36px');
                    videoJsForH5SPlayer.Pause();
                });

                // selfVideo.on('resume', function() {
                //     console.log('继续播放');
                //     videoJsForH5SPlayer.Resume();
                // });

                // selfVideo.duration(300);
                // selfVideo.currentTime(120);

                // this.on('timeupdate', function( ev ) {
                //     if( ev.manuallyTriggered ) { // .getChild('seekBar').getProgress()
                //         console.log('timeupdate:', ev,  selfVideo, event );

                //         // console.log('getPointerPosition:', videojs.dom.getPointerPosition( 
                //         //     selfVideo .getChild('controlBar').getChild('progressControl').getChild('seekBar').el(),
                //         //     event
                //         // ));
                //     }
                // });
                
                var isSeeking = false;
                var resolveSeekedFn = function () {
                    if( videoJsForH5SPlayer.newlyMouseupEv ) {
                        if( !videoJsForH5SPlayer.newlyMouseupEv.hasSeeked  ) {
                            
                            isSeeking = false;

                            var percentInfo = videojs.dom.getPointerPosition( 
                                selfVideo.getChild('controlBar').getChild('progressControl').getChild('seekBar').el(),
                                videoJsForH5SPlayer.newlyMouseupEv
                            );

                            console.log('getPointerPosition:', percentInfo);

                            if( percentInfo ) {
                                // 已触发on('pause', fn)
                                let seekTime = parseInt( videoJsForH5SPlayer.fakePlayStateObj.mistakeTime + selfVideo.duration() * percentInfo.x );
                                console.log('进度跳转', seekTime);
                                videoJsForH5SPlayer.h5splayer.seek( seekTime );  // 相对开始没有录制会跳转失败
                                videoJsForH5SPlayer.h5splayer.resume();
                                selfVideo.liveTracker.seekToLiveEdge(); // 最新流位置
                                selfVideo.tech().el().play(); // seeked前，视频有个播放暂停，实时流需要触发seeked
                                selfVideo.play();
                            }
                        }
                    }
                }

                this.on('seeked',  function( ev ) {
                    console.log('seeked', ev);
                    resolveSeekedFn();
                })

                this.on('seeking',  function( ev ) {
                    console.log('seeking', ev);
                    isSeeking = true;
                });
                
                selfVideo.getChild('controlBar').getChild('progressControl').on(['mouseup', 'touchend'], function(ev) {
                    // console.log('mouseup', ev, arguments, event);
                    videoJsForH5SPlayer.newlyMouseupEv = ev;
                    
                    setTimeout( function () {
                        if( isSeeking ) { // seeking失败不会触发seeked
                            console.log('辅助seeked');
                            selfVideo.pause();
                            videoJsForH5SPlayer.Pause();
                            resolveSeekedFn();
                        }
                    }, 50);
                });
        });
    }

    
    VideoJsForH5SPlayer.prototype.PlaybackCB = function(event, userdata) {
        // console.log("Playback callback ", event);
        
        var msgevent = JSON.parse(event);
        if (msgevent.type === 'H5S_EVENT_PB_TIME')
        {
            // console.log('userdata.value: ', userdata.value);

            if( userdata.curTimestamp === -Infinity && this.selfVideo ) {
                userdata.realBegintime = msgevent.pbTime.strTime || this.begintime;
                userdata.realBeginTimeStamp = new Date( this.iosDateStrCompatible( userdata.realBegintime ) ).getTime();
                userdata.mistakeTime = ( userdata.realBeginTimeStamp - ( new Date(  this.iosDateStrCompatible( this.begintime ) ).getTime() + 1000 ) ) / 1000;

                console.log( 'selfVideo.duration, mistakeTime:', userdata.mistakeTime);

                // gapSeconds
                userdata.duration = ( new Date( this.iosDateStrCompatible( this.endtime )  ).getTime() - 1000
                    - userdata.realBeginTimeStamp ) 
                    / 1000;

                // this.selfVideo.duration( userdata.duration  );
                setTimeout( () => this.selfVideo.duration( userdata.duration  ), 800 );
                setTimeout( () => this.selfVideo.duration( userdata.duration  ), 2000 );
            }

            userdata.value = msgevent.pbTime.strTime;

            if( msgevent.pbTime.strTime && this.selfVideo ) {
                userdata.curTimestamp = new Date( this.iosDateStrCompatible( msgevent.pbTime.strTime ) ).getTime();
                userdata.elapsedTime =  ( userdata.curTimestamp - userdata.realBeginTimeStamp ) / 1000;
                var currentTime = this.selfVideo.currentTime();

                if( this.newlyMouseupEv && !this.newlyMouseupEv.hasSeeked ) {
                    // this.selfVideo.currentTime( userdata.elapsedTime );
                    this.newlyMouseupEv.hasSeeked = true;

                    console.log( 'newlyMouseupEv.hasSeeked', true , userdata.elapsedTime);
                }
                //  else if( Math.abs(currentTime - userdata.elapsedTime) >= 1 ) { // 当前播放游标误差纠正
                //         console.log('纠正');
                //     this.selfVideo.currentTime( userdata.elapsedTime );
                // }
            }

            // console.log('当前播放时间点：', msgevent.pbTime.strTime);

            this.curPlayBackIsNone = false;
            this.hintTimer && clearTimeout( this.hintTimer );
        }
        
        if (msgevent.type === 'H5S_EVENT_PB_POS')
        {
            userdata.value = msgevent.pbPos.nPos;
        }
        if (msgevent.type === 'H5S_EVENT_PB_SESSION_ID')
        {
            this.strPbSession = msgevent.pbSessionId.strSession;
            
            if(  msgevent.strTime === 'none' ) {
                this.curPlayBackIsNone = true;
                this.hintTimer = setTimeout( function () {
                    if( this.curPlayBackIsNone ) {
                        this.curV5hOptions && this.curV5hOptions.recordNotFoundHintFn && this.curV5hOptions.recordNotFoundHintFn();
                    }
                }.bind( this ), 1500);
                
            }
        }

        if( msgevent.type === 'H5S_EVENT_PB_END' ) { // 结束时间
            if( msgevent.strTime ) {
                userdata.realEndtime = msgevent.strTime;
                userdata.realEndTimeStamp = ( new Date( this.iosDateStrCompatible( msgevent.strTime ) ).getTime() - 1000 ) / 1000;
                userdata.elapsedTime += .1; // 触发判断当前未在等待时长上
                this.selfVideo.handleTechEnded_();
            }
        }

        /*
            绿屏与回放画面交替闪烁，因h5steam录制的mp4为空文件为0KB
        */

        /*****
         * 事件段内不存在视频时未考虑，特征如下：
         * {
            "type": "H5S_EVENT_PB_SESSION_ID",
            "strDevToken": "token3",
            "strUUID": "none",
            "strTime": "none",
            "pbSessionId": {
            "strSession": "59078a1a-89b3-42cd-b51f-34fa6947c6ad"
            }
            }
         * 
         * 
         */
        
    }


    VideoJsForH5SPlayer.prototype.Connect = function() {
        console.log('h5splayer Connect', this.conf1);
        
        try{
            this.Stop();
        } catch ( e ) {
            console.warn('播放前重置：', e);
        }
        
        if( this.h5sPlayProtocol == 'rtc' ) {
            this.h5splayer = new H5sPlayerRTC(this.conf1);
        } else {
            this.h5splayer = new H5sPlayerWS(this.conf1);
        }
        this.h5splayer.connect();
        
    }

    VideoJsForH5SPlayer.prototype.Start = function()
    {
        
        if( this.h5splayer ) {
            this.h5splayer.start();
        } else {
            console.error('尝试start; h5splayer未定义');
        }
        
    }

    VideoJsForH5SPlayer.prototype.Stop = function ()
    {
        if( this.h5splayer ) {
            this.h5splayer.disconnect();

            delete this.h5splayer;
            this.h5splayer = null;
        } else {
            console.error('尝试stop; h5splayer未定义');
        }
       
    }

    VideoJsForH5SPlayer.prototype.Pause = function ()
    {
        if( this.h5splayer ) {
            this.h5splayer.pause();
        } else {
            console.error('尝试pause; h5splayer未定义');
        }
    }

    VideoJsForH5SPlayer.prototype.Resume = function()
    {
        if( this.h5splayer ) {
            this.h5splayer.resume();
        } else {
            console.error('尝试Resume; h5splayer未定义');
        }
    }

    // Speed()
    // {
    //     console.log("Speed", $('#speed1').val());
    //     this.h5splayer.speed($('#speed1').val());
    // }

    // Seek()
    // {
    //     console.log("Seek", $('#seek1').val());
    //     this.h5splayer.seek($('#seek1').val());
    // }

    // PbSnapshot()
    // {
    //     var url = '/api/v1/PbSnapshot?token=' + this.strToken + '&pbsession=' + this.strPbSession + '&session=' + this.strSession;
    //     $.get(url,function(data,status){
    //         console.log("Status: " + status);
    //      });
    // }

    // Snapshot()
    // {
    //     var date = new Date();
    //     var fileName = this.strToken + '_' + date.getFullYear() + '-' + (date.getMonth() + 1)
    //                 + '-' + date.getDate() + '-' + date.getHours() + '-' + date.getMinutes() + '-' + date.getSeconds();
    //     H5sSnapshot($('#h5sVideo1').get(0), fileName);
    // }

    // function isoDateStrTransform( isoStringLikely ) {
    //     var dateTimezoneArr = isoStringLikely.split('+');
    //     var dateStr = dateTimezoneArr[0];
    //     var dateTimeArr = dateStr.split('T');
    //     var timeStr = dateTimeArr[1];
    //     timeStr = timeStr.replace(/(\d)(?=(?:\d{2})+$)/g, '$1:');
    //     return  dateTimeArr[0].replace(/-/g, '/') + ' '
    //             + timeStr + '.'
    //             + dateTimezoneArr[1];
    // }

    VideoJsForH5SPlayer.prototype.iosDateStrCompatible = function( dateStr ) {
        return dateStr && dateStr.replace('T', ' ').replace(/-/g, '/') || dateStr;
    }

    VideoJsForH5SPlayer.prototype.destroy = function() {

        if( this.h5splayer ) {
            this.Pause();
            this.Stop();
        }

        if( this.selfVideo ) {
            setTimeout( () => this.selfVideo.dispose(), 240 );
        }
    }

    VideoJsForH5SPlayer.prototype.updateOptions = function( v5hOptions, isInit ) {

        v5hOptions = v5hOptions || {};

        if( isInit ) {
            if( !v5hOptions.videoMountPointId ) {
                console.error('初始化视频元素有误');
                return null;
            }
    
            if( !v5hOptions.h5sHost ) {
                console.error('视频地址有误');
                return null;
            }
    
            if( !v5hOptions.strToken ) {
                console.error('设备号有误');
                return null;
            }
            
            if( !v5hOptions.begintime ) {
                console.error('开始时间有误');
                return null;
            }
    
            if( !v5hOptions.endtime ) {
                console.error('结束时间有误');
                return null;
            }
        }
        this.curV5hOptions = v5hOptions;

        console.log('receive videoMountPointId：', v5hOptions.videoMountPointId.constructor == String && $('#' + v5hOptions.videoMountPointId ));

        if( v5hOptions.begintime !== undefined ) {
            this.begintime = v5hOptions.begintime;
            this.fakePlayStateObj.realBegintime = this.begintime;
            this.fakePlayStateObj.realBeginTimeStamp = new Date(  this.iosDateStrCompatible( this.begintime ) ).getTime();
            this.pbconf1.begintime = this.begintime;
        }
        
        if( v5hOptions.endtime !== undefined ) {
            this.endtime = v5hOptions.endtime;
            this.fakePlayStateObj.realEndtime = this.endtime;
            this.fakePlayStateObj.realEndTimeStamp = new Date(  this.iosDateStrCompatible( this.endtime ) ).getTime();
            this.pbconf1.endtime = this.endtime;
        }

        if( v5hOptions.strSession !== undefined ) {
            this.conf1.session = v5hOptions.strSession || this.strSession;
        }
        
        if( v5hOptions.strToken !== undefined ) {
            this.conf1.token = v5hOptions.strToken;
        }

        if( v5hOptions.h5sHost !== undefined ) {
            this.conf1.host = v5hOptions.h5sHost;
        }

        if( v5hOptions.protocol !== undefined ) {
            this.conf1.protocol = v5hOptions.protocol || this.conf1.protocol;
        }

        if( v5hOptions.h5sPlayProtocol !== undefined ) {
            this.h5sPlayProtocol = v5hOptions.h5sPlayProtocol || this.h5sPlayProtocol;
        }

        if( !isInit ) {
            
            if( this.h5splayer ) {
                this.Stop();
            }

            if( this.selfVideo ) {
                this.selfVideo.pause();
                this.selfVideo.reset();
                this.bindVideojsWithFakePlayStateObj( this.selfVideo );  // reset后需要重新bind
                this.videoElIdMaybeChange( v5hOptions );
            }
            this.resetState();
            
            this.Connect();
        }
        
        return true;
    }

    VideoJsForH5SPlayer.prototype.resetState = function() {
        this.fakePlayStateObj.value = '';
        this.fakePlayStateObj.curTimestamp = -Infinity;
        this.fakePlayStateObj.duration = 10;
        this.fakePlayStateObj.elapsedTime = 0;
        this.fakePlayStateObj.realBegintime = '';
        this.fakePlayStateObj.realEndtime = '';
        this.fakePlayStateObj.realBeginTimeStamp = 0;
        this.fakePlayStateObj.realEndTimeStamp = 0;
        this.fakePlayStateObj.mistakeTime = 0;
        this.newlyMouseupEv = undefined;
    }

    VideoJsForH5SPlayer.prototype.bindVideojsWithFakePlayStateObj = function( target ) {
        if( target ) {
            target.fakePlayStateObj = this.fakePlayStateObj; // 关联H5SPlayer信息
            target.tech().fakePlayStateObj = this.fakePlayStateObj;
        }
    }

    VideoJsForH5SPlayer.prototype.videoElIdMaybeChange = function( v5hOptions ) {

        if( this.selfVideo ) {
            var videoEle =  this.selfVideo.tech().el(); // this.children_[0];
            this.conf1.videoid = videoEle.id;
            // console.log('this video', this, this.children_[0].id);
    
            if( v5hOptions.videoReadyCb ) {
                v5hOptions.videoReadyCb( videoEle );
            }
        }
    }

    return VideoJsForH5SPlayer;
})();