cordova.define("cordova-plugin-audio-manager.AudioControl", function(require, exports, module) {
var exec = require('cordova/exec');

function defaults(object, source) {
  if(!object) object = {};
  for(var prop in source) {
    if(typeof object[prop] === 'undefined') {
      object[prop] = source[prop];
    }
  }
  return object;
}

exports.getCommunicationDevice = function( success, error) {
  exec(success, error, 'AudioControl', 'getCommunicationDevice', []);
};

exports.getAvailableCommunicationDevices = function(success, error) {
  exec(success, error, 'AudioControl', 'getAvailableCommunicationDevices', []);
};

exports.getAllDevices = function(success, error) {
  exec(success, error, 'AudioControl', 'getAllDevices', []);
};

exports.getOutputDevices = function(success, error) {
  exec(success, error, 'AudioControl', 'getOutputDevices', []);
};

exports.getMode = function(success, error) {
  exec(success, error, 'AudioControl', 'getMode', []);
};

exports.setMode = function(mode, success, error) {
  exec(success, error, 'AudioControl', 'setMode', [mode]);
};

exports.setCommunicationDevice = function(deviceType, success, error) {
  exec(success, error, 'AudioControl', 'setCommunicationDevice', [deviceType]);
};

exports.clearCommunicationDevice = function(success, error) {
  exec(success, error, 'AudioControl', 'clearCommunicationDevice', []);
};

exports.startBluetoothSco = function(success, error) {
  exec(success, error, 'AudioControl', 'startBluetoothSco', []);
};

exports.stopBluetoothSco = function(success, error) {
  exec(success, error, 'AudioControl', 'stopBluetoothSco', []);
};

exports.setBluetoothScoOn = function(ison, success, error) {
  exec(success, error, 'AudioControl', 'setBluetoothScoOn', [ison]);
};

exports.setSpeakerphoneOn = function(ison, success, error) {
  exec(success, error, 'AudioControl', 'setSpeakerphoneOn', [ison]);
};

exports.isBluetoothScoOn = function(success, error) {
  exec(success, error, 'AudioControl', 'isBluetoothScoOn', []);
};

exports.isSpeakerphoneOn = function(success, error) {
  exec(success, error, 'AudioControl', 'isSpeakerphoneOn', []);
};

exports.isWiredHeadsetOn = function(success, error) {
  exec(success, error, 'AudioControl', 'isWiredHeadsetOn', []);
};

exports.isBluetoothA2dpOn = function(success, error) {
  exec(success, error, 'AudioControl', 'isBluetoothA2dpOn', []);
};

exports.unloadSoundEffects = function(success, error) {
  exec(success, error, 'AudioControl', 'unloadSoundEffects', []);
};

/*
exports.getCategory = function(success, error) {
  exec(success, error, 'AudioControl', 'getCategory', []);
};

exports.hideVolume = function(success, error) {
  exec(success, error, 'AudioControl', 'hideVolume', []);
};
*/

});
