/**
 * @licstart The following is the entire license notice for the
 * JavaScript code in this page
 *
 * Copyright 2022 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * @licend The above is the entire license notice for the
 * JavaScript code in this page
 */
!function webpackUniversalModuleDefinition(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define("pdfjs-dist/build/pdf.worker",[],t):"object"==typeof exports?exports["pdfjs-dist/build/pdf.worker"]=t():e["pdfjs-dist/build/pdf.worker"]=e.pdfjsWorker=t()}(globalThis,(()=>(()=>{var e=[,(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.WorkerTask=t.WorkerMessageHandler=void 0;r(2);r(110);r(112);r(125);r(146);r(148);r(149);r(154);r(155);var n=r(158),a=r(209),i=r(210),s=r(288),o=r(282),c=r(322),l=r(323),h=r(213);Promise.allSettled||(Promise.allSettled=function(e){const t=e.filter((e=>!!e)).map((e=>e.then((e=>({status:"fulfilled",value:e}))).catch((e=>({status:"rejected",reason:e})))));return Promise.all(t)});class WorkerTask{constructor(e){this.name=e;this.terminated=!1;this._capability=(0,n.createPromiseCapability)()}get finished(){return this._capability.promise}finish(){this._capability.resolve()}terminate(){this.terminated=!0}ensureNotTerminated(){if(this.terminated)throw new Error("Worker task was terminated")}}t.WorkerTask=WorkerTask;class WorkerMessageHandler{static setup(e,t){let r=!1;e.on("test",(function wphSetupTest(t){if(!r){r=!0;e.send("test",t instanceof Uint8Array)}}));e.on("configure",(function wphConfigure(e){(0,n.setVerbosityLevel)(e.verbosity)}));e.on("GetDocRequest",(function wphSetupDoc(e){return WorkerMessageHandler.createDocumentHandler(e,t)}))}static createDocumentHandler(e,t){let r,u=!1,d=null;const f=[],g=(0,n.getVerbosityLevel)(),p=e.apiVersion,m="2.15.442";if(p!==m)throw new Error('The API version "'.concat(p,'" does not match ')+'the Worker version "'.concat(m,'".'));const b=[];for(const e in[])b.push(e);if(b.length)throw new Error("The `Array.prototype` contains unexpected enumerable properties: "+b.join(", ")+"; thus breaking e.g. `for...in` iteration of `Array`s.");if("undefined"==typeof ReadableStream){const e="The browser/environment lacks native support for critical functionality used by the PDF.js library (e.g. `ReadableStream`); ";if(isNodeJS)throw new Error(e+"please use a `legacy`-build instead.");throw new Error(e+"please update to a supported browser.")}const y=e.docId,w=e.docBaseUrl,S=e.docId+"_worker";let x=new c.MessageHandler(S,y,t);function ensureNotTerminated(){if(u)throw new Error("Worker was terminated")}function startWorkerTask(e){f.push(e)}function finishWorkerTask(e){e.finish();const t=f.indexOf(e);f.splice(t,1)}async function loadDocument(e){await r.ensureDoc("checkHeader");await r.ensureDoc("parseStartXRef");await r.ensureDoc("parse",[e]);await r.ensureDoc("checkFirstPage",[e]);await r.ensureDoc("checkLastPage",[e]);const t=await r.ensureDoc("isPureXfa");if(t){const e=new WorkerTask("loadXfaFonts");startWorkerTask(e);await Promise.all([r.loadXfaFonts(x,e).catch((e=>{})).then((()=>finishWorkerTask(e))),r.loadXfaImages()])}const[n,a]=await Promise.all([r.ensureDoc("numPages"),r.ensureDoc("fingerprints")]);return{numPages:n,fingerprints:a,htmlForXfa:t?await r.ensureDoc("htmlForXfa"):null}}function getPdfManager(e,t,r){const a=(0,n.createPromiseCapability)();let s;const o=e.source;if(o.data){try{s=new i.LocalPdfManager(y,o.data,o.password,x,t,r,w);a.resolve(s)}catch(e){a.reject(e)}return a.promise}let c,h=[];try{c=new l.PDFWorkerStream(x)}catch(e){a.reject(e);return a.promise}const u=c.getFullReader();u.headersReady.then((function(){if(!u.isRangeSupported)return;const e=o.disableAutoFetch||u.isStreamingSupported;s=new i.NetworkPdfManager(y,c,{msgHandler:x,password:o.password,length:u.contentLength,disableAutoFetch:e,rangeChunkSize:o.rangeChunkSize},t,r,w);for(let e=0;e<h.length;e++)s.sendProgressiveData(h[e]);h=[];a.resolve(s);d=null})).catch((function(e){a.reject(e);d=null}));let f=0;new Promise((function(e,c){const readChunk=function(e){let{value:l,done:g}=e;try{ensureNotTerminated();if(g){s||function(){const e=(0,n.arraysToBytes)(h);o.length&&e.length!==o.length&&(0,n.warn)("reported HTTP length is different from actual");try{s=new i.LocalPdfManager(y,e,o.password,x,t,r,w);a.resolve(s)}catch(e){a.reject(e)}h=[]}();d=null;return}f+=(0,n.arrayByteLength)(l);u.isStreamingSupported||x.send("DocProgress",{loaded:f,total:Math.max(f,u.contentLength||0)});s?s.sendProgressiveData(l):h.push(l);u.read().then(readChunk,c)}catch(e){c(e)}};u.read().then(readChunk,c)})).catch((function(e){a.reject(e);d=null}));d=function(e){c.cancelAllRequests(e)};return a.promise}x.on("GetPage",(function wphSetupGetPage(e){return r.getPage(e.pageIndex).then((function(e){return Promise.all([r.ensure(e,"rotate"),r.ensure(e,"ref"),r.ensure(e,"userUnit"),r.ensure(e,"view")]).then((function(e){let[t,r,n,a]=e;return{rotate:t,ref:r,userUnit:n,view:a}}))}))}));x.on("GetPageIndex",(function wphSetupGetPageIndex(e){const t=a.Ref.get(e.num,e.gen);return r.ensureCatalog("getPageIndex",[t])}));x.on("GetDestinations",(function wphSetupGetDestinations(e){return r.ensureCatalog("destinations")}));x.on("GetDestination",(function wphSetupGetDestination(e){return r.ensureCatalog("getDestination",[e.id])}));x.on("GetPageLabels",(function wphSetupGetPageLabels(e){return r.ensureCatalog("pageLabels")}));x.on("GetPageLayout",(function wphSetupGetPageLayout(e){return r.ensureCatalog("pageLayout")}));x.on("GetPageMode",(function wphSetupGetPageMode(e){return r.ensureCatalog("pageMode")}));x.on("GetViewerPreferences",(function(e){return r.ensureCatalog("viewerPreferences")}));x.on("GetOpenAction",(function(e){return r.ensureCatalog("openAction")}));x.on("GetAttachments",(function wphSetupGetAttachments(e){return r.ensureCatalog("attachments")}));x.on("GetJavaScript",(function wphSetupGetJavaScript(e){return r.ensureCatalog("javaScript")}));x.on("GetDocJSActions",(function wphSetupGetDocJSActions(e){return r.ensureCatalog("jsActions")}));x.on("GetPageJSActions",(function(e){let{pageIndex:t}=e;return r.getPage(t).then((function(e){return r.ensure(e,"jsActions")}))}));x.on("GetOutline",(function wphSetupGetOutline(e){return r.ensureCatalog("documentOutline")}));x.on("GetOptionalContentConfig",(function(e){return r.ensureCatalog("optionalContentConfig")}));x.on("GetPermissions",(function(e){return r.ensureCatalog("permissions")}));x.on("GetMetadata",(function wphSetupGetMetadata(e){return Promise.all([r.ensureDoc("documentInfo"),r.ensureCatalog("metadata")])}));x.on("GetMarkInfo",(function wphSetupGetMarkInfo(e){return r.ensureCatalog("markInfo")}));x.on("GetData",(function wphSetupGetData(e){r.requestLoadedStream();return r.onLoadedStream().then((function(e){return e.bytes}))}));x.on("GetAnnotations",(function(e){let{pageIndex:t,intent:n}=e;return r.getPage(t).then((function(e){return e.getAnnotationsData(n)}))}));x.on("GetFieldObjects",(function(e){return r.ensureDoc("fieldObjects")}));x.on("HasJSActions",(function(e){return r.ensureDoc("hasJSActions")}));x.on("GetCalculationOrderIds",(function(e){return r.ensureDoc("calculationOrderIds")}));x.on("SaveDocument",(function(e){let{isPureXfa:t,numPages:i,annotationStorage:s,filename:c}=e;r.requestLoadedStream();const l=new Map;if(!t)for(const[e,t]of s){if(!e.startsWith(n.AnnotationEditorPrefix))continue;let r=l.get(t.pageIndex);if(!r){r=[];l.set(t.pageIndex,r)}r.push(t)}const h=[r.onLoadedStream(),r.ensureCatalog("acroForm"),r.ensureCatalog("acroFormRef"),r.ensureDoc("xref"),r.ensureDoc("startXRef")];for(const[e,t]of l)h.push(r.getPage(e).then((r=>{const n=new WorkerTask("Save (editor): page ".concat(e));return r.saveNewAnnotations(x,n,t).finally((function(){finishWorkerTask(n)}))})));if(t)h.push(r.serializeXfaData(s));else for(let e=0;e<i;e++)h.push(r.getPage(e).then((function(t){const r=new WorkerTask("Save: page ".concat(e));return t.save(x,r,s).finally((function(){finishWorkerTask(r)}))})));return Promise.all(h).then((function(e){let[r,i,s,l,h,...u]=e,d=[],f=null;if(t){f=u[0];if(!f)return r.bytes}else{for(const e of u)d=e.filter((e=>null!==e)).reduce(((e,t)=>e.concat(t)),d);if(0===d.length)return r.bytes}const g=i instanceof a.Dict&&i.get("XFA")||null;let p=null,m=!1;if(Array.isArray(g)){for(let e=0,t=g.length;e<t;e+=2)if("datasets"===g[e]){p=g[e+1];s=null;m=!0}null===p&&(p=l.getNewRef())}else if(g){s=null;(0,n.warn)("Unsupported XFA type.")}let b=Object.create(null);if(l.trailer){const e=Object.create(null),t=l.trailer.get("Info")||null;t instanceof a.Dict&&t.forEach(((t,r)=>{"string"==typeof r&&(e[t]=(0,n.stringToPDFString)(r))}));b={rootRef:l.trailer.getRaw("Root")||null,encryptRef:l.trailer.getRaw("Encrypt")||null,newRef:l.getNewRef(),infoRef:l.trailer.getRaw("Info")||null,info:e,fileIds:l.trailer.get("ID")||null,startXRef:h,filename:c}}l.resetNewRef();return(0,o.incrementalUpdate)({originalData:r.bytes,xrefInfo:b,newRefs:d,xref:l,hasXfa:!!g,xfaDatasetsRef:p,hasXfaDatasetsEntry:m,acroFormRef:s,acroForm:i,xfaData:f})}))}));x.on("GetOperatorList",(function wphSetupRenderPage(e,t){const a=e.pageIndex;r.getPage(a).then((function(r){const i=new WorkerTask("GetOperatorList: page ".concat(a));startWorkerTask(i);const s=g>=n.VerbosityLevel.INFOS?Date.now():0;r.getOperatorList({handler:x,sink:t,task:i,intent:e.intent,cacheKey:e.cacheKey,annotationStorage:e.annotationStorage}).then((function(e){finishWorkerTask(i);s&&(0,n.info)("page=".concat(a+1," - getOperatorList: time=")+"".concat(Date.now()-s,"ms, len=").concat(e.length));t.close()}),(function(e){finishWorkerTask(i);if(!i.terminated){x.send("UnsupportedFeature",{featureId:n.UNSUPPORTED_FEATURES.errorOperatorList});t.error(e)}}))}))}));x.on("GetTextContent",(function wphExtractText(e,t){const a=e.pageIndex;r.getPage(a).then((function(r){const i=new WorkerTask("GetTextContent: page "+a);startWorkerTask(i);const s=g>=n.VerbosityLevel.INFOS?Date.now():0;r.extractTextContent({handler:x,task:i,sink:t,includeMarkedContent:e.includeMarkedContent,combineTextItems:e.combineTextItems}).then((function(){finishWorkerTask(i);s&&(0,n.info)("page=".concat(a+1," - getTextContent: time=")+"".concat(Date.now()-s,"ms"));t.close()}),(function(e){finishWorkerTask(i);i.terminated||t.error(e)}))}))}));x.on("GetStructTree",(function wphGetStructTree(e){return r.getPage(e.pageIndex).then((function(e){return r.ensure(e,"getStructTree")}))}));x.on("FontFallback",(function(e){return r.fontFallback(e.id,x)}));x.on("Cleanup",(function wphCleanup(e){return r.cleanup(!0)}));x.on("Terminate",(function wphTerminate(e){u=!0;const t=[];if(r){r.terminate(new n.AbortException("Worker was terminated."));const e=r.cleanup();t.push(e);r=null}else(0,s.clearGlobalCaches)();d&&d(new n.AbortException("Worker was terminated."));for(const e of f){t.push(e.finished);e.terminate()}return Promise.all(t).then((function(){x.destroy();x=null}))}));x.on("Ready",(function wphReady(t){!function setupDoc(e){function onSuccess(e){ensureNotTerminated();x.send("GetDoc",{pdfInfo:e})}function onFailure(e){ensureNotTerminated();if(e instanceof n.PasswordException){const t=new WorkerTask("PasswordException: response ".concat(e.code));startWorkerTask(t);x.sendWithPromise("PasswordRequest",e).then((function(e){let{password:n}=e;finishWorkerTask(t);r.updatePassword(n);pdfManagerReady()})).catch((function(){finishWorkerTask(t);x.send("DocException",e)}))}else e instanceof n.InvalidPDFException||e instanceof n.MissingPDFException||e instanceof n.UnexpectedResponseException||e instanceof n.UnknownErrorException?x.send("DocException",e):x.send("DocException",new n.UnknownErrorException(e.message,e.toString()))}function pdfManagerReady(){ensureNotTerminated();loadDocument(!1).then(onSuccess,(function(e){ensureNotTerminated();if(e instanceof h.XRefParseException){r.requestLoadedStream();r.onLoadedStream().then((function(){ensureNotTerminated();loadDocument(!0).then(onSuccess,onFailure)}))}else onFailure(e)}))}ensureNotTerminated();const t={maxImageSize:e.maxImageSize,disableFontFace:e.disableFontFace,ignoreErrors:e.ignoreErrors,isEvalSupported:e.isEvalSupported,fontExtraProperties:e.fontExtraProperties,useSystemFonts:e.useSystemFonts,cMapUrl:e.cMapUrl,standardFontDataUrl:e.standardFontDataUrl};let a=t.cMapUrl;"Function"===(null==a?void 0:a.constructor.name)&&(t.cMapUrl=a());getPdfManager(e,t,e.enableXfa).then((function(e){if(u){e.terminate(new n.AbortException("Worker was terminated."));throw new Error("Worker was terminated")}r=e;r.onLoadedStream().then((function(e){x.send("DataLoaded",{length:e.bytes.byteLength})}))})).then(pdfManagerReady,onFailure)}(e);e=null}));x.on("showUnverifiedSignatures",(function wphReady(e){e&&(0,n.info)("showUnverifiedSignatures="+e+". This is an incompletely implemented feature. Signatures cannot be validated, so use it at own risk.");self.showUnverifiedSignatures=e}));return S}static initializeFromPort(e){const t=new c.MessageHandler("worker","main",e);WorkerMessageHandler.setup(t,e);t.send("ready",null)}}t.WorkerMessageHandler=WorkerMessageHandler;"undefined"==typeof window&&"undefined"!=typeof self&&function isMessagePort(e){return"function"==typeof e.postMessage&&"onmessage"in e}(self)&&WorkerMessageHandler.initializeFromPort(self)},(e,t,r)=>{r(3);r(96);r(105);r(106);r(107);r(108)},(e,t,r)=>{"use strict";var n,a,i,s=r(4),o=r(35),c=r(68),l=r(5),h=r(9),u=r(47),d=r(69),f=r(71),g=r(72),p=r(30),m=r(21),b=r(20),y=r(73),w=r(74),S=r(79).set,x=r(86),v=r(89),k=r(90),C=r(91),O=r(51),T=r(92),M=r(93),E=r(95),D="Promise",N=M.CONSTRUCTOR,R=M.REJECTION_EVENT,L=M.SUBCLASSING,j=O.getterFor(D),_=O.set,U=T&&T.prototype,$=T,X=U,H=l.TypeError,q=l.document,W=l.process,z=E.f,G=z,V=!!(q&&q.createEvent&&l.dispatchEvent),K="unhandledrejection",isThenable=function(e){var t;return!(!b(e)||!m(t=e.then))&&t},callReaction=function(e,t){var r,n,a,i=t.value,s=1==t.state,o=s?e.ok:e.fail,c=e.resolve,l=e.reject,u=e.domain;try{if(o){if(!s){2===t.rejection&&onHandleUnhandled(t);t.rejection=1}if(!0===o)r=i;else{u&&u.enter();r=o(i);if(u){u.exit();a=!0}}r===e.promise?l(H("Promise-chain cycle")):(n=isThenable(r))?h(n,r,c,l):c(r)}else l(i)}catch(e){u&&!a&&u.exit();l(e)}},notify=function(e,t){if(!e.notified){e.notified=!0;x((function(){for(var r,n=e.reactions;r=n.get();)callReaction(r,e);e.notified=!1;t&&!e.rejection&&onUnhandled(e)}))}},dispatchEvent=function(e,t,r){var n,a;if(V){(n=q.createEvent("Event")).promise=t;n.reason=r;n.initEvent(e,!1,!0);l.dispatchEvent(n)}else n={promise:t,reason:r};!R&&(a=l["on"+e])?a(n):e===K&&v("Unhandled promise rejection",r)},onUnhandled=function(e){h(S,l,(function(){var t,r=e.facade,n=e.value;if(isUnhandled(e)){t=k((function(){c?W.emit("unhandledRejection",n,r):dispatchEvent(K,r,n)}));e.rejection=c||isUnhandled(e)?2:1;if(t.error)throw t.value}}))},isUnhandled=function(e){return 1!==e.rejection&&!e.parent},onHandleUnhandled=function(e){h(S,l,(function(){var t=e.facade;c?W.emit("rejectionHandled",t):dispatchEvent("rejectionhandled",t,e.value)}))},bind=function(e,t,r){return function(n){e(t,n,r)}},internalReject=function(e,t,r){if(!e.done){e.done=!0;r&&(e=r);e.value=t;e.state=2;notify(e,!0)}},internalResolve=function(e,t,r){if(!e.done){e.done=!0;r&&(e=r);try{if(e.facade===t)throw H("Promise can't be resolved itself");var n=isThenable(t);if(n)x((function(){var r={done:!1};try{h(n,t,bind(internalResolve,r,e),bind(internalReject,r,e))}catch(t){internalReject(r,t,e)}}));else{e.value=t;e.state=1;notify(e,!1)}}catch(t){internalReject({done:!1},t,e)}}};if(N){X=($=function Promise(e){y(this,X);p(e);h(n,this);var t=j(this);try{e(bind(internalResolve,t),bind(internalReject,t))}catch(e){internalReject(t,e)}}).prototype;(n=function Promise(e){_(this,{type:D,done:!1,notified:!1,parent:!1,reactions:new C,rejection:!1,state:0,value:void 0})}).prototype=u(X,"then",(function then(e,t){var r=j(this),n=z(w(this,$));r.parent=!0;n.ok=!m(e)||e;n.fail=m(t)&&t;n.domain=c?W.domain:void 0;0==r.state?r.reactions.add(n):x((function(){callReaction(n,r)}));return n.promise}));a=function(){var e=new n,t=j(e);this.promise=e;this.resolve=bind(internalResolve,t);this.reject=bind(internalReject,t)};E.f=z=function(e){return e===$||undefined===e?new a(e):G(e)};if(!o&&m(T)&&U!==Object.prototype){i=U.then;L||u(U,"then",(function then(e,t){var r=this;return new $((function(e,t){h(i,r,e,t)})).then(e,t)}),{unsafe:!0});try{delete U.constructor}catch(e){}d&&d(U,X)}}s({global:!0,constructor:!0,wrap:!0,forced:N},{Promise:$});f($,D,!1,!0);g(D)},(e,t,r)=>{var n=r(5),a=r(6).f,i=r(43),s=r(47),o=r(37),c=r(55),l=r(67);e.exports=function(e,t){var r,h,u,d,f,g=e.target,p=e.global,m=e.stat;if(r=p?n:m?n[g]||o(g,{}):(n[g]||{}).prototype)for(h in t){d=t[h];u=e.dontCallGetSet?(f=a(r,h))&&f.value:r[h];if(!l(p?h:g+(m?".":"#")+h,e.forced)&&void 0!==u){if(typeof d==typeof u)continue;c(d,u)}(e.sham||u&&u.sham)&&i(d,"sham",!0);s(r,h,d,e)}}},e=>{var check=function(e){return e&&e.Math==Math&&e};e.exports=check("object"==typeof globalThis&&globalThis)||check("object"==typeof window&&window)||check("object"==typeof self&&self)||check("object"==typeof global&&global)||function(){return this}()||Function("return this")()},(e,t,r)=>{var n=r(7),a=r(9),i=r(11),s=r(12),o=r(13),c=r(18),l=r(38),h=r(41),u=Object.getOwnPropertyDescriptor;t.f=n?u:function getOwnPropertyDescriptor(e,t){e=o(e);t=c(t);if(h)try{return u(e,t)}catch(e){}if(l(e,t))return s(!a(i.f,e,t),e[t])}},(e,t,r)=>{var n=r(8);e.exports=!n((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]}))},e=>{e.exports=function(e){try{return!!e()}catch(e){return!0}}},(e,t,r)=>{var n=r(10),a=Function.prototype.call;e.exports=n?a.bind(a):function(){return a.apply(a,arguments)}},(e,t,r)=>{var n=r(8);e.exports=!n((function(){var e=function(){}.bind();return"function"!=typeof e||e.hasOwnProperty("prototype")}))},(e,t)=>{"use strict";var r={}.propertyIsEnumerable,n=Object.getOwnPropertyDescriptor,a=n&&!r.call({1:2},1);t.f=a?function propertyIsEnumerable(e){var t=n(this,e);return!!t&&t.enumerable}:r},e=>{e.exports=function(e,t){return{enumerable:!(1&e),configurable:!(2&e),writable:!(4&e),value:t}}},(e,t,r)=>{var n=r(14),a=r(17);e.exports=function(e){return n(a(e))}},(e,t,r)=>{var n=r(15),a=r(8),i=r(16),s=Object,o=n("".split);e.exports=a((function(){return!s("z").propertyIsEnumerable(0)}))?function(e){return"String"==i(e)?o(e,""):s(e)}:s},(e,t,r)=>{var n=r(10),a=Function.prototype,i=a.bind,s=a.call,o=n&&i.bind(s,s);e.exports=n?function(e){return e&&o(e)}:function(e){return e&&function(){return s.apply(e,arguments)}}},(e,t,r)=>{var n=r(15),a=n({}.toString),i=n("".slice);e.exports=function(e){return i(a(e),8,-1)}},e=>{var t=TypeError;e.exports=function(e){if(null==e)throw t("Can't call method on "+e);return e}},(e,t,r)=>{var n=r(19),a=r(22);e.exports=function(e){var t=n(e,"string");return a(t)?t:t+""}},(e,t,r)=>{var n=r(9),a=r(20),i=r(22),s=r(29),o=r(32),c=r(33),l=TypeError,h=c("toPrimitive");e.exports=function(e,t){if(!a(e)||i(e))return e;var r,c=s(e,h);if(c){void 0===t&&(t="default");r=n(c,e,t);if(!a(r)||i(r))return r;throw l("Can't convert object to primitive value")}void 0===t&&(t="number");return o(e,t)}},(e,t,r)=>{var n=r(21);e.exports=function(e){return"object"==typeof e?null!==e:n(e)}},e=>{e.exports=function(e){return"function"==typeof e}},(e,t,r)=>{var n=r(23),a=r(21),i=r(24),s=r(25),o=Object;e.exports=s?function(e){return"symbol"==typeof e}:function(e){var t=n("Symbol");return a(t)&&i(t.prototype,o(e))}},(e,t,r)=>{var n=r(5),a=r(21),aFunction=function(e){return a(e)?e:void 0};e.exports=function(e,t){return arguments.length<2?aFunction(n[e]):n[e]&&n[e][t]}},(e,t,r)=>{var n=r(15);e.exports=n({}.isPrototypeOf)},(e,t,r)=>{var n=r(26);e.exports=n&&!Symbol.sham&&"symbol"==typeof Symbol.iterator},(e,t,r)=>{var n=r(27),a=r(8);e.exports=!!Object.getOwnPropertySymbols&&!a((function(){var e=Symbol();return!String(e)||!(Object(e)instanceof Symbol)||!Symbol.sham&&n&&n<41}))},(e,t,r)=>{var n,a,i=r(5),s=r(28),o=i.process,c=i.Deno,l=o&&o.versions||c&&c.version,h=l&&l.v8;h&&(a=(n=h.split("."))[0]>0&&n[0]<4?1:+(n[0]+n[1]));!a&&s&&(!(n=s.match(/Edge\/(\d+)/))||n[1]>=74)&&(n=s.match(/Chrome\/(\d+)/))&&(a=+n[1]);e.exports=a},(e,t,r)=>{var n=r(23);e.exports=n("navigator","userAgent")||""},(e,t,r)=>{var n=r(30);e.exports=function(e,t){var r=e[t];return null==r?void 0:n(r)}},(e,t,r)=>{var n=r(21),a=r(31),i=TypeError;e.exports=function(e){if(n(e))return e;throw i(a(e)+" is not a function")}},e=>{var t=String;e.exports=function(e){try{return t(e)}catch(e){return"Object"}}},(e,t,r)=>{var n=r(9),a=r(21),i=r(20),s=TypeError;e.exports=function(e,t){var r,o;if("string"===t&&a(r=e.toString)&&!i(o=n(r,e)))return o;if(a(r=e.valueOf)&&!i(o=n(r,e)))return o;if("string"!==t&&a(r=e.toString)&&!i(o=n(r,e)))return o;throw s("Can't convert object to primitive value")}},(e,t,r)=>{var n=r(5),a=r(34),i=r(38),s=r(40),o=r(26),c=r(25),l=a("wks"),h=n.Symbol,u=h&&h.for,d=c?h:h&&h.withoutSetter||s;e.exports=function(e){if(!i(l,e)||!o&&"string"!=typeof l[e]){var t="Symbol."+e;o&&i(h,e)?l[e]=h[e]:l[e]=c&&u?u(t):d(t)}return l[e]}},(e,t,r)=>{var n=r(35),a=r(36);(e.exports=function(e,t){return a[e]||(a[e]=void 0!==t?t:{})})("versions",[]).push({version:"3.23.1",mode:n?"pure":"global",copyright:"© 2014-2022 Denis Pushkarev (zloirock.ru)",license:"https://github.com/zloirock/core-js/blob/v3.23.1/LICENSE",source:"https://github.com/zloirock/core-js"})},e=>{e.exports=!1},(e,t,r)=>{var n=r(5),a=r(37),i="__core-js_shared__",s=n[i]||a(i,{});e.exports=s},(e,t,r)=>{var n=r(5),a=Object.defineProperty;e.exports=function(e,t){try{a(n,e,{value:t,configurable:!0,writable:!0})}catch(r){n[e]=t}return t}},(e,t,r)=>{var n=r(15),a=r(39),i=n({}.hasOwnProperty);e.exports=Object.hasOwn||function hasOwn(e,t){return i(a(e),t)}},(e,t,r)=>{var n=r(17),a=Object;e.exports=function(e){return a(n(e))}},(e,t,r)=>{var n=r(15),a=0,i=Math.random(),s=n(1..toString);e.exports=function(e){return"Symbol("+(void 0===e?"":e)+")_"+s(++a+i,36)}},(e,t,r)=>{var n=r(7),a=r(8),i=r(42);e.exports=!n&&!a((function(){return 7!=Object.defineProperty(i("div"),"a",{get:function(){return 7}}).a}))},(e,t,r)=>{var n=r(5),a=r(20),i=n.document,s=a(i)&&a(i.createElement);e.exports=function(e){return s?i.createElement(e):{}}},(e,t,r)=>{var n=r(7),a=r(44),i=r(12);e.exports=n?function(e,t,r){return a.f(e,t,i(1,r))}:function(e,t,r){e[t]=r;return e}},(e,t,r)=>{var n=r(7),a=r(41),i=r(45),s=r(46),o=r(18),c=TypeError,l=Object.defineProperty,h=Object.getOwnPropertyDescriptor,u="enumerable",d="configurable",f="writable";t.f=n?i?function defineProperty(e,t,r){s(e);t=o(t);s(r);if("function"==typeof e&&"prototype"===t&&"value"in r&&f in r&&!r.writable){var n=h(e,t);if(n&&n.writable){e[t]=r.value;r={configurable:d in r?r.configurable:n.configurable,enumerable:u in r?r.enumerable:n.enumerable,writable:!1}}}return l(e,t,r)}:l:function defineProperty(e,t,r){s(e);t=o(t);s(r);if(a)try{return l(e,t,r)}catch(e){}if("get"in r||"set"in r)throw c("Accessors not supported");"value"in r&&(e[t]=r.value);return e}},(e,t,r)=>{var n=r(7),a=r(8);e.exports=n&&a((function(){return 42!=Object.defineProperty((function(){}),"prototype",{value:42,writable:!1}).prototype}))},(e,t,r)=>{var n=r(20),a=String,i=TypeError;e.exports=function(e){if(n(e))return e;throw i(a(e)+" is not an object")}},(e,t,r)=>{var n=r(21),a=r(44),i=r(48),s=r(37);e.exports=function(e,t,r,o){o||(o={});var c=o.enumerable,l=void 0!==o.name?o.name:t;n(r)&&i(r,l,o);if(o.global)c?e[t]=r:s(t,r);else{o.unsafe?e[t]&&(c=!0):delete e[t];c?e[t]=r:a.f(e,t,{value:r,enumerable:!1,configurable:!o.nonConfigurable,writable:!o.nonWritable})}return e}},(e,t,r)=>{var n=r(8),a=r(21),i=r(38),s=r(7),o=r(49).CONFIGURABLE,c=r(50),l=r(51),h=l.enforce,u=l.get,d=Object.defineProperty,f=s&&!n((function(){return 8!==d((function(){}),"length",{value:8}).length})),g=String(String).split("String"),p=e.exports=function(e,t,r){"Symbol("===String(t).slice(0,7)&&(t="["+String(t).replace(/^Symbol\(([^)]*)\)/,"$1")+"]");r&&r.getter&&(t="get "+t);r&&r.setter&&(t="set "+t);(!i(e,"name")||o&&e.name!==t)&&d(e,"name",{value:t,configurable:!0});f&&r&&i(r,"arity")&&e.length!==r.arity&&d(e,"length",{value:r.arity});try{r&&i(r,"constructor")&&r.constructor?s&&d(e,"prototype",{writable:!1}):e.prototype&&(e.prototype=void 0)}catch(e){}var n=h(e);i(n,"source")||(n.source=g.join("string"==typeof t?t:""));return e};Function.prototype.toString=p((function toString(){return a(this)&&u(this).source||c(this)}),"toString")},(e,t,r)=>{var n=r(7),a=r(38),i=Function.prototype,s=n&&Object.getOwnPropertyDescriptor,o=a(i,"name"),c=o&&"something"===function something(){}.name,l=o&&(!n||n&&s(i,"name").configurable);e.exports={EXISTS:o,PROPER:c,CONFIGURABLE:l}},(e,t,r)=>{var n=r(15),a=r(21),i=r(36),s=n(Function.toString);a(i.inspectSource)||(i.inspectSource=function(e){return s(e)});e.exports=i.inspectSource},(e,t,r)=>{var n,a,i,s=r(52),o=r(5),c=r(15),l=r(20),h=r(43),u=r(38),d=r(36),f=r(53),g=r(54),p="Object already initialized",m=o.TypeError,b=o.WeakMap;if(s||d.state){var y=d.state||(d.state=new b),w=c(y.get),S=c(y.has),x=c(y.set);n=function(e,t){if(S(y,e))throw new m(p);t.facade=e;x(y,e,t);return t};a=function(e){return w(y,e)||{}};i=function(e){return S(y,e)}}else{var v=f("state");g[v]=!0;n=function(e,t){if(u(e,v))throw new m(p);t.facade=e;h(e,v,t);return t};a=function(e){return u(e,v)?e[v]:{}};i=function(e){return u(e,v)}}e.exports={set:n,get:a,has:i,enforce:function(e){return i(e)?a(e):n(e,{})},getterFor:function(e){return function(t){var r;if(!l(t)||(r=a(t)).type!==e)throw m("Incompatible receiver, "+e+" required");return r}}}},(e,t,r)=>{var n=r(5),a=r(21),i=r(50),s=n.WeakMap;e.exports=a(s)&&/native code/.test(i(s))},(e,t,r)=>{var n=r(34),a=r(40),i=n("keys");e.exports=function(e){return i[e]||(i[e]=a(e))}},e=>{e.exports={}},(e,t,r)=>{var n=r(38),a=r(56),i=r(6),s=r(44);e.exports=function(e,t,r){for(var o=a(t),c=s.f,l=i.f,h=0;h<o.length;h++){var u=o[h];n(e,u)||r&&n(r,u)||c(e,u,l(t,u))}}},(e,t,r)=>{var n=r(23),a=r(15),i=r(57),s=r(66),o=r(46),c=a([].concat);e.exports=n("Reflect","ownKeys")||function ownKeys(e){var t=i.f(o(e)),r=s.f;return r?c(t,r(e)):t}},(e,t,r)=>{var n=r(58),a=r(65).concat("length","prototype");t.f=Object.getOwnPropertyNames||function getOwnPropertyNames(e){return n(e,a)}},(e,t,r)=>{var n=r(15),a=r(38),i=r(13),s=r(59).indexOf,o=r(54),c=n([].push);e.exports=function(e,t){var r,n=i(e),l=0,h=[];for(r in n)!a(o,r)&&a(n,r)&&c(h,r);for(;t.length>l;)a(n,r=t[l++])&&(~s(h,r)||c(h,r));return h}},(e,t,r)=>{var n=r(13),a=r(60),i=r(63),createMethod=function(e){return function(t,r,s){var o,c=n(t),l=i(c),h=a(s,l);if(e&&r!=r){for(;l>h;)if((o=c[h++])!=o)return!0}else for(;l>h;h++)if((e||h in c)&&c[h]===r)return e||h||0;return!e&&-1}};e.exports={includes:createMethod(!0),indexOf:createMethod(!1)}},(e,t,r)=>{var n=r(61),a=Math.max,i=Math.min;e.exports=function(e,t){var r=n(e);return r<0?a(r+t,0):i(r,t)}},(e,t,r)=>{var n=r(62);e.exports=function(e){var t=+e;return t!=t||0===t?0:n(t)}},e=>{var t=Math.ceil,r=Math.floor;e.exports=Math.trunc||function trunc(e){var n=+e;return(n>0?r:t)(n)}},(e,t,r)=>{var n=r(64);e.exports=function(e){return n(e.length)}},(e,t,r)=>{var n=r(61),a=Math.min;e.exports=function(e){return e>0?a(n(e),9007199254740991):0}},e=>{e.exports=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"]},(e,t)=>{t.f=Object.getOwnPropertySymbols},(e,t,r)=>{var n=r(8),a=r(21),i=/#|\.prototype\./,isForced=function(e,t){var r=o[s(e)];return r==l||r!=c&&(a(t)?n(t):!!t)},s=isForced.normalize=function(e){return String(e).replace(i,".").toLowerCase()},o=isForced.data={},c=isForced.NATIVE="N",l=isForced.POLYFILL="P";e.exports=isForced},(e,t,r)=>{var n=r(16),a=r(5);e.exports="process"==n(a.process)},(e,t,r)=>{var n=r(15),a=r(46),i=r(70);e.exports=Object.setPrototypeOf||("__proto__"in{}?function(){var e,t=!1,r={};try{(e=n(Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set))(r,[]);t=r instanceof Array}catch(e){}return function setPrototypeOf(r,n){a(r);i(n);t?e(r,n):r.__proto__=n;return r}}():void 0)},(e,t,r)=>{var n=r(21),a=String,i=TypeError;e.exports=function(e){if("object"==typeof e||n(e))return e;throw i("Can't set "+a(e)+" as a prototype")}},(e,t,r)=>{var n=r(44).f,a=r(38),i=r(33)("toStringTag");e.exports=function(e,t,r){e&&!r&&(e=e.prototype);e&&!a(e,i)&&n(e,i,{configurable:!0,value:t})}},(e,t,r)=>{"use strict";var n=r(23),a=r(44),i=r(33),s=r(7),o=i("species");e.exports=function(e){var t=n(e),r=a.f;s&&t&&!t[o]&&r(t,o,{configurable:!0,get:function(){return this}})}},(e,t,r)=>{var n=r(24),a=TypeError;e.exports=function(e,t){if(n(t,e))return e;throw a("Incorrect invocation")}},(e,t,r)=>{var n=r(46),a=r(75),i=r(33)("species");e.exports=function(e,t){var r,s=n(e).constructor;return void 0===s||null==(r=n(s)[i])?t:a(r)}},(e,t,r)=>{var n=r(76),a=r(31),i=TypeError;e.exports=function(e){if(n(e))return e;throw i(a(e)+" is not a constructor")}},(e,t,r)=>{var n=r(15),a=r(8),i=r(21),s=r(77),o=r(23),c=r(50),noop=function(){},l=[],h=o("Reflect","construct"),u=/^\s*(?:class|function)\b/,d=n(u.exec),f=!u.exec(noop),g=function isConstructor(e){if(!i(e))return!1;try{h(noop,l,e);return!0}catch(e){return!1}},p=function isConstructor(e){if(!i(e))return!1;switch(s(e)){case"AsyncFunction":case"GeneratorFunction":case"AsyncGeneratorFunction":return!1}try{return f||!!d(u,c(e))}catch(e){return!0}};p.sham=!0;e.exports=!h||a((function(){var e;return g(g.call)||!g(Object)||!g((function(){e=!0}))||e}))?p:g},(e,t,r)=>{var n=r(78),a=r(21),i=r(16),s=r(33)("toStringTag"),o=Object,c="Arguments"==i(function(){return arguments}());e.exports=n?i:function(e){var t,r,n;return void 0===e?"Undefined":null===e?"Null":"string"==typeof(r=function(e,t){try{return e[t]}catch(e){}}(t=o(e),s))?r:c?i(t):"Object"==(n=i(t))&&a(t.callee)?"Arguments":n}},(e,t,r)=>{var n={};n[r(33)("toStringTag")]="z";e.exports="[object z]"===String(n)},(e,t,r)=>{var n,a,i,s,o=r(5),c=r(80),l=r(81),h=r(21),u=r(38),d=r(8),f=r(82),g=r(83),p=r(42),m=r(84),b=r(85),y=r(68),w=o.setImmediate,S=o.clearImmediate,x=o.process,v=o.Dispatch,k=o.Function,C=o.MessageChannel,O=o.String,T=0,M={},E="onreadystatechange";try{n=o.location}catch(e){}var run=function(e){if(u(M,e)){var t=M[e];delete M[e];t()}},runner=function(e){return function(){run(e)}},listener=function(e){run(e.data)},post=function(e){o.postMessage(O(e),n.protocol+"//"+n.host)};if(!w||!S){w=function setImmediate(e){m(arguments.length,1);var t=h(e)?e:k(e),r=g(arguments,1);M[++T]=function(){c(t,void 0,r)};a(T);return T};S=function clearImmediate(e){delete M[e]};if(y)a=function(e){x.nextTick(runner(e))};else if(v&&v.now)a=function(e){v.now(runner(e))};else if(C&&!b){s=(i=new C).port2;i.port1.onmessage=listener;a=l(s.postMessage,s)}else if(o.addEventListener&&h(o.postMessage)&&!o.importScripts&&n&&"file:"!==n.protocol&&!d(post)){a=post;o.addEventListener("message",listener,!1)}else a=E in p("script")?function(e){f.appendChild(p("script")).onreadystatechange=function(){f.removeChild(this);run(e)}}:function(e){setTimeout(runner(e),0)}}e.exports={set:w,clear:S}},(e,t,r)=>{var n=r(10),a=Function.prototype,i=a.apply,s=a.call;e.exports="object"==typeof Reflect&&Reflect.apply||(n?s.bind(i):function(){return s.apply(i,arguments)})},(e,t,r)=>{var n=r(15),a=r(30),i=r(10),s=n(n.bind);e.exports=function(e,t){a(e);return void 0===t?e:i?s(e,t):function(){return e.apply(t,arguments)}}},(e,t,r)=>{var n=r(23);e.exports=n("document","documentElement")},(e,t,r)=>{var n=r(15);e.exports=n([].slice)},e=>{var t=TypeError;e.exports=function(e,r){if(e<r)throw t("Not enough arguments");return e}},(e,t,r)=>{var n=r(28);e.exports=/(?:ipad|iphone|ipod).*applewebkit/i.test(n)},(e,t,r)=>{var n,a,i,s,o,c,l,h,u=r(5),d=r(81),f=r(6).f,g=r(79).set,p=r(85),m=r(87),b=r(88),y=r(68),w=u.MutationObserver||u.WebKitMutationObserver,S=u.document,x=u.process,v=u.Promise,k=f(u,"queueMicrotask"),C=k&&k.value;if(!C){n=function(){var e,t;y&&(e=x.domain)&&e.exit();for(;a;){t=a.fn;a=a.next;try{t()}catch(e){a?s():i=void 0;throw e}}i=void 0;e&&e.enter()};if(p||y||b||!w||!S)if(!m&&v&&v.resolve){(l=v.resolve(void 0)).constructor=v;h=d(l.then,l);s=function(){h(n)}}else if(y)s=function(){x.nextTick(n)};else{g=d(g,u);s=function(){g(n)}}else{o=!0;c=S.createTextNode("");new w(n).observe(c,{characterData:!0});s=function(){c.data=o=!o}}}e.exports=C||function(e){var t={fn:e,next:void 0};i&&(i.next=t);if(!a){a=t;s()}i=t}},(e,t,r)=>{var n=r(28),a=r(5);e.exports=/ipad|iphone|ipod/i.test(n)&&void 0!==a.Pebble},(e,t,r)=>{var n=r(28);e.exports=/web0s(?!.*chrome)/i.test(n)},(e,t,r)=>{var n=r(5);e.exports=function(e,t){var r=n.console;r&&r.error&&(1==arguments.length?r.error(e):r.error(e,t))}},e=>{e.exports=function(e){try{return{error:!1,value:e()}}catch(e){return{error:!0,value:e}}}},e=>{var Queue=function(){this.head=null;this.tail=null};Queue.prototype={add:function(e){var t={item:e,next:null};this.head?this.tail.next=t:this.head=t;this.tail=t},get:function(){var e=this.head;if(e){this.head=e.next;this.tail===e&&(this.tail=null);return e.item}}};e.exports=Queue},(e,t,r)=>{var n=r(5);e.exports=n.Promise},(e,t,r)=>{var n=r(5),a=r(92),i=r(21),s=r(67),o=r(50),c=r(33),l=r(94),h=r(35),u=r(27),d=a&&a.prototype,f=c("species"),g=!1,p=i(n.PromiseRejectionEvent),m=s("Promise",(function(){var e=o(a),t=e!==String(a);if(!t&&66===u)return!0;if(h&&(!d.catch||!d.finally))return!0;if(u>=51&&/native code/.test(e))return!1;var r=new a((function(e){e(1)})),FakePromise=function(e){e((function(){}),(function(){}))};(r.constructor={})[f]=FakePromise;return!(g=r.then((function(){}))instanceof FakePromise)||!t&&l&&!p}));e.exports={CONSTRUCTOR:m,REJECTION_EVENT:p,SUBCLASSING:g}},e=>{e.exports="object"==typeof window&&"object"!=typeof Deno},(e,t,r)=>{"use strict";var n=r(30),PromiseCapability=function(e){var t,r;this.promise=new e((function(e,n){if(void 0!==t||void 0!==r)throw TypeError("Bad Promise constructor");t=e;r=n}));this.resolve=n(t);this.reject=n(r)};e.exports.f=function(e){return new PromiseCapability(e)}},(e,t,r)=>{"use strict";var n=r(4),a=r(9),i=r(30),s=r(95),o=r(90),c=r(97);n({target:"Promise",stat:!0,forced:r(103)},{all:function all(e){var t=this,r=s.f(t),n=r.resolve,l=r.reject,h=o((function(){var r=i(t.resolve),s=[],o=0,h=1;c(e,(function(e){var i=o++,c=!1;h++;a(r,t,e).then((function(e){if(!c){c=!0;s[i]=e;--h||n(s)}}),l)}));--h||n(s)}));h.error&&l(h.value);return r.promise}})},(e,t,r)=>{var n=r(81),a=r(9),i=r(46),s=r(31),o=r(98),c=r(63),l=r(24),h=r(100),u=r(101),d=r(102),f=TypeError,Result=function(e,t){this.stopped=e;this.result=t},g=Result.prototype;e.exports=function(e,t,r){var p,m,b,y,w,S,x,v=r&&r.that,k=!(!r||!r.AS_ENTRIES),C=!(!r||!r.IS_ITERATOR),O=!(!r||!r.INTERRUPTED),T=n(t,v),stop=function(e){p&&d(p,"normal",e);return new Result(!0,e)},callFn=function(e){if(k){i(e);return O?T(e[0],e[1],stop):T(e[0],e[1])}return O?T(e,stop):T(e)};if(C)p=e;else{if(!(m=u(e)))throw f(s(e)+" is not iterable");if(o(m)){for(b=0,y=c(e);y>b;b++)if((w=callFn(e[b]))&&l(g,w))return w;return new Result(!1)}p=h(e,m)}S=p.next;for(;!(x=a(S,p)).done;){try{w=callFn(x.value)}catch(e){d(p,"throw",e)}if("object"==typeof w&&w&&l(g,w))return w}return new Result(!1)}},(e,t,r)=>{var n=r(33),a=r(99),i=n("iterator"),s=Array.prototype;e.exports=function(e){return void 0!==e&&(a.Array===e||s[i]===e)}},e=>{e.exports={}},(e,t,r)=>{var n=r(9),a=r(30),i=r(46),s=r(31),o=r(101),c=TypeError;e.exports=function(e,t){var r=arguments.length<2?o(e):t;if(a(r))return i(n(r,e));throw c(s(e)+" is not iterable")}},(e,t,r)=>{var n=r(77),a=r(29),i=r(99),s=r(33)("iterator");e.exports=function(e){if(null!=e)return a(e,s)||a(e,"@@iterator")||i[n(e)]}},(e,t,r)=>{var n=r(9),a=r(46),i=r(29);e.exports=function(e,t,r){var s,o;a(e);try{if(!(s=i(e,"return"))){if("throw"===t)throw r;return r}s=n(s,e)}catch(e){o=!0;s=e}if("throw"===t)throw r;if(o)throw s;a(s);return r}},(e,t,r)=>{var n=r(92),a=r(104),i=r(93).CONSTRUCTOR;e.exports=i||!a((function(e){n.all(e).then(void 0,(function(){}))}))},(e,t,r)=>{var n=r(33)("iterator"),a=!1;try{var i=0,s={next:function(){return{done:!!i++}},return:function(){a=!0}};s[n]=function(){return this};Array.from(s,(function(){throw 2}))}catch(e){}e.exports=function(e,t){if(!t&&!a)return!1;var r=!1;try{var i={};i[n]=function(){return{next:function(){return{done:r=!0}}}};e(i)}catch(e){}return r}},(e,t,r)=>{"use strict";var n=r(4),a=r(35),i=r(93).CONSTRUCTOR,s=r(92),o=r(23),c=r(21),l=r(47),h=s&&s.prototype;n({target:"Promise",proto:!0,forced:i,real:!0},{catch:function(e){return this.then(void 0,e)}});if(!a&&c(s)){var u=o("Promise").prototype.catch;h.catch!==u&&l(h,"catch",u,{unsafe:!0})}},(e,t,r)=>{"use strict";var n=r(4),a=r(9),i=r(30),s=r(95),o=r(90),c=r(97);n({target:"Promise",stat:!0,forced:r(103)},{race:function race(e){var t=this,r=s.f(t),n=r.reject,l=o((function(){var s=i(t.resolve);c(e,(function(e){a(s,t,e).then(r.resolve,n)}))}));l.error&&n(l.value);return r.promise}})},(e,t,r)=>{"use strict";var n=r(4),a=r(9),i=r(95);n({target:"Promise",stat:!0,forced:r(93).CONSTRUCTOR},{reject:function reject(e){var t=i.f(this);a(t.reject,void 0,e);return t.promise}})},(e,t,r)=>{"use strict";var n=r(4),a=r(23),i=r(35),s=r(92),o=r(93).CONSTRUCTOR,c=r(109),l=a("Promise"),h=i&&!o;n({target:"Promise",stat:!0,forced:i||o},{resolve:function resolve(e){return c(h&&this===l?s:this,e)}})},(e,t,r)=>{var n=r(46),a=r(20),i=r(95);e.exports=function(e,t){n(e);if(a(t)&&t.constructor===e)return t;var r=i.f(e);(0,r.resolve)(t);return r.promise}},(e,t,r)=>{r(111)},(e,t,r)=>{"use strict";var n=r(4),a=r(9),i=r(30),s=r(95),o=r(90),c=r(97);n({target:"Promise",stat:!0},{allSettled:function allSettled(e){var t=this,r=s.f(t),n=r.resolve,l=r.reject,h=o((function(){var r=i(t.resolve),s=[],o=0,l=1;c(e,(function(e){var i=o++,c=!1;l++;a(r,t,e).then((function(e){if(!c){c=!0;s[i]={status:"fulfilled",value:e};--l||n(s)}}),(function(e){if(!c){c=!0;s[i]={status:"rejected",reason:e};--l||n(s)}}))}));--l||n(s)}));h.error&&l(h.value);return r.promise}})},(e,t,r)=>{var n=r(5),a=r(113),i=r(114),s=r(115),o=r(43),c=r(33),l=c("iterator"),h=c("toStringTag"),u=s.values,handlePrototype=function(e,t){if(e){if(e[l]!==u)try{o(e,l,u)}catch(t){e[l]=u}e[h]||o(e,h,t);if(a[t])for(var r in s)if(e[r]!==s[r])try{o(e,r,s[r])}catch(t){e[r]=s[r]}}};for(var d in a)handlePrototype(n[d]&&n[d].prototype,d);handlePrototype(i,"DOMTokenList")},e=>{e.exports={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}},(e,t,r)=>{var n=r(42)("span").classList,a=n&&n.constructor&&n.constructor.prototype;e.exports=a===Object.prototype?void 0:a},(e,t,r)=>{"use strict";var n=r(13),a=r(116),i=r(99),s=r(51),o=r(44).f,c=r(120),l=r(35),h=r(7),u="Array Iterator",d=s.set,f=s.getterFor(u);e.exports=c(Array,"Array",(function(e,t){d(this,{type:u,target:n(e),index:0,kind:t})}),(function(){var e=f(this),t=e.target,r=e.kind,n=e.index++;if(!t||n>=t.length){e.target=void 0;return{value:void 0,done:!0}}return"keys"==r?{value:n,done:!1}:"values"==r?{value:t[n],done:!1}:{value:[n,t[n]],done:!1}}),"values");var g=i.Arguments=i.Array;a("keys");a("values");a("entries");if(!l&&h&&"values"!==g.name)try{o(g,"name",{value:"values"})}catch(e){}},(e,t,r)=>{var n=r(33),a=r(117),i=r(44).f,s=n("unscopables"),o=Array.prototype;null==o[s]&&i(o,s,{configurable:!0,value:a(null)});e.exports=function(e){o[s][e]=!0}},(e,t,r)=>{var n,a=r(46),i=r(118),s=r(65),o=r(54),c=r(82),l=r(42),h=r(53),u=h("IE_PROTO"),EmptyConstructor=function(){},scriptTag=function(e){return"<script>"+e+"</"+"script>"},NullProtoObjectViaActiveX=function(e){e.write(scriptTag(""));e.close();var t=e.parentWindow.Object;e=null;return t},NullProtoObject=function(){try{n=new ActiveXObject("htmlfile")}catch(e){}NullProtoObject="undefined"!=typeof document?document.domain&&n?NullProtoObjectViaActiveX(n):function(){var e,t=l("iframe");t.style.display="none";c.appendChild(t);t.src=String("javascript:");(e=t.contentWindow.document).open();e.write(scriptTag("document.F=Object"));e.close();return e.F}():NullProtoObjectViaActiveX(n);for(var e=s.length;e--;)delete NullProtoObject.prototype[s[e]];return NullProtoObject()};o[u]=!0;e.exports=Object.create||function create(e,t){var r;if(null!==e){EmptyConstructor.prototype=a(e);r=new EmptyConstructor;EmptyConstructor.prototype=null;r[u]=e}else r=NullProtoObject();return void 0===t?r:i.f(r,t)}},(e,t,r)=>{var n=r(7),a=r(45),i=r(44),s=r(46),o=r(13),c=r(119);t.f=n&&!a?Object.defineProperties:function defineProperties(e,t){s(e);for(var r,n=o(t),a=c(t),l=a.length,h=0;l>h;)i.f(e,r=a[h++],n[r]);return e}},(e,t,r)=>{var n=r(58),a=r(65);e.exports=Object.keys||function keys(e){return n(e,a)}},(e,t,r)=>{"use strict";var n=r(4),a=r(9),i=r(35),s=r(49),o=r(21),c=r(121),l=r(123),h=r(69),u=r(71),d=r(43),f=r(47),g=r(33),p=r(99),m=r(122),b=s.PROPER,y=s.CONFIGURABLE,w=m.IteratorPrototype,S=m.BUGGY_SAFARI_ITERATORS,x=g("iterator"),v="keys",k="values",C="entries",returnThis=function(){return this};e.exports=function(e,t,r,s,g,m,O){c(r,t,s);var T,M,E,getIterationMethod=function(e){if(e===g&&j)return j;if(!S&&e in R)return R[e];switch(e){case v:return function keys(){return new r(this,e)};case k:return function values(){return new r(this,e)};case C:return function entries(){return new r(this,e)}}return function(){return new r(this)}},D=t+" Iterator",N=!1,R=e.prototype,L=R[x]||R["@@iterator"]||g&&R[g],j=!S&&L||getIterationMethod(g),_="Array"==t&&R.entries||L;if(_&&(T=l(_.call(new e)))!==Object.prototype&&T.next){i||l(T)===w||(h?h(T,w):o(T[x])||f(T,x,returnThis));u(T,D,!0,!0);i&&(p[D]=returnThis)}if(b&&g==k&&L&&L.name!==k)if(!i&&y)d(R,"name",k);else{N=!0;j=function values(){return a(L,this)}}if(g){M={values:getIterationMethod(k),keys:m?j:getIterationMethod(v),entries:getIterationMethod(C)};if(O)for(E in M)(S||N||!(E in R))&&f(R,E,M[E]);else n({target:t,proto:!0,forced:S||N},M)}i&&!O||R[x]===j||f(R,x,j,{name:g});p[t]=j;return M}},(e,t,r)=>{"use strict";var n=r(122).IteratorPrototype,a=r(117),i=r(12),s=r(71),o=r(99),returnThis=function(){return this};e.exports=function(e,t,r,c){var l=t+" Iterator";e.prototype=a(n,{next:i(+!c,r)});s(e,l,!1,!0);o[l]=returnThis;return e}},(e,t,r)=>{"use strict";var n,a,i,s=r(8),o=r(21),c=r(117),l=r(123),h=r(47),u=r(33),d=r(35),f=u("iterator"),g=!1;[].keys&&("next"in(i=[].keys())?(a=l(l(i)))!==Object.prototype&&(n=a):g=!0);null==n||s((function(){var e={};return n[f].call(e)!==e}))?n={}:d&&(n=c(n));o(n[f])||h(n,f,(function(){return this}));e.exports={IteratorPrototype:n,BUGGY_SAFARI_ITERATORS:g}},(e,t,r)=>{var n=r(38),a=r(21),i=r(39),s=r(53),o=r(124),c=s("IE_PROTO"),l=Object,h=l.prototype;e.exports=o?l.getPrototypeOf:function(e){var t=i(e);if(n(t,c))return t[c];var r=t.constructor;return a(r)&&t instanceof r?r.prototype:t instanceof l?h:null}},(e,t,r)=>{var n=r(8);e.exports=!n((function(){function F(){}F.prototype.constructor=null;return Object.getPrototypeOf(new F)!==F.prototype}))},(e,t,r)=>{r(126)("Uint8",(function(e){return function Uint8Array(t,r,n){return e(this,t,r,n)}}))},(e,t,r)=>{"use strict";var n=r(4),a=r(5),i=r(9),s=r(7),o=r(127),c=r(128),l=r(130),h=r(73),u=r(12),d=r(43),f=r(137),g=r(64),p=r(132),m=r(138),b=r(18),y=r(38),w=r(77),S=r(20),x=r(22),v=r(117),k=r(24),C=r(69),O=r(57).f,T=r(140),M=r(141).forEach,E=r(72),D=r(44),N=r(6),R=r(51),L=r(145),j=R.get,_=R.set,U=D.f,$=N.f,X=Math.round,H=a.RangeError,q=l.ArrayBuffer,W=q.prototype,z=l.DataView,G=c.NATIVE_ARRAY_BUFFER_VIEWS,V=c.TYPED_ARRAY_CONSTRUCTOR,K=c.TYPED_ARRAY_TAG,Y=c.TypedArray,J=c.TypedArrayPrototype,Z=c.aTypedArrayConstructor,Q=c.isTypedArray,ee="BYTES_PER_ELEMENT",te="Wrong length",fromList=function(e,t){Z(e);for(var r=0,n=t.length,a=new e(n);n>r;)a[r]=t[r++];return a},addGetter=function(e,t){U(e,t,{get:function(){return j(this)[t]}})},isArrayBuffer=function(e){var t;return k(W,e)||"ArrayBuffer"==(t=w(e))||"SharedArrayBuffer"==t},isTypedArrayIndex=function(e,t){return Q(e)&&!x(t)&&t in e&&f(+t)&&t>=0},re=function getOwnPropertyDescriptor(e,t){t=b(t);return isTypedArrayIndex(e,t)?u(2,e[t]):$(e,t)},ne=function defineProperty(e,t,r){t=b(t);if(isTypedArrayIndex(e,t)&&S(r)&&y(r,"value")&&!y(r,"get")&&!y(r,"set")&&!r.configurable&&(!y(r,"writable")||r.writable)&&(!y(r,"enumerable")||r.enumerable)){e[t]=r.value;return e}return U(e,t,r)};if(s){if(!G){N.f=re;D.f=ne;addGetter(J,"buffer");addGetter(J,"byteOffset");addGetter(J,"byteLength");addGetter(J,"length")}n({target:"Object",stat:!0,forced:!G},{getOwnPropertyDescriptor:re,defineProperty:ne});e.exports=function(e,t,r){var s=e.match(/\d+$/)[0]/8,c=e+(r?"Clamped":"")+"Array",l="get"+e,u="set"+e,f=a[c],b=f,y=b&&b.prototype,w={},addElement=function(e,t){U(e,t,{get:function(){return function(e,t){var r=j(e);return r.view[l](t*s+r.byteOffset,!0)}(this,t)},set:function(e){return function(e,t,n){var a=j(e);r&&(n=(n=X(n))<0?0:n>255?255:255&n);a.view[u](t*s+a.byteOffset,n,!0)}(this,t,e)},enumerable:!0})};if(G){if(o){b=t((function(e,t,r,n){h(e,y);return L(S(t)?isArrayBuffer(t)?void 0!==n?new f(t,m(r,s),n):void 0!==r?new f(t,m(r,s)):new f(t):Q(t)?fromList(b,t):i(T,b,t):new f(p(t)),e,b)}));C&&C(b,Y);M(O(f),(function(e){e in b||d(b,e,f[e])}));b.prototype=y}}else{b=t((function(e,t,r,n){h(e,y);var a,o,c,l=0,u=0;if(S(t)){if(!isArrayBuffer(t))return Q(t)?fromList(b,t):i(T,b,t);a=t;u=m(r,s);var d=t.byteLength;if(void 0===n){if(d%s)throw H(te);if((o=d-u)<0)throw H(te)}else if((o=g(n)*s)+u>d)throw H(te);c=o/s}else{c=p(t);a=new q(o=c*s)}_(e,{buffer:a,byteOffset:u,byteLength:o,length:c,view:new z(a)});for(;l<c;)addElement(e,l++)}));C&&C(b,Y);y=b.prototype=v(J)}y.constructor!==b&&d(y,"constructor",b);d(y,V,b);K&&d(y,K,c);var x=b!=f;w[c]=b;n({global:!0,constructor:!0,forced:x,sham:!G},w);ee in b||d(b,ee,s);ee in y||d(y,ee,s);E(c)}}else e.exports=function(){}},(e,t,r)=>{var n=r(5),a=r(8),i=r(104),s=r(128).NATIVE_ARRAY_BUFFER_VIEWS,o=n.ArrayBuffer,c=n.Int8Array;e.exports=!s||!a((function(){c(1)}))||!a((function(){new c(-1)}))||!i((function(e){new c;new c(null);new c(1.5);new c(e)}),!0)||a((function(){return 1!==new c(new o(2),1,void 0).length}))},(e,t,r)=>{"use strict";var n,a,i,s=r(129),o=r(7),c=r(5),l=r(21),h=r(20),u=r(38),d=r(77),f=r(31),g=r(43),p=r(47),m=r(44).f,b=r(24),y=r(123),w=r(69),S=r(33),x=r(40),v=c.Int8Array,k=v&&v.prototype,C=c.Uint8ClampedArray,O=C&&C.prototype,T=v&&y(v),M=k&&y(k),E=Object.prototype,D=c.TypeError,N=S("toStringTag"),R=x("TYPED_ARRAY_TAG"),L=x("TYPED_ARRAY_CONSTRUCTOR"),j=s&&!!w&&"Opera"!==d(c.opera),_=!1,U={Int8Array:1,Uint8Array:1,Uint8ClampedArray:1,Int16Array:2,Uint16Array:2,Int32Array:4,Uint32Array:4,Float32Array:4,Float64Array:8},$={BigInt64Array:8,BigUint64Array:8},isTypedArray=function(e){if(!h(e))return!1;var t=d(e);return u(U,t)||u($,t)};for(n in U)(i=(a=c[n])&&a.prototype)?g(i,L,a):j=!1;for(n in $)(i=(a=c[n])&&a.prototype)&&g(i,L,a);if(!j||!l(T)||T===Function.prototype){T=function TypedArray(){throw D("Incorrect invocation")};if(j)for(n in U)c[n]&&w(c[n],T)}if(!j||!M||M===E){M=T.prototype;if(j)for(n in U)c[n]&&w(c[n].prototype,M)}j&&y(O)!==M&&w(O,M);if(o&&!u(M,N)){_=!0;m(M,N,{get:function(){return h(this)?this[R]:void 0}});for(n in U)c[n]&&g(c[n],R,n)}e.exports={NATIVE_ARRAY_BUFFER_VIEWS:j,TYPED_ARRAY_CONSTRUCTOR:L,TYPED_ARRAY_TAG:_&&R,aTypedArray:function(e){if(isTypedArray(e))return e;throw D("Target is not a typed array")},aTypedArrayConstructor:function(e){if(l(e)&&(!w||b(T,e)))return e;throw D(f(e)+" is not a typed array constructor")},exportTypedArrayMethod:function(e,t,r,n){if(o){if(r)for(var a in U){var i=c[a];if(i&&u(i.prototype,e))try{delete i.prototype[e]}catch(r){try{i.prototype[e]=t}catch(e){}}}M[e]&&!r||p(M,e,r?t:j&&k[e]||t,n)}},exportTypedArrayStaticMethod:function(e,t,r){var n,a;if(o){if(w){if(r)for(n in U)if((a=c[n])&&u(a,e))try{delete a[e]}catch(e){}if(T[e]&&!r)return;try{return p(T,e,r?t:j&&T[e]||t)}catch(e){}}for(n in U)!(a=c[n])||a[e]&&!r||p(a,e,t)}},isView:function isView(e){if(!h(e))return!1;var t=d(e);return"DataView"===t||u(U,t)||u($,t)},isTypedArray:isTypedArray,TypedArray:T,TypedArrayPrototype:M}},e=>{e.exports="undefined"!=typeof ArrayBuffer&&"undefined"!=typeof DataView},(e,t,r)=>{"use strict";var n=r(5),a=r(15),i=r(7),s=r(129),o=r(49),c=r(43),l=r(131),h=r(8),u=r(73),d=r(61),f=r(64),g=r(132),p=r(133),m=r(123),b=r(69),y=r(57).f,w=r(44).f,S=r(134),x=r(135),v=r(71),k=r(51),C=o.PROPER,O=o.CONFIGURABLE,T=k.get,M=k.set,E="ArrayBuffer",D="DataView",N="Wrong index",R=n.ArrayBuffer,L=R,j=L&&L.prototype,_=n.DataView,U=_&&_.prototype,$=Object.prototype,X=n.Array,H=n.RangeError,q=a(S),W=a([].reverse),z=p.pack,G=p.unpack,packInt8=function(e){return[255&e]},packInt16=function(e){return[255&e,e>>8&255]},packInt32=function(e){return[255&e,e>>8&255,e>>16&255,e>>24&255]},unpackInt32=function(e){return e[3]<<24|e[2]<<16|e[1]<<8|e[0]},packFloat32=function(e){return z(e,23,4)},packFloat64=function(e){return z(e,52,8)},addGetter=function(e,t){w(e.prototype,t,{get:function(){return T(this)[t]}})},get=function(e,t,r,n){var a=g(r),i=T(e);if(a+t>i.byteLength)throw H(N);var s=T(i.buffer).bytes,o=a+i.byteOffset,c=x(s,o,o+t);return n?c:W(c)},set=function(e,t,r,n,a,i){var s=g(r),o=T(e);if(s+t>o.byteLength)throw H(N);for(var c=T(o.buffer).bytes,l=s+o.byteOffset,h=n(+a),u=0;u<t;u++)c[l+u]=h[i?u:t-u-1]};if(s){var V=C&&R.name!==E;if(h((function(){R(1)}))&&h((function(){new R(-1)}))&&!h((function(){new R;new R(1.5);new R(NaN);return V&&!O})))V&&O&&c(R,"name",E);else{(L=function ArrayBuffer(e){u(this,j);return new R(g(e))}).prototype=j;for(var K,Y=y(R),J=0;Y.length>J;)(K=Y[J++])in L||c(L,K,R[K]);j.constructor=L}b&&m(U)!==$&&b(U,$);var Z=new _(new L(2)),Q=a(U.setInt8);Z.setInt8(0,2147483648);Z.setInt8(1,2147483649);!Z.getInt8(0)&&Z.getInt8(1)||l(U,{setInt8:function setInt8(e,t){Q(this,e,t<<24>>24)},setUint8:function setUint8(e,t){Q(this,e,t<<24>>24)}},{unsafe:!0})}else{j=(L=function ArrayBuffer(e){u(this,j);var t=g(e);M(this,{bytes:q(X(t),0),byteLength:t});i||(this.byteLength=t)}).prototype;U=(_=function DataView(e,t,r){u(this,U);u(e,j);var n=T(e).byteLength,a=d(t);if(a<0||a>n)throw H("Wrong offset");if(a+(r=void 0===r?n-a:f(r))>n)throw H("Wrong length");M(this,{buffer:e,byteLength:r,byteOffset:a});if(!i){this.buffer=e;this.byteLength=r;this.byteOffset=a}}).prototype;if(i){addGetter(L,"byteLength");addGetter(_,"buffer");addGetter(_,"byteLength");addGetter(_,"byteOffset")}l(U,{getInt8:function getInt8(e){return get(this,1,e)[0]<<24>>24},getUint8:function getUint8(e){return get(this,1,e)[0]},getInt16:function getInt16(e){var t=get(this,2,e,arguments.length>1?arguments[1]:void 0);return(t[1]<<8|t[0])<<16>>16},getUint16:function getUint16(e){var t=get(this,2,e,arguments.length>1?arguments[1]:void 0);return t[1]<<8|t[0]},getInt32:function getInt32(e){return unpackInt32(get(this,4,e,arguments.length>1?arguments[1]:void 0))},getUint32:function getUint32(e){return unpackInt32(get(this,4,e,arguments.length>1?arguments[1]:void 0))>>>0},getFloat32:function getFloat32(e){return G(get(this,4,e,arguments.length>1?arguments[1]:void 0),23)},getFloat64:function getFloat64(e){return G(get(this,8,e,arguments.length>1?arguments[1]:void 0),52)},setInt8:function setInt8(e,t){set(this,1,e,packInt8,t)},setUint8:function setUint8(e,t){set(this,1,e,packInt8,t)},setInt16:function setInt16(e,t){set(this,2,e,packInt16,t,arguments.length>2?arguments[2]:void 0)},setUint16:function setUint16(e,t){set(this,2,e,packInt16,t,arguments.length>2?arguments[2]:void 0)},setInt32:function setInt32(e,t){set(this,4,e,packInt32,t,arguments.length>2?arguments[2]:void 0)},setUint32:function setUint32(e,t){set(this,4,e,packInt32,t,arguments.length>2?arguments[2]:void 0)},setFloat32:function setFloat32(e,t){set(this,4,e,packFloat32,t,arguments.length>2?arguments[2]:void 0)},setFloat64:function setFloat64(e,t){set(this,8,e,packFloat64,t,arguments.length>2?arguments[2]:void 0)}})}v(L,E);v(_,D);e.exports={ArrayBuffer:L,DataView:_}},(e,t,r)=>{var n=r(47);e.exports=function(e,t,r){for(var a in t)n(e,a,t[a],r);return e}},(e,t,r)=>{var n=r(61),a=r(64),i=RangeError;e.exports=function(e){if(void 0===e)return 0;var t=n(e),r=a(t);if(t!==r)throw i("Wrong length or index");return r}},e=>{var t=Array,r=Math.abs,n=Math.pow,a=Math.floor,i=Math.log,s=Math.LN2;e.exports={pack:function(e,o,c){var l,h,u,d=t(c),f=8*c-o-1,g=(1<<f)-1,p=g>>1,m=23===o?n(2,-24)-n(2,-77):0,b=e<0||0===e&&1/e<0?1:0,y=0;if((e=r(e))!=e||e===1/0){h=e!=e?1:0;l=g}else{l=a(i(e)/s);if(e*(u=n(2,-l))<1){l--;u*=2}if((e+=l+p>=1?m/u:m*n(2,1-p))*u>=2){l++;u/=2}if(l+p>=g){h=0;l=g}else if(l+p>=1){h=(e*u-1)*n(2,o);l+=p}else{h=e*n(2,p-1)*n(2,o);l=0}}for(;o>=8;){d[y++]=255&h;h/=256;o-=8}l=l<<o|h;f+=o;for(;f>0;){d[y++]=255&l;l/=256;f-=8}d[--y]|=128*b;return d},unpack:function(e,t){var r,a=e.length,i=8*a-t-1,s=(1<<i)-1,o=s>>1,c=i-7,l=a-1,h=e[l--],u=127&h;h>>=7;for(;c>0;){u=256*u+e[l--];c-=8}r=u&(1<<-c)-1;u>>=-c;c+=t;for(;c>0;){r=256*r+e[l--];c-=8}if(0===u)u=1-o;else{if(u===s)return r?NaN:h?-1/0:1/0;r+=n(2,t);u-=o}return(h?-1:1)*r*n(2,u-t)}}},(e,t,r)=>{"use strict";var n=r(39),a=r(60),i=r(63);e.exports=function fill(e){for(var t=n(this),r=i(t),s=arguments.length,o=a(s>1?arguments[1]:void 0,r),c=s>2?arguments[2]:void 0,l=void 0===c?r:a(c,r);l>o;)t[o++]=e;return t}},(e,t,r)=>{var n=r(60),a=r(63),i=r(136),s=Array,o=Math.max;e.exports=function(e,t,r){for(var c=a(e),l=n(t,c),h=n(void 0===r?c:r,c),u=s(o(h-l,0)),d=0;l<h;l++,d++)i(u,d,e[l]);u.length=d;return u}},(e,t,r)=>{"use strict";var n=r(18),a=r(44),i=r(12);e.exports=function(e,t,r){var s=n(t);s in e?a.f(e,s,i(0,r)):e[s]=r}},(e,t,r)=>{var n=r(20),a=Math.floor;e.exports=Number.isInteger||function isInteger(e){return!n(e)&&isFinite(e)&&a(e)===e}},(e,t,r)=>{var n=r(139),a=RangeError;e.exports=function(e,t){var r=n(e);if(r%t)throw a("Wrong offset");return r}},(e,t,r)=>{var n=r(61),a=RangeError;e.exports=function(e){var t=n(e);if(t<0)throw a("The argument can't be less than 0");return t}},(e,t,r)=>{var n=r(81),a=r(9),i=r(75),s=r(39),o=r(63),c=r(100),l=r(101),h=r(98),u=r(128).aTypedArrayConstructor;e.exports=function from(e){var t,r,d,f,g,p,m=i(this),b=s(e),y=arguments.length,w=y>1?arguments[1]:void 0,S=void 0!==w,x=l(b);if(x&&!h(x)){p=(g=c(b,x)).next;b=[];for(;!(f=a(p,g)).done;)b.push(f.value)}S&&y>2&&(w=n(w,arguments[2]));r=o(b);d=new(u(m))(r);for(t=0;r>t;t++)d[t]=S?w(b[t],t):b[t];return d}},(e,t,r)=>{var n=r(81),a=r(15),i=r(14),s=r(39),o=r(63),c=r(142),l=a([].push),createMethod=function(e){var t=1==e,r=2==e,a=3==e,h=4==e,u=6==e,d=7==e,f=5==e||u;return function(g,p,m,b){for(var y,w,S=s(g),x=i(S),v=n(p,m),k=o(x),C=0,O=b||c,T=t?O(g,k):r||d?O(g,0):void 0;k>C;C++)if(f||C in x){w=v(y=x[C],C,S);if(e)if(t)T[C]=w;else if(w)switch(e){case 3:return!0;case 5:return y;case 6:return C;case 2:l(T,y)}else switch(e){case 4:return!1;case 7:l(T,y)}}return u?-1:a||h?h:T}};e.exports={forEach:createMethod(0),map:createMethod(1),filter:createMethod(2),some:createMethod(3),every:createMethod(4),find:createMethod(5),findIndex:createMethod(6),filterReject:createMethod(7)}},(e,t,r)=>{var n=r(143);e.exports=function(e,t){return new(n(e))(0===t?0:t)}},(e,t,r)=>{var n=r(144),a=r(76),i=r(20),s=r(33)("species"),o=Array;e.exports=function(e){var t;if(n(e)){t=e.constructor;(a(t)&&(t===o||n(t.prototype))||i(t)&&null===(t=t[s]))&&(t=void 0)}return void 0===t?o:t}},(e,t,r)=>{var n=r(16);e.exports=Array.isArray||function isArray(e){return"Array"==n(e)}},(e,t,r)=>{var n=r(21),a=r(20),i=r(69);e.exports=function(e,t,r){var s,o;i&&n(s=t.constructor)&&s!==r&&a(o=s.prototype)&&o!==r.prototype&&i(e,o);return e}},(e,t,r)=>{"use strict";var n=r(128),a=r(134),i=r(147),s=r(77),o=r(9),c=r(15),l=r(8),h=n.aTypedArray,u=n.exportTypedArrayMethod,d=c("".slice);u("fill",(function fill(e){var t=arguments.length;h(this);var r="Big"===d(s(this),0,3)?i(e):+e;return o(a,this,r,t>1?arguments[1]:void 0,t>2?arguments[2]:void 0)}),l((function(){var e=0;new Int8Array(2).fill({valueOf:function(){return e++}});return 1!==e})))},(e,t,r)=>{var n=r(19),a=TypeError;e.exports=function(e){var t=n(e,"number");if("number"==typeof t)throw a("Can't convert number to bigint");return BigInt(t)}},(e,t,r)=>{"use strict";var n=r(5),a=r(9),i=r(128),s=r(63),o=r(138),c=r(39),l=r(8),h=n.RangeError,u=n.Int8Array,d=u&&u.prototype,f=d&&d.set,g=i.aTypedArray,p=i.exportTypedArrayMethod,m=!l((function(){var e=new Uint8ClampedArray(2);a(f,e,{length:1,0:3},1);return 3!==e[1]})),b=m&&i.NATIVE_ARRAY_BUFFER_VIEWS&&l((function(){var e=new u(2);e.set(1);e.set("2",1);return 0!==e[0]||2!==e[1]}));p("set",(function set(e){g(this);var t=o(arguments.length>1?arguments[1]:void 0,1),r=c(e);if(m)return a(f,this,r,t);var n=this.length,i=s(r),l=0;if(i+t>n)throw h("Wrong length");for(;l<i;)this[t+l]=r[l++]}),!m||b)},(e,t,r)=>{"use strict";var n=r(5),a=r(15),i=r(8),s=r(30),o=r(150),c=r(128),l=r(151),h=r(152),u=r(27),d=r(153),f=c.aTypedArray,g=c.exportTypedArrayMethod,p=n.Uint16Array,m=p&&a(p.prototype.sort),b=!(!m||i((function(){m(new p(2),null)}))&&i((function(){m(new p(2),{})}))),y=!!m&&!i((function(){if(u)return u<74;if(l)return l<67;if(h)return!0;if(d)return d<602;var e,t,r=new p(516),n=Array(516);for(e=0;e<516;e++){t=e%4;r[e]=515-e;n[e]=e-2*t+3}m(r,(function(e,t){return(e/4|0)-(t/4|0)}));for(e=0;e<516;e++)if(r[e]!==n[e])return!0}));g("sort",(function sort(e){void 0!==e&&s(e);return y?m(this,e):o(f(this),function(e){return function(t,r){return void 0!==e?+e(t,r)||0:r!=r?-1:t!=t?1:0===t&&0===r?1/t>0&&1/r<0?1:-1:t>r}}(e))}),!y||b)},(e,t,r)=>{var n=r(135),a=Math.floor,mergeSort=function(e,t){var r=e.length,i=a(r/2);return r<8?insertionSort(e,t):merge(e,mergeSort(n(e,0,i),t),mergeSort(n(e,i),t),t)},insertionSort=function(e,t){for(var r,n,a=e.length,i=1;i<a;){n=i;r=e[i];for(;n&&t(e[n-1],r)>0;)e[n]=e[--n];n!==i++&&(e[n]=r)}return e},merge=function(e,t,r,n){for(var a=t.length,i=r.length,s=0,o=0;s<a||o<i;)e[s+o]=s<a&&o<i?n(t[s],r[o])<=0?t[s++]:r[o++]:s<a?t[s++]:r[o++];return e};e.exports=mergeSort},(e,t,r)=>{var n=r(28).match(/firefox\/(\d+)/i);e.exports=!!n&&+n[1]},(e,t,r)=>{var n=r(28);e.exports=/MSIE|Trident/.test(n)},(e,t,r)=>{var n=r(28).match(/AppleWebKit\/(\d+)\./);e.exports=!!n&&+n[1]},(e,t,r)=>{"use strict";var n=r(4),a=r(35),i=r(92),s=r(8),o=r(23),c=r(21),l=r(74),h=r(109),u=r(47),d=i&&i.prototype;n({target:"Promise",proto:!0,real:!0,forced:!!i&&s((function(){d.finally.call({then:function(){}},(function(){}))}))},{finally:function(e){var t=l(this,o("Promise")),r=c(e);return this.then(r?function(r){return h(t,e()).then((function(){return r}))}:e,r?function(r){return h(t,e()).then((function(){throw r}))}:e)}});if(!a&&c(i)){var f=o("Promise").prototype.finally;d.finally!==f&&u(d,"finally",f,{unsafe:!0})}},(e,t,r)=>{"use strict";var n=r(4),a=r(156).left,i=r(157),s=r(27),o=r(68);n({target:"Array",proto:!0,forced:!i("reduce")||!o&&s>79&&s<83},{reduce:function reduce(e){var t=arguments.length;return a(this,e,t,t>1?arguments[1]:void 0)}})},(e,t,r)=>{var n=r(30),a=r(39),i=r(14),s=r(63),o=TypeError,createMethod=function(e){return function(t,r,c,l){n(r);var h=a(t),u=i(h),d=s(h),f=e?d-1:0,g=e?-1:1;if(c<2)for(;;){if(f in u){l=u[f];f+=g;break}f+=g;if(e?f<0:d<=f)throw o("Reduce of empty array with no initial value")}for(;e?f>=0:d>f;f+=g)f in u&&(l=r(l,u[f],f,h));return l}};e.exports={left:createMethod(!1),right:createMethod(!0)}},(e,t,r)=>{"use strict";var n=r(8);e.exports=function(e,t){var r=[][e];return!!r&&n((function(){r.call(null,t||function(){return 1},1)}))}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.VerbosityLevel=t.Util=t.UnknownErrorException=t.UnexpectedResponseException=t.UNSUPPORTED_FEATURES=t.TextRenderingMode=t.StreamType=t.RenderingIntentFlag=t.PermissionFlag=t.PasswordResponses=t.PasswordException=t.PageActionEventType=t.OPS=t.MissingPDFException=t.LINE_FACTOR=t.LINE_DESCENT_FACTOR=t.InvalidPDFException=t.ImageKind=t.IDENTITY_MATRIX=t.FormatError=t.FontType=t.FeatureTest=t.FONT_IDENTITY_MATRIX=t.DocumentActionEventType=t.CMapCompressionType=t.BaseException=t.AnnotationType=t.AnnotationStateModelType=t.AnnotationReviewState=t.AnnotationReplyType=t.AnnotationMode=t.AnnotationMarkedState=t.AnnotationFlag=t.AnnotationFieldFlag=t.AnnotationEditorType=t.AnnotationEditorPrefix=t.AnnotationBorderStyleType=t.AnnotationActionEventType=t.AbortException=void 0;t.arrayByteLength=arrayByteLength;t.arraysToBytes=function arraysToBytes(e){const t=e.length;if(1===t&&e[0]instanceof Uint8Array)return e[0];let r=0;for(let n=0;n<t;n++)r+=arrayByteLength(e[n]);let n=0;const a=new Uint8Array(r);for(let r=0;r<t;r++){let t=e[r];t instanceof Uint8Array||(t="string"==typeof t?stringToBytes(t):new Uint8Array(t));const i=t.byteLength;a.set(t,n);n+=i}return a};t.assert=function assert(e,t){e||unreachable(t)};t.bytesToString=function bytesToString(e){"object"==typeof e&&null!==e&&void 0!==e.length||unreachable("Invalid argument for bytesToString");const t=e.length,r=8192;if(t<r)return String.fromCharCode.apply(null,e);const n=[];for(let a=0;a<t;a+=r){const i=Math.min(a+r,t),s=e.subarray(a,i);n.push(String.fromCharCode.apply(null,s))}return n.join("")};t.createPromiseCapability=function createPromiseCapability(){const e=Object.create(null);let t=!1;Object.defineProperty(e,"settled",{get:()=>t});e.promise=new Promise((function(r,n){e.resolve=function(e){t=!0;r(e)};e.reject=function(e){t=!0;n(e)}}));return e};t.createValidAbsoluteUrl=function createValidAbsoluteUrl(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;if(!e)return null;try{if(r&&"string"==typeof e){if(r.addDefaultProtocol&&e.startsWith("www.")){const t=e.match(/\./g);t&&t.length>=2&&(e="http://".concat(e))}if(r.tryConvertEncoding)try{e=stringToUTF8String(e)}catch(e){}}const n=t?new URL(e,t):new URL(e);if(_isValidProtocol(n))return n}catch(e){}return null};t.escapeString=function escapeString(e){return e.replace(/([()\\\n\r])/g,(e=>"\n"===e?"\\n":"\r"===e?"\\r":"\\".concat(e)))};t.getModificationDate=function getModificationDate(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:new Date;const t=[e.getUTCFullYear().toString(),(e.getUTCMonth()+1).toString().padStart(2,"0"),e.getUTCDate().toString().padStart(2,"0"),e.getUTCHours().toString().padStart(2,"0"),e.getUTCMinutes().toString().padStart(2,"0"),e.getUTCSeconds().toString().padStart(2,"0")];return t.join("")};t.getVerbosityLevel=function getVerbosityLevel(){return a};t.info=function info(e){a>=n.INFOS&&("undefined"!=typeof WorkerGlobalScope&&self instanceof WorkerGlobalScope?console.log("Info: ".concat(e)):Window&&Window.ngxConsole?Window.ngxConsole.log("Info: ".concat(e)):console.log("Info: ".concat(e)))};t.isArrayBuffer=function isArrayBuffer(e){return"object"==typeof e&&null!==e&&void 0!==e.byteLength};t.isArrayEqual=function isArrayEqual(e,t){if(e.length!==t.length)return!1;for(let r=0,n=e.length;r<n;r++)if(e[r]!==t[r])return!1;return!0};t.isAscii=function isAscii(e){return/^[\x00-\x7F]*$/.test(e)};t.objectFromMap=function objectFromMap(e){const t=Object.create(null);for(const[r,n]of e)t[r]=n;return t};t.objectSize=function objectSize(e){return Object.keys(e).length};t.setVerbosityLevel=function setVerbosityLevel(e){Number.isInteger(e)&&(a=e)};t.shadow=shadow;t.string32=function string32(e){return String.fromCharCode(e>>24&255,e>>16&255,e>>8&255,255&e)};t.stringToBytes=stringToBytes;t.stringToPDFString=function stringToPDFString(e){if(e[0]>="ï"){let t;"þ"===e[0]&&"ÿ"===e[1]?t="utf-16be":"ÿ"===e[0]&&"þ"===e[1]?t="utf-16le":"ï"===e[0]&&"»"===e[1]&&"¿"===e[2]&&(t="utf-8");if(t)try{const r=new TextDecoder(t,{fatal:!0}),n=stringToBytes(e);return r.decode(n)}catch(e){warn('stringToPDFString: "'.concat(e,'".'))}}const t=[];for(let r=0,n=e.length;r<n;r++){const n=o[e.charCodeAt(r)];t.push(n?String.fromCharCode(n):e.charAt(r))}return t.join("")};t.stringToUTF16BEString=function stringToUTF16BEString(e){const t=["þÿ"];for(let r=0,n=e.length;r<n;r++){const n=e.charCodeAt(r);t.push(String.fromCharCode(n>>8&255),String.fromCharCode(255&n))}return t.join("")};t.stringToUTF8String=stringToUTF8String;t.unreachable=unreachable;t.utf8StringToString=function utf8StringToString(e){return unescape(encodeURIComponent(e))};t.warn=warn;r(159);r(112);r(166);r(177);r(125);r(146);r(148);r(149);r(178);r(179);r(2);r(184);t.IDENTITY_MATRIX=[1,0,0,1,0,0];t.FONT_IDENTITY_MATRIX=[.001,0,0,.001,0,0];t.LINE_FACTOR=1.35;t.LINE_DESCENT_FACTOR=.35;t.RenderingIntentFlag={ANY:1,DISPLAY:2,PRINT:4,ANNOTATIONS_FORMS:16,ANNOTATIONS_STORAGE:32,ANNOTATIONS_DISABLE:64,OPLIST:256};t.AnnotationMode={DISABLE:0,ENABLE:1,ENABLE_FORMS:2,ENABLE_STORAGE:3};t.AnnotationEditorPrefix="pdfjs_internal_editor_";t.AnnotationEditorType={NONE:0,FREETEXT:3,INK:15};t.PermissionFlag={PRINT:4,MODIFY_CONTENTS:8,COPY:16,MODIFY_ANNOTATIONS:32,FILL_INTERACTIVE_FORMS:256,COPY_FOR_ACCESSIBILITY:512,ASSEMBLE:1024,PRINT_HIGH_QUALITY:2048};t.TextRenderingMode={FILL:0,STROKE:1,FILL_STROKE:2,INVISIBLE:3,FILL_ADD_TO_PATH:4,STROKE_ADD_TO_PATH:5,FILL_STROKE_ADD_TO_PATH:6,ADD_TO_PATH:7,FILL_STROKE_MASK:3,ADD_TO_PATH_FLAG:4};t.ImageKind={GRAYSCALE_1BPP:1,RGB_24BPP:2,RGBA_32BPP:3};t.AnnotationType={TEXT:1,LINK:2,FREETEXT:3,LINE:4,SQUARE:5,CIRCLE:6,POLYGON:7,POLYLINE:8,HIGHLIGHT:9,UNDERLINE:10,SQUIGGLY:11,STRIKEOUT:12,STAMP:13,CARET:14,INK:15,POPUP:16,FILEATTACHMENT:17,SOUND:18,MOVIE:19,WIDGET:20,SCREEN:21,PRINTERMARK:22,TRAPNET:23,WATERMARK:24,THREED:25,REDACT:26};t.AnnotationStateModelType={MARKED:"Marked",REVIEW:"Review"};t.AnnotationMarkedState={MARKED:"Marked",UNMARKED:"Unmarked"};t.AnnotationReviewState={ACCEPTED:"Accepted",REJECTED:"Rejected",CANCELLED:"Cancelled",COMPLETED:"Completed",NONE:"None"};t.AnnotationReplyType={GROUP:"Group",REPLY:"R"};t.AnnotationFlag={INVISIBLE:1,HIDDEN:2,PRINT:4,NOZOOM:8,NOROTATE:16,NOVIEW:32,READONLY:64,LOCKED:128,TOGGLENOVIEW:256,LOCKEDCONTENTS:512};t.AnnotationFieldFlag={READONLY:1,REQUIRED:2,NOEXPORT:4,MULTILINE:4096,PASSWORD:8192,NOTOGGLETOOFF:16384,RADIO:32768,PUSHBUTTON:65536,COMBO:131072,EDIT:262144,SORT:524288,FILESELECT:1048576,MULTISELECT:2097152,DONOTSPELLCHECK:4194304,DONOTSCROLL:8388608,COMB:16777216,RICHTEXT:33554432,RADIOSINUNISON:33554432,COMMITONSELCHANGE:67108864};t.AnnotationBorderStyleType={SOLID:1,DASHED:2,BEVELED:3,INSET:4,UNDERLINE:5};t.AnnotationActionEventType={E:"Mouse Enter",X:"Mouse Exit",D:"Mouse Down",U:"Mouse Up",Fo:"Focus",Bl:"Blur",PO:"PageOpen",PC:"PageClose",PV:"PageVisible",PI:"PageInvisible",K:"Keystroke",F:"Format",V:"Validate",C:"Calculate"};t.DocumentActionEventType={WC:"WillClose",WS:"WillSave",DS:"DidSave",WP:"WillPrint",DP:"DidPrint"};t.PageActionEventType={O:"PageOpen",C:"PageClose"};t.StreamType={UNKNOWN:"UNKNOWN",FLATE:"FLATE",LZW:"LZW",DCT:"DCT",JPX:"JPX",JBIG:"JBIG",A85:"A85",AHX:"AHX",CCF:"CCF",RLX:"RLX"};t.FontType={UNKNOWN:"UNKNOWN",TYPE1:"TYPE1",TYPE1STANDARD:"TYPE1STANDARD",TYPE1C:"TYPE1C",CIDFONTTYPE0:"CIDFONTTYPE0",CIDFONTTYPE0C:"CIDFONTTYPE0C",TRUETYPE:"TRUETYPE",CIDFONTTYPE2:"CIDFONTTYPE2",TYPE3:"TYPE3",OPENTYPE:"OPENTYPE",TYPE0:"TYPE0",MMTYPE1:"MMTYPE1"};const n={ERRORS:0,WARNINGS:1,INFOS:5};t.VerbosityLevel=n;t.CMapCompressionType={NONE:0,BINARY:1,STREAM:2};t.OPS={dependency:1,setLineWidth:2,setLineCap:3,setLineJoin:4,setMiterLimit:5,setDash:6,setRenderingIntent:7,setFlatness:8,setGState:9,save:10,restore:11,transform:12,moveTo:13,lineTo:14,curveTo:15,curveTo2:16,curveTo3:17,closePath:18,rectangle:19,stroke:20,closeStroke:21,fill:22,eoFill:23,fillStroke:24,eoFillStroke:25,closeFillStroke:26,closeEOFillStroke:27,endPath:28,clip:29,eoClip:30,beginText:31,endText:32,setCharSpacing:33,setWordSpacing:34,setHScale:35,setLeading:36,setFont:37,setTextRenderingMode:38,setTextRise:39,moveText:40,setLeadingMoveText:41,setTextMatrix:42,nextLine:43,showText:44,showSpacedText:45,nextLineShowText:46,nextLineSetSpacingShowText:47,setCharWidth:48,setCharWidthAndBounds:49,setStrokeColorSpace:50,setFillColorSpace:51,setStrokeColor:52,setStrokeColorN:53,setFillColor:54,setFillColorN:55,setStrokeGray:56,setFillGray:57,setStrokeRGBColor:58,setFillRGBColor:59,setStrokeCMYKColor:60,setFillCMYKColor:61,shadingFill:62,beginInlineImage:63,beginImageData:64,endInlineImage:65,paintXObject:66,markPoint:67,markPointProps:68,beginMarkedContent:69,beginMarkedContentProps:70,endMarkedContent:71,beginCompat:72,endCompat:73,paintFormXObjectBegin:74,paintFormXObjectEnd:75,beginGroup:76,endGroup:77,beginAnnotations:78,endAnnotations:79,beginAnnotation:80,endAnnotation:81,paintJpegXObject:82,paintImageMaskXObject:83,paintImageMaskXObjectGroup:84,paintImageXObject:85,paintInlineImageXObject:86,paintInlineImageXObjectGroup:87,paintImageXObjectRepeat:88,paintImageMaskXObjectRepeat:89,paintSolidColorImageMask:90,constructPath:91};t.UNSUPPORTED_FEATURES={unknown:"unknown",forms:"forms",javaScript:"javaScript",signatures:"signatures",smask:"smask",shadingPattern:"shadingPattern",font:"font",errorTilingPattern:"errorTilingPattern",errorExtGState:"errorExtGState",errorXObject:"errorXObject",errorFontLoadType3:"errorFontLoadType3",errorFontState:"errorFontState",errorFontMissing:"errorFontMissing",errorFontTranslate:"errorFontTranslate",errorColorSpace:"errorColorSpace",errorOperatorList:"errorOperatorList",errorFontToUnicode:"errorFontToUnicode",errorFontLoadNative:"errorFontLoadNative",errorFontBuildPath:"errorFontBuildPath",errorFontGetPath:"errorFontGetPath",errorMarkedContent:"errorMarkedContent",errorContentSubStream:"errorContentSubStream"};t.PasswordResponses={NEED_PASSWORD:1,INCORRECT_PASSWORD:2};let a=n.WARNINGS;function warn(e){a>=n.WARNINGS&&("undefined"!=typeof WorkerGlobalScope&&self instanceof WorkerGlobalScope?console.log("Warning: ".concat(e)):Window&&Window.ngxConsole?Window.ngxConsole.log("Warning: ".concat(e)):console.log("Warning: ".concat(e)))}function unreachable(e){throw new Error(e)}function _isValidProtocol(e){if(!e)return!1;switch(e.protocol){case"http:":case"https:":case"ftp:":case"mailto:":case"tel:":case"capacitor":return!0;default:return!1}}function shadow(e,t,r){Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!1});return r}const i=function BaseExceptionClosure(){function BaseException(e,t){this.constructor===BaseException&&unreachable("Cannot initialize BaseException.");this.message=e;this.name=t}BaseException.prototype=new Error;BaseException.constructor=BaseException;return BaseException}();t.BaseException=i;t.PasswordException=class PasswordException extends i{constructor(e,t){super(e,"PasswordException");this.code=t}};t.UnknownErrorException=class UnknownErrorException extends i{constructor(e,t){super(e,"UnknownErrorException");this.details=t}};t.InvalidPDFException=class InvalidPDFException extends i{constructor(e){super(e,"InvalidPDFException")}};t.MissingPDFException=class MissingPDFException extends i{constructor(e){super(e,"MissingPDFException")}};t.UnexpectedResponseException=class UnexpectedResponseException extends i{constructor(e,t){super(e,"UnexpectedResponseException");this.status=t}};t.FormatError=class FormatError extends i{constructor(e){super(e,"FormatError")}};t.AbortException=class AbortException extends i{constructor(e){super(e,"AbortException")}};function stringToBytes(e){"string"!=typeof e&&unreachable("Invalid argument for stringToBytes");const t=e.length,r=new Uint8Array(t);for(let n=0;n<t;++n)r[n]=255&e.charCodeAt(n);return r}function arrayByteLength(e){if(void 0!==e.length)return e.length;if(void 0!==e.byteLength)return e.byteLength;unreachable("Invalid argument for arrayByteLength")}t.FeatureTest=class FeatureTest{static get isLittleEndian(){return shadow(this,"isLittleEndian",function isLittleEndian(){const e=new Uint8Array(4);e[0]=1;return 1===new Uint32Array(e.buffer,0,1)[0]}())}static get isEvalSupported(){return shadow(this,"isEvalSupported",function isEvalSupported(){try{new Function("");return!0}catch(e){return!1}}())}static get isOffscreenCanvasSupported(){return shadow(this,"isOffscreenCanvasSupported","undefined"!=typeof OffscreenCanvas)}};const s=[...Array(256).keys()].map((e=>e.toString(16).padStart(2,"0")));class Util{static makeHexColor(e,t,r){return"#".concat(s[e]).concat(s[t]).concat(s[r])}static scaleMinMax(e,t){let r;if(e[0]){if(e[0]<0){r=t[0];t[0]=t[1];t[1]=r}t[0]*=e[0];t[1]*=e[0];if(e[3]<0){r=t[2];t[2]=t[3];t[3]=r}t[2]*=e[3];t[3]*=e[3]}else{r=t[0];t[0]=t[2];t[2]=r;r=t[1];t[1]=t[3];t[3]=r;if(e[1]<0){r=t[2];t[2]=t[3];t[3]=r}t[2]*=e[1];t[3]*=e[1];if(e[2]<0){r=t[0];t[0]=t[1];t[1]=r}t[0]*=e[2];t[1]*=e[2]}t[0]+=e[4];t[1]+=e[4];t[2]+=e[5];t[3]+=e[5]}static transform(e,t){return[e[0]*t[0]+e[2]*t[1],e[1]*t[0]+e[3]*t[1],e[0]*t[2]+e[2]*t[3],e[1]*t[2]+e[3]*t[3],e[0]*t[4]+e[2]*t[5]+e[4],e[1]*t[4]+e[3]*t[5]+e[5]]}static applyTransform(e,t){return[e[0]*t[0]+e[1]*t[2]+t[4],e[0]*t[1]+e[1]*t[3]+t[5]]}static applyInverseTransform(e,t){const r=t[0]*t[3]-t[1]*t[2];return[(e[0]*t[3]-e[1]*t[2]+t[2]*t[5]-t[4]*t[3])/r,(-e[0]*t[1]+e[1]*t[0]+t[4]*t[1]-t[5]*t[0])/r]}static getAxialAlignedBoundingBox(e,t){const r=Util.applyTransform(e,t),n=Util.applyTransform(e.slice(2,4),t),a=Util.applyTransform([e[0],e[3]],t),i=Util.applyTransform([e[2],e[1]],t);return[Math.min(r[0],n[0],a[0],i[0]),Math.min(r[1],n[1],a[1],i[1]),Math.max(r[0],n[0],a[0],i[0]),Math.max(r[1],n[1],a[1],i[1])]}static inverseTransform(e){const t=e[0]*e[3]-e[1]*e[2];return[e[3]/t,-e[1]/t,-e[2]/t,e[0]/t,(e[2]*e[5]-e[4]*e[3])/t,(e[4]*e[1]-e[5]*e[0])/t]}static apply3dTransform(e,t){return[e[0]*t[0]+e[1]*t[1]+e[2]*t[2],e[3]*t[0]+e[4]*t[1]+e[5]*t[2],e[6]*t[0]+e[7]*t[1]+e[8]*t[2]]}static singularValueDecompose2dScale(e){const t=[e[0],e[2],e[1],e[3]],r=e[0]*t[0]+e[1]*t[2],n=e[0]*t[1]+e[1]*t[3],a=e[2]*t[0]+e[3]*t[2],i=e[2]*t[1]+e[3]*t[3],s=(r+i)/2,o=Math.sqrt((r+i)**2-4*(r*i-a*n))/2,c=s+o||1,l=s-o||1;return[Math.sqrt(c),Math.sqrt(l)]}static normalizeRect(e){const t=e.slice(0);if(e[0]>e[2]){t[0]=e[2];t[2]=e[0]}if(e[1]>e[3]){t[1]=e[3];t[3]=e[1]}return t}static intersect(e,t){const r=Math.max(Math.min(e[0],e[2]),Math.min(t[0],t[2])),n=Math.min(Math.max(e[0],e[2]),Math.max(t[0],t[2]));if(r>n)return null;const a=Math.max(Math.min(e[1],e[3]),Math.min(t[1],t[3])),i=Math.min(Math.max(e[1],e[3]),Math.max(t[1],t[3]));return a>i?null:[r,a,n,i]}static bezierBoundingBox(e,t,r,n,a,i,s,o){const c=[],l=[[],[]];let h,u,d,f,g,p,m,b;for(let l=0;l<2;++l){if(0===l){u=6*e-12*r+6*a;h=-3*e+9*r-9*a+3*s;d=3*r-3*e}else{u=6*t-12*n+6*i;h=-3*t+9*n-9*i+3*o;d=3*n-3*t}if(Math.abs(h)<1e-12){if(Math.abs(u)<1e-12)continue;f=-d/u;0<f&&f<1&&c.push(f)}else{m=u*u-4*d*h;b=Math.sqrt(m);if(!(m<0)){g=(-u+b)/(2*h);0<g&&g<1&&c.push(g);p=(-u-b)/(2*h);0<p&&p<1&&c.push(p)}}}let y,w=c.length;const S=w;for(;w--;){f=c[w];y=1-f;l[0][w]=y*y*y*e+3*y*y*f*r+3*y*f*f*a+f*f*f*s;l[1][w]=y*y*y*t+3*y*y*f*n+3*y*f*f*i+f*f*f*o}l[0][S]=e;l[1][S]=t;l[0][S+1]=s;l[1][S+1]=o;l[0].length=l[1].length=S+2;return[Math.min(...l[0]),Math.min(...l[1]),Math.max(...l[0]),Math.max(...l[1])]}}t.Util=Util;const o=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,728,711,710,729,733,731,730,732,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8226,8224,8225,8230,8212,8211,402,8260,8249,8250,8722,8240,8222,8220,8221,8216,8217,8218,8482,64257,64258,321,338,352,376,381,305,322,339,353,382,0,8364];function stringToUTF8String(e){return decodeURIComponent(escape(e))}},(e,t,r)=>{"use strict";var n=r(4),a=r(160);n({target:"RegExp",proto:!0,forced:/./.exec!==a},{exec:a})},(e,t,r)=>{"use strict";var n=r(9),a=r(15),i=r(161),s=r(162),o=r(163),c=r(34),l=r(117),h=r(51).get,u=r(164),d=r(165),f=c("native-string-replace",String.prototype.replace),g=RegExp.prototype.exec,p=g,m=a("".charAt),b=a("".indexOf),y=a("".replace),w=a("".slice),S=function(){var e=/a/,t=/b*/g;n(g,e,"a");n(g,t,"a");return 0!==e.lastIndex||0!==t.lastIndex}(),x=o.BROKEN_CARET,v=void 0!==/()??/.exec("")[1];(S||v||x||u||d)&&(p=function exec(e){var t,r,a,o,c,u,d,k=this,C=h(k),O=i(e),T=C.raw;if(T){T.lastIndex=k.lastIndex;t=n(p,T,O);k.lastIndex=T.lastIndex;return t}var M=C.groups,E=x&&k.sticky,D=n(s,k),N=k.source,R=0,L=O;if(E){D=y(D,"y","");-1===b(D,"g")&&(D+="g");L=w(O,k.lastIndex);if(k.lastIndex>0&&(!k.multiline||k.multiline&&"\n"!==m(O,k.lastIndex-1))){N="(?: "+N+")";L=" "+L;R++}r=new RegExp("^(?:"+N+")",D)}v&&(r=new RegExp("^"+N+"$(?!\\s)",D));S&&(a=k.lastIndex);o=n(g,E?r:k,L);if(E)if(o){o.input=w(o.input,R);o[0]=w(o[0],R);o.index=k.lastIndex;k.lastIndex+=o[0].length}else k.lastIndex=0;else S&&o&&(k.lastIndex=k.global?o.index+o[0].length:a);v&&o&&o.length>1&&n(f,o[0],r,(function(){for(c=1;c<arguments.length-2;c++)void 0===arguments[c]&&(o[c]=void 0)}));if(o&&M){o.groups=u=l(null);for(c=0;c<M.length;c++)u[(d=M[c])[0]]=o[d[1]]}return o});e.exports=p},(e,t,r)=>{var n=r(77),a=String;e.exports=function(e){if("Symbol"===n(e))throw TypeError("Cannot convert a Symbol value to a string");return a(e)}},(e,t,r)=>{"use strict";var n=r(46);e.exports=function(){var e=n(this),t="";e.hasIndices&&(t+="d");e.global&&(t+="g");e.ignoreCase&&(t+="i");e.multiline&&(t+="m");e.dotAll&&(t+="s");e.unicode&&(t+="u");e.unicodeSets&&(t+="v");e.sticky&&(t+="y");return t}},(e,t,r)=>{var n=r(8),a=r(5).RegExp,i=n((function(){var e=a("a","y");e.lastIndex=2;return null!=e.exec("abcd")})),s=i||n((function(){return!a("a","y").sticky})),o=i||n((function(){var e=a("^r","gy");e.lastIndex=2;return null!=e.exec("str")}));e.exports={BROKEN_CARET:o,MISSED_STICKY:s,UNSUPPORTED_Y:i}},(e,t,r)=>{var n=r(8),a=r(5).RegExp;e.exports=n((function(){var e=a(".","s");return!(e.dotAll&&e.exec("\n")&&"s"===e.flags)}))},(e,t,r)=>{var n=r(8),a=r(5).RegExp;e.exports=n((function(){var e=a("(?<a>b)","g");return"b"!==e.exec("b").groups.a||"bc"!=="b".replace(e,"$<a>c")}))},(e,t,r)=>{r(167)},(e,t,r)=>{"use strict";r(168);var n,a=r(4),i=r(7),s=r(170),o=r(5),c=r(81),l=r(15),h=r(47),u=r(171),d=r(73),f=r(38),g=r(172),p=r(173),m=r(135),b=r(169).codeAt,y=r(175),w=r(161),S=r(71),x=r(84),v=r(176),k=r(51),C=k.set,O=k.getterFor("URL"),T=v.URLSearchParams,M=v.getState,E=o.URL,D=o.TypeError,N=o.parseInt,R=Math.floor,L=Math.pow,j=l("".charAt),_=l(/./.exec),U=l([].join),$=l(1..toString),X=l([].pop),H=l([].push),q=l("".replace),W=l([].shift),z=l("".split),G=l("".slice),V=l("".toLowerCase),K=l([].unshift),Y="Invalid scheme",J="Invalid host",Z="Invalid port",Q=/[a-z]/i,ee=/[\d+-.a-z]/i,te=/\d/,re=/^0x/i,ne=/^[0-7]+$/,ae=/^\d+$/,ie=/^[\da-f]+$/i,se=/[\0\t\n\r #%/:<>?@[\\\]^|]/,oe=/[\0\t\n\r #/:<>?@[\\\]^|]/,ce=/^[\u0000-\u0020]+|[\u0000-\u0020]+$/g,le=/[\t\n\r]/g,serializeHost=function(e){var t,r,n,a;if("number"==typeof e){t=[];for(r=0;r<4;r++){K(t,e%256);e=R(e/256)}return U(t,".")}if("object"==typeof e){t="";n=function(e){for(var t=null,r=1,n=null,a=0,i=0;i<8;i++)if(0!==e[i]){if(a>r){t=n;r=a}n=null;a=0}else{null===n&&(n=i);++a}if(a>r){t=n;r=a}return t}(e);for(r=0;r<8;r++)if(!a||0!==e[r]){a&&(a=!1);if(n===r){t+=r?":":"::";a=!0}else{t+=$(e[r],16);r<7&&(t+=":")}}return"["+t+"]"}return e},he={},ue=g({},he,{" ":1,'"':1,"<":1,">":1,"`":1}),de=g({},ue,{"#":1,"?":1,"{":1,"}":1}),fe=g({},de,{"/":1,":":1,";":1,"=":1,"@":1,"[":1,"\\":1,"]":1,"^":1,"|":1}),percentEncode=function(e,t){var r=b(e,0);return r>32&&r<127&&!f(t,e)?e:encodeURIComponent(e)},ge={ftp:21,file:null,http:80,https:443,ws:80,wss:443},isWindowsDriveLetter=function(e,t){var r;return 2==e.length&&_(Q,j(e,0))&&(":"==(r=j(e,1))||!t&&"|"==r)},startsWithWindowsDriveLetter=function(e){var t;return e.length>1&&isWindowsDriveLetter(G(e,0,2))&&(2==e.length||"/"===(t=j(e,2))||"\\"===t||"?"===t||"#"===t)},isSingleDot=function(e){return"."===e||"%2e"===V(e)},pe={},me={},be={},ye={},we={},Se={},xe={},ve={},Ae={},ke={},Ce={},Fe={},Oe={},Te={},Ie={},Pe={},Me={},Ee={},De={},Be={},Ne={},URLState=function(e,t,r){var n,a,i,s=w(e);if(t){if(a=this.parse(s))throw D(a);this.searchParams=null}else{void 0!==r&&(n=new URLState(r,!0));if(a=this.parse(s,null,n))throw D(a);(i=M(new T)).bindURL(this);this.searchParams=i}};URLState.prototype={type:"URL",parse:function(e,t,r){var a,i,s,o,c,l=this,h=t||pe,u=0,d="",g=!1,b=!1,y=!1;e=w(e);if(!t){l.scheme="";l.username="";l.password="";l.host=null;l.port=null;l.path=[];l.query=null;l.fragment=null;l.cannotBeABaseURL=!1;e=q(e,ce,"")}e=q(e,le,"");a=p(e);for(;u<=a.length;){i=a[u];switch(h){case pe:if(!i||!_(Q,i)){if(t)return Y;h=be;continue}d+=V(i);h=me;break;case me:if(i&&(_(ee,i)||"+"==i||"-"==i||"."==i))d+=V(i);else{if(":"!=i){if(t)return Y;d="";h=be;u=0;continue}if(t&&(l.isSpecial()!=f(ge,d)||"file"==d&&(l.includesCredentials()||null!==l.port)||"file"==l.scheme&&!l.host))return;l.scheme=d;if(t){l.isSpecial()&&ge[l.scheme]==l.port&&(l.port=null);return}d="";if("file"==l.scheme)h=Te;else if(l.isSpecial()&&r&&r.scheme==l.scheme)h=ye;else if(l.isSpecial())h=ve;else if("/"==a[u+1]){h=we;u++}else{l.cannotBeABaseURL=!0;H(l.path,"");h=De}}break;case be:if(!r||r.cannotBeABaseURL&&"#"!=i)return Y;if(r.cannotBeABaseURL&&"#"==i){l.scheme=r.scheme;l.path=m(r.path);l.query=r.query;l.fragment="";l.cannotBeABaseURL=!0;h=Ne;break}h="file"==r.scheme?Te:Se;continue;case ye:if("/"!=i||"/"!=a[u+1]){h=Se;continue}h=Ae;u++;break;case we:if("/"==i){h=ke;break}h=Ee;continue;case Se:l.scheme=r.scheme;if(i==n){l.username=r.username;l.password=r.password;l.host=r.host;l.port=r.port;l.path=m(r.path);l.query=r.query}else if("/"==i||"\\"==i&&l.isSpecial())h=xe;else if("?"==i){l.username=r.username;l.password=r.password;l.host=r.host;l.port=r.port;l.path=m(r.path);l.query="";h=Be}else{if("#"!=i){l.username=r.username;l.password=r.password;l.host=r.host;l.port=r.port;l.path=m(r.path);l.path.length--;h=Ee;continue}l.username=r.username;l.password=r.password;l.host=r.host;l.port=r.port;l.path=m(r.path);l.query=r.query;l.fragment="";h=Ne}break;case xe:if(!l.isSpecial()||"/"!=i&&"\\"!=i){if("/"!=i){l.username=r.username;l.password=r.password;l.host=r.host;l.port=r.port;h=Ee;continue}h=ke}else h=Ae;break;case ve:h=Ae;if("/"!=i||"/"!=j(d,u+1))continue;u++;break;case Ae:if("/"!=i&&"\\"!=i){h=ke;continue}break;case ke:if("@"==i){g&&(d="%40"+d);g=!0;s=p(d);for(var S=0;S<s.length;S++){var x=s[S];if(":"!=x||y){var v=percentEncode(x,fe);y?l.password+=v:l.username+=v}else y=!0}d=""}else if(i==n||"/"==i||"?"==i||"#"==i||"\\"==i&&l.isSpecial()){if(g&&""==d)return"Invalid authority";u-=p(d).length+1;d="";h=Ce}else d+=i;break;case Ce:case Fe:if(t&&"file"==l.scheme){h=Pe;continue}if(":"!=i||b){if(i==n||"/"==i||"?"==i||"#"==i||"\\"==i&&l.isSpecial()){if(l.isSpecial()&&""==d)return J;if(t&&""==d&&(l.includesCredentials()||null!==l.port))return;if(o=l.parseHost(d))return o;d="";h=Me;if(t)return;continue}"["==i?b=!0:"]"==i&&(b=!1);d+=i}else{if(""==d)return J;if(o=l.parseHost(d))return o;d="";h=Oe;if(t==Fe)return}break;case Oe:if(!_(te,i)){if(i==n||"/"==i||"?"==i||"#"==i||"\\"==i&&l.isSpecial()||t){if(""!=d){var k=N(d,10);if(k>65535)return Z;l.port=l.isSpecial()&&k===ge[l.scheme]?null:k;d=""}if(t)return;h=Me;continue}return Z}d+=i;break;case Te:l.scheme="file";if("/"==i||"\\"==i)h=Ie;else{if(!r||"file"!=r.scheme){h=Ee;continue}if(i==n){l.host=r.host;l.path=m(r.path);l.query=r.query}else if("?"==i){l.host=r.host;l.path=m(r.path);l.query="";h=Be}else{if("#"!=i){if(!startsWithWindowsDriveLetter(U(m(a,u),""))){l.host=r.host;l.path=m(r.path);l.shortenPath()}h=Ee;continue}l.host=r.host;l.path=m(r.path);l.query=r.query;l.fragment="";h=Ne}}break;case Ie:if("/"==i||"\\"==i){h=Pe;break}r&&"file"==r.scheme&&!startsWithWindowsDriveLetter(U(m(a,u),""))&&(isWindowsDriveLetter(r.path[0],!0)?H(l.path,r.path[0]):l.host=r.host);h=Ee;continue;case Pe:if(i==n||"/"==i||"\\"==i||"?"==i||"#"==i){if(!t&&isWindowsDriveLetter(d))h=Ee;else if(""==d){l.host="";if(t)return;h=Me}else{if(o=l.parseHost(d))return o;"localhost"==l.host&&(l.host="");if(t)return;d="";h=Me}continue}d+=i;break;case Me:if(l.isSpecial()){h=Ee;if("/"!=i&&"\\"!=i)continue}else if(t||"?"!=i)if(t||"#"!=i){if(i!=n){h=Ee;if("/"!=i)continue}}else{l.fragment="";h=Ne}else{l.query="";h=Be}break;case Ee:if(i==n||"/"==i||"\\"==i&&l.isSpecial()||!t&&("?"==i||"#"==i)){if(".."===(c=V(c=d))||"%2e."===c||".%2e"===c||"%2e%2e"===c){l.shortenPath();"/"==i||"\\"==i&&l.isSpecial()||H(l.path,"")}else if(isSingleDot(d))"/"==i||"\\"==i&&l.isSpecial()||H(l.path,"");else{if("file"==l.scheme&&!l.path.length&&isWindowsDriveLetter(d)){l.host&&(l.host="");d=j(d,0)+":"}H(l.path,d)}d="";if("file"==l.scheme&&(i==n||"?"==i||"#"==i))for(;l.path.length>1&&""===l.path[0];)W(l.path);if("?"==i){l.query="";h=Be}else if("#"==i){l.fragment="";h=Ne}}else d+=percentEncode(i,de);break;case De:if("?"==i){l.query="";h=Be}else if("#"==i){l.fragment="";h=Ne}else i!=n&&(l.path[0]+=percentEncode(i,he));break;case Be:if(t||"#"!=i)i!=n&&("'"==i&&l.isSpecial()?l.query+="%27":l.query+="#"==i?"%23":percentEncode(i,he));else{l.fragment="";h=Ne}break;case Ne:i!=n&&(l.fragment+=percentEncode(i,ue))}u++}},parseHost:function(e){var t,r,n;if("["==j(e,0)){if("]"!=j(e,e.length-1))return J;t=function(e){var t,r,n,a,i,s,o,c=[0,0,0,0,0,0,0,0],l=0,h=null,u=0,chr=function(){return j(e,u)};if(":"==chr()){if(":"!=j(e,1))return;u+=2;h=++l}for(;chr();){if(8==l)return;if(":"!=chr()){t=r=0;for(;r<4&&_(ie,chr());){t=16*t+N(chr(),16);u++;r++}if("."==chr()){if(0==r)return;u-=r;if(l>6)return;n=0;for(;chr();){a=null;if(n>0){if(!("."==chr()&&n<4))return;u++}if(!_(te,chr()))return;for(;_(te,chr());){i=N(chr(),10);if(null===a)a=i;else{if(0==a)return;a=10*a+i}if(a>255)return;u++}c[l]=256*c[l]+a;2!=++n&&4!=n||l++}if(4!=n)return;break}if(":"==chr()){u++;if(!chr())return}else if(chr())return;c[l++]=t}else{if(null!==h)return;u++;h=++l}}if(null!==h){s=l-h;l=7;for(;0!=l&&s>0;){o=c[l];c[l--]=c[h+s-1];c[h+--s]=o}}else if(8!=l)return;return c}(G(e,1,-1));if(!t)return J;this.host=t}else if(this.isSpecial()){e=y(e);if(_(se,e))return J;t=function(e){var t,r,n,a,i,s,o,c=z(e,".");c.length&&""==c[c.length-1]&&c.length--;if((t=c.length)>4)return e;r=[];for(n=0;n<t;n++){if(""==(a=c[n]))return e;i=10;if(a.length>1&&"0"==j(a,0)){i=_(re,a)?16:8;a=G(a,8==i?1:2)}if(""===a)s=0;else{if(!_(10==i?ae:8==i?ne:ie,a))return e;s=N(a,i)}H(r,s)}for(n=0;n<t;n++){s=r[n];if(n==t-1){if(s>=L(256,5-t))return null}else if(s>255)return null}o=X(r);for(n=0;n<r.length;n++)o+=r[n]*L(256,3-n);return o}(e);if(null===t)return J;this.host=t}else{if(_(oe,e))return J;t="";r=p(e);for(n=0;n<r.length;n++)t+=percentEncode(r[n],he);this.host=t}},cannotHaveUsernamePasswordPort:function(){return!this.host||this.cannotBeABaseURL||"file"==this.scheme},includesCredentials:function(){return""!=this.username||""!=this.password},isSpecial:function(){return f(ge,this.scheme)},shortenPath:function(){var e=this.path,t=e.length;!t||"file"==this.scheme&&1==t&&isWindowsDriveLetter(e[0],!0)||e.length--},serialize:function(){var e=this,t=e.scheme,r=e.username,n=e.password,a=e.host,i=e.port,s=e.path,o=e.query,c=e.fragment,l=t+":";if(null!==a){l+="//";e.includesCredentials()&&(l+=r+(n?":"+n:"")+"@");l+=serializeHost(a);null!==i&&(l+=":"+i)}else"file"==t&&(l+="//");l+=e.cannotBeABaseURL?s[0]:s.length?"/"+U(s,"/"):"";null!==o&&(l+="?"+o);null!==c&&(l+="#"+c);return l},setHref:function(e){var t=this.parse(e);if(t)throw D(t);this.searchParams.update()},getOrigin:function(){var e=this.scheme,t=this.port;if("blob"==e)try{return new Re(e.path[0]).origin}catch(e){return"null"}return"file"!=e&&this.isSpecial()?e+"://"+serializeHost(this.host)+(null!==t?":"+t:""):"null"},getProtocol:function(){return this.scheme+":"},setProtocol:function(e){this.parse(w(e)+":",pe)},getUsername:function(){return this.username},setUsername:function(e){var t=p(w(e));if(!this.cannotHaveUsernamePasswordPort()){this.username="";for(var r=0;r<t.length;r++)this.username+=percentEncode(t[r],fe)}},getPassword:function(){return this.password},setPassword:function(e){var t=p(w(e));if(!this.cannotHaveUsernamePasswordPort()){this.password="";for(var r=0;r<t.length;r++)this.password+=percentEncode(t[r],fe)}},getHost:function(){var e=this.host,t=this.port;return null===e?"":null===t?serializeHost(e):serializeHost(e)+":"+t},setHost:function(e){this.cannotBeABaseURL||this.parse(e,Ce)},getHostname:function(){var e=this.host;return null===e?"":serializeHost(e)},setHostname:function(e){this.cannotBeABaseURL||this.parse(e,Fe)},getPort:function(){var e=this.port;return null===e?"":w(e)},setPort:function(e){this.cannotHaveUsernamePasswordPort()||(""==(e=w(e))?this.port=null:this.parse(e,Oe))},getPathname:function(){var e=this.path;return this.cannotBeABaseURL?e[0]:e.length?"/"+U(e,"/"):""},setPathname:function(e){if(!this.cannotBeABaseURL){this.path=[];this.parse(e,Me)}},getSearch:function(){var e=this.query;return e?"?"+e:""},setSearch:function(e){if(""==(e=w(e)))this.query=null;else{"?"==j(e,0)&&(e=G(e,1));this.query="";this.parse(e,Be)}this.searchParams.update()},getSearchParams:function(){return this.searchParams.facade},getHash:function(){var e=this.fragment;return e?"#"+e:""},setHash:function(e){if(""!=(e=w(e))){"#"==j(e,0)&&(e=G(e,1));this.fragment="";this.parse(e,Ne)}else this.fragment=null},update:function(){this.query=this.searchParams.serialize()||null}};var Re=function URL(e){var t=d(this,Le),r=x(arguments.length,1)>1?arguments[1]:void 0,n=C(t,new URLState(e,!1,r));if(!i){t.href=n.serialize();t.origin=n.getOrigin();t.protocol=n.getProtocol();t.username=n.getUsername();t.password=n.getPassword();t.host=n.getHost();t.hostname=n.getHostname();t.port=n.getPort();t.pathname=n.getPathname();t.search=n.getSearch();t.searchParams=n.getSearchParams();t.hash=n.getHash()}},Le=Re.prototype,accessorDescriptor=function(e,t){return{get:function(){return O(this)[e]()},set:t&&function(e){return O(this)[t](e)},configurable:!0,enumerable:!0}};if(i){u(Le,"href",accessorDescriptor("serialize","setHref"));u(Le,"origin",accessorDescriptor("getOrigin"));u(Le,"protocol",accessorDescriptor("getProtocol","setProtocol"));u(Le,"username",accessorDescriptor("getUsername","setUsername"));u(Le,"password",accessorDescriptor("getPassword","setPassword"));u(Le,"host",accessorDescriptor("getHost","setHost"));u(Le,"hostname",accessorDescriptor("getHostname","setHostname"));u(Le,"port",accessorDescriptor("getPort","setPort"));u(Le,"pathname",accessorDescriptor("getPathname","setPathname"));u(Le,"search",accessorDescriptor("getSearch","setSearch"));u(Le,"searchParams",accessorDescriptor("getSearchParams"));u(Le,"hash",accessorDescriptor("getHash","setHash"))}h(Le,"toJSON",(function toJSON(){return O(this).serialize()}),{enumerable:!0});h(Le,"toString",(function toString(){return O(this).serialize()}),{enumerable:!0});if(E){var je=E.createObjectURL,_e=E.revokeObjectURL;je&&h(Re,"createObjectURL",c(je,E));_e&&h(Re,"revokeObjectURL",c(_e,E))}S(Re,"URL");a({global:!0,constructor:!0,forced:!s,sham:!i},{URL:Re})},(e,t,r)=>{"use strict";var n=r(169).charAt,a=r(161),i=r(51),s=r(120),o="String Iterator",c=i.set,l=i.getterFor(o);s(String,"String",(function(e){c(this,{type:o,string:a(e),index:0})}),(function next(){var e,t=l(this),r=t.string,a=t.index;if(a>=r.length)return{value:void 0,done:!0};e=n(r,a);t.index+=e.length;return{value:e,done:!1}}))},(e,t,r)=>{var n=r(15),a=r(61),i=r(161),s=r(17),o=n("".charAt),c=n("".charCodeAt),l=n("".slice),createMethod=function(e){return function(t,r){var n,h,u=i(s(t)),d=a(r),f=u.length;return d<0||d>=f?e?"":void 0:(n=c(u,d))<55296||n>56319||d+1===f||(h=c(u,d+1))<56320||h>57343?e?o(u,d):n:e?l(u,d,d+2):h-56320+(n-55296<<10)+65536}};e.exports={codeAt:createMethod(!1),charAt:createMethod(!0)}},(e,t,r)=>{var n=r(8),a=r(33),i=r(35),s=a("iterator");e.exports=!n((function(){var e=new URL("b?a=1&b=2&c=3","http://a"),t=e.searchParams,r="";e.pathname="c%20d";t.forEach((function(e,n){t.delete("b");r+=n+e}));return i&&!e.toJSON||!t.sort||"http://a/c%20d?a=1&c=3"!==e.href||"3"!==t.get("c")||"a=1"!==String(new URLSearchParams("?a=1"))||!t[s]||"a"!==new URL("https://a@b").username||"b"!==new URLSearchParams(new URLSearchParams("a=b")).get("a")||"xn--e1aybc"!==new URL("http://тест").host||"#%D0%B1"!==new URL("http://a#б").hash||"a1c3"!==r||"x"!==new URL("http://x",void 0).host}))},(e,t,r)=>{var n=r(48),a=r(44);e.exports=function(e,t,r){r.get&&n(r.get,t,{getter:!0});r.set&&n(r.set,t,{setter:!0});return a.f(e,t,r)}},(e,t,r)=>{"use strict";var n=r(7),a=r(15),i=r(9),s=r(8),o=r(119),c=r(66),l=r(11),h=r(39),u=r(14),d=Object.assign,f=Object.defineProperty,g=a([].concat);e.exports=!d||s((function(){if(n&&1!==d({b:1},d(f({},"a",{enumerable:!0,get:function(){f(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var e={},t={},r=Symbol(),a="abcdefghijklmnopqrst";e[r]=7;a.split("").forEach((function(e){t[e]=e}));return 7!=d({},e)[r]||o(d({},t)).join("")!=a}))?function assign(e,t){for(var r=h(e),a=arguments.length,s=1,d=c.f,f=l.f;a>s;)for(var p,m=u(arguments[s++]),b=d?g(o(m),d(m)):o(m),y=b.length,w=0;y>w;){p=b[w++];n&&!i(f,m,p)||(r[p]=m[p])}return r}:d},(e,t,r)=>{"use strict";var n=r(81),a=r(9),i=r(39),s=r(174),o=r(98),c=r(76),l=r(63),h=r(136),u=r(100),d=r(101),f=Array;e.exports=function from(e){var t=i(e),r=c(this),g=arguments.length,p=g>1?arguments[1]:void 0,m=void 0!==p;m&&(p=n(p,g>2?arguments[2]:void 0));var b,y,w,S,x,v,k=d(t),C=0;if(!k||this===f&&o(k)){b=l(t);y=r?new this(b):f(b);for(;b>C;C++){v=m?p(t[C],C):t[C];h(y,C,v)}}else{x=(S=u(t,k)).next;y=r?new this:[];for(;!(w=a(x,S)).done;C++){v=m?s(S,p,[w.value,C],!0):w.value;h(y,C,v)}}y.length=C;return y}},(e,t,r)=>{var n=r(46),a=r(102);e.exports=function(e,t,r,i){try{return i?t(n(r)[0],r[1]):t(r)}catch(t){a(e,"throw",t)}}},(e,t,r)=>{"use strict";var n=r(15),a=2147483647,i=/[^\0-\u007E]/,s=/[.\u3002\uFF0E\uFF61]/g,o="Overflow: input needs wider integers to process",c=RangeError,l=n(s.exec),h=Math.floor,u=String.fromCharCode,d=n("".charCodeAt),f=n([].join),g=n([].push),p=n("".replace),m=n("".split),b=n("".toLowerCase),digitToBasic=function(e){return e+22+75*(e<26)},adapt=function(e,t,r){var n=0;e=r?h(e/700):e>>1;e+=h(e/t);for(;e>455;){e=h(e/35);n+=36}return h(n+36*e/(e+38))},encode=function(e){var t=[];e=function(e){for(var t=[],r=0,n=e.length;r<n;){var a=d(e,r++);if(a>=55296&&a<=56319&&r<n){var i=d(e,r++);if(56320==(64512&i))g(t,((1023&a)<<10)+(1023&i)+65536);else{g(t,a);r--}}else g(t,a)}return t}(e);var r,n,i=e.length,s=128,l=0,p=72;for(r=0;r<e.length;r++)(n=e[r])<128&&g(t,u(n));var m=t.length,b=m;m&&g(t,"-");for(;b<i;){var y=a;for(r=0;r<e.length;r++)(n=e[r])>=s&&n<y&&(y=n);var w=b+1;if(y-s>h((a-l)/w))throw c(o);l+=(y-s)*w;s=y;for(r=0;r<e.length;r++){if((n=e[r])<s&&++l>a)throw c(o);if(n==s){for(var S=l,x=36;;){var v=x<=p?1:x>=p+26?26:x-p;if(S<v)break;var k=S-v,C=36-v;g(t,u(digitToBasic(v+k%C)));S=h(k/C);x+=36}g(t,u(digitToBasic(S)));p=adapt(l,w,b==m);l=0;b++}}l++;s++}return f(t,"")};e.exports=function(e){var t,r,n=[],a=m(p(b(e),s,"."),".");for(t=0;t<a.length;t++){r=a[t];g(n,l(i,r)?"xn--"+encode(r):r)}return f(n,".")}},(e,t,r)=>{"use strict";r(115);var n=r(4),a=r(5),i=r(9),s=r(15),o=r(7),c=r(170),l=r(47),h=r(131),u=r(71),d=r(121),f=r(51),g=r(73),p=r(21),m=r(38),b=r(81),y=r(77),w=r(46),S=r(20),x=r(161),v=r(117),k=r(12),C=r(100),O=r(101),T=r(84),M=r(33),E=r(150),D=M("iterator"),N="URLSearchParams",R="URLSearchParamsIterator",L=f.set,j=f.getterFor(N),_=f.getterFor(R),U=Object.getOwnPropertyDescriptor,safeGetBuiltIn=function(e){if(!o)return a[e];var t=U(a,e);return t&&t.value},$=safeGetBuiltIn("fetch"),X=safeGetBuiltIn("Request"),H=safeGetBuiltIn("Headers"),q=X&&X.prototype,W=H&&H.prototype,z=a.RegExp,G=a.TypeError,V=a.decodeURIComponent,K=a.encodeURIComponent,Y=s("".charAt),J=s([].join),Z=s([].push),Q=s("".replace),ee=s([].shift),te=s([].splice),re=s("".split),ne=s("".slice),ae=/\+/g,ie=Array(4),percentSequence=function(e){return ie[e-1]||(ie[e-1]=z("((?:%[\\da-f]{2}){"+e+"})","gi"))},percentDecode=function(e){try{return V(e)}catch(t){return e}},deserialize=function(e){var t=Q(e,ae," "),r=4;try{return V(t)}catch(e){for(;r;)t=Q(t,percentSequence(r--),percentDecode);return t}},se=/[!'()~]|%20/g,oe={"!":"%21","'":"%27","(":"%28",")":"%29","~":"%7E","%20":"+"},replacer=function(e){return oe[e]},serialize=function(e){return Q(K(e),se,replacer)},ce=d((function Iterator(e,t){L(this,{type:R,iterator:C(j(e).entries),kind:t})}),"Iterator",(function next(){var e=_(this),t=e.kind,r=e.iterator.next(),n=r.value;r.done||(r.value="keys"===t?n.key:"values"===t?n.value:[n.key,n.value]);return r}),!0),URLSearchParamsState=function(e){this.entries=[];this.url=null;void 0!==e&&(S(e)?this.parseObject(e):this.parseQuery("string"==typeof e?"?"===Y(e,0)?ne(e,1):e:x(e)))};URLSearchParamsState.prototype={type:N,bindURL:function(e){this.url=e;this.update()},parseObject:function(e){var t,r,n,a,s,o,c,l=O(e);if(l){r=(t=C(e,l)).next;for(;!(n=i(r,t)).done;){s=(a=C(w(n.value))).next;if((o=i(s,a)).done||(c=i(s,a)).done||!i(s,a).done)throw G("Expected sequence with length 2");Z(this.entries,{key:x(o.value),value:x(c.value)})}}else for(var h in e)m(e,h)&&Z(this.entries,{key:h,value:x(e[h])})},parseQuery:function(e){if(e)for(var t,r,n=re(e,"&"),a=0;a<n.length;)if((t=n[a++]).length){r=re(t,"=");Z(this.entries,{key:deserialize(ee(r)),value:deserialize(J(r,"="))})}},serialize:function(){for(var e,t=this.entries,r=[],n=0;n<t.length;){e=t[n++];Z(r,serialize(e.key)+"="+serialize(e.value))}return J(r,"&")},update:function(){this.entries.length=0;this.parseQuery(this.url.query)},updateURL:function(){this.url&&this.url.update()}};var le=function URLSearchParams(){g(this,he);var e=arguments.length>0?arguments[0]:void 0;L(this,new URLSearchParamsState(e))},he=le.prototype;h(he,{append:function append(e,t){T(arguments.length,2);var r=j(this);Z(r.entries,{key:x(e),value:x(t)});r.updateURL()},delete:function(e){T(arguments.length,1);for(var t=j(this),r=t.entries,n=x(e),a=0;a<r.length;)r[a].key===n?te(r,a,1):a++;t.updateURL()},get:function get(e){T(arguments.length,1);for(var t=j(this).entries,r=x(e),n=0;n<t.length;n++)if(t[n].key===r)return t[n].value;return null},getAll:function getAll(e){T(arguments.length,1);for(var t=j(this).entries,r=x(e),n=[],a=0;a<t.length;a++)t[a].key===r&&Z(n,t[a].value);return n},has:function has(e){T(arguments.length,1);for(var t=j(this).entries,r=x(e),n=0;n<t.length;)if(t[n++].key===r)return!0;return!1},set:function set(e,t){T(arguments.length,1);for(var r,n=j(this),a=n.entries,i=!1,s=x(e),o=x(t),c=0;c<a.length;c++)if((r=a[c]).key===s)if(i)te(a,c--,1);else{i=!0;r.value=o}i||Z(a,{key:s,value:o});n.updateURL()},sort:function sort(){var e=j(this);E(e.entries,(function(e,t){return e.key>t.key?1:-1}));e.updateURL()},forEach:function forEach(e){for(var t,r=j(this).entries,n=b(e,arguments.length>1?arguments[1]:void 0),a=0;a<r.length;)n((t=r[a++]).value,t.key,this)},keys:function keys(){return new ce(this,"keys")},values:function values(){return new ce(this,"values")},entries:function entries(){return new ce(this,"entries")}},{enumerable:!0});l(he,D,he.entries,{name:"entries"});l(he,"toString",(function toString(){return j(this).serialize()}),{enumerable:!0});u(le,N);n({global:!0,constructor:!0,forced:!c},{URLSearchParams:le});if(!c&&p(H)){var ue=s(W.has),de=s(W.set),wrapRequestOptions=function(e){if(S(e)){var t,r=e.body;if(y(r)===N){t=e.headers?new H(e.headers):new H;ue(t,"content-type")||de(t,"content-type","application/x-www-form-urlencoded;charset=UTF-8");return v(e,{body:k(0,x(r)),headers:k(0,t)})}}return e};p($)&&n({global:!0,enumerable:!0,dontCallGetSet:!0,forced:!0},{fetch:function fetch(e){return $(e,arguments.length>1?wrapRequestOptions(arguments[1]):{})}});if(p(X)){var fe=function Request(e){g(this,q);return new X(e,arguments.length>1?wrapRequestOptions(arguments[1]):{})};q.constructor=fe;fe.prototype=q;n({global:!0,constructor:!0,dontCallGetSet:!0,forced:!0},{Request:fe})}}e.exports={URLSearchParams:le,getState:j}},(e,t,r)=>{r(176)},(e,t,r)=>{r(126)("Uint32",(function(e){return function Uint32Array(t,r,n){return e(this,t,r,n)}}))},(e,t,r)=>{"use strict";var n=r(80),a=r(9),i=r(15),s=r(180),o=r(8),c=r(46),l=r(21),h=r(61),u=r(64),d=r(161),f=r(17),g=r(181),p=r(29),m=r(182),b=r(183),y=r(33)("replace"),w=Math.max,S=Math.min,x=i([].concat),v=i([].push),k=i("".indexOf),C=i("".slice),O="$0"==="a".replace(/./,"$0"),T=!!/./[y]&&""===/./[y]("a","$0");s("replace",(function(e,t,r){var i=T?"$":"$0";return[function replace(e,r){var n=f(this),i=null==e?void 0:p(e,y);return i?a(i,e,n,r):a(t,d(n),e,r)},function(e,a){var s=c(this),o=d(e);if("string"==typeof a&&-1===k(a,i)&&-1===k(a,"$<")){var f=r(t,s,o,a);if(f.done)return f.value}var p=l(a);p||(a=d(a));var y=s.global;if(y){var O=s.unicode;s.lastIndex=0}for(var T=[];;){var M=b(s,o);if(null===M)break;v(T,M);if(!y)break;""===d(M[0])&&(s.lastIndex=g(o,u(s.lastIndex),O))}for(var E,D="",N=0,R=0;R<T.length;R++){for(var L=d((M=T[R])[0]),j=w(S(h(M.index),o.length),0),_=[],U=1;U<M.length;U++)v(_,void 0===(E=M[U])?E:String(E));var $=M.groups;if(p){var X=x([L],_,j,o);void 0!==$&&v(X,$);var H=d(n(a,void 0,X))}else H=m(L,o,j,_,$,a);if(j>=N){D+=C(o,N,j)+H;N=j+L.length}}return D+C(o,N)}]}),!!o((function(){var e=/./;e.exec=function(){var e=[];e.groups={a:"7"};return e};return"7"!=="".replace(e,"$<a>")}))||!O||T)},(e,t,r)=>{"use strict";r(159);var n=r(15),a=r(47),i=r(160),s=r(8),o=r(33),c=r(43),l=o("species"),h=RegExp.prototype;e.exports=function(e,t,r,u){var d=o(e),f=!s((function(){var t={};t[d]=function(){return 7};return 7!=""[e](t)})),g=f&&!s((function(){var t=!1,r=/a/;if("split"===e){(r={}).constructor={};r.constructor[l]=function(){return r};r.flags="";r[d]=/./[d]}r.exec=function(){t=!0;return null};r[d]("");return!t}));if(!f||!g||r){var p=n(/./[d]),m=t(d,""[e],(function(e,t,r,a,s){var o=n(e),c=t.exec;return c===i||c===h.exec?f&&!s?{done:!0,value:p(t,r,a)}:{done:!0,value:o(r,t,a)}:{done:!1}}));a(String.prototype,e,m[0]);a(h,d,m[1])}u&&c(h[d],"sham",!0)}},(e,t,r)=>{"use strict";var n=r(169).charAt;e.exports=function(e,t,r){return t+(r?n(e,t).length:1)}},(e,t,r)=>{var n=r(15),a=r(39),i=Math.floor,s=n("".charAt),o=n("".replace),c=n("".slice),l=/\$([$&'`]|\d{1,2}|<[^>]*>)/g,h=/\$([$&'`]|\d{1,2})/g;e.exports=function(e,t,r,n,u,d){var f=r+e.length,g=n.length,p=h;if(void 0!==u){u=a(u);p=l}return o(d,p,(function(a,o){var l;switch(s(o,0)){case"$":return"$";case"&":return e;case"`":return c(t,0,r);case"'":return c(t,f);case"<":l=u[c(o,1,-1)];break;default:var h=+o;if(0===h)return a;if(h>g){var d=i(h/10);return 0===d?a:d<=g?void 0===n[d-1]?s(o,1):n[d-1]+s(o,1):a}l=n[h-1]}return void 0===l?"":l}))}},(e,t,r)=>{var n=r(9),a=r(46),i=r(21),s=r(16),o=r(160),c=TypeError;e.exports=function(e,t){var r=e.exec;if(i(r)){var l=n(r,e,t);null!==l&&a(l);return l}if("RegExp"===s(e))return n(o,e,t);throw c("RegExp#exec called on incompatible receiver")}},(e,t,r)=>{"use strict";r(125);r(146);r(148);r(149);if(!globalThis._pdfjsCompatibilityChecked){globalThis._pdfjsCompatibilityChecked=!0;!function checkNodeBtoa(){globalThis.btoa}();!function checkNodeAtob(){globalThis.atob}();!function checkDOMMatrix(){globalThis.DOMMatrix}();!function checkReadableStream(){globalThis.ReadableStream}();!function checkArrayAt(){Array.prototype.at||r(185)}();!function checkTypedArrayAt(){Uint8Array.prototype.at||r(188)}();!function checkStructuredClone(){globalThis.structuredClone||r(190)}()}},(e,t,r)=>{r(186);var n=r(187);e.exports=n("Array","at")},(e,t,r)=>{"use strict";var n=r(4),a=r(39),i=r(63),s=r(61),o=r(116);n({target:"Array",proto:!0},{at:function at(e){var t=a(this),r=i(t),n=s(e),o=n>=0?n:r+n;return o<0||o>=r?void 0:t[o]}});o("at")},(e,t,r)=>{var n=r(5),a=r(15);e.exports=function(e,t){return a(n[e].prototype[t])}},(e,t,r)=>{r(189)},(e,t,r)=>{"use strict";var n=r(128),a=r(63),i=r(61),s=n.aTypedArray;(0,n.exportTypedArrayMethod)("at",(function at(e){var t=s(this),r=a(t),n=i(e),o=n>=0?n:r+n;return o<0||o>=r?void 0:t[o]}))},(e,t,r)=>{r(115);r(191);r(193);r(202);r(204);var n=r(208);e.exports=n.structuredClone},(e,t,r)=>{var n=r(78),a=r(47),i=r(192);n||a(Object.prototype,"toString",i,{unsafe:!0})},(e,t,r)=>{"use strict";var n=r(78),a=r(77);e.exports=n?{}.toString:function toString(){return"[object "+a(this)+"]"}},(e,t,r)=>{r(194)},(e,t,r)=>{"use strict";r(195)("Map",(function(e){return function Map(){return e(this,arguments.length?arguments[0]:void 0)}}),r(201))},(e,t,r)=>{"use strict";var n=r(4),a=r(5),i=r(15),s=r(67),o=r(47),c=r(196),l=r(97),h=r(73),u=r(21),d=r(20),f=r(8),g=r(104),p=r(71),m=r(145);e.exports=function(e,t,r){var b=-1!==e.indexOf("Map"),y=-1!==e.indexOf("Weak"),w=b?"set":"add",S=a[e],x=S&&S.prototype,v=S,k={},fixMethod=function(e){var t=i(x[e]);o(x,e,"add"==e?function add(e){t(this,0===e?0:e);return this}:"delete"==e?function(e){return!(y&&!d(e))&&t(this,0===e?0:e)}:"get"==e?function get(e){return y&&!d(e)?void 0:t(this,0===e?0:e)}:"has"==e?function has(e){return!(y&&!d(e))&&t(this,0===e?0:e)}:function set(e,r){t(this,0===e?0:e,r);return this})};if(s(e,!u(S)||!(y||x.forEach&&!f((function(){(new S).entries().next()}))))){v=r.getConstructor(t,e,b,w);c.enable()}else if(s(e,!0)){var C=new v,O=C[w](y?{}:-0,1)!=C,T=f((function(){C.has(1)})),M=g((function(e){new S(e)})),E=!y&&f((function(){for(var e=new S,t=5;t--;)e[w](t,t);return!e.has(-0)}));if(!M){(v=t((function(e,t){h(e,x);var r=m(new S,e,v);null!=t&&l(t,r[w],{that:r,AS_ENTRIES:b});return r}))).prototype=x;x.constructor=v}if(T||E){fixMethod("delete");fixMethod("has");b&&fixMethod("get")}(E||O)&&fixMethod(w);y&&x.clear&&delete x.clear}k[e]=v;n({global:!0,constructor:!0,forced:v!=S},k);p(v,e);y||r.setStrong(v,e,b);return v}},(e,t,r)=>{var n=r(4),a=r(15),i=r(54),s=r(20),o=r(38),c=r(44).f,l=r(57),h=r(197),u=r(198),d=r(40),f=r(200),g=!1,p=d("meta"),m=0,setMetadata=function(e){c(e,p,{value:{objectID:"O"+m++,weakData:{}}})},b=e.exports={enable:function(){b.enable=function(){};g=!0;var e=l.f,t=a([].splice),r={};r[p]=1;if(e(r).length){l.f=function(r){for(var n=e(r),a=0,i=n.length;a<i;a++)if(n[a]===p){t(n,a,1);break}return n};n({target:"Object",stat:!0,forced:!0},{getOwnPropertyNames:h.f})}},fastKey:function(e,t){if(!s(e))return"symbol"==typeof e?e:("string"==typeof e?"S":"P")+e;if(!o(e,p)){if(!u(e))return"F";if(!t)return"E";setMetadata(e)}return e[p].objectID},getWeakData:function(e,t){if(!o(e,p)){if(!u(e))return!0;if(!t)return!1;setMetadata(e)}return e[p].weakData},onFreeze:function(e){f&&g&&u(e)&&!o(e,p)&&setMetadata(e);return e}};i[p]=!0},(e,t,r)=>{var n=r(16),a=r(13),i=r(57).f,s=r(135),o="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];e.exports.f=function getOwnPropertyNames(e){return o&&"Window"==n(e)?function(e){try{return i(e)}catch(e){return s(o)}}(e):i(a(e))}},(e,t,r)=>{var n=r(8),a=r(20),i=r(16),s=r(199),o=Object.isExtensible,c=n((function(){o(1)}));e.exports=c||s?function isExtensible(e){return!!a(e)&&((!s||"ArrayBuffer"!=i(e))&&(!o||o(e)))}:o},(e,t,r)=>{var n=r(8);e.exports=n((function(){if("function"==typeof ArrayBuffer){var e=new ArrayBuffer(8);Object.isExtensible(e)&&Object.defineProperty(e,"a",{value:8})}}))},(e,t,r)=>{var n=r(8);e.exports=!n((function(){return Object.isExtensible(Object.preventExtensions({}))}))},(e,t,r)=>{"use strict";var n=r(44).f,a=r(117),i=r(131),s=r(81),o=r(73),c=r(97),l=r(120),h=r(72),u=r(7),d=r(196).fastKey,f=r(51),g=f.set,p=f.getterFor;e.exports={getConstructor:function(e,t,r,l){var h=e((function(e,n){o(e,f);g(e,{type:t,index:a(null),first:void 0,last:void 0,size:0});u||(e.size=0);null!=n&&c(n,e[l],{that:e,AS_ENTRIES:r})})),f=h.prototype,m=p(t),define=function(e,t,r){var n,a,i=m(e),s=getEntry(e,t);if(s)s.value=r;else{i.last=s={index:a=d(t,!0),key:t,value:r,previous:n=i.last,next:void 0,removed:!1};i.first||(i.first=s);n&&(n.next=s);u?i.size++:e.size++;"F"!==a&&(i.index[a]=s)}return e},getEntry=function(e,t){var r,n=m(e),a=d(t);if("F"!==a)return n.index[a];for(r=n.first;r;r=r.next)if(r.key==t)return r};i(f,{clear:function clear(){for(var e=m(this),t=e.index,r=e.first;r;){r.removed=!0;r.previous&&(r.previous=r.previous.next=void 0);delete t[r.index];r=r.next}e.first=e.last=void 0;u?e.size=0:this.size=0},delete:function(e){var t=this,r=m(t),n=getEntry(t,e);if(n){var a=n.next,i=n.previous;delete r.index[n.index];n.removed=!0;i&&(i.next=a);a&&(a.previous=i);r.first==n&&(r.first=a);r.last==n&&(r.last=i);u?r.size--:t.size--}return!!n},forEach:function forEach(e){for(var t,r=m(this),n=s(e,arguments.length>1?arguments[1]:void 0);t=t?t.next:r.first;){n(t.value,t.key,this);for(;t&&t.removed;)t=t.previous}},has:function has(e){return!!getEntry(this,e)}});i(f,r?{get:function get(e){var t=getEntry(this,e);return t&&t.value},set:function set(e,t){return define(this,0===e?0:e,t)}}:{add:function add(e){return define(this,e=0===e?0:e,e)}});u&&n(f,"size",{get:function(){return m(this).size}});return h},setStrong:function(e,t,r){var n=t+" Iterator",a=p(t),i=p(n);l(e,t,(function(e,t){g(this,{type:n,target:e,state:a(e),kind:t,last:void 0})}),(function(){for(var e=i(this),t=e.kind,r=e.last;r&&r.removed;)r=r.previous;if(!e.target||!(e.last=r=r?r.next:e.state.first)){e.target=void 0;return{value:void 0,done:!0}}return"keys"==t?{value:r.key,done:!1}:"values"==t?{value:r.value,done:!1}:{value:[r.key,r.value],done:!1}}),r?"entries":"values",!r,!0);h(t)}}},(e,t,r)=>{r(203)},(e,t,r)=>{"use strict";r(195)("Set",(function(e){return function Set(){return e(this,arguments.length?arguments[0]:void 0)}}),r(201))},(e,t,r)=>{var n,a=r(35),i=r(4),s=r(5),o=r(23),c=r(15),l=r(8),h=r(40),u=r(21),d=r(76),f=r(20),g=r(22),p=r(97),m=r(46),b=r(77),y=r(38),w=r(136),S=r(43),x=r(63),v=r(84),k=r(205),C=r(206),O=r(27),T=r(94),M=r(207),E=r(68),D=s.Object,N=s.Date,R=s.Error,L=s.EvalError,j=s.RangeError,_=s.ReferenceError,U=s.SyntaxError,$=s.TypeError,X=s.URIError,H=s.PerformanceMark,q=s.WebAssembly,W=q&&q.CompileError||R,z=q&&q.LinkError||R,G=q&&q.RuntimeError||R,V=o("DOMException"),K=o("Set"),Y=o("Map"),J=Y.prototype,Z=c(J.has),Q=c(J.get),ee=c(J.set),te=c(K.prototype.add),re=o("Object","keys"),ne=c([].push),ae=c((!0).valueOf),ie=c(1..valueOf),se=c("".valueOf),oe=c(N.prototype.getTime),ce=h("structuredClone"),le="DataCloneError",he="Transferring",checkBasicSemantic=function(e){return!l((function(){var t=new s.Set([7]),r=e(t),n=e(D(7));return r==t||!r.has(7)||"object"!=typeof n||7!=n}))&&e},checkErrorsCloning=function(e,t){return!l((function(){var r=new t,n=e({a:r,b:r});return!(n&&n.a===n.b&&n.a instanceof t)}))},ue=s.structuredClone,de=a||!checkErrorsCloning(ue,R)||!checkErrorsCloning(ue,V)||!(n=ue,!l((function(){var e=n(new s.AggregateError([1],ce,{cause:3}));return"AggregateError"!=e.name||1!=e.errors[0]||e.message!=ce||3!=e.cause}))),fe=!ue&&checkBasicSemantic((function(e){return new H(ce,{detail:e}).detail})),ge=checkBasicSemantic(ue)||fe,throwUncloneable=function(e){throw new V("Uncloneable type: "+e,le)},throwUnpolyfillable=function(e,t){throw new V((t||"Cloning")+" of "+e+" cannot be properly polyfilled in this engine",le)},structuredCloneInternal=function(e,t){g(e)&&throwUncloneable("Symbol");if(!f(e))return e;if(t){if(Z(t,e))return Q(t,e)}else t=new Y;var r,n,a,i,c,l,h,p,m,v,O=b(e),T=!1;switch(O){case"Array":a=[];T=!0;break;case"Object":a={};T=!0;break;case"Map":a=new Y;T=!0;break;case"Set":a=new K;T=!0;break;case"RegExp":a=new RegExp(e.source,k(e));break;case"Error":switch(n=e.name){case"AggregateError":a=o("AggregateError")([]);break;case"EvalError":a=L();break;case"RangeError":a=j();break;case"ReferenceError":a=_();break;case"SyntaxError":a=U();break;case"TypeError":a=$();break;case"URIError":a=X();break;case"CompileError":a=W();break;case"LinkError":a=z();break;case"RuntimeError":a=G();break;default:a=R()}T=!0;break;case"DOMException":a=new V(e.message,e.name);T=!0;break;case"DataView":case"Int8Array":case"Uint8Array":case"Uint8ClampedArray":case"Int16Array":case"Uint16Array":case"Int32Array":case"Uint32Array":case"Float32Array":case"Float64Array":case"BigInt64Array":case"BigUint64Array":r=s[O];f(r)||throwUnpolyfillable(O);a=new r(structuredCloneInternal(e.buffer,t),e.byteOffset,"DataView"===O?e.byteLength:e.length);break;case"DOMQuad":try{a=new DOMQuad(structuredCloneInternal(e.p1,t),structuredCloneInternal(e.p2,t),structuredCloneInternal(e.p3,t),structuredCloneInternal(e.p4,t))}catch(t){ge?a=ge(e):throwUnpolyfillable(O)}break;case"FileList":r=s.DataTransfer;if(d(r)){i=new r;for(c=0,l=x(e);c<l;c++)i.items.add(structuredCloneInternal(e[c],t));a=i.files}else ge?a=ge(e):throwUnpolyfillable(O);break;case"ImageData":try{a=new ImageData(structuredCloneInternal(e.data,t),e.width,e.height,{colorSpace:e.colorSpace})}catch(t){ge?a=ge(e):throwUnpolyfillable(O)}break;default:if(ge)a=ge(e);else switch(O){case"BigInt":a=D(e.valueOf());break;case"Boolean":a=D(ae(e));break;case"Number":a=D(ie(e));break;case"String":a=D(se(e));break;case"Date":a=new N(oe(e));break;case"ArrayBuffer":(r=s.DataView)||"function"==typeof e.slice||throwUnpolyfillable(O);try{if("function"==typeof e.slice)a=e.slice(0);else{l=e.byteLength;a=new ArrayBuffer(l);m=new r(e);v=new r(a);for(c=0;c<l;c++)v.setUint8(c,m.getUint8(c))}}catch(e){throw new V("ArrayBuffer is detached",le)}break;case"SharedArrayBuffer":a=e;break;case"Blob":try{a=e.slice(0,e.size,e.type)}catch(e){throwUnpolyfillable(O)}break;case"DOMPoint":case"DOMPointReadOnly":r=s[O];try{a=r.fromPoint?r.fromPoint(e):new r(e.x,e.y,e.z,e.w)}catch(e){throwUnpolyfillable(O)}break;case"DOMRect":case"DOMRectReadOnly":r=s[O];try{a=r.fromRect?r.fromRect(e):new r(e.x,e.y,e.width,e.height)}catch(e){throwUnpolyfillable(O)}break;case"DOMMatrix":case"DOMMatrixReadOnly":r=s[O];try{a=r.fromMatrix?r.fromMatrix(e):new r(e)}catch(e){throwUnpolyfillable(O)}break;case"AudioData":case"VideoFrame":u(e.clone)||throwUnpolyfillable(O);try{a=e.clone()}catch(e){throwUncloneable(O)}break;case"File":try{a=new File([e],e.name,e)}catch(e){throwUnpolyfillable(O)}break;case"CryptoKey":case"GPUCompilationMessage":case"GPUCompilationInfo":case"ImageBitmap":case"RTCCertificate":case"WebAssembly.Module":throwUnpolyfillable(O);default:throwUncloneable(O)}}ee(t,e,a);if(T)switch(O){case"Array":case"Object":h=re(e);for(c=0,l=x(h);c<l;c++){p=h[c];w(a,p,structuredCloneInternal(e[p],t))}break;case"Map":e.forEach((function(e,r){ee(a,structuredCloneInternal(r,t),structuredCloneInternal(e,t))}));break;case"Set":e.forEach((function(e){te(a,structuredCloneInternal(e,t))}));break;case"Error":S(a,"message",structuredCloneInternal(e.message,t));y(e,"cause")&&S(a,"cause",structuredCloneInternal(e.cause,t));"AggregateError"==n&&(a.errors=structuredCloneInternal(e.errors,t));case"DOMException":C&&S(a,"stack",structuredCloneInternal(e.stack,t))}return a},pe=ue&&!l((function(){if(M&&O>92||E&&O>94||T&&O>97)return!1;var e=new ArrayBuffer(8),t=ue(e,{transfer:[e]});return 0!=e.byteLength||8!=t.byteLength})),tryToTransfer=function(e,t){if(!f(e))throw $("Transfer option cannot be converted to a sequence");var r=[];p(e,(function(e){ne(r,m(e))}));var n,a,i,o,c,l,h=0,g=x(r);if(pe){o=ue(r,{transfer:r});for(;h<g;)ee(t,r[h],o[h++])}else for(;h<g;){n=r[h++];if(Z(t,n))throw new V("Duplicate transferable",le);switch(a=b(n)){case"ImageBitmap":i=s.OffscreenCanvas;d(i)||throwUnpolyfillable(a,he);try{(l=new i(n.width,n.height)).getContext("bitmaprenderer").transferFromImageBitmap(n);c=l.transferToImageBitmap()}catch(e){}break;case"AudioData":case"VideoFrame":u(n.clone)&&u(n.close)||throwUnpolyfillable(a,he);try{c=n.clone();n.close()}catch(e){}break;case"ArrayBuffer":case"MessagePort":case"OffscreenCanvas":case"ReadableStream":case"TransformStream":case"WritableStream":throwUnpolyfillable(a,he)}if(void 0===c)throw new V("This object cannot be transferred: "+a,le);ee(t,n,c)}};i({global:!0,enumerable:!0,sham:!pe,forced:de},{structuredClone:function structuredClone(e){var t,r=v(arguments.length,1)>1&&null!=arguments[1]?m(arguments[1]):void 0,n=r?r.transfer:void 0;if(void 0!==n){t=new Y;tryToTransfer(n,t)}return structuredCloneInternal(e,t)}})},(e,t,r)=>{var n=r(9),a=r(38),i=r(24),s=r(162),o=RegExp.prototype;e.exports=function(e){var t=e.flags;return void 0!==t||"flags"in o||a(e,"flags")||!i(o,e)?t:n(s,e)}},(e,t,r)=>{var n=r(8),a=r(12);e.exports=!n((function(){var e=Error("a");if(!("stack"in e))return!0;Object.defineProperty(e,"stack",a(1,7));return 7!==e.stack}))},e=>{e.exports="object"==typeof Deno&&Deno&&"object"==typeof Deno.version},(e,t,r)=>{var n=r(5);e.exports=n},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.RefSetCache=t.RefSet=t.Ref=t.Name=t.EOF=t.Dict=t.Cmd=t.CIRCULAR_REF=void 0;t.clearPrimitiveCaches=function clearPrimitiveCaches(){o._clearCache();s._clearCache();l._clearCache()};t.isCmd=function isCmd(e,t){return e instanceof o&&(void 0===t||e.cmd===t)};t.isDict=function isDict(e,t){return e instanceof Dict&&(void 0===t||isName(e.get("Type"),t))};t.isName=isName;t.isRefsEqual=function isRefsEqual(e,t){return e.num===t.num&&e.gen===t.gen};r(2);r(112);var n=r(158);const a=Symbol("CIRCULAR_REF");t.CIRCULAR_REF=a;const i=Symbol("EOF");t.EOF=i;const s=function NameClosure(){let e=Object.create(null);class Name{constructor(e){this.name=e}static get(t){const r=e[t];return r||(e[t]=new Name(t))}static _clearCache(){e=Object.create(null)}}return Name}();t.Name=s;const o=function CmdClosure(){let e=Object.create(null);class Cmd{constructor(e){this.cmd=e}static get(t){const r=e[t];return r||(e[t]=new Cmd(t))}static _clearCache(){e=Object.create(null)}}return Cmd}();t.Cmd=o;const c=function nonSerializableClosure(){return c};class Dict{constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;this._map=Object.create(null);this.xref=e;this.objId=null;this.suppressEncryption=!1;this.__nonSerializable__=c}assignXref(e){this.xref=e}get size(){return Object.keys(this._map).length}get(e,t,r){let n=this._map[e];if(void 0===n&&void 0!==t){n=this._map[t];void 0===n&&void 0!==r&&(n=this._map[r])}return n instanceof l&&this.xref?this.xref.fetch(n,this.suppressEncryption):n}async getAsync(e,t,r){let n=this._map[e];if(void 0===n&&void 0!==t){n=this._map[t];void 0===n&&void 0!==r&&(n=this._map[r])}return n instanceof l&&this.xref?this.xref.fetchAsync(n,this.suppressEncryption):n}getArray(e,t,r){let n=this._map[e];if(void 0===n&&void 0!==t){n=this._map[t];void 0===n&&void 0!==r&&(n=this._map[r])}n instanceof l&&this.xref&&(n=this.xref.fetch(n,this.suppressEncryption));if(Array.isArray(n)){n=n.slice();for(let e=0,t=n.length;e<t;e++)n[e]instanceof l&&this.xref&&(n[e]=this.xref.fetch(n[e],this.suppressEncryption))}return n}getRaw(e){return this._map[e]}getKeys(){return Object.keys(this._map)}getRawValues(){return Object.values(this._map)}set(e,t){this._map[e]=t}has(e){return void 0!==this._map[e]}forEach(e){for(const t in this._map)e(t,this.get(t))}static get empty(){const e=new Dict(null);e.set=(e,t)=>{(0,n.unreachable)("Should not call `set` on the empty dictionary.")};return(0,n.shadow)(this,"empty",e)}static merge(e){let{xref:t,dictArray:r,mergeSubDicts:n=!1}=e;const a=new Dict(t),i=new Map;for(const e of r)if(e instanceof Dict)for(const[t,r]of Object.entries(e._map)){let e=i.get(t);if(void 0===e){e=[];i.set(t,e)}else if(!(n&&r instanceof Dict))continue;e.push(r)}for(const[e,r]of i){if(1===r.length||!(r[0]instanceof Dict)){a._map[e]=r[0];continue}const n=new Dict(t);for(const e of r)for(const[t,r]of Object.entries(e._map))void 0===n._map[t]&&(n._map[t]=r);n.size>0&&(a._map[e]=n)}i.clear();return a.size>0?a:Dict.empty}}t.Dict=Dict;const l=function RefClosure(){let e=Object.create(null);class Ref{constructor(e,t){this.num=e;this.gen=t}toString(){return 0===this.gen?"".concat(this.num,"R"):"".concat(this.num,"R").concat(this.gen)}static get(t,r){const n=0===r?"".concat(t,"R"):"".concat(t,"R").concat(r),a=e[n];return a||(e[n]=new Ref(t,r))}static _clearCache(){e=Object.create(null)}}return Ref}();t.Ref=l;class RefSet{constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;this._set=new Set(e&&e._set)}has(e){return this._set.has(e.toString())}put(e){this._set.add(e.toString())}remove(e){this._set.delete(e.toString())}[Symbol.iterator](){return this._set.values()}clear(){this._set.clear()}}t.RefSet=RefSet;class RefSetCache{constructor(){this._map=new Map}get size(){return this._map.size}get(e){return this._map.get(e.toString())}has(e){return this._map.has(e.toString())}put(e,t){this._map.set(e.toString(),t)}putAlias(e,t){this._map.set(e.toString(),this.get(t))}[Symbol.iterator](){return this._map.values()}clear(){this._map.clear()}}t.RefSetCache=RefSetCache;function isName(e,t){return e instanceof s&&(void 0===t||e.name===t)}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.NetworkPdfManager=t.LocalPdfManager=void 0;r(2);var n=r(158),a=r(211),i=r(213),s=r(219),o=r(218);function parseDocBaseUrl(e){if(e){const t=(0,n.createValidAbsoluteUrl)(e);if(t)return t.href;(0,n.warn)('Invalid absolute docBaseUrl: "'.concat(e,'".'))}return null}class BasePdfManager{constructor(){this.constructor===BasePdfManager&&(0,n.unreachable)("Cannot initialize BasePdfManager.")}get docId(){return this._docId}get password(){return this._password}get docBaseUrl(){const e=this.pdfDocument.catalog;return(0,n.shadow)(this,"docBaseUrl",e.baseUrl||this._docBaseUrl)}onLoadedStream(){(0,n.unreachable)("Abstract method `onLoadedStream` called")}ensureDoc(e,t){return this.ensure(this.pdfDocument,e,t)}ensureXRef(e,t){return this.ensure(this.pdfDocument.xref,e,t)}ensureCatalog(e,t){return this.ensure(this.pdfDocument.catalog,e,t)}getPage(e){return this.pdfDocument.getPage(e)}fontFallback(e,t){return this.pdfDocument.fontFallback(e,t)}loadXfaFonts(e,t){return this.pdfDocument.loadXfaFonts(e,t)}loadXfaImages(){return this.pdfDocument.loadXfaImages()}serializeXfaData(e){return this.pdfDocument.serializeXfaData(e)}cleanup(){let e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return this.pdfDocument.cleanup(e)}async ensure(e,t,r){(0,n.unreachable)("Abstract method `ensure` called")}requestRange(e,t){(0,n.unreachable)("Abstract method `requestRange` called")}requestLoadedStream(){(0,n.unreachable)("Abstract method `requestLoadedStream` called")}sendProgressiveData(e){(0,n.unreachable)("Abstract method `sendProgressiveData` called")}updatePassword(e){this._password=e}terminate(e){(0,n.unreachable)("Abstract method `terminate` called")}}t.LocalPdfManager=class LocalPdfManager extends BasePdfManager{constructor(e,t,r,n,a,i,c){super();this._docId=e;this._password=r;this._docBaseUrl=parseDocBaseUrl(c);this.msgHandler=n;this.evaluatorOptions=a;this.enableXfa=i;const l=new o.Stream(t);this.pdfDocument=new s.PDFDocument(this,l);this._loadedStreamPromise=Promise.resolve(l)}async ensure(e,t,r){const n=e[t];return"function"==typeof n?n.apply(e,r):n}requestRange(e,t){return Promise.resolve()}requestLoadedStream(){}onLoadedStream(){return this._loadedStreamPromise}terminate(e){}};t.NetworkPdfManager=class NetworkPdfManager extends BasePdfManager{constructor(e,t,r,n,i,o){super();this._docId=e;this._password=r.password;this._docBaseUrl=parseDocBaseUrl(o);this.msgHandler=r.msgHandler;this.evaluatorOptions=n;this.enableXfa=i;this.streamManager=new a.ChunkedStreamManager(t,{msgHandler:r.msgHandler,length:r.length,disableAutoFetch:r.disableAutoFetch,rangeChunkSize:r.rangeChunkSize});this.pdfDocument=new s.PDFDocument(this,this.streamManager.getStream())}async ensure(e,t,r){try{const n=e[t];return"function"==typeof n?n.apply(e,r):n}catch(n){if(!(n instanceof i.MissingDataException))throw n;await this.requestRange(n.begin,n.end);return this.ensure(e,t,r)}}requestRange(e,t){return this.streamManager.requestRange(e,t)}requestLoadedStream(){this.streamManager.requestAllChunks()}sendProgressiveData(e){this.streamManager.onReceiveData({chunk:e})}onLoadedStream(){return this.streamManager.onLoadedStream()}terminate(e){this.streamManager.abort(e)}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.ChunkedStreamManager=t.ChunkedStream=void 0;r(125);r(146);r(148);r(149);r(112);r(2);r(212);var n=r(158),a=r(213),i=r(218);class ChunkedStream extends i.Stream{constructor(e,t,r){super(new Uint8Array(e),0,e,null);this.chunkSize=t;this._loadedChunks=new Set;this.numChunks=Math.ceil(e/t);this.manager=r;this.progressiveDataLength=0;this.lastSuccessfulEnsureByteChunk=-1}getMissingChunks(){const e=[];for(let t=0,r=this.numChunks;t<r;++t)this._loadedChunks.has(t)||e.push(t);return e}get numChunksLoaded(){return this._loadedChunks.size}get isDataLoaded(){return this.numChunksLoaded===this.numChunks}onReceiveData(e,t){const r=this.chunkSize;if(e%r!=0)throw new Error("Bad begin offset: ".concat(e));const n=e+t.byteLength;if(n%r!=0&&n!==this.bytes.length)throw new Error("Bad end offset: ".concat(n));this.bytes.set(new Uint8Array(t),e);const a=Math.floor(e/r),i=Math.floor((n-1)/r)+1;for(let e=a;e<i;++e)this._loadedChunks.add(e)}onReceiveProgressiveData(e){let t=this.progressiveDataLength;const r=Math.floor(t/this.chunkSize);this.bytes.set(new Uint8Array(e),t);t+=e.byteLength;this.progressiveDataLength=t;const n=t>=this.end?this.numChunks:Math.floor(t/this.chunkSize);for(let e=r;e<n;++e)this._loadedChunks.add(e)}ensureByte(e){if(e<this.progressiveDataLength)return;const t=Math.floor(e/this.chunkSize);if(!(t>this.numChunks)&&t!==this.lastSuccessfulEnsureByteChunk){if(!this._loadedChunks.has(t))throw new a.MissingDataException(e,e+1);this.lastSuccessfulEnsureByteChunk=t}}ensureRange(e,t){if(e>=t)return;if(t<=this.progressiveDataLength)return;const r=Math.floor(e/this.chunkSize);if(r>this.numChunks)return;const n=Math.min(Math.floor((t-1)/this.chunkSize)+1,this.numChunks);for(let i=r;i<n;++i)if(!this._loadedChunks.has(i))throw new a.MissingDataException(e,t)}nextEmptyChunk(e){const t=this.numChunks;for(let r=0;r<t;++r){const n=(e+r)%t;if(!this._loadedChunks.has(n))return n}return null}hasChunk(e){return this._loadedChunks.has(e)}getByte(){const e=this.pos;if(e>=this.end)return-1;e>=this.progressiveDataLength&&this.ensureByte(e);return this.bytes[this.pos++]}getBytes(e){const t=this.bytes,r=this.pos,n=this.end;if(!e){n>this.progressiveDataLength&&this.ensureRange(r,n);return t.subarray(r,n)}let a=r+e;a>n&&(a=n);a>this.progressiveDataLength&&this.ensureRange(r,a);this.pos=a;return t.subarray(r,a)}getByteRange(e,t){e<0&&(e=0);t>this.end&&(t=this.end);t>this.progressiveDataLength&&this.ensureRange(e,t);return this.bytes.subarray(e,t)}makeSubStream(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;t?e+t>this.progressiveDataLength&&this.ensureRange(e,e+t):e>=this.progressiveDataLength&&this.ensureByte(e);function ChunkedStreamSubstream(){}ChunkedStreamSubstream.prototype=Object.create(this);ChunkedStreamSubstream.prototype.getMissingChunks=function(){const e=this.chunkSize,t=Math.floor(this.start/e),r=Math.floor((this.end-1)/e)+1,n=[];for(let e=t;e<r;++e)this._loadedChunks.has(e)||n.push(e);return n};Object.defineProperty(ChunkedStreamSubstream.prototype,"isDataLoaded",{get(){return this.numChunksLoaded===this.numChunks||0===this.getMissingChunks().length},configurable:!0});const n=new ChunkedStreamSubstream;n.pos=n.start=e;n.end=e+t||this.end;n.dict=r;return n}getBaseStreams(){return[this]}}t.ChunkedStream=ChunkedStream;t.ChunkedStreamManager=class ChunkedStreamManager{constructor(e,t){this.length=t.length;this.chunkSize=t.rangeChunkSize;this.stream=new ChunkedStream(this.length,this.chunkSize,this);this.pdfNetworkStream=e;this.disableAutoFetch=t.disableAutoFetch;this.msgHandler=t.msgHandler;this.currRequestId=0;this._chunksNeededByRequest=new Map;this._requestsByChunk=new Map;this._promisesByRequest=new Map;this.progressiveDataLength=0;this.aborted=!1;this._loadedStreamCapability=(0,n.createPromiseCapability)()}onLoadedStream(){return this._loadedStreamCapability.promise}sendRequest(e,t){const r=this.pdfNetworkStream.getRangeReader(e,t);r.isStreamingSupported||(r.onProgress=this.onProgress.bind(this));let a=[],i=0;return new Promise(((e,t)=>{const readChunk=s=>{try{if(!s.done){const e=s.value;a.push(e);i+=(0,n.arrayByteLength)(e);r.isStreamingSupported&&this.onProgress({loaded:i});r.read().then(readChunk,t);return}const o=(0,n.arraysToBytes)(a);a=null;e(o)}catch(e){t(e)}};r.read().then(readChunk,t)})).then((t=>{this.aborted||this.onReceiveData({chunk:t,begin:e})}))}requestAllChunks(){const e=this.stream.getMissingChunks();this._requestChunks(e);return this._loadedStreamCapability.promise}_requestChunks(e){const t=this.currRequestId++,r=new Set;this._chunksNeededByRequest.set(t,r);for(const t of e)this.stream.hasChunk(t)||r.add(t);if(0===r.size)return Promise.resolve();const a=(0,n.createPromiseCapability)();this._promisesByRequest.set(t,a);const i=[];for(const e of r){let r=this._requestsByChunk.get(e);if(!r){r=[];this._requestsByChunk.set(e,r);i.push(e)}r.push(t)}if(i.length>0){const e=this.groupChunks(i);for(const t of e){const e=t.beginChunk*this.chunkSize,r=Math.min(t.endChunk*this.chunkSize,this.length);this.sendRequest(e,r).catch(a.reject)}}return a.promise.catch((e=>{if(!this.aborted)throw e}))}getStream(){return this.stream}requestRange(e,t){t=Math.min(t,this.length);const r=this.getBeginChunk(e),n=this.getEndChunk(t),a=[];for(let e=r;e<n;++e)a.push(e);return this._requestChunks(a)}requestRanges(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[];const t=[];for(const r of e){const e=this.getBeginChunk(r.begin),n=this.getEndChunk(r.end);for(let r=e;r<n;++r)t.includes(r)||t.push(r)}t.sort((function(e,t){return e-t}));return this._requestChunks(t)}groupChunks(e){const t=[];let r=-1,n=-1;for(let a=0,i=e.length;a<i;++a){const i=e[a];r<0&&(r=i);if(n>=0&&n+1!==i){t.push({beginChunk:r,endChunk:n+1});r=i}a+1===e.length&&t.push({beginChunk:r,endChunk:i+1});n=i}return t}onProgress(e){this.msgHandler.send("DocProgress",{loaded:this.stream.numChunksLoaded*this.chunkSize+e.loaded,total:this.length})}onReceiveData(e){const t=e.chunk,r=void 0===e.begin,n=r?this.progressiveDataLength:e.begin,a=n+t.byteLength,i=Math.floor(n/this.chunkSize),s=a<this.length?Math.floor(a/this.chunkSize):Math.ceil(a/this.chunkSize);if(r){this.stream.onReceiveProgressiveData(t);this.progressiveDataLength=a}else this.stream.onReceiveData(n,t);this.stream.isDataLoaded&&this._loadedStreamCapability.resolve(this.stream);const o=[];for(let e=i;e<s;++e){const t=this._requestsByChunk.get(e);if(t){this._requestsByChunk.delete(e);for(const r of t){const t=this._chunksNeededByRequest.get(r);t.has(e)&&t.delete(e);t.size>0||o.push(r)}}}if(!this.disableAutoFetch&&0===this._requestsByChunk.size){let e;if(1===this.stream.numChunksLoaded){const t=this.stream.numChunks-1;this.stream.hasChunk(t)||(e=t)}else e=this.stream.nextEmptyChunk(s);Number.isInteger(e)&&this._requestChunks([e])}for(const e of o){const t=this._promisesByRequest.get(e);this._promisesByRequest.delete(e);t.resolve()}this.msgHandler.send("DocProgress",{loaded:this.stream.numChunksLoaded*this.chunkSize,total:this.length})}onError(e){this._loadedStreamCapability.reject(e)}getBeginChunk(e){return Math.floor(e/this.chunkSize)}getEndChunk(e){return Math.floor((e-1)/this.chunkSize)+1}abort(e){this.aborted=!0;this.pdfNetworkStream&&this.pdfNetworkStream.cancelAllRequests(e);for(const t of this._promisesByRequest.values())t.reject(e)}}},(e,t,r)=>{"use strict";var n=r(4),a=r(59).includes,i=r(8),s=r(116);n({target:"Array",proto:!0,forced:i((function(){return!Array(1).includes()}))},{includes:function includes(e){return a(this,e,arguments.length>1?arguments[1]:void 0)}});s("includes")},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.XRefParseException=t.XRefEntryException=t.ParserEOFException=t.MissingDataException=t.DocStats=void 0;t.collectActions=function collectActions(e,t,r){const i=Object.create(null),s=getInheritableProperty({dict:t,key:"AA",stopWhenFound:!1});if(s)for(let t=s.length-1;t>=0;t--){const n=s[t];if(n instanceof a.Dict)for(const t of n.getKeys()){const s=r[t];if(!s)continue;const o=n.getRaw(t),c=new a.RefSet,l=[];_collectJS(o,e,l,c);l.length>0&&(i[s]=l)}}if(t.has("A")){const r=t.get("A"),n=new a.RefSet,s=[];_collectJS(r,e,s,n);s.length>0&&(i.Action=s)}return(0,n.objectSize)(i)>0?i:null};t.encodeToXmlString=function encodeToXmlString(e){const t=[];let r=0;for(let n=0,a=e.length;n<a;n++){const a=e.codePointAt(n);if(32<=a&&a<=126){const i=o[a];if(i){r<n&&t.push(e.substring(r,n));t.push(i);r=n+1}}else{r<n&&t.push(e.substring(r,n));t.push("&#x".concat(a.toString(16).toUpperCase(),";"));a>55295&&(a<57344||a>65533)&&n++;r=n+1}}if(0===t.length)return e;r<e.length&&t.push(e.substring(r,e.length));return t.join("")};t.escapePDFName=function escapePDFName(e){const t=[];let r=0;for(let n=0,a=e.length;n<a;n++){const a=e.charCodeAt(n);if(a<33||a>126||35===a||40===a||41===a||60===a||62===a||91===a||93===a||123===a||125===a||47===a||37===a){r<n&&t.push(e.substring(r,n));t.push("#".concat(a.toString(16)));r=n+1}}if(0===t.length)return e;r<e.length&&t.push(e.substring(r,e.length));return t.join("")};t.getArrayLookupTableFactory=function getArrayLookupTableFactory(e){let t;return function(){if(e){let r=e();e=null;t=Object.create(null);for(let e=0,n=r.length;e<n;e+=2)t[r[e]]=r[e+1];r=null}return t}};t.getInheritableProperty=getInheritableProperty;t.getLookupTableFactory=function getLookupTableFactory(e){let t;return function(){if(e){t=Object.create(null);e(t);e=null}return t}};t.isWhiteSpace=function isWhiteSpace(e){return 32===e||9===e||13===e||10===e};t.log2=function log2(e){if(e<=0)return 0;return Math.ceil(Math.log2(e))};t.numberToString=function numberToString(e){if(Number.isInteger(e))return e.toString();const t=Math.round(100*e);if(t%100==0)return(t/100).toString();if(t%10==0)return e.toFixed(1);return e.toFixed(2)};t.parseXFAPath=function parseXFAPath(e){const t=/(.+)\[(\d+)\]$/;return e.split(".").map((e=>{const r=e.match(t);return r?{name:r[1],pos:parseInt(r[2],10)}:{name:e,pos:0}}))};t.readInt8=function readInt8(e,t){return e[t]<<24>>24};t.readUint16=function readUint16(e,t){return e[t]<<8|e[t+1]};t.readUint32=function readUint32(e,t){return(e[t]<<24|e[t+1]<<16|e[t+2]<<8|e[t+3])>>>0};t.recoverJsURL=function recoverJsURL(e){const t=new RegExp("^\\s*("+["app.launchURL","window.open","xfa.host.gotoURL"].join("|").split(".").join("\\.")+")\\((?:'|\")([^'\"]*)(?:'|\")(?:,\\s*(\\w+)\\)|\\))","i").exec(e);if(t&&t[2]){const e=t[2];let r=!1;"true"===t[3]&&"app.launchURL"===t[1]&&(r=!0);return{url:e,newWindow:r}}return null};t.toRomanNumerals=function toRomanNumerals(e){let t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];(0,n.assert)(Number.isInteger(e)&&e>0,"The number should be a positive integer.");const r=[];let a;for(;e>=1e3;){e-=1e3;r.push("M")}a=e/100|0;e%=100;r.push(s[a]);a=e/10|0;e%=10;r.push(s[10+a]);r.push(s[20+e]);const i=r.join("");return t?i.toLowerCase():i};t.validateCSSFont=function validateCSSFont(e){const t=new Set(["100","200","300","400","500","600","700","800","900","1000","normal","bold","bolder","lighter"]),{fontFamily:r,fontWeight:a,italicAngle:i}=e;if(/^".*"$/.test(r)){if(/[^\\]"/.test(r.slice(1,r.length-1))){(0,n.warn)('XFA - FontFamily contains some unescaped ": '.concat(r,"."));return!1}}else if(/^'.*'$/.test(r)){if(/[^\\]'/.test(r.slice(1,r.length-1))){(0,n.warn)("XFA - FontFamily contains some unescaped ': ".concat(r,"."));return!1}}else for(const e of r.split(/[ \t]+/))if(/^(\d|(-(\d|-)))/.test(e)||!/^[\w-\\]+$/.test(e)){(0,n.warn)("XFA - FontFamily contains some invalid <custom-ident>: ".concat(r,"."));return!1}const s=a?a.toString():"";e.fontWeight=t.has(s)?s:"400";const o=parseFloat(i);e.italicAngle=isNaN(o)||o<-90||o>90?"14":i.toString();return!0};r(112);r(159);r(214);var n=r(158),a=r(209),i=r(217);class MissingDataException extends n.BaseException{constructor(e,t){super("Missing data [".concat(e,", ").concat(t,")"),"MissingDataException");this.begin=e;this.end=t}}t.MissingDataException=MissingDataException;class ParserEOFException extends n.BaseException{constructor(e){super(e,"ParserEOFException")}}t.ParserEOFException=ParserEOFException;class XRefEntryException extends n.BaseException{constructor(e){super(e,"XRefEntryException")}}t.XRefEntryException=XRefEntryException;class XRefParseException extends n.BaseException{constructor(e){super(e,"XRefParseException")}}t.XRefParseException=XRefParseException;t.DocStats=class DocStats{constructor(e){this._handler=e;this._streamTypes=new Set;this._fontTypes=new Set}_send(){const e=Object.create(null),t=Object.create(null);for(const t of this._streamTypes)e[t]=!0;for(const e of this._fontTypes)t[e]=!0;this._handler.send("DocStats",{streamTypes:e,fontTypes:t})}addStreamType(e){if(!this._streamTypes.has(e)){this._streamTypes.add(e);this._send()}}addFontType(e){if(!this._fontTypes.has(e)){this._fontTypes.add(e);this._send()}}};function getInheritableProperty(e){let t,{dict:r,key:n,getArray:i=!1,stopWhenFound:s=!0}=e;const o=new a.RefSet;for(;r instanceof a.Dict&&(!r.objId||!o.has(r.objId));){r.objId&&o.put(r.objId);const e=i?r.getArray(n):r.get(n);if(void 0!==e){if(s)return e;t||(t=[]);t.push(e)}r=r.get("Parent")}return t}const s=["","C","CC","CCC","CD","D","DC","DCC","DCCC","CM","","X","XX","XXX","XL","L","LX","LXX","LXXX","XC","","I","II","III","IV","V","VI","VII","VIII","IX"];function _collectJS(e,t,r,s){if(!e)return;let o=null;if(e instanceof a.Ref){if(s.has(e))return;o=e;s.put(o);e=t.fetch(e)}if(Array.isArray(e))for(const n of e)_collectJS(n,t,r,s);else if(e instanceof a.Dict){if((0,a.isName)(e.get("S"),"JavaScript")){const t=e.get("JS");let a;t instanceof i.BaseStream?a=t.getString():"string"==typeof t&&(a=t);a=a&&(0,n.stringToPDFString)(a);a&&r.push(a)}_collectJS(e.getRaw("Next"),t,r,s)}o&&s.remove(o)}const o={60:"&lt;",62:"&gt;",38:"&amp;",34:"&quot;",39:"&apos;"}},(e,t,r)=>{var n=r(7),a=r(5),i=r(15),s=r(67),o=r(145),c=r(43),l=r(57).f,h=r(24),u=r(215),d=r(161),f=r(205),g=r(163),p=r(216),m=r(47),b=r(8),y=r(38),w=r(51).enforce,S=r(72),x=r(33),v=r(164),k=r(165),C=x("match"),O=a.RegExp,T=O.prototype,M=a.SyntaxError,E=i(T.exec),D=i("".charAt),N=i("".replace),R=i("".indexOf),L=i("".slice),j=/^\?<[^\s\d!#%&*+<=>@^][^\s!#%&*+<=>@^]*>/,_=/a/g,U=/a/g,$=new O(_)!==_,X=g.MISSED_STICKY,H=g.UNSUPPORTED_Y,q=n&&(!$||X||v||k||b((function(){U[C]=!1;return O(_)!=_||O(U)==U||"/a/i"!=O(_,"i")})));if(s("RegExp",q)){for(var W=function RegExp(e,t){var r,n,a,i,s,l,g=h(T,this),p=u(e),m=void 0===t,b=[],S=e;if(!g&&p&&m&&e.constructor===W)return e;if(p||h(T,e)){e=e.source;m&&(t=f(S))}e=void 0===e?"":d(e);t=void 0===t?"":d(t);S=e;v&&"dotAll"in _&&(n=!!t&&R(t,"s")>-1)&&(t=N(t,/s/g,""));r=t;X&&"sticky"in _&&(a=!!t&&R(t,"y")>-1)&&H&&(t=N(t,/y/g,""));if(k){i=function(e){for(var t,r=e.length,n=0,a="",i=[],s={},o=!1,c=!1,l=0,h="";n<=r;n++){if("\\"===(t=D(e,n)))t+=D(e,++n);else if("]"===t)o=!1;else if(!o)switch(!0){case"["===t:o=!0;break;case"("===t:if(E(j,L(e,n+1))){n+=2;c=!0}a+=t;l++;continue;case">"===t&&c:if(""===h||y(s,h))throw new M("Invalid capture group name");s[h]=!0;i[i.length]=[h,l];c=!1;h="";continue}c?h+=t:a+=t}return[a,i]}(e);e=i[0];b=i[1]}s=o(O(e,t),g?this:T,W);if(n||a||b.length){l=w(s);if(n){l.dotAll=!0;l.raw=W(function(e){for(var t,r=e.length,n=0,a="",i=!1;n<=r;n++)if("\\"!==(t=D(e,n)))if(i||"."!==t){"["===t?i=!0:"]"===t&&(i=!1);a+=t}else a+="[\\s\\S]";else a+=t+D(e,++n);return a}(e),r)}a&&(l.sticky=!0);b.length&&(l.groups=b)}if(e!==S)try{c(s,"source",""===S?"(?:)":S)}catch(e){}return s},z=l(O),G=0;z.length>G;)p(W,O,z[G++]);T.constructor=W;W.prototype=T;m(a,"RegExp",W,{constructor:!0})}S("RegExp")},(e,t,r)=>{var n=r(20),a=r(16),i=r(33)("match");e.exports=function(e){var t;return n(e)&&(void 0!==(t=e[i])?!!t:"RegExp"==a(e))}},(e,t,r)=>{var n=r(44).f;e.exports=function(e,t,r){r in e||n(e,r,{configurable:!0,get:function(){return t[r]},set:function(e){t[r]=e}})}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.BaseStream=void 0;var n=r(158);class BaseStream{constructor(){this.constructor===BaseStream&&(0,n.unreachable)("Cannot initialize BaseStream.")}get length(){(0,n.unreachable)("Abstract getter `length` accessed")}get isEmpty(){(0,n.unreachable)("Abstract getter `isEmpty` accessed")}get isDataLoaded(){return(0,n.shadow)(this,"isDataLoaded",!0)}getByte(){(0,n.unreachable)("Abstract method `getByte` called")}getBytes(e){(0,n.unreachable)("Abstract method `getBytes` called")}peekByte(){const e=this.getByte();-1!==e&&this.pos--;return e}peekBytes(e){const t=this.getBytes(e);this.pos-=t.length;return t}getUint16(){const e=this.getByte(),t=this.getByte();return-1===e||-1===t?-1:(e<<8)+t}getInt32(){return(this.getByte()<<24)+(this.getByte()<<16)+(this.getByte()<<8)+this.getByte()}getByteRange(e,t){(0,n.unreachable)("Abstract method `getByteRange` called")}getString(e){return(0,n.bytesToString)(this.getBytes(e))}skip(e){this.pos+=e||1}reset(){(0,n.unreachable)("Abstract method `reset` called")}moveStart(){(0,n.unreachable)("Abstract method `moveStart` called")}makeSubStream(e,t){(0,n.unreachable)("Abstract method `makeSubStream` called")}getBaseStreams(){return null}}t.BaseStream=BaseStream},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.StringStream=t.Stream=t.NullStream=void 0;r(125);r(146);r(148);r(149);var n=r(217),a=r(158);class Stream extends n.BaseStream{constructor(e,t,r,n){super();this.bytes=e instanceof Uint8Array?e:new Uint8Array(e);this.start=t||0;this.pos=this.start;this.end=t+r||this.bytes.length;this.dict=n}get length(){return this.end-this.start}get isEmpty(){return 0===this.length}getByte(){return this.pos>=this.end?-1:this.bytes[this.pos++]}getBytes(e){const t=this.bytes,r=this.pos,n=this.end;if(!e)return t.subarray(r,n);let a=r+e;a>n&&(a=n);this.pos=a;return t.subarray(r,a)}getByteRange(e,t){e<0&&(e=0);t>this.end&&(t=this.end);return this.bytes.subarray(e,t)}reset(){this.pos=this.start}moveStart(){this.start=this.pos}makeSubStream(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;return new Stream(this.bytes.buffer,e,t,r)}}t.Stream=Stream;t.StringStream=class StringStream extends Stream{constructor(e){super((0,a.stringToBytes)(e))}};t.NullStream=class NullStream extends Stream{constructor(){super(new Uint8Array(0))}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.Page=t.PDFDocument=void 0;r(2);r(112);r(125);r(146);r(148);r(149);r(159);r(179);var n=r(158),a=r(213),i=r(209),s=r(220),o=r(231),c=r(217),l=r(284),h=r(286),u=r(288),d=r(320),f=r(240),g=r(218),p=r(292),m=r(279),b=r(237),y=r(242),w=r(291),S=r(282),x=r(293),v=r(321);const k=[0,0,612,792];class Page{constructor(e){let{pdfManager:t,xref:r,pageIndex:n,pageDict:a,ref:i,globalIdFactory:s,fontCache:o,builtInCMapCache:c,standardFontDataCache:l,globalImageCache:h,nonBlendModesSet:u,xfaFactory:d}=e;this.pdfManager=t;this.pageIndex=n;this.pageDict=a;this.xref=r;this.ref=i;this.fontCache=o;this.builtInCMapCache=c;this.standardFontDataCache=l;this.globalImageCache=h;this.nonBlendModesSet=u;this.evaluatorOptions=t.evaluatorOptions;this.resourcesPromise=null;this.xfaFactory=d;const f={obj:0};this._localIdFactory=class extends s{static createObjId(){return"p".concat(n,"_").concat(++f.obj)}static getPageObjId(){return"page".concat(i.toString())}}}_getInheritableProperty(e){let t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];const r=(0,a.getInheritableProperty)({dict:this.pageDict,key:e,getArray:t,stopWhenFound:!1});return Array.isArray(r)?1!==r.length&&r[0]instanceof i.Dict?i.Dict.merge({xref:this.xref,dictArray:r}):r[0]:r}get content(){return this.pageDict.getArray("Contents")}get resources(){return(0,n.shadow)(this,"resources",this._getInheritableProperty("Resources")||i.Dict.empty)}_getBoundingBox(e){if(this.xfaData)return this.xfaData.bbox;const t=this._getInheritableProperty(e,!0);if(Array.isArray(t)&&4===t.length){if(t[2]-t[0]!=0&&t[3]-t[1]!=0)return t;(0,n.warn)("Empty /".concat(e," entry."))}return null}get mediaBox(){return(0,n.shadow)(this,"mediaBox",this._getBoundingBox("MediaBox")||k)}get cropBox(){return(0,n.shadow)(this,"cropBox",this._getBoundingBox("CropBox")||this.mediaBox)}get userUnit(){let e=this.pageDict.get("UserUnit");("number"!=typeof e||e<=0)&&(e=1);return(0,n.shadow)(this,"userUnit",e)}get view(){const{cropBox:e,mediaBox:t}=this;let r;if(e===t||(0,n.isArrayEqual)(e,t))r=t;else{const a=n.Util.intersect(e,t);a&&a[2]-a[0]!=0&&a[3]-a[1]!=0?r=a:(0,n.warn)("Empty /CropBox and /MediaBox intersection.")}return(0,n.shadow)(this,"view",r||t)}get rotate(){let e=this._getInheritableProperty("Rotate")||0;e%90!=0?e=0:e>=360?e%=360:e<0&&(e=(e%360+360)%360);return(0,n.shadow)(this,"rotate",e)}_onSubStreamError(e,t,r){if(!this.evaluatorOptions.ignoreErrors)throw t;e.send("UnsupportedFeature",{featureId:n.UNSUPPORTED_FEATURES.errorContentSubStream});(0,n.warn)("getContentStream - ignoring sub-stream (".concat(r,'): "').concat(t,'".'))}getContentStream(e){return this.pdfManager.ensure(this,"content").then((t=>t instanceof c.BaseStream?t:Array.isArray(t)?new y.StreamsSequenceStream(t,this._onSubStreamError.bind(this,e)):new g.NullStream))}get xfaData(){return(0,n.shadow)(this,"xfaData",this.xfaFactory?{bbox:this.xfaFactory.getBoundingBox(this.pageIndex)}:null)}async saveNewAnnotations(e,t,r){if(this.xfaFactory)throw new Error("XFA: Cannot save new annotations.");const n=new b.PartialEvaluator({xref:this.xref,handler:e,pageIndex:this.pageIndex,idFactory:this._localIdFactory,fontCache:this.fontCache,builtInCMapCache:this.builtInCMapCache,standardFontDataCache:this.standardFontDataCache,globalImageCache:this.globalImageCache,options:this.evaluatorOptions}),a=this.pageDict,i=this.annotations.slice(),s=await o.AnnotationFactory.saveNewAnnotations(n,t,r);for(const{ref:e}of s.annotations)i.push(e);const c=a.get("Annots");a.set("Annots",i);const l=[];let h=null;this.xref.encrypt&&(h=this.xref.encrypt.createCipherTransform(this.ref.num,this.ref.gen));(0,S.writeObject)(this.ref,a,l,h);c&&a.set("Annots",c);const u=s.dependencies;u.push({ref:this.ref,data:l.join("")},...s.annotations);return u}save(e,t,r){const a=new b.PartialEvaluator({xref:this.xref,handler:e,pageIndex:this.pageIndex,idFactory:this._localIdFactory,fontCache:this.fontCache,builtInCMapCache:this.builtInCMapCache,standardFontDataCache:this.standardFontDataCache,globalImageCache:this.globalImageCache,options:this.evaluatorOptions});return this._parsedAnnotations.then((function(e){const i=[];for(const s of e)s.mustBePrinted(r)&&i.push(s.save(a,t,r).catch((function(e){(0,n.warn)("save - ignoring annotation data during "+'"'.concat(t.name,'" task: "').concat(e,'".'));return null})));return Promise.all(i)}))}loadResources(e){this.resourcesPromise||(this.resourcesPromise=this.pdfManager.ensure(this,"resources"));return this.resourcesPromise.then((()=>new p.ObjectLoader(this.resources,e,this.xref).load()))}getOperatorList(e){let{handler:t,sink:r,task:a,intent:i,cacheKey:s,annotationStorage:o=null}=e;const c=this.getContentStream(t),l=this.loadResources(["ColorSpace","ExtGState","Font","Pattern","Properties","Shading","XObject"]),h=new b.PartialEvaluator({xref:this.xref,handler:t,pageIndex:this.pageIndex,idFactory:this._localIdFactory,fontCache:this.fontCache,builtInCMapCache:this.builtInCMapCache,standardFontDataCache:this.standardFontDataCache,globalImageCache:this.globalImageCache,options:this.evaluatorOptions}),u=Promise.all([c,l]).then((e=>{let[n]=e;const o=new m.OperatorList(i,r);t.send("StartRenderPage",{transparency:h.hasBlendModes(this.resources,this.nonBlendModesSet),pageIndex:this.pageIndex,cacheKey:s});return h.getOperatorList({stream:n,task:a,resources:this.resources,operatorList:o}).then((function(){return o}))}));return Promise.all([u,this._parsedAnnotations]).then((function(e){let[t,r]=e;if(0===r.length||i&n.RenderingIntentFlag.ANNOTATIONS_DISABLE){t.flush(!0);return{length:t.totalLength}}const s=!!(i&n.RenderingIntentFlag.ANNOTATIONS_FORMS),c=!!(i&n.RenderingIntentFlag.ANY),l=!!(i&n.RenderingIntentFlag.DISPLAY),u=!!(i&n.RenderingIntentFlag.PRINT),d=[];for(const e of r)(c||l&&e.mustBeViewed(o)||u&&e.mustBePrinted(o))&&d.push(e.getOperatorList(h,a,i,s,o).catch((function(e){(0,n.warn)("getOperatorList - ignoring annotation data during "+'"'.concat(a.name,'" task: "').concat(e,'".'));return null})));return Promise.all(d).then((function(e){for(const r of e)t.addOpList(r);t.flush(!0);return{length:t.totalLength}}))}))}extractTextContent(e){let{handler:t,task:r,includeMarkedContent:n,sink:a,combineTextItems:i}=e;const s=this.getContentStream(t),o=this.loadResources(["ExtGState","Font","Properties","XObject"]);return Promise.all([s,o]).then((e=>{let[s]=e;return new b.PartialEvaluator({xref:this.xref,handler:t,pageIndex:this.pageIndex,idFactory:this._localIdFactory,fontCache:this.fontCache,builtInCMapCache:this.builtInCMapCache,standardFontDataCache:this.standardFontDataCache,globalImageCache:this.globalImageCache,options:this.evaluatorOptions}).getTextContent({stream:s,task:r,resources:this.resources,includeMarkedContent:n,combineTextItems:i,sink:a,viewBox:this.view})}))}async getStructTree(){const e=await this.pdfManager.ensureCatalog("structTreeRoot");if(!e)return null;return(await this.pdfManager.ensure(this,"_parseStructTree",[e])).serializable}_parseStructTree(e){const t=new w.StructTreePage(e,this.pageDict);t.parse();return t}getAnnotationsData(e){return this._parsedAnnotations.then((function(t){const r=[];if(0===t.length)return r;const a=!!(e&n.RenderingIntentFlag.ANY),i=!!(e&n.RenderingIntentFlag.DISPLAY),s=!!(e&n.RenderingIntentFlag.PRINT);for(const e of t)(a||i&&e.viewable||s&&e.printable)&&r.push(e.data);return r}))}get annotations(){const e=this._getInheritableProperty("Annots");return(0,n.shadow)(this,"annotations",Array.isArray(e)?e:[])}get _parsedAnnotations(){const e=this.pdfManager.ensure(this,"annotations").then((()=>{const e=[];for(const t of this.annotations)e.push(o.AnnotationFactory.create(this.xref,t,this.pdfManager,this._localIdFactory,!1).catch((function(e){(0,n.warn)('_parsedAnnotations: "'.concat(e,'".'));return null})));return Promise.all(e).then((function(e){return e.filter((e=>!!e))}))}));return(0,n.shadow)(this,"_parsedAnnotations",e)}get jsActions(){const e=(0,a.collectActions)(this.xref,this.pageDict,n.PageActionEventType);return(0,n.shadow)(this,"jsActions",e)}}t.Page=Page;const C=new Uint8Array([37,80,68,70,45]),O=new Uint8Array([115,116,97,114,116,120,114,101,102]),T=new Uint8Array([101,110,100,111,98,106]),M=/^[1-9]\.\d$/;function find(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:1024,n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];const a=t.length,i=e.peekBytes(r),s=i.length-a;if(s<=0)return!1;if(n){const r=a-1;let n=i.length-1;for(;n>=r;){let s=0;for(;s<a&&i[n-s]===t[r-s];)s++;if(s>=a){e.pos+=n-r;return!0}n--}}else{let r=0;for(;r<=s;){let n=0;for(;n<a&&i[r+n]===t[n];)n++;if(n>=a){e.pos+=r;return!0}r++}}return!1}t.PDFDocument=class PDFDocument{constructor(e,t){if(t.length<=0)throw new n.InvalidPDFException("The PDF file is empty, i.e. its size is zero bytes.");this.pdfManager=e;this.stream=t;this.xref=new v.XRef(t,e);this._pagePromises=new Map;this._version=null;const r={font:0};this._globalIdFactory=class{static getDocId(){return"g_".concat(e.docId)}static createFontId(){return"f".concat(++r.font)}static createObjId(){(0,n.unreachable)("Abstract method `createObjId` called.")}static getPageObjId(){(0,n.unreachable)("Abstract method `getPageObjId` called.")}}}parse(e){this.xref.parse(e);this.catalog=new h.Catalog(this.pdfManager,this.xref);this.catalog.version&&(this._version=this.catalog.version)}get linearization(){let e=null;try{e=f.Linearization.create(this.stream)}catch(e){if(e instanceof a.MissingDataException)throw e;(0,n.info)(e)}return(0,n.shadow)(this,"linearization",e)}get startXRef(){const e=this.stream;let t=0;if(this.linearization){e.reset();find(e,T)&&(t=e.pos+6-e.start)}else{const r=1024,n=O.length;let i=!1,s=e.end;for(;!i&&s>0;){s-=r-n;s<0&&(s=0);e.pos=s;i=find(e,O,r,!0)}if(i){e.skip(9);let r;do{r=e.getByte()}while((0,a.isWhiteSpace)(r));let n="";for(;r>=32&&r<=57;){n+=String.fromCharCode(r);r=e.getByte()}t=parseInt(n,10);isNaN(t)&&(t=0)}}return(0,n.shadow)(this,"startXRef",t)}checkHeader(){const e=this.stream;e.reset();if(!find(e,C))return;e.moveStart();let t,r="";for(;(t=e.getByte())>32&&!(r.length>=12);)r+=String.fromCharCode(t);this._version||(this._version=r.substring(5))}parseStartXRef(){this.xref.setStartXRef(this.startXRef)}get numPages(){let e=0;e=this.catalog.hasActualNumPages?this.catalog.numPages:this.xfaFactory?this.xfaFactory.getNumPages():this.linearization?this.linearization.numPages:this.catalog.numPages;return(0,n.shadow)(this,"numPages",e)}_hasOnlyDocumentSignatures(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0;return!!Array.isArray(e)&&e.every((e=>{if(!((e=this.xref.fetchIfRef(e))instanceof i.Dict))return!1;if(e.has("Kids")){if(++t>10){(0,n.warn)("_hasOnlyDocumentSignatures: maximum recursion depth reached");return!1}return this._hasOnlyDocumentSignatures(e.get("Kids"),t)}const r=(0,i.isName)(e.get("FT"),"Sig"),a=e.get("Rect"),s=Array.isArray(a)&&a.every((e=>0===e));return r&&s}))}get _xfaStreams(){const e=this.catalog.acroForm;if(!e)return null;const t=e.get("XFA"),r={"xdp:xdp":"",template:"",datasets:"",config:"",connectionSet:"",localeSet:"",stylesheet:"","/xdp:xdp":""};if(t instanceof c.BaseStream&&!t.isEmpty){r["xdp:xdp"]=t;return r}if(!Array.isArray(t)||0===t.length)return null;for(let e=0,n=t.length;e<n;e+=2){let a;a=0===e?"xdp:xdp":e===n-2?"/xdp:xdp":t[e];if(!r.hasOwnProperty(a))continue;const i=this.xref.fetchIfRef(t[e+1]);i instanceof c.BaseStream&&!i.isEmpty&&(r[a]=i)}return r}get xfaDatasets(){const e=this._xfaStreams;if(!e)return(0,n.shadow)(this,"xfaDatasets",null);for(const t of["datasets","xdp:xdp"]){const r=e[t];if(r)try{const e={[t]:(0,n.stringToUTF8String)(r.getString())};return(0,n.shadow)(this,"xfaDatasets",new d.DatasetReader(e))}catch(e){(0,n.warn)("XFA - Invalid utf-8 string.");break}}return(0,n.shadow)(this,"xfaDatasets",null)}get xfaData(){const e=this._xfaStreams;if(!e)return null;const t=Object.create(null);for(const[r,a]of Object.entries(e))if(a)try{t[r]=(0,n.stringToUTF8String)(a.getString())}catch(e){(0,n.warn)("XFA - Invalid utf-8 string.");return null}return t}get xfaFactory(){let e;this.pdfManager.enableXfa&&this.catalog.needsRendering&&this.formInfo.hasXfa&&!this.formInfo.hasAcroForm&&(e=this.xfaData);return(0,n.shadow)(this,"xfaFactory",e?new x.XFAFactory(e):null)}get isPureXfa(){return!!this.xfaFactory&&this.xfaFactory.isValid()}get htmlForXfa(){return this.xfaFactory?this.xfaFactory.getPages():null}async loadXfaImages(){const e=await this.pdfManager.ensureCatalog("xfaImages");if(!e)return;const t=e.getKeys(),r=new p.ObjectLoader(e,t,this.xref);await r.load();const n=new Map;for(const r of t){const t=e.get(r);t instanceof c.BaseStream&&n.set(r,t.getBytes())}this.xfaFactory.setImages(n)}async loadXfaFonts(e,t){const r=await this.pdfManager.ensureCatalog("acroForm");if(!r)return;const o=await r.getAsync("DR");if(!(o instanceof i.Dict))return;const c=new p.ObjectLoader(o,["Font"],this.xref);await c.load();const l=o.get("Font");if(!(l instanceof i.Dict))return;const h=Object.assign(Object.create(null),this.pdfManager.evaluatorOptions);h.useSystemFonts=!1;const u=new b.PartialEvaluator({xref:this.xref,handler:e,pageIndex:-1,idFactory:this._globalIdFactory,fontCache:this.catalog.fontCache,builtInCMapCache:this.catalog.builtInCMapCache,standardFontDataCache:this.catalog.standardFontDataCache,options:h}),d=new m.OperatorList,f=[],g={get font(){return f.at(-1)},set font(e){f.push(e)},clone(){return this}},y=new Map;l.forEach(((e,t)=>{y.set(e,t)}));const w=[];for(const[e,r]of y){const s=r.get("FontDescriptor");if(!(s instanceof i.Dict))continue;let c=s.get("FontFamily");c=c.replace(/[ ]+(\d)/g,"$1");const l={fontFamily:c,fontWeight:s.get("FontWeight"),italicAngle:-s.get("ItalicAngle")};(0,a.validateCSSFont)(l)&&w.push(u.handleSetFont(o,[i.Name.get(e),1],null,d,t,g,null,l).catch((function(e){(0,n.warn)('loadXfaFonts: "'.concat(e,'".'));return null})))}await Promise.all(w);const S=this.xfaFactory.setFonts(f);if(!S)return;h.ignoreErrors=!0;w.length=0;f.length=0;const x=new Set;for(const e of S)(0,s.getXfaFontName)("".concat(e,"-Regular"))||x.add(e);x.size&&S.push("PdfJS-Fallback");for(const e of S)if(!x.has(e))for(const r of[{name:"Regular",fontWeight:400,italicAngle:0},{name:"Bold",fontWeight:700,italicAngle:0},{name:"Italic",fontWeight:400,italicAngle:12},{name:"BoldItalic",fontWeight:700,italicAngle:12}]){const a="".concat(e,"-").concat(r.name),c=(0,s.getXfaFontDict)(a);w.push(u.handleSetFont(o,[i.Name.get(a),1],null,d,t,g,c,{fontFamily:e,fontWeight:r.fontWeight,italicAngle:r.italicAngle}).catch((function(e){(0,n.warn)('loadXfaFonts: "'.concat(e,'".'));return null})))}await Promise.all(w);this.xfaFactory.appendFonts(f,x)}async serializeXfaData(e){return this.xfaFactory?this.xfaFactory.serializeData(e):null}get formInfo(){const e={hasFields:!1,hasAcroForm:!1,hasXfa:!1,hasSignatures:!1},t=this.catalog.acroForm;if(!t)return(0,n.shadow)(this,"formInfo",e);try{const r=t.get("Fields"),n=Array.isArray(r)&&r.length>0;e.hasFields=n;const a=t.get("XFA");e.hasXfa=Array.isArray(a)&&a.length>0||a instanceof c.BaseStream&&!a.isEmpty;const i=!!(1&t.get("SigFlags")),s=i&&this._hasOnlyDocumentSignatures(r);e.hasAcroForm=n&&!s;e.hasSignatures=i}catch(e){if(e instanceof a.MissingDataException)throw e;(0,n.warn)('Cannot fetch form information: "'.concat(e,'".'))}return(0,n.shadow)(this,"formInfo",e)}get documentInfo(){let e=this._version;if("string"!=typeof e||!M.test(e)){(0,n.warn)("Invalid PDF header version number: ".concat(e));e=null}const t={PDFFormatVersion:e,Language:this.catalog.lang,EncryptFilterName:this.xref.encrypt?this.xref.encrypt.filterName:null,IsLinearized:!!this.linearization,IsAcroFormPresent:this.formInfo.hasAcroForm,IsXFAPresent:this.formInfo.hasXfa,IsCollectionPresent:!!this.catalog.collection,IsSignaturesPresent:this.formInfo.hasSignatures};let r;try{r=this.xref.trailer.get("Info")}catch(e){if(e instanceof a.MissingDataException)throw e;(0,n.info)("The document information dictionary is invalid.")}if(!(r instanceof i.Dict))return(0,n.shadow)(this,"documentInfo",t);for(const e of r.getKeys()){const a=r.get(e);switch(e){case"Title":case"Author":case"Subject":case"Keywords":case"Creator":case"Producer":case"CreationDate":case"ModDate":if("string"==typeof a){t[e]=(0,n.stringToPDFString)(a);continue}break;case"Trapped":if(a instanceof i.Name){t[e]=a;continue}break;default:let r;switch(typeof a){case"string":r=(0,n.stringToPDFString)(a);break;case"number":case"boolean":r=a;break;default:a instanceof i.Name&&(r=a)}if(void 0===r){(0,n.warn)('Bad value, for custom key "'.concat(e,'", in Info: ').concat(a,"."));continue}t.Custom||(t.Custom=Object.create(null));t.Custom[e]=r;continue}(0,n.warn)('Bad value, for key "'.concat(e,'", in Info: ').concat(a,"."))}return(0,n.shadow)(this,"documentInfo",t)}get fingerprints(){function validate(e){return"string"==typeof e&&e.length>0&&"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"!==e}function hexString(e){const t=[];for(let r=0,n=e.length;r<n;r++){const n=e[r].toString(16);t.push(n.padStart(2,"0"))}return t.join("")}const e=this.xref.trailer.get("ID");let t,r;if(Array.isArray(e)&&validate(e[0])){t=(0,n.stringToBytes)(e[0]);e[1]!==e[0]&&validate(e[1])&&(r=(0,n.stringToBytes)(e[1]))}else t=(0,l.calculateMD5)(this.stream.getByteRange(0,1024),0,1024);return(0,n.shadow)(this,"fingerprints",[hexString(t),r?hexString(r):null])}async _getLinearizationPage(e){const{catalog:t,linearization:r,xref:a}=this,s=i.Ref.get(r.objectNumberFirst,0);try{const e=await a.fetchAsync(s);if(e instanceof i.Dict){let r=e.getRaw("Type");r instanceof i.Ref&&(r=await a.fetchAsync(r));if((0,i.isName)(r,"Page")||!e.has("Type")&&!e.has("Kids")){t.pageKidsCountCache.has(s)||t.pageKidsCountCache.put(s,1);t.pageIndexCache.has(s)||t.pageIndexCache.put(s,0);return[e,s]}}throw new n.FormatError("The Linearization dictionary doesn't point to a valid Page dictionary.")}catch(r){(0,n.warn)('_getLinearizationPage: "'.concat(r.message,'".'));return t.getPageDict(e)}}getPage(e){const t=this._pagePromises.get(e);if(t)return t;const{catalog:r,linearization:n,xfaFactory:a}=this;let s;s=a?Promise.resolve([i.Dict.empty,null]):n&&n.pageFirst===e?this._getLinearizationPage(e):r.getPageDict(e);s=s.then((t=>{let[n,i]=t;return new Page({pdfManager:this.pdfManager,xref:this.xref,pageIndex:e,pageDict:n,ref:i,globalIdFactory:this._globalIdFactory,fontCache:r.fontCache,builtInCMapCache:r.builtInCMapCache,standardFontDataCache:r.standardFontDataCache,globalImageCache:r.globalImageCache,nonBlendModesSet:r.nonBlendModesSet,xfaFactory:a})}));this._pagePromises.set(e,s);return s}async checkFirstPage(){if(!(arguments.length>0&&void 0!==arguments[0]&&arguments[0]))try{await this.getPage(0)}catch(e){if(e instanceof a.XRefEntryException){this._pagePromises.delete(0);await this.cleanup();throw new a.XRefParseException}}}async checkLastPage(){let e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];const{catalog:t,pdfManager:r}=this;t.setActualNumPages();let i;try{await Promise.all([r.ensureDoc("xfaFactory"),r.ensureDoc("linearization"),r.ensureCatalog("numPages")]);if(this.xfaFactory)return;i=this.linearization?this.linearization.numPages:t.numPages;if(!Number.isInteger(i))throw new n.FormatError("Page count is not an integer.");if(i<=1)return;await this.getPage(i-1)}catch(s){this._pagePromises.delete(i-1);await this.cleanup();if(s instanceof a.XRefEntryException&&!e)throw new a.XRefParseException;(0,n.warn)("checkLastPage - invalid /Pages tree /Count: ".concat(i,"."));let o;try{o=await t.getAllPageDicts(e)}catch(r){if(r instanceof a.XRefEntryException&&!e)throw new a.XRefParseException;t.setActualNumPages(1);return}for(const[e,[n,a]]of o){let i;if(n instanceof Error){i=Promise.reject(n);i.catch((()=>{}))}else i=Promise.resolve(new Page({pdfManager:r,xref:this.xref,pageIndex:e,pageDict:n,ref:a,globalIdFactory:this._globalIdFactory,fontCache:t.fontCache,builtInCMapCache:t.builtInCMapCache,standardFontDataCache:t.standardFontDataCache,globalImageCache:t.globalImageCache,nonBlendModesSet:t.nonBlendModesSet,xfaFactory:null}));this._pagePromises.set(e,i)}t.setActualNumPages(o.size)}}fontFallback(e,t){return this.catalog.fontFallback(e,t)}async cleanup(){let e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return this.catalog?this.catalog.cleanup(e):(0,u.clearGlobalCaches)()}_collectFieldObjects(e,t,r){const a=this.xref.fetchIfRef(t);if(a.has("T")){const t=(0,n.stringToPDFString)(a.get("T"));e=""===e?t:"".concat(e,".").concat(t)}r.has(e)||r.set(e,[]);r.get(e).push(o.AnnotationFactory.create(this.xref,t,this.pdfManager,this._localIdFactory,!0).then((e=>e&&e.getFieldObject())).catch((function(e){(0,n.warn)('_collectFieldObjects: "'.concat(e,'".'));return null})));if(a.has("Kids")){const t=a.get("Kids");for(const n of t)this._collectFieldObjects(e,n,r)}}get fieldObjects(){if(!this.formInfo.hasFields)return(0,n.shadow)(this,"fieldObjects",Promise.resolve(null));const e=Object.create(null),t=new Map;for(const e of this.catalog.acroForm.get("Fields"))this._collectFieldObjects("",e,t);const r=[];for(const[n,a]of t)r.push(Promise.all(a).then((t=>{(t=t.filter((e=>!!e))).length>0&&(e[n]=t)})));return(0,n.shadow)(this,"fieldObjects",Promise.all(r).then((()=>e)))}get hasJSActions(){const e=this.pdfManager.ensureDoc("_parseHasJSActions");return(0,n.shadow)(this,"hasJSActions",e)}async _parseHasJSActions(){const[e,t]=await Promise.all([this.pdfManager.ensureCatalog("jsActions"),this.pdfManager.ensureDoc("fieldObjects")]);return!!e||!!t&&Object.values(t).some((e=>e.some((e=>null!==e.actions))))}get calculationOrderIds(){const e=this.catalog.acroForm;if(!e||!e.has("CO"))return(0,n.shadow)(this,"calculationOrderIds",null);const t=e.get("CO");if(!Array.isArray(t)||0===t.length)return(0,n.shadow)(this,"calculationOrderIds",null);const r=[];for(const e of t)e instanceof i.Ref&&r.push(e.toString());return 0===r.length?(0,n.shadow)(this,"calculationOrderIds",null):(0,n.shadow)(this,"calculationOrderIds",r)}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.getXfaFontDict=function getXfaFontDict(e){const t=function getXfaFontWidths(e){const t=getXfaFontName(e);if(!t)return null;const{baseWidths:r,baseMapping:n,factors:a}=t;let i;i=a?r.map(((e,t)=>e*a[t])):r;let s,o=-2;const c=[];for(const[e,t]of n.map(((e,t)=>[e,t])).sort(((e,t)=>{let[r]=e,[n]=t;return r-n})))if(-1!==e)if(e===o+1){s.push(i[t]);o+=1}else{o=e;s=[i[t]];c.push(e,s)}return c}(e),r=new a.Dict(null);r.set("BaseFont",a.Name.get(e));r.set("Type",a.Name.get("Font"));r.set("Subtype",a.Name.get("CIDFontType2"));r.set("Encoding",a.Name.get("Identity-H"));r.set("CIDToGIDMap",a.Name.get("Identity"));r.set("W",t);r.set("FirstChar",t[0]);r.set("LastChar",t.at(-2)+t.at(-1).length-1);const n=new a.Dict(null);r.set("FontDescriptor",n);const i=new a.Dict(null);i.set("Ordering","Identity");i.set("Registry","Adobe");i.set("Supplement",0);r.set("CIDSystemInfo",i);return r};t.getXfaFontName=getXfaFontName;r(112);var n=r(221),a=r(209),i=r(222),s=r(223),o=r(224),c=r(225),l=r(213),h=r(226);const u=(0,l.getLookupTableFactory)((function(e){e["MyriadPro-Regular"]=e["PdfJS-Fallback-Regular"]={name:"LiberationSans-Regular",factors:o.MyriadProRegularFactors,baseWidths:s.LiberationSansRegularWidths,baseMapping:s.LiberationSansRegularMapping,metrics:o.MyriadProRegularMetrics};e["MyriadPro-Bold"]=e["PdfJS-Fallback-Bold"]={name:"LiberationSans-Bold",factors:o.MyriadProBoldFactors,baseWidths:s.LiberationSansBoldWidths,baseMapping:s.LiberationSansBoldMapping,metrics:o.MyriadProBoldMetrics};e["MyriadPro-It"]=e["MyriadPro-Italic"]=e["PdfJS-Fallback-Italic"]={name:"LiberationSans-Italic",factors:o.MyriadProItalicFactors,baseWidths:s.LiberationSansItalicWidths,baseMapping:s.LiberationSansItalicMapping,metrics:o.MyriadProItalicMetrics};e["MyriadPro-BoldIt"]=e["MyriadPro-BoldItalic"]=e["PdfJS-Fallback-BoldItalic"]={name:"LiberationSans-BoldItalic",factors:o.MyriadProBoldItalicFactors,baseWidths:s.LiberationSansBoldItalicWidths,baseMapping:s.LiberationSansBoldItalicMapping,metrics:o.MyriadProBoldItalicMetrics};e.ArialMT=e.Arial=e["Arial-Regular"]={name:"LiberationSans-Regular",baseWidths:s.LiberationSansRegularWidths,baseMapping:s.LiberationSansRegularMapping};e["Arial-BoldMT"]=e["Arial-Bold"]={name:"LiberationSans-Bold",baseWidths:s.LiberationSansBoldWidths,baseMapping:s.LiberationSansBoldMapping};e["Arial-ItalicMT"]=e["Arial-Italic"]={name:"LiberationSans-Italic",baseWidths:s.LiberationSansItalicWidths,baseMapping:s.LiberationSansItalicMapping};e["Arial-BoldItalicMT"]=e["Arial-BoldItalic"]={name:"LiberationSans-BoldItalic",baseWidths:s.LiberationSansBoldItalicWidths,baseMapping:s.LiberationSansBoldItalicMapping};e["Calibri-Regular"]={name:"LiberationSans-Regular",factors:n.CalibriRegularFactors,baseWidths:s.LiberationSansRegularWidths,baseMapping:s.LiberationSansRegularMapping,metrics:n.CalibriRegularMetrics};e["Calibri-Bold"]={name:"LiberationSans-Bold",factors:n.CalibriBoldFactors,baseWidths:s.LiberationSansBoldWidths,baseMapping:s.LiberationSansBoldMapping,metrics:n.CalibriBoldMetrics};e["Calibri-Italic"]={name:"LiberationSans-Italic",factors:n.CalibriItalicFactors,baseWidths:s.LiberationSansItalicWidths,baseMapping:s.LiberationSansItalicMapping,metrics:n.CalibriItalicMetrics};e["Calibri-BoldItalic"]={name:"LiberationSans-BoldItalic",factors:n.CalibriBoldItalicFactors,baseWidths:s.LiberationSansBoldItalicWidths,baseMapping:s.LiberationSansBoldItalicMapping,metrics:n.CalibriBoldItalicMetrics};e["Segoeui-Regular"]={name:"LiberationSans-Regular",factors:c.SegoeuiRegularFactors,baseWidths:s.LiberationSansRegularWidths,baseMapping:s.LiberationSansRegularMapping,metrics:c.SegoeuiRegularMetrics};e["Segoeui-Bold"]={name:"LiberationSans-Bold",factors:c.SegoeuiBoldFactors,baseWidths:s.LiberationSansBoldWidths,baseMapping:s.LiberationSansBoldMapping,metrics:c.SegoeuiBoldMetrics};e["Segoeui-Italic"]={name:"LiberationSans-Italic",factors:c.SegoeuiItalicFactors,baseWidths:s.LiberationSansItalicWidths,baseMapping:s.LiberationSansItalicMapping,metrics:c.SegoeuiItalicMetrics};e["Segoeui-BoldItalic"]={name:"LiberationSans-BoldItalic",factors:c.SegoeuiBoldItalicFactors,baseWidths:s.LiberationSansBoldItalicWidths,baseMapping:s.LiberationSansBoldItalicMapping,metrics:c.SegoeuiBoldItalicMetrics};e["Helvetica-Regular"]=e.Helvetica={name:"LiberationSans-Regular",factors:i.HelveticaRegularFactors,baseWidths:s.LiberationSansRegularWidths,baseMapping:s.LiberationSansRegularMapping,metrics:i.HelveticaRegularMetrics};e["Helvetica-Bold"]={name:"LiberationSans-Bold",factors:i.HelveticaBoldFactors,baseWidths:s.LiberationSansBoldWidths,baseMapping:s.LiberationSansBoldMapping,metrics:i.HelveticaBoldMetrics};e["Helvetica-Italic"]={name:"LiberationSans-Italic",factors:i.HelveticaItalicFactors,baseWidths:s.LiberationSansItalicWidths,baseMapping:s.LiberationSansItalicMapping,metrics:i.HelveticaItalicMetrics};e["Helvetica-BoldItalic"]={name:"LiberationSans-BoldItalic",factors:i.HelveticaBoldItalicFactors,baseWidths:s.LiberationSansBoldItalicWidths,baseMapping:s.LiberationSansBoldItalicMapping,metrics:i.HelveticaBoldItalicMetrics}}));function getXfaFontName(e){const t=(0,h.normalizeFontName)(e);return u()[t]}},(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.CalibriRegularMetrics=t.CalibriRegularFactors=t.CalibriItalicMetrics=t.CalibriItalicFactors=t.CalibriBoldMetrics=t.CalibriBoldItalicMetrics=t.CalibriBoldItalicFactors=t.CalibriBoldFactors=void 0;t.CalibriBoldFactors=[1.3877,1,1,1,.97801,.92482,.89552,.91133,.81988,.97566,.98152,.93548,.93548,1.2798,.85284,.92794,1,.96134,1.54657,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.82845,.82845,.85284,.85284,.85284,.75859,.92138,.83908,.7762,.73293,.87289,.73133,.7514,.81921,.87356,.95958,.59526,.75727,.69225,1.04924,.9121,.86943,.79795,.88198,.77958,.70864,.81055,.90399,.88653,.96017,.82577,.77892,.78257,.97507,1.54657,.97507,.85284,.89552,.90176,.88762,.8785,.75241,.8785,.90518,.95015,.77618,.8785,.88401,.91916,.86304,.88401,.91488,.8785,.8801,.8785,.8785,.91343,.7173,1.04106,.8785,.85075,.95794,.82616,.85162,.79492,.88331,1.69808,.88331,.85284,.97801,.89552,.91133,.89552,.91133,1.7801,.89552,1.24487,1.13254,1.12401,.96839,.85284,.68787,.70645,.85592,.90747,1.01466,1.0088,.90323,1,1.07463,1,.91056,.75806,1.19118,.96839,.78864,.82845,.84133,.75859,.83908,.83908,.83908,.83908,.83908,.83908,.77539,.73293,.73133,.73133,.73133,.73133,.95958,.95958,.95958,.95958,.88506,.9121,.86943,.86943,.86943,.86943,.86943,.85284,.87508,.90399,.90399,.90399,.90399,.77892,.79795,.90807,.88762,.88762,.88762,.88762,.88762,.88762,.8715,.75241,.90518,.90518,.90518,.90518,.88401,.88401,.88401,.88401,.8785,.8785,.8801,.8801,.8801,.8801,.8801,.90747,.89049,.8785,.8785,.8785,.8785,.85162,.8785,.85162,.83908,.88762,.83908,.88762,.83908,.88762,.73293,.75241,.73293,.75241,.73293,.75241,.73293,.75241,.87289,.83016,.88506,.93125,.73133,.90518,.73133,.90518,.73133,.90518,.73133,.90518,.73133,.90518,.81921,.77618,.81921,.77618,.81921,.77618,1,1,.87356,.8785,.91075,.89608,.95958,.88401,.95958,.88401,.95958,.88401,.95958,.88401,.95958,.88401,.76229,.90167,.59526,.91916,1,1,.86304,.69225,.88401,1,1,.70424,.79468,.91926,.88175,.70823,.94903,.9121,.8785,1,1,.9121,.8785,.87802,.88656,.8785,.86943,.8801,.86943,.8801,.86943,.8801,.87402,.89291,.77958,.91343,1,1,.77958,.91343,.70864,.7173,.70864,.7173,.70864,.7173,.70864,.7173,1,1,.81055,.75841,.81055,1.06452,.90399,.8785,.90399,.8785,.90399,.8785,.90399,.8785,.90399,.8785,.90399,.8785,.96017,.95794,.77892,.85162,.77892,.78257,.79492,.78257,.79492,.78257,.79492,.9297,.56892,.83908,.88762,.77539,.8715,.87508,.89049,1,1,.81055,1.04106,1.20528,1.20528,1,1.15543,.70674,.98387,.94721,1.33431,1.45894,.95161,1.06303,.83908,.80352,.57184,.6965,.56289,.82001,.56029,.81235,1.02988,.83908,.7762,.68156,.80367,.73133,.78257,.87356,.86943,.95958,.75727,.89019,1.04924,.9121,.7648,.86943,.87356,.79795,.78275,.81055,.77892,.9762,.82577,.99819,.84896,.95958,.77892,.96108,1.01407,.89049,1.02988,.94211,.96108,.8936,.84021,.87842,.96399,.79109,.89049,1.00813,1.02988,.86077,.87445,.92099,.84723,.86513,.8801,.75638,.85714,.78216,.79586,.87965,.94211,.97747,.78287,.97926,.84971,1.02988,.94211,.8801,.94211,.84971,.73133,1,1,1,1,1,1,1,1,1,1,1,1,.90264,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.90518,1,1,1,1,1,1,1,1,1,1,1,1,.90548,1,1,1,1,1,1,.96017,.95794,.96017,.95794,.96017,.95794,.77892,.85162,1,1,.89552,.90527,1,.90363,.92794,.92794,.92794,.92794,.87012,.87012,.87012,.89552,.89552,1.42259,.71143,1.06152,1,1,1.03372,1.03372,.97171,1.4956,2.2807,.93835,.83406,.91133,.84107,.91133,1,1,1,.72021,1,1.23108,.83489,.88525,.88525,.81499,.90527,1.81055,.90527,1.81055,1.31006,1.53711,.94434,1.08696,1,.95018,.77192,.85284,.90747,1.17534,.69825,.9716,1.37077,.90747,.90747,.85356,.90747,.90747,1.44947,.85284,.8941,.8941,.70572,.8,.70572,.70572,.70572,.70572,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.99862,.99862,1,1,1,1,1,1.08004,.91027,1,1,1,.99862,1,1,1,1,1,1,1,1,1,1,1,1,.90727,.90727,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.CalibriBoldMetrics={lineHeight:1.2207,lineGap:.2207};t.CalibriBoldItalicFactors=[1.3877,1,1,1,.97801,.92482,.89552,.91133,.81988,.97566,.98152,.93548,.93548,1.2798,.85284,.92794,1,.96134,1.56239,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.82845,.82845,.85284,.85284,.85284,.75859,.92138,.83908,.7762,.71805,.87289,.73133,.7514,.81921,.87356,.95958,.59526,.75727,.69225,1.04924,.90872,.85938,.79795,.87068,.77958,.69766,.81055,.90399,.88653,.96068,.82577,.77892,.78257,.97507,1.529,.97507,.85284,.89552,.90176,.94908,.86411,.74012,.86411,.88323,.95015,.86411,.86331,.88401,.91916,.86304,.88401,.9039,.86331,.86331,.86411,.86411,.90464,.70852,1.04106,.86331,.84372,.95794,.82616,.84548,.79492,.88331,1.69808,.88331,.85284,.97801,.89552,.91133,.89552,.91133,1.7801,.89552,1.24487,1.13254,1.19129,.96839,.85284,.68787,.70645,.85592,.90747,1.01466,1.0088,.90323,1,1.07463,1,.91056,.75806,1.19118,.96839,.78864,.82845,.84133,.75859,.83908,.83908,.83908,.83908,.83908,.83908,.77539,.71805,.73133,.73133,.73133,.73133,.95958,.95958,.95958,.95958,.88506,.90872,.85938,.85938,.85938,.85938,.85938,.85284,.87068,.90399,.90399,.90399,.90399,.77892,.79795,.90807,.94908,.94908,.94908,.94908,.94908,.94908,.85887,.74012,.88323,.88323,.88323,.88323,.88401,.88401,.88401,.88401,.8785,.86331,.86331,.86331,.86331,.86331,.86331,.90747,.89049,.86331,.86331,.86331,.86331,.84548,.86411,.84548,.83908,.94908,.83908,.94908,.83908,.94908,.71805,.74012,.71805,.74012,.71805,.74012,.71805,.74012,.87289,.79538,.88506,.92726,.73133,.88323,.73133,.88323,.73133,.88323,.73133,.88323,.73133,.88323,.81921,.86411,.81921,.86411,.81921,.86411,1,1,.87356,.86331,.91075,.8777,.95958,.88401,.95958,.88401,.95958,.88401,.95958,.88401,.95958,.88401,.76467,.90167,.59526,.91916,1,1,.86304,.69225,.88401,1,1,.70424,.77312,.91926,.88175,.70823,.94903,.90872,.86331,1,1,.90872,.86331,.86906,.88116,.86331,.85938,.86331,.85938,.86331,.85938,.86331,.87402,.86549,.77958,.90464,1,1,.77958,.90464,.69766,.70852,.69766,.70852,.69766,.70852,.69766,.70852,1,1,.81055,.75841,.81055,1.06452,.90399,.86331,.90399,.86331,.90399,.86331,.90399,.86331,.90399,.86331,.90399,.86331,.96068,.95794,.77892,.84548,.77892,.78257,.79492,.78257,.79492,.78257,.79492,.9297,.56892,.83908,.94908,.77539,.85887,.87068,.89049,1,1,.81055,1.04106,1.20528,1.20528,1,1.15543,.70088,.98387,.94721,1.33431,1.45894,.95161,1.48387,.83908,.80352,.57118,.6965,.56347,.79179,.55853,.80346,1.02988,.83908,.7762,.67174,.86036,.73133,.78257,.87356,.86441,.95958,.75727,.89019,1.04924,.90872,.74889,.85938,.87891,.79795,.7957,.81055,.77892,.97447,.82577,.97466,.87179,.95958,.77892,.94252,.95612,.8753,1.02988,.92733,.94252,.87411,.84021,.8728,.95612,.74081,.8753,1.02189,1.02988,.84814,.87445,.91822,.84723,.85668,.86331,.81344,.87581,.76422,.82046,.96057,.92733,.99375,.78022,.95452,.86015,1.02988,.92733,.86331,.92733,.86015,.73133,1,1,1,1,1,1,1,1,1,1,1,1,.90631,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.88323,1,1,1,1,1,1,1,1,1,1,1,1,.85174,1,1,1,1,1,1,.96068,.95794,.96068,.95794,.96068,.95794,.77892,.84548,1,1,.89552,.90527,1,.90363,.92794,.92794,.92794,.89807,.87012,.87012,.87012,.89552,.89552,1.42259,.71094,1.06152,1,1,1.03372,1.03372,.97171,1.4956,2.2807,.92972,.83406,.91133,.83326,.91133,1,1,1,.72021,1,1.23108,.83489,.88525,.88525,.81499,.90616,1.81055,.90527,1.81055,1.3107,1.53711,.94434,1.08696,1,.95018,.77192,.85284,.90747,1.17534,.69825,.9716,1.37077,.90747,.90747,.85356,.90747,.90747,1.44947,.85284,.8941,.8941,.70572,.8,.70572,.70572,.70572,.70572,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.99862,.99862,1,1,1,1,1,1.08004,.91027,1,1,1,.99862,1,1,1,1,1,1,1,1,1,1,1,1,.90727,.90727,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.CalibriBoldItalicMetrics={lineHeight:1.2207,lineGap:.2207};t.CalibriItalicFactors=[1.3877,1,1,1,1.17223,1.1293,.89552,.91133,.80395,1.02269,1.15601,.91056,.91056,1.2798,.85284,.89807,1,.90861,1.39543,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.96309,.96309,.85284,.85284,.85284,.83319,.88071,.8675,.81552,.72346,.85193,.73206,.7522,.81105,.86275,.90685,.6377,.77892,.75593,1.02638,.89249,.84118,.77452,.85374,.75186,.67789,.79776,.88844,.85066,.94309,.77818,.7306,.76659,1.10369,1.38313,1.10369,1.06139,.89552,.8739,.9245,.9245,.83203,.9245,.85865,1.09842,.9245,.9245,1.03297,1.07692,.90918,1.03297,.94959,.9245,.92274,.9245,.9245,1.02933,.77832,1.20562,.9245,.8916,.98986,.86621,.89453,.79004,.94152,1.77256,.94152,.85284,.97801,.89552,.91133,.89552,.91133,1.91729,.89552,1.17889,1.13254,1.16359,.92098,.85284,.68787,.71353,.84737,.90747,1.0088,1.0044,.87683,1,1.09091,1,.92229,.739,1.15642,.92098,.76288,.80504,.80972,.75859,.8675,.8675,.8675,.8675,.8675,.8675,.76318,.72346,.73206,.73206,.73206,.73206,.90685,.90685,.90685,.90685,.86477,.89249,.84118,.84118,.84118,.84118,.84118,.85284,.84557,.88844,.88844,.88844,.88844,.7306,.77452,.86331,.9245,.9245,.9245,.9245,.9245,.9245,.84843,.83203,.85865,.85865,.85865,.85865,.82601,.82601,.82601,.82601,.94469,.9245,.92274,.92274,.92274,.92274,.92274,.90747,.86651,.9245,.9245,.9245,.9245,.89453,.9245,.89453,.8675,.9245,.8675,.9245,.8675,.9245,.72346,.83203,.72346,.83203,.72346,.83203,.72346,.83203,.85193,.8875,.86477,.99034,.73206,.85865,.73206,.85865,.73206,.85865,.73206,.85865,.73206,.85865,.81105,.9245,.81105,.9245,.81105,.9245,1,1,.86275,.9245,.90872,.93591,.90685,.82601,.90685,.82601,.90685,.82601,.90685,1.03297,.90685,.82601,.77896,1.05611,.6377,1.07692,1,1,.90918,.75593,1.03297,1,1,.76032,.9375,.98156,.93407,.77261,1.11429,.89249,.9245,1,1,.89249,.9245,.92534,.86698,.9245,.84118,.92274,.84118,.92274,.84118,.92274,.8667,.86291,.75186,1.02933,1,1,.75186,1.02933,.67789,.77832,.67789,.77832,.67789,.77832,.67789,.77832,1,1,.79776,.97655,.79776,1.23023,.88844,.9245,.88844,.9245,.88844,.9245,.88844,.9245,.88844,.9245,.88844,.9245,.94309,.98986,.7306,.89453,.7306,.76659,.79004,.76659,.79004,.76659,.79004,1.09231,.54873,.8675,.9245,.76318,.84843,.84557,.86651,1,1,.79776,1.20562,1.18622,1.18622,1,1.1437,.67009,.96334,.93695,1.35191,1.40909,.95161,1.48387,.8675,.90861,.6192,.7363,.64824,.82411,.56321,.85696,1.23516,.8675,.81552,.7286,.84134,.73206,.76659,.86275,.84369,.90685,.77892,.85871,1.02638,.89249,.75828,.84118,.85984,.77452,.76466,.79776,.7306,.90782,.77818,.903,.87291,.90685,.7306,.99058,1.03667,.94635,1.23516,.9849,.99058,.92393,.8916,.942,1.03667,.75026,.94635,1.0297,1.23516,.90918,.94048,.98217,.89746,.84153,.92274,.82507,.88832,.84438,.88178,1.03525,.9849,1.00225,.78086,.97248,.89404,1.23516,.9849,.92274,.9849,.89404,.73206,1,1,1,1,1,1,1,1,1,1,1,1,.89693,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.85865,1,1,1,1,1,1,1,1,1,1,1,1,.90933,1,1,1,1,1,1,.94309,.98986,.94309,.98986,.94309,.98986,.7306,.89453,1,1,.89552,.90527,1,.90186,1.12308,1.12308,1.12308,1.12308,1.2566,1.2566,1.2566,.89552,.89552,1.42259,.68994,1.03809,1,1,1.0176,1.0176,1.11523,1.4956,2.01462,.97858,.82616,.91133,.83437,.91133,1,1,1,.70508,1,1.23108,.79801,.84426,.84426,.774,.90572,1.81055,.90749,1.81055,1.28809,1.55469,.94434,1.07806,1,.97094,.7589,.85284,.90747,1.19658,.69825,.97622,1.33512,.90747,.90747,.85284,.90747,.90747,1.44947,.85284,.8941,.8941,.70572,.8,.70572,.70572,.70572,.70572,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.99862,.99862,1,1,1,1,1,1.0336,.91027,1,1,1,.99862,1,1,1,1,1,1,1,1,1,1,1,1,1.05859,1.05859,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.CalibriItalicMetrics={lineHeight:1.2207,lineGap:.2207};t.CalibriRegularFactors=[1.3877,1,1,1,1.17223,1.1293,.89552,.91133,.80395,1.02269,1.15601,.91056,.91056,1.2798,.85284,.89807,1,.90861,1.39016,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.96309,.96309,.85284,.85284,.85284,.83319,.88071,.8675,.81552,.73834,.85193,.73206,.7522,.81105,.86275,.90685,.6377,.77892,.75593,1.02638,.89385,.85122,.77452,.86503,.75186,.68887,.79776,.88844,.85066,.94258,.77818,.7306,.76659,1.10369,1.39016,1.10369,1.06139,.89552,.8739,.86128,.94469,.8457,.94469,.89464,1.09842,.84636,.94469,1.03297,1.07692,.90918,1.03297,.95897,.94469,.9482,.94469,.94469,1.04692,.78223,1.20562,.94469,.90332,.98986,.86621,.90527,.79004,.94152,1.77256,.94152,.85284,.97801,.89552,.91133,.89552,.91133,1.91729,.89552,1.17889,1.13254,1.08707,.92098,.85284,.68787,.71353,.84737,.90747,1.0088,1.0044,.87683,1,1.09091,1,.92229,.739,1.15642,.92098,.76288,.80504,.80972,.75859,.8675,.8675,.8675,.8675,.8675,.8675,.76318,.73834,.73206,.73206,.73206,.73206,.90685,.90685,.90685,.90685,.86477,.89385,.85122,.85122,.85122,.85122,.85122,.85284,.85311,.88844,.88844,.88844,.88844,.7306,.77452,.86331,.86128,.86128,.86128,.86128,.86128,.86128,.8693,.8457,.89464,.89464,.89464,.89464,.82601,.82601,.82601,.82601,.94469,.94469,.9482,.9482,.9482,.9482,.9482,.90747,.86651,.94469,.94469,.94469,.94469,.90527,.94469,.90527,.8675,.86128,.8675,.86128,.8675,.86128,.73834,.8457,.73834,.8457,.73834,.8457,.73834,.8457,.85193,.92454,.86477,.9921,.73206,.89464,.73206,.89464,.73206,.89464,.73206,.89464,.73206,.89464,.81105,.84636,.81105,.84636,.81105,.84636,1,1,.86275,.94469,.90872,.95786,.90685,.82601,.90685,.82601,.90685,.82601,.90685,1.03297,.90685,.82601,.77741,1.05611,.6377,1.07692,1,1,.90918,.75593,1.03297,1,1,.76032,.90452,.98156,1.11842,.77261,1.11429,.89385,.94469,1,1,.89385,.94469,.95877,.86901,.94469,.85122,.9482,.85122,.9482,.85122,.9482,.8667,.90016,.75186,1.04692,1,1,.75186,1.04692,.68887,.78223,.68887,.78223,.68887,.78223,.68887,.78223,1,1,.79776,.92188,.79776,1.23023,.88844,.94469,.88844,.94469,.88844,.94469,.88844,.94469,.88844,.94469,.88844,.94469,.94258,.98986,.7306,.90527,.7306,.76659,.79004,.76659,.79004,.76659,.79004,1.09231,.54873,.8675,.86128,.76318,.8693,.85311,.86651,1,1,.79776,1.20562,1.18622,1.18622,1,1.1437,.67742,.96334,.93695,1.35191,1.40909,.95161,1.48387,.86686,.90861,.62267,.74359,.65649,.85498,.56963,.88254,1.23516,.8675,.81552,.75443,.84503,.73206,.76659,.86275,.85122,.90685,.77892,.85746,1.02638,.89385,.75657,.85122,.86275,.77452,.74171,.79776,.7306,.95165,.77818,.89772,.88831,.90685,.7306,.98142,1.02191,.96576,1.23516,.99018,.98142,.9236,.89258,.94035,1.02191,.78848,.96576,.9561,1.23516,.90918,.92578,.95424,.89746,.83969,.9482,.80113,.89442,.85208,.86155,.98022,.99018,1.00452,.81209,.99247,.89181,1.23516,.99018,.9482,.99018,.89181,.73206,1,1,1,1,1,1,1,1,1,1,1,1,.88844,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.89464,1,1,1,1,1,1,1,1,1,1,1,1,.96766,1,1,1,1,1,1,.94258,.98986,.94258,.98986,.94258,.98986,.7306,.90527,1,1,.89552,.90527,1,.90186,1.12308,1.12308,1.12308,1.12308,1.2566,1.2566,1.2566,.89552,.89552,1.42259,.69043,1.03809,1,1,1.0176,1.0176,1.11523,1.4956,2.01462,.99331,.82616,.91133,.84286,.91133,1,1,1,.70508,1,1.23108,.79801,.84426,.84426,.774,.90527,1.81055,.90527,1.81055,1.28809,1.55469,.94434,1.07806,1,.97094,.7589,.85284,.90747,1.19658,.69825,.97622,1.33512,.90747,.90747,.85356,.90747,.90747,1.44947,.85284,.8941,.8941,.70572,.8,.70572,.70572,.70572,.70572,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.99862,.99862,1,1,1,1,1,1.0336,.91027,1,1,1,.99862,1,1,1,1,1,1,1,1,1,1,1,1,1.05859,1.05859,1,1,1,1.07185,.99413,.96334,1.08065,1,1,1,1,1,1,1,1,1,1,1];t.CalibriRegularMetrics={lineHeight:1.2207,lineGap:.2207}},(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.HelveticaRegularMetrics=t.HelveticaRegularFactors=t.HelveticaItalicMetrics=t.HelveticaItalicFactors=t.HelveticaBoldMetrics=t.HelveticaBoldItalicMetrics=t.HelveticaBoldItalicFactors=t.HelveticaBoldFactors=void 0;t.HelveticaBoldFactors=[.76116,1,1,1.0006,.99998,.99974,.99973,.99973,.99982,.99977,1.00087,.99998,.99998,.99959,1.00003,1.0006,.99998,1.0006,1.0006,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99998,1,1.00003,1.00003,1.00003,1.00026,.9999,.99977,.99977,.99977,.99977,1.00001,1.00026,1.00022,.99977,1.0006,.99973,.99977,1.00026,.99999,.99977,1.00022,1.00001,1.00022,.99977,1.00001,1.00026,.99977,1.00001,1.00016,1.00001,1.00001,1.00026,.99998,1.0006,.99998,1.00003,.99973,.99998,.99973,1.00026,.99973,1.00026,.99973,.99998,1.00026,1.00026,1.0006,1.0006,.99973,1.0006,.99982,1.00026,1.00026,1.00026,1.00026,.99959,.99973,.99998,1.00026,.99973,1.00022,.99973,.99973,1,.99959,1.00077,.99959,1.00003,.99998,.99973,.99973,.99973,.99973,1.00077,.99973,.99998,1.00025,.99968,.99973,1.00003,1.00025,.60299,1.00024,1.06409,1,1,.99998,1,.99973,1.0006,.99998,1,.99936,.99973,1.00002,1.00002,1.00002,1.00026,.99977,.99977,.99977,.99977,.99977,.99977,1,.99977,1.00001,1.00001,1.00001,1.00001,1.0006,1.0006,1.0006,1.0006,.99977,.99977,1.00022,1.00022,1.00022,1.00022,1.00022,1.00003,1.00022,.99977,.99977,.99977,.99977,1.00001,1.00001,1.00026,.99973,.99973,.99973,.99973,.99973,.99973,.99982,.99973,.99973,.99973,.99973,.99973,1.0006,1.0006,1.0006,1.0006,1.00026,1.00026,1.00026,1.00026,1.00026,1.00026,1.00026,1.06409,1.00026,1.00026,1.00026,1.00026,1.00026,.99973,1.00026,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,1.03374,.99977,1.00026,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00022,1.00026,1.00022,1.00026,1.00022,1.00026,1.00022,1.00026,.99977,1.00026,.99977,1.00026,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.00042,.99973,.99973,1.0006,.99977,.99973,.99973,1.00026,1.0006,1.00026,1.0006,1.00026,1.03828,1.00026,.99999,1.00026,1.0006,.99977,1.00026,.99977,1.00026,.99977,1.00026,.9993,.9998,1.00026,1.00022,1.00026,1.00022,1.00026,1.00022,1.00026,1,1.00016,.99977,.99959,.99977,.99959,.99977,.99959,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00026,.99998,1.00026,.8121,1.00026,.99998,.99977,1.00026,.99977,1.00026,.99977,1.00026,.99977,1.00026,.99977,1.00026,.99977,1.00026,1.00016,1.00022,1.00001,.99973,1.00001,1.00026,1,1.00026,1,1.00026,1,1.0006,.99973,.99977,.99973,1,.99982,1.00022,1.00026,1.00001,.99973,1.00026,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,1.00034,.99977,1,.99997,1.00026,1.00078,1.00036,.99973,1.00013,1.0006,.99977,.99977,.99988,.85148,1.00001,1.00026,.99977,1.00022,1.0006,.99977,1.00001,.99999,.99977,1.00069,1.00022,.99977,1.00001,.99984,1.00026,1.00001,1.00024,1.00001,.9999,1,1.0006,1.00001,1.00041,.99962,1.00026,1.0006,.99995,1.00041,.99942,.99973,.99927,1.00082,.99902,1.00026,1.00087,1.0006,1.00069,.99973,.99867,.99973,.9993,1.00026,1.00049,1.00056,1,.99988,.99935,.99995,.99954,1.00055,.99945,1.00032,1.0006,.99995,1.00026,.99995,1.00032,1.00001,1.00008,.99971,1.00019,.9994,1.00001,1.0006,1.00044,.99973,1.00023,1.00047,1,.99942,.99561,.99989,1.00035,.99977,1.00035,.99977,1.00019,.99944,1.00001,1.00021,.99926,1.00035,1.00035,.99942,1.00048,.99999,.99977,1.00022,1.00035,1.00001,.99977,1.00026,.99989,1.00057,1.00001,.99936,1.00052,1.00012,.99996,1.00043,1,1.00035,.9994,.99976,1.00035,.99973,1.00052,1.00041,1.00119,1.00037,.99973,1.00002,.99986,1.00041,1.00041,.99902,.9996,1.00034,.99999,1.00026,.99999,1.00026,.99973,1.00052,.99973,1,.99973,1.00041,1.00075,.9994,1.0003,.99999,1,1.00041,.99955,1,.99915,.99973,.99973,1.00026,1.00119,.99955,.99973,1.0006,.99911,1.0006,1.00026,.99972,1.00026,.99902,1.00041,.99973,.99999,1,1,1.00038,1.0005,1.00016,1.00022,1.00016,1.00022,1.00016,1.00022,1.00001,.99973,1,1,.99973,1,1,.99955,1.0006,1.0006,1.0006,1.0006,1,1,1,.99973,.99973,.99972,1,1,1.00106,.99999,.99998,.99998,.99999,.99998,1.66475,1,.99973,.99973,1.00023,.99973,.99971,1.00047,1.00023,1,.99991,.99984,1.00002,1.00002,1.00002,1.00002,1,1,1,1,1,1,1,.99972,1,1.20985,1.39713,1.00003,1.00031,1.00015,1,.99561,1.00027,1.00031,1.00031,.99915,1.00031,1.00031,.99999,1.00003,.99999,.99999,1.41144,1.6,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.40579,1.40579,1.36625,.99999,1,.99861,.99861,1,1.00026,1.00026,1.00026,1.00026,.99972,.99999,.99999,.99999,.99999,1.40483,1,.99977,1.00054,1,1,.99953,.99962,1.00042,.9995,1,1,1,1,1,1,1,1,.99998,.99998,.99998,.99998,1,1,1,1,1,1,1,1,1,1,1];t.HelveticaBoldMetrics={lineHeight:1.2,lineGap:.2};t.HelveticaBoldItalicFactors=[.76116,1,1,1.0006,.99998,.99974,.99973,.99973,.99982,.99977,1.00087,.99998,.99998,.99959,1.00003,1.0006,.99998,1.0006,1.0006,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99998,1,1.00003,1.00003,1.00003,1.00026,.9999,.99977,.99977,.99977,.99977,1.00001,1.00026,1.00022,.99977,1.0006,.99973,.99977,1.00026,.99999,.99977,1.00022,1.00001,1.00022,.99977,1.00001,1.00026,.99977,1.00001,1.00016,1.00001,1.00001,1.00026,.99998,1.0006,.99998,1.00003,.99973,.99998,.99973,1.00026,.99973,1.00026,.99973,.99998,1.00026,1.00026,1.0006,1.0006,.99973,1.0006,.99982,1.00026,1.00026,1.00026,1.00026,.99959,.99973,.99998,1.00026,.99973,1.00022,.99973,.99973,1,.99959,1.00077,.99959,1.00003,.99998,.99973,.99973,.99973,.99973,1.00077,.99973,.99998,1.00025,.99968,.99973,1.00003,1.00025,.60299,1.00024,1.06409,1,1,.99998,1,.99973,1.0006,.99998,1,.99936,.99973,1.00002,1.00002,1.00002,1.00026,.99977,.99977,.99977,.99977,.99977,.99977,1,.99977,1.00001,1.00001,1.00001,1.00001,1.0006,1.0006,1.0006,1.0006,.99977,.99977,1.00022,1.00022,1.00022,1.00022,1.00022,1.00003,1.00022,.99977,.99977,.99977,.99977,1.00001,1.00001,1.00026,.99973,.99973,.99973,.99973,.99973,.99973,.99982,.99973,.99973,.99973,.99973,.99973,1.0006,1.0006,1.0006,1.0006,1.00026,1.00026,1.00026,1.00026,1.00026,1.00026,1.00026,1.06409,1.00026,1.00026,1.00026,1.00026,1.00026,.99973,1.00026,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,1.0044,.99977,1.00026,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00022,1.00026,1.00022,1.00026,1.00022,1.00026,1.00022,1.00026,.99977,1.00026,.99977,1.00026,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,.99971,.99973,.99973,1.0006,.99977,.99973,.99973,1.00026,1.0006,1.00026,1.0006,1.00026,1.01011,1.00026,.99999,1.00026,1.0006,.99977,1.00026,.99977,1.00026,.99977,1.00026,.9993,.9998,1.00026,1.00022,1.00026,1.00022,1.00026,1.00022,1.00026,1,1.00016,.99977,.99959,.99977,.99959,.99977,.99959,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00026,.99998,1.00026,.8121,1.00026,.99998,.99977,1.00026,.99977,1.00026,.99977,1.00026,.99977,1.00026,.99977,1.00026,.99977,1.00026,1.00016,1.00022,1.00001,.99973,1.00001,1.00026,1,1.00026,1,1.00026,1,1.0006,.99973,.99977,.99973,1,.99982,1.00022,1.00026,1.00001,.99973,1.00026,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99977,1,1,1.00026,.99969,.99972,.99981,.9998,1.0006,.99977,.99977,1.00022,.91155,1.00001,1.00026,.99977,1.00022,1.0006,.99977,1.00001,.99999,.99977,.99966,1.00022,1.00032,1.00001,.99944,1.00026,1.00001,.99968,1.00001,1.00047,1,1.0006,1.00001,.99981,1.00101,1.00026,1.0006,.99948,.99981,1.00064,.99973,.99942,1.00101,1.00061,1.00026,1.00069,1.0006,1.00014,.99973,1.01322,.99973,1.00065,1.00026,1.00012,.99923,1,1.00064,1.00076,.99948,1.00055,1.00063,1.00007,.99943,1.0006,.99948,1.00026,.99948,.99943,1.00001,1.00001,1.00029,1.00038,1.00035,1.00001,1.0006,1.0006,.99973,.99978,1.00001,1.00057,.99989,.99967,.99964,.99967,.99977,.99999,.99977,1.00038,.99977,1.00001,.99973,1.00066,.99967,.99967,1.00041,.99998,.99999,.99977,1.00022,.99967,1.00001,.99977,1.00026,.99964,1.00031,1.00001,.99999,.99999,1,1.00023,1,1,.99999,1.00035,1.00001,.99999,.99973,.99977,.99999,1.00058,.99973,.99973,.99955,.9995,1.00026,1.00026,1.00032,.99989,1.00034,.99999,1.00026,1.00026,1.00026,.99973,.45998,.99973,1.00026,.99973,1.00001,.99999,.99982,.99994,.99996,1,1.00042,1.00044,1.00029,1.00023,.99973,.99973,1.00026,.99949,1.00002,.99973,1.0006,1.0006,1.0006,.99975,1.00026,1.00026,1.00032,.98685,.99973,1.00026,1,1,.99966,1.00044,1.00016,1.00022,1.00016,1.00022,1.00016,1.00022,1.00001,.99973,1,1,.99973,1,1,.99955,1.0006,1.0006,1.0006,1.0006,1,1,1,.99973,.99973,.99972,1,1,1.00106,.99999,.99998,.99998,.99999,.99998,1.66475,1,.99973,.99973,1,.99973,.99971,.99978,1,1,.99991,.99984,1.00002,1.00002,1.00002,1.00002,1.00098,1,1,1,1.00049,1,1,.99972,1,1.20985,1.39713,1.00003,1.00031,1.00015,1,.99561,1.00027,1.00031,1.00031,.99915,1.00031,1.00031,.99999,1.00003,.99999,.99999,1.41144,1.6,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.40579,1.40579,1.36625,.99999,1,.99861,.99861,1,1.00026,1.00026,1.00026,1.00026,.99972,.99999,.99999,.99999,.99999,1.40483,1,.99977,1.00054,1,1,.99953,.99962,1.00042,.9995,1,1,1,1,1,1,1,1,.99998,.99998,.99998,.99998,1,1,1,1,1,1,1,1,1,1,1];t.HelveticaBoldItalicMetrics={lineHeight:1.35,lineGap:.2};t.HelveticaItalicFactors=[.76116,1,1,1.0006,1.0006,1.00006,.99973,.99973,.99982,1.00001,1.00043,.99998,.99998,.99959,1.00003,1.0006,.99998,1.0006,1.0006,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,1.0006,1,1.00003,1.00003,1.00003,.99973,.99987,1.00001,1.00001,.99977,.99977,1.00001,1.00026,1.00022,.99977,1.0006,1,1.00001,.99973,.99999,.99977,1.00022,1.00001,1.00022,.99977,1.00001,1.00026,.99977,1.00001,1.00016,1.00001,1.00001,1.00026,1.0006,1.0006,1.0006,.99949,.99973,.99998,.99973,.99973,1,.99973,.99973,1.0006,.99973,.99973,.99924,.99924,1,.99924,.99999,.99973,.99973,.99973,.99973,.99998,1,1.0006,.99973,1,.99977,1,1,1,1.00005,1.0009,1.00005,1.00003,.99998,.99973,.99973,.99973,.99973,1.0009,.99973,.99998,1.00025,.99968,.99973,1.00003,1.00025,.60299,1.00024,1.06409,1,1,.99998,1,.9998,1.0006,.99998,1,.99936,.99973,1.00002,1.00002,1.00002,1.00026,1.00001,1.00001,1.00001,1.00001,1.00001,1.00001,1,.99977,1.00001,1.00001,1.00001,1.00001,1.0006,1.0006,1.0006,1.0006,.99977,.99977,1.00022,1.00022,1.00022,1.00022,1.00022,1.00003,1.00022,.99977,.99977,.99977,.99977,1.00001,1.00001,1.00026,.99973,.99973,.99973,.99973,.99973,.99973,.99982,1,.99973,.99973,.99973,.99973,1.0006,1.0006,1.0006,1.0006,.99973,.99973,.99973,.99973,.99973,.99973,.99973,1.06409,1.00026,.99973,.99973,.99973,.99973,1,.99973,1,1.00001,.99973,1.00001,.99973,1.00001,.99973,.99977,1,.99977,1,.99977,1,.99977,1,.99977,1.0288,.99977,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00022,.99973,1.00022,.99973,1.00022,.99973,1.00022,.99973,.99977,.99973,.99977,.99973,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,.99924,1.0006,1.0006,.99946,1.00034,1,.99924,1.00001,1,1,.99973,.99924,.99973,.99924,.99973,1.06311,.99973,1.00024,.99973,.99924,.99977,.99973,.99977,.99973,.99977,.99973,1.00041,.9998,.99973,1.00022,.99973,1.00022,.99973,1.00022,.99973,1,1.00016,.99977,.99998,.99977,.99998,.99977,.99998,1.00001,1,1.00001,1,1.00001,1,1.00001,1,1.00026,1.0006,1.00026,.89547,1.00026,1.0006,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,1.00016,.99977,1.00001,1,1.00001,1.00026,1,1.00026,1,1.00026,1,.99924,.99973,1.00001,.99973,1,.99982,1.00022,1.00026,1.00001,1,1.00026,1.0006,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,1.00001,1,1.00054,.99977,1.00084,1.00007,.99973,1.00013,.99924,1.00001,1.00001,.99945,.91221,1.00001,1.00026,.99977,1.00022,1.0006,1.00001,1.00001,.99999,.99977,.99933,1.00022,1.00054,1.00001,1.00065,1.00026,1.00001,1.0001,1.00001,1.00052,1,1.0006,1.00001,.99945,.99897,.99968,.99924,1.00036,.99945,.99949,1,1.0006,.99897,.99918,.99968,.99911,.99924,1,.99962,1.01487,1,1.0005,.99973,1.00012,1.00043,1,.99995,.99994,1.00036,.99947,1.00019,1.00063,1.00025,.99924,1.00036,.99973,1.00036,1.00025,1.00001,1.00001,1.00027,1.0001,1.00068,1.00001,1.0006,1.0006,1,1.00008,.99957,.99972,.9994,.99954,.99975,1.00051,1.00001,1.00019,1.00001,1.0001,.99986,1.00001,1.00001,1.00038,.99954,.99954,.9994,1.00066,.99999,.99977,1.00022,1.00054,1.00001,.99977,1.00026,.99975,1.0001,1.00001,.99993,.9995,.99955,1.00016,.99978,.99974,1.00019,1.00022,.99955,1.00053,.99973,1.00089,1.00005,.99967,1.00048,.99973,1.00002,1.00034,.99973,.99973,.99964,1.00006,1.00066,.99947,.99973,.98894,.99973,1,.44898,1,.99946,1,1.00039,1.00082,.99991,.99991,.99985,1.00022,1.00023,1.00061,1.00006,.99966,.99973,.99973,.99973,1.00019,1.0008,1,.99924,.99924,.99924,.99983,1.00044,.99973,.99964,.98332,1,.99973,1,1,.99962,.99895,1.00016,.99977,1.00016,.99977,1.00016,.99977,1.00001,1,1,1,.99973,1,1,.99955,.99924,.99924,.99924,.99924,.99998,.99998,.99998,.99973,.99973,.99972,1,1,1.00267,.99999,.99998,.99998,1,.99998,1.66475,1,.99973,.99973,1.00023,.99973,1.00423,.99925,.99999,1,.99991,.99984,1.00002,1.00002,1.00002,1.00002,1.00049,1,1.00245,1,1,1,1,.96329,1,1.20985,1.39713,1.00003,.8254,1.00015,1,1.00035,1.00027,1.00031,1.00031,1.00003,1.00031,1.00031,.99999,1.00003,.99999,.99999,1.41144,1.6,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.40579,1.40579,1.36625,.99999,1,.99861,.99861,1,1.00026,1.00026,1.00026,1.00026,.95317,.99999,.99999,.99999,.99999,1.40483,1,.99977,1.00054,1,1,.99953,.99962,1.00042,.9995,1,1,1,1,1,1,1,1,.99998,.99998,.99998,.99998,1,1,1,1,1,1,1,1,1,1,1];t.HelveticaItalicMetrics={lineHeight:1.35,lineGap:.2};t.HelveticaRegularFactors=[.76116,1,1,1.0006,1.0006,1.00006,.99973,.99973,.99982,1.00001,1.00043,.99998,.99998,.99959,1.00003,1.0006,.99998,1.0006,1.0006,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,1.0006,1,1.00003,1.00003,1.00003,.99973,.99987,1.00001,1.00001,.99977,.99977,1.00001,1.00026,1.00022,.99977,1.0006,1,1.00001,.99973,.99999,.99977,1.00022,1.00001,1.00022,.99977,1.00001,1.00026,.99977,1.00001,1.00016,1.00001,1.00001,1.00026,1.0006,1.0006,1.0006,.99949,.99973,.99998,.99973,.99973,1,.99973,.99973,1.0006,.99973,.99973,.99924,.99924,1,.99924,.99999,.99973,.99973,.99973,.99973,.99998,1,1.0006,.99973,1,.99977,1,1,1,1.00005,1.0009,1.00005,1.00003,.99998,.99973,.99973,.99973,.99973,1.0009,.99973,.99998,1.00025,.99968,.99973,1.00003,1.00025,.60299,1.00024,1.06409,1,1,.99998,1,.9998,1.0006,.99998,1,.99936,.99973,1.00002,1.00002,1.00002,1.00026,1.00001,1.00001,1.00001,1.00001,1.00001,1.00001,1,.99977,1.00001,1.00001,1.00001,1.00001,1.0006,1.0006,1.0006,1.0006,.99977,.99977,1.00022,1.00022,1.00022,1.00022,1.00022,1.00003,1.00022,.99977,.99977,.99977,.99977,1.00001,1.00001,1.00026,.99973,.99973,.99973,.99973,.99973,.99973,.99982,1,.99973,.99973,.99973,.99973,1.0006,1.0006,1.0006,1.0006,.99973,.99973,.99973,.99973,.99973,.99973,.99973,1.06409,1.00026,.99973,.99973,.99973,.99973,1,.99973,1,1.00001,.99973,1.00001,.99973,1.00001,.99973,.99977,1,.99977,1,.99977,1,.99977,1,.99977,1.04596,.99977,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00022,.99973,1.00022,.99973,1.00022,.99973,1.00022,.99973,.99977,.99973,.99977,.99973,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,.99924,1.0006,1.0006,1.00019,1.00034,1,.99924,1.00001,1,1,.99973,.99924,.99973,.99924,.99973,1.02572,.99973,1.00005,.99973,.99924,.99977,.99973,.99977,.99973,.99977,.99973,.99999,.9998,.99973,1.00022,.99973,1.00022,.99973,1.00022,.99973,1,1.00016,.99977,.99998,.99977,.99998,.99977,.99998,1.00001,1,1.00001,1,1.00001,1,1.00001,1,1.00026,1.0006,1.00026,.84533,1.00026,1.0006,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,1.00016,.99977,1.00001,1,1.00001,1.00026,1,1.00026,1,1.00026,1,.99924,.99973,1.00001,.99973,1,.99982,1.00022,1.00026,1.00001,1,1.00026,1.0006,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99928,1,.99977,1.00013,1.00055,.99947,.99945,.99941,.99924,1.00001,1.00001,1.0004,.91621,1.00001,1.00026,.99977,1.00022,1.0006,1.00001,1.00005,.99999,.99977,1.00015,1.00022,.99977,1.00001,.99973,1.00026,1.00001,1.00019,1.00001,.99946,1,1.0006,1.00001,.99978,1.00045,.99973,.99924,1.00023,.99978,.99966,1,1.00065,1.00045,1.00019,.99973,.99973,.99924,1,1,.96499,1,1.00055,.99973,1.00008,1.00027,1,.9997,.99995,1.00023,.99933,1.00019,1.00015,1.00031,.99924,1.00023,.99973,1.00023,1.00031,1.00001,.99928,1.00029,1.00092,1.00035,1.00001,1.0006,1.0006,1,.99988,.99975,1,1.00082,.99561,.9996,1.00035,1.00001,.99962,1.00001,1.00092,.99964,1.00001,.99963,.99999,1.00035,1.00035,1.00082,.99962,.99999,.99977,1.00022,1.00035,1.00001,.99977,1.00026,.9996,.99967,1.00001,1.00034,1.00074,1.00054,1.00053,1.00063,.99971,.99962,1.00035,.99975,.99977,.99973,1.00043,.99953,1.0007,.99915,.99973,1.00008,.99892,1.00073,1.00073,1.00114,.99915,1.00073,.99955,.99973,1.00092,.99973,1,.99998,1,1.0003,1,1.00043,1.00001,.99969,1.0003,1,1.00035,1.00001,.9995,1,1.00092,.99973,.99973,.99973,1.0007,.9995,1,.99924,1.0006,.99924,.99972,1.00062,.99973,1.00114,1.00073,1,.99955,1,1,1.00047,.99968,1.00016,.99977,1.00016,.99977,1.00016,.99977,1.00001,1,1,1,.99973,1,1,.99955,.99924,.99924,.99924,.99924,.99998,.99998,.99998,.99973,.99973,.99972,1,1,1.00267,.99999,.99998,.99998,1,.99998,1.66475,1,.99973,.99973,1.00023,.99973,.99971,.99925,1.00023,1,.99991,.99984,1.00002,1.00002,1.00002,1.00002,1,1,1,1,1,1,1,.96329,1,1.20985,1.39713,1.00003,.8254,1.00015,1,1.00035,1.00027,1.00031,1.00031,.99915,1.00031,1.00031,.99999,1.00003,.99999,.99999,1.41144,1.6,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.40579,1.40579,1.36625,.99999,1,.99861,.99861,1,1.00026,1.00026,1.00026,1.00026,.95317,.99999,.99999,.99999,.99999,1.40483,1,.99977,1.00054,1,1,.99953,.99962,1.00042,.9995,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.HelveticaRegularMetrics={lineHeight:1.2,lineGap:.2}},(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.LiberationSansRegularWidths=t.LiberationSansRegularMapping=t.LiberationSansItalicWidths=t.LiberationSansItalicMapping=t.LiberationSansBoldWidths=t.LiberationSansBoldMapping=t.LiberationSansBoldItalicWidths=t.LiberationSansBoldItalicMapping=void 0;t.LiberationSansBoldWidths=[365,0,333,278,333,474,556,556,889,722,238,333,333,389,584,278,333,278,278,556,556,556,556,556,556,556,556,556,556,333,333,584,584,584,611,975,722,722,722,722,667,611,778,722,278,556,722,611,833,722,778,667,778,722,667,611,722,667,944,667,667,611,333,278,333,584,556,333,556,611,556,611,556,333,611,611,278,278,556,278,889,611,611,611,611,389,556,333,611,556,778,556,556,500,389,280,389,584,333,556,556,556,556,280,556,333,737,370,556,584,737,552,400,549,333,333,333,576,556,278,333,333,365,556,834,834,834,611,722,722,722,722,722,722,1e3,722,667,667,667,667,278,278,278,278,722,722,778,778,778,778,778,584,778,722,722,722,722,667,667,611,556,556,556,556,556,556,889,556,556,556,556,556,278,278,278,278,611,611,611,611,611,611,611,549,611,611,611,611,611,556,611,556,722,556,722,556,722,556,722,556,722,556,722,556,722,556,722,719,722,611,667,556,667,556,667,556,667,556,667,556,778,611,778,611,778,611,778,611,722,611,722,611,278,278,278,278,278,278,278,278,278,278,785,556,556,278,722,556,556,611,278,611,278,611,385,611,479,611,278,722,611,722,611,722,611,708,723,611,778,611,778,611,778,611,1e3,944,722,389,722,389,722,389,667,556,667,556,667,556,667,556,611,333,611,479,611,333,722,611,722,611,722,611,722,611,722,611,722,611,944,778,667,556,667,611,500,611,500,611,500,278,556,722,556,1e3,889,778,611,667,556,611,333,333,333,333,333,333,333,333,333,333,333,465,722,333,853,906,474,825,927,838,278,722,722,601,719,667,611,722,778,278,722,667,833,722,644,778,722,667,600,611,667,821,667,809,802,278,667,615,451,611,278,582,615,610,556,606,475,460,611,541,278,558,556,612,556,445,611,766,619,520,684,446,582,715,576,753,845,278,582,611,582,845,667,669,885,567,711,667,278,276,556,1094,1062,875,610,722,622,719,722,719,722,567,712,667,904,626,719,719,610,702,833,722,778,719,667,722,611,622,854,667,730,703,1005,1019,870,979,719,711,1031,719,556,618,615,417,635,556,709,497,615,615,500,635,740,604,611,604,611,556,490,556,875,556,615,581,833,844,729,854,615,552,854,583,556,556,611,417,552,556,278,281,278,969,906,611,500,615,556,604,778,611,487,447,944,778,944,778,944,778,667,556,333,333,556,1e3,1e3,552,278,278,278,278,500,500,500,556,556,350,1e3,1e3,240,479,333,333,604,333,167,396,556,556,1094,556,885,489,1115,1e3,768,600,834,834,834,834,1e3,500,1e3,500,1e3,500,500,494,612,823,713,584,549,713,979,722,274,549,549,583,549,549,604,584,604,604,708,625,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,729,604,604,354,354,1e3,990,990,990,990,494,604,604,604,604,354,1021,1052,917,750,750,531,656,594,510,500,750,750,611,611,333,333,333,333,333,333,333,333,222,222,333,333,333,333,333,333,333,333];t.LiberationSansBoldMapping=[-1,-1,-1,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,161,162,163,164,165,166,167,168,169,170,171,172,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,402,506,507,508,509,510,511,536,537,538,539,710,711,713,728,729,730,731,732,733,900,901,902,903,904,905,906,908,910,911,912,913,914,915,916,917,918,919,920,921,922,923,924,925,926,927,928,929,931,932,933,934,935,936,937,938,939,940,941,942,943,944,945,946,947,948,949,950,951,952,953,954,955,956,957,958,959,960,961,962,963,964,965,966,967,968,969,970,971,972,973,974,1024,1025,1026,1027,1028,1029,1030,1031,1032,1033,1034,1035,1036,1037,1038,1039,1040,1041,1042,1043,1044,1045,1046,1047,1048,1049,1050,1051,1052,1053,1054,1055,1056,1057,1058,1059,1060,1061,1062,1063,1064,1065,1066,1067,1068,1069,1070,1071,1072,1073,1074,1075,1076,1077,1078,1079,1080,1081,1082,1083,1084,1085,1086,1087,1088,1089,1090,1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,1103,1104,1105,1106,1107,1108,1109,1110,1111,1112,1113,1114,1115,1116,1117,1118,1119,1138,1139,1168,1169,7808,7809,7810,7811,7812,7813,7922,7923,8208,8209,8211,8212,8213,8215,8216,8217,8218,8219,8220,8221,8222,8224,8225,8226,8230,8240,8242,8243,8249,8250,8252,8254,8260,8319,8355,8356,8359,8364,8453,8467,8470,8482,8486,8494,8539,8540,8541,8542,8592,8593,8594,8595,8596,8597,8616,8706,8710,8719,8721,8722,8730,8734,8735,8745,8747,8776,8800,8801,8804,8805,8962,8976,8992,8993,9472,9474,9484,9488,9492,9496,9500,9508,9516,9524,9532,9552,9553,9554,9555,9556,9557,9558,9559,9560,9561,9562,9563,9564,9565,9566,9567,9568,9569,9570,9571,9572,9573,9574,9575,9576,9577,9578,9579,9580,9600,9604,9608,9612,9616,9617,9618,9619,9632,9633,9642,9643,9644,9650,9658,9660,9668,9674,9675,9679,9688,9689,9702,9786,9787,9788,9792,9794,9824,9827,9829,9830,9834,9835,9836,61441,61442,61445,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1];t.LiberationSansBoldItalicWidths=[365,0,333,278,333,474,556,556,889,722,238,333,333,389,584,278,333,278,278,556,556,556,556,556,556,556,556,556,556,333,333,584,584,584,611,975,722,722,722,722,667,611,778,722,278,556,722,611,833,722,778,667,778,722,667,611,722,667,944,667,667,611,333,278,333,584,556,333,556,611,556,611,556,333,611,611,278,278,556,278,889,611,611,611,611,389,556,333,611,556,778,556,556,500,389,280,389,584,333,556,556,556,556,280,556,333,737,370,556,584,737,552,400,549,333,333,333,576,556,278,333,333,365,556,834,834,834,611,722,722,722,722,722,722,1e3,722,667,667,667,667,278,278,278,278,722,722,778,778,778,778,778,584,778,722,722,722,722,667,667,611,556,556,556,556,556,556,889,556,556,556,556,556,278,278,278,278,611,611,611,611,611,611,611,549,611,611,611,611,611,556,611,556,722,556,722,556,722,556,722,556,722,556,722,556,722,556,722,740,722,611,667,556,667,556,667,556,667,556,667,556,778,611,778,611,778,611,778,611,722,611,722,611,278,278,278,278,278,278,278,278,278,278,782,556,556,278,722,556,556,611,278,611,278,611,396,611,479,611,278,722,611,722,611,722,611,708,723,611,778,611,778,611,778,611,1e3,944,722,389,722,389,722,389,667,556,667,556,667,556,667,556,611,333,611,479,611,333,722,611,722,611,722,611,722,611,722,611,722,611,944,778,667,556,667,611,500,611,500,611,500,278,556,722,556,1e3,889,778,611,667,556,611,333,333,333,333,333,333,333,333,333,333,333,333,722,333,854,906,473,844,930,847,278,722,722,610,671,667,611,722,778,278,722,667,833,722,657,778,718,667,590,611,667,822,667,829,781,278,667,620,479,611,278,591,620,621,556,610,479,492,611,558,278,566,556,603,556,450,611,712,605,532,664,409,591,704,578,773,834,278,591,611,591,834,667,667,886,614,719,667,278,278,556,1094,1042,854,622,719,677,719,722,708,722,614,722,667,927,643,719,719,615,687,833,722,778,719,667,722,611,677,781,667,729,708,979,989,854,1e3,708,719,1042,729,556,619,604,534,618,556,736,510,611,611,507,622,740,604,611,611,611,556,889,556,885,556,646,583,889,935,707,854,594,552,865,589,556,556,611,469,563,556,278,278,278,969,906,611,507,619,556,611,778,611,575,467,944,778,944,778,944,778,667,556,333,333,556,1e3,1e3,552,278,278,278,278,500,500,500,556,556,350,1e3,1e3,240,479,333,333,604,333,167,396,556,556,1104,556,885,516,1146,1e3,768,600,834,834,834,834,999,500,1e3,500,1e3,500,500,494,612,823,713,584,549,713,979,722,274,549,549,583,549,549,604,584,604,604,708,625,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,729,604,604,354,354,1e3,990,990,990,990,494,604,604,604,604,354,1021,1052,917,750,750,531,656,594,510,500,750,750,611,611,333,333,333,333,333,333,333,333,222,222,333,333,333,333,333,333,333,333];t.LiberationSansBoldItalicMapping=[-1,-1,-1,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,161,162,163,164,165,166,167,168,169,170,171,172,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,402,506,507,508,509,510,511,536,537,538,539,710,711,713,728,729,730,731,732,733,900,901,902,903,904,905,906,908,910,911,912,913,914,915,916,917,918,919,920,921,922,923,924,925,926,927,928,929,931,932,933,934,935,936,937,938,939,940,941,942,943,944,945,946,947,948,949,950,951,952,953,954,955,956,957,958,959,960,961,962,963,964,965,966,967,968,969,970,971,972,973,974,1024,1025,1026,1027,1028,1029,1030,1031,1032,1033,1034,1035,1036,1037,1038,1039,1040,1041,1042,1043,1044,1045,1046,1047,1048,1049,1050,1051,1052,1053,1054,1055,1056,1057,1058,1059,1060,1061,1062,1063,1064,1065,1066,1067,1068,1069,1070,1071,1072,1073,1074,1075,1076,1077,1078,1079,1080,1081,1082,1083,1084,1085,1086,1087,1088,1089,1090,1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,1103,1104,1105,1106,1107,1108,1109,1110,1111,1112,1113,1114,1115,1116,1117,1118,1119,1138,1139,1168,1169,7808,7809,7810,7811,7812,7813,7922,7923,8208,8209,8211,8212,8213,8215,8216,8217,8218,8219,8220,8221,8222,8224,8225,8226,8230,8240,8242,8243,8249,8250,8252,8254,8260,8319,8355,8356,8359,8364,8453,8467,8470,8482,8486,8494,8539,8540,8541,8542,8592,8593,8594,8595,8596,8597,8616,8706,8710,8719,8721,8722,8730,8734,8735,8745,8747,8776,8800,8801,8804,8805,8962,8976,8992,8993,9472,9474,9484,9488,9492,9496,9500,9508,9516,9524,9532,9552,9553,9554,9555,9556,9557,9558,9559,9560,9561,9562,9563,9564,9565,9566,9567,9568,9569,9570,9571,9572,9573,9574,9575,9576,9577,9578,9579,9580,9600,9604,9608,9612,9616,9617,9618,9619,9632,9633,9642,9643,9644,9650,9658,9660,9668,9674,9675,9679,9688,9689,9702,9786,9787,9788,9792,9794,9824,9827,9829,9830,9834,9835,9836,61441,61442,61445,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1];t.LiberationSansItalicWidths=[365,0,333,278,278,355,556,556,889,667,191,333,333,389,584,278,333,278,278,556,556,556,556,556,556,556,556,556,556,278,278,584,584,584,556,1015,667,667,722,722,667,611,778,722,278,500,667,556,833,722,778,667,778,722,667,611,722,667,944,667,667,611,278,278,278,469,556,333,556,556,500,556,556,278,556,556,222,222,500,222,833,556,556,556,556,333,500,278,556,500,722,500,500,500,334,260,334,584,333,556,556,556,556,260,556,333,737,370,556,584,737,552,400,549,333,333,333,576,537,278,333,333,365,556,834,834,834,611,667,667,667,667,667,667,1e3,722,667,667,667,667,278,278,278,278,722,722,778,778,778,778,778,584,778,722,722,722,722,667,667,611,556,556,556,556,556,556,889,500,556,556,556,556,278,278,278,278,556,556,556,556,556,556,556,549,611,556,556,556,556,500,556,500,667,556,667,556,667,556,722,500,722,500,722,500,722,500,722,625,722,556,667,556,667,556,667,556,667,556,667,556,778,556,778,556,778,556,778,556,722,556,722,556,278,278,278,278,278,278,278,222,278,278,733,444,500,222,667,500,500,556,222,556,222,556,281,556,400,556,222,722,556,722,556,722,556,615,723,556,778,556,778,556,778,556,1e3,944,722,333,722,333,722,333,667,500,667,500,667,500,667,500,611,278,611,354,611,278,722,556,722,556,722,556,722,556,722,556,722,556,944,722,667,500,667,611,500,611,500,611,500,222,556,667,556,1e3,889,778,611,667,500,611,278,333,333,333,333,333,333,333,333,333,333,333,667,278,789,846,389,794,865,775,222,667,667,570,671,667,611,722,778,278,667,667,833,722,648,778,725,667,600,611,667,837,667,831,761,278,667,570,439,555,222,550,570,571,500,556,439,463,555,542,222,500,492,548,500,447,556,670,573,486,603,374,550,652,546,728,779,222,550,556,550,779,667,667,843,544,708,667,278,278,500,1066,982,844,589,715,639,724,667,651,667,544,704,667,917,614,715,715,589,686,833,722,778,725,667,722,611,639,795,667,727,673,920,923,805,886,651,694,1022,682,556,562,522,493,553,556,688,465,556,556,472,564,686,550,556,556,556,500,833,500,835,500,572,518,830,851,621,736,526,492,752,534,556,556,556,378,496,500,222,222,222,910,828,556,472,565,500,556,778,556,492,339,944,722,944,722,944,722,667,500,333,333,556,1e3,1e3,552,222,222,222,222,333,333,333,556,556,350,1e3,1e3,188,354,333,333,500,333,167,365,556,556,1094,556,885,323,1083,1e3,768,600,834,834,834,834,1e3,500,998,500,1e3,500,500,494,612,823,713,584,549,713,979,719,274,549,549,584,549,549,604,584,604,604,708,625,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,729,604,604,354,354,1e3,990,990,990,990,494,604,604,604,604,354,1021,1052,917,750,750,531,656,594,510,500,750,750,500,500,333,333,333,333,333,333,333,333,222,222,294,294,324,324,316,328,398,285];t.LiberationSansItalicMapping=[-1,-1,-1,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,161,162,163,164,165,166,167,168,169,170,171,172,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,402,506,507,508,509,510,511,536,537,538,539,710,711,713,728,729,730,731,732,733,900,901,902,903,904,905,906,908,910,911,912,913,914,915,916,917,918,919,920,921,922,923,924,925,926,927,928,929,931,932,933,934,935,936,937,938,939,940,941,942,943,944,945,946,947,948,949,950,951,952,953,954,955,956,957,958,959,960,961,962,963,964,965,966,967,968,969,970,971,972,973,974,1024,1025,1026,1027,1028,1029,1030,1031,1032,1033,1034,1035,1036,1037,1038,1039,1040,1041,1042,1043,1044,1045,1046,1047,1048,1049,1050,1051,1052,1053,1054,1055,1056,1057,1058,1059,1060,1061,1062,1063,1064,1065,1066,1067,1068,1069,1070,1071,1072,1073,1074,1075,1076,1077,1078,1079,1080,1081,1082,1083,1084,1085,1086,1087,1088,1089,1090,1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,1103,1104,1105,1106,1107,1108,1109,1110,1111,1112,1113,1114,1115,1116,1117,1118,1119,1138,1139,1168,1169,7808,7809,7810,7811,7812,7813,7922,7923,8208,8209,8211,8212,8213,8215,8216,8217,8218,8219,8220,8221,8222,8224,8225,8226,8230,8240,8242,8243,8249,8250,8252,8254,8260,8319,8355,8356,8359,8364,8453,8467,8470,8482,8486,8494,8539,8540,8541,8542,8592,8593,8594,8595,8596,8597,8616,8706,8710,8719,8721,8722,8730,8734,8735,8745,8747,8776,8800,8801,8804,8805,8962,8976,8992,8993,9472,9474,9484,9488,9492,9496,9500,9508,9516,9524,9532,9552,9553,9554,9555,9556,9557,9558,9559,9560,9561,9562,9563,9564,9565,9566,9567,9568,9569,9570,9571,9572,9573,9574,9575,9576,9577,9578,9579,9580,9600,9604,9608,9612,9616,9617,9618,9619,9632,9633,9642,9643,9644,9650,9658,9660,9668,9674,9675,9679,9688,9689,9702,9786,9787,9788,9792,9794,9824,9827,9829,9830,9834,9835,9836,61441,61442,61445,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1];t.LiberationSansRegularWidths=[365,0,333,278,278,355,556,556,889,667,191,333,333,389,584,278,333,278,278,556,556,556,556,556,556,556,556,556,556,278,278,584,584,584,556,1015,667,667,722,722,667,611,778,722,278,500,667,556,833,722,778,667,778,722,667,611,722,667,944,667,667,611,278,278,278,469,556,333,556,556,500,556,556,278,556,556,222,222,500,222,833,556,556,556,556,333,500,278,556,500,722,500,500,500,334,260,334,584,333,556,556,556,556,260,556,333,737,370,556,584,737,552,400,549,333,333,333,576,537,278,333,333,365,556,834,834,834,611,667,667,667,667,667,667,1e3,722,667,667,667,667,278,278,278,278,722,722,778,778,778,778,778,584,778,722,722,722,722,667,667,611,556,556,556,556,556,556,889,500,556,556,556,556,278,278,278,278,556,556,556,556,556,556,556,549,611,556,556,556,556,500,556,500,667,556,667,556,667,556,722,500,722,500,722,500,722,500,722,615,722,556,667,556,667,556,667,556,667,556,667,556,778,556,778,556,778,556,778,556,722,556,722,556,278,278,278,278,278,278,278,222,278,278,735,444,500,222,667,500,500,556,222,556,222,556,292,556,334,556,222,722,556,722,556,722,556,604,723,556,778,556,778,556,778,556,1e3,944,722,333,722,333,722,333,667,500,667,500,667,500,667,500,611,278,611,375,611,278,722,556,722,556,722,556,722,556,722,556,722,556,944,722,667,500,667,611,500,611,500,611,500,222,556,667,556,1e3,889,778,611,667,500,611,278,333,333,333,333,333,333,333,333,333,333,333,667,278,784,838,384,774,855,752,222,667,667,551,668,667,611,722,778,278,667,668,833,722,650,778,722,667,618,611,667,798,667,835,748,278,667,578,446,556,222,547,578,575,500,557,446,441,556,556,222,500,500,576,500,448,556,690,569,482,617,395,547,648,525,713,781,222,547,556,547,781,667,667,865,542,719,667,278,278,500,1057,1010,854,583,722,635,719,667,656,667,542,677,667,923,604,719,719,583,656,833,722,778,719,667,722,611,635,760,667,740,667,917,938,792,885,656,719,1010,722,556,573,531,365,583,556,669,458,559,559,438,583,688,552,556,542,556,500,458,500,823,500,573,521,802,823,625,719,521,510,750,542,556,556,556,365,510,500,222,278,222,906,812,556,438,559,500,552,778,556,489,411,944,722,944,722,944,722,667,500,333,333,556,1e3,1e3,552,222,222,222,222,333,333,333,556,556,350,1e3,1e3,188,354,333,333,500,333,167,365,556,556,1094,556,885,323,1073,1e3,768,600,834,834,834,834,1e3,500,1e3,500,1e3,500,500,494,612,823,713,584,549,713,979,719,274,549,549,583,549,549,604,584,604,604,708,625,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,729,604,604,354,354,1e3,990,990,990,990,494,604,604,604,604,354,1021,1052,917,750,750,531,656,594,510,500,750,750,500,500,333,333,333,333,333,333,333,333,222,222,294,294,324,324,316,328,398,285];t.LiberationSansRegularMapping=[-1,-1,-1,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,161,162,163,164,165,166,167,168,169,170,171,172,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,402,506,507,508,509,510,511,536,537,538,539,710,711,713,728,729,730,731,732,733,900,901,902,903,904,905,906,908,910,911,912,913,914,915,916,917,918,919,920,921,922,923,924,925,926,927,928,929,931,932,933,934,935,936,937,938,939,940,941,942,943,944,945,946,947,948,949,950,951,952,953,954,955,956,957,958,959,960,961,962,963,964,965,966,967,968,969,970,971,972,973,974,1024,1025,1026,1027,1028,1029,1030,1031,1032,1033,1034,1035,1036,1037,1038,1039,1040,1041,1042,1043,1044,1045,1046,1047,1048,1049,1050,1051,1052,1053,1054,1055,1056,1057,1058,1059,1060,1061,1062,1063,1064,1065,1066,1067,1068,1069,1070,1071,1072,1073,1074,1075,1076,1077,1078,1079,1080,1081,1082,1083,1084,1085,1086,1087,1088,1089,1090,1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,1103,1104,1105,1106,1107,1108,1109,1110,1111,1112,1113,1114,1115,1116,1117,1118,1119,1138,1139,1168,1169,7808,7809,7810,7811,7812,7813,7922,7923,8208,8209,8211,8212,8213,8215,8216,8217,8218,8219,8220,8221,8222,8224,8225,8226,8230,8240,8242,8243,8249,8250,8252,8254,8260,8319,8355,8356,8359,8364,8453,8467,8470,8482,8486,8494,8539,8540,8541,8542,8592,8593,8594,8595,8596,8597,8616,8706,8710,8719,8721,8722,8730,8734,8735,8745,8747,8776,8800,8801,8804,8805,8962,8976,8992,8993,9472,9474,9484,9488,9492,9496,9500,9508,9516,9524,9532,9552,9553,9554,9555,9556,9557,9558,9559,9560,9561,9562,9563,9564,9565,9566,9567,9568,9569,9570,9571,9572,9573,9574,9575,9576,9577,9578,9579,9580,9600,9604,9608,9612,9616,9617,9618,9619,9632,9633,9642,9643,9644,9650,9658,9660,9668,9674,9675,9679,9688,9689,9702,9786,9787,9788,9792,9794,9824,9827,9829,9830,9834,9835,9836,61441,61442,61445,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1]},(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.MyriadProRegularMetrics=t.MyriadProRegularFactors=t.MyriadProItalicMetrics=t.MyriadProItalicFactors=t.MyriadProBoldMetrics=t.MyriadProBoldItalicMetrics=t.MyriadProBoldItalicFactors=t.MyriadProBoldFactors=void 0;t.MyriadProBoldFactors=[1.36898,1,1,.72706,.80479,.83734,.98894,.99793,.9897,.93884,.86209,.94292,.94292,1.16661,1.02058,.93582,.96694,.93582,1.19137,.99793,.99793,.99793,.99793,.99793,.99793,.99793,.99793,.99793,.99793,.78076,.78076,1.02058,1.02058,1.02058,.72851,.78966,.90838,.83637,.82391,.96376,.80061,.86275,.8768,.95407,1.0258,.73901,.85022,.83655,1.0156,.95546,.92179,.87107,.92179,.82114,.8096,.89713,.94438,.95353,.94083,.91905,.90406,.9446,.94292,1.18777,.94292,1.02058,.89903,.90088,.94938,.97898,.81093,.97571,.94938,1.024,.9577,.95933,.98621,1.0474,.97455,.98981,.9672,.95933,.9446,.97898,.97407,.97646,.78036,1.10208,.95442,.95298,.97579,.9332,.94039,.938,.80687,1.01149,.80687,1.02058,.80479,.99793,.99793,.99793,.99793,1.01149,1.00872,.90088,.91882,1.0213,.8361,1.02058,.62295,.54324,.89022,1.08595,1,1,.90088,1,.97455,.93582,.90088,1,1.05686,.8361,.99642,.99642,.99642,.72851,.90838,.90838,.90838,.90838,.90838,.90838,.868,.82391,.80061,.80061,.80061,.80061,1.0258,1.0258,1.0258,1.0258,.97484,.95546,.92179,.92179,.92179,.92179,.92179,1.02058,.92179,.94438,.94438,.94438,.94438,.90406,.86958,.98225,.94938,.94938,.94938,.94938,.94938,.94938,.9031,.81093,.94938,.94938,.94938,.94938,.98621,.98621,.98621,.98621,.93969,.95933,.9446,.9446,.9446,.9446,.9446,1.08595,.9446,.95442,.95442,.95442,.95442,.94039,.97898,.94039,.90838,.94938,.90838,.94938,.90838,.94938,.82391,.81093,.82391,.81093,.82391,.81093,.82391,.81093,.96376,.84313,.97484,.97571,.80061,.94938,.80061,.94938,.80061,.94938,.80061,.94938,.80061,.94938,.8768,.9577,.8768,.9577,.8768,.9577,1,1,.95407,.95933,.97069,.95933,1.0258,.98621,1.0258,.98621,1.0258,.98621,1.0258,.98621,1.0258,.98621,.887,1.01591,.73901,1.0474,1,1,.97455,.83655,.98981,1,1,.83655,.73977,.83655,.73903,.84638,1.033,.95546,.95933,1,1,.95546,.95933,.8271,.95417,.95933,.92179,.9446,.92179,.9446,.92179,.9446,.936,.91964,.82114,.97646,1,1,.82114,.97646,.8096,.78036,.8096,.78036,1,1,.8096,.78036,1,1,.89713,.77452,.89713,1.10208,.94438,.95442,.94438,.95442,.94438,.95442,.94438,.95442,.94438,.95442,.94438,.95442,.94083,.97579,.90406,.94039,.90406,.9446,.938,.9446,.938,.9446,.938,1,.99793,.90838,.94938,.868,.9031,.92179,.9446,1,1,.89713,1.10208,.90088,.90088,.90088,.90088,.90088,.90088,.90088,.90088,.90088,.90989,.9358,.91945,.83181,.75261,.87992,.82976,.96034,.83689,.97268,1.0078,.90838,.83637,.8019,.90157,.80061,.9446,.95407,.92436,1.0258,.85022,.97153,1.0156,.95546,.89192,.92179,.92361,.87107,.96318,.89713,.93704,.95638,.91905,.91709,.92796,1.0258,.93704,.94836,1.0373,.95933,1.0078,.95871,.94836,.96174,.92601,.9498,.98607,.95776,.95933,1.05453,1.0078,.98275,.9314,.95617,.91701,1.05993,.9446,.78367,.9553,1,.86832,1.0128,.95871,.99394,.87548,.96361,.86774,1.0078,.95871,.9446,.95871,.86774,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.94083,.97579,.94083,.97579,.94083,.97579,.90406,.94039,.96694,1,.89903,1,1,1,.93582,.93582,.93582,1,.908,.908,.918,.94219,.94219,.96544,1,1.285,1,1,.81079,.81079,1,1,.74854,1,1,1,1,.99793,1,1,1,.65,1,1.36145,1,1,1,1,1,1,1,1,1,1,1,1.17173,1,.80535,.76169,1.02058,1.0732,1.05486,1,1,1.30692,1.08595,1.08595,1,1.08595,1.08595,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1.16161,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.MyriadProBoldMetrics={lineHeight:1.2,lineGap:.2};t.MyriadProBoldItalicFactors=[1.36898,1,1,.66227,.80779,.81625,.97276,.97276,.97733,.92222,.83266,.94292,.94292,1.16148,1.02058,.93582,.96694,.93582,1.17337,.97276,.97276,.97276,.97276,.97276,.97276,.97276,.97276,.97276,.97276,.78076,.78076,1.02058,1.02058,1.02058,.71541,.76813,.85576,.80591,.80729,.94299,.77512,.83655,.86523,.92222,.98621,.71743,.81698,.79726,.98558,.92222,.90637,.83809,.90637,.80729,.76463,.86275,.90699,.91605,.9154,.85308,.85458,.90531,.94292,1.21296,.94292,1.02058,.89903,1.18616,.99613,.91677,.78216,.91677,.90083,.98796,.9135,.92168,.95381,.98981,.95298,.95381,.93459,.92168,.91513,.92004,.91677,.95077,.748,1.04502,.91677,.92061,.94236,.89544,.89364,.9,.80687,.8578,.80687,1.02058,.80779,.97276,.97276,.97276,.97276,.8578,.99973,1.18616,.91339,1.08074,.82891,1.02058,.55509,.71526,.89022,1.08595,1,1,1.18616,1,.96736,.93582,1.18616,1,1.04864,.82711,.99043,.99043,.99043,.71541,.85576,.85576,.85576,.85576,.85576,.85576,.845,.80729,.77512,.77512,.77512,.77512,.98621,.98621,.98621,.98621,.95961,.92222,.90637,.90637,.90637,.90637,.90637,1.02058,.90251,.90699,.90699,.90699,.90699,.85458,.83659,.94951,.99613,.99613,.99613,.99613,.99613,.99613,.85811,.78216,.90083,.90083,.90083,.90083,.95381,.95381,.95381,.95381,.9135,.92168,.91513,.91513,.91513,.91513,.91513,1.08595,.91677,.91677,.91677,.91677,.91677,.89364,.92332,.89364,.85576,.99613,.85576,.99613,.85576,.99613,.80729,.78216,.80729,.78216,.80729,.78216,.80729,.78216,.94299,.76783,.95961,.91677,.77512,.90083,.77512,.90083,.77512,.90083,.77512,.90083,.77512,.90083,.86523,.9135,.86523,.9135,.86523,.9135,1,1,.92222,.92168,.92222,.92168,.98621,.95381,.98621,.95381,.98621,.95381,.98621,.95381,.98621,.95381,.86036,.97096,.71743,.98981,1,1,.95298,.79726,.95381,1,1,.79726,.6894,.79726,.74321,.81691,1.0006,.92222,.92168,1,1,.92222,.92168,.79464,.92098,.92168,.90637,.91513,.90637,.91513,.90637,.91513,.909,.87514,.80729,.95077,1,1,.80729,.95077,.76463,.748,.76463,.748,1,1,.76463,.748,1,1,.86275,.72651,.86275,1.04502,.90699,.91677,.90699,.91677,.90699,.91677,.90699,.91677,.90699,.91677,.90699,.91677,.9154,.94236,.85458,.89364,.85458,.90531,.9,.90531,.9,.90531,.9,1,.97276,.85576,.99613,.845,.85811,.90251,.91677,1,1,.86275,1.04502,1.18616,1.18616,1.18616,1.18616,1.18616,1.18616,1.18616,1.18616,1.18616,1.00899,1.30628,.85576,.80178,.66862,.7927,.69323,.88127,.72459,.89711,.95381,.85576,.80591,.7805,.94729,.77512,.90531,.92222,.90637,.98621,.81698,.92655,.98558,.92222,.85359,.90637,.90976,.83809,.94523,.86275,.83509,.93157,.85308,.83392,.92346,.98621,.83509,.92886,.91324,.92168,.95381,.90646,.92886,.90557,.86847,.90276,.91324,.86842,.92168,.99531,.95381,.9224,.85408,.92699,.86847,1.0051,.91513,.80487,.93481,1,.88159,1.05214,.90646,.97355,.81539,.89398,.85923,.95381,.90646,.91513,.90646,.85923,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.9154,.94236,.9154,.94236,.9154,.94236,.85458,.89364,.96694,1,.89903,1,1,1,.91782,.91782,.91782,1,.896,.896,.896,.9332,.9332,.95973,1,1.26,1,1,.80479,.80178,1,1,.85633,1,1,1,1,.97276,1,1,1,.698,1,1.36145,1,1,1,1,1,1,1,1,1,1,1,1.14542,1,.79199,.78694,1.02058,1.03493,1.05486,1,1,1.23026,1.08595,1.08595,1,1.08595,1.08595,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1.20006,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.MyriadProBoldItalicMetrics={lineHeight:1.2,lineGap:.2};t.MyriadProItalicFactors=[1.36898,1,1,.65507,.84943,.85639,.88465,.88465,.86936,.88307,.86948,.85283,.85283,1.06383,1.02058,.75945,.9219,.75945,1.17337,.88465,.88465,.88465,.88465,.88465,.88465,.88465,.88465,.88465,.88465,.75945,.75945,1.02058,1.02058,1.02058,.69046,.70926,.85158,.77812,.76852,.89591,.70466,.76125,.80094,.86822,.83864,.728,.77212,.79475,.93637,.87514,.8588,.76013,.8588,.72421,.69866,.77598,.85991,.80811,.87832,.78112,.77512,.8562,1.0222,1.18417,1.0222,1.27014,.89903,1.15012,.93859,.94399,.846,.94399,.81453,1.0186,.94219,.96017,1.03075,1.02175,.912,1.03075,.96998,.96017,.93859,.94399,.94399,.95493,.746,1.12658,.94578,.91,.979,.882,.882,.83,.85034,.83537,.85034,1.02058,.70869,.88465,.88465,.88465,.88465,.83537,.90083,1.15012,.9161,.94565,.73541,1.02058,.53609,.69353,.79519,1.08595,1,1,1.15012,1,.91974,.75945,1.15012,1,.9446,.73361,.9005,.9005,.9005,.62864,.85158,.85158,.85158,.85158,.85158,.85158,.773,.76852,.70466,.70466,.70466,.70466,.83864,.83864,.83864,.83864,.90561,.87514,.8588,.8588,.8588,.8588,.8588,1.02058,.85751,.85991,.85991,.85991,.85991,.77512,.76013,.88075,.93859,.93859,.93859,.93859,.93859,.93859,.8075,.846,.81453,.81453,.81453,.81453,.82424,.82424,.82424,.82424,.9278,.96017,.93859,.93859,.93859,.93859,.93859,1.08595,.8562,.94578,.94578,.94578,.94578,.882,.94578,.882,.85158,.93859,.85158,.93859,.85158,.93859,.76852,.846,.76852,.846,.76852,.846,.76852,.846,.89591,.8544,.90561,.94399,.70466,.81453,.70466,.81453,.70466,.81453,.70466,.81453,.70466,.81453,.80094,.94219,.80094,.94219,.80094,.94219,1,1,.86822,.96017,.86822,.96017,.83864,.82424,.83864,.82424,.83864,.82424,.83864,1.03075,.83864,.82424,.81402,1.02738,.728,1.02175,1,1,.912,.79475,1.03075,1,1,.79475,.83911,.79475,.66266,.80553,1.06676,.87514,.96017,1,1,.87514,.96017,.86865,.87396,.96017,.8588,.93859,.8588,.93859,.8588,.93859,.867,.84759,.72421,.95493,1,1,.72421,.95493,.69866,.746,.69866,.746,1,1,.69866,.746,1,1,.77598,.88417,.77598,1.12658,.85991,.94578,.85991,.94578,.85991,.94578,.85991,.94578,.85991,.94578,.85991,.94578,.87832,.979,.77512,.882,.77512,.8562,.83,.8562,.83,.8562,.83,1,.88465,.85158,.93859,.773,.8075,.85751,.8562,1,1,.77598,1.12658,1.15012,1.15012,1.15012,1.15012,1.15012,1.15313,1.15012,1.15012,1.15012,1.08106,1.03901,.85158,.77025,.62264,.7646,.65351,.86026,.69461,.89947,1.03075,.85158,.77812,.76449,.88836,.70466,.8562,.86822,.8588,.83864,.77212,.85308,.93637,.87514,.82352,.8588,.85701,.76013,.89058,.77598,.8156,.82565,.78112,.77899,.89386,.83864,.8156,.9486,.92388,.96186,1.03075,.91123,.9486,.93298,.878,.93942,.92388,.84596,.96186,.95119,1.03075,.922,.88787,.95829,.88,.93559,.93859,.78815,.93758,1,.89217,1.03737,.91123,.93969,.77487,.85769,.86799,1.03075,.91123,.93859,.91123,.86799,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.87832,.979,.87832,.979,.87832,.979,.77512,.882,.9219,1,.89903,1,1,1,.87321,.87321,.87321,1,1.027,1.027,1.027,.86847,.86847,.79121,1,1.124,1,1,.73572,.73572,1,1,.85034,1,1,1,1,.88465,1,1,1,.669,1,1.36145,1,1,1,1,1,1,1,1,1,1,1,1.04828,1,.74948,.75187,1.02058,.98391,1.02119,1,1,1.06233,1.08595,1.08595,1,1.08595,1.08595,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1.05233,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.MyriadProItalicMetrics={lineHeight:1.2,lineGap:.2};t.MyriadProRegularFactors=[1.36898,1,1,.76305,.82784,.94935,.89364,.92241,.89073,.90706,.98472,.85283,.85283,1.0664,1.02058,.74505,.9219,.74505,1.23456,.92241,.92241,.92241,.92241,.92241,.92241,.92241,.92241,.92241,.92241,.74505,.74505,1.02058,1.02058,1.02058,.73002,.72601,.91755,.8126,.80314,.92222,.73764,.79726,.83051,.90284,.86023,.74,.8126,.84869,.96518,.91115,.8858,.79761,.8858,.74498,.73914,.81363,.89591,.83659,.89633,.85608,.8111,.90531,1.0222,1.22736,1.0222,1.27014,.89903,.90088,.86667,1.0231,.896,1.01411,.90083,1.05099,1.00512,.99793,1.05326,1.09377,.938,1.06226,1.00119,.99793,.98714,1.0231,1.01231,.98196,.792,1.19137,.99074,.962,1.01915,.926,.942,.856,.85034,.92006,.85034,1.02058,.69067,.92241,.92241,.92241,.92241,.92006,.9332,.90088,.91882,.93484,.75339,1.02058,.56866,.54324,.79519,1.08595,1,1,.90088,1,.95325,.74505,.90088,1,.97198,.75339,.91009,.91009,.91009,.66466,.91755,.91755,.91755,.91755,.91755,.91755,.788,.80314,.73764,.73764,.73764,.73764,.86023,.86023,.86023,.86023,.92915,.91115,.8858,.8858,.8858,.8858,.8858,1.02058,.8858,.89591,.89591,.89591,.89591,.8111,.79611,.89713,.86667,.86667,.86667,.86667,.86667,.86667,.86936,.896,.90083,.90083,.90083,.90083,.84224,.84224,.84224,.84224,.97276,.99793,.98714,.98714,.98714,.98714,.98714,1.08595,.89876,.99074,.99074,.99074,.99074,.942,1.0231,.942,.91755,.86667,.91755,.86667,.91755,.86667,.80314,.896,.80314,.896,.80314,.896,.80314,.896,.92222,.93372,.92915,1.01411,.73764,.90083,.73764,.90083,.73764,.90083,.73764,.90083,.73764,.90083,.83051,1.00512,.83051,1.00512,.83051,1.00512,1,1,.90284,.99793,.90976,.99793,.86023,.84224,.86023,.84224,.86023,.84224,.86023,1.05326,.86023,.84224,.82873,1.07469,.74,1.09377,1,1,.938,.84869,1.06226,1,1,.84869,.83704,.84869,.81441,.85588,1.08927,.91115,.99793,1,1,.91115,.99793,.91887,.90991,.99793,.8858,.98714,.8858,.98714,.8858,.98714,.894,.91434,.74498,.98196,1,1,.74498,.98196,.73914,.792,.73914,.792,1,1,.73914,.792,1,1,.81363,.904,.81363,1.19137,.89591,.99074,.89591,.99074,.89591,.99074,.89591,.99074,.89591,.99074,.89591,.99074,.89633,1.01915,.8111,.942,.8111,.90531,.856,.90531,.856,.90531,.856,1,.92241,.91755,.86667,.788,.86936,.8858,.89876,1,1,.81363,1.19137,.90088,.90088,.90088,.90088,.90088,.90088,.90088,.90088,.90088,.90388,1.03901,.92138,.78105,.7154,.86169,.80513,.94007,.82528,.98612,1.06226,.91755,.8126,.81884,.92819,.73764,.90531,.90284,.8858,.86023,.8126,.91172,.96518,.91115,.83089,.8858,.87791,.79761,.89297,.81363,.88157,.89992,.85608,.81992,.94307,.86023,.88157,.95308,.98699,.99793,1.06226,.95817,.95308,.97358,.928,.98088,.98699,.92761,.99793,.96017,1.06226,.986,.944,.95978,.938,.96705,.98714,.80442,.98972,1,.89762,1.04552,.95817,.99007,.87064,.91879,.88888,1.06226,.95817,.98714,.95817,.88888,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.89633,1.01915,.89633,1.01915,.89633,1.01915,.8111,.942,.9219,1,.89903,1,1,1,.93173,.93173,.93173,1,1.06304,1.06304,1.06904,.89903,.89903,.80549,1,1.156,1,1,.76575,.76575,1,1,.72458,1,1,1,1,.92241,1,1,1,.619,1,1.36145,1,1,1,1,1,1,1,1,1,1,1,1.07257,1,.74705,.71119,1.02058,1.024,1.02119,1,1,1.1536,1.08595,1.08595,1,1.08595,1.08595,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1.05638,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.MyriadProRegularMetrics={lineHeight:1.2,lineGap:.2}},(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.SegoeuiRegularMetrics=t.SegoeuiRegularFactors=t.SegoeuiItalicMetrics=t.SegoeuiItalicFactors=t.SegoeuiBoldMetrics=t.SegoeuiBoldItalicMetrics=t.SegoeuiBoldItalicFactors=t.SegoeuiBoldFactors=void 0;t.SegoeuiBoldFactors=[1.76738,1,1,.99297,.9824,1.04016,1.06497,1.03424,.97529,1.17647,1.23203,1.1085,1.1085,1.16939,1.2107,.9754,1.21408,.9754,1.59578,1.03424,1.03424,1.03424,1.03424,1.03424,1.03424,1.03424,1.03424,1.03424,1.03424,.81378,.81378,1.2107,1.2107,1.2107,.71703,.97847,.97363,.88776,.8641,1.02096,.79795,.85132,.914,1.06085,1.1406,.8007,.89858,.83693,1.14889,1.09398,.97489,.92094,.97489,.90399,.84041,.95923,1.00135,1,1.06467,.98243,.90996,.99361,1.1085,1.56942,1.1085,1.2107,.74627,.94282,.96752,1.01519,.86304,1.01359,.97278,1.15103,1.01359,.98561,1.02285,1.02285,1.00527,1.02285,1.0302,.99041,1.0008,1.01519,1.01359,1.02258,.79104,1.16862,.99041,.97454,1.02511,.99298,.96752,.95801,.94856,1.16579,.94856,1.2107,.9824,1.03424,1.03424,1,1.03424,1.16579,.8727,1.3871,1.18622,1.10818,1.04478,1.2107,1.18622,.75155,.94994,1.28826,1.21408,1.21408,.91056,1,.91572,.9754,.64663,1.18328,1.24866,1.04478,1.14169,1.15749,1.17389,.71703,.97363,.97363,.97363,.97363,.97363,.97363,.93506,.8641,.79795,.79795,.79795,.79795,1.1406,1.1406,1.1406,1.1406,1.02096,1.09398,.97426,.97426,.97426,.97426,.97426,1.2107,.97489,1.00135,1.00135,1.00135,1.00135,.90996,.92094,1.02798,.96752,.96752,.96752,.96752,.96752,.96752,.93136,.86304,.97278,.97278,.97278,.97278,1.02285,1.02285,1.02285,1.02285,.97122,.99041,1,1,1,1,1,1.28826,1.0008,.99041,.99041,.99041,.99041,.96752,1.01519,.96752,.97363,.96752,.97363,.96752,.97363,.96752,.8641,.86304,.8641,.86304,.8641,.86304,.8641,.86304,1.02096,1.03057,1.02096,1.03517,.79795,.97278,.79795,.97278,.79795,.97278,.79795,.97278,.79795,.97278,.914,1.01359,.914,1.01359,.914,1.01359,1,1,1.06085,.98561,1.06085,1.00879,1.1406,1.02285,1.1406,1.02285,1.1406,1.02285,1.1406,1.02285,1.1406,1.02285,.97138,1.08692,.8007,1.02285,1,1,1.00527,.83693,1.02285,1,1,.83693,.9455,.83693,.90418,.83693,1.13005,1.09398,.99041,1,1,1.09398,.99041,.96692,1.09251,.99041,.97489,1.0008,.97489,1.0008,.97489,1.0008,.93994,.97931,.90399,1.02258,1,1,.90399,1.02258,.84041,.79104,.84041,.79104,.84041,.79104,.84041,.79104,1,1,.95923,1.07034,.95923,1.16862,1.00135,.99041,1.00135,.99041,1.00135,.99041,1.00135,.99041,1.00135,.99041,1.00135,.99041,1.06467,1.02511,.90996,.96752,.90996,.99361,.95801,.99361,.95801,.99361,.95801,1.07733,1.03424,.97363,.96752,.93506,.93136,.97489,1.0008,1,1,.95923,1.16862,1.15103,1.15103,1.01173,1.03959,.75953,.81378,.79912,1.15103,1.21994,.95161,.87815,1.01149,.81525,.7676,.98167,1.01134,1.02546,.84097,1.03089,1.18102,.97363,.88776,.85134,.97826,.79795,.99361,1.06085,.97489,1.1406,.89858,1.0388,1.14889,1.09398,.86039,.97489,1.0595,.92094,.94793,.95923,.90996,.99346,.98243,1.02112,.95493,1.1406,.90996,1.03574,1.02597,1.0008,1.18102,1.06628,1.03574,1.0192,1.01932,1.00886,.97531,1.0106,1.0008,1.13189,1.18102,1.02277,.98683,1.0016,.99561,1.07237,1.0008,.90434,.99921,.93803,.8965,1.23085,1.06628,1.04983,.96268,1.0499,.98439,1.18102,1.06628,1.0008,1.06628,.98439,.79795,1,1,1,1,1,1,1,1,1,1,1,1,1.09466,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.97278,1,1,1,1,1,1,1,1,1,1,1,1,1.02065,1,1,1,1,1,1,1.06467,1.02511,1.06467,1.02511,1.06467,1.02511,.90996,.96752,1,1.21408,.89903,1,1,.75155,1.04394,1.04394,1.04394,1.04394,.98633,.98633,.98633,.73047,.73047,1.20642,.91211,1.25635,1.222,1.02956,1.03372,1.03372,.96039,1.24633,1,1.12454,.93503,1.03424,1.19687,1.03424,1,1,1,.771,1,1,1.15749,1.15749,1.15749,1.10948,.86279,.94434,.86279,.94434,.86182,1,1,1.16897,1,.96085,.90137,1.2107,1.18416,1.13973,.69825,.9716,2.10339,1.29004,1.29004,1.21172,1.29004,1.29004,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1.42603,1,.99862,.99862,1,.87025,.87025,.87025,.87025,1.18874,1.42603,1,1.42603,1.42603,.99862,1,1,1,1,1,1.2886,1.04315,1.15296,1.34163,1,1,1,1.09193,1.09193,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.SegoeuiBoldMetrics={lineHeight:1.33008,lineGap:0};t.SegoeuiBoldItalicFactors=[1.76738,1,1,.98946,1.03959,1.04016,1.02809,1.036,.97639,1.10953,1.23203,1.11144,1.11144,1.16939,1.21237,.9754,1.21261,.9754,1.59754,1.036,1.036,1.036,1.036,1.036,1.036,1.036,1.036,1.036,1.036,.81378,.81378,1.21237,1.21237,1.21237,.73541,.97847,.97363,.89723,.87897,1.0426,.79429,.85292,.91149,1.05815,1.1406,.79631,.90128,.83853,1.04396,1.10615,.97552,.94436,.97552,.88641,.80527,.96083,1.00135,1,1.06777,.9817,.91142,.99361,1.11144,1.57293,1.11144,1.21237,.74627,1.31818,1.06585,.97042,.83055,.97042,.93503,1.1261,.97042,.97922,1.14236,.94552,1.01054,1.14236,1.02471,.97922,.94165,.97042,.97042,1.0276,.78929,1.1261,.97922,.95874,1.02197,.98507,.96752,.97168,.95107,1.16579,.95107,1.21237,1.03959,1.036,1.036,1,1.036,1.16579,.87357,1.31818,1.18754,1.26781,1.05356,1.21237,1.18622,.79487,.94994,1.29004,1.24047,1.24047,1.31818,1,.91484,.9754,1.31818,1.1349,1.24866,1.05356,1.13934,1.15574,1.17389,.73541,.97363,.97363,.97363,.97363,.97363,.97363,.94385,.87897,.79429,.79429,.79429,.79429,1.1406,1.1406,1.1406,1.1406,1.0426,1.10615,.97552,.97552,.97552,.97552,.97552,1.21237,.97552,1.00135,1.00135,1.00135,1.00135,.91142,.94436,.98721,1.06585,1.06585,1.06585,1.06585,1.06585,1.06585,.96705,.83055,.93503,.93503,.93503,.93503,1.14236,1.14236,1.14236,1.14236,.93125,.97922,.94165,.94165,.94165,.94165,.94165,1.29004,.94165,.97922,.97922,.97922,.97922,.96752,.97042,.96752,.97363,1.06585,.97363,1.06585,.97363,1.06585,.87897,.83055,.87897,.83055,.87897,.83055,.87897,.83055,1.0426,1.0033,1.0426,.97042,.79429,.93503,.79429,.93503,.79429,.93503,.79429,.93503,.79429,.93503,.91149,.97042,.91149,.97042,.91149,.97042,1,1,1.05815,.97922,1.05815,.97922,1.1406,1.14236,1.1406,1.14236,1.1406,1.14236,1.1406,1.14236,1.1406,1.14236,.97441,1.04302,.79631,1.01582,1,1,1.01054,.83853,1.14236,1,1,.83853,1.09125,.83853,.90418,.83853,1.19508,1.10615,.97922,1,1,1.10615,.97922,1.01034,1.10466,.97922,.97552,.94165,.97552,.94165,.97552,.94165,.91602,.91981,.88641,1.0276,1,1,.88641,1.0276,.80527,.78929,.80527,.78929,.80527,.78929,.80527,.78929,1,1,.96083,1.05403,.95923,1.16862,1.00135,.97922,1.00135,.97922,1.00135,.97922,1.00135,.97922,1.00135,.97922,1.00135,.97922,1.06777,1.02197,.91142,.96752,.91142,.99361,.97168,.99361,.97168,.99361,.97168,1.23199,1.036,.97363,1.06585,.94385,.96705,.97552,.94165,1,1,.96083,1.1261,1.31818,1.31818,1.31818,1.31818,1.31818,1.31818,1.31818,1.31818,1.31818,.95161,1.27126,1.00811,.83284,.77702,.99137,.95253,1.0347,.86142,1.07205,1.14236,.97363,.89723,.86869,1.09818,.79429,.99361,1.05815,.97552,1.1406,.90128,1.06662,1.04396,1.10615,.84918,.97552,1.04694,.94436,.98015,.96083,.91142,1.00356,.9817,1.01945,.98999,1.1406,.91142,1.04961,.9898,1.00639,1.14236,1.07514,1.04961,.99607,1.02897,1.008,.9898,.95134,1.00639,1.11121,1.14236,1.00518,.97981,1.02186,1,1.08578,.94165,.99314,.98387,.93028,.93377,1.35125,1.07514,1.10687,.93491,1.04232,1.00351,1.14236,1.07514,.94165,1.07514,1.00351,.79429,1,1,1,1,1,1,1,1,1,1,1,1,1.09097,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.93503,1,1,1,1,1,1,1,1,1,1,1,1,.96609,1,1,1,1,1,1,1.06777,1.02197,1.06777,1.02197,1.06777,1.02197,.91142,.96752,1,1.21261,.89903,1,1,.75155,1.04745,1.04745,1.04745,1.04394,.98633,.98633,.98633,.72959,.72959,1.20502,.91406,1.26514,1.222,1.02956,1.03372,1.03372,.96039,1.24633,1,1.09125,.93327,1.03336,1.16541,1.036,1,1,1,.771,1,1,1.15574,1.15574,1.15574,1.15574,.86364,.94434,.86279,.94434,.86224,1,1,1.16798,1,.96085,.90068,1.21237,1.18416,1.13904,.69825,.9716,2.10339,1.29004,1.29004,1.21339,1.29004,1.29004,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1.42603,1,.99862,.99862,1,.87025,.87025,.87025,.87025,1.18775,1.42603,1,1.42603,1.42603,.99862,1,1,1,1,1,1.2886,1.04315,1.15296,1.34163,1,1,1,1.13269,1.13269,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.SegoeuiBoldItalicMetrics={lineHeight:1.33008,lineGap:0};t.SegoeuiItalicFactors=[1.76738,1,1,.98946,1.14763,1.05365,1.06234,.96927,.92586,1.15373,1.18414,.91349,.91349,1.07403,1.17308,.78383,1.20088,.78383,1.42531,.96927,.96927,.96927,.96927,.96927,.96927,.96927,.96927,.96927,.96927,.78383,.78383,1.17308,1.17308,1.17308,.77349,.94565,.94729,.85944,.88506,.9858,.74817,.80016,.88449,.98039,.95782,.69238,.89898,.83231,.98183,1.03989,.96924,.86237,.96924,.80595,.74524,.86091,.95402,.94143,.98448,.8858,.83089,.93285,1.0949,1.39016,1.0949,1.45994,.74627,1.04839,.97454,.97454,.87207,.97454,.87533,1.06151,.97454,1.00176,1.16484,1.08132,.98047,1.16484,1.02989,1.01054,.96225,.97454,.97454,1.06598,.79004,1.16344,1.00351,.94629,.9973,.91016,.96777,.9043,.91082,.92481,.91082,1.17308,.95748,.96927,.96927,1,.96927,.92481,.80597,1.04839,1.23393,1.1781,.9245,1.17308,1.20808,.63218,.94261,1.24822,1.09971,1.09971,1.04839,1,.85273,.78032,1.04839,1.09971,1.22326,.9245,1.09836,1.13525,1.15222,.70424,.94729,.94729,.94729,.94729,.94729,.94729,.85498,.88506,.74817,.74817,.74817,.74817,.95782,.95782,.95782,.95782,.9858,1.03989,.96924,.96924,.96924,.96924,.96924,1.17308,.96924,.95402,.95402,.95402,.95402,.83089,.86237,.88409,.97454,.97454,.97454,.97454,.97454,.97454,.92916,.87207,.87533,.87533,.87533,.87533,.93146,.93146,.93146,.93146,.93854,1.01054,.96225,.96225,.96225,.96225,.96225,1.24822,.8761,1.00351,1.00351,1.00351,1.00351,.96777,.97454,.96777,.94729,.97454,.94729,.97454,.94729,.97454,.88506,.87207,.88506,.87207,.88506,.87207,.88506,.87207,.9858,.95391,.9858,.97454,.74817,.87533,.74817,.87533,.74817,.87533,.74817,.87533,.74817,.87533,.88449,.97454,.88449,.97454,.88449,.97454,1,1,.98039,1.00176,.98039,1.00176,.95782,.93146,.95782,.93146,.95782,.93146,.95782,1.16484,.95782,.93146,.84421,1.12761,.69238,1.08132,1,1,.98047,.83231,1.16484,1,1,.84723,1.04861,.84723,.78755,.83231,1.23736,1.03989,1.01054,1,1,1.03989,1.01054,.9857,1.03849,1.01054,.96924,.96225,.96924,.96225,.96924,.96225,.92383,.90171,.80595,1.06598,1,1,.80595,1.06598,.74524,.79004,.74524,.79004,.74524,.79004,.74524,.79004,1,1,.86091,1.02759,.85771,1.16344,.95402,1.00351,.95402,1.00351,.95402,1.00351,.95402,1.00351,.95402,1.00351,.95402,1.00351,.98448,.9973,.83089,.96777,.83089,.93285,.9043,.93285,.9043,.93285,.9043,1.31868,.96927,.94729,.97454,.85498,.92916,.96924,.8761,1,1,.86091,1.16344,1.04839,1.04839,1.04839,1.04839,1.04839,1.04839,1.04839,1.04839,1.04839,.81965,.81965,.94729,.78032,.71022,.90883,.84171,.99877,.77596,1.05734,1.2,.94729,.85944,.82791,.9607,.74817,.93285,.98039,.96924,.95782,.89898,.98316,.98183,1.03989,.78614,.96924,.97642,.86237,.86075,.86091,.83089,.90082,.8858,.97296,1.01284,.95782,.83089,1.0976,1.04,1.03342,1.2,1.0675,1.0976,.98205,1.03809,1.05097,1.04,.95364,1.03342,1.05401,1.2,1.02148,1.0119,1.04724,1.0127,1.02732,.96225,.8965,.97783,.93574,.94818,1.30679,1.0675,1.11826,.99821,1.0557,1.0326,1.2,1.0675,.96225,1.0675,1.0326,.74817,1,1,1,1,1,1,1,1,1,1,1,1,1.03754,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.87533,1,1,1,1,1,1,1,1,1,1,1,1,.98705,1,1,1,1,1,1,.98448,.9973,.98448,.9973,.98448,.9973,.83089,.96777,1,1.20088,.89903,1,1,.75155,.94945,.94945,.94945,.94945,1.12317,1.12317,1.12317,.67603,.67603,1.15621,.73584,1.21191,1.22135,1.06483,.94868,.94868,.95996,1.24633,1,1.07497,.87709,.96927,1.01473,.96927,1,1,1,.77295,1,1,1.09836,1.09836,1.09836,1.01522,.86321,.94434,.8649,.94434,.86182,1,1,1.083,1,.91578,.86438,1.17308,1.18416,1.14589,.69825,.97622,1.96791,1.24822,1.24822,1.17308,1.24822,1.24822,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1.42603,1,.99862,.99862,1,.87025,.87025,.87025,.87025,1.17984,1.42603,1,1.42603,1.42603,.99862,1,1,1,1,1,1.2886,1.04315,1.15296,1.34163,1,1,1,1.10742,1.10742,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.SegoeuiItalicMetrics={lineHeight:1.33008,lineGap:0};t.SegoeuiRegularFactors=[1.76738,1,1,.98594,1.02285,1.10454,1.06234,.96927,.92037,1.19985,1.2046,.90616,.90616,1.07152,1.1714,.78032,1.20088,.78032,1.40246,.96927,.96927,.96927,.96927,.96927,.96927,.96927,.96927,.96927,.96927,.78032,.78032,1.1714,1.1714,1.1714,.80597,.94084,.96706,.85944,.85734,.97093,.75842,.79936,.88198,.9831,.95782,.71387,.86969,.84636,1.07796,1.03584,.96924,.83968,.96924,.82826,.79649,.85771,.95132,.93119,.98965,.88433,.8287,.93365,1.08612,1.3638,1.08612,1.45786,.74627,.80499,.91484,1.05707,.92383,1.05882,.9403,1.12654,1.05882,1.01756,1.09011,1.09011,.99414,1.09011,1.034,1.01756,1.05356,1.05707,1.05882,1.04399,.84863,1.21968,1.01756,.95801,1.00068,.91797,.96777,.9043,.90351,.92105,.90351,1.1714,.85337,.96927,.96927,.99912,.96927,.92105,.80597,1.2434,1.20808,1.05937,.90957,1.1714,1.20808,.75155,.94261,1.24644,1.09971,1.09971,.84751,1,.85273,.78032,.61584,1.05425,1.17914,.90957,1.08665,1.11593,1.14169,.73381,.96706,.96706,.96706,.96706,.96706,.96706,.86035,.85734,.75842,.75842,.75842,.75842,.95782,.95782,.95782,.95782,.97093,1.03584,.96924,.96924,.96924,.96924,.96924,1.1714,.96924,.95132,.95132,.95132,.95132,.8287,.83968,.89049,.91484,.91484,.91484,.91484,.91484,.91484,.93575,.92383,.9403,.9403,.9403,.9403,.8717,.8717,.8717,.8717,1.00527,1.01756,1.05356,1.05356,1.05356,1.05356,1.05356,1.24644,.95923,1.01756,1.01756,1.01756,1.01756,.96777,1.05707,.96777,.96706,.91484,.96706,.91484,.96706,.91484,.85734,.92383,.85734,.92383,.85734,.92383,.85734,.92383,.97093,1.0969,.97093,1.05882,.75842,.9403,.75842,.9403,.75842,.9403,.75842,.9403,.75842,.9403,.88198,1.05882,.88198,1.05882,.88198,1.05882,1,1,.9831,1.01756,.9831,1.01756,.95782,.8717,.95782,.8717,.95782,.8717,.95782,1.09011,.95782,.8717,.84784,1.11551,.71387,1.09011,1,1,.99414,.84636,1.09011,1,1,.84636,1.0536,.84636,.94298,.84636,1.23297,1.03584,1.01756,1,1,1.03584,1.01756,1.00323,1.03444,1.01756,.96924,1.05356,.96924,1.05356,.96924,1.05356,.93066,.98293,.82826,1.04399,1,1,.82826,1.04399,.79649,.84863,.79649,.84863,.79649,.84863,.79649,.84863,1,1,.85771,1.17318,.85771,1.21968,.95132,1.01756,.95132,1.01756,.95132,1.01756,.95132,1.01756,.95132,1.01756,.95132,1.01756,.98965,1.00068,.8287,.96777,.8287,.93365,.9043,.93365,.9043,.93365,.9043,1.08571,.96927,.96706,.91484,.86035,.93575,.96924,.95923,1,1,.85771,1.21968,1.11437,1.11437,.93109,.91202,.60411,.84164,.55572,1.01173,.97361,.81818,.81818,.96635,.78032,.72727,.92366,.98601,1.03405,.77968,1.09799,1.2,.96706,.85944,.85638,.96491,.75842,.93365,.9831,.96924,.95782,.86969,.94152,1.07796,1.03584,.78437,.96924,.98715,.83968,.83491,.85771,.8287,.94492,.88433,.9287,1.0098,.95782,.8287,1.0625,.98248,1.03424,1.2,1.01071,1.0625,.95246,1.03809,1.04912,.98248,1.00221,1.03424,1.05443,1.2,1.04785,.99609,1.00169,1.05176,.99346,1.05356,.9087,1.03004,.95542,.93117,1.23362,1.01071,1.07831,1.02512,1.05205,1.03502,1.2,1.01071,1.05356,1.01071,1.03502,.75842,1,1,1,1,1,1,1,1,1,1,1,1,1.03719,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.9403,1,1,1,1,1,1,1,1,1,1,1,1,1.04021,1,1,1,1,1,1,.98965,1.00068,.98965,1.00068,.98965,1.00068,.8287,.96777,1,1.20088,.89903,1,1,.75155,1.03077,1.03077,1.03077,1.03077,1.13196,1.13196,1.13196,.67428,.67428,1.16039,.73291,1.20996,1.22135,1.06483,.94868,.94868,.95996,1.24633,1,1.07497,.87796,.96927,1.01518,.96927,1,1,1,.77295,1,1,1.10539,1.10539,1.11358,1.06967,.86279,.94434,.86279,.94434,.86182,1,1,1.083,1,.91578,.86507,1.1714,1.18416,1.14589,.69825,.97622,1.9697,1.24822,1.24822,1.17238,1.24822,1.24822,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1.42603,1,.99862,.99862,1,.87025,.87025,.87025,.87025,1.18083,1.42603,1,1.42603,1.42603,.99862,1,1,1,1,1,1.2886,1.04315,1.15296,1.34163,1,1,1,1.10938,1.10938,1,1,1,1.05425,1.09971,1.09971,1.09971,1,1,1,1,1,1,1,1,1,1,1];t.SegoeuiRegularMetrics={lineHeight:1.33008,lineGap:0}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.SEAC_ANALYSIS_ENABLED=t.MacStandardGlyphOrdering=t.FontFlags=void 0;t.getFontType=function getFontType(e,t){let r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];switch(e){case"Type1":return r?n.FontType.TYPE1STANDARD:"Type1C"===t?n.FontType.TYPE1C:n.FontType.TYPE1;case"CIDFontType0":return"CIDFontType0C"===t?n.FontType.CIDFONTTYPE0C:n.FontType.CIDFONTTYPE0;case"OpenType":return n.FontType.OPENTYPE;case"TrueType":return n.FontType.TRUETYPE;case"CIDFontType2":return n.FontType.CIDFONTTYPE2;case"MMType1":return n.FontType.MMTYPE1;case"Type0":return n.FontType.TYPE0;default:return n.FontType.UNKNOWN}};t.normalizeFontName=function normalizeFontName(e){return e.replace(/[,_]/g,"-").replace(/\s/g,"")};t.recoverGlyphName=recoverGlyphName;t.type1FontGlyphMapping=function type1FontGlyphMapping(e,t,r){const n=Object.create(null);let s,c,l;const h=!!(e.flags&o.Symbolic);if(e.isInternalFont){l=t;for(c=0;c<l.length;c++){s=r.indexOf(l[c]);n[c]=s>=0?s:0}}else if(e.baseEncodingName){l=(0,a.getEncoding)(e.baseEncodingName);for(c=0;c<l.length;c++){s=r.indexOf(l[c]);n[c]=s>=0?s:0}}else if(h)for(c in t)n[c]=t[c];else{l=a.StandardEncoding;for(c=0;c<l.length;c++){s=r.indexOf(l[c]);n[c]=s>=0?s:0}}const u=e.differences;let d;if(u)for(c in u){const e=u[c];s=r.indexOf(e);if(-1===s){d||(d=(0,i.getGlyphsUnicode)());const t=recoverGlyphName(e,d);t!==e&&(s=r.indexOf(t))}n[c]=s>=0?s:0}return n};r(227);r(159);r(179);var n=r(158),a=r(228),i=r(229),s=r(230);t.SEAC_ANALYSIS_ENABLED=!0;const o={FixedPitch:1,Serif:2,Symbolic:4,Script:8,Nonsymbolic:32,Italic:64,AllCap:65536,SmallCap:131072,ForceBold:262144};t.FontFlags=o;t.MacStandardGlyphOrdering=[".notdef",".null","nonmarkingreturn","space","exclam","quotedbl","numbersign","dollar","percent","ampersand","quotesingle","parenleft","parenright","asterisk","plus","comma","hyphen","period","slash","zero","one","two","three","four","five","six","seven","eight","nine","colon","semicolon","less","equal","greater","question","at","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","bracketleft","backslash","bracketright","asciicircum","underscore","grave","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","braceleft","bar","braceright","asciitilde","Adieresis","Aring","Ccedilla","Eacute","Ntilde","Odieresis","Udieresis","aacute","agrave","acircumflex","adieresis","atilde","aring","ccedilla","eacute","egrave","ecircumflex","edieresis","iacute","igrave","icircumflex","idieresis","ntilde","oacute","ograve","ocircumflex","odieresis","otilde","uacute","ugrave","ucircumflex","udieresis","dagger","degree","cent","sterling","section","bullet","paragraph","germandbls","registered","copyright","trademark","acute","dieresis","notequal","AE","Oslash","infinity","plusminus","lessequal","greaterequal","yen","mu","partialdiff","summation","product","pi","integral","ordfeminine","ordmasculine","Omega","ae","oslash","questiondown","exclamdown","logicalnot","radical","florin","approxequal","Delta","guillemotleft","guillemotright","ellipsis","nonbreakingspace","Agrave","Atilde","Otilde","OE","oe","endash","emdash","quotedblleft","quotedblright","quoteleft","quoteright","divide","lozenge","ydieresis","Ydieresis","fraction","currency","guilsinglleft","guilsinglright","fi","fl","daggerdbl","periodcentered","quotesinglbase","quotedblbase","perthousand","Acircumflex","Ecircumflex","Aacute","Edieresis","Egrave","Iacute","Icircumflex","Idieresis","Igrave","Oacute","Ocircumflex","apple","Ograve","Uacute","Ucircumflex","Ugrave","dotlessi","circumflex","tilde","macron","breve","dotaccent","ring","cedilla","hungarumlaut","ogonek","caron","Lslash","lslash","Scaron","scaron","Zcaron","zcaron","brokenbar","Eth","eth","Yacute","yacute","Thorn","thorn","minus","multiply","onesuperior","twosuperior","threesuperior","onehalf","onequarter","threequarters","franc","Gbreve","gbreve","Idotaccent","Scedilla","scedilla","Cacute","cacute","Ccaron","ccaron","dcroat"];function recoverGlyphName(e,t){if(void 0!==t[e])return e;const r=(0,s.getUnicodeForGlyph)(e,t);if(-1!==r)for(const e in t)if(t[e]===r)return e;(0,n.info)("Unable to recover a standard glyph name for: "+e);return e}},(e,t,r)=>{var n=r(5),a=r(7),i=r(171),s=r(162),o=r(8),c=n.RegExp,l=c.prototype;a&&o((function(){var e=!0;try{c(".","d")}catch(t){e=!1}var t={},r="",n=e?"dgimsy":"gimsy",addGetter=function(e,n){Object.defineProperty(t,e,{get:function(){r+=n;return!0}})},a={dotAll:"s",global:"g",ignoreCase:"i",multiline:"m",sticky:"y"};e&&(a.hasIndices="d");for(var i in a)addGetter(i,a[i]);return Object.getOwnPropertyDescriptor(l,"flags").get.call(t)!==n||r!==n}))&&i(l,"flags",{configurable:!0,get:s})},(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.ZapfDingbatsEncoding=t.WinAnsiEncoding=t.SymbolSetEncoding=t.StandardEncoding=t.MacRomanEncoding=t.ExpertEncoding=void 0;t.getEncoding=function getEncoding(e){switch(e){case"WinAnsiEncoding":return s;case"StandardEncoding":return i;case"MacRomanEncoding":return a;case"SymbolSetEncoding":return o;case"ZapfDingbatsEncoding":return c;case"ExpertEncoding":return r;case"MacExpertEncoding":return n;default:return null}};const r=["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","space","exclamsmall","Hungarumlautsmall","","dollaroldstyle","dollarsuperior","ampersandsmall","Acutesmall","parenleftsuperior","parenrightsuperior","twodotenleader","onedotenleader","comma","hyphen","period","fraction","zerooldstyle","oneoldstyle","twooldstyle","threeoldstyle","fouroldstyle","fiveoldstyle","sixoldstyle","sevenoldstyle","eightoldstyle","nineoldstyle","colon","semicolon","commasuperior","threequartersemdash","periodsuperior","questionsmall","","asuperior","bsuperior","centsuperior","dsuperior","esuperior","","","","isuperior","","","lsuperior","msuperior","nsuperior","osuperior","","","rsuperior","ssuperior","tsuperior","","ff","fi","fl","ffi","ffl","parenleftinferior","","parenrightinferior","Circumflexsmall","hyphensuperior","Gravesmall","Asmall","Bsmall","Csmall","Dsmall","Esmall","Fsmall","Gsmall","Hsmall","Ismall","Jsmall","Ksmall","Lsmall","Msmall","Nsmall","Osmall","Psmall","Qsmall","Rsmall","Ssmall","Tsmall","Usmall","Vsmall","Wsmall","Xsmall","Ysmall","Zsmall","colonmonetary","onefitted","rupiah","Tildesmall","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","exclamdownsmall","centoldstyle","Lslashsmall","","","Scaronsmall","Zcaronsmall","Dieresissmall","Brevesmall","Caronsmall","","Dotaccentsmall","","","Macronsmall","","","figuredash","hypheninferior","","","Ogoneksmall","Ringsmall","Cedillasmall","","","","onequarter","onehalf","threequarters","questiondownsmall","oneeighth","threeeighths","fiveeighths","seveneighths","onethird","twothirds","","","zerosuperior","onesuperior","twosuperior","threesuperior","foursuperior","fivesuperior","sixsuperior","sevensuperior","eightsuperior","ninesuperior","zeroinferior","oneinferior","twoinferior","threeinferior","fourinferior","fiveinferior","sixinferior","seveninferior","eightinferior","nineinferior","centinferior","dollarinferior","periodinferior","commainferior","Agravesmall","Aacutesmall","Acircumflexsmall","Atildesmall","Adieresissmall","Aringsmall","AEsmall","Ccedillasmall","Egravesmall","Eacutesmall","Ecircumflexsmall","Edieresissmall","Igravesmall","Iacutesmall","Icircumflexsmall","Idieresissmall","Ethsmall","Ntildesmall","Ogravesmall","Oacutesmall","Ocircumflexsmall","Otildesmall","Odieresissmall","OEsmall","Oslashsmall","Ugravesmall","Uacutesmall","Ucircumflexsmall","Udieresissmall","Yacutesmall","Thornsmall","Ydieresissmall"];t.ExpertEncoding=r;const n=["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","space","exclamsmall","Hungarumlautsmall","centoldstyle","dollaroldstyle","dollarsuperior","ampersandsmall","Acutesmall","parenleftsuperior","parenrightsuperior","twodotenleader","onedotenleader","comma","hyphen","period","fraction","zerooldstyle","oneoldstyle","twooldstyle","threeoldstyle","fouroldstyle","fiveoldstyle","sixoldstyle","sevenoldstyle","eightoldstyle","nineoldstyle","colon","semicolon","","threequartersemdash","","questionsmall","","","","","Ethsmall","","","onequarter","onehalf","threequarters","oneeighth","threeeighths","fiveeighths","seveneighths","onethird","twothirds","","","","","","","ff","fi","fl","ffi","ffl","parenleftinferior","","parenrightinferior","Circumflexsmall","hypheninferior","Gravesmall","Asmall","Bsmall","Csmall","Dsmall","Esmall","Fsmall","Gsmall","Hsmall","Ismall","Jsmall","Ksmall","Lsmall","Msmall","Nsmall","Osmall","Psmall","Qsmall","Rsmall","Ssmall","Tsmall","Usmall","Vsmall","Wsmall","Xsmall","Ysmall","Zsmall","colonmonetary","onefitted","rupiah","Tildesmall","","","asuperior","centsuperior","","","","","Aacutesmall","Agravesmall","Acircumflexsmall","Adieresissmall","Atildesmall","Aringsmall","Ccedillasmall","Eacutesmall","Egravesmall","Ecircumflexsmall","Edieresissmall","Iacutesmall","Igravesmall","Icircumflexsmall","Idieresissmall","Ntildesmall","Oacutesmall","Ogravesmall","Ocircumflexsmall","Odieresissmall","Otildesmall","Uacutesmall","Ugravesmall","Ucircumflexsmall","Udieresissmall","","eightsuperior","fourinferior","threeinferior","sixinferior","eightinferior","seveninferior","Scaronsmall","","centinferior","twoinferior","","Dieresissmall","","Caronsmall","osuperior","fiveinferior","","commainferior","periodinferior","Yacutesmall","","dollarinferior","","","Thornsmall","","nineinferior","zeroinferior","Zcaronsmall","AEsmall","Oslashsmall","questiondownsmall","oneinferior","Lslashsmall","","","","","","","Cedillasmall","","","","","","OEsmall","figuredash","hyphensuperior","","","","","exclamdownsmall","","Ydieresissmall","","onesuperior","twosuperior","threesuperior","foursuperior","fivesuperior","sixsuperior","sevensuperior","ninesuperior","zerosuperior","","esuperior","rsuperior","tsuperior","","","isuperior","ssuperior","dsuperior","","","","","","lsuperior","Ogoneksmall","Brevesmall","Macronsmall","bsuperior","nsuperior","msuperior","commasuperior","periodsuperior","Dotaccentsmall","Ringsmall","","","",""],a=["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","space","exclam","quotedbl","numbersign","dollar","percent","ampersand","quotesingle","parenleft","parenright","asterisk","plus","comma","hyphen","period","slash","zero","one","two","three","four","five","six","seven","eight","nine","colon","semicolon","less","equal","greater","question","at","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","bracketleft","backslash","bracketright","asciicircum","underscore","grave","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","braceleft","bar","braceright","asciitilde","","Adieresis","Aring","Ccedilla","Eacute","Ntilde","Odieresis","Udieresis","aacute","agrave","acircumflex","adieresis","atilde","aring","ccedilla","eacute","egrave","ecircumflex","edieresis","iacute","igrave","icircumflex","idieresis","ntilde","oacute","ograve","ocircumflex","odieresis","otilde","uacute","ugrave","ucircumflex","udieresis","dagger","degree","cent","sterling","section","bullet","paragraph","germandbls","registered","copyright","trademark","acute","dieresis","notequal","AE","Oslash","infinity","plusminus","lessequal","greaterequal","yen","mu","partialdiff","summation","product","pi","integral","ordfeminine","ordmasculine","Omega","ae","oslash","questiondown","exclamdown","logicalnot","radical","florin","approxequal","Delta","guillemotleft","guillemotright","ellipsis","space","Agrave","Atilde","Otilde","OE","oe","endash","emdash","quotedblleft","quotedblright","quoteleft","quoteright","divide","lozenge","ydieresis","Ydieresis","fraction","currency","guilsinglleft","guilsinglright","fi","fl","daggerdbl","periodcentered","quotesinglbase","quotedblbase","perthousand","Acircumflex","Ecircumflex","Aacute","Edieresis","Egrave","Iacute","Icircumflex","Idieresis","Igrave","Oacute","Ocircumflex","apple","Ograve","Uacute","Ucircumflex","Ugrave","dotlessi","circumflex","tilde","macron","breve","dotaccent","ring","cedilla","hungarumlaut","ogonek","caron"];t.MacRomanEncoding=a;const i=["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","space","exclam","quotedbl","numbersign","dollar","percent","ampersand","quoteright","parenleft","parenright","asterisk","plus","comma","hyphen","period","slash","zero","one","two","three","four","five","six","seven","eight","nine","colon","semicolon","less","equal","greater","question","at","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","bracketleft","backslash","bracketright","asciicircum","underscore","quoteleft","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","braceleft","bar","braceright","asciitilde","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","exclamdown","cent","sterling","fraction","yen","florin","section","currency","quotesingle","quotedblleft","guillemotleft","guilsinglleft","guilsinglright","fi","fl","","endash","dagger","daggerdbl","periodcentered","","paragraph","bullet","quotesinglbase","quotedblbase","quotedblright","guillemotright","ellipsis","perthousand","","questiondown","","grave","acute","circumflex","tilde","macron","breve","dotaccent","dieresis","","ring","cedilla","","hungarumlaut","ogonek","caron","emdash","","","","","","","","","","","","","","","","","AE","","ordfeminine","","","","","Lslash","Oslash","OE","ordmasculine","","","","","","ae","","","","dotlessi","","","lslash","oslash","oe","germandbls","","","",""];t.StandardEncoding=i;const s=["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","space","exclam","quotedbl","numbersign","dollar","percent","ampersand","quotesingle","parenleft","parenright","asterisk","plus","comma","hyphen","period","slash","zero","one","two","three","four","five","six","seven","eight","nine","colon","semicolon","less","equal","greater","question","at","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","bracketleft","backslash","bracketright","asciicircum","underscore","grave","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","braceleft","bar","braceright","asciitilde","bullet","Euro","bullet","quotesinglbase","florin","quotedblbase","ellipsis","dagger","daggerdbl","circumflex","perthousand","Scaron","guilsinglleft","OE","bullet","Zcaron","bullet","bullet","quoteleft","quoteright","quotedblleft","quotedblright","bullet","endash","emdash","tilde","trademark","scaron","guilsinglright","oe","bullet","zcaron","Ydieresis","space","exclamdown","cent","sterling","currency","yen","brokenbar","section","dieresis","copyright","ordfeminine","guillemotleft","logicalnot","hyphen","registered","macron","degree","plusminus","twosuperior","threesuperior","acute","mu","paragraph","periodcentered","cedilla","onesuperior","ordmasculine","guillemotright","onequarter","onehalf","threequarters","questiondown","Agrave","Aacute","Acircumflex","Atilde","Adieresis","Aring","AE","Ccedilla","Egrave","Eacute","Ecircumflex","Edieresis","Igrave","Iacute","Icircumflex","Idieresis","Eth","Ntilde","Ograve","Oacute","Ocircumflex","Otilde","Odieresis","multiply","Oslash","Ugrave","Uacute","Ucircumflex","Udieresis","Yacute","Thorn","germandbls","agrave","aacute","acircumflex","atilde","adieresis","aring","ae","ccedilla","egrave","eacute","ecircumflex","edieresis","igrave","iacute","icircumflex","idieresis","eth","ntilde","ograve","oacute","ocircumflex","otilde","odieresis","divide","oslash","ugrave","uacute","ucircumflex","udieresis","yacute","thorn","ydieresis"];t.WinAnsiEncoding=s;const o=["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","space","exclam","universal","numbersign","existential","percent","ampersand","suchthat","parenleft","parenright","asteriskmath","plus","comma","minus","period","slash","zero","one","two","three","four","five","six","seven","eight","nine","colon","semicolon","less","equal","greater","question","congruent","Alpha","Beta","Chi","Delta","Epsilon","Phi","Gamma","Eta","Iota","theta1","Kappa","Lambda","Mu","Nu","Omicron","Pi","Theta","Rho","Sigma","Tau","Upsilon","sigma1","Omega","Xi","Psi","Zeta","bracketleft","therefore","bracketright","perpendicular","underscore","radicalex","alpha","beta","chi","delta","epsilon","phi","gamma","eta","iota","phi1","kappa","lambda","mu","nu","omicron","pi","theta","rho","sigma","tau","upsilon","omega1","omega","xi","psi","zeta","braceleft","bar","braceright","similar","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","Euro","Upsilon1","minute","lessequal","fraction","infinity","florin","club","diamond","heart","spade","arrowboth","arrowleft","arrowup","arrowright","arrowdown","degree","plusminus","second","greaterequal","multiply","proportional","partialdiff","bullet","divide","notequal","equivalence","approxequal","ellipsis","arrowvertex","arrowhorizex","carriagereturn","aleph","Ifraktur","Rfraktur","weierstrass","circlemultiply","circleplus","emptyset","intersection","union","propersuperset","reflexsuperset","notsubset","propersubset","reflexsubset","element","notelement","angle","gradient","registerserif","copyrightserif","trademarkserif","product","radical","dotmath","logicalnot","logicaland","logicalor","arrowdblboth","arrowdblleft","arrowdblup","arrowdblright","arrowdbldown","lozenge","angleleft","registersans","copyrightsans","trademarksans","summation","parenlefttp","parenleftex","parenleftbt","bracketlefttp","bracketleftex","bracketleftbt","bracelefttp","braceleftmid","braceleftbt","braceex","","angleright","integral","integraltp","integralex","integralbt","parenrighttp","parenrightex","parenrightbt","bracketrighttp","bracketrightex","bracketrightbt","bracerighttp","bracerightmid","bracerightbt",""];t.SymbolSetEncoding=o;const c=["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","space","a1","a2","a202","a3","a4","a5","a119","a118","a117","a11","a12","a13","a14","a15","a16","a105","a17","a18","a19","a20","a21","a22","a23","a24","a25","a26","a27","a28","a6","a7","a8","a9","a10","a29","a30","a31","a32","a33","a34","a35","a36","a37","a38","a39","a40","a41","a42","a43","a44","a45","a46","a47","a48","a49","a50","a51","a52","a53","a54","a55","a56","a57","a58","a59","a60","a61","a62","a63","a64","a65","a66","a67","a68","a69","a70","a71","a72","a73","a74","a203","a75","a204","a76","a77","a78","a79","a81","a82","a83","a84","a97","a98","a99","a100","","a89","a90","a93","a94","a91","a92","a205","a85","a206","a86","a87","a88","a95","a96","","","","","","","","","","","","","","","","","","","","a101","a102","a103","a104","a106","a107","a108","a112","a111","a110","a109","a120","a121","a122","a123","a124","a125","a126","a127","a128","a129","a130","a131","a132","a133","a134","a135","a136","a137","a138","a139","a140","a141","a142","a143","a144","a145","a146","a147","a148","a149","a150","a151","a152","a153","a154","a155","a156","a157","a158","a159","a160","a161","a163","a164","a196","a165","a192","a166","a167","a168","a169","a170","a171","a172","a173","a162","a174","a175","a176","a177","a178","a179","a193","a180","a199","a181","a200","a182","","a201","a183","a184","a197","a185","a194","a198","a186","a195","a187","a188","a189","a190","a191",""];t.ZapfDingbatsEncoding=c},(e,t,r)=>{"use strict";r.r(t);r.d(t,{getDingbatsGlyphsUnicode:()=>i,getGlyphsUnicode:()=>a});var n=r(213);const a=(0,n.getArrayLookupTableFactory)((function(){return["A",65,"AE",198,"AEacute",508,"AEmacron",482,"AEsmall",63462,"Aacute",193,"Aacutesmall",63457,"Abreve",258,"Abreveacute",7854,"Abrevecyrillic",1232,"Abrevedotbelow",7862,"Abrevegrave",7856,"Abrevehookabove",7858,"Abrevetilde",7860,"Acaron",461,"Acircle",9398,"Acircumflex",194,"Acircumflexacute",7844,"Acircumflexdotbelow",7852,"Acircumflexgrave",7846,"Acircumflexhookabove",7848,"Acircumflexsmall",63458,"Acircumflextilde",7850,"Acute",63177,"Acutesmall",63412,"Acyrillic",1040,"Adblgrave",512,"Adieresis",196,"Adieresiscyrillic",1234,"Adieresismacron",478,"Adieresissmall",63460,"Adotbelow",7840,"Adotmacron",480,"Agrave",192,"Agravesmall",63456,"Ahookabove",7842,"Aiecyrillic",1236,"Ainvertedbreve",514,"Alpha",913,"Alphatonos",902,"Amacron",256,"Amonospace",65313,"Aogonek",260,"Aring",197,"Aringacute",506,"Aringbelow",7680,"Aringsmall",63461,"Asmall",63329,"Atilde",195,"Atildesmall",63459,"Aybarmenian",1329,"B",66,"Bcircle",9399,"Bdotaccent",7682,"Bdotbelow",7684,"Becyrillic",1041,"Benarmenian",1330,"Beta",914,"Bhook",385,"Blinebelow",7686,"Bmonospace",65314,"Brevesmall",63220,"Bsmall",63330,"Btopbar",386,"C",67,"Caarmenian",1342,"Cacute",262,"Caron",63178,"Caronsmall",63221,"Ccaron",268,"Ccedilla",199,"Ccedillaacute",7688,"Ccedillasmall",63463,"Ccircle",9400,"Ccircumflex",264,"Cdot",266,"Cdotaccent",266,"Cedillasmall",63416,"Chaarmenian",1353,"Cheabkhasiancyrillic",1212,"Checyrillic",1063,"Chedescenderabkhasiancyrillic",1214,"Chedescendercyrillic",1206,"Chedieresiscyrillic",1268,"Cheharmenian",1347,"Chekhakassiancyrillic",1227,"Cheverticalstrokecyrillic",1208,"Chi",935,"Chook",391,"Circumflexsmall",63222,"Cmonospace",65315,"Coarmenian",1361,"Csmall",63331,"D",68,"DZ",497,"DZcaron",452,"Daarmenian",1332,"Dafrican",393,"Dcaron",270,"Dcedilla",7696,"Dcircle",9401,"Dcircumflexbelow",7698,"Dcroat",272,"Ddotaccent",7690,"Ddotbelow",7692,"Decyrillic",1044,"Deicoptic",1006,"Delta",8710,"Deltagreek",916,"Dhook",394,"Dieresis",63179,"DieresisAcute",63180,"DieresisGrave",63181,"Dieresissmall",63400,"Digammagreek",988,"Djecyrillic",1026,"Dlinebelow",7694,"Dmonospace",65316,"Dotaccentsmall",63223,"Dslash",272,"Dsmall",63332,"Dtopbar",395,"Dz",498,"Dzcaron",453,"Dzeabkhasiancyrillic",1248,"Dzecyrillic",1029,"Dzhecyrillic",1039,"E",69,"Eacute",201,"Eacutesmall",63465,"Ebreve",276,"Ecaron",282,"Ecedillabreve",7708,"Echarmenian",1333,"Ecircle",9402,"Ecircumflex",202,"Ecircumflexacute",7870,"Ecircumflexbelow",7704,"Ecircumflexdotbelow",7878,"Ecircumflexgrave",7872,"Ecircumflexhookabove",7874,"Ecircumflexsmall",63466,"Ecircumflextilde",7876,"Ecyrillic",1028,"Edblgrave",516,"Edieresis",203,"Edieresissmall",63467,"Edot",278,"Edotaccent",278,"Edotbelow",7864,"Efcyrillic",1060,"Egrave",200,"Egravesmall",63464,"Eharmenian",1335,"Ehookabove",7866,"Eightroman",8551,"Einvertedbreve",518,"Eiotifiedcyrillic",1124,"Elcyrillic",1051,"Elevenroman",8554,"Emacron",274,"Emacronacute",7702,"Emacrongrave",7700,"Emcyrillic",1052,"Emonospace",65317,"Encyrillic",1053,"Endescendercyrillic",1186,"Eng",330,"Enghecyrillic",1188,"Enhookcyrillic",1223,"Eogonek",280,"Eopen",400,"Epsilon",917,"Epsilontonos",904,"Ercyrillic",1056,"Ereversed",398,"Ereversedcyrillic",1069,"Escyrillic",1057,"Esdescendercyrillic",1194,"Esh",425,"Esmall",63333,"Eta",919,"Etarmenian",1336,"Etatonos",905,"Eth",208,"Ethsmall",63472,"Etilde",7868,"Etildebelow",7706,"Euro",8364,"Ezh",439,"Ezhcaron",494,"Ezhreversed",440,"F",70,"Fcircle",9403,"Fdotaccent",7710,"Feharmenian",1366,"Feicoptic",996,"Fhook",401,"Fitacyrillic",1138,"Fiveroman",8548,"Fmonospace",65318,"Fourroman",8547,"Fsmall",63334,"G",71,"GBsquare",13191,"Gacute",500,"Gamma",915,"Gammaafrican",404,"Gangiacoptic",1002,"Gbreve",286,"Gcaron",486,"Gcedilla",290,"Gcircle",9404,"Gcircumflex",284,"Gcommaaccent",290,"Gdot",288,"Gdotaccent",288,"Gecyrillic",1043,"Ghadarmenian",1346,"Ghemiddlehookcyrillic",1172,"Ghestrokecyrillic",1170,"Gheupturncyrillic",1168,"Ghook",403,"Gimarmenian",1331,"Gjecyrillic",1027,"Gmacron",7712,"Gmonospace",65319,"Grave",63182,"Gravesmall",63328,"Gsmall",63335,"Gsmallhook",667,"Gstroke",484,"H",72,"H18533",9679,"H18543",9642,"H18551",9643,"H22073",9633,"HPsquare",13259,"Haabkhasiancyrillic",1192,"Hadescendercyrillic",1202,"Hardsigncyrillic",1066,"Hbar",294,"Hbrevebelow",7722,"Hcedilla",7720,"Hcircle",9405,"Hcircumflex",292,"Hdieresis",7718,"Hdotaccent",7714,"Hdotbelow",7716,"Hmonospace",65320,"Hoarmenian",1344,"Horicoptic",1e3,"Hsmall",63336,"Hungarumlaut",63183,"Hungarumlautsmall",63224,"Hzsquare",13200,"I",73,"IAcyrillic",1071,"IJ",306,"IUcyrillic",1070,"Iacute",205,"Iacutesmall",63469,"Ibreve",300,"Icaron",463,"Icircle",9406,"Icircumflex",206,"Icircumflexsmall",63470,"Icyrillic",1030,"Idblgrave",520,"Idieresis",207,"Idieresisacute",7726,"Idieresiscyrillic",1252,"Idieresissmall",63471,"Idot",304,"Idotaccent",304,"Idotbelow",7882,"Iebrevecyrillic",1238,"Iecyrillic",1045,"Ifraktur",8465,"Igrave",204,"Igravesmall",63468,"Ihookabove",7880,"Iicyrillic",1048,"Iinvertedbreve",522,"Iishortcyrillic",1049,"Imacron",298,"Imacroncyrillic",1250,"Imonospace",65321,"Iniarmenian",1339,"Iocyrillic",1025,"Iogonek",302,"Iota",921,"Iotaafrican",406,"Iotadieresis",938,"Iotatonos",906,"Ismall",63337,"Istroke",407,"Itilde",296,"Itildebelow",7724,"Izhitsacyrillic",1140,"Izhitsadblgravecyrillic",1142,"J",74,"Jaarmenian",1345,"Jcircle",9407,"Jcircumflex",308,"Jecyrillic",1032,"Jheharmenian",1355,"Jmonospace",65322,"Jsmall",63338,"K",75,"KBsquare",13189,"KKsquare",13261,"Kabashkircyrillic",1184,"Kacute",7728,"Kacyrillic",1050,"Kadescendercyrillic",1178,"Kahookcyrillic",1219,"Kappa",922,"Kastrokecyrillic",1182,"Kaverticalstrokecyrillic",1180,"Kcaron",488,"Kcedilla",310,"Kcircle",9408,"Kcommaaccent",310,"Kdotbelow",7730,"Keharmenian",1364,"Kenarmenian",1343,"Khacyrillic",1061,"Kheicoptic",998,"Khook",408,"Kjecyrillic",1036,"Klinebelow",7732,"Kmonospace",65323,"Koppacyrillic",1152,"Koppagreek",990,"Ksicyrillic",1134,"Ksmall",63339,"L",76,"LJ",455,"LL",63167,"Lacute",313,"Lambda",923,"Lcaron",317,"Lcedilla",315,"Lcircle",9409,"Lcircumflexbelow",7740,"Lcommaaccent",315,"Ldot",319,"Ldotaccent",319,"Ldotbelow",7734,"Ldotbelowmacron",7736,"Liwnarmenian",1340,"Lj",456,"Ljecyrillic",1033,"Llinebelow",7738,"Lmonospace",65324,"Lslash",321,"Lslashsmall",63225,"Lsmall",63340,"M",77,"MBsquare",13190,"Macron",63184,"Macronsmall",63407,"Macute",7742,"Mcircle",9410,"Mdotaccent",7744,"Mdotbelow",7746,"Menarmenian",1348,"Mmonospace",65325,"Msmall",63341,"Mturned",412,"Mu",924,"N",78,"NJ",458,"Nacute",323,"Ncaron",327,"Ncedilla",325,"Ncircle",9411,"Ncircumflexbelow",7754,"Ncommaaccent",325,"Ndotaccent",7748,"Ndotbelow",7750,"Nhookleft",413,"Nineroman",8552,"Nj",459,"Njecyrillic",1034,"Nlinebelow",7752,"Nmonospace",65326,"Nowarmenian",1350,"Nsmall",63342,"Ntilde",209,"Ntildesmall",63473,"Nu",925,"O",79,"OE",338,"OEsmall",63226,"Oacute",211,"Oacutesmall",63475,"Obarredcyrillic",1256,"Obarreddieresiscyrillic",1258,"Obreve",334,"Ocaron",465,"Ocenteredtilde",415,"Ocircle",9412,"Ocircumflex",212,"Ocircumflexacute",7888,"Ocircumflexdotbelow",7896,"Ocircumflexgrave",7890,"Ocircumflexhookabove",7892,"Ocircumflexsmall",63476,"Ocircumflextilde",7894,"Ocyrillic",1054,"Odblacute",336,"Odblgrave",524,"Odieresis",214,"Odieresiscyrillic",1254,"Odieresissmall",63478,"Odotbelow",7884,"Ogoneksmall",63227,"Ograve",210,"Ogravesmall",63474,"Oharmenian",1365,"Ohm",8486,"Ohookabove",7886,"Ohorn",416,"Ohornacute",7898,"Ohorndotbelow",7906,"Ohorngrave",7900,"Ohornhookabove",7902,"Ohorntilde",7904,"Ohungarumlaut",336,"Oi",418,"Oinvertedbreve",526,"Omacron",332,"Omacronacute",7762,"Omacrongrave",7760,"Omega",8486,"Omegacyrillic",1120,"Omegagreek",937,"Omegaroundcyrillic",1146,"Omegatitlocyrillic",1148,"Omegatonos",911,"Omicron",927,"Omicrontonos",908,"Omonospace",65327,"Oneroman",8544,"Oogonek",490,"Oogonekmacron",492,"Oopen",390,"Oslash",216,"Oslashacute",510,"Oslashsmall",63480,"Osmall",63343,"Ostrokeacute",510,"Otcyrillic",1150,"Otilde",213,"Otildeacute",7756,"Otildedieresis",7758,"Otildesmall",63477,"P",80,"Pacute",7764,"Pcircle",9413,"Pdotaccent",7766,"Pecyrillic",1055,"Peharmenian",1354,"Pemiddlehookcyrillic",1190,"Phi",934,"Phook",420,"Pi",928,"Piwrarmenian",1363,"Pmonospace",65328,"Psi",936,"Psicyrillic",1136,"Psmall",63344,"Q",81,"Qcircle",9414,"Qmonospace",65329,"Qsmall",63345,"R",82,"Raarmenian",1356,"Racute",340,"Rcaron",344,"Rcedilla",342,"Rcircle",9415,"Rcommaaccent",342,"Rdblgrave",528,"Rdotaccent",7768,"Rdotbelow",7770,"Rdotbelowmacron",7772,"Reharmenian",1360,"Rfraktur",8476,"Rho",929,"Ringsmall",63228,"Rinvertedbreve",530,"Rlinebelow",7774,"Rmonospace",65330,"Rsmall",63346,"Rsmallinverted",641,"Rsmallinvertedsuperior",694,"S",83,"SF010000",9484,"SF020000",9492,"SF030000",9488,"SF040000",9496,"SF050000",9532,"SF060000",9516,"SF070000",9524,"SF080000",9500,"SF090000",9508,"SF100000",9472,"SF110000",9474,"SF190000",9569,"SF200000",9570,"SF210000",9558,"SF220000",9557,"SF230000",9571,"SF240000",9553,"SF250000",9559,"SF260000",9565,"SF270000",9564,"SF280000",9563,"SF360000",9566,"SF370000",9567,"SF380000",9562,"SF390000",9556,"SF400000",9577,"SF410000",9574,"SF420000",9568,"SF430000",9552,"SF440000",9580,"SF450000",9575,"SF460000",9576,"SF470000",9572,"SF480000",9573,"SF490000",9561,"SF500000",9560,"SF510000",9554,"SF520000",9555,"SF530000",9579,"SF540000",9578,"Sacute",346,"Sacutedotaccent",7780,"Sampigreek",992,"Scaron",352,"Scarondotaccent",7782,"Scaronsmall",63229,"Scedilla",350,"Schwa",399,"Schwacyrillic",1240,"Schwadieresiscyrillic",1242,"Scircle",9416,"Scircumflex",348,"Scommaaccent",536,"Sdotaccent",7776,"Sdotbelow",7778,"Sdotbelowdotaccent",7784,"Seharmenian",1357,"Sevenroman",8550,"Shaarmenian",1351,"Shacyrillic",1064,"Shchacyrillic",1065,"Sheicoptic",994,"Shhacyrillic",1210,"Shimacoptic",1004,"Sigma",931,"Sixroman",8549,"Smonospace",65331,"Softsigncyrillic",1068,"Ssmall",63347,"Stigmagreek",986,"T",84,"Tau",932,"Tbar",358,"Tcaron",356,"Tcedilla",354,"Tcircle",9417,"Tcircumflexbelow",7792,"Tcommaaccent",354,"Tdotaccent",7786,"Tdotbelow",7788,"Tecyrillic",1058,"Tedescendercyrillic",1196,"Tenroman",8553,"Tetsecyrillic",1204,"Theta",920,"Thook",428,"Thorn",222,"Thornsmall",63486,"Threeroman",8546,"Tildesmall",63230,"Tiwnarmenian",1359,"Tlinebelow",7790,"Tmonospace",65332,"Toarmenian",1337,"Tonefive",444,"Tonesix",388,"Tonetwo",423,"Tretroflexhook",430,"Tsecyrillic",1062,"Tshecyrillic",1035,"Tsmall",63348,"Twelveroman",8555,"Tworoman",8545,"U",85,"Uacute",218,"Uacutesmall",63482,"Ubreve",364,"Ucaron",467,"Ucircle",9418,"Ucircumflex",219,"Ucircumflexbelow",7798,"Ucircumflexsmall",63483,"Ucyrillic",1059,"Udblacute",368,"Udblgrave",532,"Udieresis",220,"Udieresisacute",471,"Udieresisbelow",7794,"Udieresiscaron",473,"Udieresiscyrillic",1264,"Udieresisgrave",475,"Udieresismacron",469,"Udieresissmall",63484,"Udotbelow",7908,"Ugrave",217,"Ugravesmall",63481,"Uhookabove",7910,"Uhorn",431,"Uhornacute",7912,"Uhorndotbelow",7920,"Uhorngrave",7914,"Uhornhookabove",7916,"Uhorntilde",7918,"Uhungarumlaut",368,"Uhungarumlautcyrillic",1266,"Uinvertedbreve",534,"Ukcyrillic",1144,"Umacron",362,"Umacroncyrillic",1262,"Umacrondieresis",7802,"Umonospace",65333,"Uogonek",370,"Upsilon",933,"Upsilon1",978,"Upsilonacutehooksymbolgreek",979,"Upsilonafrican",433,"Upsilondieresis",939,"Upsilondieresishooksymbolgreek",980,"Upsilonhooksymbol",978,"Upsilontonos",910,"Uring",366,"Ushortcyrillic",1038,"Usmall",63349,"Ustraightcyrillic",1198,"Ustraightstrokecyrillic",1200,"Utilde",360,"Utildeacute",7800,"Utildebelow",7796,"V",86,"Vcircle",9419,"Vdotbelow",7806,"Vecyrillic",1042,"Vewarmenian",1358,"Vhook",434,"Vmonospace",65334,"Voarmenian",1352,"Vsmall",63350,"Vtilde",7804,"W",87,"Wacute",7810,"Wcircle",9420,"Wcircumflex",372,"Wdieresis",7812,"Wdotaccent",7814,"Wdotbelow",7816,"Wgrave",7808,"Wmonospace",65335,"Wsmall",63351,"X",88,"Xcircle",9421,"Xdieresis",7820,"Xdotaccent",7818,"Xeharmenian",1341,"Xi",926,"Xmonospace",65336,"Xsmall",63352,"Y",89,"Yacute",221,"Yacutesmall",63485,"Yatcyrillic",1122,"Ycircle",9422,"Ycircumflex",374,"Ydieresis",376,"Ydieresissmall",63487,"Ydotaccent",7822,"Ydotbelow",7924,"Yericyrillic",1067,"Yerudieresiscyrillic",1272,"Ygrave",7922,"Yhook",435,"Yhookabove",7926,"Yiarmenian",1349,"Yicyrillic",1031,"Yiwnarmenian",1362,"Ymonospace",65337,"Ysmall",63353,"Ytilde",7928,"Yusbigcyrillic",1130,"Yusbigiotifiedcyrillic",1132,"Yuslittlecyrillic",1126,"Yuslittleiotifiedcyrillic",1128,"Z",90,"Zaarmenian",1334,"Zacute",377,"Zcaron",381,"Zcaronsmall",63231,"Zcircle",9423,"Zcircumflex",7824,"Zdot",379,"Zdotaccent",379,"Zdotbelow",7826,"Zecyrillic",1047,"Zedescendercyrillic",1176,"Zedieresiscyrillic",1246,"Zeta",918,"Zhearmenian",1338,"Zhebrevecyrillic",1217,"Zhecyrillic",1046,"Zhedescendercyrillic",1174,"Zhedieresiscyrillic",1244,"Zlinebelow",7828,"Zmonospace",65338,"Zsmall",63354,"Zstroke",437,"a",97,"aabengali",2438,"aacute",225,"aadeva",2310,"aagujarati",2694,"aagurmukhi",2566,"aamatragurmukhi",2622,"aarusquare",13059,"aavowelsignbengali",2494,"aavowelsigndeva",2366,"aavowelsigngujarati",2750,"abbreviationmarkarmenian",1375,"abbreviationsigndeva",2416,"abengali",2437,"abopomofo",12570,"abreve",259,"abreveacute",7855,"abrevecyrillic",1233,"abrevedotbelow",7863,"abrevegrave",7857,"abrevehookabove",7859,"abrevetilde",7861,"acaron",462,"acircle",9424,"acircumflex",226,"acircumflexacute",7845,"acircumflexdotbelow",7853,"acircumflexgrave",7847,"acircumflexhookabove",7849,"acircumflextilde",7851,"acute",180,"acutebelowcmb",791,"acutecmb",769,"acutecomb",769,"acutedeva",2388,"acutelowmod",719,"acutetonecmb",833,"acyrillic",1072,"adblgrave",513,"addakgurmukhi",2673,"adeva",2309,"adieresis",228,"adieresiscyrillic",1235,"adieresismacron",479,"adotbelow",7841,"adotmacron",481,"ae",230,"aeacute",509,"aekorean",12624,"aemacron",483,"afii00208",8213,"afii08941",8356,"afii10017",1040,"afii10018",1041,"afii10019",1042,"afii10020",1043,"afii10021",1044,"afii10022",1045,"afii10023",1025,"afii10024",1046,"afii10025",1047,"afii10026",1048,"afii10027",1049,"afii10028",1050,"afii10029",1051,"afii10030",1052,"afii10031",1053,"afii10032",1054,"afii10033",1055,"afii10034",1056,"afii10035",1057,"afii10036",1058,"afii10037",1059,"afii10038",1060,"afii10039",1061,"afii10040",1062,"afii10041",1063,"afii10042",1064,"afii10043",1065,"afii10044",1066,"afii10045",1067,"afii10046",1068,"afii10047",1069,"afii10048",1070,"afii10049",1071,"afii10050",1168,"afii10051",1026,"afii10052",1027,"afii10053",1028,"afii10054",1029,"afii10055",1030,"afii10056",1031,"afii10057",1032,"afii10058",1033,"afii10059",1034,"afii10060",1035,"afii10061",1036,"afii10062",1038,"afii10063",63172,"afii10064",63173,"afii10065",1072,"afii10066",1073,"afii10067",1074,"afii10068",1075,"afii10069",1076,"afii10070",1077,"afii10071",1105,"afii10072",1078,"afii10073",1079,"afii10074",1080,"afii10075",1081,"afii10076",1082,"afii10077",1083,"afii10078",1084,"afii10079",1085,"afii10080",1086,"afii10081",1087,"afii10082",1088,"afii10083",1089,"afii10084",1090,"afii10085",1091,"afii10086",1092,"afii10087",1093,"afii10088",1094,"afii10089",1095,"afii10090",1096,"afii10091",1097,"afii10092",1098,"afii10093",1099,"afii10094",1100,"afii10095",1101,"afii10096",1102,"afii10097",1103,"afii10098",1169,"afii10099",1106,"afii10100",1107,"afii10101",1108,"afii10102",1109,"afii10103",1110,"afii10104",1111,"afii10105",1112,"afii10106",1113,"afii10107",1114,"afii10108",1115,"afii10109",1116,"afii10110",1118,"afii10145",1039,"afii10146",1122,"afii10147",1138,"afii10148",1140,"afii10192",63174,"afii10193",1119,"afii10194",1123,"afii10195",1139,"afii10196",1141,"afii10831",63175,"afii10832",63176,"afii10846",1241,"afii299",8206,"afii300",8207,"afii301",8205,"afii57381",1642,"afii57388",1548,"afii57392",1632,"afii57393",1633,"afii57394",1634,"afii57395",1635,"afii57396",1636,"afii57397",1637,"afii57398",1638,"afii57399",1639,"afii57400",1640,"afii57401",1641,"afii57403",1563,"afii57407",1567,"afii57409",1569,"afii57410",1570,"afii57411",1571,"afii57412",1572,"afii57413",1573,"afii57414",1574,"afii57415",1575,"afii57416",1576,"afii57417",1577,"afii57418",1578,"afii57419",1579,"afii57420",1580,"afii57421",1581,"afii57422",1582,"afii57423",1583,"afii57424",1584,"afii57425",1585,"afii57426",1586,"afii57427",1587,"afii57428",1588,"afii57429",1589,"afii57430",1590,"afii57431",1591,"afii57432",1592,"afii57433",1593,"afii57434",1594,"afii57440",1600,"afii57441",1601,"afii57442",1602,"afii57443",1603,"afii57444",1604,"afii57445",1605,"afii57446",1606,"afii57448",1608,"afii57449",1609,"afii57450",1610,"afii57451",1611,"afii57452",1612,"afii57453",1613,"afii57454",1614,"afii57455",1615,"afii57456",1616,"afii57457",1617,"afii57458",1618,"afii57470",1607,"afii57505",1700,"afii57506",1662,"afii57507",1670,"afii57508",1688,"afii57509",1711,"afii57511",1657,"afii57512",1672,"afii57513",1681,"afii57514",1722,"afii57519",1746,"afii57534",1749,"afii57636",8362,"afii57645",1470,"afii57658",1475,"afii57664",1488,"afii57665",1489,"afii57666",1490,"afii57667",1491,"afii57668",1492,"afii57669",1493,"afii57670",1494,"afii57671",1495,"afii57672",1496,"afii57673",1497,"afii57674",1498,"afii57675",1499,"afii57676",1500,"afii57677",1501,"afii57678",1502,"afii57679",1503,"afii57680",1504,"afii57681",1505,"afii57682",1506,"afii57683",1507,"afii57684",1508,"afii57685",1509,"afii57686",1510,"afii57687",1511,"afii57688",1512,"afii57689",1513,"afii57690",1514,"afii57694",64298,"afii57695",64299,"afii57700",64331,"afii57705",64287,"afii57716",1520,"afii57717",1521,"afii57718",1522,"afii57723",64309,"afii57793",1460,"afii57794",1461,"afii57795",1462,"afii57796",1467,"afii57797",1464,"afii57798",1463,"afii57799",1456,"afii57800",1458,"afii57801",1457,"afii57802",1459,"afii57803",1474,"afii57804",1473,"afii57806",1465,"afii57807",1468,"afii57839",1469,"afii57841",1471,"afii57842",1472,"afii57929",700,"afii61248",8453,"afii61289",8467,"afii61352",8470,"afii61573",8236,"afii61574",8237,"afii61575",8238,"afii61664",8204,"afii63167",1645,"afii64937",701,"agrave",224,"agujarati",2693,"agurmukhi",2565,"ahiragana",12354,"ahookabove",7843,"aibengali",2448,"aibopomofo",12574,"aideva",2320,"aiecyrillic",1237,"aigujarati",2704,"aigurmukhi",2576,"aimatragurmukhi",2632,"ainarabic",1593,"ainfinalarabic",65226,"aininitialarabic",65227,"ainmedialarabic",65228,"ainvertedbreve",515,"aivowelsignbengali",2504,"aivowelsigndeva",2376,"aivowelsigngujarati",2760,"akatakana",12450,"akatakanahalfwidth",65393,"akorean",12623,"alef",1488,"alefarabic",1575,"alefdageshhebrew",64304,"aleffinalarabic",65166,"alefhamzaabovearabic",1571,"alefhamzaabovefinalarabic",65156,"alefhamzabelowarabic",1573,"alefhamzabelowfinalarabic",65160,"alefhebrew",1488,"aleflamedhebrew",64335,"alefmaddaabovearabic",1570,"alefmaddaabovefinalarabic",65154,"alefmaksuraarabic",1609,"alefmaksurafinalarabic",65264,"alefmaksurainitialarabic",65267,"alefmaksuramedialarabic",65268,"alefpatahhebrew",64302,"alefqamatshebrew",64303,"aleph",8501,"allequal",8780,"alpha",945,"alphatonos",940,"amacron",257,"amonospace",65345,"ampersand",38,"ampersandmonospace",65286,"ampersandsmall",63270,"amsquare",13250,"anbopomofo",12578,"angbopomofo",12580,"angbracketleft",12296,"angbracketright",12297,"angkhankhuthai",3674,"angle",8736,"anglebracketleft",12296,"anglebracketleftvertical",65087,"anglebracketright",12297,"anglebracketrightvertical",65088,"angleleft",9001,"angleright",9002,"angstrom",8491,"anoteleia",903,"anudattadeva",2386,"anusvarabengali",2434,"anusvaradeva",2306,"anusvaragujarati",2690,"aogonek",261,"apaatosquare",13056,"aparen",9372,"apostrophearmenian",1370,"apostrophemod",700,"apple",63743,"approaches",8784,"approxequal",8776,"approxequalorimage",8786,"approximatelyequal",8773,"araeaekorean",12686,"araeakorean",12685,"arc",8978,"arighthalfring",7834,"aring",229,"aringacute",507,"aringbelow",7681,"arrowboth",8596,"arrowdashdown",8675,"arrowdashleft",8672,"arrowdashright",8674,"arrowdashup",8673,"arrowdblboth",8660,"arrowdbldown",8659,"arrowdblleft",8656,"arrowdblright",8658,"arrowdblup",8657,"arrowdown",8595,"arrowdownleft",8601,"arrowdownright",8600,"arrowdownwhite",8681,"arrowheaddownmod",709,"arrowheadleftmod",706,"arrowheadrightmod",707,"arrowheadupmod",708,"arrowhorizex",63719,"arrowleft",8592,"arrowleftdbl",8656,"arrowleftdblstroke",8653,"arrowleftoverright",8646,"arrowleftwhite",8678,"arrowright",8594,"arrowrightdblstroke",8655,"arrowrightheavy",10142,"arrowrightoverleft",8644,"arrowrightwhite",8680,"arrowtableft",8676,"arrowtabright",8677,"arrowup",8593,"arrowupdn",8597,"arrowupdnbse",8616,"arrowupdownbase",8616,"arrowupleft",8598,"arrowupleftofdown",8645,"arrowupright",8599,"arrowupwhite",8679,"arrowvertex",63718,"asciicircum",94,"asciicircummonospace",65342,"asciitilde",126,"asciitildemonospace",65374,"ascript",593,"ascriptturned",594,"asmallhiragana",12353,"asmallkatakana",12449,"asmallkatakanahalfwidth",65383,"asterisk",42,"asteriskaltonearabic",1645,"asteriskarabic",1645,"asteriskmath",8727,"asteriskmonospace",65290,"asterisksmall",65121,"asterism",8258,"asuperior",63209,"asymptoticallyequal",8771,"at",64,"atilde",227,"atmonospace",65312,"atsmall",65131,"aturned",592,"aubengali",2452,"aubopomofo",12576,"audeva",2324,"augujarati",2708,"augurmukhi",2580,"aulengthmarkbengali",2519,"aumatragurmukhi",2636,"auvowelsignbengali",2508,"auvowelsigndeva",2380,"auvowelsigngujarati",2764,"avagrahadeva",2365,"aybarmenian",1377,"ayin",1506,"ayinaltonehebrew",64288,"ayinhebrew",1506,"b",98,"babengali",2476,"backslash",92,"backslashmonospace",65340,"badeva",2348,"bagujarati",2732,"bagurmukhi",2604,"bahiragana",12400,"bahtthai",3647,"bakatakana",12496,"bar",124,"barmonospace",65372,"bbopomofo",12549,"bcircle",9425,"bdotaccent",7683,"bdotbelow",7685,"beamedsixteenthnotes",9836,"because",8757,"becyrillic",1073,"beharabic",1576,"behfinalarabic",65168,"behinitialarabic",65169,"behiragana",12409,"behmedialarabic",65170,"behmeeminitialarabic",64671,"behmeemisolatedarabic",64520,"behnoonfinalarabic",64621,"bekatakana",12505,"benarmenian",1378,"bet",1489,"beta",946,"betasymbolgreek",976,"betdagesh",64305,"betdageshhebrew",64305,"bethebrew",1489,"betrafehebrew",64332,"bhabengali",2477,"bhadeva",2349,"bhagujarati",2733,"bhagurmukhi",2605,"bhook",595,"bihiragana",12403,"bikatakana",12499,"bilabialclick",664,"bindigurmukhi",2562,"birusquare",13105,"blackcircle",9679,"blackdiamond",9670,"blackdownpointingtriangle",9660,"blackleftpointingpointer",9668,"blackleftpointingtriangle",9664,"blacklenticularbracketleft",12304,"blacklenticularbracketleftvertical",65083,"blacklenticularbracketright",12305,"blacklenticularbracketrightvertical",65084,"blacklowerlefttriangle",9699,"blacklowerrighttriangle",9698,"blackrectangle",9644,"blackrightpointingpointer",9658,"blackrightpointingtriangle",9654,"blacksmallsquare",9642,"blacksmilingface",9787,"blacksquare",9632,"blackstar",9733,"blackupperlefttriangle",9700,"blackupperrighttriangle",9701,"blackuppointingsmalltriangle",9652,"blackuppointingtriangle",9650,"blank",9251,"blinebelow",7687,"block",9608,"bmonospace",65346,"bobaimaithai",3610,"bohiragana",12412,"bokatakana",12508,"bparen",9373,"bqsquare",13251,"braceex",63732,"braceleft",123,"braceleftbt",63731,"braceleftmid",63730,"braceleftmonospace",65371,"braceleftsmall",65115,"bracelefttp",63729,"braceleftvertical",65079,"braceright",125,"bracerightbt",63742,"bracerightmid",63741,"bracerightmonospace",65373,"bracerightsmall",65116,"bracerighttp",63740,"bracerightvertical",65080,"bracketleft",91,"bracketleftbt",63728,"bracketleftex",63727,"bracketleftmonospace",65339,"bracketlefttp",63726,"bracketright",93,"bracketrightbt",63739,"bracketrightex",63738,"bracketrightmonospace",65341,"bracketrighttp",63737,"breve",728,"brevebelowcmb",814,"brevecmb",774,"breveinvertedbelowcmb",815,"breveinvertedcmb",785,"breveinverteddoublecmb",865,"bridgebelowcmb",810,"bridgeinvertedbelowcmb",826,"brokenbar",166,"bstroke",384,"bsuperior",63210,"btopbar",387,"buhiragana",12406,"bukatakana",12502,"bullet",8226,"bulletinverse",9688,"bulletoperator",8729,"bullseye",9678,"c",99,"caarmenian",1390,"cabengali",2458,"cacute",263,"cadeva",2330,"cagujarati",2714,"cagurmukhi",2586,"calsquare",13192,"candrabindubengali",2433,"candrabinducmb",784,"candrabindudeva",2305,"candrabindugujarati",2689,"capslock",8682,"careof",8453,"caron",711,"caronbelowcmb",812,"caroncmb",780,"carriagereturn",8629,"cbopomofo",12568,"ccaron",269,"ccedilla",231,"ccedillaacute",7689,"ccircle",9426,"ccircumflex",265,"ccurl",597,"cdot",267,"cdotaccent",267,"cdsquare",13253,"cedilla",184,"cedillacmb",807,"cent",162,"centigrade",8451,"centinferior",63199,"centmonospace",65504,"centoldstyle",63394,"centsuperior",63200,"chaarmenian",1401,"chabengali",2459,"chadeva",2331,"chagujarati",2715,"chagurmukhi",2587,"chbopomofo",12564,"cheabkhasiancyrillic",1213,"checkmark",10003,"checyrillic",1095,"chedescenderabkhasiancyrillic",1215,"chedescendercyrillic",1207,"chedieresiscyrillic",1269,"cheharmenian",1395,"chekhakassiancyrillic",1228,"cheverticalstrokecyrillic",1209,"chi",967,"chieuchacirclekorean",12919,"chieuchaparenkorean",12823,"chieuchcirclekorean",12905,"chieuchkorean",12618,"chieuchparenkorean",12809,"chochangthai",3594,"chochanthai",3592,"chochingthai",3593,"chochoethai",3596,"chook",392,"cieucacirclekorean",12918,"cieucaparenkorean",12822,"cieuccirclekorean",12904,"cieuckorean",12616,"cieucparenkorean",12808,"cieucuparenkorean",12828,"circle",9675,"circlecopyrt",169,"circlemultiply",8855,"circleot",8857,"circleplus",8853,"circlepostalmark",12342,"circlewithlefthalfblack",9680,"circlewithrighthalfblack",9681,"circumflex",710,"circumflexbelowcmb",813,"circumflexcmb",770,"clear",8999,"clickalveolar",450,"clickdental",448,"clicklateral",449,"clickretroflex",451,"club",9827,"clubsuitblack",9827,"clubsuitwhite",9831,"cmcubedsquare",13220,"cmonospace",65347,"cmsquaredsquare",13216,"coarmenian",1409,"colon",58,"colonmonetary",8353,"colonmonospace",65306,"colonsign",8353,"colonsmall",65109,"colontriangularhalfmod",721,"colontriangularmod",720,"comma",44,"commaabovecmb",787,"commaaboverightcmb",789,"commaaccent",63171,"commaarabic",1548,"commaarmenian",1373,"commainferior",63201,"commamonospace",65292,"commareversedabovecmb",788,"commareversedmod",701,"commasmall",65104,"commasuperior",63202,"commaturnedabovecmb",786,"commaturnedmod",699,"compass",9788,"congruent",8773,"contourintegral",8750,"control",8963,"controlACK",6,"controlBEL",7,"controlBS",8,"controlCAN",24,"controlCR",13,"controlDC1",17,"controlDC2",18,"controlDC3",19,"controlDC4",20,"controlDEL",127,"controlDLE",16,"controlEM",25,"controlENQ",5,"controlEOT",4,"controlESC",27,"controlETB",23,"controlETX",3,"controlFF",12,"controlFS",28,"controlGS",29,"controlHT",9,"controlLF",10,"controlNAK",21,"controlNULL",0,"controlRS",30,"controlSI",15,"controlSO",14,"controlSOT",2,"controlSTX",1,"controlSUB",26,"controlSYN",22,"controlUS",31,"controlVT",11,"copyright",169,"copyrightsans",63721,"copyrightserif",63193,"cornerbracketleft",12300,"cornerbracketlefthalfwidth",65378,"cornerbracketleftvertical",65089,"cornerbracketright",12301,"cornerbracketrighthalfwidth",65379,"cornerbracketrightvertical",65090,"corporationsquare",13183,"cosquare",13255,"coverkgsquare",13254,"cparen",9374,"cruzeiro",8354,"cstretched",663,"curlyand",8911,"curlyor",8910,"currency",164,"cyrBreve",63185,"cyrFlex",63186,"cyrbreve",63188,"cyrflex",63189,"d",100,"daarmenian",1380,"dabengali",2470,"dadarabic",1590,"dadeva",2342,"dadfinalarabic",65214,"dadinitialarabic",65215,"dadmedialarabic",65216,"dagesh",1468,"dageshhebrew",1468,"dagger",8224,"daggerdbl",8225,"dagujarati",2726,"dagurmukhi",2598,"dahiragana",12384,"dakatakana",12480,"dalarabic",1583,"dalet",1491,"daletdagesh",64307,"daletdageshhebrew",64307,"dalethebrew",1491,"dalfinalarabic",65194,"dammaarabic",1615,"dammalowarabic",1615,"dammatanaltonearabic",1612,"dammatanarabic",1612,"danda",2404,"dargahebrew",1447,"dargalefthebrew",1447,"dasiapneumatacyrilliccmb",1157,"dblGrave",63187,"dblanglebracketleft",12298,"dblanglebracketleftvertical",65085,"dblanglebracketright",12299,"dblanglebracketrightvertical",65086,"dblarchinvertedbelowcmb",811,"dblarrowleft",8660,"dblarrowright",8658,"dbldanda",2405,"dblgrave",63190,"dblgravecmb",783,"dblintegral",8748,"dbllowline",8215,"dbllowlinecmb",819,"dbloverlinecmb",831,"dblprimemod",698,"dblverticalbar",8214,"dblverticallineabovecmb",782,"dbopomofo",12553,"dbsquare",13256,"dcaron",271,"dcedilla",7697,"dcircle",9427,"dcircumflexbelow",7699,"dcroat",273,"ddabengali",2465,"ddadeva",2337,"ddagujarati",2721,"ddagurmukhi",2593,"ddalarabic",1672,"ddalfinalarabic",64393,"dddhadeva",2396,"ddhabengali",2466,"ddhadeva",2338,"ddhagujarati",2722,"ddhagurmukhi",2594,"ddotaccent",7691,"ddotbelow",7693,"decimalseparatorarabic",1643,"decimalseparatorpersian",1643,"decyrillic",1076,"degree",176,"dehihebrew",1453,"dehiragana",12391,"deicoptic",1007,"dekatakana",12487,"deleteleft",9003,"deleteright",8998,"delta",948,"deltaturned",397,"denominatorminusonenumeratorbengali",2552,"dezh",676,"dhabengali",2471,"dhadeva",2343,"dhagujarati",2727,"dhagurmukhi",2599,"dhook",599,"dialytikatonos",901,"dialytikatonoscmb",836,"diamond",9830,"diamondsuitwhite",9826,"dieresis",168,"dieresisacute",63191,"dieresisbelowcmb",804,"dieresiscmb",776,"dieresisgrave",63192,"dieresistonos",901,"dihiragana",12386,"dikatakana",12482,"dittomark",12291,"divide",247,"divides",8739,"divisionslash",8725,"djecyrillic",1106,"dkshade",9619,"dlinebelow",7695,"dlsquare",13207,"dmacron",273,"dmonospace",65348,"dnblock",9604,"dochadathai",3598,"dodekthai",3604,"dohiragana",12393,"dokatakana",12489,"dollar",36,"dollarinferior",63203,"dollarmonospace",65284,"dollaroldstyle",63268,"dollarsmall",65129,"dollarsuperior",63204,"dong",8363,"dorusquare",13094,"dotaccent",729,"dotaccentcmb",775,"dotbelowcmb",803,"dotbelowcomb",803,"dotkatakana",12539,"dotlessi",305,"dotlessj",63166,"dotlessjstrokehook",644,"dotmath",8901,"dottedcircle",9676,"doubleyodpatah",64287,"doubleyodpatahhebrew",64287,"downtackbelowcmb",798,"downtackmod",725,"dparen",9375,"dsuperior",63211,"dtail",598,"dtopbar",396,"duhiragana",12389,"dukatakana",12485,"dz",499,"dzaltone",675,"dzcaron",454,"dzcurl",677,"dzeabkhasiancyrillic",1249,"dzecyrillic",1109,"dzhecyrillic",1119,"e",101,"eacute",233,"earth",9793,"ebengali",2447,"ebopomofo",12572,"ebreve",277,"ecandradeva",2317,"ecandragujarati",2701,"ecandravowelsigndeva",2373,"ecandravowelsigngujarati",2757,"ecaron",283,"ecedillabreve",7709,"echarmenian",1381,"echyiwnarmenian",1415,"ecircle",9428,"ecircumflex",234,"ecircumflexacute",7871,"ecircumflexbelow",7705,"ecircumflexdotbelow",7879,"ecircumflexgrave",7873,"ecircumflexhookabove",7875,"ecircumflextilde",7877,"ecyrillic",1108,"edblgrave",517,"edeva",2319,"edieresis",235,"edot",279,"edotaccent",279,"edotbelow",7865,"eegurmukhi",2575,"eematragurmukhi",2631,"efcyrillic",1092,"egrave",232,"egujarati",2703,"eharmenian",1383,"ehbopomofo",12573,"ehiragana",12360,"ehookabove",7867,"eibopomofo",12575,"eight",56,"eightarabic",1640,"eightbengali",2542,"eightcircle",9319,"eightcircleinversesansserif",10129,"eightdeva",2414,"eighteencircle",9329,"eighteenparen",9349,"eighteenperiod",9369,"eightgujarati",2798,"eightgurmukhi",2670,"eighthackarabic",1640,"eighthangzhou",12328,"eighthnotebeamed",9835,"eightideographicparen",12839,"eightinferior",8328,"eightmonospace",65304,"eightoldstyle",63288,"eightparen",9339,"eightperiod",9359,"eightpersian",1784,"eightroman",8567,"eightsuperior",8312,"eightthai",3672,"einvertedbreve",519,"eiotifiedcyrillic",1125,"ekatakana",12456,"ekatakanahalfwidth",65396,"ekonkargurmukhi",2676,"ekorean",12628,"elcyrillic",1083,"element",8712,"elevencircle",9322,"elevenparen",9342,"elevenperiod",9362,"elevenroman",8570,"ellipsis",8230,"ellipsisvertical",8942,"emacron",275,"emacronacute",7703,"emacrongrave",7701,"emcyrillic",1084,"emdash",8212,"emdashvertical",65073,"emonospace",65349,"emphasismarkarmenian",1371,"emptyset",8709,"enbopomofo",12579,"encyrillic",1085,"endash",8211,"endashvertical",65074,"endescendercyrillic",1187,"eng",331,"engbopomofo",12581,"enghecyrillic",1189,"enhookcyrillic",1224,"enspace",8194,"eogonek",281,"eokorean",12627,"eopen",603,"eopenclosed",666,"eopenreversed",604,"eopenreversedclosed",606,"eopenreversedhook",605,"eparen",9376,"epsilon",949,"epsilontonos",941,"equal",61,"equalmonospace",65309,"equalsmall",65126,"equalsuperior",8316,"equivalence",8801,"erbopomofo",12582,"ercyrillic",1088,"ereversed",600,"ereversedcyrillic",1101,"escyrillic",1089,"esdescendercyrillic",1195,"esh",643,"eshcurl",646,"eshortdeva",2318,"eshortvowelsigndeva",2374,"eshreversedloop",426,"eshsquatreversed",645,"esmallhiragana",12359,"esmallkatakana",12455,"esmallkatakanahalfwidth",65386,"estimated",8494,"esuperior",63212,"eta",951,"etarmenian",1384,"etatonos",942,"eth",240,"etilde",7869,"etildebelow",7707,"etnahtafoukhhebrew",1425,"etnahtafoukhlefthebrew",1425,"etnahtahebrew",1425,"etnahtalefthebrew",1425,"eturned",477,"eukorean",12641,"euro",8364,"evowelsignbengali",2503,"evowelsigndeva",2375,"evowelsigngujarati",2759,"exclam",33,"exclamarmenian",1372,"exclamdbl",8252,"exclamdown",161,"exclamdownsmall",63393,"exclammonospace",65281,"exclamsmall",63265,"existential",8707,"ezh",658,"ezhcaron",495,"ezhcurl",659,"ezhreversed",441,"ezhtail",442,"f",102,"fadeva",2398,"fagurmukhi",2654,"fahrenheit",8457,"fathaarabic",1614,"fathalowarabic",1614,"fathatanarabic",1611,"fbopomofo",12552,"fcircle",9429,"fdotaccent",7711,"feharabic",1601,"feharmenian",1414,"fehfinalarabic",65234,"fehinitialarabic",65235,"fehmedialarabic",65236,"feicoptic",997,"female",9792,"ff",64256,"f_f",64256,"ffi",64259,"ffl",64260,"fi",64257,"fifteencircle",9326,"fifteenparen",9346,"fifteenperiod",9366,"figuredash",8210,"filledbox",9632,"filledrect",9644,"finalkaf",1498,"finalkafdagesh",64314,"finalkafdageshhebrew",64314,"finalkafhebrew",1498,"finalmem",1501,"finalmemhebrew",1501,"finalnun",1503,"finalnunhebrew",1503,"finalpe",1507,"finalpehebrew",1507,"finaltsadi",1509,"finaltsadihebrew",1509,"firsttonechinese",713,"fisheye",9673,"fitacyrillic",1139,"five",53,"fivearabic",1637,"fivebengali",2539,"fivecircle",9316,"fivecircleinversesansserif",10126,"fivedeva",2411,"fiveeighths",8541,"fivegujarati",2795,"fivegurmukhi",2667,"fivehackarabic",1637,"fivehangzhou",12325,"fiveideographicparen",12836,"fiveinferior",8325,"fivemonospace",65301,"fiveoldstyle",63285,"fiveparen",9336,"fiveperiod",9356,"fivepersian",1781,"fiveroman",8564,"fivesuperior",8309,"fivethai",3669,"fl",64258,"florin",402,"fmonospace",65350,"fmsquare",13209,"fofanthai",3615,"fofathai",3613,"fongmanthai",3663,"forall",8704,"four",52,"fourarabic",1636,"fourbengali",2538,"fourcircle",9315,"fourcircleinversesansserif",10125,"fourdeva",2410,"fourgujarati",2794,"fourgurmukhi",2666,"fourhackarabic",1636,"fourhangzhou",12324,"fourideographicparen",12835,"fourinferior",8324,"fourmonospace",65300,"fournumeratorbengali",2551,"fouroldstyle",63284,"fourparen",9335,"fourperiod",9355,"fourpersian",1780,"fourroman",8563,"foursuperior",8308,"fourteencircle",9325,"fourteenparen",9345,"fourteenperiod",9365,"fourthai",3668,"fourthtonechinese",715,"fparen",9377,"fraction",8260,"franc",8355,"g",103,"gabengali",2455,"gacute",501,"gadeva",2327,"gafarabic",1711,"gaffinalarabic",64403,"gafinitialarabic",64404,"gafmedialarabic",64405,"gagujarati",2711,"gagurmukhi",2583,"gahiragana",12364,"gakatakana",12460,"gamma",947,"gammalatinsmall",611,"gammasuperior",736,"gangiacoptic",1003,"gbopomofo",12557,"gbreve",287,"gcaron",487,"gcedilla",291,"gcircle",9430,"gcircumflex",285,"gcommaaccent",291,"gdot",289,"gdotaccent",289,"gecyrillic",1075,"gehiragana",12370,"gekatakana",12466,"geometricallyequal",8785,"gereshaccenthebrew",1436,"gereshhebrew",1523,"gereshmuqdamhebrew",1437,"germandbls",223,"gershayimaccenthebrew",1438,"gershayimhebrew",1524,"getamark",12307,"ghabengali",2456,"ghadarmenian",1394,"ghadeva",2328,"ghagujarati",2712,"ghagurmukhi",2584,"ghainarabic",1594,"ghainfinalarabic",65230,"ghaininitialarabic",65231,"ghainmedialarabic",65232,"ghemiddlehookcyrillic",1173,"ghestrokecyrillic",1171,"gheupturncyrillic",1169,"ghhadeva",2394,"ghhagurmukhi",2650,"ghook",608,"ghzsquare",13203,"gihiragana",12366,"gikatakana",12462,"gimarmenian",1379,"gimel",1490,"gimeldagesh",64306,"gimeldageshhebrew",64306,"gimelhebrew",1490,"gjecyrillic",1107,"glottalinvertedstroke",446,"glottalstop",660,"glottalstopinverted",662,"glottalstopmod",704,"glottalstopreversed",661,"glottalstopreversedmod",705,"glottalstopreversedsuperior",740,"glottalstopstroke",673,"glottalstopstrokereversed",674,"gmacron",7713,"gmonospace",65351,"gohiragana",12372,"gokatakana",12468,"gparen",9378,"gpasquare",13228,"gradient",8711,"grave",96,"gravebelowcmb",790,"gravecmb",768,"gravecomb",768,"gravedeva",2387,"gravelowmod",718,"gravemonospace",65344,"gravetonecmb",832,"greater",62,"greaterequal",8805,"greaterequalorless",8923,"greatermonospace",65310,"greaterorequivalent",8819,"greaterorless",8823,"greateroverequal",8807,"greatersmall",65125,"gscript",609,"gstroke",485,"guhiragana",12368,"guillemotleft",171,"guillemotright",187,"guilsinglleft",8249,"guilsinglright",8250,"gukatakana",12464,"guramusquare",13080,"gysquare",13257,"h",104,"haabkhasiancyrillic",1193,"haaltonearabic",1729,"habengali",2489,"hadescendercyrillic",1203,"hadeva",2361,"hagujarati",2745,"hagurmukhi",2617,"haharabic",1581,"hahfinalarabic",65186,"hahinitialarabic",65187,"hahiragana",12399,"hahmedialarabic",65188,"haitusquare",13098,"hakatakana",12495,"hakatakanahalfwidth",65418,"halantgurmukhi",2637,"hamzaarabic",1569,"hamzalowarabic",1569,"hangulfiller",12644,"hardsigncyrillic",1098,"harpoonleftbarbup",8636,"harpoonrightbarbup",8640,"hasquare",13258,"hatafpatah",1458,"hatafpatah16",1458,"hatafpatah23",1458,"hatafpatah2f",1458,"hatafpatahhebrew",1458,"hatafpatahnarrowhebrew",1458,"hatafpatahquarterhebrew",1458,"hatafpatahwidehebrew",1458,"hatafqamats",1459,"hatafqamats1b",1459,"hatafqamats28",1459,"hatafqamats34",1459,"hatafqamatshebrew",1459,"hatafqamatsnarrowhebrew",1459,"hatafqamatsquarterhebrew",1459,"hatafqamatswidehebrew",1459,"hatafsegol",1457,"hatafsegol17",1457,"hatafsegol24",1457,"hatafsegol30",1457,"hatafsegolhebrew",1457,"hatafsegolnarrowhebrew",1457,"hatafsegolquarterhebrew",1457,"hatafsegolwidehebrew",1457,"hbar",295,"hbopomofo",12559,"hbrevebelow",7723,"hcedilla",7721,"hcircle",9431,"hcircumflex",293,"hdieresis",7719,"hdotaccent",7715,"hdotbelow",7717,"he",1492,"heart",9829,"heartsuitblack",9829,"heartsuitwhite",9825,"hedagesh",64308,"hedageshhebrew",64308,"hehaltonearabic",1729,"heharabic",1607,"hehebrew",1492,"hehfinalaltonearabic",64423,"hehfinalalttwoarabic",65258,"hehfinalarabic",65258,"hehhamzaabovefinalarabic",64421,"hehhamzaaboveisolatedarabic",64420,"hehinitialaltonearabic",64424,"hehinitialarabic",65259,"hehiragana",12408,"hehmedialaltonearabic",64425,"hehmedialarabic",65260,"heiseierasquare",13179,"hekatakana",12504,"hekatakanahalfwidth",65421,"hekutaarusquare",13110,"henghook",615,"herutusquare",13113,"het",1495,"hethebrew",1495,"hhook",614,"hhooksuperior",689,"hieuhacirclekorean",12923,"hieuhaparenkorean",12827,"hieuhcirclekorean",12909,"hieuhkorean",12622,"hieuhparenkorean",12813,"hihiragana",12402,"hikatakana",12498,"hikatakanahalfwidth",65419,"hiriq",1460,"hiriq14",1460,"hiriq21",1460,"hiriq2d",1460,"hiriqhebrew",1460,"hiriqnarrowhebrew",1460,"hiriqquarterhebrew",1460,"hiriqwidehebrew",1460,"hlinebelow",7830,"hmonospace",65352,"hoarmenian",1392,"hohipthai",3627,"hohiragana",12411,"hokatakana",12507,"hokatakanahalfwidth",65422,"holam",1465,"holam19",1465,"holam26",1465,"holam32",1465,"holamhebrew",1465,"holamnarrowhebrew",1465,"holamquarterhebrew",1465,"holamwidehebrew",1465,"honokhukthai",3630,"hookabovecomb",777,"hookcmb",777,"hookpalatalizedbelowcmb",801,"hookretroflexbelowcmb",802,"hoonsquare",13122,"horicoptic",1001,"horizontalbar",8213,"horncmb",795,"hotsprings",9832,"house",8962,"hparen",9379,"hsuperior",688,"hturned",613,"huhiragana",12405,"huiitosquare",13107,"hukatakana",12501,"hukatakanahalfwidth",65420,"hungarumlaut",733,"hungarumlautcmb",779,"hv",405,"hyphen",45,"hypheninferior",63205,"hyphenmonospace",65293,"hyphensmall",65123,"hyphensuperior",63206,"hyphentwo",8208,"i",105,"iacute",237,"iacyrillic",1103,"ibengali",2439,"ibopomofo",12583,"ibreve",301,"icaron",464,"icircle",9432,"icircumflex",238,"icyrillic",1110,"idblgrave",521,"ideographearthcircle",12943,"ideographfirecircle",12939,"ideographicallianceparen",12863,"ideographiccallparen",12858,"ideographiccentrecircle",12965,"ideographicclose",12294,"ideographiccomma",12289,"ideographiccommaleft",65380,"ideographiccongratulationparen",12855,"ideographiccorrectcircle",12963,"ideographicearthparen",12847,"ideographicenterpriseparen",12861,"ideographicexcellentcircle",12957,"ideographicfestivalparen",12864,"ideographicfinancialcircle",12950,"ideographicfinancialparen",12854,"ideographicfireparen",12843,"ideographichaveparen",12850,"ideographichighcircle",12964,"ideographiciterationmark",12293,"ideographiclaborcircle",12952,"ideographiclaborparen",12856,"ideographicleftcircle",12967,"ideographiclowcircle",12966,"ideographicmedicinecircle",12969,"ideographicmetalparen",12846,"ideographicmoonparen",12842,"ideographicnameparen",12852,"ideographicperiod",12290,"ideographicprintcircle",12958,"ideographicreachparen",12867,"ideographicrepresentparen",12857,"ideographicresourceparen",12862,"ideographicrightcircle",12968,"ideographicsecretcircle",12953,"ideographicselfparen",12866,"ideographicsocietyparen",12851,"ideographicspace",12288,"ideographicspecialparen",12853,"ideographicstockparen",12849,"ideographicstudyparen",12859,"ideographicsunparen",12848,"ideographicsuperviseparen",12860,"ideographicwaterparen",12844,"ideographicwoodparen",12845,"ideographiczero",12295,"ideographmetalcircle",12942,"ideographmooncircle",12938,"ideographnamecircle",12948,"ideographsuncircle",12944,"ideographwatercircle",12940,"ideographwoodcircle",12941,"ideva",2311,"idieresis",239,"idieresisacute",7727,"idieresiscyrillic",1253,"idotbelow",7883,"iebrevecyrillic",1239,"iecyrillic",1077,"ieungacirclekorean",12917,"ieungaparenkorean",12821,"ieungcirclekorean",12903,"ieungkorean",12615,"ieungparenkorean",12807,"igrave",236,"igujarati",2695,"igurmukhi",2567,"ihiragana",12356,"ihookabove",7881,"iibengali",2440,"iicyrillic",1080,"iideva",2312,"iigujarati",2696,"iigurmukhi",2568,"iimatragurmukhi",2624,"iinvertedbreve",523,"iishortcyrillic",1081,"iivowelsignbengali",2496,"iivowelsigndeva",2368,"iivowelsigngujarati",2752,"ij",307,"ikatakana",12452,"ikatakanahalfwidth",65394,"ikorean",12643,"ilde",732,"iluyhebrew",1452,"imacron",299,"imacroncyrillic",1251,"imageorapproximatelyequal",8787,"imatragurmukhi",2623,"imonospace",65353,"increment",8710,"infinity",8734,"iniarmenian",1387,"integral",8747,"integralbottom",8993,"integralbt",8993,"integralex",63733,"integraltop",8992,"integraltp",8992,"intersection",8745,"intisquare",13061,"invbullet",9688,"invcircle",9689,"invsmileface",9787,"iocyrillic",1105,"iogonek",303,"iota",953,"iotadieresis",970,"iotadieresistonos",912,"iotalatin",617,"iotatonos",943,"iparen",9380,"irigurmukhi",2674,"ismallhiragana",12355,"ismallkatakana",12451,"ismallkatakanahalfwidth",65384,"issharbengali",2554,"istroke",616,"isuperior",63213,"iterationhiragana",12445,"iterationkatakana",12541,"itilde",297,"itildebelow",7725,"iubopomofo",12585,"iucyrillic",1102,"ivowelsignbengali",2495,"ivowelsigndeva",2367,"ivowelsigngujarati",2751,"izhitsacyrillic",1141,"izhitsadblgravecyrillic",1143,"j",106,"jaarmenian",1393,"jabengali",2460,"jadeva",2332,"jagujarati",2716,"jagurmukhi",2588,"jbopomofo",12560,"jcaron",496,"jcircle",9433,"jcircumflex",309,"jcrossedtail",669,"jdotlessstroke",607,"jecyrillic",1112,"jeemarabic",1580,"jeemfinalarabic",65182,"jeeminitialarabic",65183,"jeemmedialarabic",65184,"jeharabic",1688,"jehfinalarabic",64395,"jhabengali",2461,"jhadeva",2333,"jhagujarati",2717,"jhagurmukhi",2589,"jheharmenian",1403,"jis",12292,"jmonospace",65354,"jparen",9381,"jsuperior",690,"k",107,"kabashkircyrillic",1185,"kabengali",2453,"kacute",7729,"kacyrillic",1082,"kadescendercyrillic",1179,"kadeva",2325,"kaf",1499,"kafarabic",1603,"kafdagesh",64315,"kafdageshhebrew",64315,"kaffinalarabic",65242,"kafhebrew",1499,"kafinitialarabic",65243,"kafmedialarabic",65244,"kafrafehebrew",64333,"kagujarati",2709,"kagurmukhi",2581,"kahiragana",12363,"kahookcyrillic",1220,"kakatakana",12459,"kakatakanahalfwidth",65398,"kappa",954,"kappasymbolgreek",1008,"kapyeounmieumkorean",12657,"kapyeounphieuphkorean",12676,"kapyeounpieupkorean",12664,"kapyeounssangpieupkorean",12665,"karoriisquare",13069,"kashidaautoarabic",1600,"kashidaautonosidebearingarabic",1600,"kasmallkatakana",12533,"kasquare",13188,"kasraarabic",1616,"kasratanarabic",1613,"kastrokecyrillic",1183,"katahiraprolongmarkhalfwidth",65392,"kaverticalstrokecyrillic",1181,"kbopomofo",12558,"kcalsquare",13193,"kcaron",489,"kcedilla",311,"kcircle",9434,"kcommaaccent",311,"kdotbelow",7731,"keharmenian",1412,"kehiragana",12369,"kekatakana",12465,"kekatakanahalfwidth",65401,"kenarmenian",1391,"kesmallkatakana",12534,"kgreenlandic",312,"khabengali",2454,"khacyrillic",1093,"khadeva",2326,"khagujarati",2710,"khagurmukhi",2582,"khaharabic",1582,"khahfinalarabic",65190,"khahinitialarabic",65191,"khahmedialarabic",65192,"kheicoptic",999,"khhadeva",2393,"khhagurmukhi",2649,"khieukhacirclekorean",12920,"khieukhaparenkorean",12824,"khieukhcirclekorean",12906,"khieukhkorean",12619,"khieukhparenkorean",12810,"khokhaithai",3586,"khokhonthai",3589,"khokhuatthai",3587,"khokhwaithai",3588,"khomutthai",3675,"khook",409,"khorakhangthai",3590,"khzsquare",13201,"kihiragana",12365,"kikatakana",12461,"kikatakanahalfwidth",65399,"kiroguramusquare",13077,"kiromeetorusquare",13078,"kirosquare",13076,"kiyeokacirclekorean",12910,"kiyeokaparenkorean",12814,"kiyeokcirclekorean",12896,"kiyeokkorean",12593,"kiyeokparenkorean",12800,"kiyeoksioskorean",12595,"kjecyrillic",1116,"klinebelow",7733,"klsquare",13208,"kmcubedsquare",13222,"kmonospace",65355,"kmsquaredsquare",13218,"kohiragana",12371,"kohmsquare",13248,"kokaithai",3585,"kokatakana",12467,"kokatakanahalfwidth",65402,"kooposquare",13086,"koppacyrillic",1153,"koreanstandardsymbol",12927,"koroniscmb",835,"kparen",9382,"kpasquare",13226,"ksicyrillic",1135,"ktsquare",13263,"kturned",670,"kuhiragana",12367,"kukatakana",12463,"kukatakanahalfwidth",65400,"kvsquare",13240,"kwsquare",13246,"l",108,"labengali",2482,"lacute",314,"ladeva",2354,"lagujarati",2738,"lagurmukhi",2610,"lakkhangyaothai",3653,"lamaleffinalarabic",65276,"lamalefhamzaabovefinalarabic",65272,"lamalefhamzaaboveisolatedarabic",65271,"lamalefhamzabelowfinalarabic",65274,"lamalefhamzabelowisolatedarabic",65273,"lamalefisolatedarabic",65275,"lamalefmaddaabovefinalarabic",65270,"lamalefmaddaaboveisolatedarabic",65269,"lamarabic",1604,"lambda",955,"lambdastroke",411,"lamed",1500,"lameddagesh",64316,"lameddageshhebrew",64316,"lamedhebrew",1500,"lamfinalarabic",65246,"lamhahinitialarabic",64714,"laminitialarabic",65247,"lamjeeminitialarabic",64713,"lamkhahinitialarabic",64715,"lamlamhehisolatedarabic",65010,"lammedialarabic",65248,"lammeemhahinitialarabic",64904,"lammeeminitialarabic",64716,"largecircle",9711,"lbar",410,"lbelt",620,"lbopomofo",12556,"lcaron",318,"lcedilla",316,"lcircle",9435,"lcircumflexbelow",7741,"lcommaaccent",316,"ldot",320,"ldotaccent",320,"ldotbelow",7735,"ldotbelowmacron",7737,"leftangleabovecmb",794,"lefttackbelowcmb",792,"less",60,"lessequal",8804,"lessequalorgreater",8922,"lessmonospace",65308,"lessorequivalent",8818,"lessorgreater",8822,"lessoverequal",8806,"lesssmall",65124,"lezh",622,"lfblock",9612,"lhookretroflex",621,"lira",8356,"liwnarmenian",1388,"lj",457,"ljecyrillic",1113,"ll",63168,"lladeva",2355,"llagujarati",2739,"llinebelow",7739,"llladeva",2356,"llvocalicbengali",2529,"llvocalicdeva",2401,"llvocalicvowelsignbengali",2531,"llvocalicvowelsigndeva",2403,"lmiddletilde",619,"lmonospace",65356,"lmsquare",13264,"lochulathai",3628,"logicaland",8743,"logicalnot",172,"logicalnotreversed",8976,"logicalor",8744,"lolingthai",3621,"longs",383,"lowlinecenterline",65102,"lowlinecmb",818,"lowlinedashed",65101,"lozenge",9674,"lparen",9383,"lslash",322,"lsquare",8467,"lsuperior",63214,"ltshade",9617,"luthai",3622,"lvocalicbengali",2444,"lvocalicdeva",2316,"lvocalicvowelsignbengali",2530,"lvocalicvowelsigndeva",2402,"lxsquare",13267,"m",109,"mabengali",2478,"macron",175,"macronbelowcmb",817,"macroncmb",772,"macronlowmod",717,"macronmonospace",65507,"macute",7743,"madeva",2350,"magujarati",2734,"magurmukhi",2606,"mahapakhhebrew",1444,"mahapakhlefthebrew",1444,"mahiragana",12414,"maichattawalowleftthai",63637,"maichattawalowrightthai",63636,"maichattawathai",3659,"maichattawaupperleftthai",63635,"maieklowleftthai",63628,"maieklowrightthai",63627,"maiekthai",3656,"maiekupperleftthai",63626,"maihanakatleftthai",63620,"maihanakatthai",3633,"maitaikhuleftthai",63625,"maitaikhuthai",3655,"maitholowleftthai",63631,"maitholowrightthai",63630,"maithothai",3657,"maithoupperleftthai",63629,"maitrilowleftthai",63634,"maitrilowrightthai",63633,"maitrithai",3658,"maitriupperleftthai",63632,"maiyamokthai",3654,"makatakana",12510,"makatakanahalfwidth",65423,"male",9794,"mansyonsquare",13127,"maqafhebrew",1470,"mars",9794,"masoracirclehebrew",1455,"masquare",13187,"mbopomofo",12551,"mbsquare",13268,"mcircle",9436,"mcubedsquare",13221,"mdotaccent",7745,"mdotbelow",7747,"meemarabic",1605,"meemfinalarabic",65250,"meeminitialarabic",65251,"meemmedialarabic",65252,"meemmeeminitialarabic",64721,"meemmeemisolatedarabic",64584,"meetorusquare",13133,"mehiragana",12417,"meizierasquare",13182,"mekatakana",12513,"mekatakanahalfwidth",65426,"mem",1502,"memdagesh",64318,"memdageshhebrew",64318,"memhebrew",1502,"menarmenian",1396,"merkhahebrew",1445,"merkhakefulahebrew",1446,"merkhakefulalefthebrew",1446,"merkhalefthebrew",1445,"mhook",625,"mhzsquare",13202,"middledotkatakanahalfwidth",65381,"middot",183,"mieumacirclekorean",12914,"mieumaparenkorean",12818,"mieumcirclekorean",12900,"mieumkorean",12609,"mieumpansioskorean",12656,"mieumparenkorean",12804,"mieumpieupkorean",12654,"mieumsioskorean",12655,"mihiragana",12415,"mikatakana",12511,"mikatakanahalfwidth",65424,"minus",8722,"minusbelowcmb",800,"minuscircle",8854,"minusmod",727,"minusplus",8723,"minute",8242,"miribaarusquare",13130,"mirisquare",13129,"mlonglegturned",624,"mlsquare",13206,"mmcubedsquare",13219,"mmonospace",65357,"mmsquaredsquare",13215,"mohiragana",12418,"mohmsquare",13249,"mokatakana",12514,"mokatakanahalfwidth",65427,"molsquare",13270,"momathai",3617,"moverssquare",13223,"moverssquaredsquare",13224,"mparen",9384,"mpasquare",13227,"mssquare",13235,"msuperior",63215,"mturned",623,"mu",181,"mu1",181,"muasquare",13186,"muchgreater",8811,"muchless",8810,"mufsquare",13196,"mugreek",956,"mugsquare",13197,"muhiragana",12416,"mukatakana",12512,"mukatakanahalfwidth",65425,"mulsquare",13205,"multiply",215,"mumsquare",13211,"munahhebrew",1443,"munahlefthebrew",1443,"musicalnote",9834,"musicalnotedbl",9835,"musicflatsign",9837,"musicsharpsign",9839,"mussquare",13234,"muvsquare",13238,"muwsquare",13244,"mvmegasquare",13241,"mvsquare",13239,"mwmegasquare",13247,"mwsquare",13245,"n",110,"nabengali",2472,"nabla",8711,"nacute",324,"nadeva",2344,"nagujarati",2728,"nagurmukhi",2600,"nahiragana",12394,"nakatakana",12490,"nakatakanahalfwidth",65413,"napostrophe",329,"nasquare",13185,"nbopomofo",12555,"nbspace",160,"ncaron",328,"ncedilla",326,"ncircle",9437,"ncircumflexbelow",7755,"ncommaaccent",326,"ndotaccent",7749,"ndotbelow",7751,"nehiragana",12397,"nekatakana",12493,"nekatakanahalfwidth",65416,"newsheqelsign",8362,"nfsquare",13195,"ngabengali",2457,"ngadeva",2329,"ngagujarati",2713,"ngagurmukhi",2585,"ngonguthai",3591,"nhiragana",12435,"nhookleft",626,"nhookretroflex",627,"nieunacirclekorean",12911,"nieunaparenkorean",12815,"nieuncieuckorean",12597,"nieuncirclekorean",12897,"nieunhieuhkorean",12598,"nieunkorean",12596,"nieunpansioskorean",12648,"nieunparenkorean",12801,"nieunsioskorean",12647,"nieuntikeutkorean",12646,"nihiragana",12395,"nikatakana",12491,"nikatakanahalfwidth",65414,"nikhahitleftthai",63641,"nikhahitthai",3661,"nine",57,"ninearabic",1641,"ninebengali",2543,"ninecircle",9320,"ninecircleinversesansserif",10130,"ninedeva",2415,"ninegujarati",2799,"ninegurmukhi",2671,"ninehackarabic",1641,"ninehangzhou",12329,"nineideographicparen",12840,"nineinferior",8329,"ninemonospace",65305,"nineoldstyle",63289,"nineparen",9340,"nineperiod",9360,"ninepersian",1785,"nineroman",8568,"ninesuperior",8313,"nineteencircle",9330,"nineteenparen",9350,"nineteenperiod",9370,"ninethai",3673,"nj",460,"njecyrillic",1114,"nkatakana",12531,"nkatakanahalfwidth",65437,"nlegrightlong",414,"nlinebelow",7753,"nmonospace",65358,"nmsquare",13210,"nnabengali",2467,"nnadeva",2339,"nnagujarati",2723,"nnagurmukhi",2595,"nnnadeva",2345,"nohiragana",12398,"nokatakana",12494,"nokatakanahalfwidth",65417,"nonbreakingspace",160,"nonenthai",3603,"nonuthai",3609,"noonarabic",1606,"noonfinalarabic",65254,"noonghunnaarabic",1722,"noonghunnafinalarabic",64415,"nooninitialarabic",65255,"noonjeeminitialarabic",64722,"noonjeemisolatedarabic",64587,"noonmedialarabic",65256,"noonmeeminitialarabic",64725,"noonmeemisolatedarabic",64590,"noonnoonfinalarabic",64653,"notcontains",8716,"notelement",8713,"notelementof",8713,"notequal",8800,"notgreater",8815,"notgreaternorequal",8817,"notgreaternorless",8825,"notidentical",8802,"notless",8814,"notlessnorequal",8816,"notparallel",8742,"notprecedes",8832,"notsubset",8836,"notsucceeds",8833,"notsuperset",8837,"nowarmenian",1398,"nparen",9385,"nssquare",13233,"nsuperior",8319,"ntilde",241,"nu",957,"nuhiragana",12396,"nukatakana",12492,"nukatakanahalfwidth",65415,"nuktabengali",2492,"nuktadeva",2364,"nuktagujarati",2748,"nuktagurmukhi",2620,"numbersign",35,"numbersignmonospace",65283,"numbersignsmall",65119,"numeralsigngreek",884,"numeralsignlowergreek",885,"numero",8470,"nun",1504,"nundagesh",64320,"nundageshhebrew",64320,"nunhebrew",1504,"nvsquare",13237,"nwsquare",13243,"nyabengali",2462,"nyadeva",2334,"nyagujarati",2718,"nyagurmukhi",2590,"o",111,"oacute",243,"oangthai",3629,"obarred",629,"obarredcyrillic",1257,"obarreddieresiscyrillic",1259,"obengali",2451,"obopomofo",12571,"obreve",335,"ocandradeva",2321,"ocandragujarati",2705,"ocandravowelsigndeva",2377,"ocandravowelsigngujarati",2761,"ocaron",466,"ocircle",9438,"ocircumflex",244,"ocircumflexacute",7889,"ocircumflexdotbelow",7897,"ocircumflexgrave",7891,"ocircumflexhookabove",7893,"ocircumflextilde",7895,"ocyrillic",1086,"odblacute",337,"odblgrave",525,"odeva",2323,"odieresis",246,"odieresiscyrillic",1255,"odotbelow",7885,"oe",339,"oekorean",12634,"ogonek",731,"ogonekcmb",808,"ograve",242,"ogujarati",2707,"oharmenian",1413,"ohiragana",12362,"ohookabove",7887,"ohorn",417,"ohornacute",7899,"ohorndotbelow",7907,"ohorngrave",7901,"ohornhookabove",7903,"ohorntilde",7905,"ohungarumlaut",337,"oi",419,"oinvertedbreve",527,"okatakana",12458,"okatakanahalfwidth",65397,"okorean",12631,"olehebrew",1451,"omacron",333,"omacronacute",7763,"omacrongrave",7761,"omdeva",2384,"omega",969,"omega1",982,"omegacyrillic",1121,"omegalatinclosed",631,"omegaroundcyrillic",1147,"omegatitlocyrillic",1149,"omegatonos",974,"omgujarati",2768,"omicron",959,"omicrontonos",972,"omonospace",65359,"one",49,"onearabic",1633,"onebengali",2535,"onecircle",9312,"onecircleinversesansserif",10122,"onedeva",2407,"onedotenleader",8228,"oneeighth",8539,"onefitted",63196,"onegujarati",2791,"onegurmukhi",2663,"onehackarabic",1633,"onehalf",189,"onehangzhou",12321,"oneideographicparen",12832,"oneinferior",8321,"onemonospace",65297,"onenumeratorbengali",2548,"oneoldstyle",63281,"oneparen",9332,"oneperiod",9352,"onepersian",1777,"onequarter",188,"oneroman",8560,"onesuperior",185,"onethai",3665,"onethird",8531,"oogonek",491,"oogonekmacron",493,"oogurmukhi",2579,"oomatragurmukhi",2635,"oopen",596,"oparen",9386,"openbullet",9702,"option",8997,"ordfeminine",170,"ordmasculine",186,"orthogonal",8735,"oshortdeva",2322,"oshortvowelsigndeva",2378,"oslash",248,"oslashacute",511,"osmallhiragana",12361,"osmallkatakana",12457,"osmallkatakanahalfwidth",65387,"ostrokeacute",511,"osuperior",63216,"otcyrillic",1151,"otilde",245,"otildeacute",7757,"otildedieresis",7759,"oubopomofo",12577,"overline",8254,"overlinecenterline",65098,"overlinecmb",773,"overlinedashed",65097,"overlinedblwavy",65100,"overlinewavy",65099,"overscore",175,"ovowelsignbengali",2507,"ovowelsigndeva",2379,"ovowelsigngujarati",2763,"p",112,"paampssquare",13184,"paasentosquare",13099,"pabengali",2474,"pacute",7765,"padeva",2346,"pagedown",8671,"pageup",8670,"pagujarati",2730,"pagurmukhi",2602,"pahiragana",12401,"paiyannoithai",3631,"pakatakana",12497,"palatalizationcyrilliccmb",1156,"palochkacyrillic",1216,"pansioskorean",12671,"paragraph",182,"parallel",8741,"parenleft",40,"parenleftaltonearabic",64830,"parenleftbt",63725,"parenleftex",63724,"parenleftinferior",8333,"parenleftmonospace",65288,"parenleftsmall",65113,"parenleftsuperior",8317,"parenlefttp",63723,"parenleftvertical",65077,"parenright",41,"parenrightaltonearabic",64831,"parenrightbt",63736,"parenrightex",63735,"parenrightinferior",8334,"parenrightmonospace",65289,"parenrightsmall",65114,"parenrightsuperior",8318,"parenrighttp",63734,"parenrightvertical",65078,"partialdiff",8706,"paseqhebrew",1472,"pashtahebrew",1433,"pasquare",13225,"patah",1463,"patah11",1463,"patah1d",1463,"patah2a",1463,"patahhebrew",1463,"patahnarrowhebrew",1463,"patahquarterhebrew",1463,"patahwidehebrew",1463,"pazerhebrew",1441,"pbopomofo",12550,"pcircle",9439,"pdotaccent",7767,"pe",1508,"pecyrillic",1087,"pedagesh",64324,"pedageshhebrew",64324,"peezisquare",13115,"pefinaldageshhebrew",64323,"peharabic",1662,"peharmenian",1402,"pehebrew",1508,"pehfinalarabic",64343,"pehinitialarabic",64344,"pehiragana",12410,"pehmedialarabic",64345,"pekatakana",12506,"pemiddlehookcyrillic",1191,"perafehebrew",64334,"percent",37,"percentarabic",1642,"percentmonospace",65285,"percentsmall",65130,"period",46,"periodarmenian",1417,"periodcentered",183,"periodhalfwidth",65377,"periodinferior",63207,"periodmonospace",65294,"periodsmall",65106,"periodsuperior",63208,"perispomenigreekcmb",834,"perpendicular",8869,"perthousand",8240,"peseta",8359,"pfsquare",13194,"phabengali",2475,"phadeva",2347,"phagujarati",2731,"phagurmukhi",2603,"phi",966,"phi1",981,"phieuphacirclekorean",12922,"phieuphaparenkorean",12826,"phieuphcirclekorean",12908,"phieuphkorean",12621,"phieuphparenkorean",12812,"philatin",632,"phinthuthai",3642,"phisymbolgreek",981,"phook",421,"phophanthai",3614,"phophungthai",3612,"phosamphaothai",3616,"pi",960,"pieupacirclekorean",12915,"pieupaparenkorean",12819,"pieupcieuckorean",12662,"pieupcirclekorean",12901,"pieupkiyeokkorean",12658,"pieupkorean",12610,"pieupparenkorean",12805,"pieupsioskiyeokkorean",12660,"pieupsioskorean",12612,"pieupsiostikeutkorean",12661,"pieupthieuthkorean",12663,"pieuptikeutkorean",12659,"pihiragana",12404,"pikatakana",12500,"pisymbolgreek",982,"piwrarmenian",1411,"plus",43,"plusbelowcmb",799,"pluscircle",8853,"plusminus",177,"plusmod",726,"plusmonospace",65291,"plussmall",65122,"plussuperior",8314,"pmonospace",65360,"pmsquare",13272,"pohiragana",12413,"pointingindexdownwhite",9759,"pointingindexleftwhite",9756,"pointingindexrightwhite",9758,"pointingindexupwhite",9757,"pokatakana",12509,"poplathai",3611,"postalmark",12306,"postalmarkface",12320,"pparen",9387,"precedes",8826,"prescription",8478,"primemod",697,"primereversed",8245,"product",8719,"projective",8965,"prolongedkana",12540,"propellor",8984,"propersubset",8834,"propersuperset",8835,"proportion",8759,"proportional",8733,"psi",968,"psicyrillic",1137,"psilipneumatacyrilliccmb",1158,"pssquare",13232,"puhiragana",12407,"pukatakana",12503,"pvsquare",13236,"pwsquare",13242,"q",113,"qadeva",2392,"qadmahebrew",1448,"qafarabic",1602,"qaffinalarabic",65238,"qafinitialarabic",65239,"qafmedialarabic",65240,"qamats",1464,"qamats10",1464,"qamats1a",1464,"qamats1c",1464,"qamats27",1464,"qamats29",1464,"qamats33",1464,"qamatsde",1464,"qamatshebrew",1464,"qamatsnarrowhebrew",1464,"qamatsqatanhebrew",1464,"qamatsqatannarrowhebrew",1464,"qamatsqatanquarterhebrew",1464,"qamatsqatanwidehebrew",1464,"qamatsquarterhebrew",1464,"qamatswidehebrew",1464,"qarneyparahebrew",1439,"qbopomofo",12561,"qcircle",9440,"qhook",672,"qmonospace",65361,"qof",1511,"qofdagesh",64327,"qofdageshhebrew",64327,"qofhebrew",1511,"qparen",9388,"quarternote",9833,"qubuts",1467,"qubuts18",1467,"qubuts25",1467,"qubuts31",1467,"qubutshebrew",1467,"qubutsnarrowhebrew",1467,"qubutsquarterhebrew",1467,"qubutswidehebrew",1467,"question",63,"questionarabic",1567,"questionarmenian",1374,"questiondown",191,"questiondownsmall",63423,"questiongreek",894,"questionmonospace",65311,"questionsmall",63295,"quotedbl",34,"quotedblbase",8222,"quotedblleft",8220,"quotedblmonospace",65282,"quotedblprime",12318,"quotedblprimereversed",12317,"quotedblright",8221,"quoteleft",8216,"quoteleftreversed",8219,"quotereversed",8219,"quoteright",8217,"quoterightn",329,"quotesinglbase",8218,"quotesingle",39,"quotesinglemonospace",65287,"r",114,"raarmenian",1404,"rabengali",2480,"racute",341,"radeva",2352,"radical",8730,"radicalex",63717,"radoverssquare",13230,"radoverssquaredsquare",13231,"radsquare",13229,"rafe",1471,"rafehebrew",1471,"ragujarati",2736,"ragurmukhi",2608,"rahiragana",12425,"rakatakana",12521,"rakatakanahalfwidth",65431,"ralowerdiagonalbengali",2545,"ramiddlediagonalbengali",2544,"ramshorn",612,"ratio",8758,"rbopomofo",12566,"rcaron",345,"rcedilla",343,"rcircle",9441,"rcommaaccent",343,"rdblgrave",529,"rdotaccent",7769,"rdotbelow",7771,"rdotbelowmacron",7773,"referencemark",8251,"reflexsubset",8838,"reflexsuperset",8839,"registered",174,"registersans",63720,"registerserif",63194,"reharabic",1585,"reharmenian",1408,"rehfinalarabic",65198,"rehiragana",12428,"rekatakana",12524,"rekatakanahalfwidth",65434,"resh",1512,"reshdageshhebrew",64328,"reshhebrew",1512,"reversedtilde",8765,"reviahebrew",1431,"reviamugrashhebrew",1431,"revlogicalnot",8976,"rfishhook",638,"rfishhookreversed",639,"rhabengali",2525,"rhadeva",2397,"rho",961,"rhook",637,"rhookturned",635,"rhookturnedsuperior",693,"rhosymbolgreek",1009,"rhotichookmod",734,"rieulacirclekorean",12913,"rieulaparenkorean",12817,"rieulcirclekorean",12899,"rieulhieuhkorean",12608,"rieulkiyeokkorean",12602,"rieulkiyeoksioskorean",12649,"rieulkorean",12601,"rieulmieumkorean",12603,"rieulpansioskorean",12652,"rieulparenkorean",12803,"rieulphieuphkorean",12607,"rieulpieupkorean",12604,"rieulpieupsioskorean",12651,"rieulsioskorean",12605,"rieulthieuthkorean",12606,"rieultikeutkorean",12650,"rieulyeorinhieuhkorean",12653,"rightangle",8735,"righttackbelowcmb",793,"righttriangle",8895,"rihiragana",12426,"rikatakana",12522,"rikatakanahalfwidth",65432,"ring",730,"ringbelowcmb",805,"ringcmb",778,"ringhalfleft",703,"ringhalfleftarmenian",1369,"ringhalfleftbelowcmb",796,"ringhalfleftcentered",723,"ringhalfright",702,"ringhalfrightbelowcmb",825,"ringhalfrightcentered",722,"rinvertedbreve",531,"rittorusquare",13137,"rlinebelow",7775,"rlongleg",636,"rlonglegturned",634,"rmonospace",65362,"rohiragana",12429,"rokatakana",12525,"rokatakanahalfwidth",65435,"roruathai",3619,"rparen",9389,"rrabengali",2524,"rradeva",2353,"rragurmukhi",2652,"rreharabic",1681,"rrehfinalarabic",64397,"rrvocalicbengali",2528,"rrvocalicdeva",2400,"rrvocalicgujarati",2784,"rrvocalicvowelsignbengali",2500,"rrvocalicvowelsigndeva",2372,"rrvocalicvowelsigngujarati",2756,"rsuperior",63217,"rtblock",9616,"rturned",633,"rturnedsuperior",692,"ruhiragana",12427,"rukatakana",12523,"rukatakanahalfwidth",65433,"rupeemarkbengali",2546,"rupeesignbengali",2547,"rupiah",63197,"ruthai",3620,"rvocalicbengali",2443,"rvocalicdeva",2315,"rvocalicgujarati",2699,"rvocalicvowelsignbengali",2499,"rvocalicvowelsigndeva",2371,"rvocalicvowelsigngujarati",2755,"s",115,"sabengali",2488,"sacute",347,"sacutedotaccent",7781,"sadarabic",1589,"sadeva",2360,"sadfinalarabic",65210,"sadinitialarabic",65211,"sadmedialarabic",65212,"sagujarati",2744,"sagurmukhi",2616,"sahiragana",12373,"sakatakana",12469,"sakatakanahalfwidth",65403,"sallallahoualayhewasallamarabic",65018,"samekh",1505,"samekhdagesh",64321,"samekhdageshhebrew",64321,"samekhhebrew",1505,"saraaathai",3634,"saraaethai",3649,"saraaimaimalaithai",3652,"saraaimaimuanthai",3651,"saraamthai",3635,"saraathai",3632,"saraethai",3648,"saraiileftthai",63622,"saraiithai",3637,"saraileftthai",63621,"saraithai",3636,"saraothai",3650,"saraueeleftthai",63624,"saraueethai",3639,"saraueleftthai",63623,"sarauethai",3638,"sarauthai",3640,"sarauuthai",3641,"sbopomofo",12569,"scaron",353,"scarondotaccent",7783,"scedilla",351,"schwa",601,"schwacyrillic",1241,"schwadieresiscyrillic",1243,"schwahook",602,"scircle",9442,"scircumflex",349,"scommaaccent",537,"sdotaccent",7777,"sdotbelow",7779,"sdotbelowdotaccent",7785,"seagullbelowcmb",828,"second",8243,"secondtonechinese",714,"section",167,"seenarabic",1587,"seenfinalarabic",65202,"seeninitialarabic",65203,"seenmedialarabic",65204,"segol",1462,"segol13",1462,"segol1f",1462,"segol2c",1462,"segolhebrew",1462,"segolnarrowhebrew",1462,"segolquarterhebrew",1462,"segoltahebrew",1426,"segolwidehebrew",1462,"seharmenian",1405,"sehiragana",12379,"sekatakana",12475,"sekatakanahalfwidth",65406,"semicolon",59,"semicolonarabic",1563,"semicolonmonospace",65307,"semicolonsmall",65108,"semivoicedmarkkana",12444,"semivoicedmarkkanahalfwidth",65439,"sentisquare",13090,"sentosquare",13091,"seven",55,"sevenarabic",1639,"sevenbengali",2541,"sevencircle",9318,"sevencircleinversesansserif",10128,"sevendeva",2413,"seveneighths",8542,"sevengujarati",2797,"sevengurmukhi",2669,"sevenhackarabic",1639,"sevenhangzhou",12327,"sevenideographicparen",12838,"seveninferior",8327,"sevenmonospace",65303,"sevenoldstyle",63287,"sevenparen",9338,"sevenperiod",9358,"sevenpersian",1783,"sevenroman",8566,"sevensuperior",8311,"seventeencircle",9328,"seventeenparen",9348,"seventeenperiod",9368,"seventhai",3671,"sfthyphen",173,"shaarmenian",1399,"shabengali",2486,"shacyrillic",1096,"shaddaarabic",1617,"shaddadammaarabic",64609,"shaddadammatanarabic",64606,"shaddafathaarabic",64608,"shaddakasraarabic",64610,"shaddakasratanarabic",64607,"shade",9618,"shadedark",9619,"shadelight",9617,"shademedium",9618,"shadeva",2358,"shagujarati",2742,"shagurmukhi",2614,"shalshelethebrew",1427,"shbopomofo",12565,"shchacyrillic",1097,"sheenarabic",1588,"sheenfinalarabic",65206,"sheeninitialarabic",65207,"sheenmedialarabic",65208,"sheicoptic",995,"sheqel",8362,"sheqelhebrew",8362,"sheva",1456,"sheva115",1456,"sheva15",1456,"sheva22",1456,"sheva2e",1456,"shevahebrew",1456,"shevanarrowhebrew",1456,"shevaquarterhebrew",1456,"shevawidehebrew",1456,"shhacyrillic",1211,"shimacoptic",1005,"shin",1513,"shindagesh",64329,"shindageshhebrew",64329,"shindageshshindot",64300,"shindageshshindothebrew",64300,"shindageshsindot",64301,"shindageshsindothebrew",64301,"shindothebrew",1473,"shinhebrew",1513,"shinshindot",64298,"shinshindothebrew",64298,"shinsindot",64299,"shinsindothebrew",64299,"shook",642,"sigma",963,"sigma1",962,"sigmafinal",962,"sigmalunatesymbolgreek",1010,"sihiragana",12375,"sikatakana",12471,"sikatakanahalfwidth",65404,"siluqhebrew",1469,"siluqlefthebrew",1469,"similar",8764,"sindothebrew",1474,"siosacirclekorean",12916,"siosaparenkorean",12820,"sioscieuckorean",12670,"sioscirclekorean",12902,"sioskiyeokkorean",12666,"sioskorean",12613,"siosnieunkorean",12667,"siosparenkorean",12806,"siospieupkorean",12669,"siostikeutkorean",12668,"six",54,"sixarabic",1638,"sixbengali",2540,"sixcircle",9317,"sixcircleinversesansserif",10127,"sixdeva",2412,"sixgujarati",2796,"sixgurmukhi",2668,"sixhackarabic",1638,"sixhangzhou",12326,"sixideographicparen",12837,"sixinferior",8326,"sixmonospace",65302,"sixoldstyle",63286,"sixparen",9337,"sixperiod",9357,"sixpersian",1782,"sixroman",8565,"sixsuperior",8310,"sixteencircle",9327,"sixteencurrencydenominatorbengali",2553,"sixteenparen",9347,"sixteenperiod",9367,"sixthai",3670,"slash",47,"slashmonospace",65295,"slong",383,"slongdotaccent",7835,"smileface",9786,"smonospace",65363,"sofpasuqhebrew",1475,"softhyphen",173,"softsigncyrillic",1100,"sohiragana",12381,"sokatakana",12477,"sokatakanahalfwidth",65407,"soliduslongoverlaycmb",824,"solidusshortoverlaycmb",823,"sorusithai",3625,"sosalathai",3624,"sosothai",3595,"sosuathai",3626,"space",32,"spacehackarabic",32,"spade",9824,"spadesuitblack",9824,"spadesuitwhite",9828,"sparen",9390,"squarebelowcmb",827,"squarecc",13252,"squarecm",13213,"squarediagonalcrosshatchfill",9641,"squarehorizontalfill",9636,"squarekg",13199,"squarekm",13214,"squarekmcapital",13262,"squareln",13265,"squarelog",13266,"squaremg",13198,"squaremil",13269,"squaremm",13212,"squaremsquared",13217,"squareorthogonalcrosshatchfill",9638,"squareupperlefttolowerrightfill",9639,"squareupperrighttolowerleftfill",9640,"squareverticalfill",9637,"squarewhitewithsmallblack",9635,"srsquare",13275,"ssabengali",2487,"ssadeva",2359,"ssagujarati",2743,"ssangcieuckorean",12617,"ssanghieuhkorean",12677,"ssangieungkorean",12672,"ssangkiyeokkorean",12594,"ssangnieunkorean",12645,"ssangpieupkorean",12611,"ssangsioskorean",12614,"ssangtikeutkorean",12600,"ssuperior",63218,"sterling",163,"sterlingmonospace",65505,"strokelongoverlaycmb",822,"strokeshortoverlaycmb",821,"subset",8834,"subsetnotequal",8842,"subsetorequal",8838,"succeeds",8827,"suchthat",8715,"suhiragana",12377,"sukatakana",12473,"sukatakanahalfwidth",65405,"sukunarabic",1618,"summation",8721,"sun",9788,"superset",8835,"supersetnotequal",8843,"supersetorequal",8839,"svsquare",13276,"syouwaerasquare",13180,"t",116,"tabengali",2468,"tackdown",8868,"tackleft",8867,"tadeva",2340,"tagujarati",2724,"tagurmukhi",2596,"taharabic",1591,"tahfinalarabic",65218,"tahinitialarabic",65219,"tahiragana",12383,"tahmedialarabic",65220,"taisyouerasquare",13181,"takatakana",12479,"takatakanahalfwidth",65408,"tatweelarabic",1600,"tau",964,"tav",1514,"tavdages",64330,"tavdagesh",64330,"tavdageshhebrew",64330,"tavhebrew",1514,"tbar",359,"tbopomofo",12554,"tcaron",357,"tccurl",680,"tcedilla",355,"tcheharabic",1670,"tchehfinalarabic",64379,"tchehinitialarabic",64380,"tchehmedialarabic",64381,"tcircle",9443,"tcircumflexbelow",7793,"tcommaaccent",355,"tdieresis",7831,"tdotaccent",7787,"tdotbelow",7789,"tecyrillic",1090,"tedescendercyrillic",1197,"teharabic",1578,"tehfinalarabic",65174,"tehhahinitialarabic",64674,"tehhahisolatedarabic",64524,"tehinitialarabic",65175,"tehiragana",12390,"tehjeeminitialarabic",64673,"tehjeemisolatedarabic",64523,"tehmarbutaarabic",1577,"tehmarbutafinalarabic",65172,"tehmedialarabic",65176,"tehmeeminitialarabic",64676,"tehmeemisolatedarabic",64526,"tehnoonfinalarabic",64627,"tekatakana",12486,"tekatakanahalfwidth",65411,"telephone",8481,"telephoneblack",9742,"telishagedolahebrew",1440,"telishaqetanahebrew",1449,"tencircle",9321,"tenideographicparen",12841,"tenparen",9341,"tenperiod",9361,"tenroman",8569,"tesh",679,"tet",1496,"tetdagesh",64312,"tetdageshhebrew",64312,"tethebrew",1496,"tetsecyrillic",1205,"tevirhebrew",1435,"tevirlefthebrew",1435,"thabengali",2469,"thadeva",2341,"thagujarati",2725,"thagurmukhi",2597,"thalarabic",1584,"thalfinalarabic",65196,"thanthakhatlowleftthai",63640,"thanthakhatlowrightthai",63639,"thanthakhatthai",3660,"thanthakhatupperleftthai",63638,"theharabic",1579,"thehfinalarabic",65178,"thehinitialarabic",65179,"thehmedialarabic",65180,"thereexists",8707,"therefore",8756,"theta",952,"theta1",977,"thetasymbolgreek",977,"thieuthacirclekorean",12921,"thieuthaparenkorean",12825,"thieuthcirclekorean",12907,"thieuthkorean",12620,"thieuthparenkorean",12811,"thirteencircle",9324,"thirteenparen",9344,"thirteenperiod",9364,"thonangmonthothai",3601,"thook",429,"thophuthaothai",3602,"thorn",254,"thothahanthai",3607,"thothanthai",3600,"thothongthai",3608,"thothungthai",3606,"thousandcyrillic",1154,"thousandsseparatorarabic",1644,"thousandsseparatorpersian",1644,"three",51,"threearabic",1635,"threebengali",2537,"threecircle",9314,"threecircleinversesansserif",10124,"threedeva",2409,"threeeighths",8540,"threegujarati",2793,"threegurmukhi",2665,"threehackarabic",1635,"threehangzhou",12323,"threeideographicparen",12834,"threeinferior",8323,"threemonospace",65299,"threenumeratorbengali",2550,"threeoldstyle",63283,"threeparen",9334,"threeperiod",9354,"threepersian",1779,"threequarters",190,"threequartersemdash",63198,"threeroman",8562,"threesuperior",179,"threethai",3667,"thzsquare",13204,"tihiragana",12385,"tikatakana",12481,"tikatakanahalfwidth",65409,"tikeutacirclekorean",12912,"tikeutaparenkorean",12816,"tikeutcirclekorean",12898,"tikeutkorean",12599,"tikeutparenkorean",12802,"tilde",732,"tildebelowcmb",816,"tildecmb",771,"tildecomb",771,"tildedoublecmb",864,"tildeoperator",8764,"tildeoverlaycmb",820,"tildeverticalcmb",830,"timescircle",8855,"tipehahebrew",1430,"tipehalefthebrew",1430,"tippigurmukhi",2672,"titlocyrilliccmb",1155,"tiwnarmenian",1407,"tlinebelow",7791,"tmonospace",65364,"toarmenian",1385,"tohiragana",12392,"tokatakana",12488,"tokatakanahalfwidth",65412,"tonebarextrahighmod",741,"tonebarextralowmod",745,"tonebarhighmod",742,"tonebarlowmod",744,"tonebarmidmod",743,"tonefive",445,"tonesix",389,"tonetwo",424,"tonos",900,"tonsquare",13095,"topatakthai",3599,"tortoiseshellbracketleft",12308,"tortoiseshellbracketleftsmall",65117,"tortoiseshellbracketleftvertical",65081,"tortoiseshellbracketright",12309,"tortoiseshellbracketrightsmall",65118,"tortoiseshellbracketrightvertical",65082,"totaothai",3605,"tpalatalhook",427,"tparen",9391,"trademark",8482,"trademarksans",63722,"trademarkserif",63195,"tretroflexhook",648,"triagdn",9660,"triaglf",9668,"triagrt",9658,"triagup",9650,"ts",678,"tsadi",1510,"tsadidagesh",64326,"tsadidageshhebrew",64326,"tsadihebrew",1510,"tsecyrillic",1094,"tsere",1461,"tsere12",1461,"tsere1e",1461,"tsere2b",1461,"tserehebrew",1461,"tserenarrowhebrew",1461,"tserequarterhebrew",1461,"tserewidehebrew",1461,"tshecyrillic",1115,"tsuperior",63219,"ttabengali",2463,"ttadeva",2335,"ttagujarati",2719,"ttagurmukhi",2591,"tteharabic",1657,"ttehfinalarabic",64359,"ttehinitialarabic",64360,"ttehmedialarabic",64361,"tthabengali",2464,"tthadeva",2336,"tthagujarati",2720,"tthagurmukhi",2592,"tturned",647,"tuhiragana",12388,"tukatakana",12484,"tukatakanahalfwidth",65410,"tusmallhiragana",12387,"tusmallkatakana",12483,"tusmallkatakanahalfwidth",65391,"twelvecircle",9323,"twelveparen",9343,"twelveperiod",9363,"twelveroman",8571,"twentycircle",9331,"twentyhangzhou",21316,"twentyparen",9351,"twentyperiod",9371,"two",50,"twoarabic",1634,"twobengali",2536,"twocircle",9313,"twocircleinversesansserif",10123,"twodeva",2408,"twodotenleader",8229,"twodotleader",8229,"twodotleadervertical",65072,"twogujarati",2792,"twogurmukhi",2664,"twohackarabic",1634,"twohangzhou",12322,"twoideographicparen",12833,"twoinferior",8322,"twomonospace",65298,"twonumeratorbengali",2549,"twooldstyle",63282,"twoparen",9333,"twoperiod",9353,"twopersian",1778,"tworoman",8561,"twostroke",443,"twosuperior",178,"twothai",3666,"twothirds",8532,"u",117,"uacute",250,"ubar",649,"ubengali",2441,"ubopomofo",12584,"ubreve",365,"ucaron",468,"ucircle",9444,"ucircumflex",251,"ucircumflexbelow",7799,"ucyrillic",1091,"udattadeva",2385,"udblacute",369,"udblgrave",533,"udeva",2313,"udieresis",252,"udieresisacute",472,"udieresisbelow",7795,"udieresiscaron",474,"udieresiscyrillic",1265,"udieresisgrave",476,"udieresismacron",470,"udotbelow",7909,"ugrave",249,"ugujarati",2697,"ugurmukhi",2569,"uhiragana",12358,"uhookabove",7911,"uhorn",432,"uhornacute",7913,"uhorndotbelow",7921,"uhorngrave",7915,"uhornhookabove",7917,"uhorntilde",7919,"uhungarumlaut",369,"uhungarumlautcyrillic",1267,"uinvertedbreve",535,"ukatakana",12454,"ukatakanahalfwidth",65395,"ukcyrillic",1145,"ukorean",12636,"umacron",363,"umacroncyrillic",1263,"umacrondieresis",7803,"umatragurmukhi",2625,"umonospace",65365,"underscore",95,"underscoredbl",8215,"underscoremonospace",65343,"underscorevertical",65075,"underscorewavy",65103,"union",8746,"universal",8704,"uogonek",371,"uparen",9392,"upblock",9600,"upperdothebrew",1476,"upsilon",965,"upsilondieresis",971,"upsilondieresistonos",944,"upsilonlatin",650,"upsilontonos",973,"uptackbelowcmb",797,"uptackmod",724,"uragurmukhi",2675,"uring",367,"ushortcyrillic",1118,"usmallhiragana",12357,"usmallkatakana",12453,"usmallkatakanahalfwidth",65385,"ustraightcyrillic",1199,"ustraightstrokecyrillic",1201,"utilde",361,"utildeacute",7801,"utildebelow",7797,"uubengali",2442,"uudeva",2314,"uugujarati",2698,"uugurmukhi",2570,"uumatragurmukhi",2626,"uuvowelsignbengali",2498,"uuvowelsigndeva",2370,"uuvowelsigngujarati",2754,"uvowelsignbengali",2497,"uvowelsigndeva",2369,"uvowelsigngujarati",2753,"v",118,"vadeva",2357,"vagujarati",2741,"vagurmukhi",2613,"vakatakana",12535,"vav",1493,"vavdagesh",64309,"vavdagesh65",64309,"vavdageshhebrew",64309,"vavhebrew",1493,"vavholam",64331,"vavholamhebrew",64331,"vavvavhebrew",1520,"vavyodhebrew",1521,"vcircle",9445,"vdotbelow",7807,"vecyrillic",1074,"veharabic",1700,"vehfinalarabic",64363,"vehinitialarabic",64364,"vehmedialarabic",64365,"vekatakana",12537,"venus",9792,"verticalbar",124,"verticallineabovecmb",781,"verticallinebelowcmb",809,"verticallinelowmod",716,"verticallinemod",712,"vewarmenian",1406,"vhook",651,"vikatakana",12536,"viramabengali",2509,"viramadeva",2381,"viramagujarati",2765,"visargabengali",2435,"visargadeva",2307,"visargagujarati",2691,"vmonospace",65366,"voarmenian",1400,"voicediterationhiragana",12446,"voicediterationkatakana",12542,"voicedmarkkana",12443,"voicedmarkkanahalfwidth",65438,"vokatakana",12538,"vparen",9393,"vtilde",7805,"vturned",652,"vuhiragana",12436,"vukatakana",12532,"w",119,"wacute",7811,"waekorean",12633,"wahiragana",12431,"wakatakana",12527,"wakatakanahalfwidth",65436,"wakorean",12632,"wasmallhiragana",12430,"wasmallkatakana",12526,"wattosquare",13143,"wavedash",12316,"wavyunderscorevertical",65076,"wawarabic",1608,"wawfinalarabic",65262,"wawhamzaabovearabic",1572,"wawhamzaabovefinalarabic",65158,"wbsquare",13277,"wcircle",9446,"wcircumflex",373,"wdieresis",7813,"wdotaccent",7815,"wdotbelow",7817,"wehiragana",12433,"weierstrass",8472,"wekatakana",12529,"wekorean",12638,"weokorean",12637,"wgrave",7809,"whitebullet",9702,"whitecircle",9675,"whitecircleinverse",9689,"whitecornerbracketleft",12302,"whitecornerbracketleftvertical",65091,"whitecornerbracketright",12303,"whitecornerbracketrightvertical",65092,"whitediamond",9671,"whitediamondcontainingblacksmalldiamond",9672,"whitedownpointingsmalltriangle",9663,"whitedownpointingtriangle",9661,"whiteleftpointingsmalltriangle",9667,"whiteleftpointingtriangle",9665,"whitelenticularbracketleft",12310,"whitelenticularbracketright",12311,"whiterightpointingsmalltriangle",9657,"whiterightpointingtriangle",9655,"whitesmallsquare",9643,"whitesmilingface",9786,"whitesquare",9633,"whitestar",9734,"whitetelephone",9743,"whitetortoiseshellbracketleft",12312,"whitetortoiseshellbracketright",12313,"whiteuppointingsmalltriangle",9653,"whiteuppointingtriangle",9651,"wihiragana",12432,"wikatakana",12528,"wikorean",12639,"wmonospace",65367,"wohiragana",12434,"wokatakana",12530,"wokatakanahalfwidth",65382,"won",8361,"wonmonospace",65510,"wowaenthai",3623,"wparen",9394,"wring",7832,"wsuperior",695,"wturned",653,"wynn",447,"x",120,"xabovecmb",829,"xbopomofo",12562,"xcircle",9447,"xdieresis",7821,"xdotaccent",7819,"xeharmenian",1389,"xi",958,"xmonospace",65368,"xparen",9395,"xsuperior",739,"y",121,"yaadosquare",13134,"yabengali",2479,"yacute",253,"yadeva",2351,"yaekorean",12626,"yagujarati",2735,"yagurmukhi",2607,"yahiragana",12420,"yakatakana",12516,"yakatakanahalfwidth",65428,"yakorean",12625,"yamakkanthai",3662,"yasmallhiragana",12419,"yasmallkatakana",12515,"yasmallkatakanahalfwidth",65388,"yatcyrillic",1123,"ycircle",9448,"ycircumflex",375,"ydieresis",255,"ydotaccent",7823,"ydotbelow",7925,"yeharabic",1610,"yehbarreearabic",1746,"yehbarreefinalarabic",64431,"yehfinalarabic",65266,"yehhamzaabovearabic",1574,"yehhamzaabovefinalarabic",65162,"yehhamzaaboveinitialarabic",65163,"yehhamzaabovemedialarabic",65164,"yehinitialarabic",65267,"yehmedialarabic",65268,"yehmeeminitialarabic",64733,"yehmeemisolatedarabic",64600,"yehnoonfinalarabic",64660,"yehthreedotsbelowarabic",1745,"yekorean",12630,"yen",165,"yenmonospace",65509,"yeokorean",12629,"yeorinhieuhkorean",12678,"yerahbenyomohebrew",1450,"yerahbenyomolefthebrew",1450,"yericyrillic",1099,"yerudieresiscyrillic",1273,"yesieungkorean",12673,"yesieungpansioskorean",12675,"yesieungsioskorean",12674,"yetivhebrew",1434,"ygrave",7923,"yhook",436,"yhookabove",7927,"yiarmenian",1397,"yicyrillic",1111,"yikorean",12642,"yinyang",9775,"yiwnarmenian",1410,"ymonospace",65369,"yod",1497,"yoddagesh",64313,"yoddageshhebrew",64313,"yodhebrew",1497,"yodyodhebrew",1522,"yodyodpatahhebrew",64287,"yohiragana",12424,"yoikorean",12681,"yokatakana",12520,"yokatakanahalfwidth",65430,"yokorean",12635,"yosmallhiragana",12423,"yosmallkatakana",12519,"yosmallkatakanahalfwidth",65390,"yotgreek",1011,"yoyaekorean",12680,"yoyakorean",12679,"yoyakthai",3618,"yoyingthai",3597,"yparen",9396,"ypogegrammeni",890,"ypogegrammenigreekcmb",837,"yr",422,"yring",7833,"ysuperior",696,"ytilde",7929,"yturned",654,"yuhiragana",12422,"yuikorean",12684,"yukatakana",12518,"yukatakanahalfwidth",65429,"yukorean",12640,"yusbigcyrillic",1131,"yusbigiotifiedcyrillic",1133,"yuslittlecyrillic",1127,"yuslittleiotifiedcyrillic",1129,"yusmallhiragana",12421,"yusmallkatakana",12517,"yusmallkatakanahalfwidth",65389,"yuyekorean",12683,"yuyeokorean",12682,"yyabengali",2527,"yyadeva",2399,"z",122,"zaarmenian",1382,"zacute",378,"zadeva",2395,"zagurmukhi",2651,"zaharabic",1592,"zahfinalarabic",65222,"zahinitialarabic",65223,"zahiragana",12374,"zahmedialarabic",65224,"zainarabic",1586,"zainfinalarabic",65200,"zakatakana",12470,"zaqefgadolhebrew",1429,"zaqefqatanhebrew",1428,"zarqahebrew",1432,"zayin",1494,"zayindagesh",64310,"zayindageshhebrew",64310,"zayinhebrew",1494,"zbopomofo",12567,"zcaron",382,"zcircle",9449,"zcircumflex",7825,"zcurl",657,"zdot",380,"zdotaccent",380,"zdotbelow",7827,"zecyrillic",1079,"zedescendercyrillic",1177,"zedieresiscyrillic",1247,"zehiragana",12380,"zekatakana",12476,"zero",48,"zeroarabic",1632,"zerobengali",2534,"zerodeva",2406,"zerogujarati",2790,"zerogurmukhi",2662,"zerohackarabic",1632,"zeroinferior",8320,"zeromonospace",65296,"zerooldstyle",63280,"zeropersian",1776,"zerosuperior",8304,"zerothai",3664,"zerowidthjoiner",65279,"zerowidthnonjoiner",8204,"zerowidthspace",8203,"zeta",950,"zhbopomofo",12563,"zhearmenian",1386,"zhebrevecyrillic",1218,"zhecyrillic",1078,"zhedescendercyrillic",1175,"zhedieresiscyrillic",1245,"zihiragana",12376,"zikatakana",12472,"zinorhebrew",1454,"zlinebelow",7829,"zmonospace",65370,"zohiragana",12382,"zokatakana",12478,"zparen",9397,"zretroflexhook",656,"zstroke",438,"zuhiragana",12378,"zukatakana",12474,".notdef",0,"angbracketleftbig",9001,"angbracketleftBig",9001,"angbracketleftbigg",9001,"angbracketleftBigg",9001,"angbracketrightBig",9002,"angbracketrightbig",9002,"angbracketrightBigg",9002,"angbracketrightbigg",9002,"arrowhookleft",8618,"arrowhookright",8617,"arrowlefttophalf",8636,"arrowleftbothalf",8637,"arrownortheast",8599,"arrownorthwest",8598,"arrowrighttophalf",8640,"arrowrightbothalf",8641,"arrowsoutheast",8600,"arrowsouthwest",8601,"backslashbig",8726,"backslashBig",8726,"backslashBigg",8726,"backslashbigg",8726,"bardbl",8214,"bracehtipdownleft",65079,"bracehtipdownright",65079,"bracehtipupleft",65080,"bracehtipupright",65080,"braceleftBig",123,"braceleftbig",123,"braceleftbigg",123,"braceleftBigg",123,"bracerightBig",125,"bracerightbig",125,"bracerightbigg",125,"bracerightBigg",125,"bracketleftbig",91,"bracketleftBig",91,"bracketleftbigg",91,"bracketleftBigg",91,"bracketrightBig",93,"bracketrightbig",93,"bracketrightbigg",93,"bracketrightBigg",93,"ceilingleftbig",8968,"ceilingleftBig",8968,"ceilingleftBigg",8968,"ceilingleftbigg",8968,"ceilingrightbig",8969,"ceilingrightBig",8969,"ceilingrightbigg",8969,"ceilingrightBigg",8969,"circledotdisplay",8857,"circledottext",8857,"circlemultiplydisplay",8855,"circlemultiplytext",8855,"circleplusdisplay",8853,"circleplustext",8853,"contintegraldisplay",8750,"contintegraltext",8750,"coproductdisplay",8720,"coproducttext",8720,"floorleftBig",8970,"floorleftbig",8970,"floorleftbigg",8970,"floorleftBigg",8970,"floorrightbig",8971,"floorrightBig",8971,"floorrightBigg",8971,"floorrightbigg",8971,"hatwide",770,"hatwider",770,"hatwidest",770,"intercal",7488,"integraldisplay",8747,"integraltext",8747,"intersectiondisplay",8898,"intersectiontext",8898,"logicalanddisplay",8743,"logicalandtext",8743,"logicalordisplay",8744,"logicalortext",8744,"parenleftBig",40,"parenleftbig",40,"parenleftBigg",40,"parenleftbigg",40,"parenrightBig",41,"parenrightbig",41,"parenrightBigg",41,"parenrightbigg",41,"prime",8242,"productdisplay",8719,"producttext",8719,"radicalbig",8730,"radicalBig",8730,"radicalBigg",8730,"radicalbigg",8730,"radicalbt",8730,"radicaltp",8730,"radicalvertex",8730,"slashbig",47,"slashBig",47,"slashBigg",47,"slashbigg",47,"summationdisplay",8721,"summationtext",8721,"tildewide",732,"tildewider",732,"tildewidest",732,"uniondisplay",8899,"unionmultidisplay",8846,"unionmultitext",8846,"unionsqdisplay",8852,"unionsqtext",8852,"uniontext",8899,"vextenddouble",8741,"vextendsingle",8739]})),i=(0,n.getArrayLookupTableFactory)((function(){return["space",32,"a1",9985,"a2",9986,"a202",9987,"a3",9988,"a4",9742,"a5",9990,"a119",9991,"a118",9992,"a117",9993,"a11",9755,"a12",9758,"a13",9996,"a14",9997,"a15",9998,"a16",9999,"a105",1e4,"a17",10001,"a18",10002,"a19",10003,"a20",10004,"a21",10005,"a22",10006,"a23",10007,"a24",10008,"a25",10009,"a26",10010,"a27",10011,"a28",10012,"a6",10013,"a7",10014,"a8",10015,"a9",10016,"a10",10017,"a29",10018,"a30",10019,"a31",10020,"a32",10021,"a33",10022,"a34",10023,"a35",9733,"a36",10025,"a37",10026,"a38",10027,"a39",10028,"a40",10029,"a41",10030,"a42",10031,"a43",10032,"a44",10033,"a45",10034,"a46",10035,"a47",10036,"a48",10037,"a49",10038,"a50",10039,"a51",10040,"a52",10041,"a53",10042,"a54",10043,"a55",10044,"a56",10045,"a57",10046,"a58",10047,"a59",10048,"a60",10049,"a61",10050,"a62",10051,"a63",10052,"a64",10053,"a65",10054,"a66",10055,"a67",10056,"a68",10057,"a69",10058,"a70",10059,"a71",9679,"a72",10061,"a73",9632,"a74",10063,"a203",10064,"a75",10065,"a204",10066,"a76",9650,"a77",9660,"a78",9670,"a79",10070,"a81",9687,"a82",10072,"a83",10073,"a84",10074,"a97",10075,"a98",10076,"a99",10077,"a100",10078,"a101",10081,"a102",10082,"a103",10083,"a104",10084,"a106",10085,"a107",10086,"a108",10087,"a112",9827,"a111",9830,"a110",9829,"a109",9824,"a120",9312,"a121",9313,"a122",9314,"a123",9315,"a124",9316,"a125",9317,"a126",9318,"a127",9319,"a128",9320,"a129",9321,"a130",10102,"a131",10103,"a132",10104,"a133",10105,"a134",10106,"a135",10107,"a136",10108,"a137",10109,"a138",10110,"a139",10111,"a140",10112,"a141",10113,"a142",10114,"a143",10115,"a144",10116,"a145",10117,"a146",10118,"a147",10119,"a148",10120,"a149",10121,"a150",10122,"a151",10123,"a152",10124,"a153",10125,"a154",10126,"a155",10127,"a156",10128,"a157",10129,"a158",10130,"a159",10131,"a160",10132,"a161",8594,"a163",8596,"a164",8597,"a196",10136,"a165",10137,"a192",10138,"a166",10139,"a167",10140,"a168",10141,"a169",10142,"a170",10143,"a171",10144,"a172",10145,"a173",10146,"a162",10147,"a174",10148,"a175",10149,"a176",10150,"a177",10151,"a178",10152,"a179",10153,"a193",10154,"a180",10155,"a199",10156,"a181",10157,"a200",10158,"a182",10159,"a201",10161,"a183",10162,"a184",10163,"a197",10164,"a185",10165,"a194",10166,"a198",10167,"a186",10168,"a195",10169,"a187",10170,"a188",10171,"a189",10172,"a190",10173,"a191",10174,"a89",10088,"a90",10089,"a93",10090,"a94",10091,"a91",10092,"a92",10093,"a205",10094,"a85",10095,"a206",10096,"a86",10097,"a87",10098,"a88",10099,"a95",10100,"a96",10101,".notdef",0]}))},(e,t,r)=>{"use strict";r.r(t);r.d(t,{clearUnicodeCaches:()=>clearUnicodeCaches,getCharUnicodeCategory:()=>getCharUnicodeCategory,getNormalizedUnicodes:()=>s,getUnicodeForGlyph:()=>getUnicodeForGlyph,getUnicodeRangeFor:()=>getUnicodeRangeFor,mapSpecialUnicodeValues:()=>mapSpecialUnicodeValues,reverseIfRtl:()=>reverseIfRtl});var n=r(213);const a=(0,n.getLookupTableFactory)((function(e){e[63721]=169;e[63193]=169;e[63720]=174;e[63194]=174;e[63722]=8482;e[63195]=8482;e[63729]=9127;e[63730]=9128;e[63731]=9129;e[63740]=9131;e[63741]=9132;e[63742]=9133;e[63726]=9121;e[63727]=9122;e[63728]=9123;e[63737]=9124;e[63738]=9125;e[63739]=9126;e[63723]=9115;e[63724]=9116;e[63725]=9117;e[63734]=9118;e[63735]=9119;e[63736]=9120}));function mapSpecialUnicodeValues(e){return e>=65520&&e<=65535?0:e>=62976&&e<=63743?a()[e]||e:173===e?45:e}function getUnicodeForGlyph(e,t){let r=t[e];if(void 0!==r)return r;if(!e)return-1;if("u"===e[0]){const t=e.length;let n;if(7===t&&"n"===e[1]&&"i"===e[2])n=e.substring(3);else{if(!(t>=5&&t<=7))return-1;n=e.substring(1)}if(n===n.toUpperCase()){r=parseInt(n,16);if(r>=0)return r}}return-1}const i=[{begin:0,end:127},{begin:128,end:255},{begin:256,end:383},{begin:384,end:591},{begin:592,end:687},{begin:688,end:767},{begin:768,end:879},{begin:880,end:1023},{begin:11392,end:11519},{begin:1024,end:1279},{begin:1328,end:1423},{begin:1424,end:1535},{begin:42240,end:42559},{begin:1536,end:1791},{begin:1984,end:2047},{begin:2304,end:2431},{begin:2432,end:2559},{begin:2560,end:2687},{begin:2688,end:2815},{begin:2816,end:2943},{begin:2944,end:3071},{begin:3072,end:3199},{begin:3200,end:3327},{begin:3328,end:3455},{begin:3584,end:3711},{begin:3712,end:3839},{begin:4256,end:4351},{begin:6912,end:7039},{begin:4352,end:4607},{begin:7680,end:7935},{begin:7936,end:8191},{begin:8192,end:8303},{begin:8304,end:8351},{begin:8352,end:8399},{begin:8400,end:8447},{begin:8448,end:8527},{begin:8528,end:8591},{begin:8592,end:8703},{begin:8704,end:8959},{begin:8960,end:9215},{begin:9216,end:9279},{begin:9280,end:9311},{begin:9312,end:9471},{begin:9472,end:9599},{begin:9600,end:9631},{begin:9632,end:9727},{begin:9728,end:9983},{begin:9984,end:10175},{begin:12288,end:12351},{begin:12352,end:12447},{begin:12448,end:12543},{begin:12544,end:12591},{begin:12592,end:12687},{begin:43072,end:43135},{begin:12800,end:13055},{begin:13056,end:13311},{begin:44032,end:55215},{begin:55296,end:57343},{begin:67840,end:67871},{begin:19968,end:40959},{begin:57344,end:63743},{begin:12736,end:12783},{begin:64256,end:64335},{begin:64336,end:65023},{begin:65056,end:65071},{begin:65040,end:65055},{begin:65104,end:65135},{begin:65136,end:65279},{begin:65280,end:65519},{begin:65520,end:65535},{begin:3840,end:4095},{begin:1792,end:1871},{begin:1920,end:1983},{begin:3456,end:3583},{begin:4096,end:4255},{begin:4608,end:4991},{begin:5024,end:5119},{begin:5120,end:5759},{begin:5760,end:5791},{begin:5792,end:5887},{begin:6016,end:6143},{begin:6144,end:6319},{begin:10240,end:10495},{begin:40960,end:42127},{begin:5888,end:5919},{begin:66304,end:66351},{begin:66352,end:66383},{begin:66560,end:66639},{begin:118784,end:119039},{begin:119808,end:120831},{begin:1044480,end:1048573},{begin:65024,end:65039},{begin:917504,end:917631},{begin:6400,end:6479},{begin:6480,end:6527},{begin:6528,end:6623},{begin:6656,end:6687},{begin:11264,end:11359},{begin:11568,end:11647},{begin:19904,end:19967},{begin:43008,end:43055},{begin:65536,end:65663},{begin:65856,end:65935},{begin:66432,end:66463},{begin:66464,end:66527},{begin:66640,end:66687},{begin:66688,end:66735},{begin:67584,end:67647},{begin:68096,end:68191},{begin:119552,end:119647},{begin:73728,end:74751},{begin:119648,end:119679},{begin:7040,end:7103},{begin:7168,end:7247},{begin:7248,end:7295},{begin:43136,end:43231},{begin:43264,end:43311},{begin:43312,end:43359},{begin:43520,end:43615},{begin:65936,end:65999},{begin:66e3,end:66047},{begin:66208,end:66271},{begin:127024,end:127135}];function getUnicodeRangeFor(e){for(let t=0,r=i.length;t<r;t++){const r=i[t];if(e>=r.begin&&e<r.end)return t}return-1}const s=(0,n.getArrayLookupTableFactory)((function(){return["¨"," ̈","¯"," ̄","´"," ́","µ","μ","¸"," ̧","Ĳ","IJ","ĳ","ij","Ŀ","L·","ŀ","l·","ŉ","ʼn","ſ","s","Ǆ","DŽ","ǅ","Dž","ǆ","dž","Ǉ","LJ","ǈ","Lj","ǉ","lj","Ǌ","NJ","ǋ","Nj","ǌ","nj","Ǳ","DZ","ǲ","Dz","ǳ","dz","˘"," ̆","˙"," ̇","˚"," ̊","˛"," ̨","˜"," ̃","˝"," ̋","ͺ"," ͅ","΄"," ́","ϐ","β","ϑ","θ","ϒ","Υ","ϕ","φ","ϖ","π","ϰ","κ","ϱ","ρ","ϲ","ς","ϴ","Θ","ϵ","ε","Ϲ","Σ","և","եւ","ٵ","اٴ","ٶ","وٴ","ٷ","ۇٴ","ٸ","يٴ","ำ","ํา","ຳ","ໍາ","ໜ","ຫນ","ໝ","ຫມ","ཷ","ྲཱྀ","ཹ","ླཱྀ","ẚ","aʾ","᾽"," ̓","᾿"," ̓","῀"," ͂","῾"," ̔"," "," "," "," "," "," "," "," "," "," "," "," "," "," "," "," ","‗"," ̳","․",".","‥","..","…","...","″","′′","‴","′′′","‶","‵‵","‷","‵‵‵","‼","!!","‾"," ̅","⁇","??","⁈","?!","⁉","!?","⁗","′′′′"," "," ","₨","Rs","℀","a/c","℁","a/s","℃","°C","℅","c/o","℆","c/u","ℇ","Ɛ","℉","°F","№","No","℡","TEL","ℵ","א","ℶ","ב","ℷ","ג","ℸ","ד","℻","FAX","Ⅰ","I","Ⅱ","II","Ⅲ","III","Ⅳ","IV","Ⅴ","V","Ⅵ","VI","Ⅶ","VII","Ⅷ","VIII","Ⅸ","IX","Ⅹ","X","Ⅺ","XI","Ⅻ","XII","Ⅼ","L","Ⅽ","C","Ⅾ","D","Ⅿ","M","ⅰ","i","ⅱ","ii","ⅲ","iii","ⅳ","iv","ⅴ","v","ⅵ","vi","ⅶ","vii","ⅷ","viii","ⅸ","ix","ⅹ","x","ⅺ","xi","ⅻ","xii","ⅼ","l","ⅽ","c","ⅾ","d","ⅿ","m","∬","∫∫","∭","∫∫∫","∯","∮∮","∰","∮∮∮","⑴","(1)","⑵","(2)","⑶","(3)","⑷","(4)","⑸","(5)","⑹","(6)","⑺","(7)","⑻","(8)","⑼","(9)","⑽","(10)","⑾","(11)","⑿","(12)","⒀","(13)","⒁","(14)","⒂","(15)","⒃","(16)","⒄","(17)","⒅","(18)","⒆","(19)","⒇","(20)","⒈","1.","⒉","2.","⒊","3.","⒋","4.","⒌","5.","⒍","6.","⒎","7.","⒏","8.","⒐","9.","⒑","10.","⒒","11.","⒓","12.","⒔","13.","⒕","14.","⒖","15.","⒗","16.","⒘","17.","⒙","18.","⒚","19.","⒛","20.","⒜","(a)","⒝","(b)","⒞","(c)","⒟","(d)","⒠","(e)","⒡","(f)","⒢","(g)","⒣","(h)","⒤","(i)","⒥","(j)","⒦","(k)","⒧","(l)","⒨","(m)","⒩","(n)","⒪","(o)","⒫","(p)","⒬","(q)","⒭","(r)","⒮","(s)","⒯","(t)","⒰","(u)","⒱","(v)","⒲","(w)","⒳","(x)","⒴","(y)","⒵","(z)","⨌","∫∫∫∫","⩴","::=","⩵","==","⩶","===","⺟","母","⻳","龟","⼀","一","⼁","丨","⼂","丶","⼃","丿","⼄","乙","⼅","亅","⼆","二","⼇","亠","⼈","人","⼉","儿","⼊","入","⼋","八","⼌","冂","⼍","冖","⼎","冫","⼏","几","⼐","凵","⼑","刀","⼒","力","⼓","勹","⼔","匕","⼕","匚","⼖","匸","⼗","十","⼘","卜","⼙","卩","⼚","厂","⼛","厶","⼜","又","⼝","口","⼞","囗","⼟","土","⼠","士","⼡","夂","⼢","夊","⼣","夕","⼤","大","⼥","女","⼦","子","⼧","宀","⼨","寸","⼩","小","⼪","尢","⼫","尸","⼬","屮","⼭","山","⼮","巛","⼯","工","⼰","己","⼱","巾","⼲","干","⼳","幺","⼴","广","⼵","廴","⼶","廾","⼷","弋","⼸","弓","⼹","彐","⼺","彡","⼻","彳","⼼","心","⼽","戈","⼾","戶","⼿","手","⽀","支","⽁","攴","⽂","文","⽃","斗","⽄","斤","⽅","方","⽆","无","⽇","日","⽈","曰","⽉","月","⽊","木","⽋","欠","⽌","止","⽍","歹","⽎","殳","⽏","毋","⽐","比","⽑","毛","⽒","氏","⽓","气","⽔","水","⽕","火","⽖","爪","⽗","父","⽘","爻","⽙","爿","⽚","片","⽛","牙","⽜","牛","⽝","犬","⽞","玄","⽟","玉","⽠","瓜","⽡","瓦","⽢","甘","⽣","生","⽤","用","⽥","田","⽦","疋","⽧","疒","⽨","癶","⽩","白","⽪","皮","⽫","皿","⽬","目","⽭","矛","⽮","矢","⽯","石","⽰","示","⽱","禸","⽲","禾","⽳","穴","⽴","立","⽵","竹","⽶","米","⽷","糸","⽸","缶","⽹","网","⽺","羊","⽻","羽","⽼","老","⽽","而","⽾","耒","⽿","耳","⾀","聿","⾁","肉","⾂","臣","⾃","自","⾄","至","⾅","臼","⾆","舌","⾇","舛","⾈","舟","⾉","艮","⾊","色","⾋","艸","⾌","虍","⾍","虫","⾎","血","⾏","行","⾐","衣","⾑","襾","⾒","見","⾓","角","⾔","言","⾕","谷","⾖","豆","⾗","豕","⾘","豸","⾙","貝","⾚","赤","⾛","走","⾜","足","⾝","身","⾞","車","⾟","辛","⾠","辰","⾡","辵","⾢","邑","⾣","酉","⾤","釆","⾥","里","⾦","金","⾧","長","⾨","門","⾩","阜","⾪","隶","⾫","隹","⾬","雨","⾭","靑","⾮","非","⾯","面","⾰","革","⾱","韋","⾲","韭","⾳","音","⾴","頁","⾵","風","⾶","飛","⾷","食","⾸","首","⾹","香","⾺","馬","⾻","骨","⾼","高","⾽","髟","⾾","鬥","⾿","鬯","⿀","鬲","⿁","鬼","⿂","魚","⿃","鳥","⿄","鹵","⿅","鹿","⿆","麥","⿇","麻","⿈","黃","⿉","黍","⿊","黑","⿋","黹","⿌","黽","⿍","鼎","⿎","鼓","⿏","鼠","⿐","鼻","⿑","齊","⿒","齒","⿓","龍","⿔","龜","⿕","龠","〶","〒","〸","十","〹","卄","〺","卅","゛"," ゙","゜"," ゚","ㄱ","ᄀ","ㄲ","ᄁ","ㄳ","ᆪ","ㄴ","ᄂ","ㄵ","ᆬ","ㄶ","ᆭ","ㄷ","ᄃ","ㄸ","ᄄ","ㄹ","ᄅ","ㄺ","ᆰ","ㄻ","ᆱ","ㄼ","ᆲ","ㄽ","ᆳ","ㄾ","ᆴ","ㄿ","ᆵ","ㅀ","ᄚ","ㅁ","ᄆ","ㅂ","ᄇ","ㅃ","ᄈ","ㅄ","ᄡ","ㅅ","ᄉ","ㅆ","ᄊ","ㅇ","ᄋ","ㅈ","ᄌ","ㅉ","ᄍ","ㅊ","ᄎ","ㅋ","ᄏ","ㅌ","ᄐ","ㅍ","ᄑ","ㅎ","ᄒ","ㅏ","ᅡ","ㅐ","ᅢ","ㅑ","ᅣ","ㅒ","ᅤ","ㅓ","ᅥ","ㅔ","ᅦ","ㅕ","ᅧ","ㅖ","ᅨ","ㅗ","ᅩ","ㅘ","ᅪ","ㅙ","ᅫ","ㅚ","ᅬ","ㅛ","ᅭ","ㅜ","ᅮ","ㅝ","ᅯ","ㅞ","ᅰ","ㅟ","ᅱ","ㅠ","ᅲ","ㅡ","ᅳ","ㅢ","ᅴ","ㅣ","ᅵ","ㅤ","ᅠ","ㅥ","ᄔ","ㅦ","ᄕ","ㅧ","ᇇ","ㅨ","ᇈ","ㅩ","ᇌ","ㅪ","ᇎ","ㅫ","ᇓ","ㅬ","ᇗ","ㅭ","ᇙ","ㅮ","ᄜ","ㅯ","ᇝ","ㅰ","ᇟ","ㅱ","ᄝ","ㅲ","ᄞ","ㅳ","ᄠ","ㅴ","ᄢ","ㅵ","ᄣ","ㅶ","ᄧ","ㅷ","ᄩ","ㅸ","ᄫ","ㅹ","ᄬ","ㅺ","ᄭ","ㅻ","ᄮ","ㅼ","ᄯ","ㅽ","ᄲ","ㅾ","ᄶ","ㅿ","ᅀ","ㆀ","ᅇ","ㆁ","ᅌ","ㆂ","ᇱ","ㆃ","ᇲ","ㆄ","ᅗ","ㆅ","ᅘ","ㆆ","ᅙ","ㆇ","ᆄ","ㆈ","ᆅ","ㆉ","ᆈ","ㆊ","ᆑ","ㆋ","ᆒ","ㆌ","ᆔ","ㆍ","ᆞ","ㆎ","ᆡ","㈀","(ᄀ)","㈁","(ᄂ)","㈂","(ᄃ)","㈃","(ᄅ)","㈄","(ᄆ)","㈅","(ᄇ)","㈆","(ᄉ)","㈇","(ᄋ)","㈈","(ᄌ)","㈉","(ᄎ)","㈊","(ᄏ)","㈋","(ᄐ)","㈌","(ᄑ)","㈍","(ᄒ)","㈎","(가)","㈏","(나)","㈐","(다)","㈑","(라)","㈒","(마)","㈓","(바)","㈔","(사)","㈕","(아)","㈖","(자)","㈗","(차)","㈘","(카)","㈙","(타)","㈚","(파)","㈛","(하)","㈜","(주)","㈝","(오전)","㈞","(오후)","㈠","(一)","㈡","(二)","㈢","(三)","㈣","(四)","㈤","(五)","㈥","(六)","㈦","(七)","㈧","(八)","㈨","(九)","㈩","(十)","㈪","(月)","㈫","(火)","㈬","(水)","㈭","(木)","㈮","(金)","㈯","(土)","㈰","(日)","㈱","(株)","㈲","(有)","㈳","(社)","㈴","(名)","㈵","(特)","㈶","(財)","㈷","(祝)","㈸","(労)","㈹","(代)","㈺","(呼)","㈻","(学)","㈼","(監)","㈽","(企)","㈾","(資)","㈿","(協)","㉀","(祭)","㉁","(休)","㉂","(自)","㉃","(至)","㋀","1月","㋁","2月","㋂","3月","㋃","4月","㋄","5月","㋅","6月","㋆","7月","㋇","8月","㋈","9月","㋉","10月","㋊","11月","㋋","12月","㍘","0点","㍙","1点","㍚","2点","㍛","3点","㍜","4点","㍝","5点","㍞","6点","㍟","7点","㍠","8点","㍡","9点","㍢","10点","㍣","11点","㍤","12点","㍥","13点","㍦","14点","㍧","15点","㍨","16点","㍩","17点","㍪","18点","㍫","19点","㍬","20点","㍭","21点","㍮","22点","㍯","23点","㍰","24点","㏠","1日","㏡","2日","㏢","3日","㏣","4日","㏤","5日","㏥","6日","㏦","7日","㏧","8日","㏨","9日","㏩","10日","㏪","11日","㏫","12日","㏬","13日","㏭","14日","㏮","15日","㏯","16日","㏰","17日","㏱","18日","㏲","19日","㏳","20日","㏴","21日","㏵","22日","㏶","23日","㏷","24日","㏸","25日","㏹","26日","㏺","27日","㏻","28日","㏼","29日","㏽","30日","㏾","31日","ﬀ","ff","ﬁ","fi","ﬂ","fl","ﬃ","ffi","ﬄ","ffl","ﬅ","ſt","ﬆ","st","ﬓ","մն","ﬔ","մե","ﬕ","մի","ﬖ","վն","ﬗ","մխ","ﭏ","אל","ﭐ","ٱ","ﭑ","ٱ","ﭒ","ٻ","ﭓ","ٻ","ﭔ","ٻ","ﭕ","ٻ","ﭖ","پ","ﭗ","پ","ﭘ","پ","ﭙ","پ","ﭚ","ڀ","ﭛ","ڀ","ﭜ","ڀ","ﭝ","ڀ","ﭞ","ٺ","ﭟ","ٺ","ﭠ","ٺ","ﭡ","ٺ","ﭢ","ٿ","ﭣ","ٿ","ﭤ","ٿ","ﭥ","ٿ","ﭦ","ٹ","ﭧ","ٹ","ﭨ","ٹ","ﭩ","ٹ","ﭪ","ڤ","ﭫ","ڤ","ﭬ","ڤ","ﭭ","ڤ","ﭮ","ڦ","ﭯ","ڦ","ﭰ","ڦ","ﭱ","ڦ","ﭲ","ڄ","ﭳ","ڄ","ﭴ","ڄ","ﭵ","ڄ","ﭶ","ڃ","ﭷ","ڃ","ﭸ","ڃ","ﭹ","ڃ","ﭺ","چ","ﭻ","چ","ﭼ","چ","ﭽ","چ","ﭾ","ڇ","ﭿ","ڇ","ﮀ","ڇ","ﮁ","ڇ","ﮂ","ڍ","ﮃ","ڍ","ﮄ","ڌ","ﮅ","ڌ","ﮆ","ڎ","ﮇ","ڎ","ﮈ","ڈ","ﮉ","ڈ","ﮊ","ژ","ﮋ","ژ","ﮌ","ڑ","ﮍ","ڑ","ﮎ","ک","ﮏ","ک","ﮐ","ک","ﮑ","ک","ﮒ","گ","ﮓ","گ","ﮔ","گ","ﮕ","گ","ﮖ","ڳ","ﮗ","ڳ","ﮘ","ڳ","ﮙ","ڳ","ﮚ","ڱ","ﮛ","ڱ","ﮜ","ڱ","ﮝ","ڱ","ﮞ","ں","ﮟ","ں","ﮠ","ڻ","ﮡ","ڻ","ﮢ","ڻ","ﮣ","ڻ","ﮤ","ۀ","ﮥ","ۀ","ﮦ","ہ","ﮧ","ہ","ﮨ","ہ","ﮩ","ہ","ﮪ","ھ","ﮫ","ھ","ﮬ","ھ","ﮭ","ھ","ﮮ","ے","ﮯ","ے","ﮰ","ۓ","ﮱ","ۓ","ﯓ","ڭ","ﯔ","ڭ","ﯕ","ڭ","ﯖ","ڭ","ﯗ","ۇ","ﯘ","ۇ","ﯙ","ۆ","ﯚ","ۆ","ﯛ","ۈ","ﯜ","ۈ","ﯝ","ٷ","ﯞ","ۋ","ﯟ","ۋ","ﯠ","ۅ","ﯡ","ۅ","ﯢ","ۉ","ﯣ","ۉ","ﯤ","ې","ﯥ","ې","ﯦ","ې","ﯧ","ې","ﯨ","ى","ﯩ","ى","ﯪ","ئا","ﯫ","ئا","ﯬ","ئە","ﯭ","ئە","ﯮ","ئو","ﯯ","ئو","ﯰ","ئۇ","ﯱ","ئۇ","ﯲ","ئۆ","ﯳ","ئۆ","ﯴ","ئۈ","ﯵ","ئۈ","ﯶ","ئې","ﯷ","ئې","ﯸ","ئې","ﯹ","ئى","ﯺ","ئى","ﯻ","ئى","ﯼ","ی","ﯽ","ی","ﯾ","ی","ﯿ","ی","ﰀ","ئج","ﰁ","ئح","ﰂ","ئم","ﰃ","ئى","ﰄ","ئي","ﰅ","بج","ﰆ","بح","ﰇ","بخ","ﰈ","بم","ﰉ","بى","ﰊ","بي","ﰋ","تج","ﰌ","تح","ﰍ","تخ","ﰎ","تم","ﰏ","تى","ﰐ","تي","ﰑ","ثج","ﰒ","ثم","ﰓ","ثى","ﰔ","ثي","ﰕ","جح","ﰖ","جم","ﰗ","حج","ﰘ","حم","ﰙ","خج","ﰚ","خح","ﰛ","خم","ﰜ","سج","ﰝ","سح","ﰞ","سخ","ﰟ","سم","ﰠ","صح","ﰡ","صم","ﰢ","ضج","ﰣ","ضح","ﰤ","ضخ","ﰥ","ضم","ﰦ","طح","ﰧ","طم","ﰨ","ظم","ﰩ","عج","ﰪ","عم","ﰫ","غج","ﰬ","غم","ﰭ","فج","ﰮ","فح","ﰯ","فخ","ﰰ","فم","ﰱ","فى","ﰲ","في","ﰳ","قح","ﰴ","قم","ﰵ","قى","ﰶ","قي","ﰷ","كا","ﰸ","كج","ﰹ","كح","ﰺ","كخ","ﰻ","كل","ﰼ","كم","ﰽ","كى","ﰾ","كي","ﰿ","لج","ﱀ","لح","ﱁ","لخ","ﱂ","لم","ﱃ","لى","ﱄ","لي","ﱅ","مج","ﱆ","مح","ﱇ","مخ","ﱈ","مم","ﱉ","مى","ﱊ","مي","ﱋ","نج","ﱌ","نح","ﱍ","نخ","ﱎ","نم","ﱏ","نى","ﱐ","ني","ﱑ","هج","ﱒ","هم","ﱓ","هى","ﱔ","هي","ﱕ","يج","ﱖ","يح","ﱗ","يخ","ﱘ","يم","ﱙ","يى","ﱚ","يي","ﱛ","ذٰ","ﱜ","رٰ","ﱝ","ىٰ","ﱞ"," ٌّ","ﱟ"," ٍّ","ﱠ"," َّ","ﱡ"," ُّ","ﱢ"," ِّ","ﱣ"," ّٰ","ﱤ","ئر","ﱥ","ئز","ﱦ","ئم","ﱧ","ئن","ﱨ","ئى","ﱩ","ئي","ﱪ","بر","ﱫ","بز","ﱬ","بم","ﱭ","بن","ﱮ","بى","ﱯ","بي","ﱰ","تر","ﱱ","تز","ﱲ","تم","ﱳ","تن","ﱴ","تى","ﱵ","تي","ﱶ","ثر","ﱷ","ثز","ﱸ","ثم","ﱹ","ثن","ﱺ","ثى","ﱻ","ثي","ﱼ","فى","ﱽ","في","ﱾ","قى","ﱿ","قي","ﲀ","كا","ﲁ","كل","ﲂ","كم","ﲃ","كى","ﲄ","كي","ﲅ","لم","ﲆ","لى","ﲇ","لي","ﲈ","ما","ﲉ","مم","ﲊ","نر","ﲋ","نز","ﲌ","نم","ﲍ","نن","ﲎ","نى","ﲏ","ني","ﲐ","ىٰ","ﲑ","ير","ﲒ","يز","ﲓ","يم","ﲔ","ين","ﲕ","يى","ﲖ","يي","ﲗ","ئج","ﲘ","ئح","ﲙ","ئخ","ﲚ","ئم","ﲛ","ئه","ﲜ","بج","ﲝ","بح","ﲞ","بخ","ﲟ","بم","ﲠ","به","ﲡ","تج","ﲢ","تح","ﲣ","تخ","ﲤ","تم","ﲥ","ته","ﲦ","ثم","ﲧ","جح","ﲨ","جم","ﲩ","حج","ﲪ","حم","ﲫ","خج","ﲬ","خم","ﲭ","سج","ﲮ","سح","ﲯ","سخ","ﲰ","سم","ﲱ","صح","ﲲ","صخ","ﲳ","صم","ﲴ","ضج","ﲵ","ضح","ﲶ","ضخ","ﲷ","ضم","ﲸ","طح","ﲹ","ظم","ﲺ","عج","ﲻ","عم","ﲼ","غج","ﲽ","غم","ﲾ","فج","ﲿ","فح","ﳀ","فخ","ﳁ","فم","ﳂ","قح","ﳃ","قم","ﳄ","كج","ﳅ","كح","ﳆ","كخ","ﳇ","كل","ﳈ","كم","ﳉ","لج","ﳊ","لح","ﳋ","لخ","ﳌ","لم","ﳍ","له","ﳎ","مج","ﳏ","مح","ﳐ","مخ","ﳑ","مم","ﳒ","نج","ﳓ","نح","ﳔ","نخ","ﳕ","نم","ﳖ","نه","ﳗ","هج","ﳘ","هم","ﳙ","هٰ","ﳚ","يج","ﳛ","يح","ﳜ","يخ","ﳝ","يم","ﳞ","يه","ﳟ","ئم","ﳠ","ئه","ﳡ","بم","ﳢ","به","ﳣ","تم","ﳤ","ته","ﳥ","ثم","ﳦ","ثه","ﳧ","سم","ﳨ","سه","ﳩ","شم","ﳪ","شه","ﳫ","كل","ﳬ","كم","ﳭ","لم","ﳮ","نم","ﳯ","نه","ﳰ","يم","ﳱ","يه","ﳲ","ـَّ","ﳳ","ـُّ","ﳴ","ـِّ","ﳵ","طى","ﳶ","طي","ﳷ","عى","ﳸ","عي","ﳹ","غى","ﳺ","غي","ﳻ","سى","ﳼ","سي","ﳽ","شى","ﳾ","شي","ﳿ","حى","ﴀ","حي","ﴁ","جى","ﴂ","جي","ﴃ","خى","ﴄ","خي","ﴅ","صى","ﴆ","صي","ﴇ","ضى","ﴈ","ضي","ﴉ","شج","ﴊ","شح","ﴋ","شخ","ﴌ","شم","ﴍ","شر","ﴎ","سر","ﴏ","صر","ﴐ","ضر","ﴑ","طى","ﴒ","طي","ﴓ","عى","ﴔ","عي","ﴕ","غى","ﴖ","غي","ﴗ","سى","ﴘ","سي","ﴙ","شى","ﴚ","شي","ﴛ","حى","ﴜ","حي","ﴝ","جى","ﴞ","جي","ﴟ","خى","ﴠ","خي","ﴡ","صى","ﴢ","صي","ﴣ","ضى","ﴤ","ضي","ﴥ","شج","ﴦ","شح","ﴧ","شخ","ﴨ","شم","ﴩ","شر","ﴪ","سر","ﴫ","صر","ﴬ","ضر","ﴭ","شج","ﴮ","شح","ﴯ","شخ","ﴰ","شم","ﴱ","سه","ﴲ","شه","ﴳ","طم","ﴴ","سج","ﴵ","سح","ﴶ","سخ","ﴷ","شج","ﴸ","شح","ﴹ","شخ","ﴺ","طم","ﴻ","ظم","ﴼ","اً","ﴽ","اً","ﵐ","تجم","ﵑ","تحج","ﵒ","تحج","ﵓ","تحم","ﵔ","تخم","ﵕ","تمج","ﵖ","تمح","ﵗ","تمخ","ﵘ","جمح","ﵙ","جمح","ﵚ","حمي","ﵛ","حمى","ﵜ","سحج","ﵝ","سجح","ﵞ","سجى","ﵟ","سمح","ﵠ","سمح","ﵡ","سمج","ﵢ","سمم","ﵣ","سمم","ﵤ","صحح","ﵥ","صحح","ﵦ","صمم","ﵧ","شحم","ﵨ","شحم","ﵩ","شجي","ﵪ","شمخ","ﵫ","شمخ","ﵬ","شمم","ﵭ","شمم","ﵮ","ضحى","ﵯ","ضخم","ﵰ","ضخم","ﵱ","طمح","ﵲ","طمح","ﵳ","طمم","ﵴ","طمي","ﵵ","عجم","ﵶ","عمم","ﵷ","عمم","ﵸ","عمى","ﵹ","غمم","ﵺ","غمي","ﵻ","غمى","ﵼ","فخم","ﵽ","فخم","ﵾ","قمح","ﵿ","قمم","ﶀ","لحم","ﶁ","لحي","ﶂ","لحى","ﶃ","لجج","ﶄ","لجج","ﶅ","لخم","ﶆ","لخم","ﶇ","لمح","ﶈ","لمح","ﶉ","محج","ﶊ","محم","ﶋ","محي","ﶌ","مجح","ﶍ","مجم","ﶎ","مخج","ﶏ","مخم","ﶒ","مجخ","ﶓ","همج","ﶔ","همم","ﶕ","نحم","ﶖ","نحى","ﶗ","نجم","ﶘ","نجم","ﶙ","نجى","ﶚ","نمي","ﶛ","نمى","ﶜ","يمم","ﶝ","يمم","ﶞ","بخي","ﶟ","تجي","ﶠ","تجى","ﶡ","تخي","ﶢ","تخى","ﶣ","تمي","ﶤ","تمى","ﶥ","جمي","ﶦ","جحى","ﶧ","جمى","ﶨ","سخى","ﶩ","صحي","ﶪ","شحي","ﶫ","ضحي","ﶬ","لجي","ﶭ","لمي","ﶮ","يحي","ﶯ","يجي","ﶰ","يمي","ﶱ","ممي","ﶲ","قمي","ﶳ","نحي","ﶴ","قمح","ﶵ","لحم","ﶶ","عمي","ﶷ","كمي","ﶸ","نجح","ﶹ","مخي","ﶺ","لجم","ﶻ","كمم","ﶼ","لجم","ﶽ","نجح","ﶾ","جحي","ﶿ","حجي","ﷀ","مجي","ﷁ","فمي","ﷂ","بحي","ﷃ","كمم","ﷄ","عجم","ﷅ","صمم","ﷆ","سخي","ﷇ","نجي","﹉","‾","﹊","‾","﹋","‾","﹌","‾","﹍","_","﹎","_","﹏","_","ﺀ","ء","ﺁ","آ","ﺂ","آ","ﺃ","أ","ﺄ","أ","ﺅ","ؤ","ﺆ","ؤ","ﺇ","إ","ﺈ","إ","ﺉ","ئ","ﺊ","ئ","ﺋ","ئ","ﺌ","ئ","ﺍ","ا","ﺎ","ا","ﺏ","ب","ﺐ","ب","ﺑ","ب","ﺒ","ب","ﺓ","ة","ﺔ","ة","ﺕ","ت","ﺖ","ت","ﺗ","ت","ﺘ","ت","ﺙ","ث","ﺚ","ث","ﺛ","ث","ﺜ","ث","ﺝ","ج","ﺞ","ج","ﺟ","ج","ﺠ","ج","ﺡ","ح","ﺢ","ح","ﺣ","ح","ﺤ","ح","ﺥ","خ","ﺦ","خ","ﺧ","خ","ﺨ","خ","ﺩ","د","ﺪ","د","ﺫ","ذ","ﺬ","ذ","ﺭ","ر","ﺮ","ر","ﺯ","ز","ﺰ","ز","ﺱ","س","ﺲ","س","ﺳ","س","ﺴ","س","ﺵ","ش","ﺶ","ش","ﺷ","ش","ﺸ","ش","ﺹ","ص","ﺺ","ص","ﺻ","ص","ﺼ","ص","ﺽ","ض","ﺾ","ض","ﺿ","ض","ﻀ","ض","ﻁ","ط","ﻂ","ط","ﻃ","ط","ﻄ","ط","ﻅ","ظ","ﻆ","ظ","ﻇ","ظ","ﻈ","ظ","ﻉ","ع","ﻊ","ع","ﻋ","ع","ﻌ","ع","ﻍ","غ","ﻎ","غ","ﻏ","غ","ﻐ","غ","ﻑ","ف","ﻒ","ف","ﻓ","ف","ﻔ","ف","ﻕ","ق","ﻖ","ق","ﻗ","ق","ﻘ","ق","ﻙ","ك","ﻚ","ك","ﻛ","ك","ﻜ","ك","ﻝ","ل","ﻞ","ل","ﻟ","ل","ﻠ","ل","ﻡ","م","ﻢ","م","ﻣ","م","ﻤ","م","ﻥ","ن","ﻦ","ن","ﻧ","ن","ﻨ","ن","ﻩ","ه","ﻪ","ه","ﻫ","ه","ﻬ","ه","ﻭ","و","ﻮ","و","ﻯ","ى","ﻰ","ى","ﻱ","ي","ﻲ","ي","ﻳ","ي","ﻴ","ي","ﻵ","لآ","ﻶ","لآ","ﻷ","لأ","ﻸ","لأ","ﻹ","لإ","ﻺ","لإ","ﻻ","لا","ﻼ","لا"]}));function reverseIfRtl(e){const t=e.length;if(t<=1||!function isRTLRangeFor(e){let t=i[13];if(e>=t.begin&&e<t.end)return!0;t=i[11];return e>=t.begin&&e<t.end}(e.charCodeAt(0)))return e;const r=[];for(let n=t-1;n>=0;n--)r.push(e[n]);return r.join("")}const o=new RegExp("^(\\s)|(\\p{Mn})|(\\p{Cf})$","u"),c=new Map;function getCharUnicodeCategory(e){const t=c.get(e);if(t)return t;const r=e.match(o),n={isWhitespace:!(!r||!r[1]),isZeroWidthDiacritic:!(!r||!r[2]),isInvisibleFormatMark:!(!r||!r[3])};c.set(e,n);return n}function clearUnicodeCaches(){c.clear()}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.MarkupAnnotation=t.AnnotationFactory=t.AnnotationBorderStyle=t.Annotation=void 0;t.getQuadPoints=getQuadPoints;r(2);r(112);r(232);r(146);r(148);r(149);r(155);r(227);r(159);r(212);var n=r(158),a=r(213),i=r(233),s=r(209),o=r(282),c=r(217),l=r(277),h=r(286),u=r(234),d=r(289),f=r(292),g=r(279),p=r(218),m=r(293);t.AnnotationFactory=class AnnotationFactory{static create(e,t,r,n,a){return Promise.all([r.ensureCatalog("acroForm"),r.ensureCatalog("baseUrl"),r.ensureDoc("xfaDatasets"),a?this._getPageIndex(e,t,r):-1]).then((i=>{let[s,o,c,l]=i;return r.ensure(this,"_create",[e,t,r,n,s,c,a,l])}))}static _create(e,t,r,i,o,c,l){let h=arguments.length>7&&void 0!==arguments[7]?arguments[7]:-1;const u=e.fetchIfRef(t);if(!(u instanceof s.Dict))return;const d=t instanceof s.Ref?t.toString():"annot_".concat(i.createObjId());let f=u.get("Subtype");f=f instanceof s.Name?f.name:null;const g={xref:e,ref:t,dict:u,subtype:f,id:d,pdfManager:r,acroForm:o instanceof s.Dict?o:s.Dict.empty,xfaDatasets:c,collectFields:l,pageIndex:h};switch(f){case"Link":return new LinkAnnotation(g);case"Text":return new TextAnnotation(g);case"Widget":let e=(0,a.getInheritableProperty)({dict:u,key:"FT"});e=e instanceof s.Name?e.name:null;switch(e){case"Tx":return new TextWidgetAnnotation(g);case"Btn":return new ButtonWidgetAnnotation(g);case"Ch":return new ChoiceWidgetAnnotation(g);case"Sig":if(self.showUnverifiedSignatures){(0,n.info)("The PDF file contains a signature. Please take into account that it can't be verified yet. ngx-extended-pdf-viewer also displays forged signatures, so use this feature only if you're sure what you're doing.");return new SignatureWidgetAnnotation(g)}}(0,n.warn)('Unimplemented widget field type "'.concat(e,'", ')+"falling back to base field type.");return new WidgetAnnotation(g);case"Popup":return new PopupAnnotation(g);case"FreeText":return new FreeTextAnnotation(g);case"Line":return new LineAnnotation(g);case"Square":return new SquareAnnotation(g);case"Circle":return new CircleAnnotation(g);case"PolyLine":return new PolylineAnnotation(g);case"Polygon":return new PolygonAnnotation(g);case"Caret":return new CaretAnnotation(g);case"Ink":return new InkAnnotation(g);case"Highlight":return new HighlightAnnotation(g);case"Underline":return new UnderlineAnnotation(g);case"Squiggly":return new SquigglyAnnotation(g);case"StrikeOut":return new StrikeOutAnnotation(g);case"Stamp":return new StampAnnotation(g);case"FileAttachment":return new FileAttachmentAnnotation(g);default:l||(f?(0,n.warn)('Unimplemented annotation type "'.concat(f,'", ')+"falling back to base annotation."):(0,n.warn)("Annotation is missing the required /Subtype."));return new Annotation(g)}}static async _getPageIndex(e,t,r){try{const n=await e.fetchIfRefAsync(t);if(!(n instanceof s.Dict))return-1;const a=n.getRaw("P");if(!(a instanceof s.Ref))return-1;return await r.ensureCatalog("getPageIndex",[a])}catch(e){(0,n.warn)('_getPageIndex: "'.concat(e,'".'));return-1}}static async saveNewAnnotations(e,t,r){const a=e.xref;let i;const c=[],l=[],h=[];for(const u of r)switch(u.annotationType){case n.AnnotationEditorType.FREETEXT:if(!i){const e=new s.Dict(a);e.set("BaseFont",s.Name.get("Helvetica"));e.set("Type",s.Name.get("Font"));e.set("Subtype",s.Name.get("Type1"));e.set("Encoding",s.Name.get("WinAnsiEncoding"));const t=[];i=a.getNewRef();(0,o.writeObject)(i,e,t,null);l.push({ref:i,data:t.join("")})}h.push(FreeTextAnnotation.createNewAnnotation(a,e,t,u,i,c,l));break;case n.AnnotationEditorType.INK:h.push(InkAnnotation.createNewAnnotation(a,e,t,u,c,l))}await Promise.all(h);return{annotations:c,dependencies:l}}};function getRgbColor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:new Uint8ClampedArray(3);if(!Array.isArray(e))return t;const r=t||new Uint8ClampedArray(3);switch(e.length){case 0:return null;case 1:u.ColorSpace.singletons.gray.getRgbItem(e,0,r,0);return r;case 3:u.ColorSpace.singletons.rgb.getRgbItem(e,0,r,0);return r;case 4:u.ColorSpace.singletons.cmyk.getRgbItem(e,0,r,0);return r;default:return t}}function getQuadPoints(e,t){if(!e.has("QuadPoints"))return null;const r=e.getArray("QuadPoints");if(!Array.isArray(r)||0===r.length||r.length%8>0)return null;const n=[];for(let e=0,a=r.length/8;e<a;e++){n.push([]);for(let a=8*e,i=8*e+8;a<i;a+=2){const i=r[a],s=r[a+1];if(null!==t&&(i<t[0]||i>t[2]||s<t[1]||s>t[3]))return null;n[e].push({x:i,y:s})}}return n.map((e=>{const[t,r,n,a]=e.reduce(((e,t)=>{let[r,n,a,i]=e;return[Math.min(r,t.x),Math.max(n,t.x),Math.min(a,t.y),Math.max(i,t.y)]}),[Number.MAX_VALUE,Number.MIN_VALUE,Number.MAX_VALUE,Number.MIN_VALUE]);return[{x:t,y:a},{x:r,y:a},{x:t,y:n},{x:r,y:n}]}))}function getTransformMatrix(e,t,r){const[a,i,s,o]=n.Util.getAxialAlignedBoundingBox(t,r);if(a===s||i===o)return[1,0,0,1,e[0],e[1]];const c=(e[2]-e[0])/(s-a),l=(e[3]-e[1])/(o-i);return[c,0,0,l,e[0]-a*c,e[1]-i*l]}class Annotation{constructor(e){const t=e.dict;this.setTitle(t.get("T"));this.setContents(t.get("Contents"));this.setModificationDate(t.get("M"));this.setFlags(t.get("F"));this.setRectangle(t.getArray("Rect"));this.setColor(t.getArray("C"));this.setBorderStyle(t);this.setAppearance(t);this.setBorderAndBackgroundColors(t.get("MK"));this._streams=[];this.appearance&&this._streams.push(this.appearance);this.data={annotationFlags:this.flags,borderStyle:this.borderStyle,color:this.color,backgroundColor:this.backgroundColor,borderColor:this.borderColor,contentsObj:this._contents,hasAppearance:!!this.appearance,id:e.id,modificationDate:this.modificationDate,rect:this.rectangle,subtype:e.subtype,hasOwnCanvas:!1};if(e.collectFields){const r=t.get("Kids");if(Array.isArray(r)){const e=[];for(const t of r)t instanceof s.Ref&&e.push(t.toString());0!==e.length&&(this.data.kidIds=e)}this.data.actions=(0,a.collectActions)(e.xref,t,n.AnnotationActionEventType);this.data.fieldName=this._constructFieldName(t);this.data.pageIndex=e.pageIndex}this._fallbackFontDict=null}_hasFlag(e,t){return!!(e&t)}_isViewable(e){return!this._hasFlag(e,n.AnnotationFlag.INVISIBLE)&&!this._hasFlag(e,n.AnnotationFlag.NOVIEW)}_isPrintable(e){return this._hasFlag(e,n.AnnotationFlag.PRINT)&&!this._hasFlag(e,n.AnnotationFlag.INVISIBLE)}mustBeViewed(e){const t=e&&e.get(this.data.id);return t&&void 0!==t.hidden?!t.hidden:this.viewable&&!this._hasFlag(this.flags,n.AnnotationFlag.HIDDEN)}mustBePrinted(e){const t=e&&e.get(this.data.id);return t&&void 0!==t.print?t.print:this.printable}get viewable(){return null!==this.data.quadPoints&&(0===this.flags||this._isViewable(this.flags))}get printable(){return null!==this.data.quadPoints&&(0!==this.flags&&this._isPrintable(this.flags))}_parseStringHelper(e){const t="string"==typeof e?(0,n.stringToPDFString)(e):"";return{str:t,dir:t&&"rtl"===(0,l.bidi)(t).dir?"rtl":"ltr"}}setTitle(e){this._title=this._parseStringHelper(e)}setContents(e){this._contents=this._parseStringHelper(e)}setModificationDate(e){this.modificationDate="string"==typeof e?e:null}setFlags(e){this.flags=Number.isInteger(e)&&e>0?e:0}hasFlag(e){return this._hasFlag(this.flags,e)}setRectangle(e){Array.isArray(e)&&4===e.length?this.rectangle=n.Util.normalizeRect(e):this.rectangle=[0,0,0,0]}setColor(e){this.color=getRgbColor(e)}setLineEndings(e){this.lineEndings=["None","None"];if(Array.isArray(e)&&2===e.length)for(let t=0;t<2;t++){const r=e[t];if(r instanceof s.Name)switch(r.name){case"None":continue;case"Square":case"Circle":case"Diamond":case"OpenArrow":case"ClosedArrow":case"Butt":case"ROpenArrow":case"RClosedArrow":case"Slash":this.lineEndings[t]=r.name;continue}(0,n.warn)("Ignoring invalid lineEnding: ".concat(r))}}setBorderAndBackgroundColors(e){if(e instanceof s.Dict){this.borderColor=getRgbColor(e.getArray("BC"),null);this.backgroundColor=getRgbColor(e.getArray("BG"),null)}else this.borderColor=this.backgroundColor=null}getBorderAndBackgroundAppearances(){if(!this.backgroundColor&&!this.borderColor)return"";const e=this.data.rect[2]-this.data.rect[0],t=this.data.rect[3]-this.data.rect[1],r="0 0 ".concat(e," ").concat(t," re");let n="";this.backgroundColor&&(n="".concat((0,i.getPdfColor)(this.backgroundColor,!0)," ").concat(r," f "));if(this.borderColor){const e=this.borderStyle.width||1;n+="".concat(e," w ").concat((0,i.getPdfColor)(this.borderColor,!1)," ").concat(r," S ")}return n}setBorderStyle(e){this.borderStyle=new AnnotationBorderStyle;if(e instanceof s.Dict)if(e.has("BS")){const t=e.get("BS"),r=t.get("Type");if(!r||(0,s.isName)(r,"Border")){this.borderStyle.setWidth(t.get("W"),this.rectangle);this.borderStyle.setStyle(t.get("S"));this.borderStyle.setDashArray(t.getArray("D"))}}else if(e.has("Border")){const t=e.getArray("Border");if(Array.isArray(t)&&t.length>=3){this.borderStyle.setHorizontalCornerRadius(t[0]);this.borderStyle.setVerticalCornerRadius(t[1]);this.borderStyle.setWidth(t[2],this.rectangle);4===t.length&&this.borderStyle.setDashArray(t[3],!0)}}else this.borderStyle.setWidth(0)}setAppearance(e){this.appearance=null;const t=e.get("AP");if(!(t instanceof s.Dict))return;const r=t.get("N");if(r instanceof c.BaseStream){this.appearance=r;return}if(!(r instanceof s.Dict))return;const n=e.get("AS");n instanceof s.Name&&r.has(n.name)&&(this.appearance=r.get(n.name))}loadResources(e,t){return t.dict.getAsync("Resources").then((t=>{if(!t)return;return new f.ObjectLoader(t,e,t.xref).load().then((function(){return t}))}))}getOperatorList(e,t,r,a,i){const o=this.data;let c=this.appearance;const l=o.hasOwnCanvas&&r&n.RenderingIntentFlag.DISPLAY;if(!c){if(!l)return Promise.resolve(new g.OperatorList);c=new p.StringStream("");c.dict=new s.Dict}const h=c.dict,u=this.loadResources(["ExtGState","ColorSpace","Pattern","Shading","XObject","Font"],c),d=h.getArray("BBox")||[0,0,1,1],f=h.getArray("Matrix")||[1,0,0,1,0,0],m=getTransformMatrix(o.rect,d,f);return u.then((r=>{const a=new g.OperatorList;a.addOp(n.OPS.beginAnnotation,[o.id,o.rect,m,f,l]);return e.getOperatorList({stream:c,task:t,resources:r,operatorList:a,fallbackFontDict:this._fallbackFontDict}).then((()=>{a.addOp(n.OPS.endAnnotation,[]);this.reset();return a}))}))}async save(e,t,r){return null}getFieldObject(){return this.data.kidIds?{id:this.data.id,actions:this.data.actions,name:this.data.fieldName,strokeColor:this.data.borderColor,fillColor:this.data.backgroundColor,type:"",kidIds:this.data.kidIds,page:this.data.pageIndex}:null}reset(){for(const e of this._streams)e.reset()}_constructFieldName(e){if(!e.has("T")&&!e.has("Parent")){(0,n.warn)("Unknown field name, falling back to empty field name.");return""}if(!e.has("Parent"))return(0,n.stringToPDFString)(e.get("T"));const t=[];e.has("T")&&t.unshift((0,n.stringToPDFString)(e.get("T")));let r=e;const a=new s.RefSet;e.objId&&a.put(e.objId);for(;r.has("Parent");){r=r.get("Parent");if(!(r instanceof s.Dict)||r.objId&&a.has(r.objId))break;r.objId&&a.put(r.objId);r.has("T")&&t.unshift((0,n.stringToPDFString)(r.get("T")))}return t.join(".")}}t.Annotation=Annotation;class AnnotationBorderStyle{constructor(){this.width=1;this.style=n.AnnotationBorderStyleType.SOLID;this.dashArray=[3];this.horizontalCornerRadius=0;this.verticalCornerRadius=0}setWidth(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[0,0,0,0];if(e instanceof s.Name)this.width=0;else if("number"==typeof e){if(e>0){const r=(t[2]-t[0])/2,a=(t[3]-t[1])/2;if(r>0&&a>0&&(e>r||e>a)){(0,n.warn)("AnnotationBorderStyle.setWidth - ignoring width: ".concat(e));e=1}}this.width=e}}setStyle(e){if(e instanceof s.Name)switch(e.name){case"S":this.style=n.AnnotationBorderStyleType.SOLID;break;case"D":this.style=n.AnnotationBorderStyleType.DASHED;break;case"B":this.style=n.AnnotationBorderStyleType.BEVELED;break;case"I":this.style=n.AnnotationBorderStyleType.INSET;break;case"U":this.style=n.AnnotationBorderStyleType.UNDERLINE}}setDashArray(e){let t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(Array.isArray(e)&&e.length>0){let r=!0,n=!0;for(const t of e){if(!(+t>=0)){r=!1;break}t>0&&(n=!1)}if(r&&!n){this.dashArray=e;t&&this.setStyle(s.Name.get("D"))}else this.width=0}else e&&(this.width=0)}setHorizontalCornerRadius(e){Number.isInteger(e)&&(this.horizontalCornerRadius=e)}setVerticalCornerRadius(e){Number.isInteger(e)&&(this.verticalCornerRadius=e)}}t.AnnotationBorderStyle=AnnotationBorderStyle;class MarkupAnnotation extends Annotation{constructor(e){super(e);const t=e.dict;if(t.has("IRT")){const e=t.getRaw("IRT");this.data.inReplyTo=e instanceof s.Ref?e.toString():null;const r=t.get("RT");this.data.replyType=r instanceof s.Name?r.name:n.AnnotationReplyType.REPLY}if(this.data.replyType===n.AnnotationReplyType.GROUP){const e=t.get("IRT");this.setTitle(e.get("T"));this.data.titleObj=this._title;this.setContents(e.get("Contents"));this.data.contentsObj=this._contents;if(e.has("CreationDate")){this.setCreationDate(e.get("CreationDate"));this.data.creationDate=this.creationDate}else this.data.creationDate=null;if(e.has("M")){this.setModificationDate(e.get("M"));this.data.modificationDate=this.modificationDate}else this.data.modificationDate=null;this.data.hasPopup=e.has("Popup");if(e.has("C")){this.setColor(e.getArray("C"));this.data.color=this.color}else this.data.color=null}else{this.data.titleObj=this._title;this.setCreationDate(t.get("CreationDate"));this.data.creationDate=this.creationDate;this.data.hasPopup=t.has("Popup");t.has("C")||(this.data.color=null)}t.has("RC")&&(this.data.richText=m.XFAFactory.getRichTextAsHtml(t.get("RC")))}setCreationDate(e){this.creationDate="string"==typeof e?e:null}_setDefaultAppearance(e){let{xref:t,extra:r,strokeColor:n,fillColor:a,blendMode:i,strokeAlpha:o,fillAlpha:c,pointsCallback:l}=e,h=Number.MAX_VALUE,u=Number.MAX_VALUE,d=Number.MIN_VALUE,f=Number.MIN_VALUE;const g=["q"];r&&g.push(r);n&&g.push("".concat(n[0]," ").concat(n[1]," ").concat(n[2]," RG"));a&&g.push("".concat(a[0]," ").concat(a[1]," ").concat(a[2]," rg"));let m=this.data.quadPoints;m||(m=[[{x:this.rectangle[0],y:this.rectangle[3]},{x:this.rectangle[2],y:this.rectangle[3]},{x:this.rectangle[0],y:this.rectangle[1]},{x:this.rectangle[2],y:this.rectangle[1]}]]);for(const e of m){const[t,r,n,a]=l(g,e);h=Math.min(h,t);d=Math.max(d,r);u=Math.min(u,n);f=Math.max(f,a)}g.push("Q");const b=new s.Dict(t),y=new s.Dict(t);y.set("Subtype",s.Name.get("Form"));const w=new p.StringStream(g.join(" "));w.dict=y;b.set("Fm0",w);const S=new s.Dict(t);i&&S.set("BM",s.Name.get(i));"number"==typeof o&&S.set("CA",o);"number"==typeof c&&S.set("ca",c);const x=new s.Dict(t);x.set("GS0",S);const v=new s.Dict(t);v.set("ExtGState",x);v.set("XObject",b);const k=new s.Dict(t);k.set("Resources",v);const C=this.data.rect=[h,u,d,f];k.set("BBox",C);this.appearance=new p.StringStream("/GS0 gs /Fm0 Do");this.appearance.dict=k;this._streams.push(this.appearance,w)}}t.MarkupAnnotation=MarkupAnnotation;class WidgetAnnotation extends Annotation{constructor(e){super(e);const t=e.dict,r=this.data;this.ref=e.ref;r.annotationType=n.AnnotationType.WIDGET;void 0===r.fieldName&&(r.fieldName=this._constructFieldName(t));void 0===r.actions&&(r.actions=(0,a.collectActions)(e.xref,t,n.AnnotationActionEventType));let o=(0,a.getInheritableProperty)({dict:t,key:"V",getArray:!0});r.fieldValue=this._decodeFormValue(o);const c=(0,a.getInheritableProperty)({dict:t,key:"DV",getArray:!0});r.defaultFieldValue=this._decodeFormValue(c);if(void 0===o&&e.xfaDatasets){const t=this._title.str;if(t){this._hasValueFromXFA=!0;r.fieldValue=o=e.xfaDatasets.getValue(t)}}void 0===o&&null!==r.defaultFieldValue&&(r.fieldValue=r.defaultFieldValue);r.alternativeText=(0,n.stringToPDFString)(t.get("TU")||"");const l=(0,a.getInheritableProperty)({dict:t,key:"DA"})||e.acroForm.get("DA");this._defaultAppearance="string"==typeof l?l:"";r.defaultAppearanceData=(0,i.parseDefaultAppearance)(this._defaultAppearance);const h=(0,a.getInheritableProperty)({dict:t,key:"FT"});r.fieldType=h instanceof s.Name?h.name:null;const u=(0,a.getInheritableProperty)({dict:t,key:"DR"}),d=e.acroForm.get("DR"),f=this.appearance&&this.appearance.dict.get("Resources");this._fieldResources={localResources:u,acroFormResources:d,appearanceResources:f,mergedResources:s.Dict.merge({xref:e.xref,dictArray:[u,f,d],mergeSubDicts:!0})};r.fieldFlags=(0,a.getInheritableProperty)({dict:t,key:"Ff"});(!Number.isInteger(r.fieldFlags)||r.fieldFlags<0)&&(r.fieldFlags=0);r.readOnly=this.hasFieldFlag(n.AnnotationFieldFlag.READONLY);r.required=this.hasFieldFlag(n.AnnotationFieldFlag.REQUIRED);r.hidden=this._hasFlag(r.annotationFlags,n.AnnotationFlag.HIDDEN);if("Sig"===r.fieldType&&!self.showUnverifiedSignatures){this.setFlags(n.AnnotationFlag.HIDDEN);(0,n.info)("The PDF file contains a signature. Please take into account that it can't be verified yet. By default, ngx-extended-pdf-viewer hides signatures until you configure it otherwise.")}}_decodeFormValue(e){return Array.isArray(e)?e.filter((e=>"string"==typeof e)).map((e=>(0,n.stringToPDFString)(e))):e instanceof s.Name?(0,n.stringToPDFString)(e.name):"string"==typeof e?(0,n.stringToPDFString)(e):null}hasFieldFlag(e){return!!(this.data.fieldFlags&e)}getOperatorList(e,t,r,a,i){return!a||this instanceof SignatureWidgetAnnotation?this._hasText?this._getAppearance(e,t,i).then((s=>{if(this.appearance&&null===s)return super.getOperatorList(e,t,r,a,i);const o=new g.OperatorList;if(!this._defaultAppearance||null===s)return o;const c=[1,0,0,1,0,0],l=[0,0,this.data.rect[2]-this.data.rect[0],this.data.rect[3]-this.data.rect[1]],h=getTransformMatrix(this.data.rect,l,c);o.addOp(n.OPS.beginAnnotation,[this.data.id,this.data.rect,h,c]);const u=new p.StringStream(s);return e.getOperatorList({stream:u,task:t,resources:this._fieldResources.mergedResources,operatorList:o}).then((function(){o.addOp(n.OPS.endAnnotation,[]);return o}))})):super.getOperatorList(e,t,r,a,i):Promise.resolve(new g.OperatorList)}async save(e,t,r){const a=r?r.get(this.data.id):void 0;let i=a&&a.value;if(i===this.data.fieldValue||void 0===i){if(!this._hasValueFromXFA)return null;i=i||this.data.fieldValue}if(!this._hasValueFromXFA&&Array.isArray(i)&&Array.isArray(this.data.fieldValue)&&i.length===this.data.fieldValue.length&&i.every(((e,t)=>e===this.data.fieldValue[t])))return null;let c=await this._getAppearance(e,t,r);if(null===c)return null;const{xref:l}=e,h=l.fetchIfRef(this.ref);if(!(h instanceof s.Dict))return null;const u=[0,0,this.data.rect[2]-this.data.rect[0],this.data.rect[3]-this.data.rect[1]],d={path:(0,n.stringToPDFString)(h.get("T")||""),value:i},f=l.getNewRef(),g=new s.Dict(l);g.set("N",f);const p=l.encrypt;let m=null,b=null;if(p){m=p.createCipherTransform(this.ref.num,this.ref.gen);b=p.createCipherTransform(f.num,f.gen);c=b.encryptString(c)}const encoder=e=>(0,n.isAscii)(e)?e:(0,n.stringToUTF16BEString)(e);h.set("V",Array.isArray(i)?i.map(encoder):encoder(i));h.set("AP",g);h.set("M","D:".concat((0,n.getModificationDate)()));const y=new s.Dict(l);y.set("Length",c.length);y.set("Subtype",s.Name.get("Form"));y.set("Resources",this._getSaveFieldResources(l));y.set("BBox",u);const w=["".concat(this.ref.num," ").concat(this.ref.gen," obj\n")];(0,o.writeDict)(h,w,m);w.push("\nendobj\n");const S=["".concat(f.num," ").concat(f.gen," obj\n")];(0,o.writeDict)(y,S,b);S.push(" stream\n",c,"\nendstream\nendobj\n");return[{ref:this.ref,data:w.join(""),xfa:d},{ref:f,data:S.join(""),xfa:null}]}async _getAppearance(e,t,r){if(this.hasFieldFlag(n.AnnotationFieldFlag.PASSWORD))return null;const a=r?r.get(this.data.id):void 0;let s=a&&(a.formattedValue||a.value);if(void 0===s){if(!this._hasValueFromXFA||this.appearance)return null;s=this.data.fieldValue;if(!s)return""}(0,n.assert)("string"==typeof s,"Expected `value` to be a string.");s=s.trim();if(""===s)return"";let o=-1;this.data.multiLine&&(o=s.split(/\r\n|\r|\n/).length);const c=this.data.rect[3]-this.data.rect[1],l=this.data.rect[2]-this.data.rect[0];this._defaultAppearance||(this.data.defaultAppearanceData=(0,i.parseDefaultAppearance)(this._defaultAppearance="/Helvetica 0 Tf 0 g"));const h=await WidgetAnnotation._getFontData(e,t,this.data.defaultAppearanceData,this._fieldResources.mergedResources),[u,d]=this._computeFontSize(c-2,l-4,s,h,o);let f=h.descent;isNaN(f)&&(f=0);const g=Math.min(Math.floor((c-d)/2),2)+Math.abs(f)*d,p=this.data.textAlignment;if(this.data.multiLine)return this._getMultilineAppearance(u,s,h,d,l,c,p,2,g);const m=h.encodeString(s).join("");if(this.data.comb)return this._getCombAppearance(u,h,m,l,2,g);const b=this.getBorderAndBackgroundAppearances();if(0===p||p>2)return"/Tx BMC q ".concat(b,"BT ")+u+" 1 0 0 1 ".concat(2," ").concat(g," Tm (").concat((0,n.escapeString)(m),") Tj")+" ET Q EMC";const y=this._renderText(m,h,d,l,p,2,g);return"/Tx BMC q ".concat(b,"BT ")+u+" 1 0 0 1 0 0 Tm ".concat(y)+" ET Q EMC"}static async _getFontData(e,t,r,n){const a=new g.OperatorList,i={font:null,clone(){return this}},{fontName:o,fontSize:c}=r;await e.handleSetFont(n,[o&&s.Name.get(o),c],null,a,t,i,null);return i.font}_getTextWidth(e,t){return t.charsToGlyphs(e).reduce(((e,t)=>e+t.width),0)/1e3}_computeFontSize(e,t,r,a,s){let{fontSize:o}=this.data.defaultAppearanceData;if(!o){const roundWithTwoDigits=e=>Math.floor(100*e)/100;if(-1===s){const i=this._getTextWidth(r,a);o=roundWithTwoDigits(Math.min(e/n.LINE_FACTOR,t/i))}else{const i=r.split(/\r\n?|\n/),c=[];for(const e of i){const t=a.encodeString(e).join(""),r=a.charsToGlyphs(t),n=a.getCharPositions(t);c.push({line:t,glyphs:r,positions:n})}const isTooBig=r=>{let n=0;for(const i of c){n+=this._splitLine(null,a,r,t,i).length*r;if(n>e)return!0}return!1};o=12;let l=o*n.LINE_FACTOR,h=Math.round(e/l);h=Math.max(h,s);for(;;){l=e/h;o=roundWithTwoDigits(l/n.LINE_FACTOR);if(!isTooBig(o))break;h++}}const{fontName:c,fontColor:l}=this.data.defaultAppearanceData;this._defaultAppearance=(0,i.createDefaultAppearance)({fontSize:o,fontName:c,fontColor:l})}return[this._defaultAppearance,o]}_renderText(e,t,r,i,s,o,c){let l;if(1===s){l=(i-this._getTextWidth(e,t)*r)/2}else if(2===s){l=i-this._getTextWidth(e,t)*r-o}else l=o;l=(0,a.numberToString)(l);c=(0,a.numberToString)(c);return"".concat(l," ").concat(c," Td (").concat((0,n.escapeString)(e),") Tj")}_getSaveFieldResources(e){const{localResources:t,appearanceResources:r,acroFormResources:n}=this._fieldResources,a=this.data.defaultAppearanceData&&this.data.defaultAppearanceData.fontName;if(!a)return t||s.Dict.empty;for(const e of[t,r])if(e instanceof s.Dict){const t=e.get("Font");if(t instanceof s.Dict&&t.has(a))return e}if(n instanceof s.Dict){const r=n.get("Font");if(r instanceof s.Dict&&r.has(a)){const n=new s.Dict(e);n.set(a,r.getRaw(a));const i=new s.Dict(e);i.set("Font",n);return s.Dict.merge({xref:e,dictArray:[i,t],mergeSubDicts:!0})}}return t||s.Dict.empty}getFieldObject(){return null}}class TextWidgetAnnotation extends WidgetAnnotation{constructor(e){super(e);this._hasText=!0;const t=e.dict;"string"!=typeof this.data.fieldValue&&(this.data.fieldValue="");let r=(0,a.getInheritableProperty)({dict:t,key:"Q"});(!Number.isInteger(r)||r<0||r>2)&&(r=null);this.data.textAlignment=r;let i=(0,a.getInheritableProperty)({dict:t,key:"MaxLen"});(!Number.isInteger(i)||i<0)&&(i=null);this.data.maxLen=i;this.data.multiLine=this.hasFieldFlag(n.AnnotationFieldFlag.MULTILINE);this.data.comb=this.hasFieldFlag(n.AnnotationFieldFlag.COMB)&&!this.hasFieldFlag(n.AnnotationFieldFlag.MULTILINE)&&!this.hasFieldFlag(n.AnnotationFieldFlag.PASSWORD)&&!this.hasFieldFlag(n.AnnotationFieldFlag.FILESELECT)&&null!==this.data.maxLen;this.data.doNotScroll=this.hasFieldFlag(n.AnnotationFieldFlag.DONOTSCROLL)}_getCombAppearance(e,t,r,i,s,o){const c=(0,a.numberToString)(i/this.data.maxLen),l=[],h=t.getCharPositions(r);for(const[e,t]of h)l.push("(".concat((0,n.escapeString)(r.substring(e,t)),") Tj"));const u=this.getBorderAndBackgroundAppearances(),d=l.join(" ".concat(c," 0 Td "));return"/Tx BMC q ".concat(u,"BT ")+e+" 1 0 0 1 ".concat(s," ").concat(o," Tm ").concat(d)+" ET Q EMC"}_getMultilineAppearance(e,t,r,n,a,i,s,o,c){const l=t.split(/\r\n?|\n/),h=[],u=a-2*o;for(const e of l){const t=this._splitLine(e,r,n,u);for(const e of t){const t=0===h.length?o:0;h.push(this._renderText(e,r,n,a,s,t,-n))}}const d=h.join("\n"),f=this.getBorderAndBackgroundAppearances();return"/Tx BMC q ".concat(f,"BT ")+e+" 1 0 0 1 0 ".concat(i," Tm ").concat(d)+" ET Q EMC"}_splitLine(e,t,r,n){let a=arguments.length>4&&void 0!==arguments[4]?arguments[4]:{};e=a.line||t.encodeString(e).join("");const i=a.glyphs||t.charsToGlyphs(e);if(i.length<=1)return[e];const s=a.positions||t.getCharPositions(e),o=r/1e3,c=[];let l=-1,h=-1,u=-1,d=0,f=0;for(let t=0,r=i.length;t<r;t++){const[r,a]=s[t],g=i[t],p=g.width*o;if(" "===g.unicode)if(f+p>n){c.push(e.substring(d,r));d=r;f=p;l=-1;u=-1}else{f+=p;l=r;h=a;u=t}else if(f+p>n)if(-1!==l){c.push(e.substring(d,h));d=h;t=u+1;l=-1;f=0}else{c.push(e.substring(d,r));d=r;f=p}else f+=p}d<e.length&&c.push(e.substring(d,e.length));return c}getFieldObject(){return{id:this.data.id,value:this.data.fieldValue,defaultValue:this.data.defaultFieldValue||"",multiline:this.data.multiLine,password:this.hasFieldFlag(n.AnnotationFieldFlag.PASSWORD),charLimit:this.data.maxLen,comb:this.data.comb,editable:!this.data.readOnly,hidden:this.data.hidden,name:this.data.fieldName,rect:this.data.rect,actions:this.data.actions,page:this.data.pageIndex,strokeColor:this.data.borderColor,fillColor:this.data.backgroundColor,type:"text"}}}class ButtonWidgetAnnotation extends WidgetAnnotation{constructor(e){super(e);this.checkedAppearance=null;this.uncheckedAppearance=null;this.data.checkBox=!this.hasFieldFlag(n.AnnotationFieldFlag.RADIO)&&!this.hasFieldFlag(n.AnnotationFieldFlag.PUSHBUTTON);this.data.radioButton=this.hasFieldFlag(n.AnnotationFieldFlag.RADIO)&&!this.hasFieldFlag(n.AnnotationFieldFlag.PUSHBUTTON);this.data.pushButton=this.hasFieldFlag(n.AnnotationFieldFlag.PUSHBUTTON);this.data.isTooltipOnly=!1;if(this.data.checkBox)this._processCheckBox(e);else if(this.data.radioButton)this._processRadioButton(e);else if(this.data.pushButton){this.data.hasOwnCanvas=!0;this._processPushButton(e)}else(0,n.warn)("Invalid field flags for button widget annotation")}async getOperatorList(e,t,r,n,a){if(this.data.pushButton)return super.getOperatorList(e,t,r,!1,a);let i=null;if(a){const e=a.get(this.data.id);i=e?e.value:null}if(null===i){if(this.appearance)return super.getOperatorList(e,t,r,n,a);i=this.data.checkBox?this.data.fieldValue===this.data.exportValue:this.data.fieldValue===this.data.buttonValue}const s=i?this.checkedAppearance:this.uncheckedAppearance;if(s){const i=this.appearance;this.appearance=s;const o=super.getOperatorList(e,t,r,n,a);this.appearance=i;return o}return new g.OperatorList}async save(e,t,r){return this.data.checkBox?this._saveCheckbox(e,t,r):this.data.radioButton?this._saveRadioButton(e,t,r):null}async _saveCheckbox(e,t,r){if(!r)return null;const a=r.get(this.data.id),i=a&&a.value;if(void 0===i)return null;if(this.data.fieldValue===this.data.exportValue===i)return null;const c=e.xref.fetchIfRef(this.ref);if(!(c instanceof s.Dict))return null;const l={path:(0,n.stringToPDFString)(c.get("T")||""),value:i?this.data.exportValue:""},h=s.Name.get(i?this.data.exportValue:"Off");c.set("V",h);c.set("AS",h);c.set("M","D:".concat((0,n.getModificationDate)()));const u=e.xref.encrypt;let d=null;u&&(d=u.createCipherTransform(this.ref.num,this.ref.gen));const f=["".concat(this.ref.num," ").concat(this.ref.gen," obj\n")];(0,o.writeDict)(c,f,d);f.push("\nendobj\n");return[{ref:this.ref,data:f.join(""),xfa:l}]}async _saveRadioButton(e,t,r){if(!r)return null;const a=r.get(this.data.id),i=a&&a.value;if(void 0===i)return null;if(this.data.fieldValue===this.data.buttonValue===i)return null;const c=e.xref.fetchIfRef(this.ref);if(!(c instanceof s.Dict))return null;const l={path:(0,n.stringToPDFString)(c.get("T")||""),value:i?this.data.buttonValue:""},h=s.Name.get(i?this.data.buttonValue:"Off");let u=null;const d=e.xref.encrypt;if(i)if(this.parent instanceof s.Ref){const t=e.xref.fetch(this.parent);let r=null;d&&(r=d.createCipherTransform(this.parent.num,this.parent.gen));t.set("V",h);u=["".concat(this.parent.num," ").concat(this.parent.gen," obj\n")];(0,o.writeDict)(t,u,r);u.push("\nendobj\n")}else this.parent instanceof s.Dict&&this.parent.set("V",h);c.set("AS",h);c.set("M","D:".concat((0,n.getModificationDate)()));let f=null;d&&(f=d.createCipherTransform(this.ref.num,this.ref.gen));const g=["".concat(this.ref.num," ").concat(this.ref.gen," obj\n")];(0,o.writeDict)(c,g,f);g.push("\nendobj\n");const p=[{ref:this.ref,data:g.join(""),xfa:l}];null!==u&&p.push({ref:this.parent,data:u.join(""),xfa:null});return p}_getDefaultCheckedAppearance(e,t){const r=this.data.rect[2]-this.data.rect[0],i=this.data.rect[3]-this.data.rect[1],o=[0,0,r,i],c=.8*Math.min(r,i);let l,h;if("check"===t){l={width:.755*c,height:.705*c};h="3"}else if("disc"===t){l={width:.791*c,height:.705*c};h="l"}else(0,n.unreachable)("_getDefaultCheckedAppearance - unsupported type: ".concat(t));const u=(0,a.numberToString)((r-l.width)/2),d=(0,a.numberToString)((i-l.height)/2),f="q BT /PdfJsZaDb ".concat(c," Tf 0 g ").concat(u," ").concat(d," Td (").concat(h,") Tj ET Q"),g=new s.Dict(e.xref);g.set("FormType",1);g.set("Subtype",s.Name.get("Form"));g.set("Type",s.Name.get("XObject"));g.set("BBox",o);g.set("Matrix",[1,0,0,1,0,0]);g.set("Length",f.length);const m=new s.Dict(e.xref),b=new s.Dict(e.xref);b.set("PdfJsZaDb",this.fallbackFontDict);m.set("Font",b);g.set("Resources",m);this.checkedAppearance=new p.StringStream(f);this.checkedAppearance.dict=g;this._streams.push(this.checkedAppearance)}_processCheckBox(e){const t=e.dict.get("AP");if(!(t instanceof s.Dict))return;const r=t.get("N");if(!(r instanceof s.Dict))return;const n=this._decodeFormValue(e.dict.get("AS"));"string"==typeof n&&(this.data.fieldValue=n);const a=null!==this.data.fieldValue&&"Off"!==this.data.fieldValue?this.data.fieldValue:"Yes",i=r.getKeys();if(0===i.length)i.push("Off",a);else if(1===i.length)"Off"===i[0]?i.push(a):i.unshift("Off");else if(i.includes(a)){i.length=0;i.push("Off",a)}else{const e=i.find((e=>"Off"!==e));i.length=0;i.push("Off",e)}i.includes(this.data.fieldValue)||(this.data.fieldValue="Off");this.data.exportValue=i[1];this.checkedAppearance=r.get(this.data.exportValue)||null;this.uncheckedAppearance=r.get("Off")||null;this.checkedAppearance?this._streams.push(this.checkedAppearance):this._getDefaultCheckedAppearance(e,"check");this.uncheckedAppearance&&this._streams.push(this.uncheckedAppearance);this._fallbackFontDict=this.fallbackFontDict}_processRadioButton(e){this.data.fieldValue=this.data.buttonValue=null;const t=e.dict.get("Parent");if(t instanceof s.Dict){this.parent=e.dict.getRaw("Parent");const r=t.get("V");r instanceof s.Name&&(this.data.fieldValue=this._decodeFormValue(r))}const r=e.dict.get("AP");if(!(r instanceof s.Dict))return;const n=r.get("N");if(n instanceof s.Dict){for(const e of n.getKeys())if("Off"!==e){this.data.buttonValue=this._decodeFormValue(e);break}this.checkedAppearance=n.get(this.data.buttonValue)||null;this.uncheckedAppearance=n.get("Off")||null;this.checkedAppearance?this._streams.push(this.checkedAppearance):this._getDefaultCheckedAppearance(e,"disc");this.uncheckedAppearance&&this._streams.push(this.uncheckedAppearance);this._fallbackFontDict=this.fallbackFontDict}}_processPushButton(e){if(e.dict.has("A")||e.dict.has("AA")||this.data.alternativeText){this.data.isTooltipOnly=!e.dict.has("A")&&!e.dict.has("AA");h.Catalog.parseDestDictionary({destDict:e.dict,resultObj:this.data,docBaseUrl:e.pdfManager.docBaseUrl})}else(0,n.warn)("Push buttons without action dictionaries are not supported")}getFieldObject(){let e,t="button";if(this.data.checkBox){t="checkbox";e=this.data.exportValue}else if(this.data.radioButton){t="radiobutton";e=this.data.buttonValue}return{id:this.data.id,value:this.data.fieldValue||"Off",defaultValue:this.data.defaultFieldValue,exportValues:e,editable:!this.data.readOnly,name:this.data.fieldName,rect:this.data.rect,hidden:this.data.hidden,actions:this.data.actions,page:this.data.pageIndex,strokeColor:this.data.borderColor,fillColor:this.data.backgroundColor,type:t}}get fallbackFontDict(){const e=new s.Dict;e.set("BaseFont",s.Name.get("ZapfDingbats"));e.set("Type",s.Name.get("FallbackType"));e.set("Subtype",s.Name.get("FallbackType"));e.set("Encoding",s.Name.get("ZapfDingbatsEncoding"));return(0,n.shadow)(this,"fallbackFontDict",e)}}class ChoiceWidgetAnnotation extends WidgetAnnotation{constructor(e){super(e);this.data.options=[];const t=(0,a.getInheritableProperty)({dict:e.dict,key:"Opt"});if(Array.isArray(t)){const r=e.xref;for(let e=0,n=t.length;e<n;e++){const n=r.fetchIfRef(t[e]),a=Array.isArray(n);this.data.options[e]={exportValue:this._decodeFormValue(a?r.fetchIfRef(n[0]):n),displayValue:this._decodeFormValue(a?r.fetchIfRef(n[1]):n)}}}"string"==typeof this.data.fieldValue?this.data.fieldValue=[this.data.fieldValue]:this.data.fieldValue||(this.data.fieldValue=[]);this.data.combo=this.hasFieldFlag(n.AnnotationFieldFlag.COMBO);this.data.multiSelect=this.hasFieldFlag(n.AnnotationFieldFlag.MULTISELECT);this._hasText=!0}getFieldObject(){const e=this.data.combo?"combobox":"listbox",t=this.data.fieldValue.length>0?this.data.fieldValue[0]:null;return{id:this.data.id,value:t,defaultValue:this.data.defaultFieldValue,editable:!this.data.readOnly,name:this.data.fieldName,rect:this.data.rect,numItems:this.data.fieldValue.length,multipleSelection:this.data.multiSelect,hidden:this.data.hidden,actions:this.data.actions,items:this.data.options,page:this.data.pageIndex,strokeColor:this.data.borderColor,fillColor:this.data.backgroundColor,type:e}}async _getAppearance(e,t,r){if(this.data.combo)return super._getAppearance(e,t,r);if(!r)return null;const a=r.get(this.data.id);let s=a&&a.value;if(void 0===s)return null;Array.isArray(s)||(s=[s]);const o=this.data.rect[3]-this.data.rect[1],c=this.data.rect[2]-this.data.rect[0],l=this.data.options.length,h=[];for(let e=0;e<l;e++){const{exportValue:t}=this.data.options[e];s.includes(t)&&h.push(e)}this._defaultAppearance||(this.data.defaultAppearanceData=(0,i.parseDefaultAppearance)(this._defaultAppearance="/Helvetica 0 Tf 0 g"));const u=await WidgetAnnotation._getFontData(e,t,this.data.defaultAppearanceData,this._fieldResources.mergedResources);let d,{fontSize:f}=this.data.defaultAppearanceData;if(f)d=this._defaultAppearance;else{const e=(o-2)/l;let t,r=-1;for(const{displayValue:e}of this.data.options){const n=this._getTextWidth(e,u);if(n>r){r=n;t=e}}[d,f]=this._computeFontSize(e,c-4,t,u,-1)}const g=f*n.LINE_FACTOR,p=(g-f)/2,m=Math.floor(o/g);let b;if(1===h.length){const e=h[0];b=e-e%m}else b=h.length?h[0]:0;const y=Math.min(b+m+1,l),w=["/Tx BMC q","1 1 ".concat(c," ").concat(o," re W n")];if(h.length){w.push("0.600006 0.756866 0.854904 rg");for(const e of h)b<=e&&e<y&&w.push("1 ".concat(o-(e-b+1)*g," ").concat(c," ").concat(g," re f"))}w.push("BT",d,"1 0 0 1 0 ".concat(o," Tm"));for(let e=b;e<y;e++){const{displayValue:t}=this.data.options[e],r=e===b?2:0,n=e===b?p:0;w.push(this._renderText(t,u,f,c,0,r,-g+n))}w.push("ET Q EMC");return w.join("\n")}}class SignatureWidgetAnnotation extends WidgetAnnotation{constructor(e){super(e);this.data.fieldValue=null}getFieldObject(){return{id:this.data.id,value:null,page:this.data.pageIndex,type:"signature"}}}class TextAnnotation extends MarkupAnnotation{constructor(e){super(e);const t=e.dict;this.data.annotationType=n.AnnotationType.TEXT;if(this.data.hasAppearance)this.data.name="NoIcon";else{this.data.rect[1]=this.data.rect[3]-22;this.data.rect[2]=this.data.rect[0]+22;this.data.name=t.has("Name")?t.get("Name").name:"Note"}if(t.has("State")){this.data.state=t.get("State")||null;this.data.stateModel=t.get("StateModel")||null}else{this.data.state=null;this.data.stateModel=null}}}class LinkAnnotation extends Annotation{constructor(e){super(e);this.data.annotationType=n.AnnotationType.LINK;const t=getQuadPoints(e.dict,this.rectangle);t&&(this.data.quadPoints=t);this.data.borderColor=this.data.borderColor||this.data.color;h.Catalog.parseDestDictionary({destDict:e.dict,resultObj:this.data,docBaseUrl:e.pdfManager.docBaseUrl})}}class PopupAnnotation extends Annotation{constructor(e){super(e);this.data.annotationType=n.AnnotationType.POPUP;let t=e.dict.get("Parent");if(!t){(0,n.warn)("Popup annotation has a missing or invalid parent annotation.");return}const r=t.get("Subtype");this.data.parentType=r instanceof s.Name?r.name:null;const a=e.dict.getRaw("Parent");this.data.parentId=a instanceof s.Ref?a.toString():null;const i=t.getArray("Rect");Array.isArray(i)&&4===i.length?this.data.parentRect=n.Util.normalizeRect(i):this.data.parentRect=[0,0,0,0];const o=t.get("RT");(0,s.isName)(o,n.AnnotationReplyType.GROUP)&&(t=t.get("IRT"));if(t.has("M")){this.setModificationDate(t.get("M"));this.data.modificationDate=this.modificationDate}else this.data.modificationDate=null;if(t.has("C")){this.setColor(t.getArray("C"));this.data.color=this.color}else this.data.color=null;if(!this.viewable){const e=t.get("F");this._isViewable(e)&&this.setFlags(e)}this.setTitle(t.get("T"));this.data.titleObj=this._title;this.setContents(t.get("Contents"));this.data.contentsObj=this._contents;t.has("RC")&&(this.data.richText=m.XFAFactory.getRichTextAsHtml(t.get("RC")))}}class FreeTextAnnotation extends MarkupAnnotation{constructor(e){super(e);this.data.annotationType=n.AnnotationType.FREETEXT}static async createNewAnnotation(e,t,r,c,l,h,u){const{color:d,fontSize:f,rect:g,user:m,value:b}=c,y=e.getNewRef(),w=new s.Dict(e);w.set("Type",s.Name.get("Annot"));w.set("Subtype",s.Name.get("FreeText"));w.set("CreationDate","D:".concat((0,n.getModificationDate)()));w.set("Rect",g);const S="/Helv ".concat(f," Tf ").concat((0,i.getPdfColor)(d,!0));w.set("DA",S);w.set("Contents",b);w.set("F",4);w.set("Border",[0,0,0]);w.set("Rotate",0);m&&w.set("T",(0,n.stringToUTF8String)(m));const x=new s.Dict(e),v=new s.Dict(e);v.set("Helv",l);x.set("Font",v);const k=await WidgetAnnotation._getFontData(t,r,{fontName:"Helvetica",fontSize:f},x),[C,O,T,M]=g,E=T-C,D=M-O,N=b.split("\n"),R=f/1e3;let L=-1/0;const j=[];for(let e of N){e=k.encodeString(e).join("");j.push(e);let t=0;const r=k.charsToGlyphs(e);for(const e of r)t+=e.width*R;L=Math.max(L,t)}let _=1;L>E&&(_=E/L);let U=1;const $=n.LINE_FACTOR*f,X=n.LINE_DESCENT_FACTOR*f,H=$*N.length;H>D&&(U=D/H);const q=f*Math.min(_,U),W=["q","0 0 ".concat((0,a.numberToString)(E)," ").concat((0,a.numberToString)(D)," re W n"),"BT","1 0 0 1 0 ".concat((0,a.numberToString)(D+X)," Tm 0 Tc ").concat((0,i.getPdfColor)(d,!0)),"/Helv ".concat((0,a.numberToString)(q)," Tf")],z=(0,a.numberToString)($);for(const e of j)W.push("0 -".concat(z," Td (").concat((0,n.escapeString)(e),") Tj"));W.push("ET","Q");const G=W.join("\n"),V=new s.Dict(e);V.set("FormType",1);V.set("Subtype",s.Name.get("Form"));V.set("Type",s.Name.get("XObject"));V.set("BBox",[0,0,E,D]);V.set("Length",G.length);V.set("Resources",x);const K=new p.StringStream(G);K.dict=V;W.length=0;const Y=e.getNewRef();let J=e.encrypt?e.encrypt.createCipherTransform(Y.num,Y.gen):null;(0,o.writeObject)(Y,K,W,J);u.push({ref:Y,data:W.join("")});const Z=new s.Dict(e);Z.set("N",Y);w.set("AP",Z);W.length=0;J=e.encrypt?e.encrypt.createCipherTransform(y.num,y.gen):null;(0,o.writeObject)(y,w,W,J);h.push({ref:y,data:W.join("")})}}class LineAnnotation extends MarkupAnnotation{constructor(e){super(e);const{dict:t}=e;this.data.annotationType=n.AnnotationType.LINE;const r=t.getArray("L");this.data.lineCoordinates=n.Util.normalizeRect(r);this.setLineEndings(t.getArray("LE"));this.data.lineEndings=this.lineEndings;if(!this.appearance){const a=this.color?Array.from(this.color).map((e=>e/255)):[0,0,0],i=t.get("CA");let s=null,o=t.getArray("IC");if(o){o=getRgbColor(o,null);s=o?Array.from(o).map((e=>e/255)):null}const c=s?i:null,l=this.borderStyle.width||1,h=2*l,u=[this.data.lineCoordinates[0]-h,this.data.lineCoordinates[1]-h,this.data.lineCoordinates[2]+h,this.data.lineCoordinates[3]+h];n.Util.intersect(this.rectangle,u)||(this.rectangle=u);this._setDefaultAppearance({xref:e.xref,extra:"".concat(l," w"),strokeColor:a,fillColor:s,strokeAlpha:i,fillAlpha:c,pointsCallback:(e,t)=>{e.push("".concat(r[0]," ").concat(r[1]," m"),"".concat(r[2]," ").concat(r[3]," l"),"S");return[t[0].x-l,t[1].x+l,t[3].y-l,t[1].y+l]}})}}}class SquareAnnotation extends MarkupAnnotation{constructor(e){super(e);this.data.annotationType=n.AnnotationType.SQUARE;if(!this.appearance){const t=this.color?Array.from(this.color).map((e=>e/255)):[0,0,0],r=e.dict.get("CA");let n=null,a=e.dict.getArray("IC");if(a){a=getRgbColor(a,null);n=a?Array.from(a).map((e=>e/255)):null}const i=n?r:null;if(0===this.borderStyle.width&&!n)return;this._setDefaultAppearance({xref:e.xref,extra:"".concat(this.borderStyle.width," w"),strokeColor:t,fillColor:n,strokeAlpha:r,fillAlpha:i,pointsCallback:(e,t)=>{const r=t[2].x+this.borderStyle.width/2,a=t[2].y+this.borderStyle.width/2,i=t[3].x-t[2].x-this.borderStyle.width,s=t[1].y-t[3].y-this.borderStyle.width;e.push("".concat(r," ").concat(a," ").concat(i," ").concat(s," re"));n?e.push("B"):e.push("S");return[t[0].x,t[1].x,t[3].y,t[1].y]}})}}}class CircleAnnotation extends MarkupAnnotation{constructor(e){super(e);this.data.annotationType=n.AnnotationType.CIRCLE;if(!this.appearance){const t=this.color?Array.from(this.color).map((e=>e/255)):[0,0,0],r=e.dict.get("CA");let n=null,a=e.dict.getArray("IC");if(a){a=getRgbColor(a,null);n=a?Array.from(a).map((e=>e/255)):null}const i=n?r:null;if(0===this.borderStyle.width&&!n)return;const s=4/3*Math.tan(Math.PI/8);this._setDefaultAppearance({xref:e.xref,extra:"".concat(this.borderStyle.width," w"),strokeColor:t,fillColor:n,strokeAlpha:r,fillAlpha:i,pointsCallback:(e,t)=>{const r=t[0].x+this.borderStyle.width/2,a=t[0].y-this.borderStyle.width/2,i=t[3].x-this.borderStyle.width/2,o=t[3].y+this.borderStyle.width/2,c=r+(i-r)/2,l=a+(o-a)/2,h=(i-r)/2*s,u=(o-a)/2*s;e.push("".concat(c," ").concat(o," m"),"".concat(c+h," ").concat(o," ").concat(i," ").concat(l+u," ").concat(i," ").concat(l," c"),"".concat(i," ").concat(l-u," ").concat(c+h," ").concat(a," ").concat(c," ").concat(a," c"),"".concat(c-h," ").concat(a," ").concat(r," ").concat(l-u," ").concat(r," ").concat(l," c"),"".concat(r," ").concat(l+u," ").concat(c-h," ").concat(o," ").concat(c," ").concat(o," c"),"h");n?e.push("B"):e.push("S");return[t[0].x,t[1].x,t[3].y,t[1].y]}})}}}class PolylineAnnotation extends MarkupAnnotation{constructor(e){super(e);const{dict:t}=e;this.data.annotationType=n.AnnotationType.POLYLINE;this.data.vertices=[];if(!(this instanceof PolygonAnnotation)){this.setLineEndings(t.getArray("LE"));this.data.lineEndings=this.lineEndings}const r=t.getArray("Vertices");if(Array.isArray(r)){for(let e=0,t=r.length;e<t;e+=2)this.data.vertices.push({x:r[e],y:r[e+1]});if(!this.appearance){const r=this.color?Array.from(this.color).map((e=>e/255)):[0,0,0],a=t.get("CA"),i=this.borderStyle.width||1,s=2*i,o=[1/0,1/0,-1/0,-1/0];for(const e of this.data.vertices){o[0]=Math.min(o[0],e.x-s);o[1]=Math.min(o[1],e.y-s);o[2]=Math.max(o[2],e.x+s);o[3]=Math.max(o[3],e.y+s)}n.Util.intersect(this.rectangle,o)||(this.rectangle=o);this._setDefaultAppearance({xref:e.xref,extra:"".concat(i," w"),strokeColor:r,strokeAlpha:a,pointsCallback:(e,t)=>{const r=this.data.vertices;for(let t=0,n=r.length;t<n;t++)e.push("".concat(r[t].x," ").concat(r[t].y," ").concat(0===t?"m":"l"));e.push("S");return[t[0].x,t[1].x,t[3].y,t[1].y]}})}}}}class PolygonAnnotation extends PolylineAnnotation{constructor(e){super(e);this.data.annotationType=n.AnnotationType.POLYGON}}class CaretAnnotation extends MarkupAnnotation{constructor(e){super(e);this.data.annotationType=n.AnnotationType.CARET}}class InkAnnotation extends MarkupAnnotation{constructor(e){super(e);this.data.annotationType=n.AnnotationType.INK;this.data.inkLists=[];const t=e.dict.getArray("InkList");if(!Array.isArray(t))return;const r=e.xref;for(let e=0,n=t.length;e<n;++e){this.data.inkLists.push([]);for(let n=0,a=t[e].length;n<a;n+=2)this.data.inkLists[e].push({x:r.fetchIfRef(t[e][n]),y:r.fetchIfRef(t[e][n+1])})}if(!this.appearance){const t=this.color?Array.from(this.color).map((e=>e/255)):[0,0,0],r=e.dict.get("CA"),a=this.borderStyle.width||1,i=2*a,s=[1/0,1/0,-1/0,-1/0];for(const e of this.data.inkLists)for(const t of e){s[0]=Math.min(s[0],t.x-i);s[1]=Math.min(s[1],t.y-i);s[2]=Math.max(s[2],t.x+i);s[3]=Math.max(s[3],t.y+i)}n.Util.intersect(this.rectangle,s)||(this.rectangle=s);this._setDefaultAppearance({xref:e.xref,extra:"".concat(a," w"),strokeColor:t,strokeAlpha:r,pointsCallback:(e,t)=>{for(const t of this.data.inkLists){for(let r=0,n=t.length;r<n;r++)e.push("".concat(t[r].x," ").concat(t[r].y," ").concat(0===r?"m":"l"));e.push("S")}return[t[0].x,t[1].x,t[3].y,t[1].y]}})}}static async createNewAnnotation(e,t,r,c,l,h){const u=e.getNewRef(),d=new s.Dict(e);d.set("Type",s.Name.get("Annot"));d.set("Subtype",s.Name.get("Ink"));d.set("CreationDate","D:".concat((0,n.getModificationDate)()));d.set("Rect",c.rect);d.set("InkList",c.paths.map((e=>e.points)));d.set("F",4);d.set("Border",[0,0,0]);d.set("Rotate",0);const[f,g,m,b]=c.rect,y=m-f,w=b-g,S=["".concat(c.thickness," w"),"".concat((0,i.getPdfColor)(c.color,!1))],x=[];for(const{bezier:e}of c.paths){x.length=0;x.push("".concat((0,a.numberToString)(e[0])," ").concat((0,a.numberToString)(e[1])," m"));for(let t=2,r=e.length;t<r;t+=6){const r=e.slice(t,t+6).map(a.numberToString).join(" ");x.push("".concat(r," c"))}x.push("S");S.push(x.join("\n"))}const v=S.join("\n"),k=new s.Dict(e);k.set("FormType",1);k.set("Subtype",s.Name.get("Form"));k.set("Type",s.Name.get("XObject"));k.set("BBox",[0,0,y,w]);k.set("Length",v.length);const C=new p.StringStream(v);C.dict=k;x.length=0;const O=e.getNewRef();let T=e.encrypt?e.encrypt.createCipherTransform(O.num,O.gen):null;(0,o.writeObject)(O,C,x,T);h.push({ref:O,data:x.join("")});const M=new s.Dict(e);M.set("N",O);d.set("AP",M);x.length=0;T=e.encrypt?e.encrypt.createCipherTransform(u.num,u.gen):null;(0,o.writeObject)(u,d,x,T);l.push({ref:u,data:x.join("")})}}class HighlightAnnotation extends MarkupAnnotation{constructor(e){super(e);this.data.annotationType=n.AnnotationType.HIGHLIGHT;if(this.data.quadPoints=getQuadPoints(e.dict,null)){const t=this.appearance&&this.appearance.dict.get("Resources");if(!this.appearance||!t||!t.has("ExtGState")){this.appearance&&(0,n.warn)("HighlightAnnotation - ignoring built-in appearance stream.");const t=this.color?Array.from(this.color).map((e=>e/255)):[1,1,0],r=e.dict.get("CA");this._setDefaultAppearance({xref:e.xref,fillColor:t,blendMode:"Multiply",fillAlpha:r,pointsCallback:(e,t)=>{e.push("".concat(t[0].x," ").concat(t[0].y," m"),"".concat(t[1].x," ").concat(t[1].y," l"),"".concat(t[3].x," ").concat(t[3].y," l"),"".concat(t[2].x," ").concat(t[2].y," l"),"f");return[t[0].x,t[1].x,t[3].y,t[1].y]}})}}else this.data.hasPopup=!1}}class UnderlineAnnotation extends MarkupAnnotation{constructor(e){super(e);this.data.annotationType=n.AnnotationType.UNDERLINE;if(this.data.quadPoints=getQuadPoints(e.dict,null)){if(!this.appearance){const t=this.color?Array.from(this.color).map((e=>e/255)):[0,0,0],r=e.dict.get("CA");this._setDefaultAppearance({xref:e.xref,extra:"[] 0 d 1 w",strokeColor:t,strokeAlpha:r,pointsCallback:(e,t)=>{e.push("".concat(t[2].x," ").concat(t[2].y," m"),"".concat(t[3].x," ").concat(t[3].y," l"),"S");return[t[0].x,t[1].x,t[3].y,t[1].y]}})}}else this.data.hasPopup=!1}}class SquigglyAnnotation extends MarkupAnnotation{constructor(e){super(e);this.data.annotationType=n.AnnotationType.SQUIGGLY;if(this.data.quadPoints=getQuadPoints(e.dict,null)){if(!this.appearance){const t=this.color?Array.from(this.color).map((e=>e/255)):[0,0,0],r=e.dict.get("CA");this._setDefaultAppearance({xref:e.xref,extra:"[] 0 d 1 w",strokeColor:t,strokeAlpha:r,pointsCallback:(e,t)=>{const r=(t[0].y-t[2].y)/6;let n=r,a=t[2].x;const i=t[2].y,s=t[3].x;e.push("".concat(a," ").concat(i+n," m"));do{a+=2;n=0===n?r:0;e.push("".concat(a," ").concat(i+n," l"))}while(a<s);e.push("S");return[t[2].x,s,i-2*r,i+2*r]}})}}else this.data.hasPopup=!1}}class StrikeOutAnnotation extends MarkupAnnotation{constructor(e){super(e);this.data.annotationType=n.AnnotationType.STRIKEOUT;if(this.data.quadPoints=getQuadPoints(e.dict,null)){if(!this.appearance){const t=this.color?Array.from(this.color).map((e=>e/255)):[0,0,0],r=e.dict.get("CA");this._setDefaultAppearance({xref:e.xref,extra:"[] 0 d 1 w",strokeColor:t,strokeAlpha:r,pointsCallback:(e,t)=>{e.push("".concat((t[0].x+t[2].x)/2," ")+"".concat((t[0].y+t[2].y)/2," m"),"".concat((t[1].x+t[3].x)/2," ")+"".concat((t[1].y+t[3].y)/2," l"),"S");return[t[0].x,t[1].x,t[3].y,t[1].y]}})}}else this.data.hasPopup=!1}}class StampAnnotation extends MarkupAnnotation{constructor(e){super(e);this.data.annotationType=n.AnnotationType.STAMP}}class FileAttachmentAnnotation extends MarkupAnnotation{constructor(e){super(e);const t=new d.FileSpec(e.dict.get("FS"),e.xref);this.data.annotationType=n.AnnotationType.FILEATTACHMENT;this.data.file=t.serializable}}},(e,t,r)=>{r(126)("Uint8",(function(e){return function Uint8ClampedArray(t,r,n){return e(this,t,r,n)}}),!0)},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.createDefaultAppearance=function createDefaultAppearance(e){let{fontSize:t,fontName:r,fontColor:a}=e;return"/".concat((0,n.escapePDFName)(r)," ").concat(t," Tf ").concat(getPdfColor(a,!0))};t.getPdfColor=getPdfColor;t.parseDefaultAppearance=function parseDefaultAppearance(e){return new DefaultAppearanceEvaluator(e).parse()};r(232);r(146);r(148);r(149);r(112);var n=r(213),a=r(158),i=r(234),s=r(237),o=r(209),c=r(218);class DefaultAppearanceEvaluator extends s.EvaluatorPreprocessor{constructor(e){super(new c.StringStream(e))}parse(){const e={fn:0,args:[]},t={fontSize:0,fontName:"",fontColor:new Uint8ClampedArray(3)};try{for(;;){e.args.length=0;if(!this.read(e))break;if(0!==this.savedStatesDepth)continue;const{fn:r,args:n}=e;switch(0|r){case a.OPS.setFont:const[e,r]=n;e instanceof o.Name&&(t.fontName=e.name);"number"==typeof r&&r>0&&(t.fontSize=r);break;case a.OPS.setFillRGBColor:i.ColorSpace.singletons.rgb.getRgbItem(n,0,t.fontColor,0);break;case a.OPS.setFillGray:i.ColorSpace.singletons.gray.getRgbItem(n,0,t.fontColor,0);break;case a.OPS.setFillColorSpace:i.ColorSpace.singletons.cmyk.getRgbItem(n,0,t.fontColor,0)}}}catch(e){(0,a.warn)('parseDefaultAppearance - ignoring errors: "'.concat(e,'".'))}return t}}function getPdfColor(e,t){if(e[0]===e[1]&&e[1]===e[2]){const r=e[0]/255;return"".concat((0,n.numberToString)(r)," ").concat(t?"g":"G")}return Array.from(e).map((e=>(0,n.numberToString)(e/255))).join(" ")+" ".concat(t?"rg":"RG")}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.ColorSpace=void 0;r(235);r(146);r(148);r(149);r(232);r(125);r(2);r(236);var n=r(158),a=r(209),i=r(217),s=r(213);class ColorSpace{constructor(e,t){this.constructor===ColorSpace&&(0,n.unreachable)("Cannot initialize ColorSpace.");this.name=e;this.numComps=t}getRgb(e,t){const r=new Uint8ClampedArray(3);this.getRgbItem(e,t,r,0);return r}getRgbItem(e,t,r,a){(0,n.unreachable)("Should not call ColorSpace.getRgbItem")}getRgbBuffer(e,t,r,a,i,s,o){(0,n.unreachable)("Should not call ColorSpace.getRgbBuffer")}getOutputLength(e,t){(0,n.unreachable)("Should not call ColorSpace.getOutputLength")}isPassthrough(e){return!1}isDefaultDecode(e,t){return ColorSpace.isDefaultDecode(e,this.numComps)}fillRgb(e,t,r,n,a,i,s,o,c){const l=t*r;let h=null;const u=1<<s,d=r!==a||t!==n;if(this.isPassthrough(s))h=o;else if(1===this.numComps&&l>u&&"DeviceGray"!==this.name&&"DeviceRGB"!==this.name){const t=s<=8?new Uint8Array(u):new Uint16Array(u);for(let e=0;e<u;e++)t[e]=e;const r=new Uint8ClampedArray(3*u);this.getRgbBuffer(t,0,u,r,0,s,0);if(d){h=new Uint8Array(3*l);let e=0;for(let t=0;t<l;++t){const n=3*o[t];h[e++]=r[n];h[e++]=r[n+1];h[e++]=r[n+2]}}else{let t=0;for(let n=0;n<l;++n){const a=3*o[n];e[t++]=r[a];e[t++]=r[a+1];e[t++]=r[a+2];t+=c}}}else if(d){h=new Uint8ClampedArray(3*l);this.getRgbBuffer(o,0,l,h,0,s,0)}else this.getRgbBuffer(o,0,n*i,e,0,s,c);if(h)if(d)!function resizeRgbImage(e,t,r,n,a,i,s){s=1!==s?0:s;const o=r/a,c=n/i;let l,h=0;const u=new Uint16Array(a),d=3*r;for(let e=0;e<a;e++)u[e]=3*Math.floor(e*o);for(let r=0;r<i;r++){const n=Math.floor(r*c)*d;for(let r=0;r<a;r++){l=n+u[r];t[h++]=e[l++];t[h++]=e[l++];t[h++]=e[l++];h+=s}}}(h,e,t,r,n,a,c);else{let t=0,r=0;for(let a=0,s=n*i;a<s;a++){e[t++]=h[r++];e[t++]=h[r++];e[t++]=h[r++];t+=c}}}get usesZeroToOneRange(){return(0,n.shadow)(this,"usesZeroToOneRange",!0)}static _cache(e,t,r,n){if(!r)throw new Error('ColorSpace._cache - expected "localColorSpaceCache" argument.');if(!n)throw new Error('ColorSpace._cache - expected "parsedColorSpace" argument.');let i,s;if(e instanceof a.Ref){s=e;e=t.fetch(e)}e instanceof a.Name&&(i=e.name);(i||s)&&r.set(i,s,n)}static getCached(e,t,r){if(!r)throw new Error('ColorSpace.getCached - expected "localColorSpaceCache" argument.');if(e instanceof a.Ref){const n=r.getByRef(e);if(n)return n;try{e=t.fetch(e)}catch(e){if(e instanceof s.MissingDataException)throw e}}if(e instanceof a.Name){const t=r.getByName(e.name);if(t)return t}return null}static async parseAsync(e){let{cs:t,xref:r,resources:n=null,pdfFunctionFactory:a,localColorSpaceCache:i}=e;const s=this._parse(t,r,n,a);this._cache(t,r,i,s);return s}static parse(e){let{cs:t,xref:r,resources:n=null,pdfFunctionFactory:a,localColorSpaceCache:i}=e;const s=this.getCached(t,r,i);if(s)return s;const o=this._parse(t,r,n,a);this._cache(t,r,i,o);return o}static _parse(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,i=arguments.length>3?arguments[3]:void 0;if((e=t.fetchIfRef(e))instanceof a.Name)switch(e.name){case"G":case"DeviceGray":return this.singletons.gray;case"RGB":case"DeviceRGB":return this.singletons.rgb;case"CMYK":case"DeviceCMYK":return this.singletons.cmyk;case"Pattern":return new PatternCS(null);default:if(r instanceof a.Dict){const n=r.get("ColorSpace");if(n instanceof a.Dict){const s=n.get(e.name);if(s){if(s instanceof a.Name)return this._parse(s,t,r,i);e=s;break}}}throw new n.FormatError("Unrecognized ColorSpace: ".concat(e.name))}if(Array.isArray(e)){const a=t.fetchIfRef(e[0]).name;let s,o,u,d,f,g;switch(a){case"G":case"DeviceGray":return this.singletons.gray;case"RGB":case"DeviceRGB":return this.singletons.rgb;case"CMYK":case"DeviceCMYK":return this.singletons.cmyk;case"CalGray":s=t.fetchIfRef(e[1]);d=s.getArray("WhitePoint");f=s.getArray("BlackPoint");g=s.get("Gamma");return new c(d,f,g);case"CalRGB":s=t.fetchIfRef(e[1]);d=s.getArray("WhitePoint");f=s.getArray("BlackPoint");g=s.getArray("Gamma");const p=s.getArray("Matrix");return new l(d,f,g,p);case"ICCBased":const m=t.fetchIfRef(e[1]).dict;o=m.get("N");const b=m.get("Alternate");if(b){const e=this._parse(b,t,r,i);if(e.numComps===o)return e;(0,n.warn)("ICCBased color space: Ignoring incorrect /Alternate entry.")}if(1===o)return this.singletons.gray;if(3===o)return this.singletons.rgb;if(4===o)return this.singletons.cmyk;break;case"Pattern":u=e[1]||null;u&&(u=this._parse(u,t,r,i));return new PatternCS(u);case"I":case"Indexed":u=this._parse(e[1],t,r,i);const y=t.fetchIfRef(e[2])+1,w=t.fetchIfRef(e[3]);return new IndexedCS(u,y,w);case"Separation":case"DeviceN":const S=t.fetchIfRef(e[1]);o=Array.isArray(S)?S.length:1;u=this._parse(e[2],t,r,i);const x=i.create(e[3]);return new AlternateCS(o,u,x);case"Lab":s=t.fetchIfRef(e[1]);d=s.getArray("WhitePoint");f=s.getArray("BlackPoint");const v=s.getArray("Range");return new h(d,f,v);default:throw new n.FormatError("Unimplemented ColorSpace object: ".concat(a))}}throw new n.FormatError("Unrecognized ColorSpace object: ".concat(e))}static isDefaultDecode(e,t){if(!Array.isArray(e))return!0;if(2*t!==e.length){(0,n.warn)("The decode map is not the correct length");return!0}for(let t=0,r=e.length;t<r;t+=2)if(0!==e[t]||1!==e[t+1])return!1;return!0}static get singletons(){return(0,n.shadow)(this,"singletons",{get gray(){return(0,n.shadow)(this,"gray",new DeviceGrayCS)},get rgb(){return(0,n.shadow)(this,"rgb",new DeviceRgbCS)},get cmyk(){return(0,n.shadow)(this,"cmyk",new o)}})}}t.ColorSpace=ColorSpace;class AlternateCS extends ColorSpace{constructor(e,t,r){super("Alternate",e);this.base=t;this.tintFn=r;this.tmpBuf=new Float32Array(t.numComps)}getRgbItem(e,t,r,n){const a=this.tmpBuf;this.tintFn(e,t,a,0);this.base.getRgbItem(a,0,r,n)}getRgbBuffer(e,t,r,n,a,i,s){const o=this.tintFn,c=this.base,l=1/((1<<i)-1),h=c.numComps,u=c.usesZeroToOneRange,d=(c.isPassthrough(8)||!u)&&0===s;let f=d?a:0;const g=d?n:new Uint8ClampedArray(h*r),p=this.numComps,m=new Float32Array(p),b=new Float32Array(h);let y,w;for(y=0;y<r;y++){for(w=0;w<p;w++)m[w]=e[t++]*l;o(m,0,b,0);if(u)for(w=0;w<h;w++)g[f++]=255*b[w];else{c.getRgbItem(b,0,g,f);f+=h}}d||c.getRgbBuffer(g,0,r,n,a,8,s)}getOutputLength(e,t){return this.base.getOutputLength(e*this.base.numComps/this.numComps,t)}}class PatternCS extends ColorSpace{constructor(e){super("Pattern",null);this.base=e}isDefaultDecode(e,t){(0,n.unreachable)("Should not call PatternCS.isDefaultDecode")}}class IndexedCS extends ColorSpace{constructor(e,t,r){super("Indexed",1);this.base=e;this.highVal=t;const a=e.numComps*t;this.lookup=new Uint8Array(a);if(r instanceof i.BaseStream){const e=r.getBytes(a);this.lookup.set(e)}else{if("string"!=typeof r)throw new n.FormatError("IndexedCS - unrecognized lookup table: ".concat(r));for(let e=0;e<a;++e)this.lookup[e]=255&r.charCodeAt(e)}}getRgbItem(e,t,r,n){const a=this.base.numComps,i=e[t]*a;this.base.getRgbBuffer(this.lookup,i,1,r,n,8,0)}getRgbBuffer(e,t,r,n,a,i,s){const o=this.base,c=o.numComps,l=o.getOutputLength(c,s),h=this.lookup;for(let i=0;i<r;++i){const r=e[t++]*c;o.getRgbBuffer(h,r,1,n,a,8,s);a+=l}}getOutputLength(e,t){return this.base.getOutputLength(e*this.base.numComps,t)}isDefaultDecode(e,t){if(!Array.isArray(e))return!0;if(2!==e.length){(0,n.warn)("Decode map length is not correct");return!0}if(!Number.isInteger(t)||t<1){(0,n.warn)("Bits per component is not correct");return!0}return 0===e[0]&&e[1]===(1<<t)-1}}class DeviceGrayCS extends ColorSpace{constructor(){super("DeviceGray",1)}getRgbItem(e,t,r,n){const a=255*e[t];r[n]=r[n+1]=r[n+2]=a}getRgbBuffer(e,t,r,n,a,i,s){const o=255/((1<<i)-1);let c=t,l=a;for(let t=0;t<r;++t){const t=o*e[c++];n[l++]=t;n[l++]=t;n[l++]=t;l+=s}}getOutputLength(e,t){return e*(3+t)}}class DeviceRgbCS extends ColorSpace{constructor(){super("DeviceRGB",3)}getRgbItem(e,t,r,n){r[n]=255*e[t];r[n+1]=255*e[t+1];r[n+2]=255*e[t+2]}getRgbBuffer(e,t,r,n,a,i,s){if(8===i&&0===s){n.set(e.subarray(t,t+3*r),a);return}const o=255/((1<<i)-1);let c=t,l=a;for(let t=0;t<r;++t){n[l++]=o*e[c++];n[l++]=o*e[c++];n[l++]=o*e[c++];l+=s}}getOutputLength(e,t){return e*(3+t)/3|0}isPassthrough(e){return 8===e}}const o=function DeviceCmykCSClosure(){function convertToRgb(e,t,r,n,a){const i=e[t]*r,s=e[t+1]*r,o=e[t+2]*r,c=e[t+3]*r;n[a]=255+i*(-4.387332384609988*i+54.48615194189176*s+18.82290502165302*o+212.25662451639585*c-285.2331026137004)+s*(1.7149763477362134*s-5.6096736904047315*o+-17.873870861415444*c-5.497006427196366)+o*(-2.5217340131683033*o-21.248923337353073*c+17.5119270841813)+c*(-21.86122147463605*c-189.48180835922747);n[a+1]=255+i*(8.841041422036149*i+60.118027045597366*s+6.871425592049007*o+31.159100130055922*c-79.2970844816548)+s*(-15.310361306967817*s+17.575251261109482*o+131.35250912493976*c-190.9453302588951)+o*(4.444339102852739*o+9.8632861493405*c-24.86741582555878)+c*(-20.737325471181034*c-187.80453709719578);n[a+2]=255+i*(.8842522430003296*i+8.078677503112928*s+30.89978309703729*o-.23883238689178934*c-14.183576799673286)+s*(10.49593273432072*s+63.02378494754052*o+50.606957656360734*c-112.23884253719248)+o*(.03296041114873217*o+115.60384449646641*c-193.58209356861505)+c*(-22.33816807309886*c-180.12613974708367)}return class DeviceCmykCS extends ColorSpace{constructor(){super("DeviceCMYK",4)}getRgbItem(e,t,r,n){convertToRgb(e,t,1,r,n)}getRgbBuffer(e,t,r,n,a,i,s){const o=1/((1<<i)-1);for(let i=0;i<r;i++){convertToRgb(e,t,o,n,a);t+=4;a+=3+s}}getOutputLength(e,t){return e/4*(3+t)|0}}}(),c=function CalGrayCSClosure(){function convertToRgb(e,t,r,n,a,i){const s=(t[r]*i)**e.G,o=e.YW*s,c=Math.max(295.8*o**.3333333333333333-40.8,0);n[a]=c;n[a+1]=c;n[a+2]=c}return class CalGrayCS extends ColorSpace{constructor(e,t,r){super("CalGray",1);if(!e)throw new n.FormatError("WhitePoint missing - required for color space CalGray");t=t||[0,0,0];r=r||1;this.XW=e[0];this.YW=e[1];this.ZW=e[2];this.XB=t[0];this.YB=t[1];this.ZB=t[2];this.G=r;if(this.XW<0||this.ZW<0||1!==this.YW)throw new n.FormatError("Invalid WhitePoint components for ".concat(this.name)+", no fallback available");if(this.XB<0||this.YB<0||this.ZB<0){(0,n.info)("Invalid BlackPoint for ".concat(this.name,", falling back to default."));this.XB=this.YB=this.ZB=0}0===this.XB&&0===this.YB&&0===this.ZB||(0,n.warn)("".concat(this.name,", BlackPoint: XB: ").concat(this.XB,", YB: ").concat(this.YB,", ")+"ZB: ".concat(this.ZB,", only default values are supported."));if(this.G<1){(0,n.info)("Invalid Gamma: ".concat(this.G," for ").concat(this.name,", ")+"falling back to default.");this.G=1}}getRgbItem(e,t,r,n){convertToRgb(this,e,t,r,n,1)}getRgbBuffer(e,t,r,n,a,i,s){const o=1/((1<<i)-1);for(let i=0;i<r;++i){convertToRgb(this,e,t,n,a,o);t+=1;a+=3+s}}getOutputLength(e,t){return e*(3+t)}}}(),l=function CalRGBCSClosure(){const e=new Float32Array([.8951,.2664,-.1614,-.7502,1.7135,.0367,.0389,-.0685,1.0296]),t=new Float32Array([.9869929,-.1470543,.1599627,.4323053,.5183603,.0492912,-.0085287,.0400428,.9684867]),r=new Float32Array([3.2404542,-1.5371385,-.4985314,-.969266,1.8760108,.041556,.0556434,-.2040259,1.0572252]),a=new Float32Array([1,1,1]),i=new Float32Array(3),s=new Float32Array(3),o=new Float32Array(3);function matrixProduct(e,t,r){r[0]=e[0]*t[0]+e[1]*t[1]+e[2]*t[2];r[1]=e[3]*t[0]+e[4]*t[1]+e[5]*t[2];r[2]=e[6]*t[0]+e[7]*t[1]+e[8]*t[2]}function sRGBTransferFunction(e){return e<=.0031308?adjustToRange(0,1,12.92*e):e>=.99554525?1:adjustToRange(0,1,1.055*e**(1/2.4)-.055)}function adjustToRange(e,t,r){return Math.max(e,Math.min(t,r))}function decodeL(e){return e<0?-decodeL(-e):e>8?((e+16)/116)**3:.0011070564598794539*e}function convertToRgb(n,c,l,h,u,d){const f=adjustToRange(0,1,c[l]*d),g=adjustToRange(0,1,c[l+1]*d),p=adjustToRange(0,1,c[l+2]*d),m=1===f?1:f**n.GR,b=1===g?1:g**n.GG,y=1===p?1:p**n.GB,w=n.MXA*m+n.MXB*b+n.MXC*y,S=n.MYA*m+n.MYB*b+n.MYC*y,x=n.MZA*m+n.MZB*b+n.MZC*y,v=s;v[0]=w;v[1]=S;v[2]=x;const k=o;!function normalizeWhitePointToFlat(r,n,a){if(1===r[0]&&1===r[2]){a[0]=n[0];a[1]=n[1];a[2]=n[2];return}const s=a;matrixProduct(e,n,s);const o=i;!function convertToFlat(e,t,r){r[0]=1*t[0]/e[0];r[1]=1*t[1]/e[1];r[2]=1*t[2]/e[2]}(r,s,o);matrixProduct(t,o,a)}(n.whitePoint,v,k);const C=s;!function compensateBlackPoint(e,t,r){if(0===e[0]&&0===e[1]&&0===e[2]){r[0]=t[0];r[1]=t[1];r[2]=t[2];return}const n=decodeL(0),a=(1-n)/(1-decodeL(e[0])),i=1-a,s=(1-n)/(1-decodeL(e[1])),o=1-s,c=(1-n)/(1-decodeL(e[2])),l=1-c;r[0]=t[0]*a+i;r[1]=t[1]*s+o;r[2]=t[2]*c+l}(n.blackPoint,k,C);const O=o;!function normalizeWhitePointToD65(r,n,a){const s=a;matrixProduct(e,n,s);const o=i;!function convertToD65(e,t,r){r[0]=.95047*t[0]/e[0];r[1]=1*t[1]/e[1];r[2]=1.08883*t[2]/e[2]}(r,s,o);matrixProduct(t,o,a)}(a,C,O);const T=s;matrixProduct(r,O,T);h[u]=255*sRGBTransferFunction(T[0]);h[u+1]=255*sRGBTransferFunction(T[1]);h[u+2]=255*sRGBTransferFunction(T[2])}return class CalRGBCS extends ColorSpace{constructor(e,t,r,a){super("CalRGB",3);if(!e)throw new n.FormatError("WhitePoint missing - required for color space CalRGB");t=t||new Float32Array(3);r=r||new Float32Array([1,1,1]);a=a||new Float32Array([1,0,0,0,1,0,0,0,1]);const i=e[0],s=e[1],o=e[2];this.whitePoint=e;const c=t[0],l=t[1],h=t[2];this.blackPoint=t;this.GR=r[0];this.GG=r[1];this.GB=r[2];this.MXA=a[0];this.MYA=a[1];this.MZA=a[2];this.MXB=a[3];this.MYB=a[4];this.MZB=a[5];this.MXC=a[6];this.MYC=a[7];this.MZC=a[8];if(i<0||o<0||1!==s)throw new n.FormatError("Invalid WhitePoint components for ".concat(this.name)+", no fallback available");if(c<0||l<0||h<0){(0,n.info)("Invalid BlackPoint for ".concat(this.name," [").concat(c,", ").concat(l,", ").concat(h,"], ")+"falling back to default.");this.blackPoint=new Float32Array(3)}if(this.GR<0||this.GG<0||this.GB<0){(0,n.info)("Invalid Gamma [".concat(this.GR,", ").concat(this.GG,", ").concat(this.GB,"] for ")+"".concat(this.name,", falling back to default."));this.GR=this.GG=this.GB=1}}getRgbItem(e,t,r,n){convertToRgb(this,e,t,r,n,1)}getRgbBuffer(e,t,r,n,a,i,s){const o=1/((1<<i)-1);for(let i=0;i<r;++i){convertToRgb(this,e,t,n,a,o);t+=3;a+=3+s}}getOutputLength(e,t){return e*(3+t)/3|0}}}(),h=function LabCSClosure(){function fn_g(e){let t;t=e>=6/29?e**3:108/841*(e-4/29);return t}function decode(e,t,r,n){return r+e*(n-r)/t}function convertToRgb(e,t,r,n,a,i){let s=t[r],o=t[r+1],c=t[r+2];if(!1!==n){s=decode(s,n,0,100);o=decode(o,n,e.amin,e.amax);c=decode(c,n,e.bmin,e.bmax)}o>e.amax?o=e.amax:o<e.amin&&(o=e.amin);c>e.bmax?c=e.bmax:c<e.bmin&&(c=e.bmin);const l=(s+16)/116,h=l+o/500,u=l-c/200,d=e.XW*fn_g(h),f=e.YW*fn_g(l),g=e.ZW*fn_g(u);let p,m,b;if(e.ZW<1){p=3.1339*d+-1.617*f+-.4906*g;m=-.9785*d+1.916*f+.0333*g;b=.072*d+-.229*f+1.4057*g}else{p=3.2406*d+-1.5372*f+-.4986*g;m=-.9689*d+1.8758*f+.0415*g;b=.0557*d+-.204*f+1.057*g}a[i]=255*Math.sqrt(p);a[i+1]=255*Math.sqrt(m);a[i+2]=255*Math.sqrt(b)}return class LabCS extends ColorSpace{constructor(e,t,r){super("Lab",3);if(!e)throw new n.FormatError("WhitePoint missing - required for color space Lab");t=t||[0,0,0];r=r||[-100,100,-100,100];this.XW=e[0];this.YW=e[1];this.ZW=e[2];this.amin=r[0];this.amax=r[1];this.bmin=r[2];this.bmax=r[3];this.XB=t[0];this.YB=t[1];this.ZB=t[2];if(this.XW<0||this.ZW<0||1!==this.YW)throw new n.FormatError("Invalid WhitePoint components, no fallback available");if(this.XB<0||this.YB<0||this.ZB<0){(0,n.info)("Invalid BlackPoint, falling back to default");this.XB=this.YB=this.ZB=0}if(this.amin>this.amax||this.bmin>this.bmax){(0,n.info)("Invalid Range, falling back to defaults");this.amin=-100;this.amax=100;this.bmin=-100;this.bmax=100}}getRgbItem(e,t,r,n){convertToRgb(this,e,t,!1,r,n)}getRgbBuffer(e,t,r,n,a,i,s){const o=(1<<i)-1;for(let i=0;i<r;i++){convertToRgb(this,e,t,o,n,a);t+=3;a+=3+s}}getOutputLength(e,t){return e*(3+t)/3|0}isDefaultDecode(e,t){return!0}get usesZeroToOneRange(){return(0,n.shadow)(this,"usesZeroToOneRange",!1)}}}()},(e,t,r)=>{r(126)("Uint16",(function(e){return function Uint16Array(t,r,n){return e(this,t,r,n)}}))},(e,t,r)=>{r(126)("Float32",(function(e){return function Float32Array(t,r,n){return e(this,t,r,n)}}))},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.PartialEvaluator=t.EvaluatorPreprocessor=void 0;r(2);r(112);r(125);r(146);r(148);r(149);r(236);r(238);r(227);r(159);r(179);var n=r(158),a=r(239),i=r(209),s=r(260),o=r(226),c=r(228),l=r(263),h=r(230),u=r(272),d=r(220),f=r(264),g=r(273),p=r(240),m=r(276),b=r(218),y=r(217),w=r(277),S=r(234),x=r(242),v=r(229),k=r(213),C=r(267),O=r(278),T=r(279),M=r(280);const E=Object.freeze({maxImageSize:-1,disableFontFace:!1,ignoreErrors:!1,isEvalSupported:!0,fontExtraProperties:!1,useSystemFonts:!0,cMapUrl:null,standardFontDataUrl:null}),D=1,N=2,R=Promise.resolve();function normalizeBlendMode(e){let t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(Array.isArray(e)){for(let t=0,r=e.length;t<r;t++){const r=normalizeBlendMode(e[t],!0);if(r)return r}(0,n.warn)("Unsupported blend mode Array: ".concat(e));return"source-over"}if(!(e instanceof i.Name))return t?null:"source-over";switch(e.name){case"Normal":case"Compatible":return"source-over";case"Multiply":return"multiply";case"Screen":return"screen";case"Overlay":return"overlay";case"Darken":return"darken";case"Lighten":return"lighten";case"ColorDodge":return"color-dodge";case"ColorBurn":return"color-burn";case"HardLight":return"hard-light";case"SoftLight":return"soft-light";case"Difference":return"difference";case"Exclusion":return"exclusion";case"Hue":return"hue";case"Saturation":return"saturation";case"Color":return"color";case"Luminosity":return"luminosity"}if(t)return null;(0,n.warn)("Unsupported blend mode: ".concat(e.name));return"source-over"}function incrementCachedImageMaskCount(e){e.fn===n.OPS.paintImageMaskXObject&&e.args[0]&&e.args[0].count>0&&e.args[0].count++}class TimeSlotManager{static get TIME_SLOT_DURATION_MS(){return(0,n.shadow)(this,"TIME_SLOT_DURATION_MS",20)}static get CHECK_TIME_EVERY(){return(0,n.shadow)(this,"CHECK_TIME_EVERY",100)}constructor(){this.reset()}check(){if(++this.checked<TimeSlotManager.CHECK_TIME_EVERY)return!1;this.checked=0;return this.endTime<=Date.now()}reset(){this.endTime=Date.now()+TimeSlotManager.TIME_SLOT_DURATION_MS;this.checked=0}}class PartialEvaluator{constructor(e){let{xref:t,handler:r,pageIndex:n,idFactory:a,fontCache:i,builtInCMapCache:s,standardFontDataCache:o,globalImageCache:c,options:l=null}=e;this.xref=t;this.handler=r;this.pageIndex=n;this.idFactory=a;this.fontCache=i;this.builtInCMapCache=s;this.standardFontDataCache=o;this.globalImageCache=c;this.options=l||E;this.parsingType3Font=!1;this._fetchBuiltInCMapBound=this.fetchBuiltInCMap.bind(this)}get _pdfFunctionFactory(){const e=new g.PDFFunctionFactory({xref:this.xref,isEvalSupported:this.options.isEvalSupported});return(0,n.shadow)(this,"_pdfFunctionFactory",e)}clone(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;const t=Object.create(this);t.options=Object.assign(Object.create(null),this.options,e);return t}hasBlendModes(e,t){if(!(e instanceof i.Dict))return!1;if(e.objId&&t.has(e.objId))return!1;const r=new i.RefSet(t);e.objId&&r.put(e.objId);const a=[e],s=this.xref;for(;a.length;){const e=a.shift(),t=e.get("ExtGState");if(t instanceof i.Dict)for(let e of t.getRawValues()){if(e instanceof i.Ref){if(r.has(e))continue;try{e=s.fetch(e)}catch(t){r.put(e);(0,n.info)('hasBlendModes - ignoring ExtGState: "'.concat(t,'".'));continue}}if(!(e instanceof i.Dict))continue;e.objId&&r.put(e.objId);const t=e.get("BM");if(t instanceof i.Name){if("Normal"!==t.name)return!0}else if(void 0!==t&&Array.isArray(t))for(const e of t)if(e instanceof i.Name&&"Normal"!==e.name)return!0}const o=e.get("XObject");if(o instanceof i.Dict)for(let e of o.getRawValues()){if(e instanceof i.Ref){if(r.has(e))continue;try{e=s.fetch(e)}catch(t){r.put(e);(0,n.info)('hasBlendModes - ignoring XObject: "'.concat(t,'".'));continue}}if(!(e instanceof y.BaseStream))continue;e.dict.objId&&r.put(e.dict.objId);const t=e.dict.get("Resources");if(t instanceof i.Dict&&(!t.objId||!r.has(t.objId))){a.push(t);t.objId&&r.put(t.objId)}}}for(const e of r)t.put(e);return!1}async fetchBuiltInCMap(e){var t;const r=this.builtInCMapCache.get(e);if(r)return r;let a,i=this.options.cMapUrl;"Function"===(null===(t=i)||void 0===t?void 0:t.constructor.name)&&(i=i());if(null!==i){const t="".concat(i).concat(e,".bcmap"),r=await fetch(t);if(!r.ok)throw new Error('fetchBuiltInCMap: failed to fetch file "'.concat(t,'" with "').concat(r.statusText,'".'));a={cMapData:new Uint8Array(await r.arrayBuffer()),compressionType:n.CMapCompressionType.BINARY}}else a=await this.handler.sendWithPromise("FetchBuiltInCMap",{name:e});a.compressionType!==n.CMapCompressionType.NONE&&this.builtInCMapCache.set(e,a);return a}async fetchStandardFontData(e){const t=this.standardFontDataCache.get(e);if(t)return new b.Stream(t);if(this.options.useSystemFonts&&"Symbol"!==e&&"ZapfDingbats"!==e)return null;const r=(0,l.getFontNameToFileMap)()[e];let a;if(null!==this.options.standardFontDataUrl){const e="".concat(this.options.standardFontDataUrl).concat(r),t=await fetch(e);t.ok?a=await t.arrayBuffer():(0,n.warn)('fetchStandardFontData: failed to fetch file "'.concat(e,'" with "').concat(t.statusText,'".'))}else try{a=await this.handler.sendWithPromise("FetchStandardFontData",{filename:r})}catch(e){(0,n.warn)('fetchStandardFontData: failed to fetch file "'.concat(r,'" with "').concat(e,'".'))}if(!a)return null;this.standardFontDataCache.set(e,a);return new b.Stream(a)}async buildFormXObject(e,t,r,a,s,o,c){const l=t.dict,h=l.getArray("Matrix");let u,d,f=l.getArray("BBox");f=Array.isArray(f)&&4===f.length?n.Util.normalizeRect(f):null;l.has("OC")&&(u=await this.parseMarkedContentProps(l.get("OC"),e));void 0!==u&&a.addOp(n.OPS.beginMarkedContentProps,["OC",u]);const g=l.get("Group");if(g){d={matrix:h,bbox:f,smask:r,isolated:!1,knockout:!1};const t=g.get("S");let s=null;if((0,i.isName)(t,"Transparency")){d.isolated=g.get("I")||!1;d.knockout=g.get("K")||!1;if(g.has("CS")){const t=g.getRaw("CS"),r=S.ColorSpace.getCached(t,this.xref,c);s=r||await this.parseColorSpace({cs:t,resources:e,localColorSpaceCache:c})}}if(r&&r.backdrop){s=s||S.ColorSpace.singletons.rgb;r.backdrop=s.getRgb(r.backdrop,0)}a.addOp(n.OPS.beginGroup,[d])}const p=g?[h,null]:[h,f];a.addOp(n.OPS.paintFormXObjectBegin,p);return this.getOperatorList({stream:t,task:s,resources:l.get("Resources")||e,operatorList:a,initialState:o}).then((function(){a.addOp(n.OPS.paintFormXObjectEnd,[]);g&&a.addOp(n.OPS.endGroup,[d]);void 0!==u&&a.addOp(n.OPS.endMarkedContent,[])}))}_sendImgData(e,t){let r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];const n=t?[t.bitmap||t.data.buffer]:null;return this.parsingType3Font||r?this.handler.send("commonobj",[e,"Image",t],n):this.handler.send("obj",[e,this.pageIndex,"Image",t],n)}async buildPaintImageXObject(e){let{resources:t,image:r,isInline:a=!1,operatorList:i,cacheKey:s,localImageCache:o,localColorSpaceCache:c}=e;const l=r.dict,h=l.objId,u=l.get("W","Width"),d=l.get("H","Height");if(!u||"number"!=typeof u||!d||"number"!=typeof d){(0,n.warn)("Image dimensions are missing, or not numbers.");return}const f=this.options.maxImageSize;if(-1!==f&&u*d>f){const e="Image exceeded maximum allowed size and was removed.";if(this.options.ignoreErrors){(0,n.warn)(e);return}throw new Error(e)}let g;l.has("OC")&&(g=await this.parseMarkedContentProps(l.get("OC"),t));let p,m;if(l.get("IM","ImageMask")||!1){const e=l.get("I","Interpolate"),t=u+7>>3,a=r.getBytes(t*d),c=l.getArray("D","Decode");if(this.parsingType3Font){p=M.PDFImage.createRawMask({imgArray:a,width:u,height:d,imageIsFromDecodeStream:r instanceof x.DecodeStream,inverseDecode:!!c&&c[0]>0,interpolate:e});p.cached=!!s;m=[p];i.addImageOps(n.OPS.paintImageMaskXObject,m,g);s&&o.set(s,h,{fn:n.OPS.paintImageMaskXObject,args:m,optionalContent:g});return}p=M.PDFImage.createMask({imgArray:a,width:u,height:d,imageIsFromDecodeStream:r instanceof x.DecodeStream,inverseDecode:!!c&&c[0]>0,interpolate:e});if(p.isSingleOpaquePixel){i.addImageOps(n.OPS.paintSolidColorImageMask,[],g);s&&o.set(s,h,{fn:n.OPS.paintSolidColorImageMask,args:[],optionalContent:g});return}const f="mask_".concat(this.idFactory.createObjId());i.addDependency(f);this._sendImgData(f,p);m=[{data:f,width:p.width,height:p.height,interpolate:p.interpolate,count:1}];i.addImageOps(n.OPS.paintImageMaskXObject,m,g);s&&o.set(s,h,{fn:n.OPS.paintImageMaskXObject,args:m,optionalContent:g});return}const b=l.get("SM","SMask")||!1,y=l.get("Mask")||!1;if(a&&!b&&!y&&u+d<200){const e=new M.PDFImage({xref:this.xref,res:t,image:r,isInline:a,pdfFunctionFactory:this._pdfFunctionFactory,localColorSpaceCache:c});p=e.createImageData(!0);i.addImageOps(n.OPS.paintInlineImageXObject,[p],g);return}let w="img_".concat(this.idFactory.createObjId()),S=!1;if(this.parsingType3Font)w="".concat(this.idFactory.getDocId(),"_type3_").concat(w);else if(h){S=this.globalImageCache.shouldCache(h,this.pageIndex);S&&(w="".concat(this.idFactory.getDocId(),"_").concat(w))}i.addDependency(w);m=[w,u,d];M.PDFImage.buildImage({xref:this.xref,res:t,image:r,isInline:a,pdfFunctionFactory:this._pdfFunctionFactory,localColorSpaceCache:c}).then((e=>{p=e.createImageData(!1);s&&h&&S&&this.globalImageCache.addByteSize(h,p.data.length);return this._sendImgData(w,p,S)})).catch((e=>{(0,n.warn)('Unable to decode image "'.concat(w,'": "').concat(e,'".'));return this._sendImgData(w,null,S)}));i.addImageOps(n.OPS.paintImageXObject,m,g);if(s){o.set(s,h,{fn:n.OPS.paintImageXObject,args:m,optionalContent:g});if(h){(0,n.assert)(!a,"Cannot cache an inline image globally.");this.globalImageCache.addPageIndex(h,this.pageIndex);S&&this.globalImageCache.setData(h,{objId:w,fn:n.OPS.paintImageXObject,args:m,optionalContent:g,byteSize:0})}}}handleSMask(e,t,r,n,a,i){const s=e.get("G"),o={subtype:e.get("S").name,backdrop:e.get("BC")},c=e.get("TR");if((0,g.isPDFFunction)(c)){const e=this._pdfFunctionFactory.create(c),t=new Uint8Array(256),r=new Float32Array(1);for(let n=0;n<256;n++){r[0]=n/255;e(r,0,r,0);t[n]=255*r[0]|0}o.transferMap=t}return this.buildFormXObject(t,s,o,r,n,a.state.clone(),i)}handleTransferFunction(e){let t;if(Array.isArray(e))t=e;else{if(!(0,g.isPDFFunction)(e))return null;t=[e]}const r=[];let n=0,a=0;for(const e of t){const t=this.xref.fetchIfRef(e);n++;if((0,i.isName)(t,"Identity")){r.push(null);continue}if(!(0,g.isPDFFunction)(t))return null;const s=this._pdfFunctionFactory.create(t),o=new Uint8Array(256),c=new Float32Array(1);for(let e=0;e<256;e++){c[0]=e/255;s(c,0,c,0);o[e]=255*c[0]|0}r.push(o);a++}return 1!==n&&4!==n||0===a?null:r}handleTilingType(e,t,r,a,s,o,c,l){const h=new T.OperatorList,d=i.Dict.merge({xref:this.xref,dictArray:[s.get("Resources"),r]});return this.getOperatorList({stream:a,task:c,resources:d,operatorList:h}).then((function(){const r=h.getIR(),n=(0,u.getTilingPatternIR)(r,s,t);o.addDependencies(h.dependencies);o.addOp(e,n);s.objId&&l.set(null,s.objId,{operatorListIR:r,dict:s})})).catch((e=>{if(!(e instanceof n.AbortException)){if(!this.options.ignoreErrors)throw e;this.handler.send("UnsupportedFeature",{featureId:n.UNSUPPORTED_FEATURES.errorTilingPattern});(0,n.warn)('handleTilingType - ignoring pattern: "'.concat(e,'".'))}}))}handleSetFont(e,t,r,a,o,c){let l=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,h=arguments.length>7&&void 0!==arguments[7]?arguments[7]:null;const u=t&&t[0]instanceof i.Name?t[0].name:null;return this.loadFont(u,r,e,l,h).then((t=>t.font.isType3Font?t.loadType3Data(this,e,o).then((function(){a.addDependencies(t.type3Dependencies);return t})).catch((e=>{this.handler.send("UnsupportedFeature",{featureId:n.UNSUPPORTED_FEATURES.errorFontLoadType3});return new TranslatedFont({loadedName:"g_font_error",font:new s.ErrorFont("Type3 font load error: ".concat(e)),dict:t.font,evaluatorOptions:this.options})})):t)).then((e=>{c.font=e.font;e.send(this.handler);return e.loadedName}))}handleText(e,t){const r=t.font,a=r.charsToGlyphs(e);if(r.data){(!!(t.textRenderingMode&n.TextRenderingMode.ADD_TO_PATH_FLAG)||"Pattern"===t.fillColorSpace.name||r.disableFontFace||this.options.disableFontFace)&&PartialEvaluator.buildFontPaths(r,a,this.handler,this.options)}return a}ensureStateFont(e){if(e.font)return;const t=new n.FormatError("Missing setFont (Tf) operator before text rendering operator.");if(!this.options.ignoreErrors)throw t;this.handler.send("UnsupportedFeature",{featureId:n.UNSUPPORTED_FEATURES.errorFontState});(0,n.warn)('ensureStateFont: "'.concat(t,'".'))}async setGState(e){let{resources:t,gState:r,operatorList:a,cacheKey:s,task:o,stateManager:c,localGStateCache:l,localColorSpaceCache:h}=e;const u=r.objId;let d=!0;const f=[],g=r.getKeys();let p=Promise.resolve();for(let e=0,s=g.length;e<s;e++){const s=g[e],l=r.get(s);switch(s){case"Type":break;case"LW":case"LC":case"LJ":case"ML":case"D":case"RI":case"FL":case"CA":case"ca":f.push([s,l]);break;case"Font":d=!1;p=p.then((()=>this.handleSetFont(t,null,l[0],a,o,c.state).then((function(e){a.addDependency(e);f.push([s,[e,l[1]]])}))));break;case"BM":f.push([s,normalizeBlendMode(l)]);break;case"SMask":if((0,i.isName)(l,"None")){f.push([s,!1]);break}if(l instanceof i.Dict){d=!1;p=p.then((()=>this.handleSMask(l,t,a,o,c,h)));f.push([s,!0])}else(0,n.warn)("Unsupported SMask type");break;case"TR":const e=this.handleTransferFunction(l);f.push([s,e]);break;case"OP":case"op":case"OPM":case"BG":case"BG2":case"UCR":case"UCR2":case"TR2":case"HT":case"SM":case"SA":case"AIS":case"TK":(0,n.info)("graphic state operator "+s);break;default:(0,n.info)("Unknown graphic state operator "+s)}}return p.then((function(){f.length>0&&a.addOp(n.OPS.setGState,[f]);d&&l.set(s,u,f)}))}loadFont(e,t,r){let a=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,c=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;const errorFont=async()=>new TranslatedFont({loadedName:"g_font_error",font:new s.ErrorFont('Font "'.concat(e,'" is not available.')),dict:t,evaluatorOptions:this.options}),l=this.xref;let h;if(t){if(!(t instanceof i.Ref))throw new n.FormatError('The "font" object should be a reference.');h=t}else{const t=r.get("Font");t&&(h=t.getRaw(e))}if(!h){const r='Font "'.concat(e||t&&t.toString(),'" is not available');if(!this.options.ignoreErrors&&!this.parsingType3Font){(0,n.warn)("".concat(r,"."));return errorFont()}this.handler.send("UnsupportedFeature",{featureId:n.UNSUPPORTED_FEATURES.errorFontMissing});(0,n.warn)("".concat(r," -- attempting to fallback to a default font."));h=a||PartialEvaluator.fallbackFontDict}if(this.parsingType3Font&&this.type3FontRefs.has(h))return errorFont();if(this.fontCache.has(h))return this.fontCache.get(h);if(!((t=l.fetchIfRef(h))instanceof i.Dict))return errorFont();if(t.cacheKey&&this.fontCache.has(t.cacheKey))return this.fontCache.get(t.cacheKey);const u=(0,n.createPromiseCapability)();let d;try{d=this.preEvaluateFont(t);d.cssFontInfo=c}catch(e){(0,n.warn)('loadFont - preEvaluateFont failed: "'.concat(e,'".'));return errorFont()}const{descriptor:f,hash:g}=d,p=h instanceof i.Ref;let m;p&&(m="f".concat(h.toString()));if(g&&f instanceof i.Dict){f.fontAliases||(f.fontAliases=Object.create(null));const e=f.fontAliases;if(e[g]){const t=e[g].aliasRef;if(p&&t&&this.fontCache.has(t)){this.fontCache.putAlias(h,t);return this.fontCache.get(h)}}else e[g]={fontID:this.idFactory.createFontId()};p&&(e[g].aliasRef=h);m=e[g].fontID}if(p)this.fontCache.put(h,u.promise);else{m||(m=this.idFactory.createFontId());t.cacheKey="cacheKey_".concat(m);this.fontCache.put(t.cacheKey,u.promise)}(0,n.assert)(m&&m.startsWith("f"),'The "fontID" must be (correctly) defined.');t.loadedName="".concat(this.idFactory.getDocId(),"_").concat(m);this.translateFont(d).then((e=>{void 0!==e.fontType&&l.stats.addFontType(e.fontType);u.resolve(new TranslatedFont({loadedName:t.loadedName,font:e,dict:t,evaluatorOptions:this.options}))})).catch((e=>{this.handler.send("UnsupportedFeature",{featureId:n.UNSUPPORTED_FEATURES.errorFontTranslate});(0,n.warn)('loadFont - translateFont failed: "'.concat(e,'".'));try{const e=f&&f.get("FontFile3"),t=e&&e.get("Subtype"),r=(0,o.getFontType)(d.type,t&&t.name);void 0!==r&&l.stats.addFontType(r)}catch(e){}u.resolve(new TranslatedFont({loadedName:t.loadedName,font:new s.ErrorFont(e instanceof Error?e.message:e),dict:t,evaluatorOptions:this.options}))}));return u.promise}buildPath(e,t,r){let a=arguments.length>3&&void 0!==arguments[3]&&arguments[3];const i=e.length-1;r||(r=[]);let s;if(i<0||e.fnArray[i]!==n.OPS.constructPath){if(a){(0,n.warn)('Encountered path operator "'.concat(t,'" inside of a text object.'));e.addOp(n.OPS.save,null)}s=[1/0,-1/0,1/0,-1/0];e.addOp(n.OPS.constructPath,[[t],r,s]);a&&e.addOp(n.OPS.restore,null)}else{const n=e.argsArray[i];n[0].push(t);Array.prototype.push.apply(n[1],r);s=n[2]}switch(t){case n.OPS.rectangle:s[0]=Math.min(s[0],r[0],r[0]+r[2]);s[1]=Math.max(s[1],r[0],r[0]+r[2]);s[2]=Math.min(s[2],r[1],r[1]+r[3]);s[3]=Math.max(s[3],r[1],r[1]+r[3]);break;case n.OPS.moveTo:case n.OPS.lineTo:s[0]=Math.min(s[0],r[0]);s[1]=Math.max(s[1],r[0]);s[2]=Math.min(s[2],r[1]);s[3]=Math.max(s[3],r[1])}}parseColorSpace(e){let{cs:t,resources:r,localColorSpaceCache:a}=e;return S.ColorSpace.parseAsync({cs:t,xref:this.xref,resources:r,pdfFunctionFactory:this._pdfFunctionFactory,localColorSpaceCache:a}).catch((e=>{if(e instanceof n.AbortException)return null;if(this.options.ignoreErrors){this.handler.send("UnsupportedFeature",{featureId:n.UNSUPPORTED_FEATURES.errorColorSpace});(0,n.warn)('parseColorSpace - ignoring ColorSpace: "'.concat(e,'".'));return null}throw e}))}parseShading(e){let{shading:t,resources:r,localColorSpaceCache:n,localShadingPatternCache:a}=e,i=a.get(t);if(!i){const e=u.Pattern.parseShading(t,this.xref,r,this.handler,this._pdfFunctionFactory,n).getIR();i="pattern_".concat(this.idFactory.createObjId());a.set(t,i);this.handler.send("obj",[i,this.pageIndex,"Pattern",e])}return i}handleColorN(e,t,r,a,s,o,c,l,h,d){const f=r.pop();if(f instanceof i.Name){const g=s.getRaw(f.name),p=g instanceof i.Ref&&h.getByRef(g);if(p)try{const n=a.base?a.base.getRgb(r,0):null,i=(0,u.getTilingPatternIR)(p.operatorListIR,p.dict,n);e.addOp(t,i);return}catch(e){}const m=this.xref.fetchIfRef(g);if(m){const i=m instanceof y.BaseStream?m.dict:m,s=i.get("PatternType");if(s===D){const n=a.base?a.base.getRgb(r,0):null;return this.handleTilingType(t,n,o,m,i,e,c,h)}if(s===N){const r=i.get("Shading"),n=i.getArray("Matrix"),a=this.parseShading({shading:r,resources:o,localColorSpaceCache:l,localShadingPatternCache:d});e.addOp(t,["Shading",a,n]);return}throw new n.FormatError("Unknown PatternType: ".concat(s))}}throw new n.FormatError("Unknown PatternName: ".concat(f))}_parseVisibilityExpression(e,t,r){if(++t>10){(0,n.warn)("Visibility expression is too deeply nested");return}const a=e.length,s=this.xref.fetchIfRef(e[0]);if(!(a<2)&&s instanceof i.Name){switch(s.name){case"And":case"Or":case"Not":r.push(s.name);break;default:(0,n.warn)("Invalid operator ".concat(s.name," in visibility expression"));return}for(let n=1;n<a;n++){const a=e[n],s=this.xref.fetchIfRef(a);if(Array.isArray(s)){const e=[];r.push(e);this._parseVisibilityExpression(s,t,e)}else a instanceof i.Ref&&r.push(a.toString())}}else(0,n.warn)("Invalid visibility expression")}async parseMarkedContentProps(e,t){let r;if(e instanceof i.Name){r=t.get("Properties").get(e.name)}else{if(!(e instanceof i.Dict))throw new n.FormatError("Optional content properties malformed.");r=e}const a=r.get("Type").name;if("OCG"===a)return{type:a,id:r.objId};if("OCMD"===a){const e=r.get("VE");if(Array.isArray(e)){const t=[];this._parseVisibilityExpression(e,0,t);if(t.length>0)return{type:"OCMD",expression:t}}const t=r.get("OCGs");if(Array.isArray(t)||t instanceof i.Dict){const e=[];if(Array.isArray(t))for(const r of t)e.push(r.toString());else e.push(t.objId);return{type:a,ids:e,policy:r.get("P")instanceof i.Name?r.get("P").name:null,expression:null}}if(t instanceof i.Ref)return{type:a,id:t.toString()}}return null}getOperatorList(e){let{stream:t,task:r,resources:a,operatorList:s,initialState:o=null,fallbackFontDict:c=null}=e;a=a||i.Dict.empty;o=o||new EvalState;if(!s)throw new Error('getOperatorList: missing "operatorList" parameter');const l=this,h=this.xref;let u=!1;const d=new m.LocalImageCache,f=new m.LocalColorSpaceCache,g=new m.LocalGStateCache,p=new m.LocalTilingPatternCache,b=new Map,w=a.get("XObject")||i.Dict.empty,x=a.get("Pattern")||i.Dict.empty,v=new StateManager(o),k=new EvaluatorPreprocessor(t,h,v),C=new TimeSlotManager;function closePendingRestoreOPS(e){for(let e=0,t=k.savedStatesDepth;e<t;e++)s.addOp(n.OPS.restore,[])}return new Promise((function promiseBody(e,t){const next=function(r){Promise.all([r,s.ready]).then((function(){try{promiseBody(e,t)}catch(e){t(e)}}),t)};r.ensureNotTerminated();C.reset();const o={};let m,O,T,M,E,D;for(;!(m=C.check());){o.args=null;if(!k.read(o))break;let e=o.args,t=o.fn;switch(0|t){case n.OPS.paintXObject:D=e[0]instanceof i.Name;E=e[0].name;if(D){const t=d.getByName(E);if(t){s.addImageOps(t.fn,t.args,t.optionalContent);incrementCachedImageMaskCount(t);e=null;continue}}next(new Promise((function(e,t){if(!D)throw new n.FormatError("XObject must be referred to by name.");let o=w.getRaw(E);if(o instanceof i.Ref){const t=d.getByRef(o);if(t){s.addImageOps(t.fn,t.args,t.optionalContent);incrementCachedImageMaskCount(t);e();return}const r=l.globalImageCache.getData(o,l.pageIndex);if(r){s.addDependency(r.objId);s.addImageOps(r.fn,r.args,r.optionalContent);e();return}o=h.fetch(o)}if(!(o instanceof y.BaseStream))throw new n.FormatError("XObject should be a stream");const c=o.dict.get("Subtype");if(!(c instanceof i.Name))throw new n.FormatError("XObject should have a Name subtype");if("Form"!==c.name)if("Image"!==c.name){if("PS"!==c.name)throw new n.FormatError("Unhandled XObject subtype ".concat(c.name));(0,n.info)("Ignored XObject subtype PS");e()}else l.buildPaintImageXObject({resources:a,image:o,operatorList:s,cacheKey:E,localImageCache:d,localColorSpaceCache:f}).then(e,t);else{v.save();l.buildFormXObject(a,o,null,s,r,v.state.clone(),f).then((function(){v.restore();e()}),t)}})).catch((function(e){if(!(e instanceof n.AbortException)){if(!l.options.ignoreErrors)throw e;l.handler.send("UnsupportedFeature",{featureId:n.UNSUPPORTED_FEATURES.errorXObject});(0,n.warn)('getOperatorList - ignoring XObject: "'.concat(e,'".'))}})));return;case n.OPS.setFont:var N=e[1];next(l.handleSetFont(a,e,null,s,r,v.state,c).then((function(e){s.addDependency(e);s.addOp(n.OPS.setFont,[e,N])})));return;case n.OPS.beginText:u=!0;break;case n.OPS.endText:u=!1;break;case n.OPS.endInlineImage:var L=e[0].cacheKey;if(L){const t=d.getByName(L);if(t){s.addImageOps(t.fn,t.args,t.optionalContent);incrementCachedImageMaskCount(t);e=null;continue}}next(l.buildPaintImageXObject({resources:a,image:e[0],isInline:!0,operatorList:s,cacheKey:L,localImageCache:d,localColorSpaceCache:f}));return;case n.OPS.showText:if(!v.state.font){l.ensureStateFont(v.state);continue}e[0]=l.handleText(e[0],v.state);break;case n.OPS.showSpacedText:if(!v.state.font){l.ensureStateFont(v.state);continue}var j=e[0],_=[],U=j.length,$=v.state;for(O=0;O<U;++O){const e=j[O];"string"==typeof e?Array.prototype.push.apply(_,l.handleText(e,$)):"number"==typeof e&&_.push(e)}e[0]=_;t=n.OPS.showText;break;case n.OPS.nextLineShowText:if(!v.state.font){l.ensureStateFont(v.state);continue}s.addOp(n.OPS.nextLine);e[0]=l.handleText(e[0],v.state);t=n.OPS.showText;break;case n.OPS.nextLineSetSpacingShowText:if(!v.state.font){l.ensureStateFont(v.state);continue}s.addOp(n.OPS.nextLine);s.addOp(n.OPS.setWordSpacing,[e.shift()]);s.addOp(n.OPS.setCharSpacing,[e.shift()]);e[0]=l.handleText(e[0],v.state);t=n.OPS.showText;break;case n.OPS.setTextRenderingMode:v.state.textRenderingMode=e[0];break;case n.OPS.setFillColorSpace:{const t=S.ColorSpace.getCached(e[0],h,f);if(t){v.state.fillColorSpace=t;continue}next(l.parseColorSpace({cs:e[0],resources:a,localColorSpaceCache:f}).then((function(e){e&&(v.state.fillColorSpace=e)})));return}case n.OPS.setStrokeColorSpace:{const t=S.ColorSpace.getCached(e[0],h,f);if(t){v.state.strokeColorSpace=t;continue}next(l.parseColorSpace({cs:e[0],resources:a,localColorSpaceCache:f}).then((function(e){e&&(v.state.strokeColorSpace=e)})));return}case n.OPS.setFillColor:M=v.state.fillColorSpace;e=M.getRgb(e,0);t=n.OPS.setFillRGBColor;break;case n.OPS.setStrokeColor:M=v.state.strokeColorSpace;e=M.getRgb(e,0);t=n.OPS.setStrokeRGBColor;break;case n.OPS.setFillGray:v.state.fillColorSpace=S.ColorSpace.singletons.gray;e=S.ColorSpace.singletons.gray.getRgb(e,0);t=n.OPS.setFillRGBColor;break;case n.OPS.setStrokeGray:v.state.strokeColorSpace=S.ColorSpace.singletons.gray;e=S.ColorSpace.singletons.gray.getRgb(e,0);t=n.OPS.setStrokeRGBColor;break;case n.OPS.setFillCMYKColor:v.state.fillColorSpace=S.ColorSpace.singletons.cmyk;e=S.ColorSpace.singletons.cmyk.getRgb(e,0);t=n.OPS.setFillRGBColor;break;case n.OPS.setStrokeCMYKColor:v.state.strokeColorSpace=S.ColorSpace.singletons.cmyk;e=S.ColorSpace.singletons.cmyk.getRgb(e,0);t=n.OPS.setStrokeRGBColor;break;case n.OPS.setFillRGBColor:v.state.fillColorSpace=S.ColorSpace.singletons.rgb;e=S.ColorSpace.singletons.rgb.getRgb(e,0);break;case n.OPS.setStrokeRGBColor:v.state.strokeColorSpace=S.ColorSpace.singletons.rgb;e=S.ColorSpace.singletons.rgb.getRgb(e,0);break;case n.OPS.setFillColorN:M=v.state.fillColorSpace;if("Pattern"===M.name){next(l.handleColorN(s,n.OPS.setFillColorN,e,M,x,a,r,f,p,b));return}e=M.getRgb(e,0);t=n.OPS.setFillRGBColor;break;case n.OPS.setStrokeColorN:M=v.state.strokeColorSpace;if("Pattern"===M.name){next(l.handleColorN(s,n.OPS.setStrokeColorN,e,M,x,a,r,f,p,b));return}e=M.getRgb(e,0);t=n.OPS.setStrokeRGBColor;break;case n.OPS.shadingFill:var X=a.get("Shading");if(!X)throw new n.FormatError("No shading resource found");var H=X.get(e[0].name);if(!H)throw new n.FormatError("No shading object found");e=[l.parseShading({shading:H,resources:a,localColorSpaceCache:f,localShadingPatternCache:b})];t=n.OPS.shadingFill;break;case n.OPS.setGState:D=e[0]instanceof i.Name;E=e[0].name;if(D){const t=g.getByName(E);if(t){t.length>0&&s.addOp(n.OPS.setGState,[t]);e=null;continue}}next(new Promise((function(e,t){if(!D)throw new n.FormatError("GState must be referred to by name.");const o=a.get("ExtGState");if(!(o instanceof i.Dict))throw new n.FormatError("ExtGState should be a dictionary.");const c=o.get(E);if(!(c instanceof i.Dict))throw new n.FormatError("GState should be a dictionary.");l.setGState({resources:a,gState:c,operatorList:s,cacheKey:E,task:r,stateManager:v,localGStateCache:g,localColorSpaceCache:f}).then(e,t)})).catch((function(e){if(!(e instanceof n.AbortException)){if(!l.options.ignoreErrors)throw e;l.handler.send("UnsupportedFeature",{featureId:n.UNSUPPORTED_FEATURES.errorExtGState});(0,n.warn)('getOperatorList - ignoring ExtGState: "'.concat(e,'".'))}})));return;case n.OPS.moveTo:case n.OPS.lineTo:case n.OPS.curveTo:case n.OPS.curveTo2:case n.OPS.curveTo3:case n.OPS.closePath:case n.OPS.rectangle:l.buildPath(s,t,e,u);continue;case n.OPS.markPoint:case n.OPS.markPointProps:case n.OPS.beginCompat:case n.OPS.endCompat:continue;case n.OPS.beginMarkedContentProps:if(!(e[0]instanceof i.Name)){(0,n.warn)("Expected name for beginMarkedContentProps arg0=".concat(e[0]));continue}if("OC"===e[0].name){next(l.parseMarkedContentProps(e[1],a).then((e=>{s.addOp(n.OPS.beginMarkedContentProps,["OC",e])})).catch((e=>{if(!(e instanceof n.AbortException)){if(!l.options.ignoreErrors)throw e;l.handler.send("UnsupportedFeature",{featureId:n.UNSUPPORTED_FEATURES.errorMarkedContent});(0,n.warn)('getOperatorList - ignoring beginMarkedContentProps: "'.concat(e,'".'))}})));return}e=[e[0].name,e[1]instanceof i.Dict?e[1].get("MCID"):null];break;case n.OPS.beginMarkedContent:case n.OPS.endMarkedContent:default:if(null!==e){for(O=0,T=e.length;O<T&&!(e[O]instanceof i.Dict);O++);if(O<T){(0,n.warn)("getOperatorList - ignoring operator: "+t);continue}}}s.addOp(t,e)}if(m)next(R);else{closePendingRestoreOPS();e()}})).catch((e=>{if(!(e instanceof n.AbortException)){if(!this.options.ignoreErrors)throw e;this.handler.send("UnsupportedFeature",{featureId:n.UNSUPPORTED_FEATURES.errorOperatorList});(0,n.warn)('getOperatorList - ignoring errors during "'.concat(r.name,'" ')+'task: "'.concat(e,'".'));closePendingRestoreOPS()}}))}getTextContent(e){let{stream:t,task:r,resources:a,stateManager:s=null,combineTextItems:o=!1,includeMarkedContent:c=!1,sink:l,seenStyles:u=new Set,viewBox:d}=e;a=a||i.Dict.empty;s=s||new StateManager(new TextState);const f=(0,h.getNormalizedUnicodes)(),g={items:[],styles:Object.create(null)},p={initialized:!1,str:[],totalWidth:0,totalHeight:0,width:0,height:0,vertical:!1,prevTransform:null,textAdvanceScale:0,spaceInFlowMin:0,spaceInFlowMax:0,trackingSpaceMin:1/0,negativeSpaceMax:-1/0,notASpace:-1/0,transform:null,fontName:null,hasEOL:!1},b=[" "," "];let S=0;function saveLastChar(e){const t=(S+1)%2,r=" "!==b[S]&&" "===b[t];b[S]=e;S=t;return r}function resetLastChars(){b[0]=b[1]=" ";S=0}const x=this,v=this.xref,k=[];let C=null;const O=new m.LocalImageCache,T=new m.LocalGStateCache,M=new EvaluatorPreprocessor(t,v,s);let E;function getCurrentTextTransform(){const e=E.font,t=[E.fontSize*E.textHScale,0,0,E.fontSize,0,E.textRise];if(e.isType3Font&&(E.fontSize<=1||e.isCharBBox)&&!(0,n.isArrayEqual)(E.fontMatrix,n.FONT_IDENTITY_MATRIX)){const r=e.bbox[3]-e.bbox[1];r>0&&(t[3]*=r*E.fontMatrix[3])}return n.Util.transform(E.ctm,n.Util.transform(E.textMatrix,t))}function ensureTextContentItem(){if(p.initialized)return p;const e=E.font,t=e.loadedName;if(!u.has(t)){u.add(t);g.styles[t]={fontFamily:e.fallbackName,ascent:e.ascent,descent:e.descent,vertical:e.vertical}}p.fontName=t;const r=p.transform=getCurrentTextTransform();if(e.vertical){p.width=p.totalWidth=Math.hypot(r[0],r[1]);p.height=p.totalHeight=0;p.vertical=!0}else{p.width=p.totalWidth=0;p.height=p.totalHeight=Math.hypot(r[2],r[3]);p.vertical=!1}const n=Math.hypot(E.textLineMatrix[0],E.textLineMatrix[1]),a=Math.hypot(E.ctm[0],E.ctm[1]);p.textAdvanceScale=a*n;p.trackingSpaceMin=.1*E.fontSize;p.notASpace=.03*E.fontSize;p.negativeSpaceMax=-.2*E.fontSize;p.spaceInFlowMin=.1*E.fontSize;p.spaceInFlowMax=.6*E.fontSize;p.hasEOL=!1;p.initialized=!0;return p}function updateAdvanceScale(){if(!p.initialized)return;const e=Math.hypot(E.textLineMatrix[0],E.textLineMatrix[1]),t=Math.hypot(E.ctm[0],E.ctm[1])*e;if(t!==p.textAdvanceScale){if(p.vertical){p.totalHeight+=p.height*p.textAdvanceScale;p.height=0}else{p.totalWidth+=p.width*p.textAdvanceScale;p.width=0}p.textAdvanceScale=t}}function handleSetFont(e,t){return x.loadFont(e,t,a).then((function(e){return e.font.isType3Font?e.loadType3Data(x,a,r).catch((function(){})).then((function(){return e})):e})).then((function(e){E.font=e.font;E.fontMatrix=e.font.fontMatrix||n.FONT_IDENTITY_MATRIX}))}function applyInverseRotation(e,t,r){const n=Math.hypot(r[0],r[1]);return[(r[0]*e+r[1]*t)/n,(r[2]*e+r[3]*t)/n]}function compareWithLastPosition(){const e=getCurrentTextTransform();let t=e[4],r=e[5];const n=t-d[0],a=r-d[1];if(n<0||n>d[2]||a<0||a>d[3])return!1;if(!o||!E.font||!p.prevTransform)return!0;let i=p.prevTransform[4],s=p.prevTransform[5];if(i===t&&s===r)return!0;let c=-1;e[0]&&0===e[1]&&0===e[2]?c=e[0]>0?0:180:e[1]&&0===e[0]&&0===e[3]&&(c=e[1]>0?90:270);switch(c){case 0:break;case 90:[t,r]=[r,t];[i,s]=[s,i];break;case 180:[t,r,i,s]=[-t,-r,-i,-s];break;case 270:[t,r]=[-r,-t];[i,s]=[-s,-i];break;default:[t,r]=applyInverseRotation(t,r,e);[i,s]=applyInverseRotation(i,s,p.prevTransform)}if(E.font.vertical){const e=(s-r)/p.textAdvanceScale,n=t-i,a=Math.sign(p.height);if(e<a*p.negativeSpaceMax){if(Math.abs(n)>.5*p.width){appendEOL();return!0}resetLastChars();flushTextContentItem();return!0}if(Math.abs(n)>p.width){appendEOL();return!0}e<=a*p.notASpace&&resetLastChars();if(e<=a*p.trackingSpaceMin)p.height+=e;else if(!addFakeSpaces(e,p.prevTransform,a))if(0===p.str.length){resetLastChars();g.items.push({str:" ",dir:"ltr",width:0,height:Math.abs(e),transform:p.prevTransform,fontName:p.fontName,hasEOL:!1})}else p.height+=e;return!0}const l=(t-i)/p.textAdvanceScale,h=r-s,u=Math.sign(p.width);if(l<u*p.negativeSpaceMax){if(Math.abs(h)>.5*p.height){appendEOL();return!0}resetLastChars();flushTextContentItem();return!0}if(Math.abs(h)>p.height){appendEOL();return!0}l<=u*p.notASpace&&resetLastChars();if(l<=u*p.trackingSpaceMin)p.width+=l;else if(!addFakeSpaces(l,p.prevTransform,u))if(0===p.str.length){resetLastChars();g.items.push({str:" ",dir:"ltr",width:Math.abs(l),height:0,transform:p.prevTransform,fontName:p.fontName,hasEOL:!1})}else p.width+=l;return!0}function buildTextContentItem(e){let{chars:t,extraSpacing:r}=e;const n=E.font;if(!t){const e=E.charSpacing+r;e&&(n.vertical?E.translateTextMatrix(0,-e):E.translateTextMatrix(e*E.textHScale,0));return}const a=n.charsToGlyphs(t),i=E.fontMatrix[0]*E.fontSize;for(let e=0,t=a.length;e<t;e++){const s=a[e];if(s.isInvisibleFormatMark)continue;let o=E.charSpacing+(e+1===t?r:0),c=s.width;n.vertical&&(c=s.vmetric?s.vmetric[0]:-c);let l=c*i;if(s.isWhitespace){if(n.vertical){o+=-l+E.wordSpacing;E.translateTextMatrix(0,-o)}else{o+=l+E.wordSpacing;E.translateTextMatrix(o*E.textHScale,0)}saveLastChar(" ");continue}if(!compareWithLastPosition())continue;const u=ensureTextContentItem();s.isZeroWidthDiacritic&&(l=0);if(n.vertical){E.translateTextMatrix(0,l);l=Math.abs(l);u.height+=l}else{l*=E.textHScale;E.translateTextMatrix(l,0);u.width+=l}l&&(u.prevTransform=getCurrentTextTransform());let d=s.unicode;d=f[d]||d;d=(0,h.reverseIfRtl)(d);saveLastChar(d)&&u.str.push(" ");u.str.push(d);o&&(n.vertical?E.translateTextMatrix(0,-o):E.translateTextMatrix(o*E.textHScale,0))}}function appendEOL(){resetLastChars();if(p.initialized){p.hasEOL=!0;flushTextContentItem()}else g.items.push({str:"",dir:"ltr",width:0,height:0,transform:getCurrentTextTransform(),fontName:E.font.loadedName,hasEOL:!0})}function addFakeSpaces(e,t,r){if(r*p.spaceInFlowMin<=e&&e<=r*p.spaceInFlowMax){if(p.initialized){resetLastChars();p.str.push(" ")}return!1}const n=p.fontName;let a=0;if(p.vertical){a=e;e=0}flushTextContentItem();resetLastChars();g.items.push({str:" ",dir:"ltr",width:Math.abs(e),height:Math.abs(a),transform:t||getCurrentTextTransform(),fontName:n,hasEOL:!1});return!0}function flushTextContentItem(){if(p.initialized&&p.str){p.vertical?p.totalHeight+=p.height*p.textAdvanceScale:p.totalWidth+=p.width*p.textAdvanceScale;g.items.push(function runBidiTransform(e){const t=e.str.join(""),r=(0,w.bidi)(t,-1,e.vertical);return{str:r.str,dir:r.dir,width:Math.abs(e.totalWidth),height:Math.abs(e.totalHeight),transform:e.transform,fontName:e.fontName,hasEOL:e.hasEOL}}(p));p.initialized=!1;p.str.length=0}}function enqueueChunk(){let e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];const t=g.items.length;if(0!==t&&!(e&&t<10)){l.enqueue(g,t);g.items=[];g.styles=Object.create(null)}}const D=new TimeSlotManager;return new Promise((function promiseBody(e,t){const next=function(r){enqueueChunk(!0);Promise.all([r,l.ready]).then((function(){try{promiseBody(e,t)}catch(e){t(e)}}),t)};r.ensureNotTerminated();D.reset();const h={};let f,p=[];for(;!(f=D.check());){p.length=0;h.args=p;if(!M.read(h))break;E=s.state;const e=h.fn;p=h.args;switch(0|e){case n.OPS.setFont:var m=p[0].name,b=p[1];if(E.font&&m===E.fontName&&b===E.fontSize)break;flushTextContentItem();E.fontName=m;E.fontSize=b;next(handleSetFont(m,null));return;case n.OPS.setTextRise:E.textRise=p[0];break;case n.OPS.setHScale:E.textHScale=p[0]/100;break;case n.OPS.setLeading:E.leading=p[0];break;case n.OPS.moveText:E.translateTextLineMatrix(p[0],p[1]);E.textMatrix=E.textLineMatrix.slice();break;case n.OPS.setLeadingMoveText:E.leading=-p[1];E.translateTextLineMatrix(p[0],p[1]);E.textMatrix=E.textLineMatrix.slice();break;case n.OPS.nextLine:E.carriageReturn();break;case n.OPS.setTextMatrix:E.setTextMatrix(p[0],p[1],p[2],p[3],p[4],p[5]);E.setTextLineMatrix(p[0],p[1],p[2],p[3],p[4],p[5]);updateAdvanceScale();break;case n.OPS.setCharSpacing:E.charSpacing=p[0];break;case n.OPS.setWordSpacing:E.wordSpacing=p[0];break;case n.OPS.beginText:E.textMatrix=n.IDENTITY_MATRIX.slice();E.textLineMatrix=n.IDENTITY_MATRIX.slice();break;case n.OPS.showSpacedText:if(!s.state.font){x.ensureStateFont(s.state);continue}const e=(E.font.vertical?1:-1)*E.fontSize/1e3,t=p[0];for(let r=0,n=t.length;r<n-1;r++){const n=t[r];if("string"==typeof n)k.push(n);else if("number"==typeof n&&0!==n){const t=k.join("");k.length=0;buildTextContentItem({chars:t,extraSpacing:n*e})}}const h=t.at(-1);"string"==typeof h&&k.push(h);if(k.length>0){const e=k.join("");k.length=0;buildTextContentItem({chars:e,extraSpacing:0})}break;case n.OPS.showText:if(!s.state.font){x.ensureStateFont(s.state);continue}buildTextContentItem({chars:p[0],extraSpacing:0});break;case n.OPS.nextLineShowText:if(!s.state.font){x.ensureStateFont(s.state);continue}E.carriageReturn();buildTextContentItem({chars:p[0],extraSpacing:0});break;case n.OPS.nextLineSetSpacingShowText:if(!s.state.font){x.ensureStateFont(s.state);continue}E.wordSpacing=p[0];E.charSpacing=p[1];E.carriageReturn();buildTextContentItem({chars:p[2],extraSpacing:0});break;case n.OPS.paintXObject:flushTextContentItem();C||(C=a.get("XObject")||i.Dict.empty);var w=p[0]instanceof i.Name,S=p[0].name;if(w&&O.getByName(S))break;next(new Promise((function(e,t){if(!w)throw new n.FormatError("XObject must be referred to by name.");let h=C.getRaw(S);if(h instanceof i.Ref){if(O.getByRef(h)){e();return}if(x.globalImageCache.getData(h,x.pageIndex)){e();return}h=v.fetch(h)}if(!(h instanceof y.BaseStream))throw new n.FormatError("XObject should be a stream");const f=h.dict.get("Subtype");if(!(f instanceof i.Name))throw new n.FormatError("XObject should have a Name subtype");if("Form"!==f.name){O.set(S,h.dict.objId,!0);e();return}const g=s.state.clone(),p=new StateManager(g),m=h.dict.getArray("Matrix");Array.isArray(m)&&6===m.length&&p.transform(m);enqueueChunk();const b={enqueueInvoked:!1,enqueue(e,t){this.enqueueInvoked=!0;l.enqueue(e,t)},get desiredSize(){return l.desiredSize},get ready(){return l.ready}};x.getTextContent({stream:h,task:r,resources:h.dict.get("Resources")||a,stateManager:p,combineTextItems:o,includeMarkedContent:c,sink:b,seenStyles:u,viewBox:d}).then((function(){b.enqueueInvoked||O.set(S,h.dict.objId,!0);e()}),t)})).catch((function(e){if(!(e instanceof n.AbortException)){if(!x.options.ignoreErrors)throw e;(0,n.warn)('getTextContent - ignoring XObject: "'.concat(e,'".'))}})));return;case n.OPS.setGState:w=p[0]instanceof i.Name;S=p[0].name;if(w&&T.getByName(S))break;next(new Promise((function(e,t){if(!w)throw new n.FormatError("GState must be referred to by name.");const r=a.get("ExtGState");if(!(r instanceof i.Dict))throw new n.FormatError("ExtGState should be a dictionary.");const s=r.get(S);if(!(s instanceof i.Dict))throw new n.FormatError("GState should be a dictionary.");const o=s.get("Font");if(o){flushTextContentItem();E.fontName=null;E.fontSize=o[1];handleSetFont(null,o[0]).then(e,t)}else{T.set(S,s.objId,!0);e()}})).catch((function(e){if(!(e instanceof n.AbortException)){if(!x.options.ignoreErrors)throw e;(0,n.warn)('getTextContent - ignoring ExtGState: "'.concat(e,'".'))}})));return;case n.OPS.beginMarkedContent:c&&g.items.push({type:"beginMarkedContent",tag:p[0]instanceof i.Name?p[0].name:null});break;case n.OPS.beginMarkedContentProps:if(c){flushTextContentItem();let e=null;p[1]instanceof i.Dict&&(e=p[1].get("MCID"));g.items.push({type:"beginMarkedContentProps",id:Number.isInteger(e)?"".concat(x.idFactory.getPageObjId(),"_mcid").concat(e):null,tag:p[0]instanceof i.Name?p[0].name:null})}break;case n.OPS.endMarkedContent:if(c){flushTextContentItem();g.items.push({type:"endMarkedContent"})}}if(g.items.length>=l.desiredSize){f=!0;break}}if(f)next(R);else{flushTextContentItem();enqueueChunk();e()}})).catch((e=>{if(!(e instanceof n.AbortException)){if(!this.options.ignoreErrors)throw e;(0,n.warn)('getTextContent - ignoring errors during "'.concat(r.name,'" ')+'task: "'.concat(e,'".'));flushTextContentItem();enqueueChunk()}}))}extractDataStructures(e,t,r){const a=this.xref;let s;const l=this.readToUnicode(r.toUnicode||e.get("ToUnicode")||t.get("ToUnicode"));if(r.composite){const t=e.get("CIDSystemInfo");t instanceof i.Dict&&(r.cidSystemInfo={registry:(0,n.stringToPDFString)(t.get("Registry")),ordering:(0,n.stringToPDFString)(t.get("Ordering")),supplement:t.get("Supplement")});const a=e.get("CIDToGIDMap");a instanceof y.BaseStream&&(s=a.getBytes())}const h=[];let u,d=null;if(e.has("Encoding")){u=e.get("Encoding");if(u instanceof i.Dict){d=u.get("BaseEncoding");d=d instanceof i.Name?d.name:null;if(u.has("Differences")){const e=u.get("Differences");let t=0;for(let r=0,s=e.length;r<s;r++){const s=a.fetchIfRef(e[r]);if("number"==typeof s)t=s;else{if(!(s instanceof i.Name))throw new n.FormatError("Invalid entry in 'Differences' array: ".concat(s));h[t++]=s.name}}}}else if(u instanceof i.Name)d=u.name;else{const e="Encoding is not a Name nor a Dict";if(!this.options.ignoreErrors)throw new n.FormatError(e);(0,n.warn)(e)}"MacRomanEncoding"!==d&&"MacExpertEncoding"!==d&&"WinAnsiEncoding"!==d&&(d=null)}if(d)r.defaultEncoding=(0,c.getEncoding)(d);else{const e=!!(r.flags&o.FontFlags.Symbolic),t=!!(r.flags&o.FontFlags.Nonsymbolic);u=c.StandardEncoding;"TrueType"!==r.type||t||(u=c.WinAnsiEncoding);if(e){u=c.MacRomanEncoding;r.file&&!r.isInternalFont||(/Symbol/i.test(r.name)?u=c.SymbolSetEncoding:/Dingbats|Wingdings/i.test(r.name)&&(u=c.ZapfDingbatsEncoding))}r.defaultEncoding=u}r.differences=h;r.baseEncodingName=d;r.hasEncoding=!!d||h.length>0;r.dict=e;return l.then((e=>{r.toUnicode=e;return this.buildToUnicode(r)})).then((e=>{r.toUnicode=e;s&&(r.cidToGidMap=this.readCidToGidMap(s,e));return r}))}_simpleFontToUnicode(e){let t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];(0,n.assert)(!e.composite,"Must be a simple font.");const r=[],a=e.defaultEncoding.slice(),i=e.baseEncodingName,s=e.differences;for(const e in s){const t=s[e];".notdef"!==t&&(a[e]=t)}const o=(0,v.getGlyphsUnicode)();for(const n in a){let s=a[n];if(""!==s)if(void 0!==o[s])r[n]=String.fromCharCode(o[s]);else{let a=0;switch(s[0]){case"G":3===s.length&&(a=parseInt(s.substring(1),16));break;case"g":5===s.length&&(a=parseInt(s.substring(1),16));break;case"C":case"c":if(s.length>=3&&s.length<=4){const r=s.substring(1);if(t){a=parseInt(r,16);break}a=+r;if(Number.isNaN(a)&&Number.isInteger(parseInt(r,16)))return this._simpleFontToUnicode(e,!0)}break;default:const r=(0,h.getUnicodeForGlyph)(s,o);-1!==r&&(a=r)}if(a>0&&a<=1114111&&Number.isInteger(a)){if(i&&a===+n){const e=(0,c.getEncoding)(i);if(e&&(s=e[n])){r[n]=String.fromCharCode(o[s]);continue}}r[n]=String.fromCodePoint(a)}}}return r}async buildToUnicode(e){e.hasIncludedToUnicodeMap=!!e.toUnicode&&e.toUnicode.length>0;if(e.hasIncludedToUnicodeMap){!e.composite&&e.hasEncoding&&(e.fallbackToUnicode=this._simpleFontToUnicode(e));return e.toUnicode}if(!e.composite)return new f.ToUnicodeMap(this._simpleFontToUnicode(e));if(e.composite&&(e.cMap.builtInCMap&&!(e.cMap instanceof a.IdentityCMap)||"Adobe"===e.cidSystemInfo.registry&&("GB1"===e.cidSystemInfo.ordering||"CNS1"===e.cidSystemInfo.ordering||"Japan1"===e.cidSystemInfo.ordering||"Korea1"===e.cidSystemInfo.ordering))){const{registry:t,ordering:r}=e.cidSystemInfo,s=i.Name.get("".concat(t,"-").concat(r,"-UCS2")),o=await a.CMapFactory.create({encoding:s,fetchBuiltInCMap:this._fetchBuiltInCMapBound,useCMap:null}),c=[];e.cMap.forEach((function(e,t){if(t>65535)throw new n.FormatError("Max size of CID is 65,535");const r=o.lookup(t);r&&(c[e]=String.fromCharCode((r.charCodeAt(0)<<8)+r.charCodeAt(1)))}));return new f.ToUnicodeMap(c)}return new f.IdentityToUnicodeMap(e.firstChar,e.lastChar)}readToUnicode(e){return e?e instanceof i.Name?a.CMapFactory.create({encoding:e,fetchBuiltInCMap:this._fetchBuiltInCMapBound,useCMap:null}).then((function(e){return e instanceof a.IdentityCMap?new f.IdentityToUnicodeMap(0,65535):new f.ToUnicodeMap(e.getMap())})):e instanceof y.BaseStream?a.CMapFactory.create({encoding:e,fetchBuiltInCMap:this._fetchBuiltInCMapBound,useCMap:null}).then((function(e){if(e instanceof a.IdentityCMap)return new f.IdentityToUnicodeMap(0,65535);const t=new Array(e.length);e.forEach((function(e,r){if("number"==typeof r){t[e]=String.fromCodePoint(r);return}const n=[];for(let e=0;e<r.length;e+=2){const t=r.charCodeAt(e)<<8|r.charCodeAt(e+1);if(55296!=(63488&t)){n.push(t);continue}e+=2;const a=r.charCodeAt(e)<<8|r.charCodeAt(e+1);n.push(((1023&t)<<10)+(1023&a)+65536)}t[e]=String.fromCodePoint.apply(String,n)}));return new f.ToUnicodeMap(t)}),(e=>{if(e instanceof n.AbortException)return null;if(this.options.ignoreErrors){this.handler.send("UnsupportedFeature",{featureId:n.UNSUPPORTED_FEATURES.errorFontToUnicode});(0,n.warn)('readToUnicode - ignoring ToUnicode data: "'.concat(e,'".'));return null}throw e})):Promise.resolve(null):Promise.resolve(null)}readCidToGidMap(e,t){const r=[];for(let n=0,a=e.length;n<a;n++){const a=e[n++]<<8|e[n],i=n>>1;(0!==a||t.has(i))&&(r[i]=a)}return r}extractWidths(e,t,r){const n=this.xref;let a=[],s=0;const c=[];let l,h,u,d,f,g,p,m;if(r.composite){s=e.has("DW")?e.get("DW"):1e3;m=e.get("W");if(m)for(h=0,u=m.length;h<u;h++){g=n.fetchIfRef(m[h++]);p=n.fetchIfRef(m[h]);if(Array.isArray(p))for(d=0,f=p.length;d<f;d++)a[g++]=n.fetchIfRef(p[d]);else{const e=n.fetchIfRef(m[++h]);for(d=g;d<=p;d++)a[d]=e}}if(r.vertical){let t=e.getArray("DW2")||[880,-1e3];l=[t[1],.5*s,t[0]];t=e.get("W2");if(t)for(h=0,u=t.length;h<u;h++){g=n.fetchIfRef(t[h++]);p=n.fetchIfRef(t[h]);if(Array.isArray(p))for(d=0,f=p.length;d<f;d++)c[g++]=[n.fetchIfRef(p[d++]),n.fetchIfRef(p[d++]),n.fetchIfRef(p[d])];else{const e=[n.fetchIfRef(t[++h]),n.fetchIfRef(t[++h]),n.fetchIfRef(t[++h])];for(d=g;d<=p;d++)c[d]=e}}}}else{const o=r.firstChar;m=e.get("Widths");if(m){d=o;for(h=0,u=m.length;h<u;h++)a[d++]=n.fetchIfRef(m[h]);s=parseFloat(t.get("MissingWidth"))||0}else{const t=e.get("BaseFont");if(t instanceof i.Name){const e=this.getBaseFontMetrics(t.name);a=this.buildCharCodeToWidth(e.widths,r);s=e.defaultWidth}}}let b=!0,y=s;for(const e in a){const t=a[e];if(t)if(y){if(y!==t){b=!1;break}}else y=t}b&&(r.flags|=o.FontFlags.FixedPitch);r.defaultWidth=s;r.widths=a;r.defaultVMetrics=l;r.vmetrics=c}isSerifFont(e){const t=e.split("-")[0];return t in(0,l.getSerifFonts)()||-1!==t.search(/serif/gi)}getBaseFontMetrics(e){let t=0,r=Object.create(null),n=!1;let a=(0,l.getStdFontMap)()[e]||e;const i=(0,C.getMetrics)();a in i||(a=this.isSerifFont(e)?"Times-Roman":"Helvetica");const s=i[a];if("number"==typeof s){t=s;n=!0}else r=s();return{defaultWidth:t,monospace:n,widths:r}}buildCharCodeToWidth(e,t){const r=Object.create(null),n=t.differences,a=t.defaultEncoding;for(let t=0;t<256;t++)t in n&&e[n[t]]?r[t]=e[n[t]]:t in a&&e[a[t]]&&(r[t]=e[a[t]]);return r}preEvaluateFont(e){const t=e;let r=e.get("Subtype");if(!(r instanceof i.Name))throw new n.FormatError("invalid font Subtype");let a,s,o=!1;if("Type0"===r.name){const t=e.get("DescendantFonts");if(!t)throw new n.FormatError("Descendant fonts are not specified");if(!((e=Array.isArray(t)?this.xref.fetchIfRef(t[0]):t)instanceof i.Dict))throw new n.FormatError("Descendant font is not a dictionary.");r=e.get("Subtype");if(!(r instanceof i.Name))throw new n.FormatError("invalid font Subtype");o=!0}const c=e.get("FirstChar")||0,l=e.get("LastChar")||(o?65535:255),h=e.get("FontDescriptor");if(h){a=new O.MurmurHash3_64;const r=t.getRaw("Encoding");if(r instanceof i.Name)a.update(r.name);else if(r instanceof i.Ref)a.update(r.toString());else if(r instanceof i.Dict)for(const e of r.getRawValues())if(e instanceof i.Name)a.update(e.name);else if(e instanceof i.Ref)a.update(e.toString());else if(Array.isArray(e)){const t=e.length,r=new Array(t);for(let n=0;n<t;n++){const t=e[n];t instanceof i.Name?r[n]=t.name:("number"==typeof t||t instanceof i.Ref)&&(r[n]=t.toString())}a.update(r.join())}a.update("".concat(c,"-").concat(l));s=e.get("ToUnicode")||t.get("ToUnicode");if(s instanceof y.BaseStream){const e=s.str||s,t=e.buffer?new Uint8Array(e.buffer.buffer,0,e.bufferLength):new Uint8Array(e.bytes.buffer,e.start,e.end-e.start);a.update(t)}else s instanceof i.Name&&a.update(s.name);const n=e.get("Widths")||t.get("Widths");if(Array.isArray(n)){const e=[];for(const t of n)("number"==typeof t||t instanceof i.Ref)&&e.push(t.toString());a.update(e.join())}if(o){a.update("compositeFont");const r=e.get("W")||t.get("W");if(Array.isArray(r)){const e=[];for(const t of r)if("number"==typeof t||t instanceof i.Ref)e.push(t.toString());else if(Array.isArray(t)){const r=[];for(const e of t)("number"==typeof e||e instanceof i.Ref)&&r.push(e.toString());e.push("[".concat(r.join(),"]"))}a.update(e.join())}const n=e.getRaw("CIDToGIDMap")||t.getRaw("CIDToGIDMap");n instanceof i.Name?a.update(n.name):n instanceof i.Ref?a.update(n.toString()):n instanceof y.BaseStream&&a.update(n.peekBytes())}}return{descriptor:h,dict:e,baseDict:t,composite:o,type:r.name,firstChar:c,lastChar:l,toUnicode:s,hash:a?a.hexdigest():""}}async translateFont(e){let{descriptor:t,dict:r,baseDict:c,composite:h,type:u,firstChar:f,lastChar:g,toUnicode:p,cssFontInfo:m}=e;const y="Type3"===u;let w;if(!t){if(!y){let e=r.get("BaseFont");if(!(e instanceof i.Name))throw new n.FormatError("Base font is not specified");e=e.name.replace(/[,_]/g,"-");const t=this.getBaseFontMetrics(e),a=e.split("-")[0],h=(this.isSerifFont(a)?o.FontFlags.Serif:0)|(t.monospace?o.FontFlags.FixedPitch:0)|((0,l.getSymbolsFonts)()[a]?o.FontFlags.Symbolic:o.FontFlags.Nonsymbolic);w={type:u,name:e,loadedName:c.loadedName,widths:t.widths,defaultWidth:t.defaultWidth,isSimulatedFlags:!0,flags:h,firstChar:f,lastChar:g,toUnicode:p,xHeight:0,capHeight:0,italicAngle:0,isType3Font:y};const d=r.get("Widths"),m=(0,l.getStandardFontName)(e);let b=null;if(m){w.isStandardFont=!0;b=await this.fetchStandardFontData(m);w.isInternalFont=!!b}return this.extractDataStructures(r,r,w).then((r=>{if(d){const e=[];let t=f;for(let r=0,n=d.length;r<n;r++)e[t++]=this.xref.fetchIfRef(d[r]);r.widths=e}else r.widths=this.buildCharCodeToWidth(t.widths,r);return new s.Font(e,b,r)}))}t=new i.Dict(null);t.set("FontName",i.Name.get(u));t.set("FontBBox",r.getArray("FontBBox")||[0,0,0,0])}let S,x,v,k,C,O=t.get("FontName"),T=r.get("BaseFont");"string"==typeof O&&(O=i.Name.get(O));"string"==typeof T&&(T=i.Name.get(T));if(!y){const e=O&&O.name,t=T&&T.name;if(e!==t){(0,n.info)("The FontDescriptor's FontName is \"".concat(e,'" but ')+"should be the same as the Font's BaseFont \"".concat(t,'".'));e&&t&&t.startsWith(e)&&(O=T)}}O=O||T;if(!(O instanceof i.Name))throw new n.FormatError("invalid font name");try{S=t.get("FontFile","FontFile2","FontFile3")}catch(e){if(!this.options.ignoreErrors)throw e;(0,n.warn)('translateFont - fetching "'.concat(O.name,'" font file: "').concat(e,'".'));S=new b.NullStream}let M=!1,E=!1,D=null;if(S){if(S.dict){const e=S.dict.get("Subtype");e instanceof i.Name&&(x=e.name);v=S.dict.get("Length1");k=S.dict.get("Length2");C=S.dict.get("Length3")}}else if(m){const e=(0,d.getXfaFontName)(O.name);if(e){m.fontFamily="".concat(m.fontFamily,"-PdfJS-XFA");m.metrics=e.metrics||null;D=e.factors||null;S=await this.fetchStandardFontData(e.name);E=!!S;c=r=(0,d.getXfaFontDict)(O.name);h=!0}}else if(!y){const e=(0,l.getStandardFontName)(O.name);if(e){M=!0;S=await this.fetchStandardFontData(e);E=!!S}}w={type:u,name:O.name,subtype:x,file:S,length1:v,length2:k,length3:C,isStandardFont:M,isInternalFont:E,loadedName:c.loadedName,composite:h,fixedPitch:!1,fontMatrix:r.getArray("FontMatrix")||n.FONT_IDENTITY_MATRIX,firstChar:f,lastChar:g,toUnicode:p,bbox:t.getArray("FontBBox")||r.getArray("FontBBox"),ascent:t.get("Ascent"),descent:t.get("Descent"),xHeight:t.get("XHeight")||0,capHeight:t.get("CapHeight")||0,flags:t.get("Flags"),italicAngle:t.get("ItalicAngle")||0,isType3Font:y,cssFontInfo:m,scaleFactors:D};if(h){const e=c.get("Encoding");e instanceof i.Name&&(w.cidEncoding=e.name);const t=await a.CMapFactory.create({encoding:e,fetchBuiltInCMap:this._fetchBuiltInCMapBound,useCMap:null});w.cMap=t;w.vertical=w.cMap.vertical}return this.extractDataStructures(r,c,w).then((e=>{this.extractWidths(r,t,e);return new s.Font(O.name,S,e)}))}static buildFontPaths(e,t,r,a){function buildPath(t){const i="".concat(e.loadedName,"_path_").concat(t);try{if(e.renderer.hasBuiltPath(t))return;r.send("commonobj",[i,"FontPath",e.renderer.getPathJs(t)])}catch(e){if(a.ignoreErrors){r.send("UnsupportedFeature",{featureId:n.UNSUPPORTED_FEATURES.errorFontBuildPath});(0,n.warn)("buildFontPaths - ignoring ".concat(i,' glyph: "').concat(e,'".'));return}throw e}}for(const e of t){buildPath(e.fontChar);const t=e.accent;t&&t.fontChar&&buildPath(t.fontChar)}}static get fallbackFontDict(){const e=new i.Dict;e.set("BaseFont",i.Name.get("PDFJS-FallbackFont"));e.set("Type",i.Name.get("FallbackType"));e.set("Subtype",i.Name.get("FallbackType"));e.set("Encoding",i.Name.get("WinAnsiEncoding"));return(0,n.shadow)(this,"fallbackFontDict",e)}}t.PartialEvaluator=PartialEvaluator;class TranslatedFont{constructor(e){let{loadedName:t,font:r,dict:n,evaluatorOptions:a}=e;this.loadedName=t;this.font=r;this.dict=n;this._evaluatorOptions=a||E;this.type3Loaded=null;this.type3Dependencies=r.isType3Font?new Set:null;this.sent=!1}send(e){if(!this.sent){this.sent=!0;e.send("commonobj",[this.loadedName,"Font",this.font.exportData(this._evaluatorOptions.fontExtraProperties)])}}fallback(e){if(this.font.data){this.font.disableFontFace=!0;PartialEvaluator.buildFontPaths(this.font,this.font.glyphCacheValues,e,this._evaluatorOptions)}}loadType3Data(e,t,r){if(this.type3Loaded)return this.type3Loaded;if(!this.font.isType3Font)throw new Error("Must be a Type3 font.");const a=e.clone({ignoreErrors:!1});a.parsingType3Font=!0;const s=new i.RefSet(e.type3FontRefs);this.dict.objId&&!s.has(this.dict.objId)&&s.put(this.dict.objId);a.type3FontRefs=s;const o=this.font,c=this.type3Dependencies;let l=Promise.resolve();const h=this.dict.get("CharProcs"),u=this.dict.get("Resources")||t,d=Object.create(null),f=!o.bbox||(0,n.isArrayEqual)(o.bbox,[0,0,0,0]);for(const e of h.getKeys())l=l.then((()=>{const t=h.get(e),i=new T.OperatorList;return a.getOperatorList({stream:t,task:r,resources:u,operatorList:i}).then((()=>{i.fnArray[0]===n.OPS.setCharWidthAndBounds&&this._removeType3ColorOperators(i,f);d[e]=i.getIR();for(const e of i.dependencies)c.add(e)})).catch((function(t){(0,n.warn)('Type3 font resource "'.concat(e,'" is not available.'));const r=new T.OperatorList;d[e]=r.getIR()}))}));this.type3Loaded=l.then((()=>{o.charProcOperatorList=d;if(this._bbox){o.isCharBBox=!0;o.bbox=this._bbox}}));return this.type3Loaded}_removeType3ColorOperators(e){let t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];const r=n.Util.normalizeRect(e.argsArray[0].slice(2)),a=r[2]-r[0],i=r[3]-r[1];if(0===a||0===i){e.fnArray.splice(0,1);e.argsArray.splice(0,1)}else if(t){this._bbox||(this._bbox=[1/0,1/0,-1/0,-1/0]);this._bbox[0]=Math.min(this._bbox[0],r[0]);this._bbox[1]=Math.min(this._bbox[1],r[1]);this._bbox[2]=Math.max(this._bbox[2],r[2]);this._bbox[3]=Math.max(this._bbox[3],r[3])}let s=0,o=e.length;for(;s<o;){switch(e.fnArray[s]){case n.OPS.setCharWidthAndBounds:break;case n.OPS.setStrokeColorSpace:case n.OPS.setFillColorSpace:case n.OPS.setStrokeColor:case n.OPS.setStrokeColorN:case n.OPS.setFillColor:case n.OPS.setFillColorN:case n.OPS.setStrokeGray:case n.OPS.setFillGray:case n.OPS.setStrokeRGBColor:case n.OPS.setFillRGBColor:case n.OPS.setStrokeCMYKColor:case n.OPS.setFillCMYKColor:case n.OPS.shadingFill:case n.OPS.setRenderingIntent:e.fnArray.splice(s,1);e.argsArray.splice(s,1);o--;continue;case n.OPS.setGState:const[t]=e.argsArray[s];let r=0,a=t.length;for(;r<a;){const[e]=t[r];switch(e){case"TR":case"TR2":case"HT":case"BG":case"BG2":case"UCR":case"UCR2":t.splice(r,1);a--;continue}r++}}s++}}}class StateManager{constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:new EvalState;this.state=e;this.stateStack=[]}save(){const e=this.state;this.stateStack.push(this.state);this.state=e.clone()}restore(){const e=this.stateStack.pop();e&&(this.state=e)}transform(e){this.state.ctm=n.Util.transform(this.state.ctm,e)}}class TextState{constructor(){this.ctm=new Float32Array(n.IDENTITY_MATRIX);this.fontName=null;this.fontSize=0;this.font=null;this.fontMatrix=n.FONT_IDENTITY_MATRIX;this.textMatrix=n.IDENTITY_MATRIX.slice();this.textLineMatrix=n.IDENTITY_MATRIX.slice();this.charSpacing=0;this.wordSpacing=0;this.leading=0;this.textHScale=1;this.textRise=0}setTextMatrix(e,t,r,n,a,i){const s=this.textMatrix;s[0]=e;s[1]=t;s[2]=r;s[3]=n;s[4]=a;s[5]=i}setTextLineMatrix(e,t,r,n,a,i){const s=this.textLineMatrix;s[0]=e;s[1]=t;s[2]=r;s[3]=n;s[4]=a;s[5]=i}translateTextMatrix(e,t){const r=this.textMatrix;r[4]=r[0]*e+r[2]*t+r[4];r[5]=r[1]*e+r[3]*t+r[5]}translateTextLineMatrix(e,t){const r=this.textLineMatrix;r[4]=r[0]*e+r[2]*t+r[4];r[5]=r[1]*e+r[3]*t+r[5]}carriageReturn(){this.translateTextLineMatrix(0,-this.leading);this.textMatrix=this.textLineMatrix.slice()}clone(){const e=Object.create(this);e.textMatrix=this.textMatrix.slice();e.textLineMatrix=this.textLineMatrix.slice();e.fontMatrix=this.fontMatrix.slice();return e}}class EvalState{constructor(){this.ctm=new Float32Array(n.IDENTITY_MATRIX);this.font=null;this.textRenderingMode=n.TextRenderingMode.FILL;this.fillColorSpace=S.ColorSpace.singletons.gray;this.strokeColorSpace=S.ColorSpace.singletons.gray}clone(){return Object.create(this)}}class EvaluatorPreprocessor{static get opMap(){const e=(0,k.getLookupTableFactory)((function(e){e.w={id:n.OPS.setLineWidth,numArgs:1,variableArgs:!1};e.J={id:n.OPS.setLineCap,numArgs:1,variableArgs:!1};e.j={id:n.OPS.setLineJoin,numArgs:1,variableArgs:!1};e.M={id:n.OPS.setMiterLimit,numArgs:1,variableArgs:!1};e.d={id:n.OPS.setDash,numArgs:2,variableArgs:!1};e.ri={id:n.OPS.setRenderingIntent,numArgs:1,variableArgs:!1};e.i={id:n.OPS.setFlatness,numArgs:1,variableArgs:!1};e.gs={id:n.OPS.setGState,numArgs:1,variableArgs:!1};e.q={id:n.OPS.save,numArgs:0,variableArgs:!1};e.Q={id:n.OPS.restore,numArgs:0,variableArgs:!1};e.cm={id:n.OPS.transform,numArgs:6,variableArgs:!1};e.m={id:n.OPS.moveTo,numArgs:2,variableArgs:!1};e.l={id:n.OPS.lineTo,numArgs:2,variableArgs:!1};e.c={id:n.OPS.curveTo,numArgs:6,variableArgs:!1};e.v={id:n.OPS.curveTo2,numArgs:4,variableArgs:!1};e.y={id:n.OPS.curveTo3,numArgs:4,variableArgs:!1};e.h={id:n.OPS.closePath,numArgs:0,variableArgs:!1};e.re={id:n.OPS.rectangle,numArgs:4,variableArgs:!1};e.S={id:n.OPS.stroke,numArgs:0,variableArgs:!1};e.s={id:n.OPS.closeStroke,numArgs:0,variableArgs:!1};e.f={id:n.OPS.fill,numArgs:0,variableArgs:!1};e.F={id:n.OPS.fill,numArgs:0,variableArgs:!1};e["f*"]={id:n.OPS.eoFill,numArgs:0,variableArgs:!1};e.B={id:n.OPS.fillStroke,numArgs:0,variableArgs:!1};e["B*"]={id:n.OPS.eoFillStroke,numArgs:0,variableArgs:!1};e.b={id:n.OPS.closeFillStroke,numArgs:0,variableArgs:!1};e["b*"]={id:n.OPS.closeEOFillStroke,numArgs:0,variableArgs:!1};e.n={id:n.OPS.endPath,numArgs:0,variableArgs:!1};e.W={id:n.OPS.clip,numArgs:0,variableArgs:!1};e["W*"]={id:n.OPS.eoClip,numArgs:0,variableArgs:!1};e.BT={id:n.OPS.beginText,numArgs:0,variableArgs:!1};e.ET={id:n.OPS.endText,numArgs:0,variableArgs:!1};e.Tc={id:n.OPS.setCharSpacing,numArgs:1,variableArgs:!1};e.Tw={id:n.OPS.setWordSpacing,numArgs:1,variableArgs:!1};e.Tz={id:n.OPS.setHScale,numArgs:1,variableArgs:!1};e.TL={id:n.OPS.setLeading,numArgs:1,variableArgs:!1};e.Tf={id:n.OPS.setFont,numArgs:2,variableArgs:!1};e.Tr={id:n.OPS.setTextRenderingMode,numArgs:1,variableArgs:!1};e.Ts={id:n.OPS.setTextRise,numArgs:1,variableArgs:!1};e.Td={id:n.OPS.moveText,numArgs:2,variableArgs:!1};e.TD={id:n.OPS.setLeadingMoveText,numArgs:2,variableArgs:!1};e.Tm={id:n.OPS.setTextMatrix,numArgs:6,variableArgs:!1};e["T*"]={id:n.OPS.nextLine,numArgs:0,variableArgs:!1};e.Tj={id:n.OPS.showText,numArgs:1,variableArgs:!1};e.TJ={id:n.OPS.showSpacedText,numArgs:1,variableArgs:!1};e["'"]={id:n.OPS.nextLineShowText,numArgs:1,variableArgs:!1};e['"']={id:n.OPS.nextLineSetSpacingShowText,numArgs:3,variableArgs:!1};e.d0={id:n.OPS.setCharWidth,numArgs:2,variableArgs:!1};e.d1={id:n.OPS.setCharWidthAndBounds,numArgs:6,variableArgs:!1};e.CS={id:n.OPS.setStrokeColorSpace,numArgs:1,variableArgs:!1};e.cs={id:n.OPS.setFillColorSpace,numArgs:1,variableArgs:!1};e.SC={id:n.OPS.setStrokeColor,numArgs:4,variableArgs:!0};e.SCN={id:n.OPS.setStrokeColorN,numArgs:33,variableArgs:!0};e.sc={id:n.OPS.setFillColor,numArgs:4,variableArgs:!0};e.scn={id:n.OPS.setFillColorN,numArgs:33,variableArgs:!0};e.G={id:n.OPS.setStrokeGray,numArgs:1,variableArgs:!1};e.g={id:n.OPS.setFillGray,numArgs:1,variableArgs:!1};e.RG={id:n.OPS.setStrokeRGBColor,numArgs:3,variableArgs:!1};e.rg={id:n.OPS.setFillRGBColor,numArgs:3,variableArgs:!1};e.K={id:n.OPS.setStrokeCMYKColor,numArgs:4,variableArgs:!1};e.k={id:n.OPS.setFillCMYKColor,numArgs:4,variableArgs:!1};e.sh={id:n.OPS.shadingFill,numArgs:1,variableArgs:!1};e.BI={id:n.OPS.beginInlineImage,numArgs:0,variableArgs:!1};e.ID={id:n.OPS.beginImageData,numArgs:0,variableArgs:!1};e.EI={id:n.OPS.endInlineImage,numArgs:1,variableArgs:!1};e.Do={id:n.OPS.paintXObject,numArgs:1,variableArgs:!1};e.MP={id:n.OPS.markPoint,numArgs:1,variableArgs:!1};e.DP={id:n.OPS.markPointProps,numArgs:2,variableArgs:!1};e.BMC={id:n.OPS.beginMarkedContent,numArgs:1,variableArgs:!1};e.BDC={id:n.OPS.beginMarkedContentProps,numArgs:2,variableArgs:!1};e.EMC={id:n.OPS.endMarkedContent,numArgs:0,variableArgs:!1};e.BX={id:n.OPS.beginCompat,numArgs:0,variableArgs:!1};e.EX={id:n.OPS.endCompat,numArgs:0,variableArgs:!1};e.BM=null;e.BD=null;e.true=null;e.fa=null;e.fal=null;e.fals=null;e.false=null;e.nu=null;e.nul=null;e.null=null}));return(0,n.shadow)(this,"opMap",e())}static get MAX_INVALID_PATH_OPS(){return(0,n.shadow)(this,"MAX_INVALID_PATH_OPS",10)}constructor(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:new StateManager;this.parser=new p.Parser({lexer:new p.Lexer(e,EvaluatorPreprocessor.opMap),xref:t});this.stateManager=r;this.nonProcessedArgs=[];this._isPathOp=!1;this._numInvalidPathOPS=0}get savedStatesDepth(){return this.stateManager.stateStack.length}read(e){let t=e.args;for(;;){const r=this.parser.getObj();if(r instanceof i.Cmd){const a=r.cmd,i=EvaluatorPreprocessor.opMap[a];if(!i){(0,n.warn)('Unknown command "'.concat(a,'".'));continue}const s=i.id,o=i.numArgs;let c=null!==t?t.length:0;this._isPathOp||(this._numInvalidPathOPS=0);this._isPathOp=s>=n.OPS.moveTo&&s<=n.OPS.endPath;if(i.variableArgs)c>o&&(0,n.info)("Command ".concat(a,": expected [0, ").concat(o,"] args, ")+"but received ".concat(c," args."));else{if(c!==o){const e=this.nonProcessedArgs;for(;c>o;){e.push(t.shift());c--}for(;c<o&&0!==e.length;){null===t&&(t=[]);t.unshift(e.pop());c++}}if(c<o){const e="command ".concat(a,": expected ").concat(o," args, ")+"but received ".concat(c," args.");if(this._isPathOp&&++this._numInvalidPathOPS>EvaluatorPreprocessor.MAX_INVALID_PATH_OPS)throw new n.FormatError("Invalid ".concat(e));(0,n.warn)("Skipping ".concat(e));null!==t&&(t.length=0);continue}}this.preprocessCommand(s,t);e.fn=s;e.args=t;return!0}if(r===i.EOF)return!1;if(null!==r){null===t&&(t=[]);t.push(r);if(t.length>33)throw new n.FormatError("Too many arguments")}}}preprocessCommand(e,t){switch(0|e){case n.OPS.save:this.stateManager.save();break;case n.OPS.restore:this.stateManager.restore();break;case n.OPS.transform:this.stateManager.transform(t)}}}t.EvaluatorPreprocessor=EvaluatorPreprocessor},(e,t,r)=>{var n=r(4),a=Math.hypot,i=Math.abs,s=Math.sqrt;n({target:"Math",stat:!0,arity:2,forced:!!a&&a(1/0,NaN)!==1/0},{hypot:function hypot(e,t){for(var r,n,a=0,o=0,c=arguments.length,l=0;o<c;)if(l<(r=i(arguments[o++]))){a=a*(n=l/r)*n+1;l=r}else a+=r>0?(n=r/l)*n:r;return l===1/0?1/0:l*s(a)}})},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.IdentityCMap=t.CMapFactory=t.CMap=void 0;r(125);r(146);r(148);r(149);r(2);r(212);var n=r(158),a=r(209),i=r(217),s=r(240),o=r(213),c=r(218);const l=["Adobe-GB1-UCS2","Adobe-CNS1-UCS2","Adobe-Japan1-UCS2","Adobe-Korea1-UCS2","78-EUC-H","78-EUC-V","78-H","78-RKSJ-H","78-RKSJ-V","78-V","78ms-RKSJ-H","78ms-RKSJ-V","83pv-RKSJ-H","90ms-RKSJ-H","90ms-RKSJ-V","90msp-RKSJ-H","90msp-RKSJ-V","90pv-RKSJ-H","90pv-RKSJ-V","Add-H","Add-RKSJ-H","Add-RKSJ-V","Add-V","Adobe-CNS1-0","Adobe-CNS1-1","Adobe-CNS1-2","Adobe-CNS1-3","Adobe-CNS1-4","Adobe-CNS1-5","Adobe-CNS1-6","Adobe-GB1-0","Adobe-GB1-1","Adobe-GB1-2","Adobe-GB1-3","Adobe-GB1-4","Adobe-GB1-5","Adobe-Japan1-0","Adobe-Japan1-1","Adobe-Japan1-2","Adobe-Japan1-3","Adobe-Japan1-4","Adobe-Japan1-5","Adobe-Japan1-6","Adobe-Korea1-0","Adobe-Korea1-1","Adobe-Korea1-2","B5-H","B5-V","B5pc-H","B5pc-V","CNS-EUC-H","CNS-EUC-V","CNS1-H","CNS1-V","CNS2-H","CNS2-V","ETHK-B5-H","ETHK-B5-V","ETen-B5-H","ETen-B5-V","ETenms-B5-H","ETenms-B5-V","EUC-H","EUC-V","Ext-H","Ext-RKSJ-H","Ext-RKSJ-V","Ext-V","GB-EUC-H","GB-EUC-V","GB-H","GB-V","GBK-EUC-H","GBK-EUC-V","GBK2K-H","GBK2K-V","GBKp-EUC-H","GBKp-EUC-V","GBT-EUC-H","GBT-EUC-V","GBT-H","GBT-V","GBTpc-EUC-H","GBTpc-EUC-V","GBpc-EUC-H","GBpc-EUC-V","H","HKdla-B5-H","HKdla-B5-V","HKdlb-B5-H","HKdlb-B5-V","HKgccs-B5-H","HKgccs-B5-V","HKm314-B5-H","HKm314-B5-V","HKm471-B5-H","HKm471-B5-V","HKscs-B5-H","HKscs-B5-V","Hankaku","Hiragana","KSC-EUC-H","KSC-EUC-V","KSC-H","KSC-Johab-H","KSC-Johab-V","KSC-V","KSCms-UHC-H","KSCms-UHC-HW-H","KSCms-UHC-HW-V","KSCms-UHC-V","KSCpc-EUC-H","KSCpc-EUC-V","Katakana","NWP-H","NWP-V","RKSJ-H","RKSJ-V","Roman","UniCNS-UCS2-H","UniCNS-UCS2-V","UniCNS-UTF16-H","UniCNS-UTF16-V","UniCNS-UTF32-H","UniCNS-UTF32-V","UniCNS-UTF8-H","UniCNS-UTF8-V","UniGB-UCS2-H","UniGB-UCS2-V","UniGB-UTF16-H","UniGB-UTF16-V","UniGB-UTF32-H","UniGB-UTF32-V","UniGB-UTF8-H","UniGB-UTF8-V","UniJIS-UCS2-H","UniJIS-UCS2-HW-H","UniJIS-UCS2-HW-V","UniJIS-UCS2-V","UniJIS-UTF16-H","UniJIS-UTF16-V","UniJIS-UTF32-H","UniJIS-UTF32-V","UniJIS-UTF8-H","UniJIS-UTF8-V","UniJIS2004-UTF16-H","UniJIS2004-UTF16-V","UniJIS2004-UTF32-H","UniJIS2004-UTF32-V","UniJIS2004-UTF8-H","UniJIS2004-UTF8-V","UniJISPro-UCS2-HW-V","UniJISPro-UCS2-V","UniJISPro-UTF8-V","UniJISX0213-UTF32-H","UniJISX0213-UTF32-V","UniJISX02132004-UTF32-H","UniJISX02132004-UTF32-V","UniKS-UCS2-H","UniKS-UCS2-V","UniKS-UTF16-H","UniKS-UTF16-V","UniKS-UTF32-H","UniKS-UTF32-V","UniKS-UTF8-H","UniKS-UTF8-V","V","WP-Symbol"],h=2**24-1;class CMap{constructor(){let e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];this.codespaceRanges=[[],[],[],[]];this.numCodespaceRanges=0;this._map=[];this.name="";this.vertical=!1;this.useCMap=null;this.builtInCMap=e}addCodespaceRange(e,t,r){this.codespaceRanges[e-1].push(t,r);this.numCodespaceRanges++}mapCidRange(e,t,r){if(t-e>h)throw new Error("mapCidRange - ignoring data above MAX_MAP_RANGE.");for(;e<=t;)this._map[e++]=r++}mapBfRange(e,t,r){if(t-e>h)throw new Error("mapBfRange - ignoring data above MAX_MAP_RANGE.");const n=r.length-1;for(;e<=t;){this._map[e++]=r;const t=r.charCodeAt(n)+1;t>255?r=r.substring(0,n-1)+String.fromCharCode(r.charCodeAt(n-1)+1)+"\0":r=r.substring(0,n)+String.fromCharCode(t)}}mapBfRangeToArray(e,t,r){if(t-e>h)throw new Error("mapBfRangeToArray - ignoring data above MAX_MAP_RANGE.");const n=r.length;let a=0;for(;e<=t&&a<n;){this._map[e]=r[a++];++e}}mapOne(e,t){this._map[e]=t}lookup(e){return this._map[e]}contains(e){return void 0!==this._map[e]}forEach(e){const t=this._map,r=t.length;if(r<=65536)for(let n=0;n<r;n++)void 0!==t[n]&&e(n,t[n]);else for(const r in t)e(r,t[r])}charCodeOf(e){const t=this._map;if(t.length<=65536)return t.indexOf(e);for(const r in t)if(t[r]===e)return 0|r;return-1}getMap(){return this._map}readCharCode(e,t,r){let n=0;const a=this.codespaceRanges;for(let i=0,s=a.length;i<s;i++){n=(n<<8|e.charCodeAt(t+i))>>>0;const s=a[i];for(let e=0,t=s.length;e<t;){const t=s[e++],a=s[e++];if(n>=t&&n<=a){r.charcode=n;r.length=i+1;return}}}r.charcode=0;r.length=1}getCharCodeLength(e){const t=this.codespaceRanges;for(let r=0,n=t.length;r<n;r++){const n=t[r];for(let t=0,a=n.length;t<a;){const a=n[t++],i=n[t++];if(e>=a&&e<=i)return r+1}}return 1}get length(){return this._map.length}get isIdentityCMap(){if("Identity-H"!==this.name&&"Identity-V"!==this.name)return!1;if(65536!==this._map.length)return!1;for(let e=0;e<65536;e++)if(this._map[e]!==e)return!1;return!0}}t.CMap=CMap;class IdentityCMap extends CMap{constructor(e,t){super();this.vertical=e;this.addCodespaceRange(t,0,65535)}mapCidRange(e,t,r){(0,n.unreachable)("should not call mapCidRange")}mapBfRange(e,t,r){(0,n.unreachable)("should not call mapBfRange")}mapBfRangeToArray(e,t,r){(0,n.unreachable)("should not call mapBfRangeToArray")}mapOne(e,t){(0,n.unreachable)("should not call mapCidOne")}lookup(e){return Number.isInteger(e)&&e<=65535?e:void 0}contains(e){return Number.isInteger(e)&&e<=65535}forEach(e){for(let t=0;t<=65535;t++)e(t,t)}charCodeOf(e){return Number.isInteger(e)&&e<=65535?e:-1}getMap(){const e=new Array(65536);for(let t=0;t<=65535;t++)e[t]=t;return e}get length(){return 65536}get isIdentityCMap(){(0,n.unreachable)("should not access .isIdentityCMap")}}t.IdentityCMap=IdentityCMap;const u=function BinaryCMapReaderClosure(){function hexToInt(e,t){let r=0;for(let n=0;n<=t;n++)r=r<<8|e[n];return r>>>0}function hexToStr(e,t){return 1===t?String.fromCharCode(e[0],e[1]):3===t?String.fromCharCode(e[0],e[1],e[2],e[3]):String.fromCharCode.apply(null,e.subarray(0,t+1))}function addHex(e,t,r){let n=0;for(let a=r;a>=0;a--){n+=e[a]+t[a];e[a]=255&n;n>>=8}}function incHex(e,t){let r=1;for(let n=t;n>=0&&r>0;n--){r+=e[n];e[n]=255&r;r>>=8}}const e=16;class BinaryCMapStream{constructor(e){this.buffer=e;this.pos=0;this.end=e.length;this.tmpBuf=new Uint8Array(19)}readByte(){return this.pos>=this.end?-1:this.buffer[this.pos++]}readNumber(){let e,t=0;do{const r=this.readByte();if(r<0)throw new n.FormatError("unexpected EOF in bcmap");e=!(128&r);t=t<<7|127&r}while(!e);return t}readSigned(){const e=this.readNumber();return 1&e?~(e>>>1):e>>>1}readHex(e,t){e.set(this.buffer.subarray(this.pos,this.pos+t+1));this.pos+=t+1}readHexNumber(e,t){let r;const a=this.tmpBuf;let i=0;do{const e=this.readByte();if(e<0)throw new n.FormatError("unexpected EOF in bcmap");r=!(128&e);a[i++]=127&e}while(!r);let s=t,o=0,c=0;for(;s>=0;){for(;c<8&&a.length>0;){o|=a[--i]<<c;c+=7}e[s]=255&o;s--;o>>=8;c-=8}}readHexSigned(e,t){this.readHexNumber(e,t);const r=1&e[t]?255:0;let n=0;for(let a=0;a<=t;a++){n=(1&n)<<8|e[a];e[a]=n>>1^r}}readString(){const e=this.readNumber();let t="";for(let r=0;r<e;r++)t+=String.fromCharCode(this.readNumber());return t}}return class BinaryCMapReader{async process(t,r,n){const a=new BinaryCMapStream(t),i=a.readByte();r.vertical=!!(1&i);let s=null;const o=new Uint8Array(e),c=new Uint8Array(e),l=new Uint8Array(e),h=new Uint8Array(e),u=new Uint8Array(e);let d,f;for(;(f=a.readByte())>=0;){const t=f>>5;if(7===t){switch(31&f){case 0:a.readString();break;case 1:s=a.readString()}continue}const n=!!(16&f),i=15&f;if(i+1>e)throw new Error("BinaryCMapReader.process: Invalid dataSize.");const g=1,p=a.readNumber();switch(t){case 0:a.readHex(o,i);a.readHexNumber(c,i);addHex(c,o,i);r.addCodespaceRange(i+1,hexToInt(o,i),hexToInt(c,i));for(let e=1;e<p;e++){incHex(c,i);a.readHexNumber(o,i);addHex(o,c,i);a.readHexNumber(c,i);addHex(c,o,i);r.addCodespaceRange(i+1,hexToInt(o,i),hexToInt(c,i))}break;case 1:a.readHex(o,i);a.readHexNumber(c,i);addHex(c,o,i);a.readNumber();for(let e=1;e<p;e++){incHex(c,i);a.readHexNumber(o,i);addHex(o,c,i);a.readHexNumber(c,i);addHex(c,o,i);a.readNumber()}break;case 2:a.readHex(l,i);d=a.readNumber();r.mapOne(hexToInt(l,i),d);for(let e=1;e<p;e++){incHex(l,i);if(!n){a.readHexNumber(u,i);addHex(l,u,i)}d=a.readSigned()+(d+1);r.mapOne(hexToInt(l,i),d)}break;case 3:a.readHex(o,i);a.readHexNumber(c,i);addHex(c,o,i);d=a.readNumber();r.mapCidRange(hexToInt(o,i),hexToInt(c,i),d);for(let e=1;e<p;e++){incHex(c,i);if(n)o.set(c);else{a.readHexNumber(o,i);addHex(o,c,i)}a.readHexNumber(c,i);addHex(c,o,i);d=a.readNumber();r.mapCidRange(hexToInt(o,i),hexToInt(c,i),d)}break;case 4:a.readHex(l,g);a.readHex(h,i);r.mapOne(hexToInt(l,g),hexToStr(h,i));for(let e=1;e<p;e++){incHex(l,g);if(!n){a.readHexNumber(u,g);addHex(l,u,g)}incHex(h,i);a.readHexSigned(u,i);addHex(h,u,i);r.mapOne(hexToInt(l,g),hexToStr(h,i))}break;case 5:a.readHex(o,g);a.readHexNumber(c,g);addHex(c,o,g);a.readHex(h,i);r.mapBfRange(hexToInt(o,g),hexToInt(c,g),hexToStr(h,i));for(let e=1;e<p;e++){incHex(c,g);if(n)o.set(c);else{a.readHexNumber(o,g);addHex(o,c,g)}a.readHexNumber(c,g);addHex(c,o,g);a.readHex(h,i);r.mapBfRange(hexToInt(o,g),hexToInt(c,g),hexToStr(h,i))}break;default:throw new Error("BinaryCMapReader.process - unknown type: ".concat(t))}}return s?n(s):r}}}(),d=function CMapFactoryClosure(){function strToInt(e){let t=0;for(let r=0;r<e.length;r++)t=t<<8|e.charCodeAt(r);return t>>>0}function expectString(e){if("string"!=typeof e)throw new n.FormatError("Malformed CMap: expected string.")}function expectInt(e){if(!Number.isInteger(e))throw new n.FormatError("Malformed CMap: expected int.")}function parseBfChar(e,t){for(;;){let r=t.getObj();if(r===a.EOF)break;if((0,a.isCmd)(r,"endbfchar"))return;expectString(r);const n=strToInt(r);r=t.getObj();expectString(r);const i=r;e.mapOne(n,i)}}function parseBfRange(e,t){for(;;){let r=t.getObj();if(r===a.EOF)break;if((0,a.isCmd)(r,"endbfrange"))return;expectString(r);const n=strToInt(r);r=t.getObj();expectString(r);const i=strToInt(r);r=t.getObj();if(Number.isInteger(r)||"string"==typeof r){const t=Number.isInteger(r)?String.fromCharCode(r):r;e.mapBfRange(n,i,t)}else{if(!(0,a.isCmd)(r,"["))break;{r=t.getObj();const s=[];for(;!(0,a.isCmd)(r,"]")&&r!==a.EOF;){s.push(r);r=t.getObj()}e.mapBfRangeToArray(n,i,s)}}}throw new n.FormatError("Invalid bf range.")}function parseCidChar(e,t){for(;;){let r=t.getObj();if(r===a.EOF)break;if((0,a.isCmd)(r,"endcidchar"))return;expectString(r);const n=strToInt(r);r=t.getObj();expectInt(r);const i=r;e.mapOne(n,i)}}function parseCidRange(e,t){for(;;){let r=t.getObj();if(r===a.EOF)break;if((0,a.isCmd)(r,"endcidrange"))return;expectString(r);const n=strToInt(r);r=t.getObj();expectString(r);const i=strToInt(r);r=t.getObj();expectInt(r);const s=r;e.mapCidRange(n,i,s)}}function parseCodespaceRange(e,t){for(;;){let r=t.getObj();if(r===a.EOF)break;if((0,a.isCmd)(r,"endcodespacerange"))return;if("string"!=typeof r)break;const n=strToInt(r);r=t.getObj();if("string"!=typeof r)break;const i=strToInt(r);e.addCodespaceRange(r.length,n,i)}throw new n.FormatError("Invalid codespace range.")}function parseWMode(e,t){const r=t.getObj();Number.isInteger(r)&&(e.vertical=!!r)}function parseCMapName(e,t){const r=t.getObj();r instanceof a.Name&&(e.name=r.name)}async function parseCMap(e,t,r,i){let s,c;e:for(;;)try{const r=t.getObj();if(r===a.EOF)break;if(r instanceof a.Name){"WMode"===r.name?parseWMode(e,t):"CMapName"===r.name&&parseCMapName(e,t);s=r}else if(r instanceof a.Cmd)switch(r.cmd){case"endcmap":break e;case"usecmap":s instanceof a.Name&&(c=s.name);break;case"begincodespacerange":parseCodespaceRange(e,t);break;case"beginbfchar":parseBfChar(e,t);break;case"begincidchar":parseCidChar(e,t);break;case"beginbfrange":parseBfRange(e,t);break;case"begincidrange":parseCidRange(e,t)}}catch(e){if(e instanceof o.MissingDataException)throw e;(0,n.warn)("Invalid cMap data: "+e);continue}!i&&c&&(i=c);return i?extendCMap(e,r,i):e}async function extendCMap(e,t,r){e.useCMap=await createBuiltInCMap(r,t);if(0===e.numCodespaceRanges){const t=e.useCMap.codespaceRanges;for(let r=0;r<t.length;r++)e.codespaceRanges[r]=t[r].slice();e.numCodespaceRanges=e.useCMap.numCodespaceRanges}e.useCMap.forEach((function(t,r){e.contains(t)||e.mapOne(t,e.useCMap.lookup(t))}));return e}async function createBuiltInCMap(e,t){if("Identity-H"===e)return new IdentityCMap(!1,2);if("Identity-V"===e)return new IdentityCMap(!0,2);if(!l.includes(e))throw new Error("Unknown CMap name: "+e);if(!t)throw new Error("Built-in CMap parameters are not provided.");const{cMapData:r,compressionType:a}=await t(e),i=new CMap(!0);if(a===n.CMapCompressionType.BINARY)return(new u).process(r,i,(e=>extendCMap(i,t,e)));if(a===n.CMapCompressionType.NONE){const e=new s.Lexer(new c.Stream(r));return parseCMap(i,e,t,null)}throw new Error("TODO: Only BINARY/NONE CMap compression is currently supported.")}return{async create(e){const t=e.encoding,r=e.fetchBuiltInCMap,n=e.useCMap;if(t instanceof a.Name)return createBuiltInCMap(t.name,r);if(t instanceof i.BaseStream){const e=await parseCMap(new CMap,new s.Lexer(t),r,n);return e.isIdentityCMap?createBuiltInCMap(e.name,r):e}throw new Error("Encoding required.")}}}();t.CMapFactory=d},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.Parser=t.Linearization=t.Lexer=void 0;r(125);r(146);r(148);r(149);var n=r(158),a=r(209),i=r(213),s=r(241),o=r(243),c=r(244),l=r(246),h=r(248),u=r(252),d=r(255),f=r(257),g=r(218),p=r(258),m=r(259);function computeAdler32(e){const t=e.length;let r=1,n=0;for(let a=0;a<t;++a){r+=255&e[a];n+=r}return n%65521<<16|r%65521}class Parser{constructor(e){let{lexer:t,xref:r,allowStreams:n=!1,recoveryMode:a=!1}=e;this.lexer=t;this.xref=r;this.allowStreams=n;this.recoveryMode=a;this.imageCache=Object.create(null);this.refill()}refill(){this.buf1=this.lexer.getObj();this.buf2=this.lexer.getObj()}shift(){if(this.buf2 instanceof a.Cmd&&"ID"===this.buf2.cmd){this.buf1=this.buf2;this.buf2=null}else{this.buf1=this.buf2;this.buf2=this.lexer.getObj()}}tryShift(){try{this.shift();return!0}catch(e){if(e instanceof i.MissingDataException)throw e;return!1}}getObj(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;const t=this.buf1;this.shift();if(t instanceof a.Cmd)switch(t.cmd){case"BI":return this.makeInlineImage(e);case"[":const r=[];for(;!(0,a.isCmd)(this.buf1,"]")&&this.buf1!==a.EOF;)r.push(this.getObj(e));if(this.buf1===a.EOF){if(this.recoveryMode)return r;throw new i.ParserEOFException("End of file inside array.")}this.shift();return r;case"<<":const s=new a.Dict(this.xref);for(;!(0,a.isCmd)(this.buf1,">>")&&this.buf1!==a.EOF;){if(!(this.buf1 instanceof a.Name)){(0,n.info)("Malformed dictionary: key must be a name object");this.shift();continue}const t=this.buf1.name;this.shift();if(this.buf1===a.EOF)break;s.set(t,this.getObj(e))}if(this.buf1===a.EOF){if(this.recoveryMode)return s;throw new i.ParserEOFException("End of file inside dictionary.")}if((0,a.isCmd)(this.buf2,"stream"))return this.allowStreams?this.makeStream(s,e):s;this.shift();return s;default:return t}if(Number.isInteger(t)){if(Number.isInteger(this.buf1)&&(0,a.isCmd)(this.buf2,"R")){const e=a.Ref.get(t,this.buf1);this.shift();this.shift();return e}return t}return"string"==typeof t&&e?e.decryptString(t):t}findDefaultInlineStreamEnd(e){const t=this.lexer,r=e.pos;let s,o,c=0;for(;-1!==(s=e.getByte());)if(0===c)c=69===s?1:0;else if(1===c)c=73===s?2:0;else{(0,n.assert)(2===c,"findDefaultInlineStreamEnd - invalid state.");if(32===s||10===s||13===s){o=e.pos;const r=e.peekBytes(10);for(let e=0,t=r.length;e<t;e++){s=r[e];if((0!==s||0===r[e+1])&&(10!==s&&13!==s&&(s<32||s>127))){c=0;break}}if(2!==c)continue;if(t.knownCommands){const e=t.peekObj();e instanceof a.Cmd&&!t.knownCommands[e.cmd]&&(c=0)}else(0,n.warn)("findDefaultInlineStreamEnd - `lexer.knownCommands` is undefined.");if(2===c)break}else c=0}if(-1===s){(0,n.warn)("findDefaultInlineStreamEnd: Reached the end of the stream without finding a valid EI marker");if(o){(0,n.warn)('... trying to recover by using the last "EI" occurrence.');e.skip(-(e.pos-o))}}let l=4;e.skip(-l);s=e.peekByte();e.skip(l);(0,i.isWhiteSpace)(s)||l--;return e.pos-l-r}findDCTDecodeInlineStreamEnd(e){const t=e.pos;let r,a,i=!1;for(;-1!==(r=e.getByte());)if(255===r){switch(e.getByte()){case 0:break;case 255:e.skip(-1);break;case 217:i=!0;break;case 192:case 193:case 194:case 195:case 197:case 198:case 199:case 201:case 202:case 203:case 205:case 206:case 207:case 196:case 204:case 218:case 219:case 220:case 221:case 222:case 223:case 224:case 225:case 226:case 227:case 228:case 229:case 230:case 231:case 232:case 233:case 234:case 235:case 236:case 237:case 238:case 239:case 254:a=e.getUint16();a>2?e.skip(a-2):e.skip(-2)}if(i)break}const s=e.pos-t;if(-1===r){(0,n.warn)("Inline DCTDecode image stream: EOI marker not found, searching for /EI/ instead.");e.skip(-s);return this.findDefaultInlineStreamEnd(e)}this.inlineStreamSkipEI(e);return s}findASCII85DecodeInlineStreamEnd(e){const t=e.pos;let r;for(;-1!==(r=e.getByte());)if(126===r){const t=e.pos;r=e.peekByte();for(;(0,i.isWhiteSpace)(r);){e.skip();r=e.peekByte()}if(62===r){e.skip();break}if(e.pos>t){const t=e.peekBytes(2);if(69===t[0]&&73===t[1])break}}const a=e.pos-t;if(-1===r){(0,n.warn)("Inline ASCII85Decode image stream: EOD marker not found, searching for /EI/ instead.");e.skip(-a);return this.findDefaultInlineStreamEnd(e)}this.inlineStreamSkipEI(e);return a}findASCIIHexDecodeInlineStreamEnd(e){const t=e.pos;let r;for(;-1!==(r=e.getByte())&&62!==r;);const a=e.pos-t;if(-1===r){(0,n.warn)("Inline ASCIIHexDecode image stream: EOD marker not found, searching for /EI/ instead.");e.skip(-a);return this.findDefaultInlineStreamEnd(e)}this.inlineStreamSkipEI(e);return a}inlineStreamSkipEI(e){let t,r=0;for(;-1!==(t=e.getByte());)if(0===r)r=69===t?1:0;else if(1===r)r=73===t?2:0;else if(2===r)break}makeInlineImage(e){const t=this.lexer,r=t.stream,i=new a.Dict(this.xref);let s;for(;!(0,a.isCmd)(this.buf1,"ID")&&this.buf1!==a.EOF;){if(!(this.buf1 instanceof a.Name))throw new n.FormatError("Dictionary key must be a name object");const t=this.buf1.name;this.shift();if(this.buf1===a.EOF)break;i.set(t,this.getObj(e))}-1!==t.beginInlineImagePos&&(s=r.pos-t.beginInlineImagePos);const o=i.get("F","Filter");let c;if(o instanceof a.Name)c=o.name;else if(Array.isArray(o)){const e=this.xref.fetchIfRef(o[0]);e instanceof a.Name&&(c=e.name)}const l=r.pos;let h;switch(c){case"DCT":case"DCTDecode":h=this.findDCTDecodeInlineStreamEnd(r);break;case"A85":case"ASCII85Decode":h=this.findASCII85DecodeInlineStreamEnd(r);break;case"AHx":case"ASCIIHexDecode":h=this.findASCIIHexDecodeInlineStreamEnd(r);break;default:h=this.findDefaultInlineStreamEnd(r)}let u,d=r.makeSubStream(l,h,i);if(h<1e3&&s<5552){const e=d.getBytes();d.reset();const n=r.pos;r.pos=t.beginInlineImagePos;const i=r.getBytes(s);r.pos=n;u=computeAdler32(e)+"_"+computeAdler32(i);const o=this.imageCache[u];if(void 0!==o){this.buf2=a.Cmd.get("EI");this.shift();o.reset();return o}}e&&(d=e.createStream(d,h));d=this.filter(d,i,h);d.dict=i;if(void 0!==u){d.cacheKey="inline_".concat(h,"_").concat(u);this.imageCache[u]=d}this.buf2=a.Cmd.get("EI");this.shift();return d}_findStreamLength(e,t){const{stream:r}=this.lexer;r.pos=e;const n=t.length;for(;r.pos<r.end;){const a=r.peekBytes(2048),i=a.length-n;if(i<=0)break;let s=0;for(;s<i;){let i=0;for(;i<n&&a[s+i]===t[i];)i++;if(i>=n){r.pos+=s;return r.pos-e}s++}r.pos+=i}return-1}makeStream(e,t){const r=this.lexer;let s=r.stream;r.skipToNextLine();const o=s.pos-1;let c=e.get("Length");if(!Number.isInteger(c)){(0,n.info)('Bad length "'.concat(c&&c.toString(),'" in stream.'));c=0}s.pos=o+c;r.nextChar();if(this.tryShift()&&(0,a.isCmd)(this.buf2,"endstream"))this.shift();else{const e=new Uint8Array([101,110,100,115,116,114,101,97,109]);let t=this._findStreamLength(o,e);if(t<0){const r=1;for(let a=1;a<=r;a++){const r=e.length-a,c=e.slice(0,r),l=this._findStreamLength(o,c);if(l>=0){const e=s.peekBytes(r+1)[r];if(!(0,i.isWhiteSpace)(e))break;(0,n.info)('Found "'.concat((0,n.bytesToString)(c),'" when ')+"searching for endstream command.");t=l;break}}if(t<0)throw new n.FormatError("Missing endstream command.")}c=t;r.nextChar();this.shift();this.shift()}this.shift();s=s.makeSubStream(o,c,e);t&&(s=t.createStream(s,c));s=this.filter(s,e,c);s.dict=e;return s}filter(e,t,r){let i=t.get("F","Filter"),s=t.get("DP","DecodeParms");if(i instanceof a.Name){Array.isArray(s)&&(0,n.warn)("/DecodeParms should not be an Array, when /Filter is a Name.");return this.makeFilter(e,i.name,r,s)}let o=r;if(Array.isArray(i)){const t=i,r=s;for(let c=0,l=t.length;c<l;++c){i=this.xref.fetchIfRef(t[c]);if(!(i instanceof a.Name))throw new n.FormatError('Bad filter name "'.concat(i,'"'));s=null;Array.isArray(r)&&c in r&&(s=this.xref.fetchIfRef(r[c]));e=this.makeFilter(e,i.name,o,s);o=null}}return e}makeFilter(e,t,r,a){if(0===r){(0,n.warn)('Empty "'.concat(t,'" stream.'));return new g.NullStream}const b=this.xref.stats;try{switch(t){case"Fl":case"FlateDecode":b.addStreamType(n.StreamType.FLATE);return a?new p.PredictorStream(new l.FlateStream(e,r),r,a):new l.FlateStream(e,r);case"LZW":case"LZWDecode":b.addStreamType(n.StreamType.LZW);let t=1;if(a){a.has("EarlyChange")&&(t=a.get("EarlyChange"));return new p.PredictorStream(new f.LZWStream(e,r,t),r,a)}return new f.LZWStream(e,r,t);case"DCT":case"DCTDecode":b.addStreamType(n.StreamType.DCT);return new u.JpegStream(e,r,a);case"JPX":case"JPXDecode":b.addStreamType(n.StreamType.JPX);return new d.JpxStream(e,r,a);case"A85":case"ASCII85Decode":b.addStreamType(n.StreamType.A85);return new s.Ascii85Stream(e,r);case"AHx":case"ASCIIHexDecode":b.addStreamType(n.StreamType.AHX);return new o.AsciiHexStream(e,r);case"CCF":case"CCITTFaxDecode":b.addStreamType(n.StreamType.CCF);return new c.CCITTFaxStream(e,r,a);case"RL":case"RunLengthDecode":b.addStreamType(n.StreamType.RLX);return new m.RunLengthStream(e,r);case"JBIG2Decode":b.addStreamType(n.StreamType.JBIG);return new h.Jbig2Stream(e,r,a)}(0,n.warn)('Filter "'.concat(t,'" is not supported.'));return e}catch(e){if(e instanceof i.MissingDataException)throw e;(0,n.warn)('Invalid stream: "'.concat(e,'"'));return new g.NullStream}}}t.Parser=Parser;const b=[1,0,0,0,0,0,0,0,0,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,2,0,0,2,2,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];function toHexDigit(e){return e>=48&&e<=57?15&e:e>=65&&e<=70||e>=97&&e<=102?9+(15&e):-1}class Lexer{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;this.stream=e;this.nextChar();this.strBuf=[];this.knownCommands=t;this._hexStringNumWarn=0;this.beginInlineImagePos=-1}nextChar(){return this.currentChar=this.stream.getByte()}peekChar(){return this.stream.peekByte()}getNumber(){let e=this.currentChar,t=!1,r=0,a=0;if(45===e){a=-1;e=this.nextChar();45===e&&(e=this.nextChar())}else if(43===e){a=1;e=this.nextChar()}if(10===e||13===e)do{e=this.nextChar()}while(10===e||13===e);if(46===e){r=10;e=this.nextChar()}if(e<48||e>57){if((0,i.isWhiteSpace)(e)||-1===e){if(10===r&&0===a){(0,n.warn)("Lexer.getNumber - treating a single decimal point as zero.");return 0}if(0===r&&-1===a){(0,n.warn)("Lexer.getNumber - treating a single minus sign as zero.");return 0}}throw new n.FormatError("Invalid number: ".concat(String.fromCharCode(e)," (charCode ").concat(e,")"))}a=a||1;let s=e-48,o=0,c=1;for(;(e=this.nextChar())>=0;)if(e>=48&&e<=57){const n=e-48;if(t)o=10*o+n;else{0!==r&&(r*=10);s=10*s+n}}else if(46===e){if(0!==r)break;r=1}else if(45===e)(0,n.warn)("Badly formatted number: minus sign in the middle");else{if(69!==e&&101!==e)break;e=this.peekChar();if(43===e||45===e){c=45===e?-1:1;this.nextChar()}else if(e<48||e>57)break;t=!0}0!==r&&(s/=r);t&&(s*=10**(c*o));return a*s}getString(){let e=1,t=!1;const r=this.strBuf;r.length=0;let a=this.nextChar();for(;;){let i=!1;switch(0|a){case-1:(0,n.warn)("Unterminated string");t=!0;break;case 40:++e;r.push("(");break;case 41:if(0==--e){this.nextChar();t=!0}else r.push(")");break;case 92:a=this.nextChar();switch(a){case-1:(0,n.warn)("Unterminated string");t=!0;break;case 110:r.push("\n");break;case 114:r.push("\r");break;case 116:r.push("\t");break;case 98:r.push("\b");break;case 102:r.push("\f");break;case 92:case 40:case 41:r.push(String.fromCharCode(a));break;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:let e=15&a;a=this.nextChar();i=!0;if(a>=48&&a<=55){e=(e<<3)+(15&a);a=this.nextChar();if(a>=48&&a<=55){i=!1;e=(e<<3)+(15&a)}}r.push(String.fromCharCode(e));break;case 13:10===this.peekChar()&&this.nextChar();break;case 10:break;default:r.push(String.fromCharCode(a))}break;default:r.push(String.fromCharCode(a))}if(t)break;i||(a=this.nextChar())}return r.join("")}getName(){let e,t;const r=this.strBuf;r.length=0;for(;(e=this.nextChar())>=0&&!b[e];)if(35===e){e=this.nextChar();if(b[e]){(0,n.warn)("Lexer_getName: NUMBER SIGN (#) should be followed by a hexadecimal number.");r.push("#");break}const a=toHexDigit(e);if(-1!==a){t=e;e=this.nextChar();const i=toHexDigit(e);if(-1===i){(0,n.warn)("Lexer_getName: Illegal digit (".concat(String.fromCharCode(e),") ")+"in hexadecimal number.");r.push("#",String.fromCharCode(t));if(b[e])break;r.push(String.fromCharCode(e));continue}r.push(String.fromCharCode(a<<4|i))}else r.push("#",String.fromCharCode(e))}else r.push(String.fromCharCode(e));r.length>127&&(0,n.warn)("Name token is longer than allowed by the spec: ".concat(r.length));return a.Name.get(r.join(""))}_hexStringWarn(e){5!=this._hexStringNumWarn++?this._hexStringNumWarn>5||(0,n.warn)("getHexString - ignoring invalid character: ".concat(e)):(0,n.warn)("getHexString - ignoring additional invalid characters.")}getHexString(){const e=this.strBuf;e.length=0;let t,r,a=this.currentChar,i=!0;this._hexStringNumWarn=0;for(;;){if(a<0){(0,n.warn)("Unterminated hex string");break}if(62===a){this.nextChar();break}if(1!==b[a]){if(i){t=toHexDigit(a);if(-1===t){this._hexStringWarn(a);a=this.nextChar();continue}}else{r=toHexDigit(a);if(-1===r){this._hexStringWarn(a);a=this.nextChar();continue}e.push(String.fromCharCode(t<<4|r))}i=!i;a=this.nextChar()}else a=this.nextChar()}return e.join("")}getObj(){let e=!1,t=this.currentChar;for(;;){if(t<0)return a.EOF;if(e)10!==t&&13!==t||(e=!1);else if(37===t)e=!0;else if(1!==b[t])break;t=this.nextChar()}switch(0|t){case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:case 43:case 45:case 46:return this.getNumber();case 40:return this.getString();case 47:return this.getName();case 91:this.nextChar();return a.Cmd.get("[");case 93:this.nextChar();return a.Cmd.get("]");case 60:t=this.nextChar();if(60===t){this.nextChar();return a.Cmd.get("<<")}return this.getHexString();case 62:t=this.nextChar();if(62===t){this.nextChar();return a.Cmd.get(">>")}return a.Cmd.get(">");case 123:this.nextChar();return a.Cmd.get("{");case 125:this.nextChar();return a.Cmd.get("}");case 41:this.nextChar();throw new n.FormatError("Illegal character: ".concat(t))}let r=String.fromCharCode(t);if(t<32||t>127){const e=this.peekChar();if(e>=32&&e<=127){this.nextChar();return a.Cmd.get(r)}}const i=this.knownCommands;let s=i&&void 0!==i[r];for(;(t=this.nextChar())>=0&&!b[t];){const e=r+String.fromCharCode(t);if(s&&void 0===i[e])break;if(128===r.length)throw new n.FormatError("Command token too long: ".concat(r.length));r=e;s=i&&void 0!==i[r]}if("true"===r)return!0;if("false"===r)return!1;if("null"===r)return null;"BI"===r&&(this.beginInlineImagePos=this.stream.pos);return a.Cmd.get(r)}peekObj(){const e=this.stream.pos,t=this.currentChar,r=this.beginInlineImagePos;let a;try{a=this.getObj()}catch(e){if(e instanceof i.MissingDataException)throw e;(0,n.warn)("peekObj: ".concat(e))}this.stream.pos=e;this.currentChar=t;this.beginInlineImagePos=r;return a}skipToNextLine(){let e=this.currentChar;for(;e>=0;){if(13===e){e=this.nextChar();10===e&&this.nextChar();break}if(10===e){this.nextChar();break}e=this.nextChar()}}}t.Lexer=Lexer;t.Linearization=class Linearization{static create(e){function getInt(e,t){let r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];const n=e.get(t);if(Number.isInteger(n)&&(r?n>=0:n>0))return n;throw new Error('The "'.concat(t,'" parameter in the linearization ')+"dictionary is invalid.")}const t=new Parser({lexer:new Lexer(e),xref:null}),r=t.getObj(),n=t.getObj(),i=t.getObj(),s=t.getObj();let o,c;if(!(Number.isInteger(r)&&Number.isInteger(n)&&(0,a.isCmd)(i,"obj")&&s instanceof a.Dict&&"number"==typeof(o=s.get("Linearized"))&&o>0))return null;if((c=getInt(s,"L"))!==e.length)throw new Error('The "L" parameter in the linearization dictionary does not equal the stream length.');return{length:c,hints:function getHints(e){const t=e.get("H");let r;if(Array.isArray(t)&&(2===(r=t.length)||4===r)){for(let e=0;e<r;e++){const r=t[e];if(!(Number.isInteger(r)&&r>0))throw new Error("Hint (".concat(e,") in the linearization dictionary is invalid."))}return t}throw new Error("Hint array in the linearization dictionary is invalid.")}(s),objectNumberFirst:getInt(s,"O"),endFirst:getInt(s,"E"),numPages:getInt(s,"N"),mainXRefEntriesOffset:getInt(s,"T"),pageFirst:s.has("P")?getInt(s,"P",!0):0}}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.Ascii85Stream=void 0;r(125);r(146);r(148);r(149);var n=r(242),a=r(213);class Ascii85Stream extends n.DecodeStream{constructor(e,t){t&&(t*=.8);super(t);this.str=e;this.dict=e.dict;this.input=new Uint8Array(5)}readBlock(){const e=this.str;let t=e.getByte();for(;(0,a.isWhiteSpace)(t);)t=e.getByte();if(-1===t||126===t){this.eof=!0;return}const r=this.bufferLength;let n,i;if(122===t){n=this.ensureBuffer(r+4);for(i=0;i<4;++i)n[r+i]=0;this.bufferLength+=4}else{const s=this.input;s[0]=t;for(i=1;i<5;++i){t=e.getByte();for(;(0,a.isWhiteSpace)(t);)t=e.getByte();s[i]=t;if(-1===t||126===t)break}n=this.ensureBuffer(r+i-1);this.bufferLength+=i-1;if(i<5){for(;i<5;++i)s[i]=117;this.eof=!0}let o=0;for(i=0;i<5;++i)o=85*o+(s[i]-33);for(i=3;i>=0;--i){n[r+i]=255&o;o>>=8}}}}t.Ascii85Stream=Ascii85Stream},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.StreamsSequenceStream=t.DecodeStream=void 0;r(125);r(146);r(148);r(149);r(112);var n=r(217),a=r(218);const i=new Uint8Array(0);class DecodeStream extends n.BaseStream{constructor(e){super();this._rawMinBufferLength=e||0;this.pos=0;this.bufferLength=0;this.eof=!1;this.buffer=i;this.minBufferLength=512;if(e)for(;this.minBufferLength<e;)this.minBufferLength*=2}get isEmpty(){for(;!this.eof&&0===this.bufferLength;)this.readBlock();return 0===this.bufferLength}ensureBuffer(e){const t=this.buffer;if(e<=t.byteLength)return t;let r=this.minBufferLength;for(;r<e;)r*=2;const n=new Uint8Array(r);n.set(t);return this.buffer=n}getByte(){const e=this.pos;for(;this.bufferLength<=e;){if(this.eof)return-1;this.readBlock()}return this.buffer[this.pos++]}getBytes(e){const t=this.pos;let r;if(e){this.ensureBuffer(t+e);r=t+e;for(;!this.eof&&this.bufferLength<r;)this.readBlock();const n=this.bufferLength;r>n&&(r=n)}else{for(;!this.eof;)this.readBlock();r=this.bufferLength}this.pos=r;return this.buffer.subarray(t,r)}reset(){this.pos=0}makeSubStream(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;if(void 0===t)for(;!this.eof;)this.readBlock();else{const r=e+t;for(;this.bufferLength<=r&&!this.eof;)this.readBlock()}return new a.Stream(this.buffer,e,t,r)}getBaseStreams(){return this.str?this.str.getBaseStreams():null}}t.DecodeStream=DecodeStream;t.StreamsSequenceStream=class StreamsSequenceStream extends DecodeStream{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=0;for(const t of e)r+=t instanceof DecodeStream?t._rawMinBufferLength:t.length;super(r);this.streams=e;this._onError=t}readBlock(){const e=this.streams;if(0===e.length){this.eof=!0;return}const t=e.shift();let r;try{r=t.getBytes()}catch(e){if(this._onError){this._onError(e,t.dict&&t.dict.objId);return}throw e}const n=this.bufferLength,a=n+r.length;this.ensureBuffer(a).set(r,n);this.bufferLength=a}getBaseStreams(){const e=[];for(const t of this.streams){const r=t.getBaseStreams();r&&e.push(...r)}return e.length>0?e:null}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.AsciiHexStream=void 0;r(112);var n=r(242);class AsciiHexStream extends n.DecodeStream{constructor(e,t){t&&(t*=.5);super(t);this.str=e;this.dict=e.dict;this.firstDigit=-1}readBlock(){const e=this.str.getBytes(8e3);if(!e.length){this.eof=!0;return}const t=e.length+1>>1,r=this.ensureBuffer(this.bufferLength+t);let n=this.bufferLength,a=this.firstDigit;for(const t of e){let e;if(t>=48&&t<=57)e=15&t;else{if(!(t>=65&&t<=70||t>=97&&t<=102)){if(62===t){this.eof=!0;break}continue}e=9+(15&t)}if(a<0)a=e;else{r[n++]=a<<4|e;a=-1}}if(a>=0&&this.eof){r[n++]=a<<4;a=-1}this.firstDigit=a;this.bufferLength=n}}t.AsciiHexStream=AsciiHexStream},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.CCITTFaxStream=void 0;var n=r(245),a=r(242),i=r(209);class CCITTFaxStream extends a.DecodeStream{constructor(e,t,r){super(t);this.str=e;this.dict=e.dict;r instanceof i.Dict||(r=i.Dict.empty);const a={next:()=>e.getByte()};this.ccittFaxDecoder=new n.CCITTFaxDecoder(a,{K:r.get("K"),EndOfLine:r.get("EndOfLine"),EncodedByteAlign:r.get("EncodedByteAlign"),Columns:r.get("Columns"),Rows:r.get("Rows"),EndOfBlock:r.get("EndOfBlock"),BlackIs1:r.get("BlackIs1")})}readBlock(){for(;!this.eof;){const e=this.ccittFaxDecoder.readNextChar();if(-1===e){this.eof=!0;return}this.ensureBuffer(this.bufferLength+1);this.buffer[this.bufferLength++]=e}}}t.CCITTFaxStream=CCITTFaxStream},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.CCITTFaxDecoder=void 0;r(178);r(146);r(148);r(149);var n=r(158);const a=-1,i=[[-1,-1],[-1,-1],[7,8],[7,7],[6,6],[6,6],[6,5],[6,5],[4,0],[4,0],[4,0],[4,0],[4,0],[4,0],[4,0],[4,0],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2]],s=[[-1,-1],[12,-2],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[11,1792],[11,1792],[12,1984],[12,2048],[12,2112],[12,2176],[12,2240],[12,2304],[11,1856],[11,1856],[11,1920],[11,1920],[12,2368],[12,2432],[12,2496],[12,2560]],o=[[-1,-1],[-1,-1],[-1,-1],[-1,-1],[8,29],[8,29],[8,30],[8,30],[8,45],[8,45],[8,46],[8,46],[7,22],[7,22],[7,22],[7,22],[7,23],[7,23],[7,23],[7,23],[8,47],[8,47],[8,48],[8,48],[6,13],[6,13],[6,13],[6,13],[6,13],[6,13],[6,13],[6,13],[7,20],[7,20],[7,20],[7,20],[8,33],[8,33],[8,34],[8,34],[8,35],[8,35],[8,36],[8,36],[8,37],[8,37],[8,38],[8,38],[7,19],[7,19],[7,19],[7,19],[8,31],[8,31],[8,32],[8,32],[6,1],[6,1],[6,1],[6,1],[6,1],[6,1],[6,1],[6,1],[6,12],[6,12],[6,12],[6,12],[6,12],[6,12],[6,12],[6,12],[8,53],[8,53],[8,54],[8,54],[7,26],[7,26],[7,26],[7,26],[8,39],[8,39],[8,40],[8,40],[8,41],[8,41],[8,42],[8,42],[8,43],[8,43],[8,44],[8,44],[7,21],[7,21],[7,21],[7,21],[7,28],[7,28],[7,28],[7,28],[8,61],[8,61],[8,62],[8,62],[8,63],[8,63],[8,0],[8,0],[8,320],[8,320],[8,384],[8,384],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[7,27],[7,27],[7,27],[7,27],[8,59],[8,59],[8,60],[8,60],[9,1472],[9,1536],[9,1600],[9,1728],[7,18],[7,18],[7,18],[7,18],[7,24],[7,24],[7,24],[7,24],[8,49],[8,49],[8,50],[8,50],[8,51],[8,51],[8,52],[8,52],[7,25],[7,25],[7,25],[7,25],[8,55],[8,55],[8,56],[8,56],[8,57],[8,57],[8,58],[8,58],[6,192],[6,192],[6,192],[6,192],[6,192],[6,192],[6,192],[6,192],[6,1664],[6,1664],[6,1664],[6,1664],[6,1664],[6,1664],[6,1664],[6,1664],[8,448],[8,448],[8,512],[8,512],[9,704],[9,768],[8,640],[8,640],[8,576],[8,576],[9,832],[9,896],[9,960],[9,1024],[9,1088],[9,1152],[9,1216],[9,1280],[9,1344],[9,1408],[7,256],[7,256],[7,256],[7,256],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[6,16],[6,16],[6,16],[6,16],[6,16],[6,16],[6,16],[6,16],[6,17],[6,17],[6,17],[6,17],[6,17],[6,17],[6,17],[6,17],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[6,14],[6,14],[6,14],[6,14],[6,14],[6,14],[6,14],[6,14],[6,15],[6,15],[6,15],[6,15],[6,15],[6,15],[6,15],[6,15],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7]],c=[[-1,-1],[-1,-1],[12,-2],[12,-2],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[11,1792],[11,1792],[11,1792],[11,1792],[12,1984],[12,1984],[12,2048],[12,2048],[12,2112],[12,2112],[12,2176],[12,2176],[12,2240],[12,2240],[12,2304],[12,2304],[11,1856],[11,1856],[11,1856],[11,1856],[11,1920],[11,1920],[11,1920],[11,1920],[12,2368],[12,2368],[12,2432],[12,2432],[12,2496],[12,2496],[12,2560],[12,2560],[10,18],[10,18],[10,18],[10,18],[10,18],[10,18],[10,18],[10,18],[12,52],[12,52],[13,640],[13,704],[13,768],[13,832],[12,55],[12,55],[12,56],[12,56],[13,1280],[13,1344],[13,1408],[13,1472],[12,59],[12,59],[12,60],[12,60],[13,1536],[13,1600],[11,24],[11,24],[11,24],[11,24],[11,25],[11,25],[11,25],[11,25],[13,1664],[13,1728],[12,320],[12,320],[12,384],[12,384],[12,448],[12,448],[13,512],[13,576],[12,53],[12,53],[12,54],[12,54],[13,896],[13,960],[13,1024],[13,1088],[13,1152],[13,1216],[10,64],[10,64],[10,64],[10,64],[10,64],[10,64],[10,64],[10,64]],l=[[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[11,23],[11,23],[12,50],[12,51],[12,44],[12,45],[12,46],[12,47],[12,57],[12,58],[12,61],[12,256],[10,16],[10,16],[10,16],[10,16],[10,17],[10,17],[10,17],[10,17],[12,48],[12,49],[12,62],[12,63],[12,30],[12,31],[12,32],[12,33],[12,40],[12,41],[11,22],[11,22],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[9,15],[9,15],[9,15],[9,15],[9,15],[9,15],[9,15],[9,15],[12,128],[12,192],[12,26],[12,27],[12,28],[12,29],[11,19],[11,19],[11,20],[11,20],[12,34],[12,35],[12,36],[12,37],[12,38],[12,39],[11,21],[11,21],[12,42],[12,43],[10,0],[10,0],[10,0],[10,0],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12]],h=[[-1,-1],[-1,-1],[-1,-1],[-1,-1],[6,9],[6,8],[5,7],[5,7],[4,6],[4,6],[4,6],[4,6],[4,5],[4,5],[4,5],[4,5],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2]];t.CCITTFaxDecoder=class CCITTFaxDecoder{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(!e||"function"!=typeof e.next)throw new Error('CCITTFaxDecoder - invalid "source" parameter.');this.source=e;this.eof=!1;this.encoding=t.K||0;this.eoline=t.EndOfLine||!1;this.byteAlign=t.EncodedByteAlign||!1;this.columns=t.Columns||1728;this.rows=t.Rows||0;let r,n=t.EndOfBlock;null==n&&(n=!0);this.eoblock=n;this.black=t.BlackIs1||!1;this.codingLine=new Uint32Array(this.columns+1);this.refLine=new Uint32Array(this.columns+2);this.codingLine[0]=this.columns;this.codingPos=0;this.row=0;this.nextLine2D=this.encoding<0;this.inputBits=0;this.inputBuf=0;this.outputBits=0;this.rowsDone=!1;for(;0===(r=this._lookBits(12));)this._eatBits(1);1===r&&this._eatBits(12);if(this.encoding>0){this.nextLine2D=!this._lookBits(1);this._eatBits(1)}}readNextChar(){if(this.eof)return-1;const e=this.refLine,t=this.codingLine,r=this.columns;let i,s,o,c,l;if(0===this.outputBits){this.rowsDone&&(this.eof=!0);if(this.eof)return-1;this.err=!1;let o,l,h;if(this.nextLine2D){for(c=0;t[c]<r;++c)e[c]=t[c];e[c++]=r;e[c]=r;t[0]=0;this.codingPos=0;i=0;s=0;for(;t[this.codingPos]<r;){o=this._getTwoDimCode();switch(o){case 0:this._addPixels(e[i+1],s);e[i+1]<r&&(i+=2);break;case 1:o=l=0;if(s){do{o+=h=this._getBlackCode()}while(h>=64);do{l+=h=this._getWhiteCode()}while(h>=64)}else{do{o+=h=this._getWhiteCode()}while(h>=64);do{l+=h=this._getBlackCode()}while(h>=64)}this._addPixels(t[this.codingPos]+o,s);t[this.codingPos]<r&&this._addPixels(t[this.codingPos]+l,1^s);for(;e[i]<=t[this.codingPos]&&e[i]<r;)i+=2;break;case 7:this._addPixels(e[i]+3,s);s^=1;if(t[this.codingPos]<r){++i;for(;e[i]<=t[this.codingPos]&&e[i]<r;)i+=2}break;case 5:this._addPixels(e[i]+2,s);s^=1;if(t[this.codingPos]<r){++i;for(;e[i]<=t[this.codingPos]&&e[i]<r;)i+=2}break;case 3:this._addPixels(e[i]+1,s);s^=1;if(t[this.codingPos]<r){++i;for(;e[i]<=t[this.codingPos]&&e[i]<r;)i+=2}break;case 2:this._addPixels(e[i],s);s^=1;if(t[this.codingPos]<r){++i;for(;e[i]<=t[this.codingPos]&&e[i]<r;)i+=2}break;case 8:this._addPixelsNeg(e[i]-3,s);s^=1;if(t[this.codingPos]<r){i>0?--i:++i;for(;e[i]<=t[this.codingPos]&&e[i]<r;)i+=2}break;case 6:this._addPixelsNeg(e[i]-2,s);s^=1;if(t[this.codingPos]<r){i>0?--i:++i;for(;e[i]<=t[this.codingPos]&&e[i]<r;)i+=2}break;case 4:this._addPixelsNeg(e[i]-1,s);s^=1;if(t[this.codingPos]<r){i>0?--i:++i;for(;e[i]<=t[this.codingPos]&&e[i]<r;)i+=2}break;case a:this._addPixels(r,0);this.eof=!0;break;default:(0,n.info)("bad 2d code");this._addPixels(r,0);this.err=!0}}}else{t[0]=0;this.codingPos=0;s=0;for(;t[this.codingPos]<r;){o=0;if(s)do{o+=h=this._getBlackCode()}while(h>=64);else do{o+=h=this._getWhiteCode()}while(h>=64);this._addPixels(t[this.codingPos]+o,s);s^=1}}let u=!1;this.byteAlign&&(this.inputBits&=-8);if(this.eoblock||this.row!==this.rows-1){o=this._lookBits(12);if(this.eoline)for(;o!==a&&1!==o;){this._eatBits(1);o=this._lookBits(12)}else for(;0===o;){this._eatBits(1);o=this._lookBits(12)}if(1===o){this._eatBits(12);u=!0}else o===a&&(this.eof=!0)}else this.rowsDone=!0;if(!this.eof&&this.encoding>0&&!this.rowsDone){this.nextLine2D=!this._lookBits(1);this._eatBits(1)}if(this.eoblock&&u&&this.byteAlign){o=this._lookBits(12);if(1===o){this._eatBits(12);if(this.encoding>0){this._lookBits(1);this._eatBits(1)}if(this.encoding>=0)for(c=0;c<4;++c){o=this._lookBits(12);1!==o&&(0,n.info)("bad rtc code: "+o);this._eatBits(12);if(this.encoding>0){this._lookBits(1);this._eatBits(1)}}this.eof=!0}}else if(this.err&&this.eoline){for(;;){o=this._lookBits(13);if(o===a){this.eof=!0;return-1}if(o>>1==1)break;this._eatBits(1)}this._eatBits(12);if(this.encoding>0){this._eatBits(1);this.nextLine2D=!(1&o)}}t[0]>0?this.outputBits=t[this.codingPos=0]:this.outputBits=t[this.codingPos=1];this.row++}if(this.outputBits>=8){l=1&this.codingPos?0:255;this.outputBits-=8;if(0===this.outputBits&&t[this.codingPos]<r){this.codingPos++;this.outputBits=t[this.codingPos]-t[this.codingPos-1]}}else{o=8;l=0;do{if("number"!=typeof this.outputBits)throw new n.FormatError('Invalid /CCITTFaxDecode data, "outputBits" must be a number.');if(this.outputBits>o){l<<=o;1&this.codingPos||(l|=255>>8-o);this.outputBits-=o;o=0}else{l<<=this.outputBits;1&this.codingPos||(l|=255>>8-this.outputBits);o-=this.outputBits;this.outputBits=0;if(t[this.codingPos]<r){this.codingPos++;this.outputBits=t[this.codingPos]-t[this.codingPos-1]}else if(o>0){l<<=o;o=0}}}while(o)}this.black&&(l^=255);return l}_addPixels(e,t){const r=this.codingLine;let a=this.codingPos;if(e>r[a]){if(e>this.columns){(0,n.info)("row is wrong length");this.err=!0;e=this.columns}1&a^t&&++a;r[a]=e}this.codingPos=a}_addPixelsNeg(e,t){const r=this.codingLine;let a=this.codingPos;if(e>r[a]){if(e>this.columns){(0,n.info)("row is wrong length");this.err=!0;e=this.columns}1&a^t&&++a;r[a]=e}else if(e<r[a]){if(e<0){(0,n.info)("invalid code");this.err=!0;e=0}for(;a>0&&e<r[a-1];)--a;r[a]=e}this.codingPos=a}_findTableCode(e,t,r,n){const i=n||0;for(let n=e;n<=t;++n){let e=this._lookBits(n);if(e===a)return[!0,1,!1];n<t&&(e<<=t-n);if(!i||e>=i){const t=r[e-i];if(t[0]===n){this._eatBits(n);return[!0,t[1],!0]}}}return[!1,0,!1]}_getTwoDimCode(){let e,t=0;if(this.eoblock){t=this._lookBits(7);e=i[t];if(e&&e[0]>0){this._eatBits(e[0]);return e[1]}}else{const e=this._findTableCode(1,7,i);if(e[0]&&e[2])return e[1]}(0,n.info)("Bad two dim code");return a}_getWhiteCode(){let e,t=0;if(this.eoblock){t=this._lookBits(12);if(t===a)return 1;e=t>>5==0?s[t]:o[t>>3];if(e[0]>0){this._eatBits(e[0]);return e[1]}}else{let e=this._findTableCode(1,9,o);if(e[0])return e[1];e=this._findTableCode(11,12,s);if(e[0])return e[1]}(0,n.info)("bad white code");this._eatBits(1);return 1}_getBlackCode(){let e,t;if(this.eoblock){e=this._lookBits(13);if(e===a)return 1;t=e>>7==0?c[e]:e>>9==0&&e>>7!=0?l[(e>>1)-64]:h[e>>7];if(t[0]>0){this._eatBits(t[0]);return t[1]}}else{let e=this._findTableCode(2,6,h);if(e[0])return e[1];e=this._findTableCode(7,12,l,64);if(e[0])return e[1];e=this._findTableCode(10,13,c);if(e[0])return e[1]}(0,n.info)("bad black code");this._eatBits(1);return 1}_lookBits(e){let t;for(;this.inputBits<e;){if(-1===(t=this.source.next()))return 0===this.inputBits?a:this.inputBuf<<e-this.inputBits&65535>>16-e;this.inputBuf=this.inputBuf<<8|t;this.inputBits+=8}return this.inputBuf>>this.inputBits-e&65535>>16-e}_eatBits(e){(this.inputBits-=e)<0&&(this.inputBits=0)}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.FlateStream=void 0;r(247);r(146);r(148);r(149);r(125);var n=r(242),a=r(158);const i=new Int32Array([16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15]),s=new Int32Array([3,4,5,6,7,8,9,10,65547,65549,65551,65553,131091,131095,131099,131103,196643,196651,196659,196667,262211,262227,262243,262259,327811,327843,327875,327907,258,258,258]),o=new Int32Array([1,2,3,4,65541,65543,131081,131085,196625,196633,262177,262193,327745,327777,393345,393409,459009,459137,524801,525057,590849,591361,657409,658433,724993,727041,794625,798721,868353,876545]),c=[new Int32Array([459008,524368,524304,524568,459024,524400,524336,590016,459016,524384,524320,589984,524288,524416,524352,590048,459012,524376,524312,589968,459028,524408,524344,590032,459020,524392,524328,59e4,524296,524424,524360,590064,459010,524372,524308,524572,459026,524404,524340,590024,459018,524388,524324,589992,524292,524420,524356,590056,459014,524380,524316,589976,459030,524412,524348,590040,459022,524396,524332,590008,524300,524428,524364,590072,459009,524370,524306,524570,459025,524402,524338,590020,459017,524386,524322,589988,524290,524418,524354,590052,459013,524378,524314,589972,459029,524410,524346,590036,459021,524394,524330,590004,524298,524426,524362,590068,459011,524374,524310,524574,459027,524406,524342,590028,459019,524390,524326,589996,524294,524422,524358,590060,459015,524382,524318,589980,459031,524414,524350,590044,459023,524398,524334,590012,524302,524430,524366,590076,459008,524369,524305,524569,459024,524401,524337,590018,459016,524385,524321,589986,524289,524417,524353,590050,459012,524377,524313,589970,459028,524409,524345,590034,459020,524393,524329,590002,524297,524425,524361,590066,459010,524373,524309,524573,459026,524405,524341,590026,459018,524389,524325,589994,524293,524421,524357,590058,459014,524381,524317,589978,459030,524413,524349,590042,459022,524397,524333,590010,524301,524429,524365,590074,459009,524371,524307,524571,459025,524403,524339,590022,459017,524387,524323,589990,524291,524419,524355,590054,459013,524379,524315,589974,459029,524411,524347,590038,459021,524395,524331,590006,524299,524427,524363,590070,459011,524375,524311,524575,459027,524407,524343,590030,459019,524391,524327,589998,524295,524423,524359,590062,459015,524383,524319,589982,459031,524415,524351,590046,459023,524399,524335,590014,524303,524431,524367,590078,459008,524368,524304,524568,459024,524400,524336,590017,459016,524384,524320,589985,524288,524416,524352,590049,459012,524376,524312,589969,459028,524408,524344,590033,459020,524392,524328,590001,524296,524424,524360,590065,459010,524372,524308,524572,459026,524404,524340,590025,459018,524388,524324,589993,524292,524420,524356,590057,459014,524380,524316,589977,459030,524412,524348,590041,459022,524396,524332,590009,524300,524428,524364,590073,459009,524370,524306,524570,459025,524402,524338,590021,459017,524386,524322,589989,524290,524418,524354,590053,459013,524378,524314,589973,459029,524410,524346,590037,459021,524394,524330,590005,524298,524426,524362,590069,459011,524374,524310,524574,459027,524406,524342,590029,459019,524390,524326,589997,524294,524422,524358,590061,459015,524382,524318,589981,459031,524414,524350,590045,459023,524398,524334,590013,524302,524430,524366,590077,459008,524369,524305,524569,459024,524401,524337,590019,459016,524385,524321,589987,524289,524417,524353,590051,459012,524377,524313,589971,459028,524409,524345,590035,459020,524393,524329,590003,524297,524425,524361,590067,459010,524373,524309,524573,459026,524405,524341,590027,459018,524389,524325,589995,524293,524421,524357,590059,459014,524381,524317,589979,459030,524413,524349,590043,459022,524397,524333,590011,524301,524429,524365,590075,459009,524371,524307,524571,459025,524403,524339,590023,459017,524387,524323,589991,524291,524419,524355,590055,459013,524379,524315,589975,459029,524411,524347,590039,459021,524395,524331,590007,524299,524427,524363,590071,459011,524375,524311,524575,459027,524407,524343,590031,459019,524391,524327,589999,524295,524423,524359,590063,459015,524383,524319,589983,459031,524415,524351,590047,459023,524399,524335,590015,524303,524431,524367,590079]),9],l=[new Int32Array([327680,327696,327688,327704,327684,327700,327692,327708,327682,327698,327690,327706,327686,327702,327694,0,327681,327697,327689,327705,327685,327701,327693,327709,327683,327699,327691,327707,327687,327703,327695,0]),5];class FlateStream extends n.DecodeStream{constructor(e,t){super(t);this.str=e;this.dict=e.dict;const r=e.getByte(),n=e.getByte();if(-1===r||-1===n)throw new a.FormatError("Invalid header in flate stream: ".concat(r,", ").concat(n));if(8!=(15&r))throw new a.FormatError("Unknown compression method in flate stream: ".concat(r,", ").concat(n));if(((r<<8)+n)%31!=0)throw new a.FormatError("Bad FCHECK in flate stream: ".concat(r,", ").concat(n));if(32&n)throw new a.FormatError("FDICT bit set in flate stream: ".concat(r,", ").concat(n));this.codeSize=0;this.codeBuf=0}getBits(e){const t=this.str;let r,n=this.codeSize,i=this.codeBuf;for(;n<e;){if(-1===(r=t.getByte()))throw new a.FormatError("Bad encoding in flate stream");i|=r<<n;n+=8}r=i&(1<<e)-1;this.codeBuf=i>>e;this.codeSize=n-=e;return r}getCode(e){const t=this.str,r=e[0],n=e[1];let i,s=this.codeSize,o=this.codeBuf;for(;s<n&&-1!==(i=t.getByte());){o|=i<<s;s+=8}const c=r[o&(1<<n)-1],l=c>>16,h=65535&c;if(l<1||s<l)throw new a.FormatError("Bad encoding in flate stream");this.codeBuf=o>>l;this.codeSize=s-l;return h}generateHuffmanTable(e){const t=e.length;let r,n=0;for(r=0;r<t;++r)e[r]>n&&(n=e[r]);const a=1<<n,i=new Int32Array(a);for(let s=1,o=0,c=2;s<=n;++s,o<<=1,c<<=1)for(let n=0;n<t;++n)if(e[n]===s){let e=0,t=o;for(r=0;r<s;++r){e=e<<1|1&t;t>>=1}for(r=e;r<a;r+=c)i[r]=s<<16|n;++o}return[i,n]}readBlock(){let e,t;const r=this.str;let n,h,u=this.getBits(3);1&u&&(this.eof=!0);u>>=1;if(0===u){let t;if(-1===(t=r.getByte()))throw new a.FormatError("Bad block header in flate stream");let n=t;if(-1===(t=r.getByte()))throw new a.FormatError("Bad block header in flate stream");n|=t<<8;if(-1===(t=r.getByte()))throw new a.FormatError("Bad block header in flate stream");let i=t;if(-1===(t=r.getByte()))throw new a.FormatError("Bad block header in flate stream");i|=t<<8;if(i!==(65535&~n)&&(0!==n||0!==i))throw new a.FormatError("Bad uncompressed block length in flate stream");this.codeBuf=0;this.codeSize=0;const s=this.bufferLength,o=s+n;e=this.ensureBuffer(o);this.bufferLength=o;if(0===n)-1===r.peekByte()&&(this.eof=!0);else{const t=r.getBytes(n);e.set(t,s);t.length<n&&(this.eof=!0)}return}if(1===u){n=c;h=l}else{if(2!==u)throw new a.FormatError("Unknown block type in flate stream");{const e=this.getBits(5)+257,r=this.getBits(5)+1,a=this.getBits(4)+4,s=new Uint8Array(i.length);let o;for(o=0;o<a;++o)s[i[o]]=this.getBits(3);const c=this.generateHuffmanTable(s);t=0;o=0;const l=e+r,u=new Uint8Array(l);let d,f,g;for(;o<l;){const e=this.getCode(c);if(16===e){d=2;f=3;g=t}else if(17===e){d=3;f=3;g=t=0}else{if(18!==e){u[o++]=t=e;continue}d=7;f=11;g=t=0}let r=this.getBits(d)+f;for(;r-- >0;)u[o++]=g}n=this.generateHuffmanTable(u.subarray(0,e));h=this.generateHuffmanTable(u.subarray(e,l))}}e=this.buffer;let d=e?e.length:0,f=this.bufferLength;for(;;){let r=this.getCode(n);if(r<256){if(f+1>=d){e=this.ensureBuffer(f+1);d=e.length}e[f++]=r;continue}if(256===r){this.bufferLength=f;return}r-=257;r=s[r];let a=r>>16;a>0&&(a=this.getBits(a));t=(65535&r)+a;r=this.getCode(h);r=o[r];a=r>>16;a>0&&(a=this.getBits(a));const i=(65535&r)+a;if(f+t>=d){e=this.ensureBuffer(f+t);d=e.length}for(let r=0;r<t;++r,++f)e[f]=e[f-i]}}}t.FlateStream=FlateStream},(e,t,r)=>{r(126)("Int32",(function(e){return function Int32Array(t,r,n){return e(this,t,r,n)}}))},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.Jbig2Stream=void 0;var n=r(217),a=r(242),i=r(209),s=r(249),o=r(158);class Jbig2Stream extends a.DecodeStream{constructor(e,t,r){super(t);this.stream=e;this.dict=e.dict;this.maybeLength=t;this.params=r}get bytes(){return(0,o.shadow)(this,"bytes",this.stream.getBytes(this.maybeLength))}ensureBuffer(e){}readBlock(){if(this.eof)return;const e=new s.Jbig2Image,t=[];if(this.params instanceof i.Dict){const e=this.params.get("JBIG2Globals");if(e instanceof n.BaseStream){const r=e.getBytes();t.push({data:r,start:0,end:r.length})}}t.push({data:this.bytes,start:0,end:this.bytes.length});const r=e.parseChunks(t),a=r.length;for(let e=0;e<a;e++)r[e]^=255;this.buffer=r;this.bufferLength=a;this.eof=!0}}t.Jbig2Stream=Jbig2Stream},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.Jbig2Image=void 0;r(250);r(146);r(148);r(149);r(125);r(235);r(247);r(232);r(178);var n=r(158),a=r(213),i=r(251),s=r(245);class Jbig2Error extends n.BaseException{constructor(e){super("JBIG2 error: ".concat(e),"Jbig2Error")}}class ContextCache{getContexts(e){return e in this?this[e]:this[e]=new Int8Array(65536)}}class DecodingContext{constructor(e,t,r){this.data=e;this.start=t;this.end=r}get decoder(){const e=new i.ArithmeticDecoder(this.data,this.start,this.end);return(0,n.shadow)(this,"decoder",e)}get contextCache(){const e=new ContextCache;return(0,n.shadow)(this,"contextCache",e)}}function decodeInteger(e,t,r){const n=e.getContexts(t);let a=1;function readBits(e){let t=0;for(let i=0;i<e;i++){const e=r.readBit(n,a);a=a<256?a<<1|e:511&(a<<1|e)|256;t=t<<1|e}return t>>>0}const i=readBits(1),s=readBits(1)?readBits(1)?readBits(1)?readBits(1)?readBits(1)?readBits(32)+4436:readBits(12)+340:readBits(8)+84:readBits(6)+20:readBits(4)+4:readBits(2);return 0===i?s:s>0?-s:null}function decodeIAID(e,t,r){const n=e.getContexts("IAID");let a=1;for(let e=0;e<r;e++){a=a<<1|t.readBit(n,a)}return r<31?a&(1<<r)-1:2147483647&a}const o=["SymbolDictionary",null,null,null,"IntermediateTextRegion",null,"ImmediateTextRegion","ImmediateLosslessTextRegion",null,null,null,null,null,null,null,null,"PatternDictionary",null,null,null,"IntermediateHalftoneRegion",null,"ImmediateHalftoneRegion","ImmediateLosslessHalftoneRegion",null,null,null,null,null,null,null,null,null,null,null,null,"IntermediateGenericRegion",null,"ImmediateGenericRegion","ImmediateLosslessGenericRegion","IntermediateGenericRefinementRegion",null,"ImmediateGenericRefinementRegion","ImmediateLosslessGenericRefinementRegion",null,null,null,null,"PageInformation","EndOfPage","EndOfStripe","EndOfFile","Profiles","Tables",null,null,null,null,null,null,null,null,"Extension"],c=[[{x:-1,y:-2},{x:0,y:-2},{x:1,y:-2},{x:-2,y:-1},{x:-1,y:-1},{x:0,y:-1},{x:1,y:-1},{x:2,y:-1},{x:-4,y:0},{x:-3,y:0},{x:-2,y:0},{x:-1,y:0}],[{x:-1,y:-2},{x:0,y:-2},{x:1,y:-2},{x:2,y:-2},{x:-2,y:-1},{x:-1,y:-1},{x:0,y:-1},{x:1,y:-1},{x:2,y:-1},{x:-3,y:0},{x:-2,y:0},{x:-1,y:0}],[{x:-1,y:-2},{x:0,y:-2},{x:1,y:-2},{x:-2,y:-1},{x:-1,y:-1},{x:0,y:-1},{x:1,y:-1},{x:-2,y:0},{x:-1,y:0}],[{x:-3,y:-1},{x:-2,y:-1},{x:-1,y:-1},{x:0,y:-1},{x:1,y:-1},{x:-4,y:0},{x:-3,y:0},{x:-2,y:0},{x:-1,y:0}]],l=[{coding:[{x:0,y:-1},{x:1,y:-1},{x:-1,y:0}],reference:[{x:0,y:-1},{x:1,y:-1},{x:-1,y:0},{x:0,y:0},{x:1,y:0},{x:-1,y:1},{x:0,y:1},{x:1,y:1}]},{coding:[{x:-1,y:-1},{x:0,y:-1},{x:1,y:-1},{x:-1,y:0}],reference:[{x:0,y:-1},{x:-1,y:0},{x:0,y:0},{x:1,y:0},{x:0,y:1},{x:1,y:1}]}],h=[39717,1941,229,405],u=[32,8];function decodeBitmap(e,t,r,n,a,i,s,o){if(e){return decodeMMRBitmap(new Reader(o.data,o.start,o.end),t,r,!1)}if(0===n&&!i&&!a&&4===s.length&&3===s[0].x&&-1===s[0].y&&-3===s[1].x&&-1===s[1].y&&2===s[2].x&&-2===s[2].y&&-2===s[3].x&&-2===s[3].y)return function decodeBitmapTemplate0(e,t,r){const n=r.decoder,a=r.contextCache.getContexts("GB"),i=[];let s,o,c,l,h,u,d;for(o=0;o<t;o++){h=i[o]=new Uint8Array(e);u=o<1?h:i[o-1];d=o<2?h:i[o-2];s=d[0]<<13|d[1]<<12|d[2]<<11|u[0]<<7|u[1]<<6|u[2]<<5|u[3]<<4;for(c=0;c<e;c++){h[c]=l=n.readBit(a,s);s=(31735&s)<<1|(c+3<e?d[c+3]<<11:0)|(c+4<e?u[c+4]<<4:0)|l}}return i}(t,r,o);const l=!!i,u=c[n].concat(s);u.sort((function(e,t){return e.y-t.y||e.x-t.x}));const d=u.length,f=new Int8Array(d),g=new Int8Array(d),p=[];let m,b,y=0,w=0,S=0,x=0;for(b=0;b<d;b++){f[b]=u[b].x;g[b]=u[b].y;w=Math.min(w,u[b].x);S=Math.max(S,u[b].x);x=Math.min(x,u[b].y);b<d-1&&u[b].y===u[b+1].y&&u[b].x===u[b+1].x-1?y|=1<<d-1-b:p.push(b)}const v=p.length,k=new Int8Array(v),C=new Int8Array(v),O=new Uint16Array(v);for(m=0;m<v;m++){b=p[m];k[m]=u[b].x;C[m]=u[b].y;O[m]=1<<d-1-b}const T=-w,M=-x,E=t-S,D=h[n];let N=new Uint8Array(t);const R=[],L=o.decoder,j=o.contextCache.getContexts("GB");let _,U,$,X,H,q=0,W=0;for(let e=0;e<r;e++){if(a){q^=L.readBit(j,D);if(q){R.push(N);continue}}N=new Uint8Array(N);R.push(N);for(_=0;_<t;_++){if(l&&i[e][_]){N[_]=0;continue}if(_>=T&&_<E&&e>=M){W=W<<1&y;for(b=0;b<v;b++){U=e+C[b];$=_+k[b];X=R[U][$];if(X){X=O[b];W|=X}}}else{W=0;H=d-1;for(b=0;b<d;b++,H--){$=_+f[b];if($>=0&&$<t){U=e+g[b];if(U>=0){X=R[U][$];X&&(W|=X<<H)}}}}const r=L.readBit(j,W);N[_]=r}}return R}function decodeRefinement(e,t,r,n,a,i,s,o,c){let h=l[r].coding;0===r&&(h=h.concat([o[0]]));const d=h.length,f=new Int32Array(d),g=new Int32Array(d);let p;for(p=0;p<d;p++){f[p]=h[p].x;g[p]=h[p].y}let m=l[r].reference;0===r&&(m=m.concat([o[1]]));const b=m.length,y=new Int32Array(b),w=new Int32Array(b);for(p=0;p<b;p++){y[p]=m[p].x;w[p]=m[p].y}const S=n[0].length,x=n.length,v=u[r],k=[],C=c.decoder,O=c.contextCache.getContexts("GR");let T=0;for(let r=0;r<t;r++){if(s){T^=C.readBit(O,v);if(T)throw new Jbig2Error("prediction is not supported")}const t=new Uint8Array(e);k.push(t);for(let s=0;s<e;s++){let o,c,l=0;for(p=0;p<d;p++){o=r+g[p];c=s+f[p];o<0||c<0||c>=e?l<<=1:l=l<<1|k[o][c]}for(p=0;p<b;p++){o=r+w[p]-i;c=s+y[p]-a;o<0||o>=x||c<0||c>=S?l<<=1:l=l<<1|n[o][c]}const h=C.readBit(O,l);t[s]=h}}return k}function decodeTextRegion(e,t,r,n,a,i,s,o,c,l,h,u,d,f,g,p,m,b,y){if(e&&t)throw new Jbig2Error("refinement with Huffman is not supported");const w=[];let S,x;for(S=0;S<n;S++){x=new Uint8Array(r);if(a)for(let e=0;e<r;e++)x[e]=a;w.push(x)}const v=m.decoder,k=m.contextCache;let C=e?-f.tableDeltaT.decode(y):-decodeInteger(k,"IADT",v),O=0;S=0;for(;S<i;){C+=e?f.tableDeltaT.decode(y):decodeInteger(k,"IADT",v);O+=e?f.tableFirstS.decode(y):decodeInteger(k,"IAFS",v);let n=O;for(;;){let a=0;s>1&&(a=e?y.readBits(b):decodeInteger(k,"IAIT",v));const i=s*C+a,O=e?f.symbolIDTable.decode(y):decodeIAID(k,v,c),T=t&&(e?y.readBit():decodeInteger(k,"IARI",v));let M=o[O],E=M[0].length,D=M.length;if(T){const e=decodeInteger(k,"IARDW",v),t=decodeInteger(k,"IARDH",v),r=decodeInteger(k,"IARDX",v),n=decodeInteger(k,"IARDY",v);E+=e;D+=t;M=decodeRefinement(E,D,g,M,(e>>1)+r,(t>>1)+n,!1,p,m)}const N=i-(1&u?0:D-1),R=n-(2&u?E-1:0);let L,j,_;if(l){for(L=0;L<D;L++){x=w[R+L];if(!x)continue;_=M[L];const e=Math.min(r-N,E);switch(d){case 0:for(j=0;j<e;j++)x[N+j]|=_[j];break;case 2:for(j=0;j<e;j++)x[N+j]^=_[j];break;default:throw new Jbig2Error("operator ".concat(d," is not supported"))}}n+=D-1}else{for(j=0;j<D;j++){x=w[N+j];if(x){_=M[j];switch(d){case 0:for(L=0;L<E;L++)x[R+L]|=_[L];break;case 2:for(L=0;L<E;L++)x[R+L]^=_[L];break;default:throw new Jbig2Error("operator ".concat(d," is not supported"))}}}n+=E-1}S++;const U=e?f.tableDeltaS.decode(y):decodeInteger(k,"IADS",v);if(null===U)break;n+=U+h}}return w}function readSegmentHeader(e,t){const r={};r.number=(0,a.readUint32)(e,t);const n=e[t+4],i=63&n;if(!o[i])throw new Jbig2Error("invalid segment type: "+i);r.type=i;r.typeName=o[i];r.deferredNonRetain=!!(128&n);const s=!!(64&n),c=e[t+5];let l=c>>5&7;const h=[31&c];let u=t+6;if(7===c){l=536870911&(0,a.readUint32)(e,u-1);u+=3;let t=l+7>>3;h[0]=e[u++];for(;--t>0;)h.push(e[u++])}else if(5===c||6===c)throw new Jbig2Error("invalid referred-to flags");r.retainBits=h;let f=4;r.number<=256?f=1:r.number<=65536&&(f=2);const g=[];let p,m;for(p=0;p<l;p++){let t;t=1===f?e[u]:2===f?(0,a.readUint16)(e,u):(0,a.readUint32)(e,u);g.push(t);u+=f}r.referredTo=g;if(s){r.pageAssociation=(0,a.readUint32)(e,u);u+=4}else r.pageAssociation=e[u++];r.length=(0,a.readUint32)(e,u);u+=4;if(4294967295===r.length){if(38!==i)throw new Jbig2Error("invalid unknown segment length");{const t=readRegionSegmentInformation(e,u),n=!!(1&e[u+d]),a=6,i=new Uint8Array(a);if(!n){i[0]=255;i[1]=172}i[2]=t.height>>>24&255;i[3]=t.height>>16&255;i[4]=t.height>>8&255;i[5]=255&t.height;for(p=u,m=e.length;p<m;p++){let t=0;for(;t<a&&i[t]===e[p+t];)t++;if(t===a){r.length=p+a;break}}if(4294967295===r.length)throw new Jbig2Error("segment end was not found")}}r.headerEnd=u;return r}function readSegments(e,t,r,n){const a=[];let i=r;for(;i<n;){const r=readSegmentHeader(t,i);i=r.headerEnd;const n={header:r,data:t};if(!e.randomAccess){n.start=i;i+=r.length;n.end=i}a.push(n);if(51===r.type)break}if(e.randomAccess)for(let e=0,t=a.length;e<t;e++){a[e].start=i;i+=a[e].header.length;a[e].end=i}return a}function readRegionSegmentInformation(e,t){return{width:(0,a.readUint32)(e,t),height:(0,a.readUint32)(e,t+4),x:(0,a.readUint32)(e,t+8),y:(0,a.readUint32)(e,t+12),combinationOperator:7&e[t+16]}}const d=17;function processSegment(e,t){const r=e.header,n=e.data,i=e.end;let s,o,c,l,h=e.start;switch(r.type){case 0:const e={},t=(0,a.readUint16)(n,h);e.huffman=!!(1&t);e.refinement=!!(2&t);e.huffmanDHSelector=t>>2&3;e.huffmanDWSelector=t>>4&3;e.bitmapSizeSelector=t>>6&1;e.aggregationInstancesSelector=t>>7&1;e.bitmapCodingContextUsed=!!(256&t);e.bitmapCodingContextRetained=!!(512&t);e.template=t>>10&3;e.refinementTemplate=t>>12&1;h+=2;if(!e.huffman){l=0===e.template?4:1;o=[];for(c=0;c<l;c++){o.push({x:(0,a.readInt8)(n,h),y:(0,a.readInt8)(n,h+1)});h+=2}e.at=o}if(e.refinement&&!e.refinementTemplate){o=[];for(c=0;c<2;c++){o.push({x:(0,a.readInt8)(n,h),y:(0,a.readInt8)(n,h+1)});h+=2}e.refinementAt=o}e.numberOfExportedSymbols=(0,a.readUint32)(n,h);h+=4;e.numberOfNewSymbols=(0,a.readUint32)(n,h);h+=4;s=[e,r.number,r.referredTo,n,h,i];break;case 6:case 7:const u={};u.info=readRegionSegmentInformation(n,h);h+=d;const f=(0,a.readUint16)(n,h);h+=2;u.huffman=!!(1&f);u.refinement=!!(2&f);u.logStripSize=f>>2&3;u.stripSize=1<<u.logStripSize;u.referenceCorner=f>>4&3;u.transposed=!!(64&f);u.combinationOperator=f>>7&3;u.defaultPixelValue=f>>9&1;u.dsOffset=f<<17>>27;u.refinementTemplate=f>>15&1;if(u.huffman){const e=(0,a.readUint16)(n,h);h+=2;u.huffmanFS=3&e;u.huffmanDS=e>>2&3;u.huffmanDT=e>>4&3;u.huffmanRefinementDW=e>>6&3;u.huffmanRefinementDH=e>>8&3;u.huffmanRefinementDX=e>>10&3;u.huffmanRefinementDY=e>>12&3;u.huffmanRefinementSizeSelector=!!(16384&e)}if(u.refinement&&!u.refinementTemplate){o=[];for(c=0;c<2;c++){o.push({x:(0,a.readInt8)(n,h),y:(0,a.readInt8)(n,h+1)});h+=2}u.refinementAt=o}u.numberOfSymbolInstances=(0,a.readUint32)(n,h);h+=4;s=[u,r.referredTo,n,h,i];break;case 16:const g={},p=n[h++];g.mmr=!!(1&p);g.template=p>>1&3;g.patternWidth=n[h++];g.patternHeight=n[h++];g.maxPatternIndex=(0,a.readUint32)(n,h);h+=4;s=[g,r.number,n,h,i];break;case 22:case 23:const m={};m.info=readRegionSegmentInformation(n,h);h+=d;const b=n[h++];m.mmr=!!(1&b);m.template=b>>1&3;m.enableSkip=!!(8&b);m.combinationOperator=b>>4&7;m.defaultPixelValue=b>>7&1;m.gridWidth=(0,a.readUint32)(n,h);h+=4;m.gridHeight=(0,a.readUint32)(n,h);h+=4;m.gridOffsetX=4294967295&(0,a.readUint32)(n,h);h+=4;m.gridOffsetY=4294967295&(0,a.readUint32)(n,h);h+=4;m.gridVectorX=(0,a.readUint16)(n,h);h+=2;m.gridVectorY=(0,a.readUint16)(n,h);h+=2;s=[m,r.referredTo,n,h,i];break;case 38:case 39:const y={};y.info=readRegionSegmentInformation(n,h);h+=d;const w=n[h++];y.mmr=!!(1&w);y.template=w>>1&3;y.prediction=!!(8&w);if(!y.mmr){l=0===y.template?4:1;o=[];for(c=0;c<l;c++){o.push({x:(0,a.readInt8)(n,h),y:(0,a.readInt8)(n,h+1)});h+=2}y.at=o}s=[y,n,h,i];break;case 48:const S={width:(0,a.readUint32)(n,h),height:(0,a.readUint32)(n,h+4),resolutionX:(0,a.readUint32)(n,h+8),resolutionY:(0,a.readUint32)(n,h+12)};4294967295===S.height&&delete S.height;const x=n[h+16];(0,a.readUint16)(n,h+17);S.lossless=!!(1&x);S.refinement=!!(2&x);S.defaultPixelValue=x>>2&1;S.combinationOperator=x>>3&3;S.requiresBuffer=!!(32&x);S.combinationOperatorOverride=!!(64&x);s=[S];break;case 49:case 50:case 51:case 62:break;case 53:s=[r.number,n,h,i];break;default:throw new Jbig2Error("segment type ".concat(r.typeName,"(").concat(r.type,") is not implemented"))}const u="on"+r.typeName;u in t&&t[u].apply(t,s)}function processSegments(e,t){for(let r=0,n=e.length;r<n;r++)processSegment(e[r],t)}class SimpleSegmentVisitor{onPageInformation(e){this.currentPageInfo=e;const t=e.width+7>>3,r=new Uint8ClampedArray(t*e.height);e.defaultPixelValue&&r.fill(255);this.buffer=r}drawBitmap(e,t){const r=this.currentPageInfo,n=e.width,a=e.height,i=r.width+7>>3,s=r.combinationOperatorOverride?e.combinationOperator:r.combinationOperator,o=this.buffer,c=128>>(7&e.x);let l,h,u,d,f=e.y*i+(e.x>>3);switch(s){case 0:for(l=0;l<a;l++){u=c;d=f;for(h=0;h<n;h++){t[l][h]&&(o[d]|=u);u>>=1;if(!u){u=128;d++}}f+=i}break;case 2:for(l=0;l<a;l++){u=c;d=f;for(h=0;h<n;h++){t[l][h]&&(o[d]^=u);u>>=1;if(!u){u=128;d++}}f+=i}break;default:throw new Jbig2Error("operator ".concat(s," is not supported"))}}onImmediateGenericRegion(e,t,r,n){const a=e.info,i=new DecodingContext(t,r,n),s=decodeBitmap(e.mmr,a.width,a.height,e.template,e.prediction,null,e.at,i);this.drawBitmap(a,s)}onImmediateLosslessGenericRegion(){this.onImmediateGenericRegion.apply(this,arguments)}onSymbolDictionary(e,t,r,n,i,s){let o,c;if(e.huffman){o=function getSymbolDictionaryHuffmanTables(e,t,r){let n,a,i,s,o=0;switch(e.huffmanDHSelector){case 0:case 1:n=getStandardTable(e.huffmanDHSelector+4);break;case 3:n=getCustomHuffmanTable(o,t,r);o++;break;default:throw new Jbig2Error("invalid Huffman DH selector")}switch(e.huffmanDWSelector){case 0:case 1:a=getStandardTable(e.huffmanDWSelector+2);break;case 3:a=getCustomHuffmanTable(o,t,r);o++;break;default:throw new Jbig2Error("invalid Huffman DW selector")}if(e.bitmapSizeSelector){i=getCustomHuffmanTable(o,t,r);o++}else i=getStandardTable(1);s=e.aggregationInstancesSelector?getCustomHuffmanTable(o,t,r):getStandardTable(1);return{tableDeltaHeight:n,tableDeltaWidth:a,tableBitmapSize:i,tableAggregateInstances:s}}(e,r,this.customTables);c=new Reader(n,i,s)}let l=this.symbols;l||(this.symbols=l={});let h=[];for(let e=0,t=r.length;e<t;e++){const t=l[r[e]];t&&(h=h.concat(t))}const u=new DecodingContext(n,i,s);l[t]=function decodeSymbolDictionary(e,t,r,n,i,s,o,c,l,h,u,d){if(e&&t)throw new Jbig2Error("symbol refinement with Huffman is not supported");const f=[];let g=0,p=(0,a.log2)(r.length+n);const m=u.decoder,b=u.contextCache;let y,w;if(e){y=getStandardTable(1);w=[];p=Math.max(p,1)}for(;f.length<n;){g+=e?s.tableDeltaHeight.decode(d):decodeInteger(b,"IADH",m);let n=0,a=0;const i=e?w.length:0;for(;;){const i=e?s.tableDeltaWidth.decode(d):decodeInteger(b,"IADW",m);if(null===i)break;n+=i;a+=n;let y;if(t){const a=decodeInteger(b,"IAAI",m);if(a>1)y=decodeTextRegion(e,t,n,g,0,a,1,r.concat(f),p,0,0,1,0,s,l,h,u,0,d);else{const e=decodeIAID(b,m,p),t=decodeInteger(b,"IARDX",m),a=decodeInteger(b,"IARDY",m);y=decodeRefinement(n,g,l,e<r.length?r[e]:f[e-r.length],t,a,!1,h,u)}f.push(y)}else if(e)w.push(n);else{y=decodeBitmap(!1,n,g,o,!1,null,c,u);f.push(y)}}if(e&&!t){const e=s.tableBitmapSize.decode(d);d.byteAlign();let t;if(0===e)t=readUncompressedBitmap(d,a,g);else{const r=d.end,n=d.position+e;d.end=n;t=decodeMMRBitmap(d,a,g,!1);d.end=r;d.position=n}const r=w.length;if(i===r-1)f.push(t);else{let e,n,a,s,o,c=0;for(e=i;e<r;e++){s=w[e];a=c+s;o=[];for(n=0;n<g;n++)o.push(t[n].subarray(c,a));f.push(o);c=a}}}}const S=[],x=[];let v,k,C=!1;const O=r.length+n;for(;x.length<O;){let t=e?y.decode(d):decodeInteger(b,"IAEX",m);for(;t--;)x.push(C);C=!C}for(v=0,k=r.length;v<k;v++)x[v]&&S.push(r[v]);for(let e=0;e<n;v++,e++)x[v]&&S.push(f[e]);return S}(e.huffman,e.refinement,h,e.numberOfNewSymbols,e.numberOfExportedSymbols,o,e.template,e.at,e.refinementTemplate,e.refinementAt,u,c)}onImmediateTextRegion(e,t,r,n,i){const s=e.info;let o,c;const l=this.symbols;let h=[];for(let e=0,r=t.length;e<r;e++){const r=l[t[e]];r&&(h=h.concat(r))}const u=(0,a.log2)(h.length);if(e.huffman){c=new Reader(r,n,i);o=function getTextRegionHuffmanTables(e,t,r,n,a){const i=[];for(let e=0;e<=34;e++){const t=a.readBits(4);i.push(new HuffmanLine([e,t,0,0]))}const s=new HuffmanTable(i,!1);i.length=0;for(let e=0;e<n;){const t=s.decode(a);if(t>=32){let r,n,s;switch(t){case 32:if(0===e)throw new Jbig2Error("no previous value in symbol ID table");n=a.readBits(2)+3;r=i[e-1].prefixLength;break;case 33:n=a.readBits(3)+3;r=0;break;case 34:n=a.readBits(7)+11;r=0;break;default:throw new Jbig2Error("invalid code length in symbol ID table")}for(s=0;s<n;s++){i.push(new HuffmanLine([e,r,0,0]));e++}}else{i.push(new HuffmanLine([e,t,0,0]));e++}}a.byteAlign();const o=new HuffmanTable(i,!1);let c,l,h,u=0;switch(e.huffmanFS){case 0:case 1:c=getStandardTable(e.huffmanFS+6);break;case 3:c=getCustomHuffmanTable(u,t,r);u++;break;default:throw new Jbig2Error("invalid Huffman FS selector")}switch(e.huffmanDS){case 0:case 1:case 2:l=getStandardTable(e.huffmanDS+8);break;case 3:l=getCustomHuffmanTable(u,t,r);u++;break;default:throw new Jbig2Error("invalid Huffman DS selector")}switch(e.huffmanDT){case 0:case 1:case 2:h=getStandardTable(e.huffmanDT+11);break;case 3:h=getCustomHuffmanTable(u,t,r);u++;break;default:throw new Jbig2Error("invalid Huffman DT selector")}if(e.refinement)throw new Jbig2Error("refinement with Huffman is not supported");return{symbolIDTable:o,tableFirstS:c,tableDeltaS:l,tableDeltaT:h}}(e,t,this.customTables,h.length,c)}const d=new DecodingContext(r,n,i),f=decodeTextRegion(e.huffman,e.refinement,s.width,s.height,e.defaultPixelValue,e.numberOfSymbolInstances,e.stripSize,h,u,e.transposed,e.dsOffset,e.referenceCorner,e.combinationOperator,o,e.refinementTemplate,e.refinementAt,d,e.logStripSize,c);this.drawBitmap(s,f)}onImmediateLosslessTextRegion(){this.onImmediateTextRegion.apply(this,arguments)}onPatternDictionary(e,t,r,n,a){let i=this.patterns;i||(this.patterns=i={});const s=new DecodingContext(r,n,a);i[t]=function decodePatternDictionary(e,t,r,n,a,i){const s=[];if(!e){s.push({x:-t,y:0});0===a&&s.push({x:-3,y:-1},{x:2,y:-2},{x:-2,y:-2})}const o=decodeBitmap(e,(n+1)*t,r,a,!1,null,s,i),c=[];for(let e=0;e<=n;e++){const n=[],a=t*e,i=a+t;for(let e=0;e<r;e++)n.push(o[e].subarray(a,i));c.push(n)}return c}(e.mmr,e.patternWidth,e.patternHeight,e.maxPatternIndex,e.template,s)}onImmediateHalftoneRegion(e,t,r,n,i){const s=this.patterns[t[0]],o=e.info,c=new DecodingContext(r,n,i),l=function decodeHalftoneRegion(e,t,r,n,i,s,o,c,l,h,u,d,f,g,p){if(o)throw new Jbig2Error("skip is not supported");if(0!==c)throw new Jbig2Error('operator "'.concat(c,'" is not supported in halftone region'));const m=[];let b,y,w;for(b=0;b<i;b++){w=new Uint8Array(n);if(s)for(y=0;y<n;y++)w[y]=s;m.push(w)}const S=t.length,x=t[0],v=x[0].length,k=x.length,C=(0,a.log2)(S),O=[];if(!e){O.push({x:r<=1?3:2,y:-1});0===r&&O.push({x:-3,y:-1},{x:2,y:-2},{x:-2,y:-2})}const T=[];let M,E,D,N,R,L,j,_,U,$,X;e&&(M=new Reader(p.data,p.start,p.end));for(b=C-1;b>=0;b--){E=e?decodeMMRBitmap(M,l,h,!0):decodeBitmap(!1,l,h,r,!1,null,O,p);T[b]=E}for(D=0;D<h;D++)for(N=0;N<l;N++){R=0;L=0;for(y=C-1;y>=0;y--){R^=T[y][D][N];L|=R<<y}j=t[L];_=u+D*g+N*f>>8;U=d+D*f-N*g>>8;if(_>=0&&_+v<=n&&U>=0&&U+k<=i)for(b=0;b<k;b++){X=m[U+b];$=j[b];for(y=0;y<v;y++)X[_+y]|=$[y]}else{let e,t;for(b=0;b<k;b++){t=U+b;if(!(t<0||t>=i)){X=m[t];$=j[b];for(y=0;y<v;y++){e=_+y;e>=0&&e<n&&(X[e]|=$[y])}}}}}return m}(e.mmr,s,e.template,o.width,o.height,e.defaultPixelValue,e.enableSkip,e.combinationOperator,e.gridWidth,e.gridHeight,e.gridOffsetX,e.gridOffsetY,e.gridVectorX,e.gridVectorY,c);this.drawBitmap(o,l)}onImmediateLosslessHalftoneRegion(){this.onImmediateHalftoneRegion.apply(this,arguments)}onTables(e,t,r,n){let i=this.customTables;i||(this.customTables=i={});i[e]=function decodeTablesSegment(e,t,r){const n=e[t],i=4294967295&(0,a.readUint32)(e,t+1),s=4294967295&(0,a.readUint32)(e,t+5),o=new Reader(e,t+9,r),c=1+(n>>1&7),l=1+(n>>4&7),h=[];let u,d,f=i;do{u=o.readBits(c);d=o.readBits(l);h.push(new HuffmanLine([f,u,d,0]));f+=1<<d}while(f<s);u=o.readBits(c);h.push(new HuffmanLine([i-1,u,32,0,"lower"]));u=o.readBits(c);h.push(new HuffmanLine([s,u,32,0]));if(1&n){u=o.readBits(c);h.push(new HuffmanLine([u,0]))}return new HuffmanTable(h,!1)}(t,r,n)}}class HuffmanLine{constructor(e){if(2===e.length){this.isOOB=!0;this.rangeLow=0;this.prefixLength=e[0];this.rangeLength=0;this.prefixCode=e[1];this.isLowerRange=!1}else{this.isOOB=!1;this.rangeLow=e[0];this.prefixLength=e[1];this.rangeLength=e[2];this.prefixCode=e[3];this.isLowerRange="lower"===e[4]}}}class HuffmanTreeNode{constructor(e){this.children=[];if(e){this.isLeaf=!0;this.rangeLength=e.rangeLength;this.rangeLow=e.rangeLow;this.isLowerRange=e.isLowerRange;this.isOOB=e.isOOB}else this.isLeaf=!1}buildTree(e,t){const r=e.prefixCode>>t&1;if(t<=0)this.children[r]=new HuffmanTreeNode(e);else{let n=this.children[r];n||(this.children[r]=n=new HuffmanTreeNode(null));n.buildTree(e,t-1)}}decodeNode(e){if(this.isLeaf){if(this.isOOB)return null;const t=e.readBits(this.rangeLength);return this.rangeLow+(this.isLowerRange?-t:t)}const t=this.children[e.readBit()];if(!t)throw new Jbig2Error("invalid Huffman data");return t.decodeNode(e)}}class HuffmanTable{constructor(e,t){t||this.assignPrefixCodes(e);this.rootNode=new HuffmanTreeNode(null);for(let t=0,r=e.length;t<r;t++){const r=e[t];r.prefixLength>0&&this.rootNode.buildTree(r,r.prefixLength-1)}}decode(e){return this.rootNode.decodeNode(e)}assignPrefixCodes(e){const t=e.length;let r=0;for(let n=0;n<t;n++)r=Math.max(r,e[n].prefixLength);const n=new Uint32Array(r+1);for(let r=0;r<t;r++)n[e[r].prefixLength]++;let a,i,s,o=1,c=0;n[0]=0;for(;o<=r;){c=c+n[o-1]<<1;a=c;i=0;for(;i<t;){s=e[i];if(s.prefixLength===o){s.prefixCode=a;a++}i++}o++}}}const f={};function getStandardTable(e){let t,r=f[e];if(r)return r;switch(e){case 1:t=[[0,1,4,0],[16,2,8,2],[272,3,16,6],[65808,3,32,7]];break;case 2:t=[[0,1,0,0],[1,2,0,2],[2,3,0,6],[3,4,3,14],[11,5,6,30],[75,6,32,62],[6,63]];break;case 3:t=[[-256,8,8,254],[0,1,0,0],[1,2,0,2],[2,3,0,6],[3,4,3,14],[11,5,6,30],[-257,8,32,255,"lower"],[75,7,32,126],[6,62]];break;case 4:t=[[1,1,0,0],[2,2,0,2],[3,3,0,6],[4,4,3,14],[12,5,6,30],[76,5,32,31]];break;case 5:t=[[-255,7,8,126],[1,1,0,0],[2,2,0,2],[3,3,0,6],[4,4,3,14],[12,5,6,30],[-256,7,32,127,"lower"],[76,6,32,62]];break;case 6:t=[[-2048,5,10,28],[-1024,4,9,8],[-512,4,8,9],[-256,4,7,10],[-128,5,6,29],[-64,5,5,30],[-32,4,5,11],[0,2,7,0],[128,3,7,2],[256,3,8,3],[512,4,9,12],[1024,4,10,13],[-2049,6,32,62,"lower"],[2048,6,32,63]];break;case 7:t=[[-1024,4,9,8],[-512,3,8,0],[-256,4,7,9],[-128,5,6,26],[-64,5,5,27],[-32,4,5,10],[0,4,5,11],[32,5,5,28],[64,5,6,29],[128,4,7,12],[256,3,8,1],[512,3,9,2],[1024,3,10,3],[-1025,5,32,30,"lower"],[2048,5,32,31]];break;case 8:t=[[-15,8,3,252],[-7,9,1,508],[-5,8,1,253],[-3,9,0,509],[-2,7,0,124],[-1,4,0,10],[0,2,1,0],[2,5,0,26],[3,6,0,58],[4,3,4,4],[20,6,1,59],[22,4,4,11],[38,4,5,12],[70,5,6,27],[134,5,7,28],[262,6,7,60],[390,7,8,125],[646,6,10,61],[-16,9,32,510,"lower"],[1670,9,32,511],[2,1]];break;case 9:t=[[-31,8,4,252],[-15,9,2,508],[-11,8,2,253],[-7,9,1,509],[-5,7,1,124],[-3,4,1,10],[-1,3,1,2],[1,3,1,3],[3,5,1,26],[5,6,1,58],[7,3,5,4],[39,6,2,59],[43,4,5,11],[75,4,6,12],[139,5,7,27],[267,5,8,28],[523,6,8,60],[779,7,9,125],[1291,6,11,61],[-32,9,32,510,"lower"],[3339,9,32,511],[2,0]];break;case 10:t=[[-21,7,4,122],[-5,8,0,252],[-4,7,0,123],[-3,5,0,24],[-2,2,2,0],[2,5,0,25],[3,6,0,54],[4,7,0,124],[5,8,0,253],[6,2,6,1],[70,5,5,26],[102,6,5,55],[134,6,6,56],[198,6,7,57],[326,6,8,58],[582,6,9,59],[1094,6,10,60],[2118,7,11,125],[-22,8,32,254,"lower"],[4166,8,32,255],[2,2]];break;case 11:t=[[1,1,0,0],[2,2,1,2],[4,4,0,12],[5,4,1,13],[7,5,1,28],[9,5,2,29],[13,6,2,60],[17,7,2,122],[21,7,3,123],[29,7,4,124],[45,7,5,125],[77,7,6,126],[141,7,32,127]];break;case 12:t=[[1,1,0,0],[2,2,0,2],[3,3,1,6],[5,5,0,28],[6,5,1,29],[8,6,1,60],[10,7,0,122],[11,7,1,123],[13,7,2,124],[17,7,3,125],[25,7,4,126],[41,8,5,254],[73,8,32,255]];break;case 13:t=[[1,1,0,0],[2,3,0,4],[3,4,0,12],[4,5,0,28],[5,4,1,13],[7,3,3,5],[15,6,1,58],[17,6,2,59],[21,6,3,60],[29,6,4,61],[45,6,5,62],[77,7,6,126],[141,7,32,127]];break;case 14:t=[[-2,3,0,4],[-1,3,0,5],[0,1,0,0],[1,3,0,6],[2,3,0,7]];break;case 15:t=[[-24,7,4,124],[-8,6,2,60],[-4,5,1,28],[-2,4,0,12],[-1,3,0,4],[0,1,0,0],[1,3,0,5],[2,4,0,13],[3,5,1,29],[5,6,2,61],[9,7,4,125],[-25,7,32,126,"lower"],[25,7,32,127]];break;default:throw new Jbig2Error("standard table B.".concat(e," does not exist"))}for(let e=0,r=t.length;e<r;e++)t[e]=new HuffmanLine(t[e]);r=new HuffmanTable(t,!0);f[e]=r;return r}class Reader{constructor(e,t,r){this.data=e;this.start=t;this.end=r;this.position=t;this.shift=-1;this.currentByte=0}readBit(){if(this.shift<0){if(this.position>=this.end)throw new Jbig2Error("end of data while reading bit");this.currentByte=this.data[this.position++];this.shift=7}const e=this.currentByte>>this.shift&1;this.shift--;return e}readBits(e){let t,r=0;for(t=e-1;t>=0;t--)r|=this.readBit()<<t;return r}byteAlign(){this.shift=-1}next(){return this.position>=this.end?-1:this.data[this.position++]}}function getCustomHuffmanTable(e,t,r){let n=0;for(let a=0,i=t.length;a<i;a++){const i=r[t[a]];if(i){if(e===n)return i;n++}}throw new Jbig2Error("can't find custom Huffman table")}function readUncompressedBitmap(e,t,r){const n=[];for(let a=0;a<r;a++){const r=new Uint8Array(t);n.push(r);for(let n=0;n<t;n++)r[n]=e.readBit();e.byteAlign()}return n}function decodeMMRBitmap(e,t,r,n){const a={K:-1,Columns:t,Rows:r,BlackIs1:!0,EndOfBlock:n},i=new s.CCITTFaxDecoder(e,a),o=[];let c,l=!1;for(let e=0;e<r;e++){const e=new Uint8Array(t);o.push(e);let r=-1;for(let n=0;n<t;n++){if(r<0){c=i.readNextChar();if(-1===c){c=0;l=!0}r=7}e[n]=c>>r&1;r--}}if(n&&!l){const e=5;for(let t=0;t<e&&-1!==i.readNextChar();t++);}return o}t.Jbig2Image=class Jbig2Image{parseChunks(e){return function parseJbig2Chunks(e){const t=new SimpleSegmentVisitor;for(let r=0,n=e.length;r<n;r++){const n=e[r];processSegments(readSegments({},n.data,n.start,n.end),t)}return t.buffer}(e)}parse(e){throw new Error("Not implemented: Jbig2Image.parse")}}},(e,t,r)=>{r(126)("Int8",(function(e){return function Int8Array(t,r,n){return e(this,t,r,n)}}))},(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.ArithmeticDecoder=void 0;const r=[{qe:22017,nmps:1,nlps:1,switchFlag:1},{qe:13313,nmps:2,nlps:6,switchFlag:0},{qe:6145,nmps:3,nlps:9,switchFlag:0},{qe:2753,nmps:4,nlps:12,switchFlag:0},{qe:1313,nmps:5,nlps:29,switchFlag:0},{qe:545,nmps:38,nlps:33,switchFlag:0},{qe:22017,nmps:7,nlps:6,switchFlag:1},{qe:21505,nmps:8,nlps:14,switchFlag:0},{qe:18433,nmps:9,nlps:14,switchFlag:0},{qe:14337,nmps:10,nlps:14,switchFlag:0},{qe:12289,nmps:11,nlps:17,switchFlag:0},{qe:9217,nmps:12,nlps:18,switchFlag:0},{qe:7169,nmps:13,nlps:20,switchFlag:0},{qe:5633,nmps:29,nlps:21,switchFlag:0},{qe:22017,nmps:15,nlps:14,switchFlag:1},{qe:21505,nmps:16,nlps:14,switchFlag:0},{qe:20737,nmps:17,nlps:15,switchFlag:0},{qe:18433,nmps:18,nlps:16,switchFlag:0},{qe:14337,nmps:19,nlps:17,switchFlag:0},{qe:13313,nmps:20,nlps:18,switchFlag:0},{qe:12289,nmps:21,nlps:19,switchFlag:0},{qe:10241,nmps:22,nlps:19,switchFlag:0},{qe:9217,nmps:23,nlps:20,switchFlag:0},{qe:8705,nmps:24,nlps:21,switchFlag:0},{qe:7169,nmps:25,nlps:22,switchFlag:0},{qe:6145,nmps:26,nlps:23,switchFlag:0},{qe:5633,nmps:27,nlps:24,switchFlag:0},{qe:5121,nmps:28,nlps:25,switchFlag:0},{qe:4609,nmps:29,nlps:26,switchFlag:0},{qe:4353,nmps:30,nlps:27,switchFlag:0},{qe:2753,nmps:31,nlps:28,switchFlag:0},{qe:2497,nmps:32,nlps:29,switchFlag:0},{qe:2209,nmps:33,nlps:30,switchFlag:0},{qe:1313,nmps:34,nlps:31,switchFlag:0},{qe:1089,nmps:35,nlps:32,switchFlag:0},{qe:673,nmps:36,nlps:33,switchFlag:0},{qe:545,nmps:37,nlps:34,switchFlag:0},{qe:321,nmps:38,nlps:35,switchFlag:0},{qe:273,nmps:39,nlps:36,switchFlag:0},{qe:133,nmps:40,nlps:37,switchFlag:0},{qe:73,nmps:41,nlps:38,switchFlag:0},{qe:37,nmps:42,nlps:39,switchFlag:0},{qe:21,nmps:43,nlps:40,switchFlag:0},{qe:9,nmps:44,nlps:41,switchFlag:0},{qe:5,nmps:45,nlps:42,switchFlag:0},{qe:1,nmps:45,nlps:43,switchFlag:0},{qe:22017,nmps:46,nlps:46,switchFlag:0}];t.ArithmeticDecoder=class ArithmeticDecoder{constructor(e,t,r){this.data=e;this.bp=t;this.dataEnd=r;this.chigh=e[t];this.clow=0;this.byteIn();this.chigh=this.chigh<<7&65535|this.clow>>9&127;this.clow=this.clow<<7&65535;this.ct-=7;this.a=32768}byteIn(){const e=this.data;let t=this.bp;if(255===e[t])if(e[t+1]>143){this.clow+=65280;this.ct=8}else{t++;this.clow+=e[t]<<9;this.ct=7;this.bp=t}else{t++;this.clow+=t<this.dataEnd?e[t]<<8:65280;this.ct=8;this.bp=t}if(this.clow>65535){this.chigh+=this.clow>>16;this.clow&=65535}}readBit(e,t){let n=e[t]>>1,a=1&e[t];const i=r[n],s=i.qe;let o,c=this.a-s;if(this.chigh<s)if(c<s){c=s;o=a;n=i.nmps}else{c=s;o=1^a;1===i.switchFlag&&(a=o);n=i.nlps}else{this.chigh-=s;if(0!=(32768&c)){this.a=c;return a}if(c<s){o=1^a;1===i.switchFlag&&(a=o);n=i.nlps}else{o=a;n=i.nmps}}do{0===this.ct&&this.byteIn();c<<=1;this.chigh=this.chigh<<1&65535|this.clow>>15&1;this.clow=this.clow<<1&65535;this.ct--}while(0==(32768&c));this.a=c;e[t]=n<<1|a;return o}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.JpegStream=void 0;r(247);r(146);r(148);r(149);var n=r(242),a=r(209),i=r(253),s=r(158);class JpegStream extends n.DecodeStream{constructor(e,t,r){let n;for(;-1!==(n=e.getByte());)if(255===n){e.skip(-1);break}super(t);this.stream=e;this.dict=e.dict;this.maybeLength=t;this.params=r}get bytes(){return(0,s.shadow)(this,"bytes",this.stream.getBytes(this.maybeLength))}ensureBuffer(e){}readBlock(){if(this.eof)return;const e={decodeTransform:void 0,colorTransform:void 0},t=this.dict.getArray("D","Decode");if(this.forceRGB&&Array.isArray(t)){const r=this.dict.get("BPC","BitsPerComponent")||8,n=t.length,a=new Int32Array(n);let i=!1;const s=(1<<r)-1;for(let e=0;e<n;e+=2){a[e]=256*(t[e+1]-t[e])|0;a[e+1]=t[e]*s|0;256===a[e]&&0===a[e+1]||(i=!0)}i&&(e.decodeTransform=a)}if(this.params instanceof a.Dict){const t=this.params.get("ColorTransform");Number.isInteger(t)&&(e.colorTransform=t)}const r=new i.JpegImage(e);r.parse(this.bytes);const n=r.getData({width:this.drawWidth,height:this.drawHeight,forceRGB:this.forceRGB,isSourcePDF:!0});this.buffer=n;this.bufferLength=n.length;this.eof=!0}}t.JpegStream=JpegStream},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.JpegImage=void 0;r(125);r(146);r(148);r(149);r(254);r(235);r(232);r(178);r(247);var n=r(158),a=r(213);class JpegError extends n.BaseException{constructor(e){super("JPEG error: ".concat(e),"JpegError")}}class DNLMarkerError extends n.BaseException{constructor(e,t){super(e,"DNLMarkerError");this.scanLines=t}}class EOIMarkerError extends n.BaseException{constructor(e){super(e,"EOIMarkerError")}}const i=new Uint8Array([0,1,8,16,9,2,3,10,17,24,32,25,18,11,4,5,12,19,26,33,40,48,41,34,27,20,13,6,7,14,21,28,35,42,49,56,57,50,43,36,29,22,15,23,30,37,44,51,58,59,52,45,38,31,39,46,53,60,61,54,47,55,62,63]),s=4017,o=799,c=3406,l=2276,h=1567,u=3784,d=5793,f=2896;function buildHuffmanTable(e,t){let r,n,a=0,i=16;for(;i>0&&!e[i-1];)i--;const s=[{children:[],index:0}];let o,c=s[0];for(r=0;r<i;r++){for(n=0;n<e[r];n++){c=s.pop();c.children[c.index]=t[a];for(;c.index>0;)c=s.pop();c.index++;s.push(c);for(;s.length<=r;){s.push(o={children:[],index:0});c.children[c.index]=o.children;c=o}a++}if(r+1<i){s.push(o={children:[],index:0});c.children[c.index]=o.children;c=o}}return s[0].children}function getBlockBufferOffset(e,t,r){return 64*((e.blocksPerLine+1)*t+r)}function decodeScan(e,t,r,s,o,c,l,h,u){let d=arguments.length>9&&void 0!==arguments[9]&&arguments[9];const f=r.mcusPerLine,g=r.progressive,p=t;let m=0,b=0;function readBit(){if(b>0){b--;return m>>b&1}m=e[t++];if(255===m){const n=e[t++];if(n){if(220===n&&d){t+=2;const n=(0,a.readUint16)(e,t);t+=2;if(n>0&&n!==r.scanLines)throw new DNLMarkerError("Found DNL marker (0xFFDC) while parsing scan data",n)}else if(217===n){if(d){const e=x*(8===r.precision?8:0);if(e>0&&Math.round(r.scanLines/e)>=10)throw new DNLMarkerError("Found EOI marker (0xFFD9) while parsing scan data, possibly caused by incorrect `scanLines` parameter",e)}throw new EOIMarkerError("Found EOI marker (0xFFD9) while parsing scan data")}throw new JpegError("unexpected marker ".concat((m<<8|n).toString(16)))}}b=7;return m>>>7}function decodeHuffman(e){let t=e;for(;;){t=t[readBit()];switch(typeof t){case"number":return t;case"object":continue}throw new JpegError("invalid huffman sequence")}}function receive(e){let t=0;for(;e>0;){t=t<<1|readBit();e--}return t}function receiveAndExtend(e){if(1===e)return 1===readBit()?1:-1;const t=receive(e);return t>=1<<e-1?t:t+(-1<<e)+1}function decodeBaseline(e,t){const r=decodeHuffman(e.huffmanTableDC),n=0===r?0:receiveAndExtend(r);e.blockData[t]=e.pred+=n;let a=1;for(;a<64;){const r=decodeHuffman(e.huffmanTableAC),n=15&r,s=r>>4;if(0===n){if(s<15)break;a+=16;continue}a+=s;const o=i[a];e.blockData[t+o]=receiveAndExtend(n);a++}}function decodeDCFirst(e,t){const r=decodeHuffman(e.huffmanTableDC),n=0===r?0:receiveAndExtend(r)<<u;e.blockData[t]=e.pred+=n}function decodeDCSuccessive(e,t){e.blockData[t]|=readBit()<<u}let y=0;function decodeACFirst(e,t){if(y>0){y--;return}let r=c;const n=l;for(;r<=n;){const n=decodeHuffman(e.huffmanTableAC),a=15&n,s=n>>4;if(0===a){if(s<15){y=receive(s)+(1<<s)-1;break}r+=16;continue}r+=s;const o=i[r];e.blockData[t+o]=receiveAndExtend(a)*(1<<u);r++}}let w,S=0;function decodeACSuccessive(e,t){let r=c;const n=l;let a,s,o=0;for(;r<=n;){const n=t+i[r],c=e.blockData[n]<0?-1:1;switch(S){case 0:s=decodeHuffman(e.huffmanTableAC);a=15&s;o=s>>4;if(0===a)if(o<15){y=receive(o)+(1<<o);S=4}else{o=16;S=1}else{if(1!==a)throw new JpegError("invalid ACn encoding");w=receiveAndExtend(a);S=o?2:3}continue;case 1:case 2:if(e.blockData[n])e.blockData[n]+=c*(readBit()<<u);else{o--;0===o&&(S=2===S?3:0)}break;case 3:if(e.blockData[n])e.blockData[n]+=c*(readBit()<<u);else{e.blockData[n]=w<<u;S=0}break;case 4:e.blockData[n]&&(e.blockData[n]+=c*(readBit()<<u))}r++}if(4===S){y--;0===y&&(S=0)}}let x=0;function decodeMcu(e,t,r,n,a){const i=r%f;x=(r/f|0)*e.v+n;const s=i*e.h+a;t(e,getBlockBufferOffset(e,x,s))}function decodeBlock(e,t,r){x=r/e.blocksPerLine|0;const n=r%e.blocksPerLine;t(e,getBlockBufferOffset(e,x,n))}const v=s.length;let k,C,O,T,M,E;E=g?0===c?0===h?decodeDCFirst:decodeDCSuccessive:0===h?decodeACFirst:decodeACSuccessive:decodeBaseline;let D,N,R,L,j=0;N=1===v?s[0].blocksPerLine*s[0].blocksPerColumn:f*r.mcusPerColumn;for(;j<=N;){const r=o?Math.min(N-j,o):N;if(r>0){for(C=0;C<v;C++)s[C].pred=0;y=0;if(1===v){k=s[0];for(M=0;M<r;M++){decodeBlock(k,E,j);j++}}else for(M=0;M<r;M++){for(C=0;C<v;C++){k=s[C];R=k.h;L=k.v;for(O=0;O<L;O++)for(T=0;T<R;T++)decodeMcu(k,E,j,O,T)}j++}}b=0;D=findNextFileMarker(e,t);if(!D)break;if(D.invalid){const e=r>0?"unexpected":"excessive";(0,n.warn)("decodeScan - ".concat(e," MCU data, current marker is: ").concat(D.invalid));t=D.offset}if(!(D.marker>=65488&&D.marker<=65495))break;t+=2}return t-p}function quantizeAndInverse(e,t,r){const n=e.quantizationTable,a=e.blockData;let i,g,p,m,b,y,w,S,x,v,k,C,O,T,M,E,D;if(!n)throw new JpegError("missing required Quantization Table.");for(let e=0;e<64;e+=8){x=a[t+e];v=a[t+e+1];k=a[t+e+2];C=a[t+e+3];O=a[t+e+4];T=a[t+e+5];M=a[t+e+6];E=a[t+e+7];x*=n[e];if(0!=(v|k|C|O|T|M|E)){v*=n[e+1];k*=n[e+2];C*=n[e+3];O*=n[e+4];T*=n[e+5];M*=n[e+6];E*=n[e+7];i=d*x+128>>8;g=d*O+128>>8;p=k;m=M;b=f*(v-E)+128>>8;S=f*(v+E)+128>>8;y=C<<4;w=T<<4;i=i+g+1>>1;g=i-g;D=p*u+m*h+128>>8;p=p*h-m*u+128>>8;m=D;b=b+w+1>>1;w=b-w;S=S+y+1>>1;y=S-y;i=i+m+1>>1;m=i-m;g=g+p+1>>1;p=g-p;D=b*l+S*c+2048>>12;b=b*c-S*l+2048>>12;S=D;D=y*o+w*s+2048>>12;y=y*s-w*o+2048>>12;w=D;r[e]=i+S;r[e+7]=i-S;r[e+1]=g+w;r[e+6]=g-w;r[e+2]=p+y;r[e+5]=p-y;r[e+3]=m+b;r[e+4]=m-b}else{D=d*x+512>>10;r[e]=D;r[e+1]=D;r[e+2]=D;r[e+3]=D;r[e+4]=D;r[e+5]=D;r[e+6]=D;r[e+7]=D}}for(let e=0;e<8;++e){x=r[e];v=r[e+8];k=r[e+16];C=r[e+24];O=r[e+32];T=r[e+40];M=r[e+48];E=r[e+56];if(0!=(v|k|C|O|T|M|E)){i=d*x+2048>>12;g=d*O+2048>>12;p=k;m=M;b=f*(v-E)+2048>>12;S=f*(v+E)+2048>>12;y=C;w=T;i=4112+(i+g+1>>1);g=i-g;D=p*u+m*h+2048>>12;p=p*h-m*u+2048>>12;m=D;b=b+w+1>>1;w=b-w;S=S+y+1>>1;y=S-y;i=i+m+1>>1;m=i-m;g=g+p+1>>1;p=g-p;D=b*l+S*c+2048>>12;b=b*c-S*l+2048>>12;S=D;D=y*o+w*s+2048>>12;y=y*s-w*o+2048>>12;w=D;x=i+S;E=i-S;v=g+w;M=g-w;k=p+y;T=p-y;C=m+b;O=m-b;x<16?x=0:x>=4080?x=255:x>>=4;v<16?v=0:v>=4080?v=255:v>>=4;k<16?k=0:k>=4080?k=255:k>>=4;C<16?C=0:C>=4080?C=255:C>>=4;O<16?O=0:O>=4080?O=255:O>>=4;T<16?T=0:T>=4080?T=255:T>>=4;M<16?M=0:M>=4080?M=255:M>>=4;E<16?E=0:E>=4080?E=255:E>>=4;a[t+e]=x;a[t+e+8]=v;a[t+e+16]=k;a[t+e+24]=C;a[t+e+32]=O;a[t+e+40]=T;a[t+e+48]=M;a[t+e+56]=E}else{D=d*x+8192>>14;D=D<-2040?0:D>=2024?255:D+2056>>4;a[t+e]=D;a[t+e+8]=D;a[t+e+16]=D;a[t+e+24]=D;a[t+e+32]=D;a[t+e+40]=D;a[t+e+48]=D;a[t+e+56]=D}}}function buildComponentData(e,t){const r=t.blocksPerLine,n=t.blocksPerColumn,a=new Int16Array(64);for(let e=0;e<n;e++)for(let n=0;n<r;n++){quantizeAndInverse(t,getBlockBufferOffset(t,e,n),a)}return t.blockData}function findNextFileMarker(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:t;const n=e.length-1;let i=r<t?r:t;if(t>=n)return null;const s=(0,a.readUint16)(e,t);if(s>=65472&&s<=65534)return{invalid:null,marker:s,offset:t};let o=(0,a.readUint16)(e,i);for(;!(o>=65472&&o<=65534);){if(++i>=n)return null;o=(0,a.readUint16)(e,i)}return{invalid:s.toString(16),marker:o,offset:i}}t.JpegImage=class JpegImage{constructor(){let{decodeTransform:e=null,colorTransform:t=-1}=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this._decodeTransform=e;this._colorTransform=t}parse(e){let{dnlScanLines:t=null}=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};function readDataBlock(){const t=(0,a.readUint16)(e,o);o+=2;let r=o+t-2;const i=findNextFileMarker(e,r,o);if(i&&i.invalid){(0,n.warn)("readDataBlock - incorrect length, current marker is: "+i.invalid);r=i.offset}const s=e.subarray(o,r);o+=s.length;return s}function prepareComponents(e){const t=Math.ceil(e.samplesPerLine/8/e.maxH),r=Math.ceil(e.scanLines/8/e.maxV);for(let n=0,a=e.components.length;n<a;n++){const a=e.components[n],i=Math.ceil(Math.ceil(e.samplesPerLine/8)*a.h/e.maxH),s=Math.ceil(Math.ceil(e.scanLines/8)*a.v/e.maxV),o=t*a.h,c=64*(r*a.v)*(o+1);a.blockData=new Int16Array(c);a.blocksPerLine=i;a.blocksPerColumn=s}e.mcusPerLine=t;e.mcusPerColumn=r}let r,s,o=0,c=null,l=null,h=0;const u=[],d=[],f=[];let g=(0,a.readUint16)(e,o);o+=2;if(65496!==g)throw new JpegError("SOI not found");g=(0,a.readUint16)(e,o);o+=2;e:for(;65497!==g;){let p,m,b;switch(g){case 65504:case 65505:case 65506:case 65507:case 65508:case 65509:case 65510:case 65511:case 65512:case 65513:case 65514:case 65515:case 65516:case 65517:case 65518:case 65519:case 65534:const y=readDataBlock();65504===g&&74===y[0]&&70===y[1]&&73===y[2]&&70===y[3]&&0===y[4]&&(c={version:{major:y[5],minor:y[6]},densityUnits:y[7],xDensity:y[8]<<8|y[9],yDensity:y[10]<<8|y[11],thumbWidth:y[12],thumbHeight:y[13],thumbData:y.subarray(14,14+3*y[12]*y[13])});65518===g&&65===y[0]&&100===y[1]&&111===y[2]&&98===y[3]&&101===y[4]&&(l={version:y[5]<<8|y[6],flags0:y[7]<<8|y[8],flags1:y[9]<<8|y[10],transformCode:y[11]});break;case 65499:const w=(0,a.readUint16)(e,o);o+=2;const S=w+o-2;let x;for(;o<S;){const t=e[o++],r=new Uint16Array(64);if(t>>4==0)for(m=0;m<64;m++){x=i[m];r[x]=e[o++]}else{if(t>>4!=1)throw new JpegError("DQT - invalid table spec");for(m=0;m<64;m++){x=i[m];r[x]=(0,a.readUint16)(e,o);o+=2}}u[15&t]=r}break;case 65472:case 65473:case 65474:if(r)throw new JpegError("Only single frame JPEGs supported");o+=2;r={};r.extended=65473===g;r.progressive=65474===g;r.precision=e[o++];const v=(0,a.readUint16)(e,o);o+=2;r.scanLines=t||v;r.samplesPerLine=(0,a.readUint16)(e,o);o+=2;r.components=[];r.componentIds={};const k=e[o++];let C=0,O=0;for(p=0;p<k;p++){const t=e[o],n=e[o+1]>>4,a=15&e[o+1];C<n&&(C=n);O<a&&(O=a);const i=e[o+2];b=r.components.push({h:n,v:a,quantizationId:i,quantizationTable:null});r.componentIds[t]=b-1;o+=3}r.maxH=C;r.maxV=O;prepareComponents(r);break;case 65476:const T=(0,a.readUint16)(e,o);o+=2;for(p=2;p<T;){const t=e[o++],r=new Uint8Array(16);let n=0;for(m=0;m<16;m++,o++)n+=r[m]=e[o];const a=new Uint8Array(n);for(m=0;m<n;m++,o++)a[m]=e[o];p+=17+n;(t>>4==0?f:d)[15&t]=buildHuffmanTable(r,a)}break;case 65501:o+=2;s=(0,a.readUint16)(e,o);o+=2;break;case 65498:const M=1==++h&&!t;o+=2;const E=e[o++],D=[];for(p=0;p<E;p++){const t=e[o++],n=r.componentIds[t],a=r.components[n];a.index=t;const i=e[o++];a.huffmanTableDC=f[i>>4];a.huffmanTableAC=d[15&i];D.push(a)}const N=e[o++],R=e[o++],L=e[o++];try{const t=decodeScan(e,o,r,D,s,N,R,L>>4,15&L,M);o+=t}catch(t){if(t instanceof DNLMarkerError){(0,n.warn)("".concat(t.message," -- attempting to re-parse the JPEG image."));return this.parse(e,{dnlScanLines:t.scanLines})}if(t instanceof EOIMarkerError){(0,n.warn)("".concat(t.message," -- ignoring the rest of the image data."));break e}throw t}break;case 65500:o+=4;break;case 65535:255!==e[o]&&o--;break;default:const j=findNextFileMarker(e,o-2,o-3);if(j&&j.invalid){(0,n.warn)("JpegImage.parse - unexpected data, current marker is: "+j.invalid);o=j.offset;break}if(!j||o>=e.length-1){(0,n.warn)("JpegImage.parse - reached the end of the image data without finding an EOI marker (0xFFD9).");break e}throw new JpegError("JpegImage.parse - unknown marker: "+g.toString(16))}g=(0,a.readUint16)(e,o);o+=2}this.width=r.samplesPerLine;this.height=r.scanLines;this.jfif=c;this.adobe=l;this.components=[];for(let e=0,t=r.components.length;e<t;e++){const t=r.components[e],n=u[t.quantizationId];n&&(t.quantizationTable=n);this.components.push({index:t.index,output:buildComponentData(0,t),scaleX:t.h/r.maxH,scaleY:t.v/r.maxV,blocksPerLine:t.blocksPerLine,blocksPerColumn:t.blocksPerColumn})}this.numComponents=this.components.length}_getLinearizedBlockData(e,t){let r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];const n=this.width/e,a=this.height/t;let i,s,o,c,l,h,u,d,f,g,p,m=0;const b=this.components.length,y=e*t*b,w=new Uint8ClampedArray(y),S=new Uint32Array(e),x=4294967288;let v;for(u=0;u<b;u++){i=this.components[u];s=i.scaleX*n;o=i.scaleY*a;m=u;p=i.output;c=i.blocksPerLine+1<<3;if(s!==v){for(l=0;l<e;l++){d=0|l*s;S[l]=(d&x)<<3|7&d}v=s}for(h=0;h<t;h++){d=0|h*o;g=c*(d&x)|(7&d)<<3;for(l=0;l<e;l++){w[m]=p[g+S[l]];m+=b}}}let k=this._decodeTransform;r||4!==b||k||(k=new Int32Array([-256,255,-256,255,-256,255,-256,255]));if(k)for(u=0;u<y;)for(d=0,f=0;d<b;d++,u++,f+=2)w[u]=(w[u]*k[f]>>8)+k[f+1];return w}get _isColorConversionNeeded(){return this.adobe?!!this.adobe.transformCode:3===this.numComponents?0!==this._colorTransform&&(82!==this.components[0].index||71!==this.components[1].index||66!==this.components[2].index):1===this._colorTransform}_convertYccToRgb(e){let t,r,n;for(let a=0,i=e.length;a<i;a+=3){t=e[a];r=e[a+1];n=e[a+2];e[a]=t-179.456+1.402*n;e[a+1]=t+135.459-.344*r-.714*n;e[a+2]=t-226.816+1.772*r}return e}_convertYcckToRgb(e){let t,r,n,a,i=0;for(let s=0,o=e.length;s<o;s+=4){t=e[s];r=e[s+1];n=e[s+2];a=e[s+3];e[i++]=r*(-660635669420364e-19*r+.000437130475926232*n-54080610064599e-18*t+.00048449797120281*a-.154362151871126)-122.67195406894+n*(-.000957964378445773*n+.000817076911346625*t-.00477271405408747*a+1.53380253221734)+t*(.000961250184130688*t-.00266257332283933*a+.48357088451265)+a*(-.000336197177618394*a+.484791561490776);e[i++]=107.268039397724+r*(219927104525741e-19*r-.000640992018297945*n+.000659397001245577*t+.000426105652938837*a-.176491792462875)+n*(-.000778269941513683*n+.00130872261408275*t+.000770482631801132*a-.151051492775562)+t*(.00126935368114843*t-.00265090189010898*a+.25802910206845)+a*(-.000318913117588328*a-.213742400323665);e[i++]=r*(-.000570115196973677*r-263409051004589e-19*n+.0020741088115012*t-.00288260236853442*a+.814272968359295)-20.810012546947+n*(-153496057440975e-19*n-.000132689043961446*t+.000560833691242812*a-.195152027534049)+t*(.00174418132927582*t-.00255243321439347*a+.116935020465145)+a*(-.000343531996510555*a+.24165260232407)}return e.subarray(0,i)}_convertYcckToCmyk(e){let t,r,n;for(let a=0,i=e.length;a<i;a+=4){t=e[a];r=e[a+1];n=e[a+2];e[a]=434.456-t-1.402*n;e[a+1]=119.541-t+.344*r+.714*n;e[a+2]=481.816-t-1.772*r}return e}_convertCmykToRgb(e){let t,r,n,a,i=0;for(let s=0,o=e.length;s<o;s+=4){t=e[s];r=e[s+1];n=e[s+2];a=e[s+3];e[i++]=255+t*(-6747147073602441e-20*t+.0008379262121013727*r+.0002894718188643294*n+.003264231057537806*a-1.1185611867203937)+r*(26374107616089405e-21*r-8626949158638572e-20*n-.0002748769067499491*a-.02155688794978967)+n*(-3878099212869363e-20*n-.0003267808279485286*a+.0686742238595345)-a*(.0003361971776183937*a+.7430659151342254);e[i++]=255+t*(.00013596372813588848*t+.000924537132573585*r+.00010567359618683593*n+.0004791864687436512*a-.3109689587515875)+r*(-.00023545346108370344*r+.0002702845253534714*n+.0020200308977307156*a-.7488052167015494)+n*(6834815998235662e-20*n+.00015168452363460973*a-.09751927774728933)-a*(.0003189131175883281*a+.7364883807733168);e[i++]=255+t*(13598650411385307e-21*t+.00012423956175490851*r+.0004751985097583589*n-36729317476630422e-22*a-.05562186980264034)+r*(.00016141380598724676*r+.0009692239130725186*n+.0007782692450036253*a-.44015232367526463)+n*(5.068882914068769e-7*n+.0017778369011375071*a-.7591454649749609)-a*(.0003435319965105553*a+.7063770186160144)}return e.subarray(0,i)}getData(e){let{width:t,height:r,forceRGB:n=!1,isSourcePDF:a=!1}=e;if(this.numComponents>4)throw new JpegError("Unsupported color mode");const i=this._getLinearizedBlockData(t,r,a);if(1===this.numComponents&&n){const e=i.length,t=new Uint8ClampedArray(3*e);let r=0;for(let n=0;n<e;n++){const e=i[n];t[r++]=e;t[r++]=e;t[r++]=e}return t}if(3===this.numComponents&&this._isColorConversionNeeded)return this._convertYccToRgb(i);if(4===this.numComponents){if(this._isColorConversionNeeded)return n?this._convertYcckToRgb(i):this._convertYcckToCmyk(i);if(n)return this._convertCmykToRgb(i)}return i}}},(e,t,r)=>{r(126)("Int16",(function(e){return function Int16Array(t,r,n){return e(this,t,r,n)}}))},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.JpxStream=void 0;r(232);r(146);r(148);r(149);var n=r(242),a=r(256),i=r(158);class JpxStream extends n.DecodeStream{constructor(e,t,r){super(t);this.stream=e;this.dict=e.dict;this.maybeLength=t;this.params=r}get bytes(){return(0,i.shadow)(this,"bytes",this.stream.getBytes(this.maybeLength))}ensureBuffer(e){}readBlock(){if(this.eof)return;const e=new a.JpxImage;e.parse(this.bytes);const t=e.width,r=e.height,n=e.componentsCount,i=e.tiles.length;if(1===i)this.buffer=e.tiles[0].items;else{const a=new Uint8ClampedArray(t*r*n);for(let r=0;r<i;r++){const i=e.tiles[r],s=i.width,o=i.height,c=i.left,l=i.top,h=i.items;let u=0,d=(t*l+c)*n;const f=t*n,g=s*n;for(let e=0;e<o;e++){const e=h.subarray(u,u+g);a.set(e,d);u+=g;d+=f}}this.buffer=a}this.bufferLength=this.buffer.length;this.eof=!0}}t.JpxStream=JpxStream},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.JpxImage=void 0;r(247);r(146);r(148);r(149);r(125);r(236);r(232);r(178);r(235);r(250);var n=r(158),a=r(213),i=r(251);class JpxError extends n.BaseException{constructor(e){super("JPX error: ".concat(e),"JpxError")}}const s={LL:0,LH:1,HL:1,HH:2};t.JpxImage=class JpxImage{constructor(){this.failOnCorruptedImage=!1}parse(e){if(65359===(0,a.readUint16)(e,0)){this.parseCodestream(e,0,e.length);return}const t=e.length;let r=0;for(;r<t;){let i=8,s=(0,a.readUint32)(e,r);const o=(0,a.readUint32)(e,r+4);r+=i;if(1===s){s=4294967296*(0,a.readUint32)(e,r)+(0,a.readUint32)(e,r+4);r+=8;i+=8}0===s&&(s=t-r+i);if(s<i)throw new JpxError("Invalid box field size");const c=s-i;let l=!0;switch(o){case 1785737832:l=!1;break;case 1668246642:const t=e[r];if(1===t){const t=(0,a.readUint32)(e,r+3);switch(t){case 16:case 17:case 18:break;default:(0,n.warn)("Unknown colorspace "+t)}}else 2===t&&(0,n.info)("ICC profile not supported");break;case 1785737827:this.parseCodestream(e,r,r+c);break;case 1783636e3:218793738!==(0,a.readUint32)(e,r)&&(0,n.warn)("Invalid JP2 signature");break;case 1783634458:case 1718909296:case 1920099697:case 1919251232:case 1768449138:break;default:const i=String.fromCharCode(o>>24&255,o>>16&255,o>>8&255,255&o);(0,n.warn)("Unsupported header type ".concat(o," (").concat(i,")."))}l&&(r+=c)}}parseImageProperties(e){let t=e.getByte();for(;t>=0;){const r=t;t=e.getByte();if(65361===(r<<8|t)){e.skip(4);const t=e.getInt32()>>>0,r=e.getInt32()>>>0,n=e.getInt32()>>>0,a=e.getInt32()>>>0;e.skip(16);const i=e.getUint16();this.width=t-n;this.height=r-a;this.componentsCount=i;this.bitsPerComponent=8;return}}throw new JpxError("No size marker found in JPX stream")}parseCodestream(e,t,r){const i={};let s=!1;try{let o=t;for(;o+1<r;){const t=(0,a.readUint16)(e,o);o+=2;let r,c,l,h,u,d,f=0;switch(t){case 65359:i.mainHeader=!0;break;case 65497:break;case 65361:f=(0,a.readUint16)(e,o);const g={};g.Xsiz=(0,a.readUint32)(e,o+4);g.Ysiz=(0,a.readUint32)(e,o+8);g.XOsiz=(0,a.readUint32)(e,o+12);g.YOsiz=(0,a.readUint32)(e,o+16);g.XTsiz=(0,a.readUint32)(e,o+20);g.YTsiz=(0,a.readUint32)(e,o+24);g.XTOsiz=(0,a.readUint32)(e,o+28);g.YTOsiz=(0,a.readUint32)(e,o+32);const p=(0,a.readUint16)(e,o+36);g.Csiz=p;const m=[];r=o+38;for(let t=0;t<p;t++){const t={precision:1+(127&e[r]),isSigned:!!(128&e[r]),XRsiz:e[r+1],YRsiz:e[r+2]};r+=3;calculateComponentDimensions(t,g);m.push(t)}i.SIZ=g;i.components=m;calculateTileGrids(i,m);i.QCC=[];i.COC=[];break;case 65372:f=(0,a.readUint16)(e,o);const b={};r=o+2;c=e[r++];switch(31&c){case 0:h=8;u=!0;break;case 1:h=16;u=!1;break;case 2:h=16;u=!0;break;default:throw new Error("Invalid SQcd value "+c)}b.noQuantization=8===h;b.scalarExpounded=u;b.guardBits=c>>5;l=[];for(;r<f+o;){const t={};if(8===h){t.epsilon=e[r++]>>3;t.mu=0}else{t.epsilon=e[r]>>3;t.mu=(7&e[r])<<8|e[r+1];r+=2}l.push(t)}b.SPqcds=l;if(i.mainHeader)i.QCD=b;else{i.currentTile.QCD=b;i.currentTile.QCC=[]}break;case 65373:f=(0,a.readUint16)(e,o);const y={};r=o+2;let w;if(i.SIZ.Csiz<257)w=e[r++];else{w=(0,a.readUint16)(e,r);r+=2}c=e[r++];switch(31&c){case 0:h=8;u=!0;break;case 1:h=16;u=!1;break;case 2:h=16;u=!0;break;default:throw new Error("Invalid SQcd value "+c)}y.noQuantization=8===h;y.scalarExpounded=u;y.guardBits=c>>5;l=[];for(;r<f+o;){const t={};if(8===h){t.epsilon=e[r++]>>3;t.mu=0}else{t.epsilon=e[r]>>3;t.mu=(7&e[r])<<8|e[r+1];r+=2}l.push(t)}y.SPqcds=l;i.mainHeader?i.QCC[w]=y:i.currentTile.QCC[w]=y;break;case 65362:f=(0,a.readUint16)(e,o);const S={};r=o+2;const x=e[r++];S.entropyCoderWithCustomPrecincts=!!(1&x);S.sopMarkerUsed=!!(2&x);S.ephMarkerUsed=!!(4&x);S.progressionOrder=e[r++];S.layersCount=(0,a.readUint16)(e,r);r+=2;S.multipleComponentTransform=e[r++];S.decompositionLevelsCount=e[r++];S.xcb=2+(15&e[r++]);S.ycb=2+(15&e[r++]);const v=e[r++];S.selectiveArithmeticCodingBypass=!!(1&v);S.resetContextProbabilities=!!(2&v);S.terminationOnEachCodingPass=!!(4&v);S.verticallyStripe=!!(8&v);S.predictableTermination=!!(16&v);S.segmentationSymbolUsed=!!(32&v);S.reversibleTransformation=e[r++];if(S.entropyCoderWithCustomPrecincts){const t=[];for(;r<f+o;){const n=e[r++];t.push({PPx:15&n,PPy:n>>4})}S.precinctsSizes=t}const k=[];S.selectiveArithmeticCodingBypass&&k.push("selectiveArithmeticCodingBypass");S.terminationOnEachCodingPass&&k.push("terminationOnEachCodingPass");S.verticallyStripe&&k.push("verticallyStripe");S.predictableTermination&&k.push("predictableTermination");if(k.length>0){s=!0;(0,n.warn)("JPX: Unsupported COD options (".concat(k.join(", "),")."))}if(i.mainHeader)i.COD=S;else{i.currentTile.COD=S;i.currentTile.COC=[]}break;case 65424:f=(0,a.readUint16)(e,o);d={};d.index=(0,a.readUint16)(e,o+2);d.length=(0,a.readUint32)(e,o+4);d.dataEnd=d.length+o-2;d.partIndex=e[o+8];d.partsCount=e[o+9];i.mainHeader=!1;if(0===d.partIndex){d.COD=i.COD;d.COC=i.COC.slice(0);d.QCD=i.QCD;d.QCC=i.QCC.slice(0)}i.currentTile=d;break;case 65427:d=i.currentTile;if(0===d.partIndex){initializeTile(i,d.index);buildPackets(i)}f=d.dataEnd-o;parseTilePackets(i,e,o,f);break;case 65363:(0,n.warn)("JPX: Codestream code 0xFF53 (COC) is not implemented.");case 65365:case 65367:case 65368:case 65380:f=(0,a.readUint16)(e,o);break;default:throw new Error("Unknown codestream code: "+t.toString(16))}o+=f}}catch(e){if(s||this.failOnCorruptedImage)throw new JpxError(e.message);(0,n.warn)('JPX: Trying to recover from: "'.concat(e.message,'".'))}this.tiles=function transformComponents(e){const t=e.SIZ,r=e.components,n=t.Csiz,a=[];for(let t=0,i=e.tiles.length;t<i;t++){const i=e.tiles[t],s=[];for(let t=0;t<n;t++)s[t]=transformTile(e,i,t);const o=s[0],c=new Uint8ClampedArray(o.items.length*n),l={left:o.left,top:o.top,width:o.width,height:o.height,items:c};let h,u,d,f,g,p,m,b=0;if(i.codingStyleDefaultParameters.multipleComponentTransform){const e=4===n,t=s[0].items,a=s[1].items,o=s[2].items,l=e?s[3].items:null;h=r[0].precision-8;u=.5+(128<<h);const y=i.components[0],w=n-3;f=t.length;if(y.codingStyleParameters.reversibleTransformation)for(d=0;d<f;d++,b+=w){g=t[d]+u;p=a[d];m=o[d];const e=g-(m+p>>2);c[b++]=e+m>>h;c[b++]=e>>h;c[b++]=e+p>>h}else for(d=0;d<f;d++,b+=w){g=t[d]+u;p=a[d];m=o[d];c[b++]=g+1.402*m>>h;c[b++]=g-.34413*p-.71414*m>>h;c[b++]=g+1.772*p>>h}if(e)for(d=0,b=3;d<f;d++,b+=4)c[b]=l[d]+u>>h}else for(let e=0;e<n;e++){const t=s[e].items;h=r[e].precision-8;u=.5+(128<<h);for(b=e,d=0,f=t.length;d<f;d++){c[b]=t[d]+u>>h;b+=n}}a.push(l)}return a}(i);this.width=i.SIZ.Xsiz-i.SIZ.XOsiz;this.height=i.SIZ.Ysiz-i.SIZ.YOsiz;this.componentsCount=i.SIZ.Csiz}};function calculateComponentDimensions(e,t){e.x0=Math.ceil(t.XOsiz/e.XRsiz);e.x1=Math.ceil(t.Xsiz/e.XRsiz);e.y0=Math.ceil(t.YOsiz/e.YRsiz);e.y1=Math.ceil(t.Ysiz/e.YRsiz);e.width=e.x1-e.x0;e.height=e.y1-e.y0}function calculateTileGrids(e,t){const r=e.SIZ,n=[];let a;const i=Math.ceil((r.Xsiz-r.XTOsiz)/r.XTsiz),s=Math.ceil((r.Ysiz-r.YTOsiz)/r.YTsiz);for(let e=0;e<s;e++)for(let t=0;t<i;t++){a={};a.tx0=Math.max(r.XTOsiz+t*r.XTsiz,r.XOsiz);a.ty0=Math.max(r.YTOsiz+e*r.YTsiz,r.YOsiz);a.tx1=Math.min(r.XTOsiz+(t+1)*r.XTsiz,r.Xsiz);a.ty1=Math.min(r.YTOsiz+(e+1)*r.YTsiz,r.Ysiz);a.width=a.tx1-a.tx0;a.height=a.ty1-a.ty0;a.components=[];n.push(a)}e.tiles=n;for(let e=0,i=r.Csiz;e<i;e++){const r=t[e];for(let t=0,i=n.length;t<i;t++){const i={};a=n[t];i.tcx0=Math.ceil(a.tx0/r.XRsiz);i.tcy0=Math.ceil(a.ty0/r.YRsiz);i.tcx1=Math.ceil(a.tx1/r.XRsiz);i.tcy1=Math.ceil(a.ty1/r.YRsiz);i.width=i.tcx1-i.tcx0;i.height=i.tcy1-i.tcy0;a.components[e]=i}}}function getBlocksDimensions(e,t,r){const n=t.codingStyleParameters,a={};if(n.entropyCoderWithCustomPrecincts){a.PPx=n.precinctsSizes[r].PPx;a.PPy=n.precinctsSizes[r].PPy}else{a.PPx=15;a.PPy=15}a.xcb_=r>0?Math.min(n.xcb,a.PPx-1):Math.min(n.xcb,a.PPx);a.ycb_=r>0?Math.min(n.ycb,a.PPy-1):Math.min(n.ycb,a.PPy);return a}function buildPrecincts(e,t,r){const n=1<<r.PPx,a=1<<r.PPy,i=0===t.resLevel,s=1<<r.PPx+(i?0:-1),o=1<<r.PPy+(i?0:-1),c=t.trx1>t.trx0?Math.ceil(t.trx1/n)-Math.floor(t.trx0/n):0,l=t.try1>t.try0?Math.ceil(t.try1/a)-Math.floor(t.try0/a):0,h=c*l;t.precinctParameters={precinctWidth:n,precinctHeight:a,numprecinctswide:c,numprecinctshigh:l,numprecincts:h,precinctWidthInSubband:s,precinctHeightInSubband:o}}function buildCodeblocks(e,t,r){const n=r.xcb_,a=r.ycb_,i=1<<n,s=1<<a,o=t.tbx0>>n,c=t.tby0>>a,l=t.tbx1+i-1>>n,h=t.tby1+s-1>>a,u=t.resolution.precinctParameters,d=[],f=[];let g,p,m,b;for(p=c;p<h;p++)for(g=o;g<l;g++){m={cbx:g,cby:p,tbx0:i*g,tby0:s*p,tbx1:i*(g+1),tby1:s*(p+1)};m.tbx0_=Math.max(t.tbx0,m.tbx0);m.tby0_=Math.max(t.tby0,m.tby0);m.tbx1_=Math.min(t.tbx1,m.tbx1);m.tby1_=Math.min(t.tby1,m.tby1);b=Math.floor((m.tbx0_-t.tbx0)/u.precinctWidthInSubband)+Math.floor((m.tby0_-t.tby0)/u.precinctHeightInSubband)*u.numprecinctswide;m.precinctNumber=b;m.subbandType=t.type;m.Lblock=3;if(m.tbx1_<=m.tbx0_||m.tby1_<=m.tby0_)continue;d.push(m);let e=f[b];if(void 0!==e){g<e.cbxMin?e.cbxMin=g:g>e.cbxMax&&(e.cbxMax=g);p<e.cbyMin?e.cbxMin=p:p>e.cbyMax&&(e.cbyMax=p)}else f[b]=e={cbxMin:g,cbyMin:p,cbxMax:g,cbyMax:p};m.precinct=e}t.codeblockParameters={codeblockWidth:n,codeblockHeight:a,numcodeblockwide:l-o+1,numcodeblockhigh:h-c+1};t.codeblocks=d;t.precincts=f}function createPacket(e,t,r){const n=[],a=e.subbands;for(let e=0,r=a.length;e<r;e++){const r=a[e].codeblocks;for(let e=0,a=r.length;e<a;e++){const a=r[e];a.precinctNumber===t&&n.push(a)}}return{layerNumber:r,codeblocks:n}}function LayerResolutionComponentPositionIterator(e){const t=e.SIZ,r=e.currentTile.index,n=e.tiles[r],a=n.codingStyleDefaultParameters.layersCount,i=t.Csiz;let s=0;for(let e=0;e<i;e++)s=Math.max(s,n.components[e].codingStyleParameters.decompositionLevelsCount);let o=0,c=0,l=0,h=0;this.nextPacket=function JpxImage_nextPacket(){for(;o<a;o++){for(;c<=s;c++){for(;l<i;l++){const e=n.components[l];if(c>e.codingStyleParameters.decompositionLevelsCount)continue;const t=e.resolutions[c],r=t.precinctParameters.numprecincts;for(;h<r;){const e=createPacket(t,h,o);h++;return e}h=0}l=0}c=0}throw new JpxError("Out of packets")}}function ResolutionLayerComponentPositionIterator(e){const t=e.SIZ,r=e.currentTile.index,n=e.tiles[r],a=n.codingStyleDefaultParameters.layersCount,i=t.Csiz;let s=0;for(let e=0;e<i;e++)s=Math.max(s,n.components[e].codingStyleParameters.decompositionLevelsCount);let o=0,c=0,l=0,h=0;this.nextPacket=function JpxImage_nextPacket(){for(;o<=s;o++){for(;c<a;c++){for(;l<i;l++){const e=n.components[l];if(o>e.codingStyleParameters.decompositionLevelsCount)continue;const t=e.resolutions[o],r=t.precinctParameters.numprecincts;for(;h<r;){const e=createPacket(t,h,c);h++;return e}h=0}l=0}c=0}throw new JpxError("Out of packets")}}function ResolutionPositionComponentLayerIterator(e){const t=e.SIZ,r=e.currentTile.index,n=e.tiles[r],a=n.codingStyleDefaultParameters.layersCount,i=t.Csiz;let s,o,c,l,h=0;for(c=0;c<i;c++){const e=n.components[c];h=Math.max(h,e.codingStyleParameters.decompositionLevelsCount)}const u=new Int32Array(h+1);for(o=0;o<=h;++o){let e=0;for(c=0;c<i;++c){const t=n.components[c].resolutions;o<t.length&&(e=Math.max(e,t[o].precinctParameters.numprecincts))}u[o]=e}s=0;o=0;c=0;l=0;this.nextPacket=function JpxImage_nextPacket(){for(;o<=h;o++){for(;l<u[o];l++){for(;c<i;c++){const e=n.components[c];if(o>e.codingStyleParameters.decompositionLevelsCount)continue;const t=e.resolutions[o],r=t.precinctParameters.numprecincts;if(!(l>=r)){for(;s<a;){const e=createPacket(t,l,s);s++;return e}s=0}}c=0}l=0}throw new JpxError("Out of packets")}}function PositionComponentResolutionLayerIterator(e){const t=e.SIZ,r=e.currentTile.index,n=e.tiles[r],a=n.codingStyleDefaultParameters.layersCount,i=t.Csiz,s=getPrecinctSizesInImageScale(n),o=s;let c=0,l=0,h=0,u=0,d=0;this.nextPacket=function JpxImage_nextPacket(){for(;d<o.maxNumHigh;d++){for(;u<o.maxNumWide;u++){for(;h<i;h++){const e=n.components[h],t=e.codingStyleParameters.decompositionLevelsCount;for(;l<=t;l++){const t=e.resolutions[l],r=s.components[h].resolutions[l],n=getPrecinctIndexIfExist(u,d,r,o,t);if(null!==n){for(;c<a;){const e=createPacket(t,n,c);c++;return e}c=0}}l=0}h=0}u=0}throw new JpxError("Out of packets")}}function ComponentPositionResolutionLayerIterator(e){const t=e.SIZ,r=e.currentTile.index,n=e.tiles[r],a=n.codingStyleDefaultParameters.layersCount,i=t.Csiz,s=getPrecinctSizesInImageScale(n);let o=0,c=0,l=0,h=0,u=0;this.nextPacket=function JpxImage_nextPacket(){for(;l<i;++l){const e=n.components[l],t=s.components[l],r=e.codingStyleParameters.decompositionLevelsCount;for(;u<t.maxNumHigh;u++){for(;h<t.maxNumWide;h++){for(;c<=r;c++){const r=e.resolutions[c],n=t.resolutions[c],i=getPrecinctIndexIfExist(h,u,n,t,r);if(null!==i){for(;o<a;){const e=createPacket(r,i,o);o++;return e}o=0}}c=0}h=0}u=0}throw new JpxError("Out of packets")}}function getPrecinctIndexIfExist(e,t,r,n,a){const i=e*n.minWidth,s=t*n.minHeight;if(i%r.width!=0||s%r.height!=0)return null;const o=s/r.width*a.precinctParameters.numprecinctswide;return i/r.height+o}function getPrecinctSizesInImageScale(e){const t=e.components.length;let r=Number.MAX_VALUE,n=Number.MAX_VALUE,a=0,i=0;const s=new Array(t);for(let o=0;o<t;o++){const t=e.components[o],c=t.codingStyleParameters.decompositionLevelsCount,l=new Array(c+1);let h=Number.MAX_VALUE,u=Number.MAX_VALUE,d=0,f=0,g=1;for(let e=c;e>=0;--e){const r=t.resolutions[e],n=g*r.precinctParameters.precinctWidth,a=g*r.precinctParameters.precinctHeight;h=Math.min(h,n);u=Math.min(u,a);d=Math.max(d,r.precinctParameters.numprecinctswide);f=Math.max(f,r.precinctParameters.numprecinctshigh);l[e]={width:n,height:a};g<<=1}r=Math.min(r,h);n=Math.min(n,u);a=Math.max(a,d);i=Math.max(i,f);s[o]={resolutions:l,minWidth:h,minHeight:u,maxNumWide:d,maxNumHigh:f}}return{components:s,minWidth:r,minHeight:n,maxNumWide:a,maxNumHigh:i}}function buildPackets(e){const t=e.SIZ,r=e.currentTile.index,n=e.tiles[r],a=t.Csiz;for(let e=0;e<a;e++){const t=n.components[e],r=t.codingStyleParameters.decompositionLevelsCount,a=[],i=[];for(let e=0;e<=r;e++){const n=getBlocksDimensions(0,t,e),s={},o=1<<r-e;s.trx0=Math.ceil(t.tcx0/o);s.try0=Math.ceil(t.tcy0/o);s.trx1=Math.ceil(t.tcx1/o);s.try1=Math.ceil(t.tcy1/o);s.resLevel=e;buildPrecincts(0,s,n);a.push(s);let c;if(0===e){c={};c.type="LL";c.tbx0=Math.ceil(t.tcx0/o);c.tby0=Math.ceil(t.tcy0/o);c.tbx1=Math.ceil(t.tcx1/o);c.tby1=Math.ceil(t.tcy1/o);c.resolution=s;buildCodeblocks(0,c,n);i.push(c);s.subbands=[c]}else{const a=1<<r-e+1,o=[];c={};c.type="HL";c.tbx0=Math.ceil(t.tcx0/a-.5);c.tby0=Math.ceil(t.tcy0/a);c.tbx1=Math.ceil(t.tcx1/a-.5);c.tby1=Math.ceil(t.tcy1/a);c.resolution=s;buildCodeblocks(0,c,n);i.push(c);o.push(c);c={};c.type="LH";c.tbx0=Math.ceil(t.tcx0/a);c.tby0=Math.ceil(t.tcy0/a-.5);c.tbx1=Math.ceil(t.tcx1/a);c.tby1=Math.ceil(t.tcy1/a-.5);c.resolution=s;buildCodeblocks(0,c,n);i.push(c);o.push(c);c={};c.type="HH";c.tbx0=Math.ceil(t.tcx0/a-.5);c.tby0=Math.ceil(t.tcy0/a-.5);c.tbx1=Math.ceil(t.tcx1/a-.5);c.tby1=Math.ceil(t.tcy1/a-.5);c.resolution=s;buildCodeblocks(0,c,n);i.push(c);o.push(c);s.subbands=o}}t.resolutions=a;t.subbands=i}const i=n.codingStyleDefaultParameters.progressionOrder;switch(i){case 0:n.packetsIterator=new LayerResolutionComponentPositionIterator(e);break;case 1:n.packetsIterator=new ResolutionLayerComponentPositionIterator(e);break;case 2:n.packetsIterator=new ResolutionPositionComponentLayerIterator(e);break;case 3:n.packetsIterator=new PositionComponentResolutionLayerIterator(e);break;case 4:n.packetsIterator=new ComponentPositionResolutionLayerIterator(e);break;default:throw new JpxError("Unsupported progression order ".concat(i))}}function parseTilePackets(e,t,r,n){let i,s=0,o=0,c=!1;function readBits(e){for(;o<e;){const e=t[r+s];s++;if(c){i=i<<7|e;o+=7;c=!1}else{i=i<<8|e;o+=8}255===e&&(c=!0)}o-=e;return i>>>o&(1<<e)-1}function skipMarkerIfEqual(e){if(255===t[r+s-1]&&t[r+s]===e){skipBytes(1);return!0}if(255===t[r+s]&&t[r+s+1]===e){skipBytes(2);return!0}return!1}function skipBytes(e){s+=e}function alignToByte(){o=0;if(c){s++;c=!1}}function readCodingpasses(){if(0===readBits(1))return 1;if(0===readBits(1))return 2;let e=readBits(2);if(e<3)return e+3;e=readBits(5);if(e<31)return e+6;e=readBits(7);return e+37}const l=e.currentTile.index,h=e.tiles[l],u=e.COD.sopMarkerUsed,d=e.COD.ephMarkerUsed,f=h.packetsIterator;for(;s<n;){alignToByte();u&&skipMarkerIfEqual(145)&&skipBytes(4);const e=f.nextPacket();if(!readBits(1))continue;const n=e.layerNumber,i=[];let o;for(let t=0,r=e.codeblocks.length;t<r;t++){o=e.codeblocks[t];let r=o.precinct;const s=o.cbx-r.cbxMin,c=o.cby-r.cbyMin;let l,h,u=!1,d=!1;if(void 0!==o.included)u=!!readBits(1);else{r=o.precinct;let e;if(void 0!==r.inclusionTree)e=r.inclusionTree;else{const t=r.cbxMax-r.cbxMin+1,a=r.cbyMax-r.cbyMin+1;e=new InclusionTree(t,a,n);h=new TagTree(t,a);r.inclusionTree=e;r.zeroBitPlanesTree=h;for(let e=0;e<n;e++)if(0!==readBits(1))throw new JpxError("Invalid tag tree")}if(e.reset(s,c,n))for(;;){if(!readBits(1)){e.incrementValue(n);break}l=!e.nextLevel();if(l){o.included=!0;u=d=!0;break}}}if(!u)continue;if(d){h=r.zeroBitPlanesTree;h.reset(s,c);for(;;)if(readBits(1)){l=!h.nextLevel();if(l)break}else h.incrementValue();o.zeroBitPlanes=h.value}const f=readCodingpasses();for(;readBits(1);)o.Lblock++;const g=(0,a.log2)(f),p=readBits((f<1<<g?g-1:g)+o.Lblock);i.push({codeblock:o,codingpasses:f,dataLength:p})}alignToByte();d&&skipMarkerIfEqual(146);for(;i.length>0;){const e=i.shift();o=e.codeblock;void 0===o.data&&(o.data=[]);o.data.push({data:t,start:r+s,end:r+s+e.dataLength,codingpasses:e.codingpasses});s+=e.dataLength}}return s}function copyCoefficients(e,t,r,n,a,s,c,l,h){const u=n.tbx0,d=n.tby0,f=n.tbx1-n.tbx0,g=n.codeblocks,p="H"===n.type.charAt(0)?1:0,m="H"===n.type.charAt(1)?t:0;for(let r=0,b=g.length;r<b;++r){const b=g[r],y=b.tbx1_-b.tbx0_,w=b.tby1_-b.tby0_;if(0===y||0===w)continue;if(void 0===b.data)continue;const S=new o(y,w,b.subbandType,b.zeroBitPlanes,s);let x=2;const v=b.data;let k,C,O,T=0,M=0;for(k=0,C=v.length;k<C;k++){O=v[k];T+=O.end-O.start;M+=O.codingpasses}const E=new Uint8Array(T);let D=0;for(k=0,C=v.length;k<C;k++){O=v[k];const e=O.data.subarray(O.start,O.end);E.set(e,D);D+=e.length}const N=new i.ArithmeticDecoder(E,0,T);S.setDecoder(N);for(k=0;k<M;k++){switch(x){case 0:S.runSignificancePropagationPass();break;case 1:S.runMagnitudeRefinementPass();break;case 2:S.runCleanupPass();l&&S.checkSegmentationSymbol()}h&&S.reset();x=(x+1)%3}let R=b.tbx0_-u+(b.tby0_-d)*f;const L=S.coefficentsSign,j=S.coefficentsMagnitude,_=S.bitsDecoded,U=c?0:.5;let $,X,H;D=0;const q="LL"!==n.type;for(k=0;k<w;k++){const r=2*(R/f|0)*(t-f)+p+m;for($=0;$<y;$++){X=j[D];if(0!==X){X=(X+U)*a;0!==L[D]&&(X=-X);H=_[D];const t=q?r+(R<<1):R;e[t]=c&&H>=s?X:X*(1<<s-H)}R++;D++}R+=f-y}}}function transformTile(e,t,r){const n=t.components[r],a=n.codingStyleParameters,i=n.quantizationParameters,o=a.decompositionLevelsCount,c=i.SPqcds,l=i.scalarExpounded,h=i.guardBits,u=a.segmentationSymbolUsed,d=a.resetContextProbabilities,f=e.components[r].precision,g=a.reversibleTransformation,p=g?new ReversibleTransform:new IrreversibleTransform,m=[];let b=0;for(let e=0;e<=o;e++){const t=n.resolutions[e],r=t.trx1-t.trx0,a=t.try1-t.try0,i=new Float32Array(r*a);for(let n=0,a=t.subbands.length;n<a;n++){let a,o;if(l){a=c[b].mu;o=c[b].epsilon;b++}else{a=c[0].mu;o=c[0].epsilon+(e>0?1-e:0)}const p=t.subbands[n],m=s[p.type];copyCoefficients(i,r,0,p,g?1:2**(f+m-o)*(1+a/2048),h+o-1,g,u,d)}m.push({width:r,height:a,items:i})}const y=p.calculate(m,n.tcx0,n.tcy0);return{left:n.tcx0,top:n.tcy0,width:y.width,height:y.height,items:y.items}}function initializeTile(e,t){const r=e.SIZ.Csiz,n=e.tiles[t];for(let t=0;t<r;t++){const r=n.components[t],a=void 0!==e.currentTile.QCC[t]?e.currentTile.QCC[t]:e.currentTile.QCD;r.quantizationParameters=a;const i=void 0!==e.currentTile.COC[t]?e.currentTile.COC[t]:e.currentTile.COD;r.codingStyleParameters=i}n.codingStyleDefaultParameters=e.currentTile.COD}class TagTree{constructor(e,t){const r=(0,a.log2)(Math.max(e,t))+1;this.levels=[];for(let n=0;n<r;n++){const r={width:e,height:t,items:[]};this.levels.push(r);e=Math.ceil(e/2);t=Math.ceil(t/2)}}reset(e,t){let r,n=0,a=0;for(;n<this.levels.length;){r=this.levels[n];const i=e+t*r.width;if(void 0!==r.items[i]){a=r.items[i];break}r.index=i;e>>=1;t>>=1;n++}n--;r=this.levels[n];r.items[r.index]=a;this.currentLevel=n;delete this.value}incrementValue(){const e=this.levels[this.currentLevel];e.items[e.index]++}nextLevel(){let e=this.currentLevel,t=this.levels[e];const r=t.items[t.index];e--;if(e<0){this.value=r;return!1}this.currentLevel=e;t=this.levels[e];t.items[t.index]=r;return!0}}class InclusionTree{constructor(e,t,r){const n=(0,a.log2)(Math.max(e,t))+1;this.levels=[];for(let a=0;a<n;a++){const n=new Uint8Array(e*t);for(let e=0,t=n.length;e<t;e++)n[e]=r;const a={width:e,height:t,items:n};this.levels.push(a);e=Math.ceil(e/2);t=Math.ceil(t/2)}}reset(e,t,r){let n=0;for(;n<this.levels.length;){const a=this.levels[n],i=e+t*a.width;a.index=i;const s=a.items[i];if(255===s)break;if(s>r){this.currentLevel=n;this.propagateValues();return!1}e>>=1;t>>=1;n++}this.currentLevel=n-1;return!0}incrementValue(e){const t=this.levels[this.currentLevel];t.items[t.index]=e+1;this.propagateValues()}propagateValues(){let e=this.currentLevel,t=this.levels[e];const r=t.items[t.index];for(;--e>=0;){t=this.levels[e];t.items[t.index]=r}}nextLevel(){let e=this.currentLevel,t=this.levels[e];const r=t.items[t.index];t.items[t.index]=255;e--;if(e<0)return!1;this.currentLevel=e;t=this.levels[e];t.items[t.index]=r;return!0}}const o=function BitModelClosure(){const e=17,t=new Uint8Array([0,5,8,0,3,7,8,0,4,7,8,0,0,0,0,0,1,6,8,0,3,7,8,0,4,7,8,0,0,0,0,0,2,6,8,0,3,7,8,0,4,7,8,0,0,0,0,0,2,6,8,0,3,7,8,0,4,7,8,0,0,0,0,0,2,6,8,0,3,7,8,0,4,7,8]),r=new Uint8Array([0,3,4,0,5,7,7,0,8,8,8,0,0,0,0,0,1,3,4,0,6,7,7,0,8,8,8,0,0,0,0,0,2,3,4,0,6,7,7,0,8,8,8,0,0,0,0,0,2,3,4,0,6,7,7,0,8,8,8,0,0,0,0,0,2,3,4,0,6,7,7,0,8,8,8]),n=new Uint8Array([0,1,2,0,1,2,2,0,2,2,2,0,0,0,0,0,3,4,5,0,4,5,5,0,5,5,5,0,0,0,0,0,6,7,7,0,7,7,7,0,7,7,7,0,0,0,0,0,8,8,8,0,8,8,8,0,8,8,8,0,0,0,0,0,8,8,8,0,8,8,8,0,8,8,8]);return class BitModel{constructor(e,a,i,s,o){this.width=e;this.height=a;let c;c="HH"===i?n:"HL"===i?r:t;this.contextLabelTable=c;const l=e*a;this.neighborsSignificance=new Uint8Array(l);this.coefficentsSign=new Uint8Array(l);let h;h=o>14?new Uint32Array(l):o>6?new Uint16Array(l):new Uint8Array(l);this.coefficentsMagnitude=h;this.processingFlags=new Uint8Array(l);const u=new Uint8Array(l);if(0!==s)for(let e=0;e<l;e++)u[e]=s;this.bitsDecoded=u;this.reset()}setDecoder(e){this.decoder=e}reset(){this.contexts=new Int8Array(19);this.contexts[0]=8;this.contexts[17]=92;this.contexts[18]=6}setNeighborsSignificance(e,t,r){const n=this.neighborsSignificance,a=this.width,i=this.height,s=t>0,o=t+1<a;let c;if(e>0){c=r-a;s&&(n[c-1]+=16);o&&(n[c+1]+=16);n[c]+=4}if(e+1<i){c=r+a;s&&(n[c-1]+=16);o&&(n[c+1]+=16);n[c]+=4}s&&(n[r-1]+=1);o&&(n[r+1]+=1);n[r]|=128}runSignificancePropagationPass(){const e=this.decoder,t=this.width,r=this.height,n=this.coefficentsMagnitude,a=this.coefficentsSign,i=this.neighborsSignificance,s=this.processingFlags,o=this.contexts,c=this.contextLabelTable,l=this.bitsDecoded;for(let h=0;h<r;h+=4)for(let u=0;u<t;u++){let d=h*t+u;for(let f=0;f<4;f++,d+=t){const t=h+f;if(t>=r)break;s[d]&=-2;if(n[d]||!i[d])continue;const g=c[i[d]];if(e.readBit(o,g)){const e=this.decodeSignBit(t,u,d);a[d]=e;n[d]=1;this.setNeighborsSignificance(t,u,d);s[d]|=2}l[d]++;s[d]|=1}}}decodeSignBit(e,t,r){const n=this.width,a=this.height,i=this.coefficentsMagnitude,s=this.coefficentsSign;let o,c,l,h,u,d;h=t>0&&0!==i[r-1];if(t+1<n&&0!==i[r+1]){l=s[r+1];if(h){c=s[r-1];o=1-l-c}else o=1-l-l}else if(h){c=s[r-1];o=1-c-c}else o=0;const f=3*o;h=e>0&&0!==i[r-n];if(e+1<a&&0!==i[r+n]){l=s[r+n];if(h){c=s[r-n];o=1-l-c+f}else o=1-l-l+f}else if(h){c=s[r-n];o=1-c-c+f}else o=f;if(o>=0){u=9+o;d=this.decoder.readBit(this.contexts,u)}else{u=9-o;d=1^this.decoder.readBit(this.contexts,u)}return d}runMagnitudeRefinementPass(){const e=this.decoder,t=this.width,r=this.height,n=this.coefficentsMagnitude,a=this.neighborsSignificance,i=this.contexts,s=this.bitsDecoded,o=this.processingFlags,c=t*r,l=4*t;for(let r,h=0;h<c;h=r){r=Math.min(c,h+l);for(let c=0;c<t;c++)for(let l=h+c;l<r;l+=t){if(!n[l]||0!=(1&o[l]))continue;let t=16;if(0!=(2&o[l])){o[l]^=2;t=0===(127&a[l])?15:14}const r=e.readBit(i,t);n[l]=n[l]<<1|r;s[l]++;o[l]|=1}}}runCleanupPass(){const t=this.decoder,r=this.width,n=this.height,a=this.neighborsSignificance,i=this.coefficentsMagnitude,s=this.coefficentsSign,o=this.contexts,c=this.contextLabelTable,l=this.bitsDecoded,h=this.processingFlags,u=r,d=2*r,f=3*r;let g;for(let p=0;p<n;p=g){g=Math.min(p+4,n);const m=p*r,b=p+3<n;for(let n=0;n<r;n++){const y=m+n;let w,S=0,x=y,v=p;if(b&&0===h[y]&&0===h[y+u]&&0===h[y+d]&&0===h[y+f]&&0===a[y]&&0===a[y+u]&&0===a[y+d]&&0===a[y+f]){if(!t.readBit(o,18)){l[y]++;l[y+u]++;l[y+d]++;l[y+f]++;continue}S=t.readBit(o,e)<<1|t.readBit(o,e);if(0!==S){v=p+S;x+=S*r}w=this.decodeSignBit(v,n,x);s[x]=w;i[x]=1;this.setNeighborsSignificance(v,n,x);h[x]|=2;x=y;for(let e=p;e<=v;e++,x+=r)l[x]++;S++}for(v=p+S;v<g;v++,x+=r){if(i[x]||0!=(1&h[x]))continue;const e=c[a[x]];if(1===t.readBit(o,e)){w=this.decodeSignBit(v,n,x);s[x]=w;i[x]=1;this.setNeighborsSignificance(v,n,x);h[x]|=2}l[x]++}}}}checkSegmentationSymbol(){const t=this.decoder,r=this.contexts;if(10!==(t.readBit(r,e)<<3|t.readBit(r,e)<<2|t.readBit(r,e)<<1|t.readBit(r,e)))throw new JpxError("Invalid segmentation symbol")}}}();class Transform{constructor(){this.constructor===Transform&&(0,n.unreachable)("Cannot initialize Transform.")}calculate(e,t,r){let n=e[0];for(let a=1,i=e.length;a<i;a++)n=this.iterate(n,e[a],t,r);return n}extend(e,t,r){let n=t-1,a=t+1,i=t+r-2,s=t+r;e[n--]=e[a++];e[s++]=e[i--];e[n--]=e[a++];e[s++]=e[i--];e[n--]=e[a++];e[s++]=e[i--];e[n]=e[a];e[s]=e[i]}filter(e,t,r){(0,n.unreachable)("Abstract method `filter` called")}iterate(e,t,r,n){const a=e.width,i=e.height;let s=e.items;const o=t.width,c=t.height,l=t.items;let h,u,d,f,g,p;for(d=0,h=0;h<i;h++){f=2*h*o;for(u=0;u<a;u++,d++,f+=2)l[f]=s[d]}s=e.items=null;const m=new Float32Array(o+8);if(1===o){if(0!=(1&r))for(p=0,d=0;p<c;p++,d+=o)l[d]*=.5}else for(p=0,d=0;p<c;p++,d+=o){m.set(l.subarray(d,d+o),4);this.extend(m,4,o);this.filter(m,4,o);l.set(m.subarray(4,4+o),d)}let b=16;const y=[];for(h=0;h<b;h++)y.push(new Float32Array(c+8));let w,S=0;e=4+c;if(1===c){if(0!=(1&n))for(g=0;g<o;g++)l[g]*=.5}else for(g=0;g<o;g++){if(0===S){b=Math.min(o-g,b);for(d=g,f=4;f<e;d+=o,f++)for(w=0;w<b;w++)y[w][f]=l[d+w];S=b}S--;const t=y[S];this.extend(t,4,c);this.filter(t,4,c);if(0===S){d=g-b+1;for(f=4;f<e;d+=o,f++)for(w=0;w<b;w++)l[d+w]=y[w][f]}}return{width:o,height:c,items:l}}}class IrreversibleTransform extends Transform{filter(e,t,r){const n=r>>1;let a,i,s,o;const c=-1.586134342059924,l=-.052980118572961,h=.882911075530934,u=.443506852043971,d=1.230174104914001;a=(t|=0)-3;for(i=n+4;i--;a+=2)e[a]*=.8128930661159609;a=t-2;s=u*e[a-1];for(i=n+3;i--;a+=2){o=u*e[a+1];e[a]=d*e[a]-s-o;if(!i--)break;a+=2;s=u*e[a+1];e[a]=d*e[a]-s-o}a=t-1;s=h*e[a-1];for(i=n+2;i--;a+=2){o=h*e[a+1];e[a]-=s+o;if(!i--)break;a+=2;s=h*e[a+1];e[a]-=s+o}a=t;s=l*e[a-1];for(i=n+1;i--;a+=2){o=l*e[a+1];e[a]-=s+o;if(!i--)break;a+=2;s=l*e[a+1];e[a]-=s+o}if(0!==n){a=t+1;s=c*e[a-1];for(i=n;i--;a+=2){o=c*e[a+1];e[a]-=s+o;if(!i--)break;a+=2;s=c*e[a+1];e[a]-=s+o}}}}class ReversibleTransform extends Transform{filter(e,t,r){const n=r>>1;let a,i;for(a=t|=0,i=n+1;i--;a+=2)e[a]-=e[a-1]+e[a+1]+2>>2;for(a=t+1,i=n;i--;a+=2)e[a]+=e[a-1]+e[a+1]>>1}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.LZWStream=void 0;r(125);r(146);r(148);r(149);r(235);var n=r(242);class LZWStream extends n.DecodeStream{constructor(e,t,r){super(t);this.str=e;this.dict=e.dict;this.cachedData=0;this.bitsCached=0;const n=4096,a={earlyChange:r,codeLength:9,nextCode:258,dictionaryValues:new Uint8Array(n),dictionaryLengths:new Uint16Array(n),dictionaryPrevCodes:new Uint16Array(n),currentSequence:new Uint8Array(n),currentSequenceLength:0};for(let e=0;e<256;++e){a.dictionaryValues[e]=e;a.dictionaryLengths[e]=1}this.lzwState=a}readBits(e){let t=this.bitsCached,r=this.cachedData;for(;t<e;){const e=this.str.getByte();if(-1===e){this.eof=!0;return null}r=r<<8|e;t+=8}this.bitsCached=t-=e;this.cachedData=r;this.lastCode=null;return r>>>t&(1<<e)-1}readBlock(){let e,t,r,n=1024;const a=this.lzwState;if(!a)return;const i=a.earlyChange;let s=a.nextCode;const o=a.dictionaryValues,c=a.dictionaryLengths,l=a.dictionaryPrevCodes;let h=a.codeLength,u=a.prevCode;const d=a.currentSequence;let f=a.currentSequenceLength,g=0,p=this.bufferLength,m=this.ensureBuffer(this.bufferLength+n);for(e=0;e<512;e++){const e=this.readBits(h),a=f>0;if(e<256){d[0]=e;f=1}else{if(!(e>=258)){if(256===e){h=9;s=258;f=0;continue}this.eof=!0;delete this.lzwState;break}if(e<s){f=c[e];for(t=f-1,r=e;t>=0;t--){d[t]=o[r];r=l[r]}}else d[f++]=d[0]}if(a){l[s]=u;c[s]=c[u]+1;o[s]=d[0];s++;h=s+i&s+i-1?h:0|Math.min(Math.log(s+i)/.6931471805599453+1,12)}u=e;g+=f;if(n<g){do{n+=512}while(n<g);m=this.ensureBuffer(this.bufferLength+n)}for(t=0;t<f;t++)m[p++]=d[t]}a.nextCode=s;a.codeLength=h;a.prevCode=u;a.currentSequenceLength=f;this.bufferLength=p}}t.LZWStream=LZWStream},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.PredictorStream=void 0;r(125);r(146);r(148);r(149);var n=r(242),a=r(209),i=r(158);class PredictorStream extends n.DecodeStream{constructor(e,t,r){super(t);if(!(r instanceof a.Dict))return e;const n=this.predictor=r.get("Predictor")||1;if(n<=1)return e;if(2!==n&&(n<10||n>15))throw new i.FormatError("Unsupported predictor: ".concat(n));this.readBlock=2===n?this.readBlockTiff:this.readBlockPng;this.str=e;this.dict=e.dict;const s=this.colors=r.get("Colors")||1,o=this.bits=r.get("BPC","BitsPerComponent")||8,c=this.columns=r.get("Columns")||1;this.pixBytes=s*o+7>>3;this.rowBytes=c*s*o+7>>3;return this}readBlockTiff(){const e=this.rowBytes,t=this.bufferLength,r=this.ensureBuffer(t+e),n=this.bits,a=this.colors,i=this.str.getBytes(e);this.eof=!i.length;if(this.eof)return;let s,o=0,c=0,l=0,h=0,u=t;if(1===n&&1===a)for(s=0;s<e;++s){let e=i[s]^o;e^=e>>1;e^=e>>2;e^=e>>4;o=(1&e)<<7;r[u++]=e}else if(8===n){for(s=0;s<a;++s)r[u++]=i[s];for(;s<e;++s){r[u]=r[u-a]+i[s];u++}}else if(16===n){const t=2*a;for(s=0;s<t;++s)r[u++]=i[s];for(;s<e;s+=2){const e=((255&i[s])<<8)+(255&i[s+1])+((255&r[u-t])<<8)+(255&r[u-t+1]);r[u++]=e>>8&255;r[u++]=255&e}}else{const e=new Uint8Array(a+1),u=(1<<n)-1;let d=0,f=t;const g=this.columns;for(s=0;s<g;++s)for(let t=0;t<a;++t){if(l<n){o=o<<8|255&i[d++];l+=8}e[t]=e[t]+(o>>l-n)&u;l-=n;c=c<<n|e[t];h+=n;if(h>=8){r[f++]=c>>h-8&255;h-=8}}h>0&&(r[f++]=(c<<8-h)+(o&(1<<8-h)-1))}this.bufferLength+=e}readBlockPng(){const e=this.rowBytes,t=this.pixBytes,r=this.str.getByte(),n=this.str.getBytes(e);this.eof=!n.length;if(this.eof)return;const a=this.bufferLength,s=this.ensureBuffer(a+e);let o=s.subarray(a-e,a);0===o.length&&(o=new Uint8Array(e));let c,l,h,u=a;switch(r){case 0:for(c=0;c<e;++c)s[u++]=n[c];break;case 1:for(c=0;c<t;++c)s[u++]=n[c];for(;c<e;++c){s[u]=s[u-t]+n[c]&255;u++}break;case 2:for(c=0;c<e;++c)s[u++]=o[c]+n[c]&255;break;case 3:for(c=0;c<t;++c)s[u++]=(o[c]>>1)+n[c];for(;c<e;++c){s[u]=(o[c]+s[u-t]>>1)+n[c]&255;u++}break;case 4:for(c=0;c<t;++c){l=o[c];h=n[c];s[u++]=l+h}for(;c<e;++c){l=o[c];const e=o[c-t],r=s[u-t],a=r+l-e;let i=a-r;i<0&&(i=-i);let d=a-l;d<0&&(d=-d);let f=a-e;f<0&&(f=-f);h=n[c];s[u++]=i<=d&&i<=f?r+h:d<=f?l+h:e+h}break;default:throw new i.FormatError("Unsupported predictor: ".concat(r))}this.bufferLength+=e}}t.PredictorStream=PredictorStream},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.RunLengthStream=void 0;var n=r(242);class RunLengthStream extends n.DecodeStream{constructor(e,t){super(t);this.str=e;this.dict=e.dict}readBlock(){const e=this.str.getBytes(2);if(!e||e.length<2||128===e[0]){this.eof=!0;return}let t,r=this.bufferLength,n=e[0];if(n<128){t=this.ensureBuffer(r+n+1);t[r++]=e[1];if(n>0){const e=this.str.getBytes(n);t.set(e,r);r+=n}}else{n=257-n;const a=e[1];t=this.ensureBuffer(r+n+1);for(let e=0;e<n;e++)t[r++]=a}this.bufferLength=r}}t.RunLengthStream=RunLengthStream},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.Font=t.ErrorFont=void 0;r(159);r(179);r(227);r(112);r(212);r(125);r(146);r(148);r(149);r(2);var n=r(158),a=r(261),i=r(226),s=r(230),o=r(229),c=r(228),l=r(263),h=r(264),u=r(265),d=r(266),f=r(267),g=r(268),p=r(239),m=r(269),b=r(213),y=r(218),w=r(270);const S=[[57344,63743],[1048576,1114109]],x=1e3,v=["ascent","bbox","black","bold","charProcOperatorList","composite","cssFontInfo","data","defaultVMetrics","defaultWidth","descent","fallbackName","fontMatrix","fontType","isType3Font","italic","loadedName","mimetype","missingFile","name","remeasure","subtype","type","vertical"],k=["cMap","defaultEncoding","differences","isMonospace","isSerifFont","isSymbolicFont","seacMap","toFontChar","toUnicode","vmetrics","widths"];function adjustWidths(e){if(!e.fontMatrix)return;if(e.fontMatrix[0]===n.FONT_IDENTITY_MATRIX[0])return;const t=.001/e.fontMatrix[0],r=e.widths;for(const e in r)r[e]*=t;e.defaultWidth*=t}function amendFallbackToUnicode(e){if(!e.fallbackToUnicode)return;if(e.toUnicode instanceof h.IdentityToUnicodeMap)return;const t=[];for(const r in e.fallbackToUnicode)e.toUnicode.has(r)||(t[r]=e.fallbackToUnicode[r]);t.length>0&&e.toUnicode.amend(t)}class Glyph{constructor(e,t,r,n,a,i,o,c,l){this.originalCharCode=e;this.fontChar=t;this.unicode=r;this.accent=n;this.width=a;this.vmetric=i;this.operatorListId=o;this.isSpace=c;this.isInFont=l;const h=(0,s.getCharUnicodeCategory)(r);this.isWhitespace=h.isWhitespace;this.isZeroWidthDiacritic=h.isZeroWidthDiacritic;this.isInvisibleFormatMark=h.isInvisibleFormatMark}matchesForCache(e,t,r,n,a,i,s,o,c){return this.originalCharCode===e&&this.fontChar===t&&this.unicode===r&&this.accent===n&&this.width===a&&this.vmetric===i&&this.operatorListId===s&&this.isSpace===o&&this.isInFont===c}}function int16(e,t){return(e<<8)+t}function writeSignedInt16(e,t,r){e[t+1]=r;e[t]=r>>>8}function signedInt16(e,t){const r=(e<<8)+t;return 32768&r?r-65536:r}function string16(e){return String.fromCharCode(e>>8&255,255&e)}function safeString16(e){e>32767?e=32767:e<-32768&&(e=-32768);return String.fromCharCode(e>>8&255,255&e)}function isTrueTypeCollectionFile(e){const t=e.peekBytes(4);return"ttcf"===(0,n.bytesToString)(t)}function getFontFileType(e,t){let r,a,{type:i,subtype:s,composite:o}=t;if(function isTrueTypeFile(e){const t=e.peekBytes(4);return 65536===(0,b.readUint32)(t,0)||"true"===(0,n.bytesToString)(t)}(e)||isTrueTypeCollectionFile(e))r=o?"CIDFontType2":"TrueType";else if(function isOpenTypeFile(e){const t=e.peekBytes(4);return"OTTO"===(0,n.bytesToString)(t)}(e))r=o?"CIDFontType2":"OpenType";else if(function isType1File(e){const t=e.peekBytes(2);return 37===t[0]&&33===t[1]||128===t[0]&&1===t[1]}(e))r=o?"CIDFontType0":"MMType1"===i?"MMType1":"Type1";else if(function isCFFFile(e){const t=e.peekBytes(4);return t[0]>=1&&t[3]>=1&&t[3]<=4}(e))if(o){r="CIDFontType0";a="CIDFontType0C"}else{r="MMType1"===i?"MMType1":"Type1";a="Type1C"}else{(0,n.warn)("getFontFileType: Unable to detect correct font file Type/Subtype.");r=i;a=s}return[r,a]}function applyStandardFontGlyphMap(e,t){for(const r in t)e[+r]=t[r]}function buildToFontChar(e,t,r){const n=[];let a;for(let r=0,i=e.length;r<i;r++){a=(0,s.getUnicodeForGlyph)(e[r],t);-1!==a&&(n[r]=a)}for(const e in r){a=(0,s.getUnicodeForGlyph)(r[e],t);-1!==a&&(n[+e]=a)}return n}function convertCidString(e,t){let r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];switch(t.length){case 1:return t.charCodeAt(0);case 2:return t.charCodeAt(0)<<8|t.charCodeAt(1)}const a="Unsupported CID string (charCode ".concat(e,'): "').concat(t,'".');if(r)throw new n.FormatError(a);(0,n.warn)(a);return t}function adjustMapping(e,t,r){const a=Object.create(null),i=[];let s=0,o=S[s][0],c=S[s][1];for(let l in e){l|=0;let h=e[l];if(!t(h))continue;if(o>c){s++;if(s>=S.length){(0,n.warn)("Ran out of space in font private use area.");break}o=S[s][0];c=S[s][1]}const u=o++;0===h&&(h=r);a[u]=h;i[l]=u}return{toFontChar:i,charCodeToGlyphId:a,nextAvailableFontCharCode:o}}function createCmapTable(e,t){const r=function getRanges(e,t){const r=[];for(const n in e)e[n]>=t||r.push({fontCharCode:0|n,glyphId:e[n]});0===r.length&&r.push({fontCharCode:0,glyphId:0});r.sort((function fontGetRangesSort(e,t){return e.fontCharCode-t.fontCharCode}));const n=[],a=r.length;for(let e=0;e<a;){const t=r[e].fontCharCode,i=[r[e].glyphId];++e;let s=t;for(;e<a&&s+1===r[e].fontCharCode;){i.push(r[e].glyphId);++s;++e;if(65535===s)break}n.push([t,s,i])}return n}(e,t),a=r.at(-1)[1]>65535?2:1;let i,s,o,c,l="\0\0"+string16(a)+"\0\0"+(0,n.string32)(4+8*a);for(i=r.length-1;i>=0&&!(r[i][0]<=65535);--i);const h=i+1;r[i][0]<65535&&65535===r[i][1]&&(r[i][1]=65534);const u=r[i][1]<65535?1:0,d=h+u,f=m.OpenTypeFileBuilder.getSearchParams(d,2);let g,p,b,y,w="",S="",x="",v="",k="",C=0;for(i=0,s=h;i<s;i++){g=r[i];p=g[0];b=g[1];w+=string16(p);S+=string16(b);y=g[2];let e=!0;for(o=1,c=y.length;o<c;++o)if(y[o]!==y[o-1]+1){e=!1;break}if(e){x+=string16(y[0]-p&65535);v+=string16(0)}else{const e=2*(d-i)+2*C;C+=b-p+1;x+=string16(0);v+=string16(e);for(o=0,c=y.length;o<c;++o)k+=string16(y[o])}}if(u>0){S+="ÿÿ";w+="ÿÿ";x+="\0";v+="\0\0"}const O="\0\0"+string16(2*d)+string16(f.range)+string16(f.entry)+string16(f.rangeShift)+S+"\0\0"+w+x+v+k;let T="",M="";if(a>1){l+="\0\0\n"+(0,n.string32)(4+8*a+4+O.length);T="";for(i=0,s=r.length;i<s;i++){g=r[i];p=g[0];y=g[2];let e=y[0];for(o=1,c=y.length;o<c;++o)if(y[o]!==y[o-1]+1){b=g[0]+o-1;T+=(0,n.string32)(p)+(0,n.string32)(b)+(0,n.string32)(e);p=b+1;e=y[o]}T+=(0,n.string32)(p)+(0,n.string32)(g[1])+(0,n.string32)(e)}M="\0\f\0\0"+(0,n.string32)(T.length+16)+"\0\0\0\0"+(0,n.string32)(T.length/12)}return l+"\0"+string16(O.length+4)+O+M+T}function createOS2Table(e,t,r){r=r||{unitsPerEm:0,yMax:0,yMin:0,ascent:0,descent:0};let a=0,i=0,o=0,c=0,l=null,h=0;if(t){for(let e in t){e|=0;(l>e||!l)&&(l=e);h<e&&(h=e);const t=(0,s.getUnicodeRangeFor)(e);if(t<32)a|=1<<t;else if(t<64)i|=1<<t-32;else if(t<96)o|=1<<t-64;else{if(!(t<123))throw new n.FormatError("Unicode ranges Bits > 123 are reserved for internal usage");c|=1<<t-96}}h>65535&&(h=65535)}else{l=0;h=255}const u=e.bbox||[0,0,0,0],d=r.unitsPerEm||1/(e.fontMatrix||n.FONT_IDENTITY_MATRIX)[0],f=e.ascentScaled?1:d/x,g=r.ascent||Math.round(f*(e.ascent||u[3]));let p=r.descent||Math.round(f*(e.descent||u[1]));p>0&&e.descent>0&&u[1]<0&&(p=-p);const m=r.yMax||g,b=-r.yMin||-p;return"\0$ô\0\0\0»\0\0\0»\0\0ß\x001\0\0\0\0"+String.fromCharCode(e.fixedPitch?9:0)+"\0\0\0\0\0\0"+(0,n.string32)(a)+(0,n.string32)(i)+(0,n.string32)(o)+(0,n.string32)(c)+"*21*"+string16(e.italicAngle?1:0)+string16(l||e.firstChar)+string16(h||e.lastChar)+string16(g)+string16(p)+"\0d"+string16(m)+string16(b)+"\0\0\0\0\0\0\0\0"+string16(e.xHeight)+string16(e.capHeight)+string16(0)+string16(l||e.firstChar)+"\0"}function createPostTable(e){const t=Math.floor(65536*e.italicAngle);return"\0\0\0"+(0,n.string32)(t)+"\0\0\0\0"+(0,n.string32)(e.fixedPitch?1:0)+"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"}function createPostscriptName(e){return e.replace(/[^\x21-\x7E]|[[\](){}<>/%]/g,"").slice(0,63)}function createNameTable(e,t){t||(t=[[],[]]);const r=[t[0][0]||"Original licence",t[0][1]||e,t[0][2]||"Unknown",t[0][3]||"uniqueID",t[0][4]||e,t[0][5]||"Version 0.11",t[0][6]||createPostscriptName(e),t[0][7]||"Unknown",t[0][8]||"Unknown",t[0][9]||"Unknown"],n=[];let a,i,s,o,c;for(a=0,i=r.length;a<i;a++){c=t[1][a]||r[a];const e=[];for(s=0,o=c.length;s<o;s++)e.push(string16(c.charCodeAt(s)));n.push(e.join(""))}const l=[r,n],h=["\0","\0"],u=["\0\0","\0"],d=["\0\0","\t"],f=r.length*h.length;let g="\0\0"+string16(f)+string16(12*f+6),p=0;for(a=0,i=h.length;a<i;a++){const e=l[a];for(s=0,o=e.length;s<o;s++){c=e[s];g+=h[a]+u[a]+d[a]+string16(s)+string16(c.length)+string16(p);p+=c.length}}g+=r.join("")+n.join("");return g}t.Font=class Font{constructor(e,t,r){this.name=e;this.psName=null;this.mimetype=null;this.disableFontFace=!1;this.loadedName=r.loadedName;this.isType3Font=r.isType3Font;this.missingFile=!1;this.cssFontInfo=r.cssFontInfo;this._charsCache=Object.create(null);this._glyphCache=Object.create(null);let a=!!(r.flags&i.FontFlags.Serif);if(!a&&!r.isSimulatedFlags){const t=e.replace(/[,_]/g,"-").split("-")[0],r=(0,l.getSerifFonts)();for(const e of t.split("+"))if(r[e]){a=!0;break}}this.isSerifFont=a;this.isSymbolicFont=!!(r.flags&i.FontFlags.Symbolic);this.isMonospace=!!(r.flags&i.FontFlags.FixedPitch);let s=r.type,o=r.subtype;this.type=s;this.subtype=o;let c,h="sans-serif";this.isMonospace?h="monospace":this.isSerifFont&&(h="serif");this.fallbackName=h;this.differences=r.differences;this.widths=r.widths;this.defaultWidth=r.defaultWidth;this.composite=r.composite;this.cMap=r.cMap;this.capHeight=r.capHeight/x;this.ascent=r.ascent/x;this.descent=r.descent/x;this.lineHeight=this.ascent-this.descent;this.fontMatrix=r.fontMatrix;this.bbox=r.bbox;this.defaultEncoding=r.defaultEncoding;this.toUnicode=r.toUnicode;this.toFontChar=[];if("Type3"!==r.type){this.cidEncoding=r.cidEncoding||"";this.vertical=!!r.vertical;if(this.vertical){this.vmetrics=r.vmetrics;this.defaultVMetrics=r.defaultVMetrics}if(t&&!t.isEmpty){[s,o]=getFontFileType(t,r);s===this.type&&o===this.subtype||(0,n.info)("Inconsistent font file Type/SubType, expected: "+"".concat(this.type,"/").concat(this.subtype," but found: ").concat(s,"/").concat(o,"."));try{switch(s){case"MMType1":(0,n.info)("MMType1 font ("+e+"), falling back to Type1.");case"Type1":case"CIDFontType0":this.mimetype="font/opentype";const a="Type1C"===o||"CIDFontType0C"===o?new u.CFFFont(t,r):new w.Type1Font(e,t,r);adjustWidths(r);c=this.convert(e,a,r);break;case"OpenType":case"TrueType":case"CIDFontType2":this.mimetype="font/opentype";c=this.checkAndRepair(e,t,r);if(this.isOpenType){adjustWidths(r);s="OpenType"}break;default:throw new n.FormatError("Font ".concat(s," is not supported"))}}catch(e){(0,n.warn)(e);this.fallbackToSystemFont(r);return}amendFallbackToUnicode(r);this.data=c;this.fontType=(0,i.getFontType)(s,o,r.isStandardFont);this.fontMatrix=r.fontMatrix;this.widths=r.widths;this.defaultWidth=r.defaultWidth;this.toUnicode=r.toUnicode;this.seacMap=r.seacMap}else{t&&(0,n.warn)('Font file is empty in "'+e+'" ('+this.loadedName+")");this.fallbackToSystemFont(r)}}else{for(let e=0;e<256;e++)this.toFontChar[e]=this.differences[e]||r.defaultEncoding[e];this.fontType=n.FontType.TYPE3}}get renderer(){const e=d.FontRendererFactory.create(this,i.SEAC_ANALYSIS_ENABLED);return(0,n.shadow)(this,"renderer",e)}exportData(){const e=arguments.length>0&&void 0!==arguments[0]&&arguments[0]?[...v,...k]:v,t=Object.create(null);let r,n;for(r of e){n=this[r];void 0!==n&&(t[r]=n)}return t}fallbackToSystemFont(e){this.missingFile=!0;const t=this.name,r=this.type,a=this.subtype;let u=(0,i.normalizeFontName)(t);const d=(0,l.getStdFontMap)(),g=(0,l.getNonStdFontMap)(),p=!!d[u],m=!(!g[u]||!d[g[u]]);u=d[u]||g[u]||u;const b=(0,f.getFontBasicMetrics)()[u];if(b){isNaN(this.ascent)&&(this.ascent=b.ascent/x);isNaN(this.descent)&&(this.descent=b.descent/x);isNaN(this.capHeight)&&(this.capHeight=b.capHeight/x)}this.bold=-1!==u.search(/bold/gi);this.italic=-1!==u.search(/oblique/gi)||-1!==u.search(/italic/gi);this.black=-1!==t.search(/Black/g);const y=-1!==t.search(/Narrow/g);this.remeasure=(!p||y)&&Object.keys(this.widths).length>0;if((p||m)&&"CIDFontType2"===r&&this.cidEncoding.startsWith("Identity-")){const r=e.cidToGidMap,n=[];applyStandardFontGlyphMap(n,(0,l.getGlyphMapForStandardFonts)());/Arial-?Black/i.test(t)?applyStandardFontGlyphMap(n,(0,l.getSupplementalGlyphMapForArialBlack)()):/Calibri/i.test(t)&&applyStandardFontGlyphMap(n,(0,l.getSupplementalGlyphMapForCalibri)());if(r){for(const e in n){const t=n[e];void 0!==r[t]&&(n[+e]=r[t])}r.length!==this.toUnicode.length&&e.hasIncludedToUnicodeMap&&this.toUnicode instanceof h.IdentityToUnicodeMap&&this.toUnicode.forEach((function(e,t){const a=n[e];void 0===r[a]&&(n[+e]=t)}))}this.toUnicode instanceof h.IdentityToUnicodeMap||this.toUnicode.forEach((function(e,t){n[+e]=t}));this.toFontChar=n;this.toUnicode=new h.ToUnicodeMap(n)}else if(/Symbol/i.test(u))this.toFontChar=buildToFontChar(c.SymbolSetEncoding,(0,o.getGlyphsUnicode)(),this.differences);else if(/Dingbats/i.test(u)){/Wingdings/i.test(t)&&(0,n.warn)("Non-embedded Wingdings font, falling back to ZapfDingbats.");this.toFontChar=buildToFontChar(c.ZapfDingbatsEncoding,(0,o.getDingbatsGlyphsUnicode)(),this.differences)}else if(p){const e=buildToFontChar(this.defaultEncoding,(0,o.getGlyphsUnicode)(),this.differences);"CIDFontType2"!==r||this.cidEncoding.startsWith("Identity-")||this.toUnicode instanceof h.IdentityToUnicodeMap||this.toUnicode.forEach((function(t,r){e[+t]=r}));this.toFontChar=e}else{const e=(0,o.getGlyphsUnicode)(),r=[];this.toUnicode.forEach(((t,n)=>{if(!this.composite){const r=this.differences[t]||this.defaultEncoding[t],a=(0,s.getUnicodeForGlyph)(r,e);-1!==a&&(n=a)}r[+t]=n}));this.composite&&this.toUnicode instanceof h.IdentityToUnicodeMap&&/Verdana/i.test(t)&&applyStandardFontGlyphMap(r,(0,l.getGlyphMapForStandardFonts)());this.toFontChar=r}amendFallbackToUnicode(e);this.loadedName=u.split("-")[0];this.fontType=(0,i.getFontType)(r,a,e.isStandardFont)}checkAndRepair(e,t,r){const s=["OS/2","cmap","head","hhea","hmtx","maxp","name","post","loca","glyf","fpgm","prep","cvt ","CFF "];function readTables(e,t){const r=Object.create(null);r["OS/2"]=null;r.cmap=null;r.head=null;r.hhea=null;r.hmtx=null;r.maxp=null;r.name=null;r.post=null;for(let n=0;n<t;n++){const t=readTableEntry(e);s.includes(t.tag)&&(0!==t.length&&(r[t.tag]=t))}return r}function readTableEntry(e){const t=e.getString(4),r=e.getInt32()>>>0,n=e.getInt32()>>>0,a=e.getInt32()>>>0,i=e.pos;e.pos=e.start?e.start:0;e.skip(n);const s=e.getBytes(a);e.pos=i;if("head"===t){s[8]=s[9]=s[10]=s[11]=0;s[17]|=32}return{tag:t,checksum:r,length:a,offset:n,data:s}}function readOpenTypeHeader(e){return{version:e.getString(4),numTables:e.getUint16(),searchRange:e.getUint16(),entrySelector:e.getUint16(),rangeShift:e.getUint16()}}function sanitizeGlyph(e,t,r,n,a,i){const s={length:0,sizeOfInstructions:0};if(r-t<=12)return s;const o=e.subarray(t,r);let c=signedInt16(o[0],o[1]);if(c<0){c=-1;writeSignedInt16(o,0,c);n.set(o,a);s.length=o.length;return s}let l,h=10,u=0;for(l=0;l<c;l++){u=(o[h]<<8|o[h+1])+1;h+=2}const d=h,f=o[h]<<8|o[h+1];s.sizeOfInstructions=f;h+=2+f;const g=h;let p=0;for(l=0;l<u;l++){const e=o[h++];192&e&&(o[h-1]=63&e);let t=2;2&e?t=1:16&e&&(t=0);let r=2;4&e?r=1:32&e&&(r=0);const n=t+r;p+=n;if(8&e){const e=o[h++];l+=e;p+=e*n}}if(0===p)return s;let m=h+p;if(m>o.length)return s;if(!i&&f>0){n.set(o.subarray(0,d),a);n.set([0,0],a+d);n.set(o.subarray(g,m),a+d+2);m-=f;o.length-m>3&&(m=m+3&-4);s.length=m;return s}if(o.length-m>3){m=m+3&-4;n.set(o.subarray(0,m),a);s.length=m;return s}n.set(o,a);s.length=o.length;return s}function readNameTable(e){const r=(t.start?t.start:0)+e.offset;t.pos=r;const n=[[],[]],a=e.length,i=r+a;if(0!==t.getUint16()||a<6)return n;const s=t.getUint16(),o=t.getUint16(),c=[];let l,h;for(l=0;l<s&&t.pos+12<=i;l++){const e={platform:t.getUint16(),encoding:t.getUint16(),language:t.getUint16(),name:t.getUint16(),length:t.getUint16(),offset:t.getUint16()};(1===e.platform&&0===e.encoding&&0===e.language||3===e.platform&&1===e.encoding&&1033===e.language)&&c.push(e)}for(l=0,h=c.length;l<h;l++){const e=c[l];if(e.length<=0)continue;const a=r+o+e.offset;if(a+e.length>i)continue;t.pos=a;const s=e.name;if(e.encoding){let r="";for(let n=0,a=e.length;n<a;n+=2)r+=String.fromCharCode(t.getUint16());n[1][s]=r}else n[0][s]=t.getString(e.length)}return n}const l=[0,0,0,0,0,0,0,0,-2,-2,-2,-2,0,0,-2,-5,-1,-1,-1,-1,-1,-1,-1,-1,0,0,-1,0,-1,-1,-1,-1,1,-1,-999,0,1,0,-1,-2,0,-1,-2,-1,-1,0,-1,-1,0,0,-999,-999,-1,-1,-1,-1,-2,-999,-2,-2,-999,0,-2,-2,0,0,-2,0,-2,0,0,0,-2,-1,-1,1,1,0,0,-1,-1,-1,-1,-1,-1,-1,0,0,-1,0,-1,-1,0,-999,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,-2,-999,-999,-999,-999,-999,-1,-1,-2,-2,0,0,0,0,-1,-1,-999,-2,-2,0,0,-1,-2,-2,0,0,0,-1,-1,-1,-2];function sanitizeTTProgram(e,t){let r,a,i,s,o,c=e.data,h=0,u=0,d=0;const f=[],g=[],p=[];let m=t.tooComplexToFollowFunctions,b=!1,y=0,w=0;for(let e=c.length;h<e;){const e=c[h++];if(64===e){a=c[h++];if(b||w)h+=a;else for(r=0;r<a;r++)f.push(c[h++])}else if(65===e){a=c[h++];if(b||w)h+=2*a;else for(r=0;r<a;r++){i=c[h++];f.push(i<<8|c[h++])}}else if(176==(248&e)){a=e-176+1;if(b||w)h+=a;else for(r=0;r<a;r++)f.push(c[h++])}else if(184==(248&e)){a=e-184+1;if(b||w)h+=2*a;else for(r=0;r<a;r++){i=c[h++];f.push(i<<8|c[h++])}}else if(43!==e||m)if(44!==e||m){if(45===e)if(b){b=!1;u=h}else{o=g.pop();if(!o){(0,n.warn)("TT: ENDF bad stack");t.hintsValid=!1;return}s=p.pop();c=o.data;h=o.i;t.functionsStackDeltas[s]=f.length-o.stackTop}else if(137===e){if(b||w){(0,n.warn)("TT: nested IDEFs not allowed");m=!0}b=!0;d=h}else if(88===e)++y;else if(27===e)w=y;else if(89===e){w===y&&(w=0);--y}else if(28===e&&!b&&!w){const e=f.at(-1);e>0&&(h+=e-1)}}else{if(b||w){(0,n.warn)("TT: nested FDEFs not allowed");m=!0}b=!0;d=h;s=f.pop();t.functionsDefined[s]={data:c,i:h}}else if(!b&&!w){s=f.at(-1);if(isNaN(s))(0,n.info)("TT: CALL empty stack (or invalid entry).");else{t.functionsUsed[s]=!0;if(s in t.functionsStackDeltas){const e=f.length+t.functionsStackDeltas[s];if(e<0){(0,n.warn)("TT: CALL invalid functions stack delta.");t.hintsValid=!1;return}f.length=e}else if(s in t.functionsDefined&&!p.includes(s)){g.push({data:c,i:h,stackTop:f.length-1});p.push(s);o=t.functionsDefined[s];if(!o){(0,n.warn)("TT: CALL non-existent function");t.hintsValid=!1;return}c=o.data;h=o.i}}}if(!b&&!w){let t=0;e<=142?t=l[e]:e>=192&&e<=223?t=-1:e>=224&&(t=-2);if(e>=113&&e<=117){a=f.pop();isNaN(a)||(t=2*-a)}for(;t<0&&f.length>0;){f.pop();t++}for(;t>0;){f.push(NaN);t--}}}t.tooComplexToFollowFunctions=m;const S=[c];h>c.length&&S.push(new Uint8Array(h-c.length));if(d>u){(0,n.warn)("TT: complementing a missing function tail");S.push(new Uint8Array([34,45]))}!function foldTTTable(e,t){if(t.length>1){let r,n,a=0;for(r=0,n=t.length;r<n;r++)a+=t[r].length;a=a+3&-4;const i=new Uint8Array(a);let s=0;for(r=0,n=t.length;r<n;r++){i.set(t[r],s);s+=t[r].length}e.data=i;e.length=a}}(e,S)}let d,f,b,w;if(isTrueTypeCollectionFile(t=new y.Stream(new Uint8Array(t.getBytes())))){const e=function readTrueTypeCollectionData(e,t){const{numFonts:r,offsetTable:a}=function readTrueTypeCollectionHeader(e){const t=e.getString(4);(0,n.assert)("ttcf"===t,"Must be a TrueType Collection font.");const r=e.getUint16(),a=e.getUint16(),i=e.getInt32()>>>0,s=[];for(let t=0;t<i;t++)s.push(e.getInt32()>>>0);const o={ttcTag:t,majorVersion:r,minorVersion:a,numFonts:i,offsetTable:s};switch(r){case 1:return o;case 2:o.dsigTag=e.getInt32()>>>0;o.dsigLength=e.getInt32()>>>0;o.dsigOffset=e.getInt32()>>>0;return o}throw new n.FormatError("Invalid TrueType Collection majorVersion: ".concat(r,"."))}(e),i=t.split("+");let s;for(let o=0;o<r;o++){e.pos=(e.start||0)+a[o];const r=readOpenTypeHeader(e),c=readTables(e,r.numTables);if(!c.name)throw new n.FormatError('TrueType Collection font must contain a "name" table.');const l=readNameTable(c.name);for(let e=0,n=l.length;e<n;e++)for(let n=0,a=l[e].length;n<a;n++){const a=l[e][n]&&l[e][n].replace(/\s/g,"");if(a){if(a===t)return{header:r,tables:c};if(!(i.length<2))for(const e of i)a===e&&(s={name:e,header:r,tables:c})}}}if(s){(0,n.warn)('TrueType Collection does not contain "'.concat(t,'" font, ')+'falling back to "'.concat(s.name,'" font instead.'));return{header:s.header,tables:s.tables}}throw new n.FormatError('TrueType Collection does not contain "'.concat(t,'" font.'))}(t,this.name);d=e.header;f=e.tables}else{d=readOpenTypeHeader(t);f=readTables(t,d.numTables)}const S=!f["CFF "];if(S){if(!f.loca)throw new n.FormatError('Required "loca" table is not found');if(!f.glyf){(0,n.warn)('Required "glyf" table is not found -- trying to recover.');f.glyf={tag:"glyf",data:new Uint8Array(0)}}this.isOpenType=!1}else{const t=r.composite&&((r.cidToGidMap||[]).length>0||!(r.cMap instanceof p.IdentityCMap));if("OTTO"===d.version&&!t||!f.head||!f.hhea||!f.maxp||!f.post){w=new y.Stream(f["CFF "].data);b=new u.CFFFont(w,r);adjustWidths(r);return this.convert(e,b,r)}delete f.glyf;delete f.loca;delete f.fpgm;delete f.prep;delete f["cvt "];this.isOpenType=!0}if(!f.maxp)throw new n.FormatError('Required "maxp" table is not found');t.pos=(t.start||0)+f.maxp.offset;const x=t.getInt32(),v=t.getUint16();if(r.scaleFactors&&r.scaleFactors.length===v&&S){const{scaleFactors:e}=r,t=int16(f.head.data[50],f.head.data[51]),n=new g.GlyfTable({glyfTable:f.glyf.data,isGlyphLocationsLong:t,locaTable:f.loca.data,numGlyphs:v});n.scale(e);const{glyf:a,loca:i,isLocationLong:s}=n.write();f.glyf.data=a;f.loca.data=i;if(s!==!!t){f.head.data[50]=0;f.head.data[51]=s?1:0}const o=f.hmtx.data;for(let t=0;t<v;t++){const r=4*t,n=Math.round(e[t]*int16(o[r],o[r+1]));o[r]=n>>8&255;o[r+1]=255&n;writeSignedInt16(o,r+2,Math.round(e[t]*signedInt16(o[r+2],o[r+3])))}}let k=v+1,C=!0;if(k>65535){C=!1;k=v;(0,n.warn)("Not enough space in glyfs to duplicate first glyph.")}let O=0,T=0;if(x>=65536&&f.maxp.length>=22){t.pos+=8;if(t.getUint16()>2){f.maxp.data[14]=0;f.maxp.data[15]=2}t.pos+=4;O=t.getUint16();t.pos+=4;T=t.getUint16()}f.maxp.data[4]=k>>8;f.maxp.data[5]=255&k;const M=function sanitizeTTPrograms(e,t,r,a){const i={functionsDefined:[],functionsUsed:[],functionsStackDeltas:[],tooComplexToFollowFunctions:!1,hintsValid:!0};e&&sanitizeTTProgram(e,i);t&&sanitizeTTProgram(t,i);e&&function checkInvalidFunctions(e,t){if(!e.tooComplexToFollowFunctions)if(e.functionsDefined.length>t){(0,n.warn)("TT: more functions defined than expected");e.hintsValid=!1}else for(let r=0,a=e.functionsUsed.length;r<a;r++){if(r>t){(0,n.warn)("TT: invalid function id: "+r);e.hintsValid=!1;return}if(e.functionsUsed[r]&&!e.functionsDefined[r]){(0,n.warn)("TT: undefined function: "+r);e.hintsValid=!1;return}}}(i,a);if(r&&1&r.length){const e=new Uint8Array(r.length+1);e.set(r.data);r.data=e}return i.hintsValid}(f.fpgm,f.prep,f["cvt "],O);if(!M){delete f.fpgm;delete f.prep;delete f["cvt "]}!function sanitizeMetrics(e,t,r,a,i,s){if(!t){r&&(r.data=null);return}e.pos=(e.start?e.start:0)+t.offset;e.pos+=4;e.pos+=2;e.pos+=2;e.pos+=2;e.pos+=2;e.pos+=2;e.pos+=2;e.pos+=2;e.pos+=2;e.pos+=2;const o=e.getUint16();e.pos+=8;e.pos+=2;let c=e.getUint16();if(0!==o){if(!(2&int16(a.data[44],a.data[45]))){t.data[22]=0;t.data[23]=0}}if(c>i){(0,n.info)("The numOfMetrics (".concat(c,") should not be ")+"greater than the numGlyphs (".concat(i,")."));c=i;t.data[34]=(65280&c)>>8;t.data[35]=255&c}const l=i-c-(r.length-4*c>>1);if(l>0){const e=new Uint8Array(r.length+2*l);e.set(r.data);if(s){e[r.length]=r.data[2];e[r.length+1]=r.data[3]}r.data=e}}(t,f.hhea,f.hmtx,f.head,k,C);if(!f.head)throw new n.FormatError('Required "head" table is not found');!function sanitizeHead(e,t,r){const a=e.data,i=function int32(e,t,r,n){return(e<<24)+(t<<16)+(r<<8)+n}(a[0],a[1],a[2],a[3]);if(i>>16!=1){(0,n.info)("Attempting to fix invalid version in head table: "+i);a[0]=0;a[1]=1;a[2]=0;a[3]=0}const s=int16(a[50],a[51]);if(s<0||s>1){(0,n.info)("Attempting to fix invalid indexToLocFormat in head table: "+s);const e=t+1;if(r===e<<1){a[50]=0;a[51]=0}else{if(r!==e<<2)throw new n.FormatError("Could not fix indexToLocFormat: "+s);a[50]=0;a[51]=1}}}(f.head,v,S?f.loca.length:0);let E=Object.create(null);if(S){const e=int16(f.head.data[50],f.head.data[51]),t=function sanitizeGlyphLocations(e,t,r,n,a,i,s){let o,c,l;if(n){o=4;c=function fontItemDecodeLong(e,t){return e[t]<<24|e[t+1]<<16|e[t+2]<<8|e[t+3]};l=function fontItemEncodeLong(e,t,r){e[t]=r>>>24&255;e[t+1]=r>>16&255;e[t+2]=r>>8&255;e[t+3]=255&r}}else{o=2;c=function fontItemDecode(e,t){return e[t]<<9|e[t+1]<<1};l=function fontItemEncode(e,t,r){e[t]=r>>9&255;e[t+1]=r>>1&255}}const h=i?r+1:r,u=o*(1+h),d=new Uint8Array(u);d.set(e.data.subarray(0,u));e.data=d;const f=t.data,g=f.length,p=new Uint8Array(g);let m,b;const y=[];for(m=0,b=0;m<r+1;m++,b+=o){let e=c(d,b);e>g&&(e=g);y.push({index:m,offset:e,endOffset:0})}y.sort(((e,t)=>e.offset-t.offset));for(m=0;m<r;m++)y[m].endOffset=y[m+1].offset;y.sort(((e,t)=>e.index-t.index));for(m=0;m<r;m++){const{offset:e,endOffset:t}=y[m];if(0!==e||0!==t)break;const r=y[m+1].offset;if(0!==r){y[m].endOffset=r;break}}const w=Object.create(null);let S=0;l(d,0,S);for(m=0,b=o;m<r;m++,b+=o){const e=sanitizeGlyph(f,y[m].offset,y[m].endOffset,p,S,a),t=e.length;0===t&&(w[m]=!0);e.sizeOfInstructions>s&&(s=e.sizeOfInstructions);S+=t;l(d,b,S)}if(0===S){const e=new Uint8Array([0,1,0,0,0,0,0,0,0,0,0,0,0,0,49,0]);for(m=0,b=o;m<h;m++,b+=o)l(d,b,e.length);t.data=e}else if(i){const r=c(d,o);if(p.length>r+S)t.data=p.subarray(0,r+S);else{t.data=new Uint8Array(r+S);t.data.set(p.subarray(0,S))}t.data.set(p.subarray(0,r),S);l(e.data,d.length-o,S+r)}else t.data=p.subarray(0,S);return{missingGlyphs:w,maxSizeOfInstructions:s}}(f.loca,f.glyf,v,e,M,C,T);E=t.missingGlyphs;if(x>=65536&&f.maxp.length>=22){f.maxp.data[26]=t.maxSizeOfInstructions>>8;f.maxp.data[27]=255&t.maxSizeOfInstructions}}if(!f.hhea)throw new n.FormatError('Required "hhea" table is not found');if(0===f.hhea.data[10]&&0===f.hhea.data[11]){f.hhea.data[10]=255;f.hhea.data[11]=255}const D={unitsPerEm:int16(f.head.data[18],f.head.data[19]),yMax:int16(f.head.data[42],f.head.data[43]),yMin:signedInt16(f.head.data[38],f.head.data[39]),ascent:signedInt16(f.hhea.data[4],f.hhea.data[5]),descent:signedInt16(f.hhea.data[6],f.hhea.data[7]),lineGap:signedInt16(f.hhea.data[8],f.hhea.data[9])};this.ascent=D.ascent/D.unitsPerEm;this.descent=D.descent/D.unitsPerEm;this.lineGap=D.lineGap/D.unitsPerEm;if(this.cssFontInfo&&this.cssFontInfo.lineHeight){this.lineHeight=this.cssFontInfo.metrics.lineHeight;this.lineGap=this.cssFontInfo.metrics.lineGap}else this.lineHeight=this.ascent-this.descent+this.lineGap;f.post&&function readPostScriptTable(e,r,a){const s=(t.start?t.start:0)+e.offset;t.pos=s;const o=s+e.length,c=t.getInt32();t.skip(28);let l,h,u=!0;switch(c){case 65536:l=i.MacStandardGlyphOrdering;break;case 131072:const e=t.getUint16();if(e!==a){u=!1;break}const s=[];for(h=0;h<e;++h){const e=t.getUint16();if(e>=32768){u=!1;break}s.push(e)}if(!u)break;const d=[],f=[];for(;t.pos<o;){const e=t.getByte();f.length=e;for(h=0;h<e;++h)f[h]=String.fromCharCode(t.getByte());d.push(f.join(""))}l=[];for(h=0;h<e;++h){const e=s[h];e<258?l.push(i.MacStandardGlyphOrdering[e]):l.push(d[e-258])}break;case 196608:break;default:(0,n.warn)("Unknown/unsupported post table version "+c);u=!1;r.defaultEncoding&&(l=r.defaultEncoding)}r.glyphNames=l;return u}(f.post,r,v);f.post={tag:"post",data:createPostTable(r)};const N=[];function hasGlyph(e){return!E[e]}if(r.composite){const e=r.cidToGidMap||[],t=0===e.length;r.cMap.forEach((function(r,a){"string"==typeof a&&(a=convertCidString(r,a,!0));if(a>65535)throw new n.FormatError("Max size of CID is 65,535");let i=-1;t?i=a:void 0!==e[a]&&(i=e[a]);i>=0&&i<v&&hasGlyph(i)&&(N[r]=i)}))}else{const e=function readCmapTable(e,t,r,a){if(!e){(0,n.warn)("No cmap table available.");return{platformId:-1,encodingId:-1,mappings:[],hasShortCmap:!1}}let i,s=(t.start?t.start:0)+e.offset;t.pos=s;t.skip(2);const o=t.getUint16();let c,l=!1;for(let e=0;e<o;e++){const n=t.getUint16(),i=t.getUint16(),s=t.getInt32()>>>0;let h=!1;if(!c||c.platformId!==n||c.encodingId!==i){if(0!==n||0!==i&&1!==i&&3!==i)if(1===n&&0===i)h=!0;else if(3!==n||1!==i||!a&&c){if(r&&3===n&&0===i){h=!0;let r=!0;if(e<o-1){const e=t.peekBytes(2);int16(e[0],e[1])<n&&(r=!1)}r&&(l=!0)}}else{h=!0;r||(l=!0)}else h=!0;h&&(c={platformId:n,encodingId:i,offset:s});if(l)break}}c&&(t.pos=s+c.offset);if(!c||-1===t.peekByte()){(0,n.warn)("Could not find a preferred cmap table.");return{platformId:-1,encodingId:-1,mappings:[],hasShortCmap:!1}}const h=t.getUint16();let u=!1;const d=[];let f,g;if(0===h){t.skip(4);for(f=0;f<256;f++){const e=t.getByte();e&&d.push({charCode:f,glyphId:e})}u=!0}else if(2===h){t.skip(4);const e=[];let r=0;for(let n=0;n<256;n++){const n=t.getUint16()>>3;e.push(n);r=Math.max(n,r)}const n=[];for(let e=0;e<=r;e++)n.push({firstCode:t.getUint16(),entryCount:t.getUint16(),idDelta:signedInt16(t.getByte(),t.getByte()),idRangePos:t.pos+t.getUint16()});for(let r=0;r<256;r++)if(0===e[r]){t.pos=n[0].idRangePos+2*r;g=t.getUint16();d.push({charCode:r,glyphId:g})}else{const a=n[e[r]];for(f=0;f<a.entryCount;f++){const e=(r<<8)+f+a.firstCode;t.pos=a.idRangePos+2*f;g=t.getUint16();0!==g&&(g=(g+a.idDelta)%65536);d.push({charCode:e,glyphId:g})}}}else if(4===h){t.skip(4);const e=t.getUint16()>>1;t.skip(6);const r=[];let n;for(n=0;n<e;n++)r.push({end:t.getUint16()});t.skip(2);for(n=0;n<e;n++)r[n].start=t.getUint16();for(n=0;n<e;n++)r[n].delta=t.getUint16();let a,o=0;for(n=0;n<e;n++){i=r[n];const s=t.getUint16();if(s){a=(s>>1)-(e-n);i.offsetIndex=a;o=Math.max(o,a+i.end-i.start+1)}else i.offsetIndex=-1}const c=[];for(f=0;f<o;f++)c.push(t.getUint16());for(n=0;n<e;n++){i=r[n];s=i.start;const e=i.end,t=i.delta;a=i.offsetIndex;for(f=s;f<=e;f++)if(65535!==f){g=a<0?f:c[a+f-s];g=g+t&65535;d.push({charCode:f,glyphId:g})}}}else if(6===h){t.skip(4);const e=t.getUint16(),r=t.getUint16();for(f=0;f<r;f++){g=t.getUint16();const r=e+f;d.push({charCode:r,glyphId:g})}}else{if(12!==h){(0,n.warn)("cmap table has unsupported format: "+h);return{platformId:-1,encodingId:-1,mappings:[],hasShortCmap:!1}}{t.skip(10);const e=t.getInt32()>>>0;for(f=0;f<e;f++){const e=t.getInt32()>>>0,r=t.getInt32()>>>0;let n=t.getInt32()>>>0;for(let t=e;t<=r;t++)d.push({charCode:t,glyphId:n++})}}}d.sort((function(e,t){return e.charCode-t.charCode}));for(let e=1;e<d.length;e++)if(d[e-1].charCode===d[e].charCode){d.splice(e,1);e--}return{platformId:c.platformId,encodingId:c.encodingId,mappings:d,hasShortCmap:u}}(f.cmap,t,this.isSymbolicFont,r.hasEncoding),a=e.platformId,s=e.encodingId,l=e.mappings,u=l.length;let d=[],g=!1;!r.hasEncoding||"MacRomanEncoding"!==r.baseEncodingName&&"WinAnsiEncoding"!==r.baseEncodingName||(d=(0,c.getEncoding)(r.baseEncodingName));if(r.hasEncoding&&!this.isSymbolicFont&&(3===a&&1===s||1===a&&0===s)){const e=(0,o.getGlyphsUnicode)();for(let t=0;t<256;t++){let n;n=void 0!==this.differences[t]?this.differences[t]:d.length&&""!==d[t]?d[t]:c.StandardEncoding[t];if(!n)continue;const o=(0,i.recoverGlyphName)(n,e);let f;3===a&&1===s?f=e[o]:1===a&&0===s&&(f=c.MacRomanEncoding.indexOf(o));if(void 0===f){if(!r.glyphNames&&r.hasIncludedToUnicodeMap&&!(this.toUnicode instanceof h.IdentityToUnicodeMap)){const e=this.toUnicode.get(t);e&&(f=e.codePointAt(0))}if(void 0===f)continue}for(let e=0;e<u;++e)if(l[e].charCode===f){N[t]=l[e].glyphId;break}}}else if(0===a){for(let e=0;e<u;++e)N[l[e].charCode]=l[e].glyphId;g=!0}else for(let e=0;e<u;++e){let t=l[e].charCode;3===a&&t>=61440&&t<=61695&&(t&=255);N[t]=l[e].glyphId}if(r.glyphNames&&(d.length||this.differences.length))for(let e=0;e<256;++e){if(!g&&void 0!==N[e])continue;const t=this.differences[e]||d[e];if(!t)continue;const n=r.glyphNames.indexOf(t);n>0&&hasGlyph(n)&&(N[e]=n)}}0===N.length&&(N[0]=0);let R=k-1;C||(R=0);if(!r.cssFontInfo){const e=adjustMapping(N,hasGlyph,R);this.toFontChar=e.toFontChar;f.cmap={tag:"cmap",data:createCmapTable(e.charCodeToGlyphId,k)};f["OS/2"]&&function validateOS2Table(e,t){t.pos=(t.start||0)+e.offset;const r=t.getUint16();t.skip(60);const n=t.getUint16();if(r<4&&768&n)return!1;if(t.getUint16()>t.getUint16())return!1;t.skip(6);if(0===t.getUint16())return!1;e.data[8]=e.data[9]=0;return!0}(f["OS/2"],t)||(f["OS/2"]={tag:"OS/2",data:createOS2Table(r,e.charCodeToGlyphId,D)})}if(!S)try{w=new y.Stream(f["CFF "].data);b=new a.CFFParser(w,r,i.SEAC_ANALYSIS_ENABLED).parse();b.duplicateFirstGlyph();const e=new a.CFFCompiler(b);f["CFF "].data=e.compile()}catch(e){(0,n.warn)("Failed to compile font "+r.loadedName)}if(f.name){const t=readNameTable(f.name);f.name.data=createNameTable(e,t);this.psName=t[0][6]||null}else f.name={tag:"name",data:createNameTable(this.name)};const L=new m.OpenTypeFileBuilder(d.version);for(const e in f)L.addTable(e,f[e].data);return L.toArray()}convert(e,t,r){r.fixedPitch=!1;r.builtInEncoding&&function adjustToUnicode(e,t){if(e.isInternalFont)return;if(t===e.defaultEncoding)return;if(e.toUnicode instanceof h.IdentityToUnicodeMap)return;const r=[],n=(0,o.getGlyphsUnicode)();for(const a in t){if(e.hasIncludedToUnicodeMap){if(e.toUnicode.has(a))continue}else if(e.hasEncoding&&(0===e.differences.length||void 0!==e.differences[a]))continue;const i=t[a],o=(0,s.getUnicodeForGlyph)(i,n);-1!==o&&(r[a]=String.fromCharCode(o))}r.length>0&&e.toUnicode.amend(r)}(r,r.builtInEncoding);let a=1;t instanceof u.CFFFont&&(a=t.numGlyphs-1);const l=t.getGlyphMapping(r);let d=null,f=l;if(!r.cssFontInfo){d=adjustMapping(l,t.hasGlyphId.bind(t),a);this.toFontChar=d.toFontChar;f=d.charCodeToGlyphId}const g=t.numGlyphs;function getCharCodes(e,t){let r=null;for(const n in e)if(t===e[n]){r||(r=[]);r.push(0|n)}return r}function createCharCode(e,t){for(const r in e)if(t===e[r])return 0|r;d.charCodeToGlyphId[d.nextAvailableFontCharCode]=t;return d.nextAvailableFontCharCode++}const p=t.seacs;if(d&&i.SEAC_ANALYSIS_ENABLED&&p&&p.length){const e=r.fontMatrix||n.FONT_IDENTITY_MATRIX,a=t.getCharset(),i=Object.create(null);for(let t in p){t|=0;const r=p[t],n=c.StandardEncoding[r[2]],s=c.StandardEncoding[r[3]],o=a.indexOf(n),h=a.indexOf(s);if(o<0||h<0)continue;const u={x:r[0]*e[0]+r[1]*e[2]+e[4],y:r[0]*e[1]+r[1]*e[3]+e[5]},f=getCharCodes(l,t);if(f)for(let e=0,t=f.length;e<t;e++){const t=f[e],r=d.charCodeToGlyphId,n=createCharCode(r,o),a=createCharCode(r,h);i[t]={baseFontCharCode:n,accentFontCharCode:a,accentOffset:u}}}r.seacMap=i}const b=1/(r.fontMatrix||n.FONT_IDENTITY_MATRIX)[0],y=new m.OpenTypeFileBuilder("OTTO");y.addTable("CFF ",t.data);y.addTable("OS/2",createOS2Table(r,f));y.addTable("cmap",createCmapTable(f,g));y.addTable("head","\0\0\0\0\0\0\0\0\0\0_<õ\0\0"+safeString16(b)+"\0\0\0\0\v~'\0\0\0\0\v~'\0\0"+safeString16(r.descent)+"ÿ"+safeString16(r.ascent)+string16(r.italicAngle?2:0)+"\0\0\0\0\0\0\0");y.addTable("hhea","\0\0\0"+safeString16(r.ascent)+safeString16(r.descent)+"\0\0ÿÿ\0\0\0\0\0\0"+safeString16(r.capHeight)+safeString16(Math.tan(r.italicAngle)*r.xHeight)+"\0\0\0\0\0\0\0\0\0\0\0\0"+string16(g));y.addTable("hmtx",function fontFieldsHmtx(){const e=t.charstrings,r=t.cff?t.cff.widths:null;let n="\0\0\0\0";for(let t=1,a=g;t<a;t++){let a=0;if(e){const r=e[t-1];a="width"in r?r.width:0}else r&&(a=Math.ceil(r[t]||0));n+=string16(a)+string16(0)}return n}());y.addTable("maxp","\0\0P\0"+string16(g));y.addTable("name",createNameTable(e));y.addTable("post",createPostTable(r));return y.toArray()}get spaceWidth(){const e=["space","minus","one","i","I"];let t;for(let r=0,n=e.length;r<n;r++){const n=e[r];if(n in this.widths){t=this.widths[n];break}const a=(0,o.getGlyphsUnicode)()[n];let i=0;if(this.composite&&this.cMap.contains(a)){i=this.cMap.lookup(a);"string"==typeof i&&(i=convertCidString(a,i))}!i&&this.toUnicode&&(i=this.toUnicode.charCodeOf(a));i<=0&&(i=a);t=this.widths[i];if(t)break}t=t||this.defaultWidth;return(0,n.shadow)(this,"spaceWidth",t)}_charToGlyph(e){let t,r,a,i=arguments.length>1&&void 0!==arguments[1]&&arguments[1],o=e;if(this.cMap&&this.cMap.contains(e)){o=this.cMap.lookup(e);"string"==typeof o&&(o=convertCidString(e,o))}r=this.widths[o];"number"!=typeof r&&(r=this.defaultWidth);const c=this.vmetrics&&this.vmetrics[o];let l=this.toUnicode.get(e)||e;"number"==typeof l&&(l=String.fromCharCode(l));let h=void 0!==this.toFontChar[e];t=this.toFontChar[e]||e;if(this.missingFile){const r=this.differences[e]||this.defaultEncoding[e];".notdef"!==r&&""!==r||"Type1"!==this.type||(t=32);t=(0,s.mapSpecialUnicodeValues)(t)}this.isType3Font&&(a=t);let u=null;if(this.seacMap&&this.seacMap[e]){h=!0;const r=this.seacMap[e];t=r.baseFontCharCode;u={fontChar:String.fromCodePoint(r.accentFontCharCode),offset:r.accentOffset}}let d="";"number"==typeof t&&(t<=1114111?d=String.fromCodePoint(t):(0,n.warn)("charToGlyph - invalid fontCharCode: ".concat(t)));let f=this._glyphCache[e];if(!f||!f.matchesForCache(e,d,l,u,r,c,a,i,h)){f=new Glyph(e,d,l,u,r,c,a,i,h);this._glyphCache[e]=f}return f}charsToGlyphs(e){let t=this._charsCache[e];if(t)return t;t=[];if(this.cMap){const r=Object.create(null),n=e.length;let a=0;for(;a<n;){this.cMap.readCharCode(e,a,r);const{charcode:n,length:i}=r;a+=i;const s=this._charToGlyph(n,1===i&&32===e.charCodeAt(a-1));t.push(s)}}else for(let r=0,n=e.length;r<n;++r){const n=e.charCodeAt(r),a=this._charToGlyph(n,32===n);t.push(a)}return this._charsCache[e]=t}getCharPositions(e){const t=[];if(this.cMap){const r=Object.create(null);let n=0;for(;n<e.length;){this.cMap.readCharCode(e,n,r);const a=r.length;t.push([n,n+a]);n+=a}}else for(let r=0,n=e.length;r<n;++r)t.push([r,r+1]);return t}get glyphCacheValues(){return Object.values(this._glyphCache)}encodeString(e){const t=[],r=[],hasCurrentBufErrors=()=>t.length%2==1,n=this.toUnicode instanceof h.IdentityToUnicodeMap?e=>this.toUnicode.charCodeOf(e):e=>this.toUnicode.charCodeOf(String.fromCodePoint(e));for(let a=0,i=e.length;a<i;a++){const i=e.codePointAt(a);i>55295&&(i<57344||i>65533)&&a++;if(this.toUnicode){const e=n(i);if(-1!==e){if(hasCurrentBufErrors()){t.push(r.join(""));r.length=0}for(let t=(this.cMap?this.cMap.getCharCodeLength(e):1)-1;t>=0;t--)r.push(String.fromCharCode(e>>8*t&255));continue}}if(!hasCurrentBufErrors()){t.push(r.join(""));r.length=0}r.push(String.fromCodePoint(i))}t.push(r.join(""));return t}};t.ErrorFont=class ErrorFont{constructor(e){this.error=e;this.loadedName="g_font_error";this.missingFile=!0}charsToGlyphs(){return[]}encodeString(e){return[e]}exportData(){return{error:this.error}}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.CFFTopDict=t.CFFStrings=t.CFFStandardStrings=t.CFFPrivateDict=t.CFFParser=t.CFFIndex=t.CFFHeader=t.CFFFDSelect=t.CFFCompiler=t.CFFCharset=t.CFF=void 0;r(125);r(146);r(148);r(149);r(112);r(159);var n=r(158),a=r(262),i=r(228);const s=[".notdef","space","exclam","quotedbl","numbersign","dollar","percent","ampersand","quoteright","parenleft","parenright","asterisk","plus","comma","hyphen","period","slash","zero","one","two","three","four","five","six","seven","eight","nine","colon","semicolon","less","equal","greater","question","at","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","bracketleft","backslash","bracketright","asciicircum","underscore","quoteleft","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","braceleft","bar","braceright","asciitilde","exclamdown","cent","sterling","fraction","yen","florin","section","currency","quotesingle","quotedblleft","guillemotleft","guilsinglleft","guilsinglright","fi","fl","endash","dagger","daggerdbl","periodcentered","paragraph","bullet","quotesinglbase","quotedblbase","quotedblright","guillemotright","ellipsis","perthousand","questiondown","grave","acute","circumflex","tilde","macron","breve","dotaccent","dieresis","ring","cedilla","hungarumlaut","ogonek","caron","emdash","AE","ordfeminine","Lslash","Oslash","OE","ordmasculine","ae","dotlessi","lslash","oslash","oe","germandbls","onesuperior","logicalnot","mu","trademark","Eth","onehalf","plusminus","Thorn","onequarter","divide","brokenbar","degree","thorn","threequarters","twosuperior","registered","minus","eth","multiply","threesuperior","copyright","Aacute","Acircumflex","Adieresis","Agrave","Aring","Atilde","Ccedilla","Eacute","Ecircumflex","Edieresis","Egrave","Iacute","Icircumflex","Idieresis","Igrave","Ntilde","Oacute","Ocircumflex","Odieresis","Ograve","Otilde","Scaron","Uacute","Ucircumflex","Udieresis","Ugrave","Yacute","Ydieresis","Zcaron","aacute","acircumflex","adieresis","agrave","aring","atilde","ccedilla","eacute","ecircumflex","edieresis","egrave","iacute","icircumflex","idieresis","igrave","ntilde","oacute","ocircumflex","odieresis","ograve","otilde","scaron","uacute","ucircumflex","udieresis","ugrave","yacute","ydieresis","zcaron","exclamsmall","Hungarumlautsmall","dollaroldstyle","dollarsuperior","ampersandsmall","Acutesmall","parenleftsuperior","parenrightsuperior","twodotenleader","onedotenleader","zerooldstyle","oneoldstyle","twooldstyle","threeoldstyle","fouroldstyle","fiveoldstyle","sixoldstyle","sevenoldstyle","eightoldstyle","nineoldstyle","commasuperior","threequartersemdash","periodsuperior","questionsmall","asuperior","bsuperior","centsuperior","dsuperior","esuperior","isuperior","lsuperior","msuperior","nsuperior","osuperior","rsuperior","ssuperior","tsuperior","ff","ffi","ffl","parenleftinferior","parenrightinferior","Circumflexsmall","hyphensuperior","Gravesmall","Asmall","Bsmall","Csmall","Dsmall","Esmall","Fsmall","Gsmall","Hsmall","Ismall","Jsmall","Ksmall","Lsmall","Msmall","Nsmall","Osmall","Psmall","Qsmall","Rsmall","Ssmall","Tsmall","Usmall","Vsmall","Wsmall","Xsmall","Ysmall","Zsmall","colonmonetary","onefitted","rupiah","Tildesmall","exclamdownsmall","centoldstyle","Lslashsmall","Scaronsmall","Zcaronsmall","Dieresissmall","Brevesmall","Caronsmall","Dotaccentsmall","Macronsmall","figuredash","hypheninferior","Ogoneksmall","Ringsmall","Cedillasmall","questiondownsmall","oneeighth","threeeighths","fiveeighths","seveneighths","onethird","twothirds","zerosuperior","foursuperior","fivesuperior","sixsuperior","sevensuperior","eightsuperior","ninesuperior","zeroinferior","oneinferior","twoinferior","threeinferior","fourinferior","fiveinferior","sixinferior","seveninferior","eightinferior","nineinferior","centinferior","dollarinferior","periodinferior","commainferior","Agravesmall","Aacutesmall","Acircumflexsmall","Atildesmall","Adieresissmall","Aringsmall","AEsmall","Ccedillasmall","Egravesmall","Eacutesmall","Ecircumflexsmall","Edieresissmall","Igravesmall","Iacutesmall","Icircumflexsmall","Idieresissmall","Ethsmall","Ntildesmall","Ogravesmall","Oacutesmall","Ocircumflexsmall","Otildesmall","Odieresissmall","OEsmall","Oslashsmall","Ugravesmall","Uacutesmall","Ucircumflexsmall","Udieresissmall","Yacutesmall","Thornsmall","Ydieresissmall","001.000","001.001","001.002","001.003","Black","Bold","Book","Light","Medium","Regular","Roman","Semibold"];t.CFFStandardStrings=s;const o=391,c=function CFFParserClosure(){const e=[null,{id:"hstem",min:2,stackClearing:!0,stem:!0},null,{id:"vstem",min:2,stackClearing:!0,stem:!0},{id:"vmoveto",min:1,stackClearing:!0},{id:"rlineto",min:2,resetStack:!0},{id:"hlineto",min:1,resetStack:!0},{id:"vlineto",min:1,resetStack:!0},{id:"rrcurveto",min:6,resetStack:!0},null,{id:"callsubr",min:1,undefStack:!0},{id:"return",min:0,undefStack:!0},null,null,{id:"endchar",min:0,stackClearing:!0},null,null,null,{id:"hstemhm",min:2,stackClearing:!0,stem:!0},{id:"hintmask",min:0,stackClearing:!0},{id:"cntrmask",min:0,stackClearing:!0},{id:"rmoveto",min:2,stackClearing:!0},{id:"hmoveto",min:1,stackClearing:!0},{id:"vstemhm",min:2,stackClearing:!0,stem:!0},{id:"rcurveline",min:8,resetStack:!0},{id:"rlinecurve",min:8,resetStack:!0},{id:"vvcurveto",min:4,resetStack:!0},{id:"hhcurveto",min:4,resetStack:!0},null,{id:"callgsubr",min:1,undefStack:!0},{id:"vhcurveto",min:4,resetStack:!0},{id:"hvcurveto",min:4,resetStack:!0}],t=[null,null,null,{id:"and",min:2,stackDelta:-1},{id:"or",min:2,stackDelta:-1},{id:"not",min:1,stackDelta:0},null,null,null,{id:"abs",min:1,stackDelta:0},{id:"add",min:2,stackDelta:-1,stackFn:function stack_div(e,t){e[t-2]=e[t-2]+e[t-1]}},{id:"sub",min:2,stackDelta:-1,stackFn:function stack_div(e,t){e[t-2]=e[t-2]-e[t-1]}},{id:"div",min:2,stackDelta:-1,stackFn:function stack_div(e,t){e[t-2]=e[t-2]/e[t-1]}},null,{id:"neg",min:1,stackDelta:0,stackFn:function stack_div(e,t){e[t-1]=-e[t-1]}},{id:"eq",min:2,stackDelta:-1},null,null,{id:"drop",min:1,stackDelta:-1},null,{id:"put",min:2,stackDelta:-2},{id:"get",min:1,stackDelta:0},{id:"ifelse",min:4,stackDelta:-3},{id:"random",min:0,stackDelta:1},{id:"mul",min:2,stackDelta:-1,stackFn:function stack_div(e,t){e[t-2]=e[t-2]*e[t-1]}},null,{id:"sqrt",min:1,stackDelta:0},{id:"dup",min:1,stackDelta:1},{id:"exch",min:2,stackDelta:0},{id:"index",min:2,stackDelta:0},{id:"roll",min:3,stackDelta:-2},null,null,null,{id:"hflex",min:7,resetStack:!0},{id:"flex",min:13,resetStack:!0},{id:"hflex1",min:9,resetStack:!0},{id:"flex1",min:11,resetStack:!0}];return class CFFParser{constructor(e,t,r){this.bytes=e.getBytes();this.properties=t;this.seacAnalysisEnabled=!!r}parse(){const e=this.properties,t=new CFF;this.cff=t;const r=this.parseHeader(),n=this.parseIndex(r.endPos),a=this.parseIndex(n.endPos),i=this.parseIndex(a.endPos),s=this.parseIndex(i.endPos),o=this.parseDict(a.obj.get(0)),c=this.createDict(l,o,t.strings);t.header=r.obj;t.names=this.parseNameIndex(n.obj);t.strings=this.parseStringIndex(i.obj);t.topDict=c;t.globalSubrIndex=s.obj;this.parsePrivateDict(t.topDict);t.isCIDFont=c.hasName("ROS");const h=c.getByName("CharStrings"),u=this.parseIndex(h).obj,d=c.getByName("FontMatrix");d&&(e.fontMatrix=d);const f=c.getByName("FontBBox");if(f){e.ascent=Math.max(f[3],f[1]);e.descent=Math.min(f[1],f[3]);e.ascentScaled=!0}let g,p;if(t.isCIDFont){const e=this.parseIndex(c.getByName("FDArray")).obj;for(let r=0,n=e.count;r<n;++r){const n=e.get(r),a=this.createDict(l,this.parseDict(n),t.strings);this.parsePrivateDict(a);t.fdArray.push(a)}p=null;g=this.parseCharsets(c.getByName("charset"),u.count,t.strings,!0);t.fdSelect=this.parseFDSelect(c.getByName("FDSelect"),u.count)}else{g=this.parseCharsets(c.getByName("charset"),u.count,t.strings,!1);p=this.parseEncoding(c.getByName("Encoding"),e,t.strings,g.charset)}t.charset=g;t.encoding=p;const m=this.parseCharStrings({charStrings:u,localSubrIndex:c.privateDict.subrsIndex,globalSubrIndex:s.obj,fdSelect:t.fdSelect,fdArray:t.fdArray,privateDict:c.privateDict});t.charStrings=m.charStrings;t.seacs=m.seacs;t.widths=m.widths;return t}parseHeader(){let e=this.bytes;const t=e.length;let r=0;for(;r<t&&1!==e[r];)++r;if(r>=t)throw new n.FormatError("Invalid CFF header");if(0!==r){(0,n.info)("cff data is shifted");e=e.subarray(r);this.bytes=e}const a=e[0],i=e[1],s=e[2],o=e[3];return{obj:new CFFHeader(a,i,s,o),endPos:s}}parseDict(e){let t=0;function parseOperand(){let r=e[t++];if(30===r)return function parseFloatOperand(){let r="";const n=15,a=["0","1","2","3","4","5","6","7","8","9",".","E","E-",null,"-"],i=e.length;for(;t<i;){const i=e[t++],s=i>>4,o=15&i;if(s===n)break;r+=a[s];if(o===n)break;r+=a[o]}return parseFloat(r)}();if(28===r){r=e[t++];r=(r<<24|e[t++]<<16)>>16;return r}if(29===r){r=e[t++];r=r<<8|e[t++];r=r<<8|e[t++];r=r<<8|e[t++];return r}if(r>=32&&r<=246)return r-139;if(r>=247&&r<=250)return 256*(r-247)+e[t++]+108;if(r>=251&&r<=254)return-256*(r-251)-e[t++]-108;(0,n.warn)('CFFParser_parseDict: "'+r+'" is a reserved command.');return NaN}let r=[];const a=[];t=0;const i=e.length;for(;t<i;){let n=e[t];if(n<=21){12===n&&(n=n<<8|e[++t]);a.push([n,r]);r=[];++t}else r.push(parseOperand())}return a}parseIndex(e){const t=new CFFIndex,r=this.bytes,n=r[e++]<<8|r[e++],a=[];let i,s,o=e;if(0!==n){const t=r[e++],c=e+(n+1)*t-1;for(i=0,s=n+1;i<s;++i){let n=0;for(let a=0;a<t;++a){n<<=8;n+=r[e++]}a.push(c+n)}o=a[n]}for(i=0,s=a.length-1;i<s;++i){const e=a[i],n=a[i+1];t.add(r.subarray(e,n))}return{obj:t,endPos:o}}parseNameIndex(e){const t=[];for(let r=0,a=e.count;r<a;++r){const a=e.get(r);t.push((0,n.bytesToString)(a))}return t}parseStringIndex(e){const t=new CFFStrings;for(let r=0,a=e.count;r<a;++r){const a=e.get(r);t.add((0,n.bytesToString)(a))}return t}createDict(e,t,r){const n=new e(r);for(let e=0,r=t.length;e<r;++e){const r=t[e],a=r[0],i=r[1];n.setByKey(a,i)}return n}parseCharString(r,a,i,s){if(!a||r.callDepth>10)return!1;let o=r.stackSize;const c=r.stack,l=a.length;for(let h=0;h<l;){const l=a[h++];let u=null;if(12===l){const e=a[h++];if(0===e){a[h-2]=139;a[h-1]=22;o=0}else u=t[e]}else if(28===l){c[o]=(a[h]<<24|a[h+1]<<16)>>16;h+=2;o++}else if(14===l){if(o>=4){o-=4;if(this.seacAnalysisEnabled){r.seac=c.slice(o,o+4);return!1}}u=e[l]}else if(l>=32&&l<=246){c[o]=l-139;o++}else if(l>=247&&l<=254){c[o]=l<251?(l-247<<8)+a[h]+108:-(l-251<<8)-a[h]-108;h++;o++}else if(255===l){c[o]=(a[h]<<24|a[h+1]<<16|a[h+2]<<8|a[h+3])/65536;h+=4;o++}else if(19===l||20===l){r.hints+=o>>1;h+=r.hints+7>>3;o%=2;u=e[l]}else{if(10===l||29===l){let t;t=10===l?i:s;if(!t){u=e[l];(0,n.warn)("Missing subrsIndex for "+u.id);return!1}let a=32768;t.count<1240?a=107:t.count<33900&&(a=1131);const h=c[--o]+a;if(h<0||h>=t.count||isNaN(h)){u=e[l];(0,n.warn)("Out of bounds subrIndex for "+u.id);return!1}r.stackSize=o;r.callDepth++;if(!this.parseCharString(r,t.get(h),i,s))return!1;r.callDepth--;o=r.stackSize;continue}if(11===l){r.stackSize=o;return!0}if(0===l&&h===a.length){a[h-1]=14;u=e[14]}else u=e[l]}if(u){if(u.stem){r.hints+=o>>1;if(3===l||23===l)r.hasVStems=!0;else if(r.hasVStems&&(1===l||18===l)){(0,n.warn)("CFF stem hints are in wrong order");a[h-1]=1===l?3:23}}if("min"in u&&!r.undefStack&&o<u.min){(0,n.warn)("Not enough parameters for "+u.id+"; actual: "+o+", expected: "+u.min);if(0===o){a[h-1]=14;return!0}return!1}if(r.firstStackClearing&&u.stackClearing){r.firstStackClearing=!1;o-=u.min;o>=2&&u.stem?o%=2:o>1&&(0,n.warn)("Found too many parameters for stack-clearing command");o>0&&(r.width=c[o-1])}if("stackDelta"in u){"stackFn"in u&&u.stackFn(c,o);o+=u.stackDelta}else if(u.stackClearing)o=0;else if(u.resetStack){o=0;r.undefStack=!1}else if(u.undefStack){o=0;r.undefStack=!0;r.firstStackClearing=!1}}}r.stackSize=o;return!0}parseCharStrings(e){let{charStrings:t,localSubrIndex:r,globalSubrIndex:a,fdSelect:i,fdArray:s,privateDict:o}=e;const c=[],l=[],h=t.count;for(let e=0;e<h;e++){const h=t.get(e),u={callDepth:0,stackSize:0,stack:[],undefStack:!0,hints:0,firstStackClearing:!0,seac:null,width:null,hasVStems:!1};let d=!0,f=null,g=o;if(i&&s.length){const t=i.getFDIndex(e);if(-1===t){(0,n.warn)("Glyph index is not in fd select.");d=!1}if(t>=s.length){(0,n.warn)("Invalid fd index for glyph index.");d=!1}if(d){g=s[t].privateDict;f=g.subrsIndex}}else r&&(f=r);d&&(d=this.parseCharString(u,h,f,a));if(null!==u.width){const t=g.getByName("nominalWidthX");l[e]=t+u.width}else{const t=g.getByName("defaultWidthX");l[e]=t}null!==u.seac&&(c[e]=u.seac);d||t.set(e,new Uint8Array([14]))}return{charStrings:t,seacs:c,widths:l}}emptyPrivateDictionary(e){const t=this.createDict(h,[],e.strings);e.setByKey(18,[0,0]);e.privateDict=t}parsePrivateDict(e){if(!e.hasName("Private")){this.emptyPrivateDictionary(e);return}const t=e.getByName("Private");if(!Array.isArray(t)||2!==t.length){e.removeByName("Private");return}const r=t[0],n=t[1];if(0===r||n>=this.bytes.length){this.emptyPrivateDictionary(e);return}const a=n+r,i=this.bytes.subarray(n,a),s=this.parseDict(i),o=this.createDict(h,s,e.strings);e.privateDict=o;if(!o.getByName("Subrs"))return;const c=o.getByName("Subrs"),l=n+c;if(0===c||l>=this.bytes.length){this.emptyPrivateDictionary(e);return}const u=this.parseIndex(l);o.subrsIndex=u.obj}parseCharsets(e,t,r,i){if(0===e)return new CFFCharset(!0,u.ISO_ADOBE,a.ISOAdobeCharset);if(1===e)return new CFFCharset(!0,u.EXPERT,a.ExpertCharset);if(2===e)return new CFFCharset(!0,u.EXPERT_SUBSET,a.ExpertSubsetCharset);const s=this.bytes,o=e,c=s[e++],l=[i?0:".notdef"];let h,d,f;t-=1;switch(c){case 0:for(f=0;f<t;f++){h=s[e++]<<8|s[e++];l.push(i?h:r.get(h))}break;case 1:for(;l.length<=t;){h=s[e++]<<8|s[e++];d=s[e++];for(f=0;f<=d;f++)l.push(i?h++:r.get(h++))}break;case 2:for(;l.length<=t;){h=s[e++]<<8|s[e++];d=s[e++]<<8|s[e++];for(f=0;f<=d;f++)l.push(i?h++:r.get(h++))}break;default:throw new n.FormatError("Unknown charset format")}const g=e,p=s.subarray(o,g);return new CFFCharset(!1,c,l,p)}parseEncoding(e,t,r,a){const s=Object.create(null),o=this.bytes;let c,l,h,u=!1,d=null;if(0===e||1===e){u=!0;c=e;const t=e?i.ExpertEncoding:i.StandardEncoding;for(l=0,h=a.length;l<h;l++){const e=t.indexOf(a[l]);-1!==e&&(s[e]=l)}}else{const t=e;c=o[e++];switch(127&c){case 0:const t=o[e++];for(l=1;l<=t;l++)s[o[e++]]=l;break;case 1:const r=o[e++];let a=1;for(l=0;l<r;l++){const t=o[e++],r=o[e++];for(let e=t;e<=t+r;e++)s[e]=a++}break;default:throw new n.FormatError("Unknown encoding format: ".concat(c," in CFF"))}const i=e;if(128&c){o[t]&=127;!function readSupplement(){const t=o[e++];for(l=0;l<t;l++){const t=o[e++],n=(o[e++]<<8)+(255&o[e++]);s[t]=a.indexOf(r.get(n))}}()}d=o.subarray(t,i)}c&=127;return new CFFEncoding(u,c,s,d)}parseFDSelect(e,t){const r=this.bytes,a=r[e++],i=[];let s;switch(a){case 0:for(s=0;s<t;++s){const t=r[e++];i.push(t)}break;case 3:const o=r[e++]<<8|r[e++];for(s=0;s<o;++s){let t=r[e++]<<8|r[e++];if(0===s&&0!==t){(0,n.warn)("parseFDSelect: The first range must have a first GID of 0 -- trying to recover.");t=0}const a=r[e++],o=r[e]<<8|r[e+1];for(let e=t;e<o;++e)i.push(a)}e+=2;break;default:throw new n.FormatError('parseFDSelect: Unknown format "'.concat(a,'".'))}if(i.length!==t)throw new n.FormatError("parseFDSelect: Invalid font data.");return new CFFFDSelect(a,i)}}}();t.CFFParser=c;class CFF{constructor(){this.header=null;this.names=[];this.topDict=null;this.strings=new CFFStrings;this.globalSubrIndex=null;this.encoding=null;this.charset=null;this.charStrings=null;this.fdArray=[];this.fdSelect=null;this.isCIDFont=!1}duplicateFirstGlyph(){if(this.charStrings.count>=65535){(0,n.warn)("Not enough space in charstrings to duplicate first glyph.");return}const e=this.charStrings.get(0);this.charStrings.add(e);this.isCIDFont&&this.fdSelect.fdSelect.push(this.fdSelect.fdSelect[0])}hasGlyphId(e){if(e<0||e>=this.charStrings.count)return!1;return this.charStrings.get(e).length>0}}t.CFF=CFF;class CFFHeader{constructor(e,t,r,n){this.major=e;this.minor=t;this.hdrSize=r;this.offSize=n}}t.CFFHeader=CFFHeader;class CFFStrings{constructor(){this.strings=[]}get(e){return e>=0&&e<=390?s[e]:e-o<=this.strings.length?this.strings[e-o]:s[0]}getSID(e){let t=s.indexOf(e);if(-1!==t)return t;t=this.strings.indexOf(e);return-1!==t?t+o:-1}add(e){this.strings.push(e)}get count(){return this.strings.length}}t.CFFStrings=CFFStrings;class CFFIndex{constructor(){this.objects=[];this.length=0}add(e){this.length+=e.length;this.objects.push(e)}set(e,t){this.length+=t.length-this.objects[e].length;this.objects[e]=t}get(e){return this.objects[e]}get count(){return this.objects.length}}t.CFFIndex=CFFIndex;class CFFDict{constructor(e,t){this.keyToNameMap=e.keyToNameMap;this.nameToKeyMap=e.nameToKeyMap;this.defaults=e.defaults;this.types=e.types;this.opcodes=e.opcodes;this.order=e.order;this.strings=t;this.values=Object.create(null)}setByKey(e,t){if(!(e in this.keyToNameMap))return!1;const r=t.length;if(0===r)return!0;for(let a=0;a<r;a++)if(isNaN(t[a])){(0,n.warn)('Invalid CFFDict value: "'+t+'" for key "'+e+'".');return!0}const a=this.types[e];"num"!==a&&"sid"!==a&&"offset"!==a||(t=t[0]);this.values[e]=t;return!0}setByName(e,t){if(!(e in this.nameToKeyMap))throw new n.FormatError('Invalid dictionary name "'.concat(e,'"'));this.values[this.nameToKeyMap[e]]=t}hasName(e){return this.nameToKeyMap[e]in this.values}getByName(e){if(!(e in this.nameToKeyMap))throw new n.FormatError("Invalid dictionary name ".concat(e,'"'));const t=this.nameToKeyMap[e];return t in this.values?this.values[t]:this.defaults[t]}removeByName(e){delete this.values[this.nameToKeyMap[e]]}static createTables(e){const t={keyToNameMap:{},nameToKeyMap:{},defaults:{},types:{},opcodes:{},order:[]};for(let r=0,n=e.length;r<n;++r){const n=e[r],a=Array.isArray(n[0])?(n[0][0]<<8)+n[0][1]:n[0];t.keyToNameMap[a]=n[1];t.nameToKeyMap[n[1]]=a;t.types[a]=n[2];t.defaults[a]=n[3];t.opcodes[a]=Array.isArray(n[0])?n[0]:[n[0]];t.order.push(a)}return t}}const l=function CFFTopDictClosure(){const e=[[[12,30],"ROS",["sid","sid","num"],null],[[12,20],"SyntheticBase","num",null],[0,"version","sid",null],[1,"Notice","sid",null],[[12,0],"Copyright","sid",null],[2,"FullName","sid",null],[3,"FamilyName","sid",null],[4,"Weight","sid",null],[[12,1],"isFixedPitch","num",0],[[12,2],"ItalicAngle","num",0],[[12,3],"UnderlinePosition","num",-100],[[12,4],"UnderlineThickness","num",50],[[12,5],"PaintType","num",0],[[12,6],"CharstringType","num",2],[[12,7],"FontMatrix",["num","num","num","num","num","num"],[.001,0,0,.001,0,0]],[13,"UniqueID","num",null],[5,"FontBBox",["num","num","num","num"],[0,0,0,0]],[[12,8],"StrokeWidth","num",0],[14,"XUID","array",null],[15,"charset","offset",0],[16,"Encoding","offset",0],[17,"CharStrings","offset",0],[18,"Private",["offset","offset"],null],[[12,21],"PostScript","sid",null],[[12,22],"BaseFontName","sid",null],[[12,23],"BaseFontBlend","delta",null],[[12,31],"CIDFontVersion","num",0],[[12,32],"CIDFontRevision","num",0],[[12,33],"CIDFontType","num",0],[[12,34],"CIDCount","num",8720],[[12,35],"UIDBase","num",null],[[12,37],"FDSelect","offset",null],[[12,36],"FDArray","offset",null],[[12,38],"FontName","sid",null]];let t=null;return class CFFTopDict extends CFFDict{constructor(r){null===t&&(t=CFFDict.createTables(e));super(t,r);this.privateDict=null}}}();t.CFFTopDict=l;const h=function CFFPrivateDictClosure(){const e=[[6,"BlueValues","delta",null],[7,"OtherBlues","delta",null],[8,"FamilyBlues","delta",null],[9,"FamilyOtherBlues","delta",null],[[12,9],"BlueScale","num",.039625],[[12,10],"BlueShift","num",7],[[12,11],"BlueFuzz","num",1],[10,"StdHW","num",null],[11,"StdVW","num",null],[[12,12],"StemSnapH","delta",null],[[12,13],"StemSnapV","delta",null],[[12,14],"ForceBold","num",0],[[12,17],"LanguageGroup","num",0],[[12,18],"ExpansionFactor","num",.06],[[12,19],"initialRandomSeed","num",0],[20,"defaultWidthX","num",0],[21,"nominalWidthX","num",0],[19,"Subrs","offset",null]];let t=null;return class CFFPrivateDict extends CFFDict{constructor(r){null===t&&(t=CFFDict.createTables(e));super(t,r);this.subrsIndex=null}}}();t.CFFPrivateDict=h;const u={ISO_ADOBE:0,EXPERT:1,EXPERT_SUBSET:2};class CFFCharset{constructor(e,t,r,n){this.predefined=e;this.format=t;this.charset=r;this.raw=n}}t.CFFCharset=CFFCharset;class CFFEncoding{constructor(e,t,r,n){this.predefined=e;this.format=t;this.encoding=r;this.raw=n}}class CFFFDSelect{constructor(e,t){this.format=e;this.fdSelect=t}getFDIndex(e){return e<0||e>=this.fdSelect.length?-1:this.fdSelect[e]}}t.CFFFDSelect=CFFFDSelect;class CFFOffsetTracker{constructor(){this.offsets=Object.create(null)}isTracking(e){return e in this.offsets}track(e,t){if(e in this.offsets)throw new n.FormatError("Already tracking location of ".concat(e));this.offsets[e]=t}offset(e){for(const t in this.offsets)this.offsets[t]+=e}setEntryLocation(e,t,r){if(!(e in this.offsets))throw new n.FormatError("Not tracking location of ".concat(e));const a=r.data,i=this.offsets[e];for(let e=0,r=t.length;e<r;++e){const r=5*e+i,s=r+1,o=r+2,c=r+3,l=r+4;if(29!==a[r]||0!==a[s]||0!==a[o]||0!==a[c]||0!==a[l])throw new n.FormatError("writing to an offset that is not empty");const h=t[e];a[r]=29;a[s]=h>>24&255;a[o]=h>>16&255;a[c]=h>>8&255;a[l]=255&h}}}class CFFCompiler{constructor(e){this.cff=e}compile(){const e=this.cff,t={data:[],length:0,add:function CFFCompiler_add(e){this.data=this.data.concat(e);this.length=this.data.length}},r=this.compileHeader(e.header);t.add(r);const a=this.compileNameIndex(e.names);t.add(a);if(e.isCIDFont&&e.topDict.hasName("FontMatrix")){const t=e.topDict.getByName("FontMatrix");e.topDict.removeByName("FontMatrix");for(let r=0,a=e.fdArray.length;r<a;r++){const a=e.fdArray[r];let i=t.slice(0);a.hasName("FontMatrix")&&(i=n.Util.transform(i,a.getByName("FontMatrix")));a.setByName("FontMatrix",i)}}const i=e.topDict.getByName("XUID");i&&i.length>16&&e.topDict.removeByName("XUID");e.topDict.setByName("charset",0);let s=this.compileTopDicts([e.topDict],t.length,e.isCIDFont);t.add(s.output);const o=s.trackers[0],c=this.compileStringIndex(e.strings.strings);t.add(c);const l=this.compileIndex(e.globalSubrIndex);t.add(l);if(e.encoding&&e.topDict.hasName("Encoding"))if(e.encoding.predefined)o.setEntryLocation("Encoding",[e.encoding.format],t);else{const r=this.compileEncoding(e.encoding);o.setEntryLocation("Encoding",[t.length],t);t.add(r)}const h=this.compileCharset(e.charset,e.charStrings.count,e.strings,e.isCIDFont);o.setEntryLocation("charset",[t.length],t);t.add(h);const u=this.compileCharStrings(e.charStrings);o.setEntryLocation("CharStrings",[t.length],t);t.add(u);if(e.isCIDFont){o.setEntryLocation("FDSelect",[t.length],t);const r=this.compileFDSelect(e.fdSelect);t.add(r);s=this.compileTopDicts(e.fdArray,t.length,!0);o.setEntryLocation("FDArray",[t.length],t);t.add(s.output);const n=s.trackers;this.compilePrivateDicts(e.fdArray,n,t)}this.compilePrivateDicts([e.topDict],[o],t);t.add([0]);return t.data}encodeNumber(e){return Number.isInteger(e)?this.encodeInteger(e):this.encodeFloat(e)}static get EncodeFloatRegExp(){return(0,n.shadow)(this,"EncodeFloatRegExp",/\.(\d*?)(?:9{5,20}|0{5,20})\d{0,2}(?:e(.+)|$)/)}encodeFloat(e){let t=e.toString();const r=CFFCompiler.EncodeFloatRegExp.exec(t);if(r){const n=parseFloat("1e"+((r[2]?+r[2]:0)+r[1].length));t=(Math.round(e*n)/n).toString()}let n,a,i="";for(n=0,a=t.length;n<a;++n){const e=t[n];i+="e"===e?"-"===t[++n]?"c":"b":"."===e?"a":"-"===e?"e":e}i+=1&i.length?"f":"ff";const s=[30];for(n=0,a=i.length;n<a;n+=2)s.push(parseInt(i.substring(n,n+2),16));return s}encodeInteger(e){let t;t=e>=-107&&e<=107?[e+139]:e>=108&&e<=1131?[247+((e-=108)>>8),255&e]:e>=-1131&&e<=-108?[251+((e=-e-108)>>8),255&e]:e>=-32768&&e<=32767?[28,e>>8&255,255&e]:[29,e>>24&255,e>>16&255,e>>8&255,255&e];return t}compileHeader(e){return[e.major,e.minor,4,e.offSize]}compileNameIndex(e){const t=new CFFIndex;for(let r=0,a=e.length;r<a;++r){const a=e[r],i=Math.min(a.length,127);let s=new Array(i);for(let e=0;e<i;e++){let t=a[e];(t<"!"||t>"~"||"["===t||"]"===t||"("===t||")"===t||"{"===t||"}"===t||"<"===t||">"===t||"/"===t||"%"===t)&&(t="_");s[e]=t}s=s.join("");""===s&&(s="Bad_Font_Name");t.add((0,n.stringToBytes)(s))}return this.compileIndex(t)}compileTopDicts(e,t,r){const n=[];let a=new CFFIndex;for(let i=0,s=e.length;i<s;++i){const s=e[i];if(r){s.removeByName("CIDFontVersion");s.removeByName("CIDFontRevision");s.removeByName("CIDFontType");s.removeByName("CIDCount");s.removeByName("UIDBase")}const o=new CFFOffsetTracker,c=this.compileDict(s,o);n.push(o);a.add(c);o.offset(t)}a=this.compileIndex(a,n);return{trackers:n,output:a}}compilePrivateDicts(e,t,r){for(let a=0,i=e.length;a<i;++a){const i=e[a],s=i.privateDict;if(!s||!i.hasName("Private"))throw new n.FormatError("There must be a private dictionary.");const o=new CFFOffsetTracker,c=this.compileDict(s,o);let l=r.length;o.offset(l);c.length||(l=0);t[a].setEntryLocation("Private",[c.length,l],r);r.add(c);if(s.subrsIndex&&s.hasName("Subrs")){const e=this.compileIndex(s.subrsIndex);o.setEntryLocation("Subrs",[c.length],r);r.add(e)}}}compileDict(e,t){let r=[];const a=e.order;for(let i=0;i<a.length;++i){const s=a[i];if(!(s in e.values))continue;let o=e.values[s],c=e.types[s];Array.isArray(c)||(c=[c]);Array.isArray(o)||(o=[o]);if(0!==o.length){for(let a=0,i=c.length;a<i;++a){const i=c[a],l=o[a];switch(i){case"num":case"sid":r=r.concat(this.encodeNumber(l));break;case"offset":const a=e.keyToNameMap[s];t.isTracking(a)||t.track(a,r.length);r=r.concat([29,0,0,0,0]);break;case"array":case"delta":r=r.concat(this.encodeNumber(l));for(let e=1,t=o.length;e<t;++e)r=r.concat(this.encodeNumber(o[e]));break;default:throw new n.FormatError("Unknown data type of ".concat(i))}}r=r.concat(e.opcodes[s])}}return r}compileStringIndex(e){const t=new CFFIndex;for(let r=0,a=e.length;r<a;++r)t.add((0,n.stringToBytes)(e[r]));return this.compileIndex(t)}compileGlobalSubrIndex(){const e=this.cff.globalSubrIndex;this.out.writeByteArray(this.compileIndex(e))}compileCharStrings(e){const t=new CFFIndex;for(let r=0;r<e.count;r++){const n=e.get(r);0!==n.length?t.add(n):t.add(new Uint8Array([139,14]))}return this.compileIndex(t)}compileCharset(e,t,r,a){let i;const s=t-1;if(a)i=new Uint8Array([2,0,0,s>>8&255,255&s]);else{i=new Uint8Array(1+2*s);i[0]=0;let t=0;const a=e.charset.length;let o=!1;for(let s=1;s<i.length;s+=2){let c=0;if(t<a){const a=e.charset[t++];c=r.getSID(a);if(-1===c){c=0;if(!o){o=!0;(0,n.warn)("Couldn't find ".concat(a," in CFF strings"))}}}i[s]=c>>8&255;i[s+1]=255&c}}return this.compileTypedArray(i)}compileEncoding(e){return this.compileTypedArray(e.raw)}compileFDSelect(e){const t=e.format;let r,n;switch(t){case 0:r=new Uint8Array(1+e.fdSelect.length);r[0]=t;for(n=0;n<e.fdSelect.length;n++)r[n+1]=e.fdSelect[n];break;case 3:const a=0;let i=e.fdSelect[0];const s=[t,0,0,a>>8&255,255&a,i];for(n=1;n<e.fdSelect.length;n++){const t=e.fdSelect[n];if(t!==i){s.push(n>>8&255,255&n,t);i=t}}const o=(s.length-3)/3;s[1]=o>>8&255;s[2]=255&o;s.push(n>>8&255,255&n);r=new Uint8Array(s)}return this.compileTypedArray(r)}compileTypedArray(e){const t=[];for(let r=0,n=e.length;r<n;++r)t[r]=e[r];return t}compileIndex(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[];const r=e.objects,n=r.length;if(0===n)return[0,0,0];const a=[n>>8&255,255&n];let i,s,o=1;for(i=0;i<n;++i)o+=r[i].length;s=o<256?1:o<65536?2:o<16777216?3:4;a.push(s);let c=1;for(i=0;i<n+1;i++){1===s?a.push(255&c):2===s?a.push(c>>8&255,255&c):3===s?a.push(c>>16&255,c>>8&255,255&c):a.push(c>>>24&255,c>>16&255,c>>8&255,255&c);r[i]&&(c+=r[i].length)}for(i=0;i<n;i++){t[i]&&t[i].offset(a.length);for(let e=0,t=r[i].length;e<t;e++)a.push(r[i][e])}return a}}t.CFFCompiler=CFFCompiler},(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.ISOAdobeCharset=t.ExpertSubsetCharset=t.ExpertCharset=void 0;t.ISOAdobeCharset=[".notdef","space","exclam","quotedbl","numbersign","dollar","percent","ampersand","quoteright","parenleft","parenright","asterisk","plus","comma","hyphen","period","slash","zero","one","two","three","four","five","six","seven","eight","nine","colon","semicolon","less","equal","greater","question","at","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","bracketleft","backslash","bracketright","asciicircum","underscore","quoteleft","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","braceleft","bar","braceright","asciitilde","exclamdown","cent","sterling","fraction","yen","florin","section","currency","quotesingle","quotedblleft","guillemotleft","guilsinglleft","guilsinglright","fi","fl","endash","dagger","daggerdbl","periodcentered","paragraph","bullet","quotesinglbase","quotedblbase","quotedblright","guillemotright","ellipsis","perthousand","questiondown","grave","acute","circumflex","tilde","macron","breve","dotaccent","dieresis","ring","cedilla","hungarumlaut","ogonek","caron","emdash","AE","ordfeminine","Lslash","Oslash","OE","ordmasculine","ae","dotlessi","lslash","oslash","oe","germandbls","onesuperior","logicalnot","mu","trademark","Eth","onehalf","plusminus","Thorn","onequarter","divide","brokenbar","degree","thorn","threequarters","twosuperior","registered","minus","eth","multiply","threesuperior","copyright","Aacute","Acircumflex","Adieresis","Agrave","Aring","Atilde","Ccedilla","Eacute","Ecircumflex","Edieresis","Egrave","Iacute","Icircumflex","Idieresis","Igrave","Ntilde","Oacute","Ocircumflex","Odieresis","Ograve","Otilde","Scaron","Uacute","Ucircumflex","Udieresis","Ugrave","Yacute","Ydieresis","Zcaron","aacute","acircumflex","adieresis","agrave","aring","atilde","ccedilla","eacute","ecircumflex","edieresis","egrave","iacute","icircumflex","idieresis","igrave","ntilde","oacute","ocircumflex","odieresis","ograve","otilde","scaron","uacute","ucircumflex","udieresis","ugrave","yacute","ydieresis","zcaron"];t.ExpertCharset=[".notdef","space","exclamsmall","Hungarumlautsmall","dollaroldstyle","dollarsuperior","ampersandsmall","Acutesmall","parenleftsuperior","parenrightsuperior","twodotenleader","onedotenleader","comma","hyphen","period","fraction","zerooldstyle","oneoldstyle","twooldstyle","threeoldstyle","fouroldstyle","fiveoldstyle","sixoldstyle","sevenoldstyle","eightoldstyle","nineoldstyle","colon","semicolon","commasuperior","threequartersemdash","periodsuperior","questionsmall","asuperior","bsuperior","centsuperior","dsuperior","esuperior","isuperior","lsuperior","msuperior","nsuperior","osuperior","rsuperior","ssuperior","tsuperior","ff","fi","fl","ffi","ffl","parenleftinferior","parenrightinferior","Circumflexsmall","hyphensuperior","Gravesmall","Asmall","Bsmall","Csmall","Dsmall","Esmall","Fsmall","Gsmall","Hsmall","Ismall","Jsmall","Ksmall","Lsmall","Msmall","Nsmall","Osmall","Psmall","Qsmall","Rsmall","Ssmall","Tsmall","Usmall","Vsmall","Wsmall","Xsmall","Ysmall","Zsmall","colonmonetary","onefitted","rupiah","Tildesmall","exclamdownsmall","centoldstyle","Lslashsmall","Scaronsmall","Zcaronsmall","Dieresissmall","Brevesmall","Caronsmall","Dotaccentsmall","Macronsmall","figuredash","hypheninferior","Ogoneksmall","Ringsmall","Cedillasmall","onequarter","onehalf","threequarters","questiondownsmall","oneeighth","threeeighths","fiveeighths","seveneighths","onethird","twothirds","zerosuperior","onesuperior","twosuperior","threesuperior","foursuperior","fivesuperior","sixsuperior","sevensuperior","eightsuperior","ninesuperior","zeroinferior","oneinferior","twoinferior","threeinferior","fourinferior","fiveinferior","sixinferior","seveninferior","eightinferior","nineinferior","centinferior","dollarinferior","periodinferior","commainferior","Agravesmall","Aacutesmall","Acircumflexsmall","Atildesmall","Adieresissmall","Aringsmall","AEsmall","Ccedillasmall","Egravesmall","Eacutesmall","Ecircumflexsmall","Edieresissmall","Igravesmall","Iacutesmall","Icircumflexsmall","Idieresissmall","Ethsmall","Ntildesmall","Ogravesmall","Oacutesmall","Ocircumflexsmall","Otildesmall","Odieresissmall","OEsmall","Oslashsmall","Ugravesmall","Uacutesmall","Ucircumflexsmall","Udieresissmall","Yacutesmall","Thornsmall","Ydieresissmall"];t.ExpertSubsetCharset=[".notdef","space","dollaroldstyle","dollarsuperior","parenleftsuperior","parenrightsuperior","twodotenleader","onedotenleader","comma","hyphen","period","fraction","zerooldstyle","oneoldstyle","twooldstyle","threeoldstyle","fouroldstyle","fiveoldstyle","sixoldstyle","sevenoldstyle","eightoldstyle","nineoldstyle","colon","semicolon","commasuperior","threequartersemdash","periodsuperior","asuperior","bsuperior","centsuperior","dsuperior","esuperior","isuperior","lsuperior","msuperior","nsuperior","osuperior","rsuperior","ssuperior","tsuperior","ff","fi","fl","ffi","ffl","parenleftinferior","parenrightinferior","hyphensuperior","colonmonetary","onefitted","rupiah","centoldstyle","figuredash","hypheninferior","onequarter","onehalf","threequarters","oneeighth","threeeighths","fiveeighths","seveneighths","onethird","twothirds","zerosuperior","onesuperior","twosuperior","threesuperior","foursuperior","fivesuperior","sixsuperior","sevensuperior","eightsuperior","ninesuperior","zeroinferior","oneinferior","twoinferior","threeinferior","fourinferior","fiveinferior","sixinferior","seveninferior","eightinferior","nineinferior","centinferior","dollarinferior","periodinferior","commainferior"]},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.getSerifFonts=t.getNonStdFontMap=t.getGlyphMapForStandardFonts=t.getFontNameToFileMap=void 0;t.getStandardFontName=function getStandardFontName(e){const t=(0,a.normalizeFontName)(e);return i()[t]};t.getSymbolsFonts=t.getSupplementalGlyphMapForCalibri=t.getSupplementalGlyphMapForArialBlack=t.getStdFontMap=void 0;var n=r(213),a=r(226);const i=(0,n.getLookupTableFactory)((function(e){e["Times-Roman"]="Times-Roman";e.Helvetica="Helvetica";e.Courier="Courier";e.Symbol="Symbol";e["Times-Bold"]="Times-Bold";e["Helvetica-Bold"]="Helvetica-Bold";e["Courier-Bold"]="Courier-Bold";e.ZapfDingbats="ZapfDingbats";e["Times-Italic"]="Times-Italic";e["Helvetica-Oblique"]="Helvetica-Oblique";e["Courier-Oblique"]="Courier-Oblique";e["Times-BoldItalic"]="Times-BoldItalic";e["Helvetica-BoldOblique"]="Helvetica-BoldOblique";e["Courier-BoldOblique"]="Courier-BoldOblique";e.ArialNarrow="Helvetica";e["ArialNarrow-Bold"]="Helvetica-Bold";e["ArialNarrow-BoldItalic"]="Helvetica-BoldOblique";e["ArialNarrow-Italic"]="Helvetica-Oblique";e.ArialBlack="Helvetica";e["ArialBlack-Bold"]="Helvetica-Bold";e["ArialBlack-BoldItalic"]="Helvetica-BoldOblique";e["ArialBlack-Italic"]="Helvetica-Oblique";e["Arial-Black"]="Helvetica";e["Arial-Black-Bold"]="Helvetica-Bold";e["Arial-Black-BoldItalic"]="Helvetica-BoldOblique";e["Arial-Black-Italic"]="Helvetica-Oblique";e.Arial="Helvetica";e["Arial-Bold"]="Helvetica-Bold";e["Arial-BoldItalic"]="Helvetica-BoldOblique";e["Arial-Italic"]="Helvetica-Oblique";e.ArialMT="Helvetica";e["Arial-BoldItalicMT"]="Helvetica-BoldOblique";e["Arial-BoldMT"]="Helvetica-Bold";e["Arial-ItalicMT"]="Helvetica-Oblique";e.ArialUnicodeMS="Helvetica";e["ArialUnicodeMS-Bold"]="Helvetica-Bold";e["ArialUnicodeMS-BoldItalic"]="Helvetica-BoldOblique";e["ArialUnicodeMS-Italic"]="Helvetica-Oblique";e["Courier-BoldItalic"]="Courier-BoldOblique";e["Courier-Italic"]="Courier-Oblique";e.CourierNew="Courier";e["CourierNew-Bold"]="Courier-Bold";e["CourierNew-BoldItalic"]="Courier-BoldOblique";e["CourierNew-Italic"]="Courier-Oblique";e["CourierNewPS-BoldItalicMT"]="Courier-BoldOblique";e["CourierNewPS-BoldMT"]="Courier-Bold";e["CourierNewPS-ItalicMT"]="Courier-Oblique";e.CourierNewPSMT="Courier";e["Helvetica-BoldItalic"]="Helvetica-BoldOblique";e["Helvetica-Italic"]="Helvetica-Oblique";e["Symbol-Bold"]="Symbol";e["Symbol-BoldItalic"]="Symbol";e["Symbol-Italic"]="Symbol";e.TimesNewRoman="Times-Roman";e["TimesNewRoman-Bold"]="Times-Bold";e["TimesNewRoman-BoldItalic"]="Times-BoldItalic";e["TimesNewRoman-Italic"]="Times-Italic";e.TimesNewRomanPS="Times-Roman";e["TimesNewRomanPS-Bold"]="Times-Bold";e["TimesNewRomanPS-BoldItalic"]="Times-BoldItalic";e["TimesNewRomanPS-BoldItalicMT"]="Times-BoldItalic";e["TimesNewRomanPS-BoldMT"]="Times-Bold";e["TimesNewRomanPS-Italic"]="Times-Italic";e["TimesNewRomanPS-ItalicMT"]="Times-Italic";e.TimesNewRomanPSMT="Times-Roman";e["TimesNewRomanPSMT-Bold"]="Times-Bold";e["TimesNewRomanPSMT-BoldItalic"]="Times-BoldItalic";e["TimesNewRomanPSMT-Italic"]="Times-Italic"}));t.getStdFontMap=i;const s=(0,n.getLookupTableFactory)((function(e){e.Courier="FoxitFixed.pfb";e["Courier-Bold"]="FoxitFixedBold.pfb";e["Courier-BoldOblique"]="FoxitFixedBoldItalic.pfb";e["Courier-Oblique"]="FoxitFixedItalic.pfb";e.Helvetica="FoxitSans.pfb";e["Helvetica-Bold"]="FoxitSansBold.pfb";e["Helvetica-BoldOblique"]="FoxitSansBoldItalic.pfb";e["Helvetica-Oblique"]="FoxitSansItalic.pfb";e["Times-Roman"]="FoxitSerif.pfb";e["Times-Bold"]="FoxitSerifBold.pfb";e["Times-BoldItalic"]="FoxitSerifBoldItalic.pfb";e["Times-Italic"]="FoxitSerifItalic.pfb";e.Symbol="FoxitSymbol.pfb";e.ZapfDingbats="FoxitDingbats.pfb";e["LiberationSans-Regular"]="LiberationSans-Regular.ttf";e["LiberationSans-Bold"]="LiberationSans-Bold.ttf";e["LiberationSans-Italic"]="LiberationSans-Italic.ttf";e["LiberationSans-BoldItalic"]="LiberationSans-BoldItalic.ttf"}));t.getFontNameToFileMap=s;const o=(0,n.getLookupTableFactory)((function(e){e.Calibri="Helvetica";e["Calibri-Bold"]="Helvetica-Bold";e["Calibri-BoldItalic"]="Helvetica-BoldOblique";e["Calibri-Italic"]="Helvetica-Oblique";e.CenturyGothic="Helvetica";e["CenturyGothic-Bold"]="Helvetica-Bold";e["CenturyGothic-BoldItalic"]="Helvetica-BoldOblique";e["CenturyGothic-Italic"]="Helvetica-Oblique";e.ComicSansMS="Comic Sans MS";e["ComicSansMS-Bold"]="Comic Sans MS-Bold";e["ComicSansMS-BoldItalic"]="Comic Sans MS-BoldItalic";e["ComicSansMS-Italic"]="Comic Sans MS-Italic";e["ItcSymbol-Bold"]="Helvetica-Bold";e["ItcSymbol-BoldItalic"]="Helvetica-BoldOblique";e["ItcSymbol-Book"]="Helvetica";e["ItcSymbol-BookItalic"]="Helvetica-Oblique";e["ItcSymbol-Medium"]="Helvetica";e["ItcSymbol-MediumItalic"]="Helvetica-Oblique";e.LucidaConsole="Courier";e["LucidaConsole-Bold"]="Courier-Bold";e["LucidaConsole-BoldItalic"]="Courier-BoldOblique";e["LucidaConsole-Italic"]="Courier-Oblique";e["LucidaSans-Demi"]="Helvetica-Bold";e["MS-Gothic"]="MS Gothic";e["MS-Gothic-Bold"]="MS Gothic-Bold";e["MS-Gothic-BoldItalic"]="MS Gothic-BoldItalic";e["MS-Gothic-Italic"]="MS Gothic-Italic";e["MS-Mincho"]="MS Mincho";e["MS-Mincho-Bold"]="MS Mincho-Bold";e["MS-Mincho-BoldItalic"]="MS Mincho-BoldItalic";e["MS-Mincho-Italic"]="MS Mincho-Italic";e["MS-PGothic"]="MS PGothic";e["MS-PGothic-Bold"]="MS PGothic-Bold";e["MS-PGothic-BoldItalic"]="MS PGothic-BoldItalic";e["MS-PGothic-Italic"]="MS PGothic-Italic";e["MS-PMincho"]="MS PMincho";e["MS-PMincho-Bold"]="MS PMincho-Bold";e["MS-PMincho-BoldItalic"]="MS PMincho-BoldItalic";e["MS-PMincho-Italic"]="MS PMincho-Italic";e.NuptialScript="Times-Italic";e.SegoeUISymbol="Helvetica";e.Wingdings="ZapfDingbats";e["Wingdings-Regular"]="ZapfDingbats"}));t.getNonStdFontMap=o;const c=(0,n.getLookupTableFactory)((function(e){e["Adobe Jenson"]=!0;e["Adobe Text"]=!0;e.Albertus=!0;e.Aldus=!0;e.Alexandria=!0;e.Algerian=!0;e["American Typewriter"]=!0;e.Antiqua=!0;e.Apex=!0;e.Arno=!0;e.Aster=!0;e.Aurora=!0;e.Baskerville=!0;e.Bell=!0;e.Bembo=!0;e["Bembo Schoolbook"]=!0;e.Benguiat=!0;e["Berkeley Old Style"]=!0;e["Bernhard Modern"]=!0;e["Berthold City"]=!0;e.Bodoni=!0;e["Bauer Bodoni"]=!0;e["Book Antiqua"]=!0;e.Bookman=!0;e["Bordeaux Roman"]=!0;e["Californian FB"]=!0;e.Calisto=!0;e.Calvert=!0;e.Capitals=!0;e.Cambria=!0;e.Cartier=!0;e.Caslon=!0;e.Catull=!0;e.Centaur=!0;e["Century Old Style"]=!0;e["Century Schoolbook"]=!0;e.Chaparral=!0;e["Charis SIL"]=!0;e.Cheltenham=!0;e["Cholla Slab"]=!0;e.Clarendon=!0;e.Clearface=!0;e.Cochin=!0;e.Colonna=!0;e["Computer Modern"]=!0;e["Concrete Roman"]=!0;e.Constantia=!0;e["Cooper Black"]=!0;e.Corona=!0;e.Ecotype=!0;e.Egyptienne=!0;e.Elephant=!0;e.Excelsior=!0;e.Fairfield=!0;e["FF Scala"]=!0;e.Folkard=!0;e.Footlight=!0;e.FreeSerif=!0;e["Friz Quadrata"]=!0;e.Garamond=!0;e.Gentium=!0;e.Georgia=!0;e.Gloucester=!0;e["Goudy Old Style"]=!0;e["Goudy Schoolbook"]=!0;e["Goudy Pro Font"]=!0;e.Granjon=!0;e["Guardian Egyptian"]=!0;e.Heather=!0;e.Hercules=!0;e["High Tower Text"]=!0;e.Hiroshige=!0;e["Hoefler Text"]=!0;e["Humana Serif"]=!0;e.Imprint=!0;e["Ionic No. 5"]=!0;e.Janson=!0;e.Joanna=!0;e.Korinna=!0;e.Lexicon=!0;e.LiberationSerif=!0;e["Liberation Serif"]=!0;e["Linux Libertine"]=!0;e.Literaturnaya=!0;e.Lucida=!0;e["Lucida Bright"]=!0;e.Melior=!0;e.Memphis=!0;e.Miller=!0;e.Minion=!0;e.Modern=!0;e["Mona Lisa"]=!0;e["Mrs Eaves"]=!0;e["MS Serif"]=!0;e["Museo Slab"]=!0;e["New York"]=!0;e["Nimbus Roman"]=!0;e["NPS Rawlinson Roadway"]=!0;e.NuptialScript=!0;e.Palatino=!0;e.Perpetua=!0;e.Plantin=!0;e["Plantin Schoolbook"]=!0;e.Playbill=!0;e["Poor Richard"]=!0;e["Rawlinson Roadway"]=!0;e.Renault=!0;e.Requiem=!0;e.Rockwell=!0;e.Roman=!0;e["Rotis Serif"]=!0;e.Sabon=!0;e.Scala=!0;e.Seagull=!0;e.Sistina=!0;e.Souvenir=!0;e.STIX=!0;e["Stone Informal"]=!0;e["Stone Serif"]=!0;e.Sylfaen=!0;e.Times=!0;e.Trajan=!0;e["Trinité"]=!0;e["Trump Mediaeval"]=!0;e.Utopia=!0;e["Vale Type"]=!0;e["Bitstream Vera"]=!0;e["Vera Serif"]=!0;e.Versailles=!0;e.Wanted=!0;e.Weiss=!0;e["Wide Latin"]=!0;e.Windsor=!0;e.XITS=!0}));t.getSerifFonts=c;const l=(0,n.getLookupTableFactory)((function(e){e.Dingbats=!0;e.Symbol=!0;e.ZapfDingbats=!0}));t.getSymbolsFonts=l;const h=(0,n.getLookupTableFactory)((function(e){e[2]=10;e[3]=32;e[4]=33;e[5]=34;e[6]=35;e[7]=36;e[8]=37;e[9]=38;e[10]=39;e[11]=40;e[12]=41;e[13]=42;e[14]=43;e[15]=44;e[16]=45;e[17]=46;e[18]=47;e[19]=48;e[20]=49;e[21]=50;e[22]=51;e[23]=52;e[24]=53;e[25]=54;e[26]=55;e[27]=56;e[28]=57;e[29]=58;e[30]=894;e[31]=60;e[32]=61;e[33]=62;e[34]=63;e[35]=64;e[36]=65;e[37]=66;e[38]=67;e[39]=68;e[40]=69;e[41]=70;e[42]=71;e[43]=72;e[44]=73;e[45]=74;e[46]=75;e[47]=76;e[48]=77;e[49]=78;e[50]=79;e[51]=80;e[52]=81;e[53]=82;e[54]=83;e[55]=84;e[56]=85;e[57]=86;e[58]=87;e[59]=88;e[60]=89;e[61]=90;e[62]=91;e[63]=92;e[64]=93;e[65]=94;e[66]=95;e[67]=96;e[68]=97;e[69]=98;e[70]=99;e[71]=100;e[72]=101;e[73]=102;e[74]=103;e[75]=104;e[76]=105;e[77]=106;e[78]=107;e[79]=108;e[80]=109;e[81]=110;e[82]=111;e[83]=112;e[84]=113;e[85]=114;e[86]=115;e[87]=116;e[88]=117;e[89]=118;e[90]=119;e[91]=120;e[92]=121;e[93]=122;e[94]=123;e[95]=124;e[96]=125;e[97]=126;e[98]=196;e[99]=197;e[100]=199;e[101]=201;e[102]=209;e[103]=214;e[104]=220;e[105]=225;e[106]=224;e[107]=226;e[108]=228;e[109]=227;e[110]=229;e[111]=231;e[112]=233;e[113]=232;e[114]=234;e[115]=235;e[116]=237;e[117]=236;e[118]=238;e[119]=239;e[120]=241;e[121]=243;e[122]=242;e[123]=244;e[124]=246;e[125]=245;e[126]=250;e[127]=249;e[128]=251;e[129]=252;e[130]=8224;e[131]=176;e[132]=162;e[133]=163;e[134]=167;e[135]=8226;e[136]=182;e[137]=223;e[138]=174;e[139]=169;e[140]=8482;e[141]=180;e[142]=168;e[143]=8800;e[144]=198;e[145]=216;e[146]=8734;e[147]=177;e[148]=8804;e[149]=8805;e[150]=165;e[151]=181;e[152]=8706;e[153]=8721;e[154]=8719;e[156]=8747;e[157]=170;e[158]=186;e[159]=8486;e[160]=230;e[161]=248;e[162]=191;e[163]=161;e[164]=172;e[165]=8730;e[166]=402;e[167]=8776;e[168]=8710;e[169]=171;e[170]=187;e[171]=8230;e[200]=193;e[203]=205;e[210]=218;e[223]=711;e[224]=321;e[225]=322;e[226]=352;e[227]=353;e[228]=381;e[229]=382;e[233]=221;e[234]=253;e[252]=263;e[253]=268;e[254]=269;e[258]=258;e[260]=260;e[261]=261;e[265]=280;e[266]=281;e[267]=282;e[268]=283;e[269]=313;e[275]=323;e[276]=324;e[278]=328;e[283]=344;e[284]=345;e[285]=346;e[286]=347;e[292]=367;e[295]=377;e[296]=378;e[298]=380;e[305]=963;e[306]=964;e[307]=966;e[308]=8215;e[309]=8252;e[310]=8319;e[311]=8359;e[312]=8592;e[313]=8593;e[337]=9552;e[493]=1039;e[494]=1040;e[672]=1488;e[673]=1489;e[674]=1490;e[675]=1491;e[676]=1492;e[677]=1493;e[678]=1494;e[679]=1495;e[680]=1496;e[681]=1497;e[682]=1498;e[683]=1499;e[684]=1500;e[685]=1501;e[686]=1502;e[687]=1503;e[688]=1504;e[689]=1505;e[690]=1506;e[691]=1507;e[692]=1508;e[693]=1509;e[694]=1510;e[695]=1511;e[696]=1512;e[697]=1513;e[698]=1514;e[705]=1524;e[706]=8362;e[710]=64288;e[711]=64298;e[759]=1617;e[761]=1776;e[763]=1778;e[775]=1652;e[777]=1764;e[778]=1780;e[779]=1781;e[780]=1782;e[782]=771;e[783]=64726;e[786]=8363;e[788]=8532;e[790]=768;e[791]=769;e[792]=768;e[795]=803;e[797]=64336;e[798]=64337;e[799]=64342;e[800]=64343;e[801]=64344;e[802]=64345;e[803]=64362;e[804]=64363;e[805]=64364;e[2424]=7821;e[2425]=7822;e[2426]=7823;e[2427]=7824;e[2428]=7825;e[2429]=7826;e[2430]=7827;e[2433]=7682;e[2678]=8045;e[2679]=8046;e[2830]=1552;e[2838]=686;e[2840]=751;e[2842]=753;e[2843]=754;e[2844]=755;e[2846]=757;e[2856]=767;e[2857]=848;e[2858]=849;e[2862]=853;e[2863]=854;e[2864]=855;e[2865]=861;e[2866]=862;e[2906]=7460;e[2908]=7462;e[2909]=7463;e[2910]=7464;e[2912]=7466;e[2913]=7467;e[2914]=7468;e[2916]=7470;e[2917]=7471;e[2918]=7472;e[2920]=7474;e[2921]=7475;e[2922]=7476;e[2924]=7478;e[2925]=7479;e[2926]=7480;e[2928]=7482;e[2929]=7483;e[2930]=7484;e[2932]=7486;e[2933]=7487;e[2934]=7488;e[2936]=7490;e[2937]=7491;e[2938]=7492;e[2940]=7494;e[2941]=7495;e[2942]=7496;e[2944]=7498;e[2946]=7500;e[2948]=7502;e[2950]=7504;e[2951]=7505;e[2952]=7506;e[2954]=7508;e[2955]=7509;e[2956]=7510;e[2958]=7512;e[2959]=7513;e[2960]=7514;e[2962]=7516;e[2963]=7517;e[2964]=7518;e[2966]=7520;e[2967]=7521;e[2968]=7522;e[2970]=7524;e[2971]=7525;e[2972]=7526;e[2974]=7528;e[2975]=7529;e[2976]=7530;e[2978]=1537;e[2979]=1538;e[2980]=1539;e[2982]=1549;e[2983]=1551;e[2984]=1552;e[2986]=1554;e[2987]=1555;e[2988]=1556;e[2990]=1623;e[2991]=1624;e[2995]=1775;e[2999]=1791;e[3002]=64290;e[3003]=64291;e[3004]=64292;e[3006]=64294;e[3007]=64295;e[3008]=64296;e[3011]=1900;e[3014]=8223;e[3015]=8244;e[3017]=7532;e[3018]=7533;e[3019]=7534;e[3075]=7590;e[3076]=7591;e[3079]=7594;e[3080]=7595;e[3083]=7598;e[3084]=7599;e[3087]=7602;e[3088]=7603;e[3091]=7606;e[3092]=7607;e[3095]=7610;e[3096]=7611;e[3099]=7614;e[3100]=7615;e[3103]=7618;e[3104]=7619;e[3107]=8337;e[3108]=8338;e[3116]=1884;e[3119]=1885;e[3120]=1885;e[3123]=1886;e[3124]=1886;e[3127]=1887;e[3128]=1887;e[3131]=1888;e[3132]=1888;e[3135]=1889;e[3136]=1889;e[3139]=1890;e[3140]=1890;e[3143]=1891;e[3144]=1891;e[3147]=1892;e[3148]=1892;e[3153]=580;e[3154]=581;e[3157]=584;e[3158]=585;e[3161]=588;e[3162]=589;e[3165]=891;e[3166]=892;e[3169]=1274;e[3170]=1275;e[3173]=1278;e[3174]=1279;e[3181]=7622;e[3182]=7623;e[3282]=11799;e[3316]=578;e[3379]=42785;e[3393]=1159;e[3416]=8377}));t.getGlyphMapForStandardFonts=h;const u=(0,n.getLookupTableFactory)((function(e){e[227]=322;e[264]=261;e[291]=346}));t.getSupplementalGlyphMapForArialBlack=u;const d=(0,n.getLookupTableFactory)((function(e){e[1]=32;e[4]=65;e[6]=193;e[17]=66;e[18]=67;e[21]=268;e[24]=68;e[28]=69;e[30]=201;e[32]=282;e[38]=70;e[39]=71;e[44]=72;e[47]=73;e[49]=205;e[58]=74;e[60]=75;e[62]=76;e[68]=77;e[69]=78;e[75]=79;e[87]=80;e[89]=81;e[90]=82;e[92]=344;e[94]=83;e[97]=352;e[100]=84;e[104]=85;e[115]=86;e[116]=87;e[121]=88;e[122]=89;e[124]=221;e[127]=90;e[129]=381;e[258]=97;e[260]=225;e[268]=261;e[271]=98;e[272]=99;e[273]=263;e[275]=269;e[282]=100;e[286]=101;e[288]=233;e[290]=283;e[295]=281;e[296]=102;e[336]=103;e[346]=104;e[349]=105;e[351]=237;e[361]=106;e[364]=107;e[367]=108;e[371]=322;e[373]=109;e[374]=110;e[381]=111;e[383]=243;e[393]=112;e[395]=113;e[396]=114;e[398]=345;e[400]=115;e[401]=347;e[403]=353;e[410]=116;e[437]=117;e[448]=118;e[449]=119;e[454]=120;e[455]=121;e[457]=253;e[460]=122;e[462]=382;e[463]=380;e[853]=44;e[855]=58;e[856]=46;e[876]=47;e[878]=45;e[882]=45;e[894]=40;e[895]=41;e[896]=91;e[897]=93;e[923]=64;e[1004]=48;e[1005]=49;e[1006]=50;e[1007]=51;e[1008]=52;e[1009]=53;e[1010]=54;e[1011]=55;e[1012]=56;e[1013]=57;e[1081]=37;e[1085]=43;e[1086]=45}));t.getSupplementalGlyphMapForCalibri=d},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.ToUnicodeMap=t.IdentityToUnicodeMap=void 0;var n=r(158);t.ToUnicodeMap=class ToUnicodeMap{constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[];this._map=e}get length(){return this._map.length}forEach(e){for(const t in this._map)e(t,this._map[t].charCodeAt(0))}has(e){return void 0!==this._map[e]}get(e){return this._map[e]}charCodeOf(e){const t=this._map;if(t.length<=65536)return t.indexOf(e);for(const r in t)if(t[r]===e)return 0|r;return-1}amend(e){for(const t in e)this._map[t]=e[t]}};t.IdentityToUnicodeMap=class IdentityToUnicodeMap{constructor(e,t){this.firstChar=e;this.lastChar=t}get length(){return this.lastChar+1-this.firstChar}forEach(e){for(let t=this.firstChar,r=this.lastChar;t<=r;t++)e(t,t)}has(e){return this.firstChar<=e&&e<=this.lastChar}get(e){if(this.firstChar<=e&&e<=this.lastChar)return String.fromCharCode(e)}charCodeOf(e){return Number.isInteger(e)&&e>=this.firstChar&&e<=this.lastChar?e:-1}amend(e){(0,n.unreachable)("Should not call amend()")}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.CFFFont=void 0;var n=r(261),a=r(226),i=r(158);t.CFFFont=class CFFFont{constructor(e,t){this.properties=t;const r=new n.CFFParser(e,t,a.SEAC_ANALYSIS_ENABLED);this.cff=r.parse();this.cff.duplicateFirstGlyph();const s=new n.CFFCompiler(this.cff);this.seacs=this.cff.seacs;try{this.data=s.compile()}catch(r){(0,i.warn)("Failed to compile font "+t.loadedName);this.data=e}this._createBuiltInEncoding()}get numGlyphs(){return this.cff.charStrings.count}getCharset(){return this.cff.charset.charset}getGlyphMapping(){const e=this.cff,t=this.properties,r=e.charset.charset;let n,i;if(t.composite){n=Object.create(null);let a;if(e.isCIDFont)for(i=0;i<r.length;i++){const e=r[i];a=t.cMap.charCodeOf(e);n[a]=i}else for(i=0;i<e.charStrings.count;i++){a=t.cMap.charCodeOf(i);n[a]=i}return n}let s=e.encoding?e.encoding.encoding:null;t.isInternalFont&&(s=t.defaultEncoding);n=(0,a.type1FontGlyphMapping)(t,s,r);return n}hasGlyphId(e){return this.cff.hasGlyphId(e)}_createBuiltInEncoding(){const{charset:e,encoding:t}=this.cff;if(!e||!t)return;const r=e.charset,n=t.encoding,a=[];for(const e in n){const t=n[e];if(t>=0){const n=r[t];n&&(a[e]=n)}}a.length>0&&(this.properties.builtInEncoding=a)}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.FontRendererFactory=void 0;r(227);r(125);r(146);r(148);r(149);var n=r(158),a=r(261),i=r(229),s=r(228),o=r(218);function getUint32(e,t){return(e[t]<<24|e[t+1]<<16|e[t+2]<<8|e[t+3])>>>0}function getUint16(e,t){return e[t]<<8|e[t+1]}function getInt16(e,t){return(e[t]<<24|e[t+1]<<16)>>16}function getInt8(e,t){return e[t]<<24>>24}function getFloat214(e,t){return getInt16(e,t)/16384}function getSubroutineBias(e){const t=e.length;let r=32768;t<1240?r=107:t<33900&&(r=1131);return r}function parseCmap(e,t,r){const a=1===getUint16(e,t+2)?getUint32(e,t+8):getUint32(e,t+16),i=getUint16(e,t+a);let s,o,c;if(4===i){getUint16(e,t+a+2);const r=getUint16(e,t+a+6)>>1;o=t+a+14;s=[];for(c=0;c<r;c++,o+=2)s[c]={end:getUint16(e,o)};o+=2;for(c=0;c<r;c++,o+=2)s[c].start=getUint16(e,o);for(c=0;c<r;c++,o+=2)s[c].idDelta=getUint16(e,o);for(c=0;c<r;c++,o+=2){let t=getUint16(e,o);if(0!==t){s[c].ids=[];for(let r=0,n=s[c].end-s[c].start+1;r<n;r++){s[c].ids[r]=getUint16(e,o+t);t+=2}}}return s}if(12===i){const r=getUint32(e,t+a+12);o=t+a+16;s=[];for(c=0;c<r;c++){t=getUint32(e,o);s.push({start:t,end:getUint32(e,o+4),idDelta:getUint32(e,o+8)-t});o+=12}return s}throw new n.FormatError("unsupported cmap: ".concat(i))}function parseCff(e,t,r,n){const i=new a.CFFParser(new o.Stream(e,t,r-t),{},n).parse();return{glyphs:i.charStrings.objects,subrs:i.topDict.privateDict&&i.topDict.privateDict.subrsIndex&&i.topDict.privateDict.subrsIndex.objects,gsubrs:i.globalSubrIndex&&i.globalSubrIndex.objects,isCFFCIDFont:i.isCIDFont,fdSelect:i.fdSelect,fdArray:i.fdArray}}function lookupCmap(e,t){const r=t.codePointAt(0);let n=0,a=0,i=e.length-1;for(;a<i;){const t=a+i+1>>1;r<e[t].start?i=t-1:a=t}e[a].start<=r&&r<=e[a].end&&(n=e[a].idDelta+(e[a].ids?e[a].ids[r-e[a].start]:r)&65535);return{charCode:r,glyphId:n}}function compileGlyf(e,t,r){function moveTo(e,r){t.push({cmd:"moveTo",args:[e,r]})}function lineTo(e,r){t.push({cmd:"lineTo",args:[e,r]})}function quadraticCurveTo(e,r,n,a){t.push({cmd:"quadraticCurveTo",args:[e,r,n,a]})}let n=0;const a=getInt16(e,n);let i,s=0,o=0;n+=10;if(a<0)do{i=getUint16(e,n);const a=getUint16(e,n+2);n+=4;let c,l;if(1&i){if(2&i){c=getInt16(e,n);l=getInt16(e,n+2)}else{c=getUint16(e,n);l=getUint16(e,n+2)}n+=4}else if(2&i){c=getInt8(e,n++);l=getInt8(e,n++)}else{c=e[n++];l=e[n++]}if(2&i){s=c;o=l}else{s=0;o=0}let h=1,u=1,d=0,f=0;if(8&i){h=u=getFloat214(e,n);n+=2}else if(64&i){h=getFloat214(e,n);u=getFloat214(e,n+2);n+=4}else if(128&i){h=getFloat214(e,n);d=getFloat214(e,n+2);f=getFloat214(e,n+4);u=getFloat214(e,n+6);n+=8}const g=r.glyphs[a];if(g){t.push({cmd:"save"},{cmd:"transform",args:[h,d,f,u,s,o]});compileGlyf(g,t,r);t.push({cmd:"restore"})}}while(32&i);else{const t=[];let r,c;for(r=0;r<a;r++){t.push(getUint16(e,n));n+=2}n+=2+getUint16(e,n);const l=t.at(-1)+1,h=[];for(;h.length<l;){i=e[n++];let t=1;8&i&&(t+=e[n++]);for(;t-- >0;)h.push({flags:i})}for(r=0;r<l;r++){switch(18&h[r].flags){case 0:s+=getInt16(e,n);n+=2;break;case 2:s-=e[n++];break;case 18:s+=e[n++]}h[r].x=s}for(r=0;r<l;r++){switch(36&h[r].flags){case 0:o+=getInt16(e,n);n+=2;break;case 4:o-=e[n++];break;case 36:o+=e[n++]}h[r].y=o}let u=0;for(n=0;n<a;n++){const e=t[n],a=h.slice(u,e+1);if(1&a[0].flags)a.push(a[0]);else if(1&a.at(-1).flags)a.unshift(a.at(-1));else{const e={flags:1,x:(a[0].x+a.at(-1).x)/2,y:(a[0].y+a.at(-1).y)/2};a.unshift(e);a.push(e)}moveTo(a[0].x,a[0].y);for(r=1,c=a.length;r<c;r++)if(1&a[r].flags)lineTo(a[r].x,a[r].y);else if(1&a[r+1].flags){quadraticCurveTo(a[r].x,a[r].y,a[r+1].x,a[r+1].y);r++}else quadraticCurveTo(a[r].x,a[r].y,(a[r].x+a[r+1].x)/2,(a[r].y+a[r+1].y)/2);u=e+1}}}function compileCharString(e,t,r,a){function moveTo(e,r){t.push({cmd:"moveTo",args:[e,r]})}function lineTo(e,r){t.push({cmd:"lineTo",args:[e,r]})}function bezierCurveTo(e,r,n,a,i,s){t.push({cmd:"bezierCurveTo",args:[e,r,n,a,i,s]})}const i=[];let o=0,c=0,l=0;!function parse(e){let h=0;for(;h<e.length;){let u,d,f,g,p,m,b,y,w,S=!1,x=e[h++];switch(x){case 1:case 3:case 18:case 23:l+=i.length>>1;S=!0;break;case 4:c+=i.pop();moveTo(o,c);S=!0;break;case 5:for(;i.length>0;){o+=i.shift();c+=i.shift();lineTo(o,c)}break;case 6:for(;i.length>0;){o+=i.shift();lineTo(o,c);if(0===i.length)break;c+=i.shift();lineTo(o,c)}break;case 7:for(;i.length>0;){c+=i.shift();lineTo(o,c);if(0===i.length)break;o+=i.shift();lineTo(o,c)}break;case 8:for(;i.length>0;){u=o+i.shift();f=c+i.shift();d=u+i.shift();g=f+i.shift();o=d+i.shift();c=g+i.shift();bezierCurveTo(u,f,d,g,o,c)}break;case 10:y=i.pop();w=null;if(r.isCFFCIDFont){const e=r.fdSelect.getFDIndex(a);if(e>=0&&e<r.fdArray.length){const t=r.fdArray[e];let n;t.privateDict&&t.privateDict.subrsIndex&&(n=t.privateDict.subrsIndex.objects);if(n){y+=getSubroutineBias(n);w=n[y]}}else(0,n.warn)("Invalid fd index for glyph index.")}else w=r.subrs[y+r.subrsBias];w&&parse(w);break;case 11:return;case 12:x=e[h++];switch(x){case 34:u=o+i.shift();d=u+i.shift();p=c+i.shift();o=d+i.shift();bezierCurveTo(u,c,d,p,o,p);u=o+i.shift();d=u+i.shift();o=d+i.shift();bezierCurveTo(u,p,d,c,o,c);break;case 35:u=o+i.shift();f=c+i.shift();d=u+i.shift();g=f+i.shift();o=d+i.shift();c=g+i.shift();bezierCurveTo(u,f,d,g,o,c);u=o+i.shift();f=c+i.shift();d=u+i.shift();g=f+i.shift();o=d+i.shift();c=g+i.shift();bezierCurveTo(u,f,d,g,o,c);i.pop();break;case 36:u=o+i.shift();p=c+i.shift();d=u+i.shift();m=p+i.shift();o=d+i.shift();bezierCurveTo(u,p,d,m,o,m);u=o+i.shift();d=u+i.shift();b=m+i.shift();o=d+i.shift();bezierCurveTo(u,m,d,b,o,c);break;case 37:const e=o,t=c;u=o+i.shift();f=c+i.shift();d=u+i.shift();g=f+i.shift();o=d+i.shift();c=g+i.shift();bezierCurveTo(u,f,d,g,o,c);u=o+i.shift();f=c+i.shift();d=u+i.shift();g=f+i.shift();o=d;c=g;Math.abs(o-e)>Math.abs(c-t)?o+=i.shift():c+=i.shift();bezierCurveTo(u,f,d,g,o,c);break;default:throw new n.FormatError("unknown operator: 12 ".concat(x))}break;case 14:if(i.length>=4){const e=i.pop(),n=i.pop();c=i.pop();o=i.pop();t.push({cmd:"save"},{cmd:"translate",args:[o,c]});let a=lookupCmap(r.cmap,String.fromCharCode(r.glyphNameMap[s.StandardEncoding[e]]));compileCharString(r.glyphs[a.glyphId],t,r,a.glyphId);t.push({cmd:"restore"});a=lookupCmap(r.cmap,String.fromCharCode(r.glyphNameMap[s.StandardEncoding[n]]));compileCharString(r.glyphs[a.glyphId],t,r,a.glyphId)}return;case 19:case 20:l+=i.length>>1;h+=l+7>>3;S=!0;break;case 21:c+=i.pop();o+=i.pop();moveTo(o,c);S=!0;break;case 22:o+=i.pop();moveTo(o,c);S=!0;break;case 24:for(;i.length>2;){u=o+i.shift();f=c+i.shift();d=u+i.shift();g=f+i.shift();o=d+i.shift();c=g+i.shift();bezierCurveTo(u,f,d,g,o,c)}o+=i.shift();c+=i.shift();lineTo(o,c);break;case 25:for(;i.length>6;){o+=i.shift();c+=i.shift();lineTo(o,c)}u=o+i.shift();f=c+i.shift();d=u+i.shift();g=f+i.shift();o=d+i.shift();c=g+i.shift();bezierCurveTo(u,f,d,g,o,c);break;case 26:i.length%2&&(o+=i.shift());for(;i.length>0;){u=o;f=c+i.shift();d=u+i.shift();g=f+i.shift();o=d;c=g+i.shift();bezierCurveTo(u,f,d,g,o,c)}break;case 27:i.length%2&&(c+=i.shift());for(;i.length>0;){u=o+i.shift();f=c;d=u+i.shift();g=f+i.shift();o=d+i.shift();c=g;bezierCurveTo(u,f,d,g,o,c)}break;case 28:i.push((e[h]<<24|e[h+1]<<16)>>16);h+=2;break;case 29:y=i.pop()+r.gsubrsBias;w=r.gsubrs[y];w&&parse(w);break;case 30:for(;i.length>0;){u=o;f=c+i.shift();d=u+i.shift();g=f+i.shift();o=d+i.shift();c=g+(1===i.length?i.shift():0);bezierCurveTo(u,f,d,g,o,c);if(0===i.length)break;u=o+i.shift();f=c;d=u+i.shift();g=f+i.shift();c=g+i.shift();o=d+(1===i.length?i.shift():0);bezierCurveTo(u,f,d,g,o,c)}break;case 31:for(;i.length>0;){u=o+i.shift();f=c;d=u+i.shift();g=f+i.shift();c=g+i.shift();o=d+(1===i.length?i.shift():0);bezierCurveTo(u,f,d,g,o,c);if(0===i.length)break;u=o;f=c+i.shift();d=u+i.shift();g=f+i.shift();o=d+i.shift();c=g+(1===i.length?i.shift():0);bezierCurveTo(u,f,d,g,o,c)}break;default:if(x<32)throw new n.FormatError("unknown operator: ".concat(x));if(x<247)i.push(x-139);else if(x<251)i.push(256*(x-247)+e[h++]+108);else if(x<255)i.push(256*-(x-251)-e[h++]-108);else{i.push((e[h]<<24|e[h+1]<<16|e[h+2]<<8|e[h+3])/65536);h+=4}}S&&(i.length=0)}}(e)}const c=[];class CompiledFont{constructor(e){this.constructor===CompiledFont&&(0,n.unreachable)("Cannot initialize CompiledFont.");this.fontMatrix=e;this.compiledGlyphs=Object.create(null);this.compiledCharCodeToGlyphId=Object.create(null)}getPathJs(e){const{charCode:t,glyphId:r}=lookupCmap(this.cmap,e);let n=this.compiledGlyphs[r];if(!n)try{n=this.compileGlyph(this.glyphs[r],r);this.compiledGlyphs[r]=n}catch(e){this.compiledGlyphs[r]=c;void 0===this.compiledCharCodeToGlyphId[t]&&(this.compiledCharCodeToGlyphId[t]=r);throw e}void 0===this.compiledCharCodeToGlyphId[t]&&(this.compiledCharCodeToGlyphId[t]=r);return n}compileGlyph(e,t){if(!e||0===e.length||14===e[0])return c;let r=this.fontMatrix;if(this.isCFFCIDFont){const e=this.fdSelect.getFDIndex(t);if(e>=0&&e<this.fdArray.length){r=this.fdArray[e].getByName("FontMatrix")||n.FONT_IDENTITY_MATRIX}else(0,n.warn)("Invalid fd index for glyph index.")}const a=[{cmd:"save"},{cmd:"transform",args:r.slice()},{cmd:"scale",args:["size","-size"]}];this.compileGlyphImpl(e,a,t);a.push({cmd:"restore"});return a}compileGlyphImpl(){(0,n.unreachable)("Children classes should implement this.")}hasBuiltPath(e){const{charCode:t,glyphId:r}=lookupCmap(this.cmap,e);return void 0!==this.compiledGlyphs[r]&&void 0!==this.compiledCharCodeToGlyphId[t]}}class TrueTypeCompiled extends CompiledFont{constructor(e,t,r){super(r||[488e-6,0,0,488e-6,0,0]);this.glyphs=e;this.cmap=t}compileGlyphImpl(e,t){compileGlyf(e,t,this)}}class Type2Compiled extends CompiledFont{constructor(e,t,r,n){super(r||[.001,0,0,.001,0,0]);this.glyphs=e.glyphs;this.gsubrs=e.gsubrs||[];this.subrs=e.subrs||[];this.cmap=t;this.glyphNameMap=n||(0,i.getGlyphsUnicode)();this.gsubrsBias=getSubroutineBias(this.gsubrs);this.subrsBias=getSubroutineBias(this.subrs);this.isCFFCIDFont=e.isCFFCIDFont;this.fdSelect=e.fdSelect;this.fdArray=e.fdArray}compileGlyphImpl(e,t,r){compileCharString(e,t,this,r)}}t.FontRendererFactory=class FontRendererFactory{static create(e,t){const r=new Uint8Array(e.data);let a,i,s,o,c,l;const h=getUint16(r,4);for(let e=0,u=12;e<h;e++,u+=16){const e=(0,n.bytesToString)(r.subarray(u,u+4)),h=getUint32(r,u+8),d=getUint32(r,u+12);switch(e){case"cmap":a=parseCmap(r,h);break;case"glyf":i=r.subarray(h,h+d);break;case"loca":s=r.subarray(h,h+d);break;case"head":l=getUint16(r,h+18);c=getUint16(r,h+50);break;case"CFF ":o=parseCff(r,h,h+d,t)}}if(i){const t=l?[1/l,0,0,1/l,0,0]:e.fontMatrix;return new TrueTypeCompiled(function parseGlyfTable(e,t,r){let n,a;if(r){n=4;a=getUint32}else{n=2;a=(e,t)=>2*getUint16(e,t)}const i=[];let s=a(t,0);for(let r=n;r<t.length;r+=n){const n=a(t,r);i.push(e.subarray(s,n));s=n}return i}(i,s,c),a,t)}return new Type2Compiled(o,a,e.fontMatrix,e.glyphNameMap)}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.getMetrics=t.getFontBasicMetrics=void 0;var n=r(213);const a=(0,n.getLookupTableFactory)((function(e){e.Courier=600;e["Courier-Bold"]=600;e["Courier-BoldOblique"]=600;e["Courier-Oblique"]=600;e.Helvetica=(0,n.getLookupTableFactory)((function(e){e.space=278;e.exclam=278;e.quotedbl=355;e.numbersign=556;e.dollar=556;e.percent=889;e.ampersand=667;e.quoteright=222;e.parenleft=333;e.parenright=333;e.asterisk=389;e.plus=584;e.comma=278;e.hyphen=333;e.period=278;e.slash=278;e.zero=556;e.one=556;e.two=556;e.three=556;e.four=556;e.five=556;e.six=556;e.seven=556;e.eight=556;e.nine=556;e.colon=278;e.semicolon=278;e.less=584;e.equal=584;e.greater=584;e.question=556;e.at=1015;e.A=667;e.B=667;e.C=722;e.D=722;e.E=667;e.F=611;e.G=778;e.H=722;e.I=278;e.J=500;e.K=667;e.L=556;e.M=833;e.N=722;e.O=778;e.P=667;e.Q=778;e.R=722;e.S=667;e.T=611;e.U=722;e.V=667;e.W=944;e.X=667;e.Y=667;e.Z=611;e.bracketleft=278;e.backslash=278;e.bracketright=278;e.asciicircum=469;e.underscore=556;e.quoteleft=222;e.a=556;e.b=556;e.c=500;e.d=556;e.e=556;e.f=278;e.g=556;e.h=556;e.i=222;e.j=222;e.k=500;e.l=222;e.m=833;e.n=556;e.o=556;e.p=556;e.q=556;e.r=333;e.s=500;e.t=278;e.u=556;e.v=500;e.w=722;e.x=500;e.y=500;e.z=500;e.braceleft=334;e.bar=260;e.braceright=334;e.asciitilde=584;e.exclamdown=333;e.cent=556;e.sterling=556;e.fraction=167;e.yen=556;e.florin=556;e.section=556;e.currency=556;e.quotesingle=191;e.quotedblleft=333;e.guillemotleft=556;e.guilsinglleft=333;e.guilsinglright=333;e.fi=500;e.fl=500;e.endash=556;e.dagger=556;e.daggerdbl=556;e.periodcentered=278;e.paragraph=537;e.bullet=350;e.quotesinglbase=222;e.quotedblbase=333;e.quotedblright=333;e.guillemotright=556;e.ellipsis=1e3;e.perthousand=1e3;e.questiondown=611;e.grave=333;e.acute=333;e.circumflex=333;e.tilde=333;e.macron=333;e.breve=333;e.dotaccent=333;e.dieresis=333;e.ring=333;e.cedilla=333;e.hungarumlaut=333;e.ogonek=333;e.caron=333;e.emdash=1e3;e.AE=1e3;e.ordfeminine=370;e.Lslash=556;e.Oslash=778;e.OE=1e3;e.ordmasculine=365;e.ae=889;e.dotlessi=278;e.lslash=222;e.oslash=611;e.oe=944;e.germandbls=611;e.Idieresis=278;e.eacute=556;e.abreve=556;e.uhungarumlaut=556;e.ecaron=556;e.Ydieresis=667;e.divide=584;e.Yacute=667;e.Acircumflex=667;e.aacute=556;e.Ucircumflex=722;e.yacute=500;e.scommaaccent=500;e.ecircumflex=556;e.Uring=722;e.Udieresis=722;e.aogonek=556;e.Uacute=722;e.uogonek=556;e.Edieresis=667;e.Dcroat=722;e.commaaccent=250;e.copyright=737;e.Emacron=667;e.ccaron=500;e.aring=556;e.Ncommaaccent=722;e.lacute=222;e.agrave=556;e.Tcommaaccent=611;e.Cacute=722;e.atilde=556;e.Edotaccent=667;e.scaron=500;e.scedilla=500;e.iacute=278;e.lozenge=471;e.Rcaron=722;e.Gcommaaccent=778;e.ucircumflex=556;e.acircumflex=556;e.Amacron=667;e.rcaron=333;e.ccedilla=500;e.Zdotaccent=611;e.Thorn=667;e.Omacron=778;e.Racute=722;e.Sacute=667;e.dcaron=643;e.Umacron=722;e.uring=556;e.threesuperior=333;e.Ograve=778;e.Agrave=667;e.Abreve=667;e.multiply=584;e.uacute=556;e.Tcaron=611;e.partialdiff=476;e.ydieresis=500;e.Nacute=722;e.icircumflex=278;e.Ecircumflex=667;e.adieresis=556;e.edieresis=556;e.cacute=500;e.nacute=556;e.umacron=556;e.Ncaron=722;e.Iacute=278;e.plusminus=584;e.brokenbar=260;e.registered=737;e.Gbreve=778;e.Idotaccent=278;e.summation=600;e.Egrave=667;e.racute=333;e.omacron=556;e.Zacute=611;e.Zcaron=611;e.greaterequal=549;e.Eth=722;e.Ccedilla=722;e.lcommaaccent=222;e.tcaron=317;e.eogonek=556;e.Uogonek=722;e.Aacute=667;e.Adieresis=667;e.egrave=556;e.zacute=500;e.iogonek=222;e.Oacute=778;e.oacute=556;e.amacron=556;e.sacute=500;e.idieresis=278;e.Ocircumflex=778;e.Ugrave=722;e.Delta=612;e.thorn=556;e.twosuperior=333;e.Odieresis=778;e.mu=556;e.igrave=278;e.ohungarumlaut=556;e.Eogonek=667;e.dcroat=556;e.threequarters=834;e.Scedilla=667;e.lcaron=299;e.Kcommaaccent=667;e.Lacute=556;e.trademark=1e3;e.edotaccent=556;e.Igrave=278;e.Imacron=278;e.Lcaron=556;e.onehalf=834;e.lessequal=549;e.ocircumflex=556;e.ntilde=556;e.Uhungarumlaut=722;e.Eacute=667;e.emacron=556;e.gbreve=556;e.onequarter=834;e.Scaron=667;e.Scommaaccent=667;e.Ohungarumlaut=778;e.degree=400;e.ograve=556;e.Ccaron=722;e.ugrave=556;e.radical=453;e.Dcaron=722;e.rcommaaccent=333;e.Ntilde=722;e.otilde=556;e.Rcommaaccent=722;e.Lcommaaccent=556;e.Atilde=667;e.Aogonek=667;e.Aring=667;e.Otilde=778;e.zdotaccent=500;e.Ecaron=667;e.Iogonek=278;e.kcommaaccent=500;e.minus=584;e.Icircumflex=278;e.ncaron=556;e.tcommaaccent=278;e.logicalnot=584;e.odieresis=556;e.udieresis=556;e.notequal=549;e.gcommaaccent=556;e.eth=556;e.zcaron=500;e.ncommaaccent=556;e.onesuperior=333;e.imacron=278;e.Euro=556}));e["Helvetica-Bold"]=(0,n.getLookupTableFactory)((function(e){e.space=278;e.exclam=333;e.quotedbl=474;e.numbersign=556;e.dollar=556;e.percent=889;e.ampersand=722;e.quoteright=278;e.parenleft=333;e.parenright=333;e.asterisk=389;e.plus=584;e.comma=278;e.hyphen=333;e.period=278;e.slash=278;e.zero=556;e.one=556;e.two=556;e.three=556;e.four=556;e.five=556;e.six=556;e.seven=556;e.eight=556;e.nine=556;e.colon=333;e.semicolon=333;e.less=584;e.equal=584;e.greater=584;e.question=611;e.at=975;e.A=722;e.B=722;e.C=722;e.D=722;e.E=667;e.F=611;e.G=778;e.H=722;e.I=278;e.J=556;e.K=722;e.L=611;e.M=833;e.N=722;e.O=778;e.P=667;e.Q=778;e.R=722;e.S=667;e.T=611;e.U=722;e.V=667;e.W=944;e.X=667;e.Y=667;e.Z=611;e.bracketleft=333;e.backslash=278;e.bracketright=333;e.asciicircum=584;e.underscore=556;e.quoteleft=278;e.a=556;e.b=611;e.c=556;e.d=611;e.e=556;e.f=333;e.g=611;e.h=611;e.i=278;e.j=278;e.k=556;e.l=278;e.m=889;e.n=611;e.o=611;e.p=611;e.q=611;e.r=389;e.s=556;e.t=333;e.u=611;e.v=556;e.w=778;e.x=556;e.y=556;e.z=500;e.braceleft=389;e.bar=280;e.braceright=389;e.asciitilde=584;e.exclamdown=333;e.cent=556;e.sterling=556;e.fraction=167;e.yen=556;e.florin=556;e.section=556;e.currency=556;e.quotesingle=238;e.quotedblleft=500;e.guillemotleft=556;e.guilsinglleft=333;e.guilsinglright=333;e.fi=611;e.fl=611;e.endash=556;e.dagger=556;e.daggerdbl=556;e.periodcentered=278;e.paragraph=556;e.bullet=350;e.quotesinglbase=278;e.quotedblbase=500;e.quotedblright=500;e.guillemotright=556;e.ellipsis=1e3;e.perthousand=1e3;e.questiondown=611;e.grave=333;e.acute=333;e.circumflex=333;e.tilde=333;e.macron=333;e.breve=333;e.dotaccent=333;e.dieresis=333;e.ring=333;e.cedilla=333;e.hungarumlaut=333;e.ogonek=333;e.caron=333;e.emdash=1e3;e.AE=1e3;e.ordfeminine=370;e.Lslash=611;e.Oslash=778;e.OE=1e3;e.ordmasculine=365;e.ae=889;e.dotlessi=278;e.lslash=278;e.oslash=611;e.oe=944;e.germandbls=611;e.Idieresis=278;e.eacute=556;e.abreve=556;e.uhungarumlaut=611;e.ecaron=556;e.Ydieresis=667;e.divide=584;e.Yacute=667;e.Acircumflex=722;e.aacute=556;e.Ucircumflex=722;e.yacute=556;e.scommaaccent=556;e.ecircumflex=556;e.Uring=722;e.Udieresis=722;e.aogonek=556;e.Uacute=722;e.uogonek=611;e.Edieresis=667;e.Dcroat=722;e.commaaccent=250;e.copyright=737;e.Emacron=667;e.ccaron=556;e.aring=556;e.Ncommaaccent=722;e.lacute=278;e.agrave=556;e.Tcommaaccent=611;e.Cacute=722;e.atilde=556;e.Edotaccent=667;e.scaron=556;e.scedilla=556;e.iacute=278;e.lozenge=494;e.Rcaron=722;e.Gcommaaccent=778;e.ucircumflex=611;e.acircumflex=556;e.Amacron=722;e.rcaron=389;e.ccedilla=556;e.Zdotaccent=611;e.Thorn=667;e.Omacron=778;e.Racute=722;e.Sacute=667;e.dcaron=743;e.Umacron=722;e.uring=611;e.threesuperior=333;e.Ograve=778;e.Agrave=722;e.Abreve=722;e.multiply=584;e.uacute=611;e.Tcaron=611;e.partialdiff=494;e.ydieresis=556;e.Nacute=722;e.icircumflex=278;e.Ecircumflex=667;e.adieresis=556;e.edieresis=556;e.cacute=556;e.nacute=611;e.umacron=611;e.Ncaron=722;e.Iacute=278;e.plusminus=584;e.brokenbar=280;e.registered=737;e.Gbreve=778;e.Idotaccent=278;e.summation=600;e.Egrave=667;e.racute=389;e.omacron=611;e.Zacute=611;e.Zcaron=611;e.greaterequal=549;e.Eth=722;e.Ccedilla=722;e.lcommaaccent=278;e.tcaron=389;e.eogonek=556;e.Uogonek=722;e.Aacute=722;e.Adieresis=722;e.egrave=556;e.zacute=500;e.iogonek=278;e.Oacute=778;e.oacute=611;e.amacron=556;e.sacute=556;e.idieresis=278;e.Ocircumflex=778;e.Ugrave=722;e.Delta=612;e.thorn=611;e.twosuperior=333;e.Odieresis=778;e.mu=611;e.igrave=278;e.ohungarumlaut=611;e.Eogonek=667;e.dcroat=611;e.threequarters=834;e.Scedilla=667;e.lcaron=400;e.Kcommaaccent=722;e.Lacute=611;e.trademark=1e3;e.edotaccent=556;e.Igrave=278;e.Imacron=278;e.Lcaron=611;e.onehalf=834;e.lessequal=549;e.ocircumflex=611;e.ntilde=611;e.Uhungarumlaut=722;e.Eacute=667;e.emacron=556;e.gbreve=611;e.onequarter=834;e.Scaron=667;e.Scommaaccent=667;e.Ohungarumlaut=778;e.degree=400;e.ograve=611;e.Ccaron=722;e.ugrave=611;e.radical=549;e.Dcaron=722;e.rcommaaccent=389;e.Ntilde=722;e.otilde=611;e.Rcommaaccent=722;e.Lcommaaccent=611;e.Atilde=722;e.Aogonek=722;e.Aring=722;e.Otilde=778;e.zdotaccent=500;e.Ecaron=667;e.Iogonek=278;e.kcommaaccent=556;e.minus=584;e.Icircumflex=278;e.ncaron=611;e.tcommaaccent=333;e.logicalnot=584;e.odieresis=611;e.udieresis=611;e.notequal=549;e.gcommaaccent=611;e.eth=611;e.zcaron=500;e.ncommaaccent=611;e.onesuperior=333;e.imacron=278;e.Euro=556}));e["Helvetica-BoldOblique"]=(0,n.getLookupTableFactory)((function(e){e.space=278;e.exclam=333;e.quotedbl=474;e.numbersign=556;e.dollar=556;e.percent=889;e.ampersand=722;e.quoteright=278;e.parenleft=333;e.parenright=333;e.asterisk=389;e.plus=584;e.comma=278;e.hyphen=333;e.period=278;e.slash=278;e.zero=556;e.one=556;e.two=556;e.three=556;e.four=556;e.five=556;e.six=556;e.seven=556;e.eight=556;e.nine=556;e.colon=333;e.semicolon=333;e.less=584;e.equal=584;e.greater=584;e.question=611;e.at=975;e.A=722;e.B=722;e.C=722;e.D=722;e.E=667;e.F=611;e.G=778;e.H=722;e.I=278;e.J=556;e.K=722;e.L=611;e.M=833;e.N=722;e.O=778;e.P=667;e.Q=778;e.R=722;e.S=667;e.T=611;e.U=722;e.V=667;e.W=944;e.X=667;e.Y=667;e.Z=611;e.bracketleft=333;e.backslash=278;e.bracketright=333;e.asciicircum=584;e.underscore=556;e.quoteleft=278;e.a=556;e.b=611;e.c=556;e.d=611;e.e=556;e.f=333;e.g=611;e.h=611;e.i=278;e.j=278;e.k=556;e.l=278;e.m=889;e.n=611;e.o=611;e.p=611;e.q=611;e.r=389;e.s=556;e.t=333;e.u=611;e.v=556;e.w=778;e.x=556;e.y=556;e.z=500;e.braceleft=389;e.bar=280;e.braceright=389;e.asciitilde=584;e.exclamdown=333;e.cent=556;e.sterling=556;e.fraction=167;e.yen=556;e.florin=556;e.section=556;e.currency=556;e.quotesingle=238;e.quotedblleft=500;e.guillemotleft=556;e.guilsinglleft=333;e.guilsinglright=333;e.fi=611;e.fl=611;e.endash=556;e.dagger=556;e.daggerdbl=556;e.periodcentered=278;e.paragraph=556;e.bullet=350;e.quotesinglbase=278;e.quotedblbase=500;e.quotedblright=500;e.guillemotright=556;e.ellipsis=1e3;e.perthousand=1e3;e.questiondown=611;e.grave=333;e.acute=333;e.circumflex=333;e.tilde=333;e.macron=333;e.breve=333;e.dotaccent=333;e.dieresis=333;e.ring=333;e.cedilla=333;e.hungarumlaut=333;e.ogonek=333;e.caron=333;e.emdash=1e3;e.AE=1e3;e.ordfeminine=370;e.Lslash=611;e.Oslash=778;e.OE=1e3;e.ordmasculine=365;e.ae=889;e.dotlessi=278;e.lslash=278;e.oslash=611;e.oe=944;e.germandbls=611;e.Idieresis=278;e.eacute=556;e.abreve=556;e.uhungarumlaut=611;e.ecaron=556;e.Ydieresis=667;e.divide=584;e.Yacute=667;e.Acircumflex=722;e.aacute=556;e.Ucircumflex=722;e.yacute=556;e.scommaaccent=556;e.ecircumflex=556;e.Uring=722;e.Udieresis=722;e.aogonek=556;e.Uacute=722;e.uogonek=611;e.Edieresis=667;e.Dcroat=722;e.commaaccent=250;e.copyright=737;e.Emacron=667;e.ccaron=556;e.aring=556;e.Ncommaaccent=722;e.lacute=278;e.agrave=556;e.Tcommaaccent=611;e.Cacute=722;e.atilde=556;e.Edotaccent=667;e.scaron=556;e.scedilla=556;e.iacute=278;e.lozenge=494;e.Rcaron=722;e.Gcommaaccent=778;e.ucircumflex=611;e.acircumflex=556;e.Amacron=722;e.rcaron=389;e.ccedilla=556;e.Zdotaccent=611;e.Thorn=667;e.Omacron=778;e.Racute=722;e.Sacute=667;e.dcaron=743;e.Umacron=722;e.uring=611;e.threesuperior=333;e.Ograve=778;e.Agrave=722;e.Abreve=722;e.multiply=584;e.uacute=611;e.Tcaron=611;e.partialdiff=494;e.ydieresis=556;e.Nacute=722;e.icircumflex=278;e.Ecircumflex=667;e.adieresis=556;e.edieresis=556;e.cacute=556;e.nacute=611;e.umacron=611;e.Ncaron=722;e.Iacute=278;e.plusminus=584;e.brokenbar=280;e.registered=737;e.Gbreve=778;e.Idotaccent=278;e.summation=600;e.Egrave=667;e.racute=389;e.omacron=611;e.Zacute=611;e.Zcaron=611;e.greaterequal=549;e.Eth=722;e.Ccedilla=722;e.lcommaaccent=278;e.tcaron=389;e.eogonek=556;e.Uogonek=722;e.Aacute=722;e.Adieresis=722;e.egrave=556;e.zacute=500;e.iogonek=278;e.Oacute=778;e.oacute=611;e.amacron=556;e.sacute=556;e.idieresis=278;e.Ocircumflex=778;e.Ugrave=722;e.Delta=612;e.thorn=611;e.twosuperior=333;e.Odieresis=778;e.mu=611;e.igrave=278;e.ohungarumlaut=611;e.Eogonek=667;e.dcroat=611;e.threequarters=834;e.Scedilla=667;e.lcaron=400;e.Kcommaaccent=722;e.Lacute=611;e.trademark=1e3;e.edotaccent=556;e.Igrave=278;e.Imacron=278;e.Lcaron=611;e.onehalf=834;e.lessequal=549;e.ocircumflex=611;e.ntilde=611;e.Uhungarumlaut=722;e.Eacute=667;e.emacron=556;e.gbreve=611;e.onequarter=834;e.Scaron=667;e.Scommaaccent=667;e.Ohungarumlaut=778;e.degree=400;e.ograve=611;e.Ccaron=722;e.ugrave=611;e.radical=549;e.Dcaron=722;e.rcommaaccent=389;e.Ntilde=722;e.otilde=611;e.Rcommaaccent=722;e.Lcommaaccent=611;e.Atilde=722;e.Aogonek=722;e.Aring=722;e.Otilde=778;e.zdotaccent=500;e.Ecaron=667;e.Iogonek=278;e.kcommaaccent=556;e.minus=584;e.Icircumflex=278;e.ncaron=611;e.tcommaaccent=333;e.logicalnot=584;e.odieresis=611;e.udieresis=611;e.notequal=549;e.gcommaaccent=611;e.eth=611;e.zcaron=500;e.ncommaaccent=611;e.onesuperior=333;e.imacron=278;e.Euro=556}));e["Helvetica-Oblique"]=(0,n.getLookupTableFactory)((function(e){e.space=278;e.exclam=278;e.quotedbl=355;e.numbersign=556;e.dollar=556;e.percent=889;e.ampersand=667;e.quoteright=222;e.parenleft=333;e.parenright=333;e.asterisk=389;e.plus=584;e.comma=278;e.hyphen=333;e.period=278;e.slash=278;e.zero=556;e.one=556;e.two=556;e.three=556;e.four=556;e.five=556;e.six=556;e.seven=556;e.eight=556;e.nine=556;e.colon=278;e.semicolon=278;e.less=584;e.equal=584;e.greater=584;e.question=556;e.at=1015;e.A=667;e.B=667;e.C=722;e.D=722;e.E=667;e.F=611;e.G=778;e.H=722;e.I=278;e.J=500;e.K=667;e.L=556;e.M=833;e.N=722;e.O=778;e.P=667;e.Q=778;e.R=722;e.S=667;e.T=611;e.U=722;e.V=667;e.W=944;e.X=667;e.Y=667;e.Z=611;e.bracketleft=278;e.backslash=278;e.bracketright=278;e.asciicircum=469;e.underscore=556;e.quoteleft=222;e.a=556;e.b=556;e.c=500;e.d=556;e.e=556;e.f=278;e.g=556;e.h=556;e.i=222;e.j=222;e.k=500;e.l=222;e.m=833;e.n=556;e.o=556;e.p=556;e.q=556;e.r=333;e.s=500;e.t=278;e.u=556;e.v=500;e.w=722;e.x=500;e.y=500;e.z=500;e.braceleft=334;e.bar=260;e.braceright=334;e.asciitilde=584;e.exclamdown=333;e.cent=556;e.sterling=556;e.fraction=167;e.yen=556;e.florin=556;e.section=556;e.currency=556;e.quotesingle=191;e.quotedblleft=333;e.guillemotleft=556;e.guilsinglleft=333;e.guilsinglright=333;e.fi=500;e.fl=500;e.endash=556;e.dagger=556;e.daggerdbl=556;e.periodcentered=278;e.paragraph=537;e.bullet=350;e.quotesinglbase=222;e.quotedblbase=333;e.quotedblright=333;e.guillemotright=556;e.ellipsis=1e3;e.perthousand=1e3;e.questiondown=611;e.grave=333;e.acute=333;e.circumflex=333;e.tilde=333;e.macron=333;e.breve=333;e.dotaccent=333;e.dieresis=333;e.ring=333;e.cedilla=333;e.hungarumlaut=333;e.ogonek=333;e.caron=333;e.emdash=1e3;e.AE=1e3;e.ordfeminine=370;e.Lslash=556;e.Oslash=778;e.OE=1e3;e.ordmasculine=365;e.ae=889;e.dotlessi=278;e.lslash=222;e.oslash=611;e.oe=944;e.germandbls=611;e.Idieresis=278;e.eacute=556;e.abreve=556;e.uhungarumlaut=556;e.ecaron=556;e.Ydieresis=667;e.divide=584;e.Yacute=667;e.Acircumflex=667;e.aacute=556;e.Ucircumflex=722;e.yacute=500;e.scommaaccent=500;e.ecircumflex=556;e.Uring=722;e.Udieresis=722;e.aogonek=556;e.Uacute=722;e.uogonek=556;e.Edieresis=667;e.Dcroat=722;e.commaaccent=250;e.copyright=737;e.Emacron=667;e.ccaron=500;e.aring=556;e.Ncommaaccent=722;e.lacute=222;e.agrave=556;e.Tcommaaccent=611;e.Cacute=722;e.atilde=556;e.Edotaccent=667;e.scaron=500;e.scedilla=500;e.iacute=278;e.lozenge=471;e.Rcaron=722;e.Gcommaaccent=778;e.ucircumflex=556;e.acircumflex=556;e.Amacron=667;e.rcaron=333;e.ccedilla=500;e.Zdotaccent=611;e.Thorn=667;e.Omacron=778;e.Racute=722;e.Sacute=667;e.dcaron=643;e.Umacron=722;e.uring=556;e.threesuperior=333;e.Ograve=778;e.Agrave=667;e.Abreve=667;e.multiply=584;e.uacute=556;e.Tcaron=611;e.partialdiff=476;e.ydieresis=500;e.Nacute=722;e.icircumflex=278;e.Ecircumflex=667;e.adieresis=556;e.edieresis=556;e.cacute=500;e.nacute=556;e.umacron=556;e.Ncaron=722;e.Iacute=278;e.plusminus=584;e.brokenbar=260;e.registered=737;e.Gbreve=778;e.Idotaccent=278;e.summation=600;e.Egrave=667;e.racute=333;e.omacron=556;e.Zacute=611;e.Zcaron=611;e.greaterequal=549;e.Eth=722;e.Ccedilla=722;e.lcommaaccent=222;e.tcaron=317;e.eogonek=556;e.Uogonek=722;e.Aacute=667;e.Adieresis=667;e.egrave=556;e.zacute=500;e.iogonek=222;e.Oacute=778;e.oacute=556;e.amacron=556;e.sacute=500;e.idieresis=278;e.Ocircumflex=778;e.Ugrave=722;e.Delta=612;e.thorn=556;e.twosuperior=333;e.Odieresis=778;e.mu=556;e.igrave=278;e.ohungarumlaut=556;e.Eogonek=667;e.dcroat=556;e.threequarters=834;e.Scedilla=667;e.lcaron=299;e.Kcommaaccent=667;e.Lacute=556;e.trademark=1e3;e.edotaccent=556;e.Igrave=278;e.Imacron=278;e.Lcaron=556;e.onehalf=834;e.lessequal=549;e.ocircumflex=556;e.ntilde=556;e.Uhungarumlaut=722;e.Eacute=667;e.emacron=556;e.gbreve=556;e.onequarter=834;e.Scaron=667;e.Scommaaccent=667;e.Ohungarumlaut=778;e.degree=400;e.ograve=556;e.Ccaron=722;e.ugrave=556;e.radical=453;e.Dcaron=722;e.rcommaaccent=333;e.Ntilde=722;e.otilde=556;e.Rcommaaccent=722;e.Lcommaaccent=556;e.Atilde=667;e.Aogonek=667;e.Aring=667;e.Otilde=778;e.zdotaccent=500;e.Ecaron=667;e.Iogonek=278;e.kcommaaccent=500;e.minus=584;e.Icircumflex=278;e.ncaron=556;e.tcommaaccent=278;e.logicalnot=584;e.odieresis=556;e.udieresis=556;e.notequal=549;e.gcommaaccent=556;e.eth=556;e.zcaron=500;e.ncommaaccent=556;e.onesuperior=333;e.imacron=278;e.Euro=556}));e.Symbol=(0,n.getLookupTableFactory)((function(e){e.space=250;e.exclam=333;e.universal=713;e.numbersign=500;e.existential=549;e.percent=833;e.ampersand=778;e.suchthat=439;e.parenleft=333;e.parenright=333;e.asteriskmath=500;e.plus=549;e.comma=250;e.minus=549;e.period=250;e.slash=278;e.zero=500;e.one=500;e.two=500;e.three=500;e.four=500;e.five=500;e.six=500;e.seven=500;e.eight=500;e.nine=500;e.colon=278;e.semicolon=278;e.less=549;e.equal=549;e.greater=549;e.question=444;e.congruent=549;e.Alpha=722;e.Beta=667;e.Chi=722;e.Delta=612;e.Epsilon=611;e.Phi=763;e.Gamma=603;e.Eta=722;e.Iota=333;e.theta1=631;e.Kappa=722;e.Lambda=686;e.Mu=889;e.Nu=722;e.Omicron=722;e.Pi=768;e.Theta=741;e.Rho=556;e.Sigma=592;e.Tau=611;e.Upsilon=690;e.sigma1=439;e.Omega=768;e.Xi=645;e.Psi=795;e.Zeta=611;e.bracketleft=333;e.therefore=863;e.bracketright=333;e.perpendicular=658;e.underscore=500;e.radicalex=500;e.alpha=631;e.beta=549;e.chi=549;e.delta=494;e.epsilon=439;e.phi=521;e.gamma=411;e.eta=603;e.iota=329;e.phi1=603;e.kappa=549;e.lambda=549;e.mu=576;e.nu=521;e.omicron=549;e.pi=549;e.theta=521;e.rho=549;e.sigma=603;e.tau=439;e.upsilon=576;e.omega1=713;e.omega=686;e.xi=493;e.psi=686;e.zeta=494;e.braceleft=480;e.bar=200;e.braceright=480;e.similar=549;e.Euro=750;e.Upsilon1=620;e.minute=247;e.lessequal=549;e.fraction=167;e.infinity=713;e.florin=500;e.club=753;e.diamond=753;e.heart=753;e.spade=753;e.arrowboth=1042;e.arrowleft=987;e.arrowup=603;e.arrowright=987;e.arrowdown=603;e.degree=400;e.plusminus=549;e.second=411;e.greaterequal=549;e.multiply=549;e.proportional=713;e.partialdiff=494;e.bullet=460;e.divide=549;e.notequal=549;e.equivalence=549;e.approxequal=549;e.ellipsis=1e3;e.arrowvertex=603;e.arrowhorizex=1e3;e.carriagereturn=658;e.aleph=823;e.Ifraktur=686;e.Rfraktur=795;e.weierstrass=987;e.circlemultiply=768;e.circleplus=768;e.emptyset=823;e.intersection=768;e.union=768;e.propersuperset=713;e.reflexsuperset=713;e.notsubset=713;e.propersubset=713;e.reflexsubset=713;e.element=713;e.notelement=713;e.angle=768;e.gradient=713;e.registerserif=790;e.copyrightserif=790;e.trademarkserif=890;e.product=823;e.radical=549;e.dotmath=250;e.logicalnot=713;e.logicaland=603;e.logicalor=603;e.arrowdblboth=1042;e.arrowdblleft=987;e.arrowdblup=603;e.arrowdblright=987;e.arrowdbldown=603;e.lozenge=494;e.angleleft=329;e.registersans=790;e.copyrightsans=790;e.trademarksans=786;e.summation=713;e.parenlefttp=384;e.parenleftex=384;e.parenleftbt=384;e.bracketlefttp=384;e.bracketleftex=384;e.bracketleftbt=384;e.bracelefttp=494;e.braceleftmid=494;e.braceleftbt=494;e.braceex=494;e.angleright=329;e.integral=274;e.integraltp=686;e.integralex=686;e.integralbt=686;e.parenrighttp=384;e.parenrightex=384;e.parenrightbt=384;e.bracketrighttp=384;e.bracketrightex=384;e.bracketrightbt=384;e.bracerighttp=494;e.bracerightmid=494;e.bracerightbt=494;e.apple=790}));e["Times-Roman"]=(0,n.getLookupTableFactory)((function(e){e.space=250;e.exclam=333;e.quotedbl=408;e.numbersign=500;e.dollar=500;e.percent=833;e.ampersand=778;e.quoteright=333;e.parenleft=333;e.parenright=333;e.asterisk=500;e.plus=564;e.comma=250;e.hyphen=333;e.period=250;e.slash=278;e.zero=500;e.one=500;e.two=500;e.three=500;e.four=500;e.five=500;e.six=500;e.seven=500;e.eight=500;e.nine=500;e.colon=278;e.semicolon=278;e.less=564;e.equal=564;e.greater=564;e.question=444;e.at=921;e.A=722;e.B=667;e.C=667;e.D=722;e.E=611;e.F=556;e.G=722;e.H=722;e.I=333;e.J=389;e.K=722;e.L=611;e.M=889;e.N=722;e.O=722;e.P=556;e.Q=722;e.R=667;e.S=556;e.T=611;e.U=722;e.V=722;e.W=944;e.X=722;e.Y=722;e.Z=611;e.bracketleft=333;e.backslash=278;e.bracketright=333;e.asciicircum=469;e.underscore=500;e.quoteleft=333;e.a=444;e.b=500;e.c=444;e.d=500;e.e=444;e.f=333;e.g=500;e.h=500;e.i=278;e.j=278;e.k=500;e.l=278;e.m=778;e.n=500;e.o=500;e.p=500;e.q=500;e.r=333;e.s=389;e.t=278;e.u=500;e.v=500;e.w=722;e.x=500;e.y=500;e.z=444;e.braceleft=480;e.bar=200;e.braceright=480;e.asciitilde=541;e.exclamdown=333;e.cent=500;e.sterling=500;e.fraction=167;e.yen=500;e.florin=500;e.section=500;e.currency=500;e.quotesingle=180;e.quotedblleft=444;e.guillemotleft=500;e.guilsinglleft=333;e.guilsinglright=333;e.fi=556;e.fl=556;e.endash=500;e.dagger=500;e.daggerdbl=500;e.periodcentered=250;e.paragraph=453;e.bullet=350;e.quotesinglbase=333;e.quotedblbase=444;e.quotedblright=444;e.guillemotright=500;e.ellipsis=1e3;e.perthousand=1e3;e.questiondown=444;e.grave=333;e.acute=333;e.circumflex=333;e.tilde=333;e.macron=333;e.breve=333;e.dotaccent=333;e.dieresis=333;e.ring=333;e.cedilla=333;e.hungarumlaut=333;e.ogonek=333;e.caron=333;e.emdash=1e3;e.AE=889;e.ordfeminine=276;e.Lslash=611;e.Oslash=722;e.OE=889;e.ordmasculine=310;e.ae=667;e.dotlessi=278;e.lslash=278;e.oslash=500;e.oe=722;e.germandbls=500;e.Idieresis=333;e.eacute=444;e.abreve=444;e.uhungarumlaut=500;e.ecaron=444;e.Ydieresis=722;e.divide=564;e.Yacute=722;e.Acircumflex=722;e.aacute=444;e.Ucircumflex=722;e.yacute=500;e.scommaaccent=389;e.ecircumflex=444;e.Uring=722;e.Udieresis=722;e.aogonek=444;e.Uacute=722;e.uogonek=500;e.Edieresis=611;e.Dcroat=722;e.commaaccent=250;e.copyright=760;e.Emacron=611;e.ccaron=444;e.aring=444;e.Ncommaaccent=722;e.lacute=278;e.agrave=444;e.Tcommaaccent=611;e.Cacute=667;e.atilde=444;e.Edotaccent=611;e.scaron=389;e.scedilla=389;e.iacute=278;e.lozenge=471;e.Rcaron=667;e.Gcommaaccent=722;e.ucircumflex=500;e.acircumflex=444;e.Amacron=722;e.rcaron=333;e.ccedilla=444;e.Zdotaccent=611;e.Thorn=556;e.Omacron=722;e.Racute=667;e.Sacute=556;e.dcaron=588;e.Umacron=722;e.uring=500;e.threesuperior=300;e.Ograve=722;e.Agrave=722;e.Abreve=722;e.multiply=564;e.uacute=500;e.Tcaron=611;e.partialdiff=476;e.ydieresis=500;e.Nacute=722;e.icircumflex=278;e.Ecircumflex=611;e.adieresis=444;e.edieresis=444;e.cacute=444;e.nacute=500;e.umacron=500;e.Ncaron=722;e.Iacute=333;e.plusminus=564;e.brokenbar=200;e.registered=760;e.Gbreve=722;e.Idotaccent=333;e.summation=600;e.Egrave=611;e.racute=333;e.omacron=500;e.Zacute=611;e.Zcaron=611;e.greaterequal=549;e.Eth=722;e.Ccedilla=667;e.lcommaaccent=278;e.tcaron=326;e.eogonek=444;e.Uogonek=722;e.Aacute=722;e.Adieresis=722;e.egrave=444;e.zacute=444;e.iogonek=278;e.Oacute=722;e.oacute=500;e.amacron=444;e.sacute=389;e.idieresis=278;e.Ocircumflex=722;e.Ugrave=722;e.Delta=612;e.thorn=500;e.twosuperior=300;e.Odieresis=722;e.mu=500;e.igrave=278;e.ohungarumlaut=500;e.Eogonek=611;e.dcroat=500;e.threequarters=750;e.Scedilla=556;e.lcaron=344;e.Kcommaaccent=722;e.Lacute=611;e.trademark=980;e.edotaccent=444;e.Igrave=333;e.Imacron=333;e.Lcaron=611;e.onehalf=750;e.lessequal=549;e.ocircumflex=500;e.ntilde=500;e.Uhungarumlaut=722;e.Eacute=611;e.emacron=444;e.gbreve=500;e.onequarter=750;e.Scaron=556;e.Scommaaccent=556;e.Ohungarumlaut=722;e.degree=400;e.ograve=500;e.Ccaron=667;e.ugrave=500;e.radical=453;e.Dcaron=722;e.rcommaaccent=333;e.Ntilde=722;e.otilde=500;e.Rcommaaccent=667;e.Lcommaaccent=611;e.Atilde=722;e.Aogonek=722;e.Aring=722;e.Otilde=722;e.zdotaccent=444;e.Ecaron=611;e.Iogonek=333;e.kcommaaccent=500;e.minus=564;e.Icircumflex=333;e.ncaron=500;e.tcommaaccent=278;e.logicalnot=564;e.odieresis=500;e.udieresis=500;e.notequal=549;e.gcommaaccent=500;e.eth=500;e.zcaron=444;e.ncommaaccent=500;e.onesuperior=300;e.imacron=278;e.Euro=500}));e["Times-Bold"]=(0,n.getLookupTableFactory)((function(e){e.space=250;e.exclam=333;e.quotedbl=555;e.numbersign=500;e.dollar=500;e.percent=1e3;e.ampersand=833;e.quoteright=333;e.parenleft=333;e.parenright=333;e.asterisk=500;e.plus=570;e.comma=250;e.hyphen=333;e.period=250;e.slash=278;e.zero=500;e.one=500;e.two=500;e.three=500;e.four=500;e.five=500;e.six=500;e.seven=500;e.eight=500;e.nine=500;e.colon=333;e.semicolon=333;e.less=570;e.equal=570;e.greater=570;e.question=500;e.at=930;e.A=722;e.B=667;e.C=722;e.D=722;e.E=667;e.F=611;e.G=778;e.H=778;e.I=389;e.J=500;e.K=778;e.L=667;e.M=944;e.N=722;e.O=778;e.P=611;e.Q=778;e.R=722;e.S=556;e.T=667;e.U=722;e.V=722;e.W=1e3;e.X=722;e.Y=722;e.Z=667;e.bracketleft=333;e.backslash=278;e.bracketright=333;e.asciicircum=581;e.underscore=500;e.quoteleft=333;e.a=500;e.b=556;e.c=444;e.d=556;e.e=444;e.f=333;e.g=500;e.h=556;e.i=278;e.j=333;e.k=556;e.l=278;e.m=833;e.n=556;e.o=500;e.p=556;e.q=556;e.r=444;e.s=389;e.t=333;e.u=556;e.v=500;e.w=722;e.x=500;e.y=500;e.z=444;e.braceleft=394;e.bar=220;e.braceright=394;e.asciitilde=520;e.exclamdown=333;e.cent=500;e.sterling=500;e.fraction=167;e.yen=500;e.florin=500;e.section=500;e.currency=500;e.quotesingle=278;e.quotedblleft=500;e.guillemotleft=500;e.guilsinglleft=333;e.guilsinglright=333;e.fi=556;e.fl=556;e.endash=500;e.dagger=500;e.daggerdbl=500;e.periodcentered=250;e.paragraph=540;e.bullet=350;e.quotesinglbase=333;e.quotedblbase=500;e.quotedblright=500;e.guillemotright=500;e.ellipsis=1e3;e.perthousand=1e3;e.questiondown=500;e.grave=333;e.acute=333;e.circumflex=333;e.tilde=333;e.macron=333;e.breve=333;e.dotaccent=333;e.dieresis=333;e.ring=333;e.cedilla=333;e.hungarumlaut=333;e.ogonek=333;e.caron=333;e.emdash=1e3;e.AE=1e3;e.ordfeminine=300;e.Lslash=667;e.Oslash=778;e.OE=1e3;e.ordmasculine=330;e.ae=722;e.dotlessi=278;e.lslash=278;e.oslash=500;e.oe=722;e.germandbls=556;e.Idieresis=389;e.eacute=444;e.abreve=500;e.uhungarumlaut=556;e.ecaron=444;e.Ydieresis=722;e.divide=570;e.Yacute=722;e.Acircumflex=722;e.aacute=500;e.Ucircumflex=722;e.yacute=500;e.scommaaccent=389;e.ecircumflex=444;e.Uring=722;e.Udieresis=722;e.aogonek=500;e.Uacute=722;e.uogonek=556;e.Edieresis=667;e.Dcroat=722;e.commaaccent=250;e.copyright=747;e.Emacron=667;e.ccaron=444;e.aring=500;e.Ncommaaccent=722;e.lacute=278;e.agrave=500;e.Tcommaaccent=667;e.Cacute=722;e.atilde=500;e.Edotaccent=667;e.scaron=389;e.scedilla=389;e.iacute=278;e.lozenge=494;e.Rcaron=722;e.Gcommaaccent=778;e.ucircumflex=556;e.acircumflex=500;e.Amacron=722;e.rcaron=444;e.ccedilla=444;e.Zdotaccent=667;e.Thorn=611;e.Omacron=778;e.Racute=722;e.Sacute=556;e.dcaron=672;e.Umacron=722;e.uring=556;e.threesuperior=300;e.Ograve=778;e.Agrave=722;e.Abreve=722;e.multiply=570;e.uacute=556;e.Tcaron=667;e.partialdiff=494;e.ydieresis=500;e.Nacute=722;e.icircumflex=278;e.Ecircumflex=667;e.adieresis=500;e.edieresis=444;e.cacute=444;e.nacute=556;e.umacron=556;e.Ncaron=722;e.Iacute=389;e.plusminus=570;e.brokenbar=220;e.registered=747;e.Gbreve=778;e.Idotaccent=389;e.summation=600;e.Egrave=667;e.racute=444;e.omacron=500;e.Zacute=667;e.Zcaron=667;e.greaterequal=549;e.Eth=722;e.Ccedilla=722;e.lcommaaccent=278;e.tcaron=416;e.eogonek=444;e.Uogonek=722;e.Aacute=722;e.Adieresis=722;e.egrave=444;e.zacute=444;e.iogonek=278;e.Oacute=778;e.oacute=500;e.amacron=500;e.sacute=389;e.idieresis=278;e.Ocircumflex=778;e.Ugrave=722;e.Delta=612;e.thorn=556;e.twosuperior=300;e.Odieresis=778;e.mu=556;e.igrave=278;e.ohungarumlaut=500;e.Eogonek=667;e.dcroat=556;e.threequarters=750;e.Scedilla=556;e.lcaron=394;e.Kcommaaccent=778;e.Lacute=667;e.trademark=1e3;e.edotaccent=444;e.Igrave=389;e.Imacron=389;e.Lcaron=667;e.onehalf=750;e.lessequal=549;e.ocircumflex=500;e.ntilde=556;e.Uhungarumlaut=722;e.Eacute=667;e.emacron=444;e.gbreve=500;e.onequarter=750;e.Scaron=556;e.Scommaaccent=556;e.Ohungarumlaut=778;e.degree=400;e.ograve=500;e.Ccaron=722;e.ugrave=556;e.radical=549;e.Dcaron=722;e.rcommaaccent=444;e.Ntilde=722;e.otilde=500;e.Rcommaaccent=722;e.Lcommaaccent=667;e.Atilde=722;e.Aogonek=722;e.Aring=722;e.Otilde=778;e.zdotaccent=444;e.Ecaron=667;e.Iogonek=389;e.kcommaaccent=556;e.minus=570;e.Icircumflex=389;e.ncaron=556;e.tcommaaccent=333;e.logicalnot=570;e.odieresis=500;e.udieresis=556;e.notequal=549;e.gcommaaccent=500;e.eth=500;e.zcaron=444;e.ncommaaccent=556;e.onesuperior=300;e.imacron=278;e.Euro=500}));e["Times-BoldItalic"]=(0,n.getLookupTableFactory)((function(e){e.space=250;e.exclam=389;e.quotedbl=555;e.numbersign=500;e.dollar=500;e.percent=833;e.ampersand=778;e.quoteright=333;e.parenleft=333;e.parenright=333;e.asterisk=500;e.plus=570;e.comma=250;e.hyphen=333;e.period=250;e.slash=278;e.zero=500;e.one=500;e.two=500;e.three=500;e.four=500;e.five=500;e.six=500;e.seven=500;e.eight=500;e.nine=500;e.colon=333;e.semicolon=333;e.less=570;e.equal=570;e.greater=570;e.question=500;e.at=832;e.A=667;e.B=667;e.C=667;e.D=722;e.E=667;e.F=667;e.G=722;e.H=778;e.I=389;e.J=500;e.K=667;e.L=611;e.M=889;e.N=722;e.O=722;e.P=611;e.Q=722;e.R=667;e.S=556;e.T=611;e.U=722;e.V=667;e.W=889;e.X=667;e.Y=611;e.Z=611;e.bracketleft=333;e.backslash=278;e.bracketright=333;e.asciicircum=570;e.underscore=500;e.quoteleft=333;e.a=500;e.b=500;e.c=444;e.d=500;e.e=444;e.f=333;e.g=500;e.h=556;e.i=278;e.j=278;e.k=500;e.l=278;e.m=778;e.n=556;e.o=500;e.p=500;e.q=500;e.r=389;e.s=389;e.t=278;e.u=556;e.v=444;e.w=667;e.x=500;e.y=444;e.z=389;e.braceleft=348;e.bar=220;e.braceright=348;e.asciitilde=570;e.exclamdown=389;e.cent=500;e.sterling=500;e.fraction=167;e.yen=500;e.florin=500;e.section=500;e.currency=500;e.quotesingle=278;e.quotedblleft=500;e.guillemotleft=500;e.guilsinglleft=333;e.guilsinglright=333;e.fi=556;e.fl=556;e.endash=500;e.dagger=500;e.daggerdbl=500;e.periodcentered=250;e.paragraph=500;e.bullet=350;e.quotesinglbase=333;e.quotedblbase=500;e.quotedblright=500;e.guillemotright=500;e.ellipsis=1e3;e.perthousand=1e3;e.questiondown=500;e.grave=333;e.acute=333;e.circumflex=333;e.tilde=333;e.macron=333;e.breve=333;e.dotaccent=333;e.dieresis=333;e.ring=333;e.cedilla=333;e.hungarumlaut=333;e.ogonek=333;e.caron=333;e.emdash=1e3;e.AE=944;e.ordfeminine=266;e.Lslash=611;e.Oslash=722;e.OE=944;e.ordmasculine=300;e.ae=722;e.dotlessi=278;e.lslash=278;e.oslash=500;e.oe=722;e.germandbls=500;e.Idieresis=389;e.eacute=444;e.abreve=500;e.uhungarumlaut=556;e.ecaron=444;e.Ydieresis=611;e.divide=570;e.Yacute=611;e.Acircumflex=667;e.aacute=500;e.Ucircumflex=722;e.yacute=444;e.scommaaccent=389;e.ecircumflex=444;e.Uring=722;e.Udieresis=722;e.aogonek=500;e.Uacute=722;e.uogonek=556;e.Edieresis=667;e.Dcroat=722;e.commaaccent=250;e.copyright=747;e.Emacron=667;e.ccaron=444;e.aring=500;e.Ncommaaccent=722;e.lacute=278;e.agrave=500;e.Tcommaaccent=611;e.Cacute=667;e.atilde=500;e.Edotaccent=667;e.scaron=389;e.scedilla=389;e.iacute=278;e.lozenge=494;e.Rcaron=667;e.Gcommaaccent=722;e.ucircumflex=556;e.acircumflex=500;e.Amacron=667;e.rcaron=389;e.ccedilla=444;e.Zdotaccent=611;e.Thorn=611;e.Omacron=722;e.Racute=667;e.Sacute=556;e.dcaron=608;e.Umacron=722;e.uring=556;e.threesuperior=300;e.Ograve=722;e.Agrave=667;e.Abreve=667;e.multiply=570;e.uacute=556;e.Tcaron=611;e.partialdiff=494;e.ydieresis=444;e.Nacute=722;e.icircumflex=278;e.Ecircumflex=667;e.adieresis=500;e.edieresis=444;e.cacute=444;e.nacute=556;e.umacron=556;e.Ncaron=722;e.Iacute=389;e.plusminus=570;e.brokenbar=220;e.registered=747;e.Gbreve=722;e.Idotaccent=389;e.summation=600;e.Egrave=667;e.racute=389;e.omacron=500;e.Zacute=611;e.Zcaron=611;e.greaterequal=549;e.Eth=722;e.Ccedilla=667;e.lcommaaccent=278;e.tcaron=366;e.eogonek=444;e.Uogonek=722;e.Aacute=667;e.Adieresis=667;e.egrave=444;e.zacute=389;e.iogonek=278;e.Oacute=722;e.oacute=500;e.amacron=500;e.sacute=389;e.idieresis=278;e.Ocircumflex=722;e.Ugrave=722;e.Delta=612;e.thorn=500;e.twosuperior=300;e.Odieresis=722;e.mu=576;e.igrave=278;e.ohungarumlaut=500;e.Eogonek=667;e.dcroat=500;e.threequarters=750;e.Scedilla=556;e.lcaron=382;e.Kcommaaccent=667;e.Lacute=611;e.trademark=1e3;e.edotaccent=444;e.Igrave=389;e.Imacron=389;e.Lcaron=611;e.onehalf=750;e.lessequal=549;e.ocircumflex=500;e.ntilde=556;e.Uhungarumlaut=722;e.Eacute=667;e.emacron=444;e.gbreve=500;e.onequarter=750;e.Scaron=556;e.Scommaaccent=556;e.Ohungarumlaut=722;e.degree=400;e.ograve=500;e.Ccaron=667;e.ugrave=556;e.radical=549;e.Dcaron=722;e.rcommaaccent=389;e.Ntilde=722;e.otilde=500;e.Rcommaaccent=667;e.Lcommaaccent=611;e.Atilde=667;e.Aogonek=667;e.Aring=667;e.Otilde=722;e.zdotaccent=389;e.Ecaron=667;e.Iogonek=389;e.kcommaaccent=500;e.minus=606;e.Icircumflex=389;e.ncaron=556;e.tcommaaccent=278;e.logicalnot=606;e.odieresis=500;e.udieresis=556;e.notequal=549;e.gcommaaccent=500;e.eth=500;e.zcaron=389;e.ncommaaccent=556;e.onesuperior=300;e.imacron=278;e.Euro=500}));e["Times-Italic"]=(0,n.getLookupTableFactory)((function(e){e.space=250;e.exclam=333;e.quotedbl=420;e.numbersign=500;e.dollar=500;e.percent=833;e.ampersand=778;e.quoteright=333;e.parenleft=333;e.parenright=333;e.asterisk=500;e.plus=675;e.comma=250;e.hyphen=333;e.period=250;e.slash=278;e.zero=500;e.one=500;e.two=500;e.three=500;e.four=500;e.five=500;e.six=500;e.seven=500;e.eight=500;e.nine=500;e.colon=333;e.semicolon=333;e.less=675;e.equal=675;e.greater=675;e.question=500;e.at=920;e.A=611;e.B=611;e.C=667;e.D=722;e.E=611;e.F=611;e.G=722;e.H=722;e.I=333;e.J=444;e.K=667;e.L=556;e.M=833;e.N=667;e.O=722;e.P=611;e.Q=722;e.R=611;e.S=500;e.T=556;e.U=722;e.V=611;e.W=833;e.X=611;e.Y=556;e.Z=556;e.bracketleft=389;e.backslash=278;e.bracketright=389;e.asciicircum=422;e.underscore=500;e.quoteleft=333;e.a=500;e.b=500;e.c=444;e.d=500;e.e=444;e.f=278;e.g=500;e.h=500;e.i=278;e.j=278;e.k=444;e.l=278;e.m=722;e.n=500;e.o=500;e.p=500;e.q=500;e.r=389;e.s=389;e.t=278;e.u=500;e.v=444;e.w=667;e.x=444;e.y=444;e.z=389;e.braceleft=400;e.bar=275;e.braceright=400;e.asciitilde=541;e.exclamdown=389;e.cent=500;e.sterling=500;e.fraction=167;e.yen=500;e.florin=500;e.section=500;e.currency=500;e.quotesingle=214;e.quotedblleft=556;e.guillemotleft=500;e.guilsinglleft=333;e.guilsinglright=333;e.fi=500;e.fl=500;e.endash=500;e.dagger=500;e.daggerdbl=500;e.periodcentered=250;e.paragraph=523;e.bullet=350;e.quotesinglbase=333;e.quotedblbase=556;e.quotedblright=556;e.guillemotright=500;e.ellipsis=889;e.perthousand=1e3;e.questiondown=500;e.grave=333;e.acute=333;e.circumflex=333;e.tilde=333;e.macron=333;e.breve=333;e.dotaccent=333;e.dieresis=333;e.ring=333;e.cedilla=333;e.hungarumlaut=333;e.ogonek=333;e.caron=333;e.emdash=889;e.AE=889;e.ordfeminine=276;e.Lslash=556;e.Oslash=722;e.OE=944;e.ordmasculine=310;e.ae=667;e.dotlessi=278;e.lslash=278;e.oslash=500;e.oe=667;e.germandbls=500;e.Idieresis=333;e.eacute=444;e.abreve=500;e.uhungarumlaut=500;e.ecaron=444;e.Ydieresis=556;e.divide=675;e.Yacute=556;e.Acircumflex=611;e.aacute=500;e.Ucircumflex=722;e.yacute=444;e.scommaaccent=389;e.ecircumflex=444;e.Uring=722;e.Udieresis=722;e.aogonek=500;e.Uacute=722;e.uogonek=500;e.Edieresis=611;e.Dcroat=722;e.commaaccent=250;e.copyright=760;e.Emacron=611;e.ccaron=444;e.aring=500;e.Ncommaaccent=667;e.lacute=278;e.agrave=500;e.Tcommaaccent=556;e.Cacute=667;e.atilde=500;e.Edotaccent=611;e.scaron=389;e.scedilla=389;e.iacute=278;e.lozenge=471;e.Rcaron=611;e.Gcommaaccent=722;e.ucircumflex=500;e.acircumflex=500;e.Amacron=611;e.rcaron=389;e.ccedilla=444;e.Zdotaccent=556;e.Thorn=611;e.Omacron=722;e.Racute=611;e.Sacute=500;e.dcaron=544;e.Umacron=722;e.uring=500;e.threesuperior=300;e.Ograve=722;e.Agrave=611;e.Abreve=611;e.multiply=675;e.uacute=500;e.Tcaron=556;e.partialdiff=476;e.ydieresis=444;e.Nacute=667;e.icircumflex=278;e.Ecircumflex=611;e.adieresis=500;e.edieresis=444;e.cacute=444;e.nacute=500;e.umacron=500;e.Ncaron=667;e.Iacute=333;e.plusminus=675;e.brokenbar=275;e.registered=760;e.Gbreve=722;e.Idotaccent=333;e.summation=600;e.Egrave=611;e.racute=389;e.omacron=500;e.Zacute=556;e.Zcaron=556;e.greaterequal=549;e.Eth=722;e.Ccedilla=667;e.lcommaaccent=278;e.tcaron=300;e.eogonek=444;e.Uogonek=722;e.Aacute=611;e.Adieresis=611;e.egrave=444;e.zacute=389;e.iogonek=278;e.Oacute=722;e.oacute=500;e.amacron=500;e.sacute=389;e.idieresis=278;e.Ocircumflex=722;e.Ugrave=722;e.Delta=612;e.thorn=500;e.twosuperior=300;e.Odieresis=722;e.mu=500;e.igrave=278;e.ohungarumlaut=500;e.Eogonek=611;e.dcroat=500;e.threequarters=750;e.Scedilla=500;e.lcaron=300;e.Kcommaaccent=667;e.Lacute=556;e.trademark=980;e.edotaccent=444;e.Igrave=333;e.Imacron=333;e.Lcaron=611;e.onehalf=750;e.lessequal=549;e.ocircumflex=500;e.ntilde=500;e.Uhungarumlaut=722;e.Eacute=611;e.emacron=444;e.gbreve=500;e.onequarter=750;e.Scaron=500;e.Scommaaccent=500;e.Ohungarumlaut=722;e.degree=400;e.ograve=500;e.Ccaron=667;e.ugrave=500;e.radical=453;e.Dcaron=722;e.rcommaaccent=389;e.Ntilde=667;e.otilde=500;e.Rcommaaccent=611;e.Lcommaaccent=556;e.Atilde=611;e.Aogonek=611;e.Aring=611;e.Otilde=722;e.zdotaccent=389;e.Ecaron=611;e.Iogonek=333;e.kcommaaccent=444;e.minus=675;e.Icircumflex=333;e.ncaron=500;e.tcommaaccent=278;e.logicalnot=675;e.odieresis=500;e.udieresis=500;e.notequal=549;e.gcommaaccent=500;e.eth=500;e.zcaron=389;e.ncommaaccent=500;e.onesuperior=300;e.imacron=278;e.Euro=500}));e.ZapfDingbats=(0,n.getLookupTableFactory)((function(e){e.space=278;e.a1=974;e.a2=961;e.a202=974;e.a3=980;e.a4=719;e.a5=789;e.a119=790;e.a118=791;e.a117=690;e.a11=960;e.a12=939;e.a13=549;e.a14=855;e.a15=911;e.a16=933;e.a105=911;e.a17=945;e.a18=974;e.a19=755;e.a20=846;e.a21=762;e.a22=761;e.a23=571;e.a24=677;e.a25=763;e.a26=760;e.a27=759;e.a28=754;e.a6=494;e.a7=552;e.a8=537;e.a9=577;e.a10=692;e.a29=786;e.a30=788;e.a31=788;e.a32=790;e.a33=793;e.a34=794;e.a35=816;e.a36=823;e.a37=789;e.a38=841;e.a39=823;e.a40=833;e.a41=816;e.a42=831;e.a43=923;e.a44=744;e.a45=723;e.a46=749;e.a47=790;e.a48=792;e.a49=695;e.a50=776;e.a51=768;e.a52=792;e.a53=759;e.a54=707;e.a55=708;e.a56=682;e.a57=701;e.a58=826;e.a59=815;e.a60=789;e.a61=789;e.a62=707;e.a63=687;e.a64=696;e.a65=689;e.a66=786;e.a67=787;e.a68=713;e.a69=791;e.a70=785;e.a71=791;e.a72=873;e.a73=761;e.a74=762;e.a203=762;e.a75=759;e.a204=759;e.a76=892;e.a77=892;e.a78=788;e.a79=784;e.a81=438;e.a82=138;e.a83=277;e.a84=415;e.a97=392;e.a98=392;e.a99=668;e.a100=668;e.a89=390;e.a90=390;e.a93=317;e.a94=317;e.a91=276;e.a92=276;e.a205=509;e.a85=509;e.a206=410;e.a86=410;e.a87=234;e.a88=234;e.a95=334;e.a96=334;e.a101=732;e.a102=544;e.a103=544;e.a104=910;e.a106=667;e.a107=760;e.a108=760;e.a112=776;e.a111=595;e.a110=694;e.a109=626;e.a120=788;e.a121=788;e.a122=788;e.a123=788;e.a124=788;e.a125=788;e.a126=788;e.a127=788;e.a128=788;e.a129=788;e.a130=788;e.a131=788;e.a132=788;e.a133=788;e.a134=788;e.a135=788;e.a136=788;e.a137=788;e.a138=788;e.a139=788;e.a140=788;e.a141=788;e.a142=788;e.a143=788;e.a144=788;e.a145=788;e.a146=788;e.a147=788;e.a148=788;e.a149=788;e.a150=788;e.a151=788;e.a152=788;e.a153=788;e.a154=788;e.a155=788;e.a156=788;e.a157=788;e.a158=788;e.a159=788;e.a160=894;e.a161=838;e.a163=1016;e.a164=458;e.a196=748;e.a165=924;e.a192=748;e.a166=918;e.a167=927;e.a168=928;e.a169=928;e.a170=834;e.a171=873;e.a172=828;e.a173=924;e.a162=924;e.a174=917;e.a175=930;e.a176=931;e.a177=463;e.a178=883;e.a179=836;e.a193=836;e.a180=867;e.a199=867;e.a181=696;e.a200=696;e.a182=874;e.a201=874;e.a183=760;e.a184=946;e.a197=771;e.a185=865;e.a194=771;e.a198=888;e.a186=967;e.a195=888;e.a187=831;e.a188=873;e.a189=927;e.a190=970;e.a191=918}))}));t.getMetrics=a;const i=(0,n.getLookupTableFactory)((function(e){e.Courier={ascent:629,descent:-157,capHeight:562,xHeight:-426};e["Courier-Bold"]={ascent:629,descent:-157,capHeight:562,xHeight:439};e["Courier-Oblique"]={ascent:629,descent:-157,capHeight:562,xHeight:426};e["Courier-BoldOblique"]={ascent:629,descent:-157,capHeight:562,xHeight:426};e.Helvetica={ascent:718,descent:-207,capHeight:718,xHeight:523};e["Helvetica-Bold"]={ascent:718,descent:-207,capHeight:718,xHeight:532};e["Helvetica-Oblique"]={ascent:718,descent:-207,capHeight:718,xHeight:523};e["Helvetica-BoldOblique"]={ascent:718,descent:-207,capHeight:718,xHeight:532};e["Times-Roman"]={ascent:683,descent:-217,capHeight:662,xHeight:450};e["Times-Bold"]={ascent:683,descent:-217,capHeight:676,xHeight:461};e["Times-Italic"]={ascent:683,descent:-217,capHeight:653,xHeight:441};e["Times-BoldItalic"]={ascent:683,descent:-217,capHeight:669,xHeight:462};e.Symbol={ascent:Math.NaN,descent:Math.NaN,capHeight:Math.NaN,xHeight:Math.NaN};e.ZapfDingbats={ascent:Math.NaN,descent:Math.NaN,capHeight:Math.NaN,xHeight:Math.NaN}}));t.getFontBasicMetrics=i},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.GlyfTable=void 0;r(155);r(112);r(125);r(146);r(148);r(149);r(227);t.GlyfTable=class GlyfTable{constructor(e){let{glyfTable:t,isGlyphLocationsLong:r,locaTable:n,numGlyphs:a}=e;this.glyphs=[];const i=new DataView(n.buffer,n.byteOffset,n.byteLength),s=new DataView(t.buffer,t.byteOffset,t.byteLength),o=r?4:2;let c=r?i.getUint32(0):2*i.getUint16(0),l=0;for(let e=0;e<a;e++){l+=o;const e=r?i.getUint32(l):2*i.getUint16(l);if(e===c){this.glyphs.push(new Glyph({}));continue}const t=Glyph.parse(c,s);this.glyphs.push(t);c=e}}getSize(){return this.glyphs.reduce(((e,t)=>e+(t.getSize()+3&-4)),0)}write(){const e=this.getSize(),t=new DataView(new ArrayBuffer(e)),r=e>131070,n=r?4:2,a=new DataView(new ArrayBuffer((this.glyphs.length+1)*n));r?a.setUint32(0,0):a.setUint16(0,0);let i=0,s=0;for(const e of this.glyphs){i+=e.write(i,t);i=i+3&-4;s+=n;r?a.setUint32(s,i):a.setUint16(s,i>>1)}return{isLocationLong:r,loca:new Uint8Array(a.buffer),glyf:new Uint8Array(t.buffer)}}scale(e){for(let t=0,r=this.glyphs.length;t<r;t++)this.glyphs[t].scale(e[t])}};class Glyph{constructor(e){let{header:t=null,simple:r=null,composites:n=null}=e;this.header=t;this.simple=r;this.composites=n}static parse(e,t){const[r,n]=GlyphHeader.parse(e,t);e+=r;if(n.numberOfContours<0){const r=[];for(;;){const[n,a]=CompositeGlyph.parse(e,t);e+=n;r.push(a);if(!(32&a.flags))break}return new Glyph({header:n,composites:r})}const a=SimpleGlyph.parse(e,t,n.numberOfContours);return new Glyph({header:n,simple:a})}getSize(){if(!this.header)return 0;const e=this.simple?this.simple.getSize():this.composites.reduce(((e,t)=>e+t.getSize()),0);return this.header.getSize()+e}write(e,t){if(!this.header)return 0;const r=e;e+=this.header.write(e,t);if(this.simple)e+=this.simple.write(e,t);else for(const r of this.composites)e+=r.write(e,t);return e-r}scale(e){if(!this.header)return;const t=(this.header.xMin+this.header.xMax)/2;this.header.scale(t,e);if(this.simple)this.simple.scale(t,e);else for(const r of this.composites)r.scale(t,e)}}class GlyphHeader{constructor(e){let{numberOfContours:t,xMin:r,yMin:n,xMax:a,yMax:i}=e;this.numberOfContours=t;this.xMin=r;this.yMin=n;this.xMax=a;this.yMax=i}static parse(e,t){return[10,new GlyphHeader({numberOfContours:t.getInt16(e),xMin:t.getInt16(e+2),yMin:t.getInt16(e+4),xMax:t.getInt16(e+6),yMax:t.getInt16(e+8)})]}getSize(){return 10}write(e,t){t.setInt16(e,this.numberOfContours);t.setInt16(e+2,this.xMin);t.setInt16(e+4,this.yMin);t.setInt16(e+6,this.xMax);t.setInt16(e+8,this.yMax);return 10}scale(e,t){this.xMin=Math.round(e+(this.xMin-e)*t);this.xMax=Math.round(e+(this.xMax-e)*t)}}class Contour{constructor(e){let{flags:t,xCoordinates:r,yCoordinates:n}=e;this.xCoordinates=r;this.yCoordinates=n;this.flags=t}}class SimpleGlyph{constructor(e){let{contours:t,instructions:r}=e;this.contours=t;this.instructions=r}static parse(e,t,r){const n=[];for(let a=0;a<r;a++){const r=t.getUint16(e);e+=2;n.push(r)}const a=n[r-1]+1,i=t.getUint16(e);e+=2;const s=new Uint8Array(t).slice(e,e+i);e+=i;const o=[];for(let r=0;r<a;e++,r++){let n=t.getUint8(e);o.push(n);if(8&n){const a=t.getUint8(++e);n^=8;for(let e=0;e<a;e++)o.push(n);r+=a}}const c=[];let l=[],h=[],u=[];const d=[];let f=0,g=0;for(let r=0;r<a;r++){const a=o[r];if(2&a){const r=t.getUint8(e++);g+=16&a?r:-r;l.push(g)}else if(16&a)l.push(g);else{g+=t.getInt16(e);e+=2;l.push(g)}if(n[f]===r){f++;c.push(l);l=[]}}g=0;f=0;for(let r=0;r<a;r++){const a=o[r];if(4&a){const r=t.getUint8(e++);g+=32&a?r:-r;h.push(g)}else if(32&a)h.push(g);else{g+=t.getInt16(e);e+=2;h.push(g)}u.push(1&a|64&a);if(n[f]===r){l=c[f];f++;d.push(new Contour({flags:u,xCoordinates:l,yCoordinates:h}));h=[];u=[]}}return new SimpleGlyph({contours:d,instructions:s})}getSize(){let e=2*this.contours.length+2+this.instructions.length,t=0,r=0;for(const n of this.contours){e+=n.flags.length;for(let a=0,i=n.xCoordinates.length;a<i;a++){const i=n.xCoordinates[a],s=n.yCoordinates[a];let o=Math.abs(i-t);o>255?e+=2:o>0&&(e+=1);t=i;o=Math.abs(s-r);o>255?e+=2:o>0&&(e+=1);r=s}}return e}write(e,t){const r=e,n=[],a=[],i=[];let s=0,o=0;for(const r of this.contours){for(let e=0,t=r.xCoordinates.length;e<t;e++){let t=r.flags[e];const c=r.xCoordinates[e];let l=c-s;if(0===l){t|=16;n.push(0)}else{const e=Math.abs(l);if(e<=255){t|=l>=0?18:2;n.push(e)}else n.push(l)}s=c;const h=r.yCoordinates[e];l=h-o;if(0===l){t|=32;a.push(0)}else{const e=Math.abs(l);if(e<=255){t|=l>=0?36:4;a.push(e)}else a.push(l)}o=h;i.push(t)}t.setUint16(e,n.length-1);e+=2}t.setUint16(e,this.instructions.length);e+=2;if(this.instructions.length){new Uint8Array(t.buffer,0,t.buffer.byteLength).set(this.instructions,e);e+=this.instructions.length}for(const r of i)t.setUint8(e++,r);for(let r=0,a=n.length;r<a;r++){const a=n[r],s=i[r];if(2&s)t.setUint8(e++,a);else if(!(16&s)){t.setInt16(e,a);e+=2}}for(let r=0,n=a.length;r<n;r++){const n=a[r],s=i[r];if(4&s)t.setUint8(e++,n);else if(!(32&s)){t.setInt16(e,n);e+=2}}return e-r}scale(e,t){for(const r of this.contours)if(0!==r.xCoordinates.length)for(let n=0,a=r.xCoordinates.length;n<a;n++)r.xCoordinates[n]=Math.round(e+(r.xCoordinates[n]-e)*t)}}class CompositeGlyph{constructor(e){let{flags:t,glyphIndex:r,argument1:n,argument2:a,transf:i,instructions:s}=e;this.flags=t;this.glyphIndex=r;this.argument1=n;this.argument2=a;this.transf=i;this.instructions=s}static parse(e,t){const r=e,n=[];let a=t.getUint16(e);const i=t.getUint16(e+2);e+=4;let s,o;if(1&a){if(2&a){s=t.getInt16(e);o=t.getInt16(e+2)}else{s=t.getUint16(e);o=t.getUint16(e+2)}e+=4;a^=1}else{if(2&a){s=t.getInt8(e);o=t.getInt8(e+1)}else{s=t.getUint8(e);o=t.getUint8(e+1)}e+=2}if(8&a){n.push(t.getUint16(e));e+=2}else if(64&a){n.push(t.getUint16(e),t.getUint16(e+2));e+=4}else if(128&a){n.push(t.getUint16(e),t.getUint16(e+2),t.getUint16(e+4),t.getUint16(e+6));e+=8}let c=null;if(256&a){const r=t.getUint16(e);e+=2;c=new Uint8Array(t).slice(e,e+r);e+=r}return[e-r,new CompositeGlyph({flags:a,glyphIndex:i,argument1:s,argument2:o,transf:n,instructions:c})]}getSize(){let e=4+2*this.transf.length;256&this.flags&&(e+=2+this.instructions.length);e+=2;2&this.flags?this.argument1>=-128&&this.argument1<=127&&this.argument2>=-128&&this.argument2<=127||(e+=2):this.argument1>=0&&this.argument1<=255&&this.argument2>=0&&this.argument2<=255||(e+=2);return e}write(e,t){const r=e;2&this.flags?this.argument1>=-128&&this.argument1<=127&&this.argument2>=-128&&this.argument2<=127||(this.flags|=1):this.argument1>=0&&this.argument1<=255&&this.argument2>=0&&this.argument2<=255||(this.flags|=1);t.setUint16(e,this.flags);t.setUint16(e+2,this.glyphIndex);e+=4;if(1&this.flags){if(2&this.flags){t.setInt16(e,this.argument1);t.setInt16(e+2,this.argument2)}else{t.setUint16(e,this.argument1);t.setUint16(e+2,this.argument2)}e+=4}else{t.setUint8(e,this.argument1);t.setUint8(e+1,this.argument2);e+=2}if(256&this.flags){t.setUint16(e,this.instructions.length);e+=2;if(this.instructions.length){new Uint8Array(t.buffer,0,t.buffer.byteLength).set(this.instructions,e);e+=this.instructions.length}}return e-r}scale(e,t){}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.OpenTypeFileBuilder=void 0;r(125);r(146);r(148);r(149);var n=r(213),a=r(158);function writeInt16(e,t,r){e[t]=r>>8&255;e[t+1]=255&r}function writeInt32(e,t,r){e[t]=r>>24&255;e[t+1]=r>>16&255;e[t+2]=r>>8&255;e[t+3]=255&r}function writeData(e,t,r){if(r instanceof Uint8Array)e.set(r,t);else if("string"==typeof r)for(let n=0,a=r.length;n<a;n++)e[t++]=255&r.charCodeAt(n);else for(let n=0,a=r.length;n<a;n++)e[t++]=255&r[n]}class OpenTypeFileBuilder{constructor(e){this.sfnt=e;this.tables=Object.create(null)}static getSearchParams(e,t){let r=1,n=0;for(;(r^e)>r;){r<<=1;n++}const a=r*t;return{range:a,entry:n,rangeShift:t*e-a}}toArray(){let e=this.sfnt;const t=this.tables,r=Object.keys(t);r.sort();const i=r.length;let s,o,c,l,h,u=12+16*i;const d=[u];for(s=0;s<i;s++){l=t[r[s]];u+=(l.length+3&-4)>>>0;d.push(u)}const f=new Uint8Array(u);for(s=0;s<i;s++){l=t[r[s]];writeData(f,d[s],l)}"true"===e&&(e=(0,a.string32)(65536));f[0]=255&e.charCodeAt(0);f[1]=255&e.charCodeAt(1);f[2]=255&e.charCodeAt(2);f[3]=255&e.charCodeAt(3);writeInt16(f,4,i);const g=OpenTypeFileBuilder.getSearchParams(i,16);writeInt16(f,6,g.range);writeInt16(f,8,g.entry);writeInt16(f,10,g.rangeShift);u=12;for(s=0;s<i;s++){h=r[s];f[u]=255&h.charCodeAt(0);f[u+1]=255&h.charCodeAt(1);f[u+2]=255&h.charCodeAt(2);f[u+3]=255&h.charCodeAt(3);let e=0;for(o=d[s],c=d[s+1];o<c;o+=4){e=e+(0,n.readUint32)(f,o)>>>0}writeInt32(f,u+4,e);writeInt32(f,u+8,d[s]);writeInt32(f,u+12,t[h].length);u+=16}return f}addTable(e,t){if(e in this.tables)throw new Error("Table "+e+" already exists");this.tables[e]=t}}t.OpenTypeFileBuilder=OpenTypeFileBuilder},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.Type1Font=void 0;var n=r(261),a=r(226),i=r(213),s=r(218),o=r(271),c=r(158);function findBlock(e,t,r){const n=e.length,a=t.length,s=n-a;let o=r,c=!1;for(;o<s;){let r=0;for(;r<a&&e[o+r]===t[r];)r++;if(r>=a){o+=r;for(;o<n&&(0,i.isWhiteSpace)(e[o]);)o++;c=!0;break}o++}return{found:c,length:o}}t.Type1Font=class Type1Font{constructor(e,t,r){let n=r.length1,i=r.length2,l=t.peekBytes(6);const h=128===l[0]&&1===l[1];if(h){t.skip(6);n=l[5]<<24|l[4]<<16|l[3]<<8|l[2]}const u=function getHeaderBlock(e,t){const r=[101,101,120,101,99],n=e.pos;let a,i,o,l;try{a=e.getBytes(t);i=a.length}catch(e){}if(i===t){o=findBlock(a,r,t-2*r.length);if(o.found&&o.length===t)return{stream:new s.Stream(a),length:t}}(0,c.warn)('Invalid "Length1" property in Type1 font -- trying to recover.');e.pos=n;for(;;){o=findBlock(e.peekBytes(2048),r,0);if(0===o.length)break;e.pos+=o.length;if(o.found){l=e.pos-n;break}}e.pos=n;if(l)return{stream:new s.Stream(e.getBytes(l)),length:l};(0,c.warn)('Unable to recover "Length1" property in Type1 font -- using as is.');return{stream:new s.Stream(e.getBytes(t)),length:t}}(t,n);new o.Type1Parser(u.stream,!1,a.SEAC_ANALYSIS_ENABLED).extractFontHeader(r);if(h){l=t.getBytes(6);i=l[5]<<24|l[4]<<16|l[3]<<8|l[2]}const d=function getEexecBlock(e,t){const r=e.getBytes();return{stream:new s.Stream(r),length:r.length}}(t),f=new o.Type1Parser(d.stream,!0,a.SEAC_ANALYSIS_ENABLED).extractFontProgram(r);for(const e in f.properties)r[e]=f.properties[e];const g=f.charstrings,p=this.getType2Charstrings(g),m=this.getType2Subrs(f.subrs);this.charstrings=g;this.data=this.wrap(e,p,this.charstrings,m,r);this.seacs=this.getSeacs(f.charstrings)}get numGlyphs(){return this.charstrings.length+1}getCharset(){const e=[".notdef"],t=this.charstrings;for(let r=0;r<t.length;r++)e.push(t[r].glyphName);return e}getGlyphMapping(e){const t=this.charstrings;if(e.composite){const r=Object.create(null);for(let n=0,a=t.length;n<a;n++){r[e.cMap.charCodeOf(n)]=n+1}return r}const r=[".notdef"];let n,i;for(i=0;i<t.length;i++)r.push(t[i].glyphName);const s=e.builtInEncoding;if(s){n=Object.create(null);for(const e in s){i=r.indexOf(s[e]);i>=0&&(n[e]=i)}}return(0,a.type1FontGlyphMapping)(e,n,r)}hasGlyphId(e){if(e<0||e>=this.numGlyphs)return!1;if(0===e)return!0;return this.charstrings[e-1].charstring.length>0}getSeacs(e){const t=[];for(let r=0,n=e.length;r<n;r++){const n=e[r];n.seac&&(t[r+1]=n.seac)}return t}getType2Charstrings(e){const t=[];for(let r=0,n=e.length;r<n;r++)t.push(e[r].charstring);return t}getType2Subrs(e){let t=0;const r=e.length;t=r<1133?107:r<33769?1131:32768;const n=[];let a;for(a=0;a<t;a++)n.push([11]);for(a=0;a<r;a++)n.push(e[a]);return n}wrap(e,t,r,a,i){const s=new n.CFF;s.header=new n.CFFHeader(1,0,4,4);s.names=[e];const o=new n.CFFTopDict;o.setByName("version",391);o.setByName("Notice",392);o.setByName("FullName",393);o.setByName("FamilyName",394);o.setByName("Weight",395);o.setByName("Encoding",null);o.setByName("FontMatrix",i.fontMatrix);o.setByName("FontBBox",i.bbox);o.setByName("charset",null);o.setByName("CharStrings",null);o.setByName("Private",null);s.topDict=o;const c=new n.CFFStrings;c.add("Version 0.11");c.add("See original notice");c.add(e);c.add(e);c.add("Medium");s.strings=c;s.globalSubrIndex=new n.CFFIndex;const l=t.length,h=[".notdef"];let u,d;for(u=0;u<l;u++){const e=r[u].glyphName;-1===n.CFFStandardStrings.indexOf(e)&&c.add(e);h.push(e)}s.charset=new n.CFFCharset(!1,0,h);const f=new n.CFFIndex;f.add([139,14]);for(u=0;u<l;u++)f.add(t[u]);s.charStrings=f;const g=new n.CFFPrivateDict;g.setByName("Subrs",null);const p=["BlueValues","OtherBlues","FamilyBlues","FamilyOtherBlues","StemSnapH","StemSnapV","BlueShift","BlueFuzz","BlueScale","LanguageGroup","ExpansionFactor","ForceBold","StdHW","StdVW"];for(u=0,d=p.length;u<d;u++){const e=p[u];if(!(e in i.privateData))continue;const t=i.privateData[e];if(Array.isArray(t))for(let e=t.length-1;e>0;e--)t[e]-=t[e-1];g.setByName(e,t)}s.topDict.privateDict=g;const m=new n.CFFIndex;for(u=0,d=a.length;u<d;u++)m.add(a[u]);g.subrsIndex=m;return new n.CFFCompiler(s).compile()}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.Type1Parser=void 0;r(125);r(146);r(148);r(149);r(159);var n=r(228),a=r(213),i=r(218),s=r(158);const o=function Type1CharStringClosure(){const e=[4],t=[5],r=[6],n=[7],a=[8],i=[12,35],o=[14],c=[21],l=[22],h=[30],u=[31];return class Type1CharString{constructor(){this.width=0;this.lsb=0;this.flexing=!1;this.output=[];this.stack=[]}convert(d,f,g){const p=d.length;let m,b,y,w=!1;for(let S=0;S<p;S++){let p=d[S];if(p<32){12===p&&(p=(p<<8)+d[++S]);switch(p){case 1:case 3:case 9:case 3072:case 3073:case 3074:case 3105:this.stack=[];break;case 4:if(this.flexing){if(this.stack.length<1){w=!0;break}const e=this.stack.pop();this.stack.push(0,e);break}w=this.executeCommand(1,e);break;case 5:w=this.executeCommand(2,t);break;case 6:w=this.executeCommand(1,r);break;case 7:w=this.executeCommand(1,n);break;case 8:w=this.executeCommand(6,a);break;case 10:if(this.stack.length<1){w=!0;break}y=this.stack.pop();if(!f[y]){w=!0;break}w=this.convert(f[y],f,g);break;case 11:return w;case 13:if(this.stack.length<2){w=!0;break}m=this.stack.pop();b=this.stack.pop();this.lsb=b;this.width=m;this.stack.push(m,b);w=this.executeCommand(2,l);break;case 14:this.output.push(o[0]);break;case 21:if(this.flexing)break;w=this.executeCommand(2,c);break;case 22:if(this.flexing){this.stack.push(0);break}w=this.executeCommand(1,l);break;case 30:w=this.executeCommand(4,h);break;case 31:w=this.executeCommand(4,u);break;case 3078:if(g){const e=this.stack.at(-5);this.seac=this.stack.splice(-4,4);this.seac[0]+=this.lsb-e;w=this.executeCommand(0,o)}else w=this.executeCommand(4,o);break;case 3079:if(this.stack.length<4){w=!0;break}this.stack.pop();m=this.stack.pop();const d=this.stack.pop();b=this.stack.pop();this.lsb=b;this.width=m;this.stack.push(m,b,d);w=this.executeCommand(3,c);break;case 3084:if(this.stack.length<2){w=!0;break}const S=this.stack.pop(),x=this.stack.pop();this.stack.push(x/S);break;case 3088:if(this.stack.length<2){w=!0;break}y=this.stack.pop();const v=this.stack.pop();if(0===y&&3===v){const e=this.stack.splice(this.stack.length-17,17);this.stack.push(e[2]+e[0],e[3]+e[1],e[4],e[5],e[6],e[7],e[8],e[9],e[10],e[11],e[12],e[13],e[14]);w=this.executeCommand(13,i,!0);this.flexing=!1;this.stack.push(e[15],e[16])}else 1===y&&0===v&&(this.flexing=!0);break;case 3089:break;default:(0,s.warn)('Unknown type 1 charstring command of "'+p+'"')}if(w)break}else{p<=246?p-=139:p=p<=250?256*(p-247)+d[++S]+108:p<=254?-256*(p-251)-d[++S]-108:(255&d[++S])<<24|(255&d[++S])<<16|(255&d[++S])<<8|(255&d[++S])<<0;this.stack.push(p)}}return w}executeCommand(e,t,r){const n=this.stack.length;if(e>n)return!0;const a=n-e;for(let e=a;e<n;e++){let t=this.stack[e];if(Number.isInteger(t))this.output.push(28,t>>8&255,255&t);else{t=65536*t|0;this.output.push(255,t>>24&255,t>>16&255,t>>8&255,255&t)}}this.output.push.apply(this.output,t);r?this.stack.splice(a,e):this.stack.length=0;return!1}}}(),c=function Type1ParserClosure(){function isHexDigit(e){return e>=48&&e<=57||e>=65&&e<=70||e>=97&&e<=102}function decrypt(e,t,r){if(r>=e.length)return new Uint8Array(0);let n,a,i=0|t;for(n=0;n<r;n++)i=52845*(e[n]+i)+22719&65535;const s=e.length-r,o=new Uint8Array(s);for(n=r,a=0;a<s;n++,a++){const t=e[n];o[a]=t^i>>8;i=52845*(t+i)+22719&65535}return o}function isSpecial(e){return 47===e||91===e||93===e||123===e||125===e||40===e||41===e}return class Type1Parser{constructor(e,t,r){if(t){const t=e.getBytes(),r=!((isHexDigit(t[0])||(0,a.isWhiteSpace)(t[0]))&&isHexDigit(t[1])&&isHexDigit(t[2])&&isHexDigit(t[3])&&isHexDigit(t[4])&&isHexDigit(t[5])&&isHexDigit(t[6])&&isHexDigit(t[7]));e=new i.Stream(r?decrypt(t,55665,4):function decryptAscii(e,t,r){let n=0|t;const a=e.length,i=new Uint8Array(a>>>1);let s,o;for(s=0,o=0;s<a;s++){const t=e[s];if(!isHexDigit(t))continue;s++;let r;for(;s<a&&!isHexDigit(r=e[s]);)s++;if(s<a){const e=parseInt(String.fromCharCode(t,r),16);i[o++]=e^n>>8;n=52845*(e+n)+22719&65535}}return i.slice(r,o)}(t,55665,4))}this.seacAnalysisEnabled=!!r;this.stream=e;this.nextChar()}readNumberArray(){this.getToken();const e=[];for(;;){const t=this.getToken();if(null===t||"]"===t||"}"===t)break;e.push(parseFloat(t||0))}return e}readNumber(){const e=this.getToken();return parseFloat(e||0)}readInt(){const e=this.getToken();return 0|parseInt(e||0,10)}readBoolean(){return"true"===this.getToken()?1:0}nextChar(){return this.currentChar=this.stream.getByte()}prevChar(){this.stream.skip(-2);return this.currentChar=this.stream.getByte()}getToken(){let e=!1,t=this.currentChar;for(;;){if(-1===t)return null;if(e)10!==t&&13!==t||(e=!1);else if(37===t)e=!0;else if(!(0,a.isWhiteSpace)(t))break;t=this.nextChar()}if(isSpecial(t)){this.nextChar();return String.fromCharCode(t)}let r="";do{r+=String.fromCharCode(t);t=this.nextChar()}while(t>=0&&!(0,a.isWhiteSpace)(t)&&!isSpecial(t));return r}readCharStrings(e,t){return-1===t?e:decrypt(e,4330,t)}extractFontProgram(e){const t=this.stream,r=[],n=[],a=Object.create(null);a.lenIV=4;const i={subrs:[],charstrings:[],properties:{privateData:a}};let s,c,l,h,u;for(;null!==(s=this.getToken());)if("/"===s){s=this.getToken();switch(s){case"CharStrings":this.getToken();this.getToken();this.getToken();this.getToken();for(;;){s=this.getToken();if(null===s||"end"===s)break;if("/"!==s)continue;const e=this.getToken();c=this.readInt();this.getToken();l=c>0?t.getBytes(c):new Uint8Array(0);h=i.properties.privateData.lenIV;u=this.readCharStrings(l,h);this.nextChar();s=this.getToken();"noaccess"===s?this.getToken():"/"===s&&this.prevChar();n.push({glyph:e,encoded:u})}break;case"Subrs":this.readInt();this.getToken();for(;"dup"===this.getToken();){const e=this.readInt();c=this.readInt();this.getToken();l=c>0?t.getBytes(c):new Uint8Array(0);h=i.properties.privateData.lenIV;u=this.readCharStrings(l,h);this.nextChar();s=this.getToken();"noaccess"===s&&this.getToken();r[e]=u}break;case"BlueValues":case"OtherBlues":case"FamilyBlues":case"FamilyOtherBlues":const e=this.readNumberArray();e.length>0&&e.length,0;break;case"StemSnapH":case"StemSnapV":i.properties.privateData[s]=this.readNumberArray();break;case"StdHW":case"StdVW":i.properties.privateData[s]=this.readNumberArray()[0];break;case"BlueShift":case"lenIV":case"BlueFuzz":case"BlueScale":case"LanguageGroup":case"ExpansionFactor":i.properties.privateData[s]=this.readNumber();break;case"ForceBold":i.properties.privateData[s]=this.readBoolean()}}for(let t=0;t<n.length;t++){const a=n[t].glyph;u=n[t].encoded;const s=new o,c=s.convert(u,r,this.seacAnalysisEnabled);let l=s.output;c&&(l=[14]);const h={glyphName:a,charstring:l,width:s.width,lsb:s.lsb,seac:s.seac};".notdef"===a?i.charstrings.unshift(h):i.charstrings.push(h);if(e.builtInEncoding){const t=e.builtInEncoding.indexOf(a);t>-1&&void 0===e.widths[t]&&t>=e.firstChar&&t<=e.lastChar&&(e.widths[t]=s.width)}}return i}extractFontHeader(e){let t;for(;null!==(t=this.getToken());)if("/"===t){t=this.getToken();switch(t){case"FontMatrix":const r=this.readNumberArray();e.fontMatrix=r;break;case"Encoding":const a=this.getToken();let i;if(/^\d+$/.test(a)){i=[];const e=0|parseInt(a,10);this.getToken();for(let r=0;r<e;r++){t=this.getToken();for(;"dup"!==t&&"def"!==t;){t=this.getToken();if(null===t)return}if("def"===t)break;const e=this.readInt();this.getToken();const r=this.getToken();i[e]=r;this.getToken()}}else i=(0,n.getEncoding)(a);e.builtInEncoding=i;break;case"FontBBox":const s=this.readNumberArray();e.ascent=Math.max(s[3],s[1]);e.descent=Math.min(s[1],s[3]);e.ascentScaled=!0}}}}}();t.Type1Parser=c},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.Pattern=void 0;t.getTilingPatternIR=function getTilingPatternIR(e,t,r){const a=t.getArray("Matrix"),i=n.Util.normalizeRect(t.getArray("BBox")),s=t.get("XStep"),o=t.get("YStep"),c=t.get("PaintType"),l=t.get("TilingType");if(i[2]-i[0]==0||i[3]-i[1]==0)throw new n.FormatError("Invalid getTilingPatternIR /BBox array: [".concat(i,"]."));return["TilingPattern",r,e,a,i,s,o,c,l]};r(112);r(238);r(236);r(146);r(148);r(149);r(247);r(125);var n=r(158),a=r(217),i=r(234),s=r(213);const o=2,c=3,l=4,h=5,u=6,d=7;t.Pattern=class Pattern{constructor(){(0,n.unreachable)("Cannot initialize Pattern.")}static parseShading(e,t,r,i,f,g){const p=e instanceof a.BaseStream?e.dict:e,m=p.get("ShadingType");try{switch(m){case o:case c:return new RadialAxialShading(p,t,r,f,g);case l:case h:case u:case d:return new MeshShading(e,t,r,f,g);default:throw new n.FormatError("Unsupported ShadingType: "+m)}}catch(e){if(e instanceof s.MissingDataException)throw e;i.send("UnsupportedFeature",{featureId:n.UNSUPPORTED_FEATURES.shadingPattern});(0,n.warn)(e);return new DummyShading}}};class BaseShading{static get SMALL_NUMBER(){return(0,n.shadow)(this,"SMALL_NUMBER",1e-6)}constructor(){this.constructor===BaseShading&&(0,n.unreachable)("Cannot initialize BaseShading.")}getIR(){(0,n.unreachable)("Abstract method `getIR` called.")}}class RadialAxialShading extends BaseShading{constructor(e,t,r,a,s){super();this.coordsArr=e.getArray("Coords");this.shadingType=e.get("ShadingType");const o=i.ColorSpace.parse({cs:e.getRaw("CS")||e.getRaw("ColorSpace"),xref:t,resources:r,pdfFunctionFactory:a,localColorSpaceCache:s}),l=e.getArray("BBox");Array.isArray(l)&&4===l.length?this.bbox=n.Util.normalizeRect(l):this.bbox=null;let h=0,u=1;if(e.has("Domain")){const t=e.getArray("Domain");h=t[0];u=t[1]}let d=!1,f=!1;if(e.has("Extend")){const t=e.getArray("Extend");d=t[0];f=t[1]}if(!(this.shadingType!==c||d&&f)){const[e,t,r,a,i,s]=this.coordsArr,o=Math.hypot(e-a,t-i);r<=s+o&&s<=r+o&&(0,n.warn)("Unsupported radial gradient.")}this.extendStart=d;this.extendEnd=f;const g=e.getRaw("Function"),p=a.createFromArray(g),m=(u-h)/10,b=this.colorStops=[];if(h>=u||m<=0){(0,n.info)("Bad shading domain.");return}const y=new Float32Array(o.numComps),w=new Float32Array(1);let S;for(let e=0;e<=10;e++){w[0]=h+e*m;p(w,0,y,0);S=o.getRgb(y,0);const t=n.Util.makeHexColor(S[0],S[1],S[2]);b.push([e/10,t])}let x="transparent";if(e.has("Background")){S=o.getRgb(e.get("Background"),0);x=n.Util.makeHexColor(S[0],S[1],S[2])}if(!d){b.unshift([0,x]);b[1][0]+=BaseShading.SMALL_NUMBER}if(!f){b.at(-1)[0]-=BaseShading.SMALL_NUMBER;b.push([1,x])}this.colorStops=b}getIR(){const e=this.coordsArr,t=this.shadingType;let r,a,i,s,l;if(t===o){a=[e[0],e[1]];i=[e[2],e[3]];s=null;l=null;r="axial"}else if(t===c){a=[e[0],e[1]];i=[e[3],e[4]];s=e[2];l=e[5];r="radial"}else(0,n.unreachable)("getPattern type unknown: ".concat(t));return["RadialAxial",r,this.bbox,this.colorStops,a,i,s,l]}}class MeshStreamReader{constructor(e,t){this.stream=e;this.context=t;this.buffer=0;this.bufferLength=0;const r=t.numComps;this.tmpCompsBuf=new Float32Array(r);const n=t.colorSpace.numComps;this.tmpCsCompsBuf=t.colorFn?new Float32Array(n):this.tmpCompsBuf}get hasData(){if(this.stream.end)return this.stream.pos<this.stream.end;if(this.bufferLength>0)return!0;const e=this.stream.getByte();if(e<0)return!1;this.buffer=e;this.bufferLength=8;return!0}readBits(e){let t=this.buffer,r=this.bufferLength;if(32===e){if(0===r)return(this.stream.getByte()<<24|this.stream.getByte()<<16|this.stream.getByte()<<8|this.stream.getByte())>>>0;t=t<<24|this.stream.getByte()<<16|this.stream.getByte()<<8|this.stream.getByte();const e=this.stream.getByte();this.buffer=e&(1<<r)-1;return(t<<8-r|(255&e)>>r)>>>0}if(8===e&&0===r)return this.stream.getByte();for(;r<e;){t=t<<8|this.stream.getByte();r+=8}r-=e;this.bufferLength=r;this.buffer=t&(1<<r)-1;return t>>r}align(){this.buffer=0;this.bufferLength=0}readFlag(){return this.readBits(this.context.bitsPerFlag)}readCoordinate(){const e=this.context.bitsPerCoordinate,t=this.readBits(e),r=this.readBits(e),n=this.context.decode,a=e<32?1/((1<<e)-1):2.3283064365386963e-10;return[t*a*(n[1]-n[0])+n[0],r*a*(n[3]-n[2])+n[2]]}readComponents(){const e=this.context.numComps,t=this.context.bitsPerComponent,r=t<32?1/((1<<t)-1):2.3283064365386963e-10,n=this.context.decode,a=this.tmpCompsBuf;for(let i=0,s=4;i<e;i++,s+=2){const e=this.readBits(t);a[i]=e*r*(n[s+1]-n[s])+n[s]}const i=this.tmpCsCompsBuf;this.context.colorFn&&this.context.colorFn(a,0,i,0);return this.context.colorSpace.getRgb(i,0)}}const f=function getBClosure(){const e=[];return function(t){e[t]||(e[t]=function buildB(e){const t=[];for(let r=0;r<=e;r++){const n=r/e,a=1-n;t.push(new Float32Array([a*a*a,3*n*a*a,3*n*n*a,n*n*n]))}return t}(t));return e[t]}}();class MeshShading extends BaseShading{static get MIN_SPLIT_PATCH_CHUNKS_AMOUNT(){return(0,n.shadow)(this,"MIN_SPLIT_PATCH_CHUNKS_AMOUNT",3)}static get MAX_SPLIT_PATCH_CHUNKS_AMOUNT(){return(0,n.shadow)(this,"MAX_SPLIT_PATCH_CHUNKS_AMOUNT",20)}static get TRIANGLE_DENSITY(){return(0,n.shadow)(this,"TRIANGLE_DENSITY",20)}constructor(e,t,r,s,o){super();if(!(e instanceof a.BaseStream))throw new n.FormatError("Mesh data is not a stream");const c=e.dict;this.shadingType=c.get("ShadingType");const f=c.getArray("BBox");Array.isArray(f)&&4===f.length?this.bbox=n.Util.normalizeRect(f):this.bbox=null;const g=i.ColorSpace.parse({cs:c.getRaw("CS")||c.getRaw("ColorSpace"),xref:t,resources:r,pdfFunctionFactory:s,localColorSpaceCache:o});this.background=c.has("Background")?g.getRgb(c.get("Background"),0):null;const p=c.getRaw("Function"),m=p?s.createFromArray(p):null;this.coords=[];this.colors=[];this.figures=[];const b={bitsPerCoordinate:c.get("BitsPerCoordinate"),bitsPerComponent:c.get("BitsPerComponent"),bitsPerFlag:c.get("BitsPerFlag"),decode:c.getArray("Decode"),colorFn:m,colorSpace:g,numComps:m?1:g.numComps},y=new MeshStreamReader(e,b);let w=!1;switch(this.shadingType){case l:this._decodeType4Shading(y);break;case h:const e=0|c.get("VerticesPerRow");if(e<2)throw new n.FormatError("Invalid VerticesPerRow");this._decodeType5Shading(y,e);break;case u:this._decodeType6Shading(y);w=!0;break;case d:this._decodeType7Shading(y);w=!0;break;default:(0,n.unreachable)("Unsupported mesh type.")}if(w){this._updateBounds();for(let e=0,t=this.figures.length;e<t;e++)this._buildFigureFromPatch(e)}this._updateBounds();this._packData()}_decodeType4Shading(e){const t=this.coords,r=this.colors,a=[],i=[];let s=0;for(;e.hasData;){const o=e.readFlag(),c=e.readCoordinate(),l=e.readComponents();if(0===s){if(!(0<=o&&o<=2))throw new n.FormatError("Unknown type4 flag");switch(o){case 0:s=3;break;case 1:i.push(i.at(-2),i.at(-1));s=1;break;case 2:i.push(i.at(-3),i.at(-1));s=1}a.push(o)}i.push(t.length);t.push(c);r.push(l);s--;e.align()}this.figures.push({type:"triangles",coords:new Int32Array(i),colors:new Int32Array(i)})}_decodeType5Shading(e,t){const r=this.coords,n=this.colors,a=[];for(;e.hasData;){const t=e.readCoordinate(),i=e.readComponents();a.push(r.length);r.push(t);n.push(i)}this.figures.push({type:"lattice",coords:new Int32Array(a),colors:new Int32Array(a),verticesPerRow:t})}_decodeType6Shading(e){const t=this.coords,r=this.colors,a=new Int32Array(16),i=new Int32Array(4);for(;e.hasData;){const s=e.readFlag();if(!(0<=s&&s<=3))throw new n.FormatError("Unknown type6 flag");const o=t.length;for(let r=0,n=0!==s?8:12;r<n;r++)t.push(e.readCoordinate());const c=r.length;for(let t=0,n=0!==s?2:4;t<n;t++)r.push(e.readComponents());let l,h,u,d;switch(s){case 0:a[12]=o+3;a[13]=o+4;a[14]=o+5;a[15]=o+6;a[8]=o+2;a[11]=o+7;a[4]=o+1;a[7]=o+8;a[0]=o;a[1]=o+11;a[2]=o+10;a[3]=o+9;i[2]=c+1;i[3]=c+2;i[0]=c;i[1]=c+3;break;case 1:l=a[12];h=a[13];u=a[14];d=a[15];a[12]=d;a[13]=o+0;a[14]=o+1;a[15]=o+2;a[8]=u;a[11]=o+3;a[4]=h;a[7]=o+4;a[0]=l;a[1]=o+7;a[2]=o+6;a[3]=o+5;l=i[2];h=i[3];i[2]=h;i[3]=c;i[0]=l;i[1]=c+1;break;case 2:l=a[15];h=a[11];a[12]=a[3];a[13]=o+0;a[14]=o+1;a[15]=o+2;a[8]=a[7];a[11]=o+3;a[4]=h;a[7]=o+4;a[0]=l;a[1]=o+7;a[2]=o+6;a[3]=o+5;l=i[3];i[2]=i[1];i[3]=c;i[0]=l;i[1]=c+1;break;case 3:a[12]=a[0];a[13]=o+0;a[14]=o+1;a[15]=o+2;a[8]=a[1];a[11]=o+3;a[4]=a[2];a[7]=o+4;a[0]=a[3];a[1]=o+7;a[2]=o+6;a[3]=o+5;i[2]=i[0];i[3]=c;i[0]=i[1];i[1]=c+1}a[5]=t.length;t.push([(-4*t[a[0]][0]-t[a[15]][0]+6*(t[a[4]][0]+t[a[1]][0])-2*(t[a[12]][0]+t[a[3]][0])+3*(t[a[13]][0]+t[a[7]][0]))/9,(-4*t[a[0]][1]-t[a[15]][1]+6*(t[a[4]][1]+t[a[1]][1])-2*(t[a[12]][1]+t[a[3]][1])+3*(t[a[13]][1]+t[a[7]][1]))/9]);a[6]=t.length;t.push([(-4*t[a[3]][0]-t[a[12]][0]+6*(t[a[2]][0]+t[a[7]][0])-2*(t[a[0]][0]+t[a[15]][0])+3*(t[a[4]][0]+t[a[14]][0]))/9,(-4*t[a[3]][1]-t[a[12]][1]+6*(t[a[2]][1]+t[a[7]][1])-2*(t[a[0]][1]+t[a[15]][1])+3*(t[a[4]][1]+t[a[14]][1]))/9]);a[9]=t.length;t.push([(-4*t[a[12]][0]-t[a[3]][0]+6*(t[a[8]][0]+t[a[13]][0])-2*(t[a[0]][0]+t[a[15]][0])+3*(t[a[11]][0]+t[a[1]][0]))/9,(-4*t[a[12]][1]-t[a[3]][1]+6*(t[a[8]][1]+t[a[13]][1])-2*(t[a[0]][1]+t[a[15]][1])+3*(t[a[11]][1]+t[a[1]][1]))/9]);a[10]=t.length;t.push([(-4*t[a[15]][0]-t[a[0]][0]+6*(t[a[11]][0]+t[a[14]][0])-2*(t[a[12]][0]+t[a[3]][0])+3*(t[a[2]][0]+t[a[8]][0]))/9,(-4*t[a[15]][1]-t[a[0]][1]+6*(t[a[11]][1]+t[a[14]][1])-2*(t[a[12]][1]+t[a[3]][1])+3*(t[a[2]][1]+t[a[8]][1]))/9]);this.figures.push({type:"patch",coords:new Int32Array(a),colors:new Int32Array(i)})}}_decodeType7Shading(e){const t=this.coords,r=this.colors,a=new Int32Array(16),i=new Int32Array(4);for(;e.hasData;){const s=e.readFlag();if(!(0<=s&&s<=3))throw new n.FormatError("Unknown type7 flag");const o=t.length;for(let r=0,n=0!==s?12:16;r<n;r++)t.push(e.readCoordinate());const c=r.length;for(let t=0,n=0!==s?2:4;t<n;t++)r.push(e.readComponents());let l,h,u,d;switch(s){case 0:a[12]=o+3;a[13]=o+4;a[14]=o+5;a[15]=o+6;a[8]=o+2;a[9]=o+13;a[10]=o+14;a[11]=o+7;a[4]=o+1;a[5]=o+12;a[6]=o+15;a[7]=o+8;a[0]=o;a[1]=o+11;a[2]=o+10;a[3]=o+9;i[2]=c+1;i[3]=c+2;i[0]=c;i[1]=c+3;break;case 1:l=a[12];h=a[13];u=a[14];d=a[15];a[12]=d;a[13]=o+0;a[14]=o+1;a[15]=o+2;a[8]=u;a[9]=o+9;a[10]=o+10;a[11]=o+3;a[4]=h;a[5]=o+8;a[6]=o+11;a[7]=o+4;a[0]=l;a[1]=o+7;a[2]=o+6;a[3]=o+5;l=i[2];h=i[3];i[2]=h;i[3]=c;i[0]=l;i[1]=c+1;break;case 2:l=a[15];h=a[11];a[12]=a[3];a[13]=o+0;a[14]=o+1;a[15]=o+2;a[8]=a[7];a[9]=o+9;a[10]=o+10;a[11]=o+3;a[4]=h;a[5]=o+8;a[6]=o+11;a[7]=o+4;a[0]=l;a[1]=o+7;a[2]=o+6;a[3]=o+5;l=i[3];i[2]=i[1];i[3]=c;i[0]=l;i[1]=c+1;break;case 3:a[12]=a[0];a[13]=o+0;a[14]=o+1;a[15]=o+2;a[8]=a[1];a[9]=o+9;a[10]=o+10;a[11]=o+3;a[4]=a[2];a[5]=o+8;a[6]=o+11;a[7]=o+4;a[0]=a[3];a[1]=o+7;a[2]=o+6;a[3]=o+5;i[2]=i[0];i[3]=c;i[0]=i[1];i[1]=c+1}this.figures.push({type:"patch",coords:new Int32Array(a),colors:new Int32Array(i)})}}_buildFigureFromPatch(e){const t=this.figures[e];(0,n.assert)("patch"===t.type,"Unexpected patch mesh figure");const r=this.coords,a=this.colors,i=t.coords,s=t.colors,o=Math.min(r[i[0]][0],r[i[3]][0],r[i[12]][0],r[i[15]][0]),c=Math.min(r[i[0]][1],r[i[3]][1],r[i[12]][1],r[i[15]][1]),l=Math.max(r[i[0]][0],r[i[3]][0],r[i[12]][0],r[i[15]][0]),h=Math.max(r[i[0]][1],r[i[3]][1],r[i[12]][1],r[i[15]][1]);let u=Math.ceil((l-o)*MeshShading.TRIANGLE_DENSITY/(this.bounds[2]-this.bounds[0]));u=Math.max(MeshShading.MIN_SPLIT_PATCH_CHUNKS_AMOUNT,Math.min(MeshShading.MAX_SPLIT_PATCH_CHUNKS_AMOUNT,u));let d=Math.ceil((h-c)*MeshShading.TRIANGLE_DENSITY/(this.bounds[3]-this.bounds[1]));d=Math.max(MeshShading.MIN_SPLIT_PATCH_CHUNKS_AMOUNT,Math.min(MeshShading.MAX_SPLIT_PATCH_CHUNKS_AMOUNT,d));const g=u+1,p=new Int32Array((d+1)*g),m=new Int32Array((d+1)*g);let b=0;const y=new Uint8Array(3),w=new Uint8Array(3),S=a[s[0]],x=a[s[1]],v=a[s[2]],k=a[s[3]],C=f(d),O=f(u);for(let e=0;e<=d;e++){y[0]=(S[0]*(d-e)+v[0]*e)/d|0;y[1]=(S[1]*(d-e)+v[1]*e)/d|0;y[2]=(S[2]*(d-e)+v[2]*e)/d|0;w[0]=(x[0]*(d-e)+k[0]*e)/d|0;w[1]=(x[1]*(d-e)+k[1]*e)/d|0;w[2]=(x[2]*(d-e)+k[2]*e)/d|0;for(let t=0;t<=u;t++,b++){if(!(0!==e&&e!==d||0!==t&&t!==u))continue;let n=0,s=0,o=0;for(let a=0;a<=3;a++)for(let c=0;c<=3;c++,o++){const l=C[e][a]*O[t][c];n+=r[i[o]][0]*l;s+=r[i[o]][1]*l}p[b]=r.length;r.push([n,s]);m[b]=a.length;const c=new Uint8Array(3);c[0]=(y[0]*(u-t)+w[0]*t)/u|0;c[1]=(y[1]*(u-t)+w[1]*t)/u|0;c[2]=(y[2]*(u-t)+w[2]*t)/u|0;a.push(c)}}p[0]=i[0];m[0]=s[0];p[u]=i[3];m[u]=s[1];p[g*d]=i[12];m[g*d]=s[2];p[g*d+u]=i[15];m[g*d+u]=s[3];this.figures[e]={type:"lattice",coords:p,colors:m,verticesPerRow:g}}_updateBounds(){let e=this.coords[0][0],t=this.coords[0][1],r=e,n=t;for(let a=1,i=this.coords.length;a<i;a++){const i=this.coords[a][0],s=this.coords[a][1];e=e>i?i:e;t=t>s?s:t;r=r<i?i:r;n=n<s?s:n}this.bounds=[e,t,r,n]}_packData(){let e,t,r,n;const a=this.coords,i=new Float32Array(2*a.length);for(e=0,r=0,t=a.length;e<t;e++){const t=a[e];i[r++]=t[0];i[r++]=t[1]}this.coords=i;const s=this.colors,o=new Uint8Array(3*s.length);for(e=0,r=0,t=s.length;e<t;e++){const t=s[e];o[r++]=t[0];o[r++]=t[1];o[r++]=t[2]}this.colors=o;const c=this.figures;for(e=0,t=c.length;e<t;e++){const t=c[e],a=t.coords,i=t.colors;for(r=0,n=a.length;r<n;r++){a[r]*=2;i[r]*=3}}}getIR(){return["Mesh",this.shadingType,this.coords,this.colors,this.figures,this.bounds,this.bbox,this.background]}}class DummyShading extends BaseShading{getIR(){return["Dummy"]}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.PostScriptEvaluator=t.PostScriptCompiler=t.PDFFunctionFactory=void 0;t.isPDFFunction=function isPDFFunction(e){let t;if("object"!=typeof e)return!1;if(e instanceof n.Dict)t=e;else{if(!(e instanceof s.BaseStream))return!1;t=e.dict}return t.has("FunctionType")};r(274);r(146);r(148);r(149);r(178);r(236);r(112);var n=r(209),a=r(158),i=r(275),s=r(217),o=r(276);t.PDFFunctionFactory=class PDFFunctionFactory{constructor(e){let{xref:t,isEvalSupported:r=!0}=e;this.xref=t;this.isEvalSupported=!1!==r}create(e){const t=this.getCached(e);if(t)return t;const r=PDFFunction.parse({xref:this.xref,isEvalSupported:this.isEvalSupported,fn:e instanceof n.Ref?this.xref.fetch(e):e});this._cache(e,r);return r}createFromArray(e){const t=this.getCached(e);if(t)return t;const r=PDFFunction.parseArray({xref:this.xref,isEvalSupported:this.isEvalSupported,fnObj:e instanceof n.Ref?this.xref.fetch(e):e});this._cache(e,r);return r}getCached(e){let t;e instanceof n.Ref?t=e:e instanceof n.Dict?t=e.objId:e instanceof s.BaseStream&&(t=e.dict&&e.dict.objId);if(t){const e=this._localFunctionCache.getByRef(t);if(e)return e}return null}_cache(e,t){if(!t)throw new Error('PDFFunctionFactory._cache - expected "parsedFunction" argument.');let r;e instanceof n.Ref?r=e:e instanceof n.Dict?r=e.objId:e instanceof s.BaseStream&&(r=e.dict&&e.dict.objId);r&&this._localFunctionCache.set(null,r,t)}get _localFunctionCache(){return(0,a.shadow)(this,"_localFunctionCache",new o.LocalFunctionCache)}};function toNumberArray(e){if(!Array.isArray(e))return null;const t=e.length;for(let r=0;r<t;r++)if("number"!=typeof e[r]){const r=new Array(t);for(let n=0;n<t;n++)r[n]=+e[n];return r}return e}class PDFFunction{static getSampleArray(e,t,r,n){let a,i,s=1;for(a=0,i=e.length;a<i;a++)s*=e[a];s*=t;const o=new Array(s);let c=0,l=0;const h=1/(2**r-1),u=n.getBytes((s*r+7)/8);let d=0;for(a=0;a<s;a++){for(;c<r;){l<<=8;l|=u[d++];c+=8}c-=r;o[a]=(l>>c)*h;l&=(1<<c)-1}return o}static parse(e){let{xref:t,isEvalSupported:r,fn:n}=e;const i=n.dict||n;switch(i.get("FunctionType")){case 0:return this.constructSampled({xref:t,isEvalSupported:r,fn:n,dict:i});case 1:break;case 2:return this.constructInterpolated({xref:t,isEvalSupported:r,dict:i});case 3:return this.constructStiched({xref:t,isEvalSupported:r,dict:i});case 4:return this.constructPostScript({xref:t,isEvalSupported:r,fn:n,dict:i})}throw new a.FormatError("Unknown type of function")}static parseArray(e){let{xref:t,isEvalSupported:r,fnObj:n}=e;if(!Array.isArray(n))return this.parse({xref:t,isEvalSupported:r,fn:n});const a=[];for(let e=0,i=n.length;e<i;e++)a.push(this.parse({xref:t,isEvalSupported:r,fn:t.fetchIfRef(n[e])}));return function(e,t,r,n){for(let i=0,s=a.length;i<s;i++)a[i](e,t,r,n+i)}}static constructSampled(e){let{xref:t,isEvalSupported:r,fn:n,dict:i}=e;function toMultiArray(e){const t=e.length,r=[];let n=0;for(let a=0;a<t;a+=2)r[n++]=[e[a],e[a+1]];return r}function interpolate(e,t,r,n,a){return n+(a-n)/(r-t)*(e-t)}let s=toNumberArray(i.getArray("Domain")),o=toNumberArray(i.getArray("Range"));if(!s||!o)throw new a.FormatError("No domain or range");const c=s.length/2,l=o.length/2;s=toMultiArray(s);o=toMultiArray(o);const h=toNumberArray(i.getArray("Size")),u=i.get("BitsPerSample"),d=i.get("Order")||1;1!==d&&(0,a.info)("No support for cubic spline interpolation: "+d);let f=toNumberArray(i.getArray("Encode"));if(f)f=toMultiArray(f);else{f=[];for(let e=0;e<c;++e)f.push([0,h[e]-1])}let g=toNumberArray(i.getArray("Decode"));g=g?toMultiArray(g):o;const p=this.getSampleArray(h,l,u,n);return function constructSampledFn(e,t,r,n){const a=1<<c,i=new Float64Array(a),u=new Uint32Array(a);let d,m;for(m=0;m<a;m++)i[m]=1;let b=l,y=1;for(d=0;d<c;++d){const r=s[d][0],n=s[d][1];let o=interpolate(Math.min(Math.max(e[t+d],r),n),r,n,f[d][0],f[d][1]);const c=h[d];o=Math.min(Math.max(o,0),c-1);const l=o<c-1?Math.floor(o):o-1,g=l+1-o,p=o-l,w=l*b,S=w+b;for(m=0;m<a;m++)if(m&y){i[m]*=p;u[m]+=S}else{i[m]*=g;u[m]+=w}b*=c;y<<=1}for(m=0;m<l;++m){let e=0;for(d=0;d<a;d++)e+=p[u[d]+m]*i[d];e=interpolate(e,0,1,g[m][0],g[m][1]);r[n+m]=Math.min(Math.max(e,o[m][0]),o[m][1])}}}static constructInterpolated(e){let{xref:t,isEvalSupported:r,dict:n}=e;const a=toNumberArray(n.getArray("C0"))||[0],i=toNumberArray(n.getArray("C1"))||[1],s=n.get("N"),o=[];for(let e=0,t=a.length;e<t;++e)o.push(i[e]-a[e]);const c=o.length;return function constructInterpolatedFn(e,t,r,n){const i=1===s?e[t]:e[t]**s;for(let e=0;e<c;++e)r[n+e]=a[e]+i*o[e]}}static constructStiched(e){let{xref:t,isEvalSupported:r,dict:n}=e;const i=toNumberArray(n.getArray("Domain"));if(!i)throw new a.FormatError("No domain");if(1!==i.length/2)throw new a.FormatError("Bad domain for stiched function");const s=n.get("Functions"),o=[];for(let e=0,n=s.length;e<n;++e)o.push(this.parse({xref:t,isEvalSupported:r,fn:t.fetchIfRef(s[e])}));const c=toNumberArray(n.getArray("Bounds")),l=toNumberArray(n.getArray("Encode")),h=new Float32Array(1);return function constructStichedFn(e,t,r,n){const a=function constructStichedFromIRClip(e,t,r){e>r?e=r:e<t&&(e=t);return e}(e[t],i[0],i[1]),s=c.length;let u;for(u=0;u<s&&!(a<c[u]);++u);let d=i[0];u>0&&(d=c[u-1]);let f=i[1];u<c.length&&(f=c[u]);const g=l[2*u],p=l[2*u+1];h[0]=d===f?g:g+(a-d)*(p-g)/(f-d);o[u](h,0,r,n)}}static constructPostScript(e){let{xref:t,isEvalSupported:r,fn:n,dict:s}=e;const o=toNumberArray(s.getArray("Domain")),l=toNumberArray(s.getArray("Range"));if(!o)throw new a.FormatError("No domain.");if(!l)throw new a.FormatError("No range.");const h=new i.PostScriptLexer(n),u=new i.PostScriptParser(h).parse();if(r&&a.FeatureTest.isEvalSupported){const e=(new c).compile(u,o,l);if(e)return new Function("src","srcOffset","dest","destOffset",e)}(0,a.info)("Unable to compile PS function");const d=l.length>>1,f=o.length>>1,g=new PostScriptEvaluator(u),p=Object.create(null);let m=8192;const b=new Float32Array(f);return function constructPostScriptFn(e,t,r,n){let a,i,s="";const o=b;for(a=0;a<f;a++){i=e[t+a];o[a]=i;s+=i+"_"}const c=p[s];if(void 0!==c){r.set(c,n);return}const h=new Float32Array(d),u=g.execute(o),y=u.length-d;for(a=0;a<d;a++){i=u[y+a];let e=l[2*a];if(i<e)i=e;else{e=l[2*a+1];i>e&&(i=e)}h[a]=i}if(m>0){m--;p[s]=h}r.set(h,n)}}}class PostScriptStack{static get MAX_STACK_SIZE(){return(0,a.shadow)(this,"MAX_STACK_SIZE",100)}constructor(e){this.stack=e?Array.prototype.slice.call(e,0):[]}push(e){if(this.stack.length>=PostScriptStack.MAX_STACK_SIZE)throw new Error("PostScript function stack overflow.");this.stack.push(e)}pop(){if(this.stack.length<=0)throw new Error("PostScript function stack underflow.");return this.stack.pop()}copy(e){if(this.stack.length+e>=PostScriptStack.MAX_STACK_SIZE)throw new Error("PostScript function stack overflow.");const t=this.stack;for(let r=t.length-e,n=e-1;n>=0;n--,r++)t.push(t[r])}index(e){this.push(this.stack[this.stack.length-e-1])}roll(e,t){const r=this.stack,n=r.length-e,a=r.length-1,i=n+(t-Math.floor(t/e)*e);for(let e=n,t=a;e<t;e++,t--){const n=r[e];r[e]=r[t];r[t]=n}for(let e=n,t=i-1;e<t;e++,t--){const n=r[e];r[e]=r[t];r[t]=n}for(let e=i,t=a;e<t;e++,t--){const n=r[e];r[e]=r[t];r[t]=n}}}class PostScriptEvaluator{constructor(e){this.operators=e}execute(e){const t=new PostScriptStack(e);let r=0;const n=this.operators,i=n.length;let s,o,c;for(;r<i;){s=n[r++];if("number"!=typeof s)switch(s){case"jz":c=t.pop();o=t.pop();o||(r=c);break;case"j":o=t.pop();r=o;break;case"abs":o=t.pop();t.push(Math.abs(o));break;case"add":c=t.pop();o=t.pop();t.push(o+c);break;case"and":c=t.pop();o=t.pop();"boolean"==typeof o&&"boolean"==typeof c?t.push(o&&c):t.push(o&c);break;case"atan":o=t.pop();t.push(Math.atan(o));break;case"bitshift":c=t.pop();o=t.pop();o>0?t.push(o<<c):t.push(o>>c);break;case"ceiling":o=t.pop();t.push(Math.ceil(o));break;case"copy":o=t.pop();t.copy(o);break;case"cos":o=t.pop();t.push(Math.cos(o));break;case"cvi":o=0|t.pop();t.push(o);break;case"cvr":break;case"div":c=t.pop();o=t.pop();t.push(o/c);break;case"dup":t.copy(1);break;case"eq":c=t.pop();o=t.pop();t.push(o===c);break;case"exch":t.roll(2,1);break;case"exp":c=t.pop();o=t.pop();t.push(o**c);break;case"false":t.push(!1);break;case"floor":o=t.pop();t.push(Math.floor(o));break;case"ge":c=t.pop();o=t.pop();t.push(o>=c);break;case"gt":c=t.pop();o=t.pop();t.push(o>c);break;case"idiv":c=t.pop();o=t.pop();t.push(o/c|0);break;case"index":o=t.pop();t.index(o);break;case"le":c=t.pop();o=t.pop();t.push(o<=c);break;case"ln":o=t.pop();t.push(Math.log(o));break;case"log":o=t.pop();t.push(Math.log(o)/Math.LN10);break;case"lt":c=t.pop();o=t.pop();t.push(o<c);break;case"mod":c=t.pop();o=t.pop();t.push(o%c);break;case"mul":c=t.pop();o=t.pop();t.push(o*c);break;case"ne":c=t.pop();o=t.pop();t.push(o!==c);break;case"neg":o=t.pop();t.push(-o);break;case"not":o=t.pop();"boolean"==typeof o?t.push(!o):t.push(~o);break;case"or":c=t.pop();o=t.pop();"boolean"==typeof o&&"boolean"==typeof c?t.push(o||c):t.push(o|c);break;case"pop":t.pop();break;case"roll":c=t.pop();o=t.pop();t.roll(o,c);break;case"round":o=t.pop();t.push(Math.round(o));break;case"sin":o=t.pop();t.push(Math.sin(o));break;case"sqrt":o=t.pop();t.push(Math.sqrt(o));break;case"sub":c=t.pop();o=t.pop();t.push(o-c);break;case"true":t.push(!0);break;case"truncate":o=t.pop();o=o<0?Math.ceil(o):Math.floor(o);t.push(o);break;case"xor":c=t.pop();o=t.pop();"boolean"==typeof o&&"boolean"==typeof c?t.push(o!==c):t.push(o^c);break;default:throw new a.FormatError("Unknown operator ".concat(s))}else t.push(s)}return t.stack}}t.PostScriptEvaluator=PostScriptEvaluator;const c=function PostScriptCompilerClosure(){class AstNode{constructor(e){this.type=e}visit(e){(0,a.unreachable)("abstract method")}}class AstArgument extends AstNode{constructor(e,t,r){super("args");this.index=e;this.min=t;this.max=r}visit(e){e.visitArgument(this)}}class AstLiteral extends AstNode{constructor(e){super("literal");this.number=e;this.min=e;this.max=e}visit(e){e.visitLiteral(this)}}class AstBinaryOperation extends AstNode{constructor(e,t,r,n,a){super("binary");this.op=e;this.arg1=t;this.arg2=r;this.min=n;this.max=a}visit(e){e.visitBinaryOperation(this)}}class AstMin extends AstNode{constructor(e,t){super("max");this.arg=e;this.min=e.min;this.max=t}visit(e){e.visitMin(this)}}class AstVariable extends AstNode{constructor(e,t,r){super("var");this.index=e;this.min=t;this.max=r}visit(e){e.visitVariable(this)}}class AstVariableDefinition extends AstNode{constructor(e,t){super("definition");this.variable=e;this.arg=t}visit(e){e.visitVariableDefinition(this)}}class ExpressionBuilderVisitor{constructor(){this.parts=[]}visitArgument(e){this.parts.push("Math.max(",e.min,", Math.min(",e.max,", src[srcOffset + ",e.index,"]))")}visitVariable(e){this.parts.push("v",e.index)}visitLiteral(e){this.parts.push(e.number)}visitBinaryOperation(e){this.parts.push("(");e.arg1.visit(this);this.parts.push(" ",e.op," ");e.arg2.visit(this);this.parts.push(")")}visitVariableDefinition(e){this.parts.push("var ");e.variable.visit(this);this.parts.push(" = ");e.arg.visit(this);this.parts.push(";")}visitMin(e){this.parts.push("Math.min(");e.arg.visit(this);this.parts.push(", ",e.max,")")}toString(){return this.parts.join("")}}function buildAddOperation(e,t){return"literal"===t.type&&0===t.number?e:"literal"===e.type&&0===e.number?t:"literal"===t.type&&"literal"===e.type?new AstLiteral(e.number+t.number):new AstBinaryOperation("+",e,t,e.min+t.min,e.max+t.max)}function buildMulOperation(e,t){if("literal"===t.type){if(0===t.number)return new AstLiteral(0);if(1===t.number)return e;if("literal"===e.type)return new AstLiteral(e.number*t.number)}if("literal"===e.type){if(0===e.number)return new AstLiteral(0);if(1===e.number)return t}const r=Math.min(e.min*t.min,e.min*t.max,e.max*t.min,e.max*t.max),n=Math.max(e.min*t.min,e.min*t.max,e.max*t.min,e.max*t.max);return new AstBinaryOperation("*",e,t,r,n)}function buildSubOperation(e,t){if("literal"===t.type){if(0===t.number)return e;if("literal"===e.type)return new AstLiteral(e.number-t.number)}return"binary"===t.type&&"-"===t.op&&"literal"===e.type&&1===e.number&&"literal"===t.arg1.type&&1===t.arg1.number?t.arg2:new AstBinaryOperation("-",e,t,e.min-t.max,e.max-t.min)}function buildMinOperation(e,t){return e.min>=t?new AstLiteral(t):e.max<=t?e:new AstMin(e,t)}return class PostScriptCompiler{compile(e,t,r){const n=[],a=[],i=t.length>>1,s=r.length>>1;let o,c,l,h,u,d,f,g,p=0;for(let e=0;e<i;e++)n.push(new AstArgument(e,t[2*e],t[2*e+1]));for(let t=0,r=e.length;t<r;t++){g=e[t];if("number"!=typeof g)switch(g){case"add":if(n.length<2)return null;h=n.pop();l=n.pop();n.push(buildAddOperation(l,h));break;case"cvr":if(n.length<1)return null;break;case"mul":if(n.length<2)return null;h=n.pop();l=n.pop();n.push(buildMulOperation(l,h));break;case"sub":if(n.length<2)return null;h=n.pop();l=n.pop();n.push(buildSubOperation(l,h));break;case"exch":if(n.length<2)return null;u=n.pop();d=n.pop();n.push(u,d);break;case"pop":if(n.length<1)return null;n.pop();break;case"index":if(n.length<1)return null;l=n.pop();if("literal"!==l.type)return null;o=l.number;if(o<0||!Number.isInteger(o)||n.length<o)return null;u=n[n.length-o-1];if("literal"===u.type||"var"===u.type){n.push(u);break}f=new AstVariable(p++,u.min,u.max);n[n.length-o-1]=f;n.push(f);a.push(new AstVariableDefinition(f,u));break;case"dup":if(n.length<1)return null;if("number"==typeof e[t+1]&&"gt"===e[t+2]&&e[t+3]===t+7&&"jz"===e[t+4]&&"pop"===e[t+5]&&e[t+6]===e[t+1]){l=n.pop();n.push(buildMinOperation(l,e[t+1]));t+=6;break}u=n.at(-1);if("literal"===u.type||"var"===u.type){n.push(u);break}f=new AstVariable(p++,u.min,u.max);n[n.length-1]=f;n.push(f);a.push(new AstVariableDefinition(f,u));break;case"roll":if(n.length<2)return null;h=n.pop();l=n.pop();if("literal"!==h.type||"literal"!==l.type)return null;c=h.number;o=l.number;if(o<=0||!Number.isInteger(o)||!Number.isInteger(c)||n.length<o)return null;c=(c%o+o)%o;if(0===c)break;Array.prototype.push.apply(n,n.splice(n.length-o,o-c));break;default:return null}else n.push(new AstLiteral(g))}if(n.length!==s)return null;const m=[];for(const e of a){const t=new ExpressionBuilderVisitor;e.visit(t);m.push(t.toString())}for(let e=0,t=n.length;e<t;e++){const t=n[e],a=new ExpressionBuilderVisitor;t.visit(a);const i=r[2*e],s=r[2*e+1],o=[a.toString()];if(i>t.min){o.unshift("Math.max(",i,", ");o.push(")")}if(s<t.max){o.unshift("Math.min(",s,", ");o.push(")")}o.unshift("dest[destOffset + ",e,"] = ");o.push(";");m.push(o.join(""))}return m.join("\n")}}}();t.PostScriptCompiler=c},(e,t,r)=>{r(126)("Float64",(function(e){return function Float64Array(t,r,n){return e(this,t,r,n)}}))},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.PostScriptParser=t.PostScriptLexer=void 0;var n=r(158),a=r(209),i=r(213);t.PostScriptParser=class PostScriptParser{constructor(e){this.lexer=e;this.operators=[];this.token=null;this.prev=null}nextToken(){this.prev=this.token;this.token=this.lexer.getToken()}accept(e){if(this.token.type===e){this.nextToken();return!0}return!1}expect(e){if(this.accept(e))return!0;throw new n.FormatError("Unexpected symbol: found ".concat(this.token.type," expected ").concat(e,"."))}parse(){this.nextToken();this.expect(s.LBRACE);this.parseBlock();this.expect(s.RBRACE);return this.operators}parseBlock(){for(;;)if(this.accept(s.NUMBER))this.operators.push(this.prev.value);else if(this.accept(s.OPERATOR))this.operators.push(this.prev.value);else{if(!this.accept(s.LBRACE))return;this.parseCondition()}}parseCondition(){const e=this.operators.length;this.operators.push(null,null);this.parseBlock();this.expect(s.RBRACE);if(this.accept(s.IF)){this.operators[e]=this.operators.length;this.operators[e+1]="jz"}else{if(!this.accept(s.LBRACE))throw new n.FormatError("PS Function: error parsing conditional.");{const t=this.operators.length;this.operators.push(null,null);const r=this.operators.length;this.parseBlock();this.expect(s.RBRACE);this.expect(s.IFELSE);this.operators[t]=this.operators.length;this.operators[t+1]="j";this.operators[e]=r;this.operators[e+1]="jz"}}}};const s={LBRACE:0,RBRACE:1,NUMBER:2,OPERATOR:3,IF:4,IFELSE:5};class PostScriptToken{static get opCache(){return(0,n.shadow)(this,"opCache",Object.create(null))}constructor(e,t){this.type=e;this.value=t}static getOperator(e){const t=PostScriptToken.opCache[e];return t||(PostScriptToken.opCache[e]=new PostScriptToken(s.OPERATOR,e))}static get LBRACE(){return(0,n.shadow)(this,"LBRACE",new PostScriptToken(s.LBRACE,"{"))}static get RBRACE(){return(0,n.shadow)(this,"RBRACE",new PostScriptToken(s.RBRACE,"}"))}static get IF(){return(0,n.shadow)(this,"IF",new PostScriptToken(s.IF,"IF"))}static get IFELSE(){return(0,n.shadow)(this,"IFELSE",new PostScriptToken(s.IFELSE,"IFELSE"))}}t.PostScriptLexer=class PostScriptLexer{constructor(e){this.stream=e;this.nextChar();this.strBuf=[]}nextChar(){return this.currentChar=this.stream.getByte()}getToken(){let e=!1,t=this.currentChar;for(;;){if(t<0)return a.EOF;if(e)10!==t&&13!==t||(e=!1);else if(37===t)e=!0;else if(!(0,i.isWhiteSpace)(t))break;t=this.nextChar()}switch(0|t){case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:case 43:case 45:case 46:return new PostScriptToken(s.NUMBER,this.getNumber());case 123:this.nextChar();return PostScriptToken.LBRACE;case 125:this.nextChar();return PostScriptToken.RBRACE}const r=this.strBuf;r.length=0;r[0]=String.fromCharCode(t);for(;(t=this.nextChar())>=0&&(t>=65&&t<=90||t>=97&&t<=122);)r.push(String.fromCharCode(t));const n=r.join("");switch(n.toLowerCase()){case"if":return PostScriptToken.IF;case"ifelse":return PostScriptToken.IFELSE;default:return PostScriptToken.getOperator(n)}}getNumber(){let e=this.currentChar;const t=this.strBuf;t.length=0;t[0]=String.fromCharCode(e);for(;(e=this.nextChar())>=0&&(e>=48&&e<=57||45===e||46===e);)t.push(String.fromCharCode(e));const r=parseFloat(t.join(""));if(isNaN(r))throw new n.FormatError("Invalid floating point number: ".concat(r));return r}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.LocalTilingPatternCache=t.LocalImageCache=t.LocalGStateCache=t.LocalFunctionCache=t.LocalColorSpaceCache=t.GlobalImageCache=void 0;r(112);var n=r(158),a=r(209);class BaseLocalCache{constructor(e){this.constructor===BaseLocalCache&&(0,n.unreachable)("Cannot initialize BaseLocalCache.");this._onlyRefs=!0===(e&&e.onlyRefs);if(!this._onlyRefs){this._nameRefMap=new Map;this._imageMap=new Map}this._imageCache=new a.RefSetCache}getByName(e){this._onlyRefs&&(0,n.unreachable)("Should not call `getByName` method.");const t=this._nameRefMap.get(e);return t?this.getByRef(t):this._imageMap.get(e)||null}getByRef(e){return this._imageCache.get(e)||null}set(e,t,r){(0,n.unreachable)("Abstract method `set` called.")}}t.LocalImageCache=class LocalImageCache extends BaseLocalCache{set(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=arguments.length>2?arguments[2]:void 0;if("string"!=typeof e)throw new Error('LocalImageCache.set - expected "name" argument.');if(t){if(this._imageCache.has(t))return;this._nameRefMap.set(e,t);this._imageCache.put(t,r)}else this._imageMap.has(e)||this._imageMap.set(e,r)}};t.LocalColorSpaceCache=class LocalColorSpaceCache extends BaseLocalCache{set(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null,t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=arguments.length>2?arguments[2]:void 0;if("string"!=typeof e&&!t)throw new Error('LocalColorSpaceCache.set - expected "name" and/or "ref" argument.');if(t){if(this._imageCache.has(t))return;null!==e&&this._nameRefMap.set(e,t);this._imageCache.put(t,r)}else this._imageMap.has(e)||this._imageMap.set(e,r)}};t.LocalFunctionCache=class LocalFunctionCache extends BaseLocalCache{constructor(e){super({onlyRefs:!0})}set(){let e=arguments.length>1?arguments[1]:void 0,t=arguments.length>2?arguments[2]:void 0;if(!e)throw new Error('LocalFunctionCache.set - expected "ref" argument.');this._imageCache.has(e)||this._imageCache.put(e,t)}};t.LocalGStateCache=class LocalGStateCache extends BaseLocalCache{set(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=arguments.length>2?arguments[2]:void 0;if("string"!=typeof e)throw new Error('LocalGStateCache.set - expected "name" argument.');if(t){if(this._imageCache.has(t))return;this._nameRefMap.set(e,t);this._imageCache.put(t,r)}else this._imageMap.has(e)||this._imageMap.set(e,r)}};t.LocalTilingPatternCache=class LocalTilingPatternCache extends BaseLocalCache{constructor(e){super({onlyRefs:!0})}set(){let e=arguments.length>1?arguments[1]:void 0,t=arguments.length>2?arguments[2]:void 0;if(!e)throw new Error('LocalTilingPatternCache.set - expected "ref" argument.');this._imageCache.has(e)||this._imageCache.put(e,t)}};class GlobalImageCache{static get NUM_PAGES_THRESHOLD(){return(0,n.shadow)(this,"NUM_PAGES_THRESHOLD",2)}static get MIN_IMAGES_TO_CACHE(){return(0,n.shadow)(this,"MIN_IMAGES_TO_CACHE",10)}static get MAX_BYTE_SIZE(){return(0,n.shadow)(this,"MAX_BYTE_SIZE",4e7)}constructor(){this._refCache=new a.RefSetCache;this._imageCache=new a.RefSetCache}get _byteSize(){let e=0;for(const t of this._imageCache)e+=t.byteSize;return e}get _cacheLimitReached(){return!(this._imageCache.size<GlobalImageCache.MIN_IMAGES_TO_CACHE)&&!(this._byteSize<GlobalImageCache.MAX_BYTE_SIZE)}shouldCache(e,t){const r=this._refCache.get(e);return!((r?r.size+(r.has(t)?0:1):1)<GlobalImageCache.NUM_PAGES_THRESHOLD)&&!(!this._imageCache.has(e)&&this._cacheLimitReached)}addPageIndex(e,t){let r=this._refCache.get(e);if(!r){r=new Set;this._refCache.put(e,r)}r.add(t)}addByteSize(e,t){const r=this._imageCache.get(e);r&&(r.byteSize||(r.byteSize=t))}getData(e,t){const r=this._refCache.get(e);if(!r)return null;if(r.size<GlobalImageCache.NUM_PAGES_THRESHOLD)return null;const n=this._imageCache.get(e);if(!n)return null;r.add(t);return n}setData(e,t){if(!this._refCache.has(e))throw new Error('GlobalImageCache.setData - expected "addPageIndex" to have been called.');this._imageCache.has(e)||(this._cacheLimitReached?(0,n.warn)("GlobalImageCache.setData - cache limit reached."):this._imageCache.put(e,t))}clear(){arguments.length>0&&void 0!==arguments[0]&&arguments[0]||this._refCache.clear();this._imageCache.clear()}}t.GlobalImageCache=GlobalImageCache},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.bidi=function bidi(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:-1,r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],c=!0;const l=e.length;if(0===l||r)return createBidiText(e,c,r);s.length=l;o.length=l;let h,u,d=0;for(h=0;h<l;++h){s[h]=e.charAt(h);const t=e.charCodeAt(h);let r="L";if(t<=255)r=a[t];else if(1424<=t&&t<=1524)r="R";else if(1536<=t&&t<=1791){r=i[255&t];r||(0,n.warn)("Bidi: invalid Unicode character "+t.toString(16))}else 1792<=t&&t<=2220&&(r="AL");"R"!==r&&"AL"!==r&&"AN"!==r||d++;o[h]=r}if(0===d){c=!0;return createBidiText(e,c)}if(-1===t)if(d/l<.3&&l>4){c=!0;t=0}else{c=!1;t=1}const f=[];for(h=0;h<l;++h)f[h]=t;const g=isOdd(t)?"R":"L",p=g,m=p;let b,y=p;for(h=0;h<l;++h)"NSM"===o[h]?o[h]=y:y=o[h];y=p;for(h=0;h<l;++h){b=o[h];"EN"===b?o[h]="AL"===y?"AN":"EN":"R"!==b&&"L"!==b&&"AL"!==b||(y=b)}for(h=0;h<l;++h){b=o[h];"AL"===b&&(o[h]="R")}for(h=1;h<l-1;++h){"ES"===o[h]&&"EN"===o[h-1]&&"EN"===o[h+1]&&(o[h]="EN");"CS"!==o[h]||"EN"!==o[h-1]&&"AN"!==o[h-1]||o[h+1]!==o[h-1]||(o[h]=o[h-1])}for(h=0;h<l;++h)if("EN"===o[h]){for(let e=h-1;e>=0&&"ET"===o[e];--e)o[e]="EN";for(let e=h+1;e<l&&"ET"===o[e];++e)o[e]="EN"}for(h=0;h<l;++h){b=o[h];"WS"!==b&&"ES"!==b&&"ET"!==b&&"CS"!==b||(o[h]="ON")}y=p;for(h=0;h<l;++h){b=o[h];"EN"===b?o[h]="L"===y?"L":"EN":"R"!==b&&"L"!==b||(y=b)}for(h=0;h<l;++h)if("ON"===o[h]){const e=findUnequal(o,h+1,"ON");let t=p;h>0&&(t=o[h-1]);let r=m;e+1<l&&(r=o[e+1]);"L"!==t&&(t="R");"L"!==r&&(r="R");t===r&&setValues(o,h,e,t);h=e-1}for(h=0;h<l;++h)"ON"===o[h]&&(o[h]=g);for(h=0;h<l;++h){b=o[h];isEven(f[h])?"R"===b?f[h]+=1:"AN"!==b&&"EN"!==b||(f[h]+=2):"L"!==b&&"AN"!==b&&"EN"!==b||(f[h]+=1)}let w,S=-1,x=99;for(h=0,u=f.length;h<u;++h){w=f[h];S<w&&(S=w);x>w&&isOdd(w)&&(x=w)}for(w=S;w>=x;--w){let e=-1;for(h=0,u=f.length;h<u;++h)if(f[h]<w){if(e>=0){reverseValues(s,e,h);e=-1}}else e<0&&(e=h);e>=0&&reverseValues(s,e,f.length)}for(h=0,u=s.length;h<u;++h){const e=s[h];"<"!==e&&">"!==e||(s[h]="")}return createBidiText(s.join(""),c)};var n=r(158);const a=["BN","BN","BN","BN","BN","BN","BN","BN","BN","S","B","S","WS","B","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","B","B","B","S","WS","ON","ON","ET","ET","ET","ON","ON","ON","ON","ON","ES","CS","ES","CS","CS","EN","EN","EN","EN","EN","EN","EN","EN","EN","EN","CS","ON","ON","ON","ON","ON","ON","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","ON","ON","ON","ON","ON","ON","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","ON","ON","ON","ON","BN","BN","BN","BN","BN","BN","B","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","CS","ON","ET","ET","ET","ET","ON","ON","ON","ON","L","ON","ON","BN","ON","ON","ET","ET","EN","EN","ON","L","ON","ON","ON","EN","L","ON","ON","ON","ON","ON","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","ON","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","ON","L","L","L","L","L","L","L","L"],i=["AN","AN","AN","AN","AN","AN","ON","ON","AL","ET","ET","AL","CS","AL","ON","ON","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","AL","AL","","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","AN","AN","AN","AN","AN","AN","AN","AN","AN","AN","ET","AN","AN","AL","AL","AL","NSM","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","NSM","NSM","NSM","NSM","NSM","NSM","NSM","AN","ON","NSM","NSM","NSM","NSM","NSM","NSM","AL","AL","NSM","NSM","ON","NSM","NSM","NSM","NSM","AL","AL","EN","EN","EN","EN","EN","EN","EN","EN","EN","EN","AL","AL","AL","AL","AL","AL"];function isOdd(e){return 0!=(1&e)}function isEven(e){return 0==(1&e)}function findUnequal(e,t,r){let n,a;for(n=t,a=e.length;n<a;++n)if(e[n]!==r)return n;return n}function setValues(e,t,r,n){for(let a=t;a<r;++a)e[a]=n}function reverseValues(e,t,r){for(let n=t,a=r-1;n<a;++n,--a){const t=e[n];e[n]=e[a];e[a]=t}}function createBidiText(e,t){let r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n="ltr";r?n="ttb":t||(n="rtl");return{str:e,dir:n}}const s=[],o=[]},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.MurmurHash3_64=void 0;r(125);r(146);r(148);r(149);r(178);var n=r(158);const a=3285377520,i=4294901760,s=65535;t.MurmurHash3_64=class MurmurHash3_64{constructor(e){this.h1=e?4294967295&e:a;this.h2=e?4294967295&e:a}update(e){let t,r;if("string"==typeof e){t=new Uint8Array(2*e.length);r=0;for(let n=0,a=e.length;n<a;n++){const a=e.charCodeAt(n);if(a<=255)t[r++]=a;else{t[r++]=a>>>8;t[r++]=255&a}}}else{if(!(0,n.isArrayBuffer)(e))throw new Error("Wrong data format in MurmurHash3_64_update. Input must be a string or array.");t=e.slice();r=t.byteLength}const a=r>>2,o=r-4*a,c=new Uint32Array(t.buffer,0,a);let l=0,h=0,u=this.h1,d=this.h2;const f=3432918353,g=461845907,p=11601,m=13715;for(let e=0;e<a;e++)if(1&e){l=c[e];l=l*f&i|l*p&s;l=l<<15|l>>>17;l=l*g&i|l*m&s;u^=l;u=u<<13|u>>>19;u=5*u+3864292196}else{h=c[e];h=h*f&i|h*p&s;h=h<<15|h>>>17;h=h*g&i|h*m&s;d^=h;d=d<<13|d>>>19;d=5*d+3864292196}l=0;switch(o){case 3:l^=t[4*a+2]<<16;case 2:l^=t[4*a+1]<<8;case 1:l^=t[4*a];l=l*f&i|l*p&s;l=l<<15|l>>>17;l=l*g&i|l*m&s;1&a?u^=l:d^=l}this.h1=u;this.h2=d}hexdigest(){let e=this.h1,t=this.h2;e^=t>>>1;e=3981806797*e&i|36045*e&s;t=4283543511*t&i|(2950163797*(t<<16|e>>>16)&i)>>>16;e^=t>>>1;e=444984403*e&i|60499*e&s;t=3301882366*t&i|(3120437893*(t<<16|e>>>16)&i)>>>16;e^=t>>>1;const r=(e>>>0).toString(16),n=(t>>>0).toString(16);return r.padStart(8,"0")+n.padStart(8,"0")}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.OperatorList=void 0;r(125);r(146);r(148);r(149);r(236);r(159);r(112);r(2);var n=r(158);function addState(e,t,r,n,a){let i=e;for(let e=0,r=t.length-1;e<r;e++){const r=t[e];i=i[r]||(i[r]=[])}i[t.at(-1)]={checkFn:r,iterateFn:n,processFn:a}}const a=[];addState(a,[n.OPS.save,n.OPS.transform,n.OPS.paintInlineImageXObject,n.OPS.restore],null,(function iterateInlineImageGroup(e,t){const r=e.fnArray,a=(t-(e.iCurr-3))%4;switch(a){case 0:return r[t]===n.OPS.save;case 1:return r[t]===n.OPS.transform;case 2:return r[t]===n.OPS.paintInlineImageXObject;case 3:return r[t]===n.OPS.restore}throw new Error("iterateInlineImageGroup - invalid pos: ".concat(a))}),(function foundInlineImageGroup(e,t){const r=e.fnArray,a=e.argsArray,i=e.iCurr,s=i-3,o=i-2,c=i-1,l=Math.min(Math.floor((t-s)/4),200);if(l<10)return t-(t-s)%4;let h=0;const u=[];let d=0,f=1,g=1;for(let e=0;e<l;e++){const t=a[o+(e<<2)],r=a[c+(e<<2)][0];if(f+r.width>1e3){h=Math.max(h,f);g+=d+2;f=0;d=0}u.push({transform:t,x:f,y:g,w:r.width,h:r.height});f+=r.width+2;d=Math.max(d,r.height)}const p=Math.max(h,f)+1,m=g+d+1,b=new Uint8Array(p*m*4),y=p<<2;for(let e=0;e<l;e++){const t=a[c+(e<<2)][0].data,r=u[e].w<<2;let n=0,i=u[e].x+u[e].y*p<<2;b.set(t.subarray(0,r),i-y);for(let a=0,s=u[e].h;a<s;a++){b.set(t.subarray(n,n+r),i);n+=r;i+=y}b.set(t.subarray(n-r,n),i);for(;i>=0;){t[i-4]=t[i];t[i-3]=t[i+1];t[i-2]=t[i+2];t[i-1]=t[i+3];t[i+r]=t[i+r-4];t[i+r+1]=t[i+r-3];t[i+r+2]=t[i+r-2];t[i+r+3]=t[i+r-1];i-=y}}r.splice(s,4*l,n.OPS.paintInlineImageXObjectGroup);a.splice(s,4*l,[{width:p,height:m,kind:n.ImageKind.RGBA_32BPP,data:b},u]);return s+1}));addState(a,[n.OPS.save,n.OPS.transform,n.OPS.paintImageMaskXObject,n.OPS.restore],null,(function iterateImageMaskGroup(e,t){const r=e.fnArray,a=(t-(e.iCurr-3))%4;switch(a){case 0:return r[t]===n.OPS.save;case 1:return r[t]===n.OPS.transform;case 2:return r[t]===n.OPS.paintImageMaskXObject;case 3:return r[t]===n.OPS.restore}throw new Error("iterateImageMaskGroup - invalid pos: ".concat(a))}),(function foundImageMaskGroup(e,t){const r=e.fnArray,a=e.argsArray,i=e.iCurr,s=i-3,o=i-2,c=i-1;let l=Math.floor((t-s)/4);if(l<10)return t-(t-s)%4;let h,u,d=!1;const f=a[c][0],g=a[o][0],p=a[o][1],m=a[o][2],b=a[o][3];if(p===m){d=!0;h=o+4;let e=c+4;for(let t=1;t<l;t++,h+=4,e+=4){u=a[h];if(a[e][0]!==f||u[0]!==g||u[1]!==p||u[2]!==m||u[3]!==b){t<10?d=!1:l=t;break}}}if(d){l=Math.min(l,1e3);const e=new Float32Array(2*l);h=o;for(let t=0;t<l;t++,h+=4){u=a[h];e[t<<1]=u[4];e[1+(t<<1)]=u[5]}r.splice(s,4*l,n.OPS.paintImageMaskXObjectRepeat);a.splice(s,4*l,[f,g,p,m,b,e])}else{l=Math.min(l,100);const e=[];for(let t=0;t<l;t++){u=a[o+(t<<2)];const r=a[c+(t<<2)][0];e.push({data:r.data,width:r.width,height:r.height,interpolate:r.interpolate,count:r.count,transform:u})}r.splice(s,4*l,n.OPS.paintImageMaskXObjectGroup);a.splice(s,4*l,[e])}return s+1}));addState(a,[n.OPS.save,n.OPS.transform,n.OPS.paintImageXObject,n.OPS.restore],(function(e){const t=e.argsArray,r=e.iCurr-2;return 0===t[r][1]&&0===t[r][2]}),(function iterateImageGroup(e,t){const r=e.fnArray,a=e.argsArray,i=(t-(e.iCurr-3))%4;switch(i){case 0:return r[t]===n.OPS.save;case 1:if(r[t]!==n.OPS.transform)return!1;const i=e.iCurr-2,s=a[i][0],o=a[i][3];return a[t][0]===s&&0===a[t][1]&&0===a[t][2]&&a[t][3]===o;case 2:if(r[t]!==n.OPS.paintImageXObject)return!1;const c=a[e.iCurr-1][0];return a[t][0]===c;case 3:return r[t]===n.OPS.restore}throw new Error("iterateImageGroup - invalid pos: ".concat(i))}),(function(e,t){const r=e.fnArray,a=e.argsArray,i=e.iCurr,s=i-3,o=i-2,c=a[i-1][0],l=a[o][0],h=a[o][3],u=Math.min(Math.floor((t-s)/4),1e3);if(u<3)return t-(t-s)%4;const d=new Float32Array(2*u);let f=o;for(let e=0;e<u;e++,f+=4){const t=a[f];d[e<<1]=t[4];d[1+(e<<1)]=t[5]}const g=[c,l,h,d];r.splice(s,4*u,n.OPS.paintImageXObjectRepeat);a.splice(s,4*u,g);return s+1}));addState(a,[n.OPS.beginText,n.OPS.setFont,n.OPS.setTextMatrix,n.OPS.showText,n.OPS.endText],null,(function iterateShowTextGroup(e,t){const r=e.fnArray,a=e.argsArray,i=(t-(e.iCurr-4))%5;switch(i){case 0:return r[t]===n.OPS.beginText;case 1:return r[t]===n.OPS.setFont;case 2:return r[t]===n.OPS.setTextMatrix;case 3:if(r[t]!==n.OPS.showText)return!1;const i=e.iCurr-3,s=a[i][0],o=a[i][1];return a[t][0]===s&&a[t][1]===o;case 4:return r[t]===n.OPS.endText}throw new Error("iterateShowTextGroup - invalid pos: ".concat(i))}),(function(e,t){const r=e.fnArray,n=e.argsArray,a=e.iCurr,i=a-4,s=a-3,o=a-2,c=a-1,l=a,h=n[s][0],u=n[s][1];let d=Math.min(Math.floor((t-i)/5),1e3);if(d<3)return t-(t-i)%5;let f=i;if(i>=4&&r[i-4]===r[s]&&r[i-3]===r[o]&&r[i-2]===r[c]&&r[i-1]===r[l]&&n[i-4][0]===h&&n[i-4][1]===u){d++;f-=5}let g=f+4;for(let e=1;e<d;e++){r.splice(g,3);n.splice(g,3);g+=2}return g+1}));class NullOptimizer{constructor(e){this.queue=e}_optimize(){}push(e,t){this.queue.fnArray.push(e);this.queue.argsArray.push(t);this._optimize()}flush(){}reset(){}}class QueueOptimizer extends NullOptimizer{constructor(e){super(e);this.state=null;this.context={iCurr:0,fnArray:e.fnArray,argsArray:e.argsArray};this.match=null;this.lastProcessed=0}_optimize(){const e=this.queue.fnArray;let t=this.lastProcessed,r=e.length,n=this.state,i=this.match;if(!n&&!i&&t+1===r&&!a[e[t]]){this.lastProcessed=r;return}const s=this.context;for(;t<r;){if(i){if((0,i.iterateFn)(s,t)){t++;continue}t=(0,i.processFn)(s,t+1);r=e.length;i=null;n=null;if(t>=r)break}n=(n||a)[e[t]];if(n&&!Array.isArray(n)){s.iCurr=t;t++;if(!n.checkFn||(0,n.checkFn)(s)){i=n;n=null}else n=null}else t++}this.state=n;this.match=i;this.lastProcessed=t}flush(){for(;this.match;){const e=this.queue.fnArray.length;this.lastProcessed=(0,this.match.processFn)(this.context,e);this.match=null;this.state=null;this._optimize()}}reset(){this.state=null;this.match=null;this.lastProcessed=0}}class OperatorList{static get CHUNK_SIZE(){return(0,n.shadow)(this,"CHUNK_SIZE",1e3)}static get CHUNK_SIZE_ABOUT(){return(0,n.shadow)(this,"CHUNK_SIZE_ABOUT",this.CHUNK_SIZE-5)}constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:0,t=arguments.length>1?arguments[1]:void 0;this._streamSink=t;this.fnArray=[];this.argsArray=[];!t||e&n.RenderingIntentFlag.OPLIST?this.optimizer=new NullOptimizer(this):this.optimizer=new QueueOptimizer(this);this.dependencies=new Set;this._totalLength=0;this.weight=0;this._resolved=t?null:Promise.resolve()}get length(){return this.argsArray.length}get ready(){return this._resolved||this._streamSink.ready}get totalLength(){return this._totalLength+this.length}addOp(e,t){this.optimizer.push(e,t);this.weight++;this._streamSink&&(this.weight>=OperatorList.CHUNK_SIZE||this.weight>=OperatorList.CHUNK_SIZE_ABOUT&&(e===n.OPS.restore||e===n.OPS.endText))&&this.flush()}addImageOps(e,t,r){void 0!==r&&this.addOp(n.OPS.beginMarkedContentProps,["OC",r]);this.addOp(e,t);void 0!==r&&this.addOp(n.OPS.endMarkedContent,[])}addDependency(e){if(!this.dependencies.has(e)){this.dependencies.add(e);this.addOp(n.OPS.dependency,[e])}}addDependencies(e){for(const t of e)this.addDependency(t)}addOpList(e){if(e instanceof OperatorList){for(const t of e.dependencies)this.dependencies.add(t);for(let t=0,r=e.length;t<r;t++)this.addOp(e.fnArray[t],e.argsArray[t])}else(0,n.warn)('addOpList - ignoring invalid "opList" parameter.')}getIR(){return{fnArray:this.fnArray,argsArray:this.argsArray,length:this.length}}get _transfers(){const e=[],{fnArray:t,argsArray:r,length:a}=this;for(let i=0;i<a;i++)switch(t[i]){case n.OPS.paintInlineImageXObject:case n.OPS.paintInlineImageXObjectGroup:case n.OPS.paintImageMaskXObject:const t=r[i][0];!t.cached&&t.data&&t.data.buffer instanceof ArrayBuffer&&e.push(t.data.buffer)}return e}flush(){let e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];this.optimizer.flush();const t=this.length;this._totalLength+=t;this._streamSink.enqueue({fnArray:this.fnArray,argsArray:this.argsArray,lastChunk:e,length:t},1,this._transfers);this.dependencies.clear();this.fnArray.length=0;this.argsArray.length=0;this.weight=0;this.optimizer.reset()}}t.OperatorList=OperatorList},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.PDFImage=void 0;r(125);r(146);r(148);r(149);r(235);r(178);r(2);r(232);var n=r(158),a=r(281),i=r(217),s=r(234),o=r(242),c=r(252),l=r(256),h=r(209);function decodeAndClamp(e,t,r,n){(e=t+e*r)<0?e=0:e>n&&(e=n);return e}function resizeImageMask(e,t,r,n,a,i){const s=a*i;let o;o=t<=8?new Uint8Array(s):t<=16?new Uint16Array(s):new Uint32Array(s);const c=r/a,l=n/i;let h,u,d,f,g=0;const p=new Uint16Array(a),m=r;for(h=0;h<a;h++)p[h]=Math.floor(h*c);for(h=0;h<i;h++){d=Math.floor(h*l)*m;for(u=0;u<a;u++){f=d+p[u];o[g++]=e[f]}}return o}class PDFImage{constructor(e){let{xref:t,res:r,image:a,isInline:o=!1,smask:c=null,mask:u=null,isMask:d=!1,pdfFunctionFactory:f,localColorSpaceCache:g}=e;this.image=a;const p=a.dict,m=p.get("F","Filter");if(m instanceof h.Name)switch(m.name){case"JPXDecode":const e=new l.JpxImage;e.parseImageProperties(a.stream);a.stream.reset();a.width=e.width;a.height=e.height;a.bitsPerComponent=e.bitsPerComponent;a.numComps=e.componentsCount;break;case"JBIG2Decode":a.bitsPerComponent=1;a.numComps=1}let b=p.get("W","Width"),y=p.get("H","Height");if(Number.isInteger(a.width)&&a.width>0&&Number.isInteger(a.height)&&a.height>0&&(a.width!==b||a.height!==y)){(0,n.warn)("PDFImage - using the Width/Height of the image data, rather than the image dictionary.");b=a.width;y=a.height}if(b<1||y<1)throw new n.FormatError("Invalid image width: ".concat(b," or height: ").concat(y));this.width=b;this.height=y;this.interpolate=p.get("I","Interpolate");this.imageMask=p.get("IM","ImageMask")||!1;this.matte=p.get("Matte")||!1;let w=a.bitsPerComponent;if(!w){w=p.get("BPC","BitsPerComponent");if(!w){if(!this.imageMask)throw new n.FormatError("Bits per component missing in image: ".concat(this.imageMask));w=1}}this.bpc=w;if(!this.imageMask){let e=p.getRaw("CS")||p.getRaw("ColorSpace");if(!e){(0,n.info)("JPX images (which do not require color spaces)");switch(a.numComps){case 1:e=h.Name.get("DeviceGray");break;case 3:e=h.Name.get("DeviceRGB");break;case 4:e=h.Name.get("DeviceCMYK");break;default:throw new Error("JPX images with ".concat(a.numComps," color components not supported."))}}this.colorSpace=s.ColorSpace.parse({cs:e,xref:t,resources:o?r:null,pdfFunctionFactory:f,localColorSpaceCache:g});this.numComps=this.colorSpace.numComps}this.decode=p.getArray("D","Decode");this.needsDecode=!1;if(this.decode&&(this.colorSpace&&!this.colorSpace.isDefaultDecode(this.decode,w)||d&&!s.ColorSpace.isDefaultDecode(this.decode,1))){this.needsDecode=!0;const e=(1<<w)-1;this.decodeCoefficients=[];this.decodeAddends=[];const t=this.colorSpace&&"Indexed"===this.colorSpace.name;for(let r=0,n=0;r<this.decode.length;r+=2,++n){const a=this.decode[r],i=this.decode[r+1];this.decodeCoefficients[n]=t?(i-a)/e:i-a;this.decodeAddends[n]=t?a:e*a}}if(c)this.smask=new PDFImage({xref:t,res:r,image:c,isInline:o,pdfFunctionFactory:f,localColorSpaceCache:g});else if(u)if(u instanceof i.BaseStream){u.dict.get("IM","ImageMask")?this.mask=new PDFImage({xref:t,res:r,image:u,isInline:o,isMask:!0,pdfFunctionFactory:f,localColorSpaceCache:g}):(0,n.warn)("Ignoring /Mask in image without /ImageMask.")}else this.mask=u}static async buildImage(e){let{xref:t,res:r,image:a,isInline:s=!1,pdfFunctionFactory:o,localColorSpaceCache:c}=e;const l=a;let h=null,u=null;const d=a.dict.get("SMask"),f=a.dict.get("Mask");d?d instanceof i.BaseStream?h=d:(0,n.warn)("Unsupported /SMask format."):f&&(f instanceof i.BaseStream||Array.isArray(f)?u=f:(0,n.warn)("Unsupported /Mask format."));return new PDFImage({xref:t,res:r,image:l,isInline:s,smask:h,mask:u,pdfFunctionFactory:o,localColorSpaceCache:c})}static createRawMask(e){let{imgArray:t,width:r,height:n,imageIsFromDecodeStream:a,inverseDecode:i,interpolate:s}=e;const o=(r+7>>3)*n,c=t.byteLength;let l,h;if(!a||i&&!(o===c))if(i){l=new Uint8Array(o);l.set(t);l.fill(255,c)}else l=new Uint8Array(t);else l=t;if(i)for(h=0;h<c;h++)l[h]^=255;return{data:l,width:r,height:n,interpolate:s}}static createMask(e){let{imgArray:t,width:r,height:i,imageIsFromDecodeStream:s,inverseDecode:o,interpolate:c}=e;const l=1===r&&1===i&&o===(0===t.length||!!(128&t[0]));if(l)return{isSingleOpaquePixel:l};if(n.FeatureTest.isOffscreenCanvasSupported){const e=new OffscreenCanvas(r,i),n=e.getContext("2d"),s=n.createImageData(r,i);(0,a.applyMaskImageData)({src:t,dest:s.data,width:r,height:i,inverseDecode:o});n.putImageData(s,0,0);return{data:null,width:r,height:i,interpolate:c,bitmap:e.transferToImageBitmap()}}return this.createRawMask({imgArray:t,width:r,height:i,inverseDecode:o,imageIsFromDecodeStream:s,interpolate:c})}get drawWidth(){return Math.max(this.width,this.smask&&this.smask.width||0,this.mask&&this.mask.width||0)}get drawHeight(){return Math.max(this.height,this.smask&&this.smask.height||0,this.mask&&this.mask.height||0)}decodeBuffer(e){const t=this.bpc,r=this.numComps,n=this.decodeAddends,a=this.decodeCoefficients,i=(1<<t)-1;let s,o;if(1===t){for(s=0,o=e.length;s<o;s++)e[s]=+!e[s];return}let c=0;for(s=0,o=this.width*this.height;s<o;s++)for(let t=0;t<r;t++){e[c]=decodeAndClamp(e[c],n[t],a[t],i);c++}}getComponents(e){const t=this.bpc;if(8===t)return e;const r=this.width,n=this.height,a=this.numComps,i=r*n*a;let s,o=0;s=t<=8?new Uint8Array(i):t<=16?new Uint16Array(i):new Uint32Array(i);const c=r*a,l=(1<<t)-1;let h,u,d=0;if(1===t){let t,r,a;for(let i=0;i<n;i++){r=d+(-8&c);a=d+c;for(;d<r;){u=e[o++];s[d]=u>>7&1;s[d+1]=u>>6&1;s[d+2]=u>>5&1;s[d+3]=u>>4&1;s[d+4]=u>>3&1;s[d+5]=u>>2&1;s[d+6]=u>>1&1;s[d+7]=1&u;d+=8}if(d<a){u=e[o++];t=128;for(;d<a;){s[d++]=+!!(u&t);t>>=1}}}}else{let r=0;u=0;for(d=0,h=i;d<h;++d){if(d%c==0){u=0;r=0}for(;r<t;){u=u<<8|e[o++];r+=8}const n=r-t;let a=u>>n;a<0?a=0:a>l&&(a=l);s[d]=a;u&=(1<<n)-1;r=n}}return s}fillOpacity(e,t,r,a,i){const s=this.smask,o=this.mask;let c,l,h,u,d,f;if(s){l=s.width;h=s.height;c=new Uint8ClampedArray(l*h);s.fillGrayBuffer(c);l===t&&h===r||(c=resizeImageMask(c,s.bpc,l,h,t,r))}else if(o)if(o instanceof PDFImage){l=o.width;h=o.height;c=new Uint8ClampedArray(l*h);o.numComps=1;o.fillGrayBuffer(c);for(u=0,d=l*h;u<d;++u)c[u]=255-c[u];l===t&&h===r||(c=resizeImageMask(c,o.bpc,l,h,t,r))}else{if(!Array.isArray(o))throw new n.FormatError("Unknown mask format.");{c=new Uint8ClampedArray(t*r);const e=this.numComps;for(u=0,d=t*r;u<d;++u){let t=0;const r=u*e;for(f=0;f<e;++f){const e=i[r+f],n=2*f;if(e<o[n]||e>o[n+1]){t=255;break}}c[u]=t}}}if(c)for(u=0,f=3,d=t*a;u<d;++u,f+=4)e[f]=c[u];else for(u=0,f=3,d=t*a;u<d;++u,f+=4)e[f]=255}undoPreblend(e,t,r){const n=this.smask&&this.smask.matte;if(!n)return;const a=this.colorSpace.getRgb(n,0),i=a[0],s=a[1],o=a[2],c=t*r*4;for(let t=0;t<c;t+=4){const r=e[t+3];if(0===r){e[t]=255;e[t+1]=255;e[t+2]=255;continue}const n=255/r;e[t]=(e[t]-i)*n+i;e[t+1]=(e[t+1]-s)*n+s;e[t+2]=(e[t+2]-o)*n+o}}createImageData(){let e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];const t=this.drawWidth,r=this.drawHeight,a={width:t,height:r,interpolate:this.interpolate,kind:0,data:null},i=this.numComps,s=this.width,o=this.height,l=this.bpc,h=s*i*l+7>>3;if(!e){let e;"DeviceGray"===this.colorSpace.name&&1===l?e=n.ImageKind.GRAYSCALE_1BPP:"DeviceRGB"!==this.colorSpace.name||8!==l||this.needsDecode||(e=n.ImageKind.RGB_24BPP);if(e&&!this.smask&&!this.mask&&t===s&&r===o){a.kind=e;a.data=this.getImageBytes(o*h,{});if(this.needsDecode){(0,n.assert)(e===n.ImageKind.GRAYSCALE_1BPP,"PDFImage.createImageData: The image must be grayscale.");const t=a.data;for(let e=0,r=t.length;e<r;e++)t[e]^=255}return a}if(this.image instanceof c.JpegStream&&!this.smask&&!this.mask){let e=o*h;switch(this.colorSpace.name){case"DeviceGray":e*=3;case"DeviceRGB":case"DeviceCMYK":a.kind=n.ImageKind.RGB_24BPP;a.data=this.getImageBytes(e,{drawWidth:t,drawHeight:r,forceRGB:!0});return a}}}const u=this.getImageBytes(o*h,{internal:!0}),d=0|u.length/h*r/o,f=this.getComponents(u);let g,p;if(e||this.smask||this.mask){a.kind=n.ImageKind.RGBA_32BPP;a.data=new Uint8ClampedArray(t*r*4);g=1;p=!0;this.fillOpacity(a.data,t,r,d,f)}else{a.kind=n.ImageKind.RGB_24BPP;a.data=new Uint8ClampedArray(t*r*3);g=0;p=!1}this.needsDecode&&this.decodeBuffer(f);this.colorSpace.fillRgb(a.data,s,o,t,r,d,l,f,g);p&&this.undoPreblend(a.data,t,d);return a}fillGrayBuffer(e){const t=this.numComps;if(1!==t)throw new n.FormatError("Reading gray scale from a color image: ".concat(t));const r=this.width,a=this.height,i=this.bpc,s=r*t*i+7>>3,o=this.getImageBytes(a*s,{internal:!0}),c=this.getComponents(o);let l,h;if(1===i){h=r*a;if(this.needsDecode)for(l=0;l<h;++l)e[l]=c[l]-1&255;else for(l=0;l<h;++l)e[l]=255&-c[l];return}this.needsDecode&&this.decodeBuffer(c);h=r*a;const u=255/((1<<i)-1);for(l=0;l<h;++l)e[l]=u*c[l]}getImageBytes(e,t){let{drawWidth:r,drawHeight:a,forceRGB:i=!1,internal:s=!1}=t;this.image.reset();this.image.drawWidth=r||this.width;this.image.drawHeight=a||this.height;this.image.forceRGB=!!i;const c=this.image.getBytes(e);if(s||this.image instanceof o.DecodeStream)return c;(0,n.assert)(c instanceof Uint8Array,'PDFImage.getImageBytes: Unsupported "imageBytes" type.');return new Uint8Array(c)}}t.PDFImage=PDFImage},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.applyMaskImageData=function applyMaskImageData(e){let{src:t,srcPos:r=0,dest:a,destPos:i=0,width:s,height:o,inverseDecode:c=!1}=e;const l=n.FeatureTest.isLittleEndian?4278190080:255,[h,u]=c?[0,l]:[l,0],d=s>>3,f=7&s,g=t.length;a=new Uint32Array(a.buffer);for(let e=0;e<o;e++){for(const e=r+d;r<e;r++){const e=r<g?t[r]:255;a[i++]=128&e?u:h;a[i++]=64&e?u:h;a[i++]=32&e?u:h;a[i++]=16&e?u:h;a[i++]=8&e?u:h;a[i++]=4&e?u:h;a[i++]=2&e?u:h;a[i++]=1&e?u:h}if(0===f)continue;const e=r<g?t[r++]:255;for(let t=0;t<f;t++)a[i++]=e&1<<7-t?u:h}return{srcPos:r,destPos:i}};r(112);r(178);r(146);r(148);r(149);var n=r(158)},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.incrementalUpdate=function incrementalUpdate(e){let{originalData:t,xrefInfo:r,newRefs:o,xref:l=null,hasXfa:h=!1,xfaDatasetsRef:u=null,hasXfaDatasetsEntry:d=!1,acroFormRef:f=null,acroForm:g=null,xfaData:p=null}=e;h&&function updateXFA(e){let{xfaData:t,xfaDatasetsRef:r,hasXfaDatasetsEntry:a,acroFormRef:o,acroForm:c,newRefs:l,xref:h,xrefInfo:u}=e;if(null===h)return;if(!a){if(!o){(0,n.warn)("XFA - Cannot save it");return}const e=c.get("XFA"),t=e.slice();t.splice(2,0,"datasets");t.splice(3,0,r);c.set("XFA",t);const a=h.encrypt;let i=null;a&&(i=a.createCipherTransform(o.num,o.gen));const s=["".concat(o.num," ").concat(o.gen," obj\n")];writeDict(c,s,i);s.push("\n");c.set("XFA",e);l.push({ref:o,data:s.join("")})}if(null===t){t=function writeXFADataForAcroform(e,t){const r=new s.SimpleXMLParser({hasAttributes:!0}).parseFromString(e);for(const{xfa:e}of t){if(!e)continue;const{path:t,value:a}=e;if(!t)continue;const o=r.documentElement.searchNode((0,i.parseXFAPath)(t),0);o?Array.isArray(a)?o.childNodes=a.map((e=>new s.SimpleDOMNode("value",e))):o.childNodes=[new s.SimpleDOMNode("#text",a)]:(0,n.warn)("Node not found for path: ".concat(t))}const a=[];r.documentElement.dump(a);return a.join("")}(h.fetchIfRef(r).getString(),l)}const d=h.encrypt;if(d){t=d.createCipherTransform(r.num,r.gen).encryptString(t)}const f="".concat(r.num," ").concat(r.gen," obj\n")+"<< /Type /EmbeddedFile /Length ".concat(t.length,">>\nstream\n")+t+"\nendstream\nendobj\n";l.push({ref:r,data:f})}({xfaData:p,xfaDatasetsRef:u,hasXfaDatasetsEntry:d,acroFormRef:f,acroForm:g,newRefs:o,xref:l,xrefInfo:r});const m=new a.Dict(null),b=r.newRef;let y,w;const S=t.at(-1);if(10===S||13===S){y=[];w=t.length}else{y=["\n"];w=t.length+1}m.set("Size",b.num+1);m.set("Prev",r.startXRef);m.set("Type",a.Name.get("XRef"));null!==r.rootRef&&m.set("Root",r.rootRef);null!==r.infoRef&&m.set("Info",r.infoRef);null!==r.encryptRef&&m.set("Encrypt",r.encryptRef);o.push({ref:b,data:""});o=o.sort(((e,t)=>e.ref.num-t.ref.num));const x=[[0,1,65535]],v=[0,1];let k=0;for(const{ref:e,data:t}of o){k=Math.max(k,w);x.push([1,w,Math.min(e.gen,65535)]);w+=t.length;v.push(e.num,1);y.push(t)}m.set("Index",v);if(Array.isArray(r.fileIds)&&r.fileIds.length>0){const e=function computeMD5(e,t){const r=Math.floor(Date.now()/1e3),a=t.filename||"",i=[r.toString(),a,e.toString()];let s=i.reduce(((e,t)=>e+t.length),0);for(const e of Object.values(t.info)){i.push(e);s+=e.length}const o=new Uint8Array(s);let l=0;for(const e of i){writeString(e,l,o);l+=e.length}return(0,n.bytesToString)((0,c.calculateMD5)(o))}(w,r);m.set("ID",[r.fileIds[0],e])}const C=[1,Math.ceil(Math.log2(k)/8),2],O=(C[0]+C[1]+C[2])*x.length;m.set("W",C);m.set("Length",O);y.push("".concat(b.num," ").concat(b.gen," obj\n"));writeDict(m,y,null);y.push(" stream\n");const T=y.reduce(((e,t)=>e+t.length),0),M="\nendstream\nendobj\nstartxref\n".concat(w,"\n%%EOF\n"),E=new Uint8Array(t.length+T+O+M.length);E.set(t);let D=t.length;for(const e of y){writeString(e,D,E);D+=e.length}for(const[e,t,r]of x){D=writeInt(e,C[0],D,E);D=writeInt(t,C[1],D,E);D=writeInt(r,C[2],D,E)}writeString(M,D,E);return E};t.writeDict=writeDict;t.writeObject=function writeObject(e,t,r,n){r.push("".concat(e.num," ").concat(e.gen," obj\n"));t instanceof a.Dict?writeDict(t,r,n):t instanceof o.BaseStream&&writeStream(t,r,n);r.push("\nendobj\n")};r(112);r(155);r(125);r(146);r(148);r(149);var n=r(158),a=r(209),i=r(213),s=r(283),o=r(217),c=r(284);function writeDict(e,t,r){t.push("<<");for(const n of e.getKeys()){t.push(" /".concat((0,i.escapePDFName)(n)," "));writeValue(e.getRaw(n),t,r)}t.push(">>")}function writeStream(e,t,r){writeDict(e.dict,t,r);t.push(" stream\n");let n=e.getString();null!==r&&(n=r.encryptString(n));t.push(n,"\nendstream\n")}function writeValue(e,t,r){if(e instanceof a.Name)t.push("/".concat((0,i.escapePDFName)(e.name)));else if(e instanceof a.Ref)t.push("".concat(e.num," ").concat(e.gen," R"));else if(Array.isArray(e))!function writeArray(e,t,r){t.push("[");let n=!0;for(const a of e){n?n=!1:t.push(" ");writeValue(a,t,r)}t.push("]")}(e,t,r);else if("string"==typeof e){null!==r&&(e=r.encryptString(e));t.push("(".concat((0,n.escapeString)(e),")"))}else"number"==typeof e?t.push((0,i.numberToString)(e)):"boolean"==typeof e?t.push(e.toString()):e instanceof a.Dict?writeDict(e,t,r):e instanceof o.BaseStream?writeStream(e,t,r):null===e?t.push("null"):(0,n.warn)("Unhandled value in writer: ".concat(typeof e,", please file a bug."))}function writeInt(e,t,r,n){for(let a=t+r-1;a>r-1;a--){n[a]=255&e;e>>=8}return r+t}function writeString(e,t,r){for(let n=0,a=e.length;n<a;n++)r[t+n]=255&e.charCodeAt(n)}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.XMLParserErrorCode=t.XMLParserBase=t.SimpleXMLParser=t.SimpleDOMNode=void 0;r(159);r(179);r(112);var n=r(213);const a={NoError:0,EndOfDocument:-1,UnterminatedCdat:-2,UnterminatedXmlDeclaration:-3,UnterminatedDoctypeDeclaration:-4,UnterminatedComment:-5,MalformedElement:-6,OutOfMemory:-7,UnterminatedAttributeValue:-8,UnterminatedElement:-9,ElementNeverBegun:-10};t.XMLParserErrorCode=a;function isWhitespace(e,t){const r=e[t];return" "===r||"\n"===r||"\r"===r||"\t"===r}class XMLParserBase{_resolveEntities(e){return e.replace(/&([^;]+);/g,((e,t)=>{if("#x"===t.substring(0,2))return String.fromCodePoint(parseInt(t.substring(2),16));if("#"===t.substring(0,1))return String.fromCodePoint(parseInt(t.substring(1),10));switch(t){case"lt":return"<";case"gt":return">";case"amp":return"&";case"quot":return'"';case"apos":return"'"}return this.onResolveEntity(t)}))}_parseContent(e,t){const r=[];let n=t;function skipWs(){for(;n<e.length&&isWhitespace(e,n);)++n}for(;n<e.length&&!isWhitespace(e,n)&&">"!==e[n]&&"/"!==e[n];)++n;const a=e.substring(t,n);skipWs();for(;n<e.length&&">"!==e[n]&&"/"!==e[n]&&"?"!==e[n];){skipWs();let t="",a="";for(;n<e.length&&!isWhitespace(e,n)&&"="!==e[n];){t+=e[n];++n}skipWs();if("="!==e[n])return null;++n;skipWs();const i=e[n];if('"'!==i&&"'"!==i)return null;const s=e.indexOf(i,++n);if(s<0)return null;a=e.substring(n,s);r.push({name:t,value:this._resolveEntities(a)});n=s+1;skipWs()}return{name:a,attributes:r,parsed:n-t}}_parseProcessingInstruction(e,t){let r=t;for(;r<e.length&&!isWhitespace(e,r)&&">"!==e[r]&&"?"!==e[r]&&"/"!==e[r];)++r;const n=e.substring(t,r);!function skipWs(){for(;r<e.length&&isWhitespace(e,r);)++r}();const a=r;for(;r<e.length&&("?"!==e[r]||">"!==e[r+1]);)++r;return{name:n,value:e.substring(a,r),parsed:r-t}}parseXml(e){let t=0;for(;t<e.length;){let r=t;if("<"===e[t]){++r;let t;switch(e[r]){case"/":++r;t=e.indexOf(">",r);if(t<0){this.onError(a.UnterminatedElement);return}this.onEndElement(e.substring(r,t));r=t+1;break;case"?":++r;const n=this._parseProcessingInstruction(e,r);if("?>"!==e.substring(r+n.parsed,r+n.parsed+2)){this.onError(a.UnterminatedXmlDeclaration);return}this.onPi(n.name,n.value);r+=n.parsed+2;break;case"!":if("--"===e.substring(r+1,r+3)){t=e.indexOf("--\x3e",r+3);if(t<0){this.onError(a.UnterminatedComment);return}this.onComment(e.substring(r+3,t));r=t+3}else if("[CDATA["===e.substring(r+1,r+8)){t=e.indexOf("]]>",r+8);if(t<0){this.onError(a.UnterminatedCdat);return}this.onCdata(e.substring(r+8,t));r=t+3}else{if("DOCTYPE"!==e.substring(r+1,r+8)){this.onError(a.MalformedElement);return}{const n=e.indexOf("[",r+8);let i=!1;t=e.indexOf(">",r+8);if(t<0){this.onError(a.UnterminatedDoctypeDeclaration);return}if(n>0&&t>n){t=e.indexOf("]>",r+8);if(t<0){this.onError(a.UnterminatedDoctypeDeclaration);return}i=!0}const s=e.substring(r+8,t+(i?1:0));this.onDoctype(s);r=t+(i?2:1)}}break;default:const i=this._parseContent(e,r);if(null===i){this.onError(a.MalformedElement);return}let s=!1;if("/>"===e.substring(r+i.parsed,r+i.parsed+2))s=!0;else if(">"!==e.substring(r+i.parsed,r+i.parsed+1)){this.onError(a.UnterminatedElement);return}this.onBeginElement(i.name,i.attributes,s);r+=i.parsed+(s?2:1)}}else{for(;r<e.length&&"<"!==e[r];)r++;const n=e.substring(t,r);this.onText(this._resolveEntities(n))}t=r}}onResolveEntity(e){return"&".concat(e,";")}onPi(e,t){}onComment(e){}onCdata(e){}onDoctype(e){}onText(e){}onBeginElement(e,t,r){}onEndElement(e){}onError(e){}}t.XMLParserBase=XMLParserBase;class SimpleDOMNode{constructor(e,t){this.nodeName=e;this.nodeValue=t;Object.defineProperty(this,"parentNode",{value:null,writable:!0})}get firstChild(){return this.childNodes&&this.childNodes[0]}get nextSibling(){const e=this.parentNode.childNodes;if(!e)return;const t=e.indexOf(this);return-1!==t?e[t+1]:void 0}get textContent(){return this.childNodes?this.childNodes.map((function(e){return e.textContent})).join(""):this.nodeValue||""}get children(){return this.childNodes||[]}hasChildNodes(){return this.childNodes&&this.childNodes.length>0}searchNode(e,t){if(t>=e.length)return this;const r=e[t],n=[];let a=this;for(;;){if(r.name===a.nodeName){if(0!==r.pos){if(0===n.length)return null;{const[i]=n.pop();let s=0;for(const n of i.childNodes)if(r.name===n.nodeName){if(s===r.pos)return n.searchNode(e,t+1);s++}return a.searchNode(e,t+1)}}{const r=a.searchNode(e,t+1);if(null!==r)return r}}if(a.childNodes&&0!==a.childNodes.length){n.push([a,0]);a=a.childNodes[0]}else{if(0===n.length)return null;for(;0!==n.length;){const[e,t]=n.pop(),r=t+1;if(r<e.childNodes.length){n.push([e,r]);a=e.childNodes[r];break}}if(0===n.length)return null}}}dump(e){if("#text"!==this.nodeName){e.push("<".concat(this.nodeName));if(this.attributes)for(const t of this.attributes)e.push(" ".concat(t.name,'="').concat((0,n.encodeToXmlString)(t.value),'"'));if(this.hasChildNodes()){e.push(">");for(const t of this.childNodes)t.dump(e);e.push("</".concat(this.nodeName,">"))}else this.nodeValue?e.push(">".concat((0,n.encodeToXmlString)(this.nodeValue),"</").concat(this.nodeName,">")):e.push("/>")}else e.push((0,n.encodeToXmlString)(this.nodeValue))}}t.SimpleDOMNode=SimpleDOMNode;t.SimpleXMLParser=class SimpleXMLParser extends XMLParserBase{constructor(e){let{hasAttributes:t=!1,lowerCaseName:r=!1}=e;super();this._currentFragment=null;this._stack=null;this._errorCode=a.NoError;this._hasAttributes=t;this._lowerCaseName=r}parseFromString(e){this._currentFragment=[];this._stack=[];this._errorCode=a.NoError;this.parseXml(e);if(this._errorCode!==a.NoError)return;const[t]=this._currentFragment;return t?{documentElement:t}:void 0}onText(e){if(function isWhitespaceString(e){for(let t=0,r=e.length;t<r;t++)if(!isWhitespace(e,t))return!1;return!0}(e))return;const t=new SimpleDOMNode("#text",e);this._currentFragment.push(t)}onCdata(e){const t=new SimpleDOMNode("#text",e);this._currentFragment.push(t)}onBeginElement(e,t,r){this._lowerCaseName&&(e=e.toLowerCase());const n=new SimpleDOMNode(e);n.childNodes=[];this._hasAttributes&&(n.attributes=t);this._currentFragment.push(n);if(!r){this._stack.push(this._currentFragment);this._currentFragment=n.childNodes}}onEndElement(e){this._currentFragment=this._stack.pop()||[];const t=this._currentFragment.at(-1);if(!t)return null;for(let e=0,r=t.childNodes.length;e<r;e++)t.childNodes[e].parentNode=t;return t}onError(e){this._errorCode=e}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.calculateSHA256=t.calculateMD5=t.PDF20=t.PDF17=t.CipherTransformFactory=t.ARCFourCipher=t.AES256Cipher=t.AES128Cipher=void 0;t.calculateSHA384=calculateSHA384;t.calculateSHA512=void 0;r(125);r(146);r(148);r(149);r(247);r(178);var n=r(158),a=r(209),i=r(285);class ARCFourCipher{constructor(e){this.a=0;this.b=0;const t=new Uint8Array(256),r=e.length;for(let e=0;e<256;++e)t[e]=e;for(let n=0,a=0;n<256;++n){const i=t[n];a=a+i+e[n%r]&255;t[n]=t[a];t[a]=i}this.s=t}encryptBlock(e){let t=this.a,r=this.b;const n=this.s,a=e.length,i=new Uint8Array(a);for(let s=0;s<a;++s){t=t+1&255;const a=n[t];r=r+a&255;const o=n[r];n[t]=o;n[r]=a;i[s]=e[s]^n[a+o&255]}this.a=t;this.b=r;return i}decryptBlock(e){return this.encryptBlock(e)}encrypt(e){return this.encryptBlock(e)}}t.ARCFourCipher=ARCFourCipher;const s=function calculateMD5Closure(){const e=new Uint8Array([7,12,17,22,7,12,17,22,7,12,17,22,7,12,17,22,5,9,14,20,5,9,14,20,5,9,14,20,5,9,14,20,4,11,16,23,4,11,16,23,4,11,16,23,4,11,16,23,6,10,15,21,6,10,15,21,6,10,15,21,6,10,15,21]),t=new Int32Array([-680876936,-389564586,606105819,-1044525330,-176418897,1200080426,-1473231341,-45705983,1770035416,-1958414417,-42063,-1990404162,1804603682,-40341101,-1502002290,1236535329,-165796510,-1069501632,643717713,-373897302,-701558691,38016083,-660478335,-405537848,568446438,-1019803690,-187363961,1163531501,-1444681467,-51403784,1735328473,-1926607734,-378558,-2022574463,1839030562,-35309556,-1530992060,1272893353,-155497632,-1094730640,681279174,-358537222,-722521979,76029189,-640364487,-421815835,530742520,-995338651,-198630844,1126891415,-1416354905,-57434055,1700485571,-1894986606,-1051523,-2054922799,1873313359,-30611744,-1560198380,1309151649,-145523070,-1120210379,718787259,-343485551]);return function hash(r,n,a){let i=1732584193,s=-271733879,o=-1732584194,c=271733878;const l=a+72&-64,h=new Uint8Array(l);let u,d;for(u=0;u<a;++u)h[u]=r[n++];h[u++]=128;const f=l-8;for(;u<f;)h[u++]=0;h[u++]=a<<3&255;h[u++]=a>>5&255;h[u++]=a>>13&255;h[u++]=a>>21&255;h[u++]=a>>>29&255;h[u++]=0;h[u++]=0;h[u++]=0;const g=new Int32Array(16);for(u=0;u<l;){for(d=0;d<16;++d,u+=4)g[d]=h[u]|h[u+1]<<8|h[u+2]<<16|h[u+3]<<24;let r,n,a=i,l=s,f=o,p=c;for(d=0;d<64;++d){if(d<16){r=l&f|~l&p;n=d}else if(d<32){r=p&l|~p&f;n=5*d+1&15}else if(d<48){r=l^f^p;n=3*d+5&15}else{r=f^(l|~p);n=7*d&15}const i=p,s=a+r+t[d]+g[n]|0,o=e[d];p=f;f=l;l=l+(s<<o|s>>>32-o)|0;a=i}i=i+a|0;s=s+l|0;o=o+f|0;c=c+p|0}return new Uint8Array([255&i,i>>8&255,i>>16&255,i>>>24&255,255&s,s>>8&255,s>>16&255,s>>>24&255,255&o,o>>8&255,o>>16&255,o>>>24&255,255&c,c>>8&255,c>>16&255,c>>>24&255])}}();t.calculateMD5=s;class Word64{constructor(e,t){this.high=0|e;this.low=0|t}and(e){this.high&=e.high;this.low&=e.low}xor(e){this.high^=e.high;this.low^=e.low}or(e){this.high|=e.high;this.low|=e.low}shiftRight(e){if(e>=32){this.low=this.high>>>e-32|0;this.high=0}else{this.low=this.low>>>e|this.high<<32-e;this.high=this.high>>>e|0}}shiftLeft(e){if(e>=32){this.high=this.low<<e-32;this.low=0}else{this.high=this.high<<e|this.low>>>32-e;this.low<<=e}}rotateRight(e){let t,r;if(32&e){r=this.low;t=this.high}else{t=this.low;r=this.high}e&=31;this.low=t>>>e|r<<32-e;this.high=r>>>e|t<<32-e}not(){this.high=~this.high;this.low=~this.low}add(e){const t=(this.low>>>0)+(e.low>>>0);let r=(this.high>>>0)+(e.high>>>0);t>4294967295&&(r+=1);this.low=0|t;this.high=0|r}copyTo(e,t){e[t]=this.high>>>24&255;e[t+1]=this.high>>16&255;e[t+2]=this.high>>8&255;e[t+3]=255&this.high;e[t+4]=this.low>>>24&255;e[t+5]=this.low>>16&255;e[t+6]=this.low>>8&255;e[t+7]=255&this.low}assign(e){this.high=e.high;this.low=e.low}}const o=function calculateSHA256Closure(){function rotr(e,t){return e>>>t|e<<32-t}function ch(e,t,r){return e&t^~e&r}function maj(e,t,r){return e&t^e&r^t&r}function sigma(e){return rotr(e,2)^rotr(e,13)^rotr(e,22)}function sigmaPrime(e){return rotr(e,6)^rotr(e,11)^rotr(e,25)}function littleSigma(e){return rotr(e,7)^rotr(e,18)^e>>>3}const e=[1116352408,1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298];return function hash(t,r,n){let a=1779033703,i=3144134277,s=1013904242,o=2773480762,c=1359893119,l=2600822924,h=528734635,u=1541459225;const d=64*Math.ceil((n+9)/64),f=new Uint8Array(d);let g,p;for(g=0;g<n;++g)f[g]=t[r++];f[g++]=128;const m=d-8;for(;g<m;)f[g++]=0;f[g++]=0;f[g++]=0;f[g++]=0;f[g++]=n>>>29&255;f[g++]=n>>21&255;f[g++]=n>>13&255;f[g++]=n>>5&255;f[g++]=n<<3&255;const b=new Uint32Array(64);for(g=0;g<d;){for(p=0;p<16;++p){b[p]=f[g]<<24|f[g+1]<<16|f[g+2]<<8|f[g+3];g+=4}for(p=16;p<64;++p)b[p]=(rotr(y=b[p-2],17)^rotr(y,19)^y>>>10)+b[p-7]+littleSigma(b[p-15])+b[p-16]|0;let t,r,n=a,d=i,m=s,w=o,S=c,x=l,v=h,k=u;for(p=0;p<64;++p){t=k+sigmaPrime(S)+ch(S,x,v)+e[p]+b[p];r=sigma(n)+maj(n,d,m);k=v;v=x;x=S;S=w+t|0;w=m;m=d;d=n;n=t+r|0}a=a+n|0;i=i+d|0;s=s+m|0;o=o+w|0;c=c+S|0;l=l+x|0;h=h+v|0;u=u+k|0}var y;return new Uint8Array([a>>24&255,a>>16&255,a>>8&255,255&a,i>>24&255,i>>16&255,i>>8&255,255&i,s>>24&255,s>>16&255,s>>8&255,255&s,o>>24&255,o>>16&255,o>>8&255,255&o,c>>24&255,c>>16&255,c>>8&255,255&c,l>>24&255,l>>16&255,l>>8&255,255&l,h>>24&255,h>>16&255,h>>8&255,255&h,u>>24&255,u>>16&255,u>>8&255,255&u])}}();t.calculateSHA256=o;const c=function calculateSHA512Closure(){function ch(e,t,r,n,a){e.assign(t);e.and(r);a.assign(t);a.not();a.and(n);e.xor(a)}function maj(e,t,r,n,a){e.assign(t);e.and(r);a.assign(t);a.and(n);e.xor(a);a.assign(r);a.and(n);e.xor(a)}function sigma(e,t,r){e.assign(t);e.rotateRight(28);r.assign(t);r.rotateRight(34);e.xor(r);r.assign(t);r.rotateRight(39);e.xor(r)}function sigmaPrime(e,t,r){e.assign(t);e.rotateRight(14);r.assign(t);r.rotateRight(18);e.xor(r);r.assign(t);r.rotateRight(41);e.xor(r)}function littleSigma(e,t,r){e.assign(t);e.rotateRight(1);r.assign(t);r.rotateRight(8);e.xor(r);r.assign(t);r.shiftRight(7);e.xor(r)}function littleSigmaPrime(e,t,r){e.assign(t);e.rotateRight(19);r.assign(t);r.rotateRight(61);e.xor(r);r.assign(t);r.shiftRight(6);e.xor(r)}const e=[new Word64(1116352408,3609767458),new Word64(1899447441,602891725),new Word64(3049323471,3964484399),new Word64(3921009573,2173295548),new Word64(961987163,4081628472),new Word64(1508970993,3053834265),new Word64(2453635748,2937671579),new Word64(2870763221,3664609560),new Word64(3624381080,2734883394),new Word64(310598401,1164996542),new Word64(607225278,1323610764),new Word64(1426881987,3590304994),new Word64(1925078388,4068182383),new Word64(2162078206,991336113),new Word64(2614888103,633803317),new Word64(3248222580,3479774868),new Word64(3835390401,2666613458),new Word64(4022224774,944711139),new Word64(264347078,2341262773),new Word64(604807628,2007800933),new Word64(770255983,1495990901),new Word64(1249150122,1856431235),new Word64(1555081692,3175218132),new Word64(1996064986,2198950837),new Word64(2554220882,3999719339),new Word64(2821834349,766784016),new Word64(2952996808,2566594879),new Word64(3210313671,3203337956),new Word64(3336571891,1034457026),new Word64(3584528711,2466948901),new Word64(113926993,3758326383),new Word64(338241895,168717936),new Word64(666307205,1188179964),new Word64(773529912,1546045734),new Word64(1294757372,1522805485),new Word64(1396182291,2643833823),new Word64(1695183700,2343527390),new Word64(1986661051,1014477480),new Word64(2177026350,1206759142),new Word64(2456956037,344077627),new Word64(2730485921,1290863460),new Word64(2820302411,3158454273),new Word64(3259730800,3505952657),new Word64(3345764771,106217008),new Word64(3516065817,3606008344),new Word64(3600352804,1432725776),new Word64(4094571909,1467031594),new Word64(275423344,851169720),new Word64(430227734,3100823752),new Word64(506948616,1363258195),new Word64(659060556,3750685593),new Word64(883997877,3785050280),new Word64(958139571,3318307427),new Word64(1322822218,3812723403),new Word64(1537002063,2003034995),new Word64(1747873779,3602036899),new Word64(1955562222,1575990012),new Word64(2024104815,1125592928),new Word64(2227730452,2716904306),new Word64(2361852424,442776044),new Word64(2428436474,593698344),new Word64(2756734187,3733110249),new Word64(3204031479,2999351573),new Word64(3329325298,3815920427),new Word64(3391569614,3928383900),new Word64(3515267271,566280711),new Word64(3940187606,3454069534),new Word64(4118630271,4000239992),new Word64(116418474,1914138554),new Word64(174292421,2731055270),new Word64(289380356,3203993006),new Word64(460393269,320620315),new Word64(685471733,587496836),new Word64(852142971,1086792851),new Word64(1017036298,365543100),new Word64(1126000580,2618297676),new Word64(1288033470,3409855158),new Word64(1501505948,4234509866),new Word64(1607167915,987167468),new Word64(1816402316,1246189591)];return function hash(t,r,n){let a,i,s,o,c,l,h,u,d=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(d){a=new Word64(3418070365,3238371032);i=new Word64(1654270250,914150663);s=new Word64(2438529370,812702999);o=new Word64(355462360,4144912697);c=new Word64(1731405415,4290775857);l=new Word64(2394180231,1750603025);h=new Word64(3675008525,1694076839);u=new Word64(1203062813,3204075428)}else{a=new Word64(1779033703,4089235720);i=new Word64(3144134277,2227873595);s=new Word64(1013904242,4271175723);o=new Word64(2773480762,1595750129);c=new Word64(1359893119,2917565137);l=new Word64(2600822924,725511199);h=new Word64(528734635,4215389547);u=new Word64(1541459225,327033209)}const f=128*Math.ceil((n+17)/128),g=new Uint8Array(f);let p,m;for(p=0;p<n;++p)g[p]=t[r++];g[p++]=128;const b=f-16;for(;p<b;)g[p++]=0;g[p++]=0;g[p++]=0;g[p++]=0;g[p++]=0;g[p++]=0;g[p++]=0;g[p++]=0;g[p++]=0;g[p++]=0;g[p++]=0;g[p++]=0;g[p++]=n>>>29&255;g[p++]=n>>21&255;g[p++]=n>>13&255;g[p++]=n>>5&255;g[p++]=n<<3&255;const y=new Array(80);for(p=0;p<80;p++)y[p]=new Word64(0,0);let w=new Word64(0,0),S=new Word64(0,0),x=new Word64(0,0),v=new Word64(0,0),k=new Word64(0,0),C=new Word64(0,0),O=new Word64(0,0),T=new Word64(0,0);const M=new Word64(0,0),E=new Word64(0,0),D=new Word64(0,0),N=new Word64(0,0);let R,L;for(p=0;p<f;){for(m=0;m<16;++m){y[m].high=g[p]<<24|g[p+1]<<16|g[p+2]<<8|g[p+3];y[m].low=g[p+4]<<24|g[p+5]<<16|g[p+6]<<8|g[p+7];p+=8}for(m=16;m<80;++m){R=y[m];littleSigmaPrime(R,y[m-2],N);R.add(y[m-7]);littleSigma(D,y[m-15],N);R.add(D);R.add(y[m-16])}w.assign(a);S.assign(i);x.assign(s);v.assign(o);k.assign(c);C.assign(l);O.assign(h);T.assign(u);for(m=0;m<80;++m){M.assign(T);sigmaPrime(D,k,N);M.add(D);ch(D,k,C,O,N);M.add(D);M.add(e[m]);M.add(y[m]);sigma(E,w,N);maj(D,w,S,x,N);E.add(D);R=T;T=O;O=C;C=k;v.add(M);k=v;v=x;x=S;S=w;R.assign(M);R.add(E);w=R}a.add(w);i.add(S);s.add(x);o.add(v);c.add(k);l.add(C);h.add(O);u.add(T)}if(d){L=new Uint8Array(48);a.copyTo(L,0);i.copyTo(L,8);s.copyTo(L,16);o.copyTo(L,24);c.copyTo(L,32);l.copyTo(L,40)}else{L=new Uint8Array(64);a.copyTo(L,0);i.copyTo(L,8);s.copyTo(L,16);o.copyTo(L,24);c.copyTo(L,32);l.copyTo(L,40);h.copyTo(L,48);u.copyTo(L,56)}return L}}();t.calculateSHA512=c;function calculateSHA384(e,t,r){return c(e,t,r,!0)}class NullCipher{decryptBlock(e){return e}encrypt(e){return e}}class AESBaseCipher{constructor(){this.constructor===AESBaseCipher&&(0,n.unreachable)("Cannot initialize AESBaseCipher.");this._s=new Uint8Array([99,124,119,123,242,107,111,197,48,1,103,43,254,215,171,118,202,130,201,125,250,89,71,240,173,212,162,175,156,164,114,192,183,253,147,38,54,63,247,204,52,165,229,241,113,216,49,21,4,199,35,195,24,150,5,154,7,18,128,226,235,39,178,117,9,131,44,26,27,110,90,160,82,59,214,179,41,227,47,132,83,209,0,237,32,252,177,91,106,203,190,57,74,76,88,207,208,239,170,251,67,77,51,133,69,249,2,127,80,60,159,168,81,163,64,143,146,157,56,245,188,182,218,33,16,255,243,210,205,12,19,236,95,151,68,23,196,167,126,61,100,93,25,115,96,129,79,220,34,42,144,136,70,238,184,20,222,94,11,219,224,50,58,10,73,6,36,92,194,211,172,98,145,149,228,121,231,200,55,109,141,213,78,169,108,86,244,234,101,122,174,8,186,120,37,46,28,166,180,198,232,221,116,31,75,189,139,138,112,62,181,102,72,3,246,14,97,53,87,185,134,193,29,158,225,248,152,17,105,217,142,148,155,30,135,233,206,85,40,223,140,161,137,13,191,230,66,104,65,153,45,15,176,84,187,22]);this._inv_s=new Uint8Array([82,9,106,213,48,54,165,56,191,64,163,158,129,243,215,251,124,227,57,130,155,47,255,135,52,142,67,68,196,222,233,203,84,123,148,50,166,194,35,61,238,76,149,11,66,250,195,78,8,46,161,102,40,217,36,178,118,91,162,73,109,139,209,37,114,248,246,100,134,104,152,22,212,164,92,204,93,101,182,146,108,112,72,80,253,237,185,218,94,21,70,87,167,141,157,132,144,216,171,0,140,188,211,10,247,228,88,5,184,179,69,6,208,44,30,143,202,63,15,2,193,175,189,3,1,19,138,107,58,145,17,65,79,103,220,234,151,242,207,206,240,180,230,115,150,172,116,34,231,173,53,133,226,249,55,232,28,117,223,110,71,241,26,113,29,41,197,137,111,183,98,14,170,24,190,27,252,86,62,75,198,210,121,32,154,219,192,254,120,205,90,244,31,221,168,51,136,7,199,49,177,18,16,89,39,128,236,95,96,81,127,169,25,181,74,13,45,229,122,159,147,201,156,239,160,224,59,77,174,42,245,176,200,235,187,60,131,83,153,97,23,43,4,126,186,119,214,38,225,105,20,99,85,33,12,125]);this._mix=new Uint32Array([0,235474187,470948374,303765277,941896748,908933415,607530554,708780849,1883793496,2118214995,1817866830,1649639237,1215061108,1181045119,1417561698,1517767529,3767586992,4003061179,4236429990,4069246893,3635733660,3602770327,3299278474,3400528769,2430122216,2664543715,2362090238,2193862645,2835123396,2801107407,3035535058,3135740889,3678124923,3576870512,3341394285,3374361702,3810496343,3977675356,4279080257,4043610186,2876494627,2776292904,3076639029,3110650942,2472011535,2640243204,2403728665,2169303058,1001089995,899835584,666464733,699432150,59727847,226906860,530400753,294930682,1273168787,1172967064,1475418501,1509430414,1942435775,2110667444,1876241833,1641816226,2910219766,2743034109,2976151520,3211623147,2505202138,2606453969,2302690252,2269728455,3711829422,3543599269,3240894392,3475313331,3843699074,3943906441,4178062228,4144047775,1306967366,1139781709,1374988112,1610459739,1975683434,2076935265,1775276924,1742315127,1034867998,866637845,566021896,800440835,92987698,193195065,429456164,395441711,1984812685,2017778566,1784663195,1683407248,1315562145,1080094634,1383856311,1551037884,101039829,135050206,437757123,337553864,1042385657,807962610,573804783,742039012,2531067453,2564033334,2328828971,2227573024,2935566865,2700099354,3001755655,3168937228,3868552805,3902563182,4203181171,4102977912,3736164937,3501741890,3265478751,3433712980,1106041591,1340463100,1576976609,1408749034,2043211483,2009195472,1708848333,1809054150,832877231,1068351396,766945465,599762354,159417987,126454664,361929877,463180190,2709260871,2943682380,3178106961,3009879386,2572697195,2538681184,2236228733,2336434550,3509871135,3745345300,3441850377,3274667266,3910161971,3877198648,4110568485,4211818798,2597806476,2497604743,2261089178,2295101073,2733856160,2902087851,3202437046,2968011453,3936291284,3835036895,4136440770,4169408201,3535486456,3702665459,3467192302,3231722213,2051518780,1951317047,1716890410,1750902305,1113818384,1282050075,1584504582,1350078989,168810852,67556463,371049330,404016761,841739592,1008918595,775550814,540080725,3969562369,3801332234,4035489047,4269907996,3569255213,3669462566,3366754619,3332740144,2631065433,2463879762,2160117071,2395588676,2767645557,2868897406,3102011747,3069049960,202008497,33778362,270040487,504459436,875451293,975658646,675039627,641025152,2084704233,1917518562,1615861247,1851332852,1147550661,1248802510,1484005843,1451044056,933301370,967311729,733156972,632953703,260388950,25965917,328671808,496906059,1206477858,1239443753,1543208500,1441952575,2144161806,1908694277,1675577880,1842759443,3610369226,3644379585,3408119516,3307916247,4011190502,3776767469,4077384432,4245618683,2809771154,2842737049,3144396420,3043140495,2673705150,2438237621,2203032232,2370213795]);this._mixCol=new Uint8Array(256);for(let e=0;e<256;e++)this._mixCol[e]=e<128?e<<1:e<<1^27;this.buffer=new Uint8Array(16);this.bufferPosition=0}_expandKey(e){(0,n.unreachable)("Cannot call `_expandKey` on the base class")}_decrypt(e,t){let r,n,a;const i=new Uint8Array(16);i.set(e);for(let e=0,r=this._keySize;e<16;++e,++r)i[e]^=t[r];for(let e=this._cyclesOfRepetition-1;e>=1;--e){r=i[13];i[13]=i[9];i[9]=i[5];i[5]=i[1];i[1]=r;r=i[14];n=i[10];i[14]=i[6];i[10]=i[2];i[6]=r;i[2]=n;r=i[15];n=i[11];a=i[7];i[15]=i[3];i[11]=r;i[7]=n;i[3]=a;for(let e=0;e<16;++e)i[e]=this._inv_s[i[e]];for(let r=0,n=16*e;r<16;++r,++n)i[r]^=t[n];for(let e=0;e<16;e+=4){const t=this._mix[i[e]],n=this._mix[i[e+1]],a=this._mix[i[e+2]],s=this._mix[i[e+3]];r=t^n>>>8^n<<24^a>>>16^a<<16^s>>>24^s<<8;i[e]=r>>>24&255;i[e+1]=r>>16&255;i[e+2]=r>>8&255;i[e+3]=255&r}}r=i[13];i[13]=i[9];i[9]=i[5];i[5]=i[1];i[1]=r;r=i[14];n=i[10];i[14]=i[6];i[10]=i[2];i[6]=r;i[2]=n;r=i[15];n=i[11];a=i[7];i[15]=i[3];i[11]=r;i[7]=n;i[3]=a;for(let e=0;e<16;++e){i[e]=this._inv_s[i[e]];i[e]^=t[e]}return i}_encrypt(e,t){const r=this._s;let n,a,i;const s=new Uint8Array(16);s.set(e);for(let e=0;e<16;++e)s[e]^=t[e];for(let e=1;e<this._cyclesOfRepetition;e++){for(let e=0;e<16;++e)s[e]=r[s[e]];i=s[1];s[1]=s[5];s[5]=s[9];s[9]=s[13];s[13]=i;i=s[2];a=s[6];s[2]=s[10];s[6]=s[14];s[10]=i;s[14]=a;i=s[3];a=s[7];n=s[11];s[3]=s[15];s[7]=i;s[11]=a;s[15]=n;for(let e=0;e<16;e+=4){const t=s[e+0],r=s[e+1],a=s[e+2],i=s[e+3];n=t^r^a^i;s[e+0]^=n^this._mixCol[t^r];s[e+1]^=n^this._mixCol[r^a];s[e+2]^=n^this._mixCol[a^i];s[e+3]^=n^this._mixCol[i^t]}for(let r=0,n=16*e;r<16;++r,++n)s[r]^=t[n]}for(let e=0;e<16;++e)s[e]=r[s[e]];i=s[1];s[1]=s[5];s[5]=s[9];s[9]=s[13];s[13]=i;i=s[2];a=s[6];s[2]=s[10];s[6]=s[14];s[10]=i;s[14]=a;i=s[3];a=s[7];n=s[11];s[3]=s[15];s[7]=i;s[11]=a;s[15]=n;for(let e=0,r=this._keySize;e<16;++e,++r)s[e]^=t[r];return s}_decryptBlock2(e,t){const r=e.length;let n=this.buffer,a=this.bufferPosition;const i=[];let s=this.iv;for(let t=0;t<r;++t){n[a]=e[t];++a;if(a<16)continue;const r=this._decrypt(n,this._key);for(let e=0;e<16;++e)r[e]^=s[e];s=n;i.push(r);n=new Uint8Array(16);a=0}this.buffer=n;this.bufferLength=a;this.iv=s;if(0===i.length)return new Uint8Array(0);let o=16*i.length;if(t){const e=i.at(-1);let t=e[15];if(t<=16){for(let r=15,n=16-t;r>=n;--r)if(e[r]!==t){t=0;break}o-=t;i[i.length-1]=e.subarray(0,16-t)}}const c=new Uint8Array(o);for(let e=0,t=0,r=i.length;e<r;++e,t+=16)c.set(i[e],t);return c}decryptBlock(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;const n=e.length,a=this.buffer;let i=this.bufferPosition;if(r)this.iv=r;else{for(let t=0;i<16&&t<n;++t,++i)a[i]=e[t];if(i<16){this.bufferLength=i;return new Uint8Array(0)}this.iv=a;e=e.subarray(16)}this.buffer=new Uint8Array(16);this.bufferLength=0;this.decryptBlock=this._decryptBlock2;return this.decryptBlock(e,t)}encrypt(e,t){const r=e.length;let n=this.buffer,a=this.bufferPosition;const i=[];t||(t=new Uint8Array(16));for(let s=0;s<r;++s){n[a]=e[s];++a;if(a<16)continue;for(let e=0;e<16;++e)n[e]^=t[e];const r=this._encrypt(n,this._key);t=r;i.push(r);n=new Uint8Array(16);a=0}this.buffer=n;this.bufferLength=a;this.iv=t;if(0===i.length)return new Uint8Array(0);const s=16*i.length,o=new Uint8Array(s);for(let e=0,t=0,r=i.length;e<r;++e,t+=16)o.set(i[e],t);return o}}class AES128Cipher extends AESBaseCipher{constructor(e){super();this._cyclesOfRepetition=10;this._keySize=160;this._rcon=new Uint8Array([141,1,2,4,8,16,32,64,128,27,54,108,216,171,77,154,47,94,188,99,198,151,53,106,212,179,125,250,239,197,145,57,114,228,211,189,97,194,159,37,74,148,51,102,204,131,29,58,116,232,203,141,1,2,4,8,16,32,64,128,27,54,108,216,171,77,154,47,94,188,99,198,151,53,106,212,179,125,250,239,197,145,57,114,228,211,189,97,194,159,37,74,148,51,102,204,131,29,58,116,232,203,141,1,2,4,8,16,32,64,128,27,54,108,216,171,77,154,47,94,188,99,198,151,53,106,212,179,125,250,239,197,145,57,114,228,211,189,97,194,159,37,74,148,51,102,204,131,29,58,116,232,203,141,1,2,4,8,16,32,64,128,27,54,108,216,171,77,154,47,94,188,99,198,151,53,106,212,179,125,250,239,197,145,57,114,228,211,189,97,194,159,37,74,148,51,102,204,131,29,58,116,232,203,141,1,2,4,8,16,32,64,128,27,54,108,216,171,77,154,47,94,188,99,198,151,53,106,212,179,125,250,239,197,145,57,114,228,211,189,97,194,159,37,74,148,51,102,204,131,29,58,116,232,203,141]);this._key=this._expandKey(e)}_expandKey(e){const t=this._s,r=this._rcon,n=new Uint8Array(176);n.set(e);for(let e=16,a=1;e<176;++a){let i=n[e-3],s=n[e-2],o=n[e-1],c=n[e-4];i=t[i];s=t[s];o=t[o];c=t[c];i^=r[a];for(let t=0;t<4;++t){n[e]=i^=n[e-16];e++;n[e]=s^=n[e-16];e++;n[e]=o^=n[e-16];e++;n[e]=c^=n[e-16];e++}}return n}}t.AES128Cipher=AES128Cipher;class AES256Cipher extends AESBaseCipher{constructor(e){super();this._cyclesOfRepetition=14;this._keySize=224;this._key=this._expandKey(e)}_expandKey(e){const t=this._s,r=new Uint8Array(240);r.set(e);let n,a,i,s,o=1;for(let e=32,c=1;e<240;++c){if(e%32==16){n=t[n];a=t[a];i=t[i];s=t[s]}else if(e%32==0){n=r[e-3];a=r[e-2];i=r[e-1];s=r[e-4];n=t[n];a=t[a];i=t[i];s=t[s];n^=o;(o<<=1)>=256&&(o=255&(27^o))}for(let t=0;t<4;++t){r[e]=n^=r[e-32];e++;r[e]=a^=r[e-32];e++;r[e]=i^=r[e-32];e++;r[e]=s^=r[e-32];e++}}return r}}t.AES256Cipher=AES256Cipher;class PDF17{checkOwnerPassword(e,t,r,a){const i=new Uint8Array(e.length+56);i.set(e,0);i.set(t,e.length);i.set(r,e.length+t.length);const s=o(i,0,i.length);return(0,n.isArrayEqual)(s,a)}checkUserPassword(e,t,r){const a=new Uint8Array(e.length+8);a.set(e,0);a.set(t,e.length);const i=o(a,0,a.length);return(0,n.isArrayEqual)(i,r)}getOwnerKey(e,t,r,n){const a=new Uint8Array(e.length+56);a.set(e,0);a.set(t,e.length);a.set(r,e.length+t.length);const i=o(a,0,a.length);return new AES256Cipher(i).decryptBlock(n,!1,new Uint8Array(16))}getUserKey(e,t,r){const n=new Uint8Array(e.length+8);n.set(e,0);n.set(t,e.length);const a=o(n,0,n.length);return new AES256Cipher(a).decryptBlock(r,!1,new Uint8Array(16))}}t.PDF17=PDF17;const l=function PDF20Closure(){function calculatePDF20Hash(e,t,r){let n=o(t,0,t.length).subarray(0,32),a=[0],i=0;for(;i<64||a.at(-1)>i-32;){const t=e.length+n.length+r.length,s=new Uint8Array(t);let l=0;s.set(e,l);l+=e.length;s.set(n,l);l+=n.length;s.set(r,l);const h=new Uint8Array(64*t);for(let e=0,r=0;e<64;e++,r+=t)h.set(s,r);a=new AES128Cipher(n.subarray(0,16)).encrypt(h,n.subarray(16,32));let u=0;for(let e=0;e<16;e++){u*=1;u%=3;u+=(a[e]>>>0)%3;u%=3}0===u?n=o(a,0,a.length):1===u?n=calculateSHA384(a,0,a.length):2===u&&(n=c(a,0,a.length));i++}return n.subarray(0,32)}return class PDF20{hash(e,t,r){return calculatePDF20Hash(e,t,r)}checkOwnerPassword(e,t,r,a){const i=new Uint8Array(e.length+56);i.set(e,0);i.set(t,e.length);i.set(r,e.length+t.length);const s=calculatePDF20Hash(e,i,r);return(0,n.isArrayEqual)(s,a)}checkUserPassword(e,t,r){const a=new Uint8Array(e.length+8);a.set(e,0);a.set(t,e.length);const i=calculatePDF20Hash(e,a,[]);return(0,n.isArrayEqual)(i,r)}getOwnerKey(e,t,r,n){const a=new Uint8Array(e.length+56);a.set(e,0);a.set(t,e.length);a.set(r,e.length+t.length);const i=calculatePDF20Hash(e,a,r);return new AES256Cipher(i).decryptBlock(n,!1,new Uint8Array(16))}getUserKey(e,t,r){const n=new Uint8Array(e.length+8);n.set(e,0);n.set(t,e.length);const a=calculatePDF20Hash(e,n,[]);return new AES256Cipher(a).decryptBlock(r,!1,new Uint8Array(16))}}}();t.PDF20=l;class CipherTransform{constructor(e,t){this.StringCipherConstructor=e;this.StreamCipherConstructor=t}createStream(e,t){const r=new this.StreamCipherConstructor;return new i.DecryptStream(e,t,(function cipherTransformDecryptStream(e,t){return r.decryptBlock(e,t)}))}decryptString(e){const t=new this.StringCipherConstructor;let r=(0,n.stringToBytes)(e);r=t.decryptBlock(r,!0);return(0,n.bytesToString)(r)}encryptString(e){const t=new this.StringCipherConstructor;if(t instanceof AESBaseCipher){const r=16-e.length%16;e+=String.fromCharCode(r).repeat(r);const a=new Uint8Array(16);if("undefined"!=typeof crypto)crypto.getRandomValues(a);else for(let e=0;e<16;e++)a[e]=Math.floor(256*Math.random());let i=(0,n.stringToBytes)(e);i=t.encrypt(i,a);const s=new Uint8Array(16+i.length);s.set(a);s.set(i,16);return(0,n.bytesToString)(s)}let r=(0,n.stringToBytes)(e);r=t.encrypt(r);return(0,n.bytesToString)(r)}}const h=function CipherTransformFactoryClosure(){const e=new Uint8Array([40,191,78,94,78,117,138,65,100,0,78,86,255,250,1,8,46,46,0,182,208,104,62,128,47,12,169,254,100,83,105,122]);function prepareKeyData(t,r,n,a,i,o,c,l){const h=40+n.length+t.length,u=new Uint8Array(h);let d,f,g=0;if(r){f=Math.min(32,r.length);for(;g<f;++g)u[g]=r[g]}d=0;for(;g<32;)u[g++]=e[d++];for(d=0,f=n.length;d<f;++d)u[g++]=n[d];u[g++]=255&i;u[g++]=i>>8&255;u[g++]=i>>16&255;u[g++]=i>>>24&255;for(d=0,f=t.length;d<f;++d)u[g++]=t[d];if(o>=4&&!l){u[g++]=255;u[g++]=255;u[g++]=255;u[g++]=255}let p=s(u,0,g);const m=c>>3;if(o>=3)for(d=0;d<50;++d)p=s(p,0,m);const b=p.subarray(0,m);let y,w;if(o>=3){for(g=0;g<32;++g)u[g]=e[g];for(d=0,f=t.length;d<f;++d)u[g++]=t[d];y=new ARCFourCipher(b);w=y.encryptBlock(s(u,0,g));f=b.length;const r=new Uint8Array(f);for(d=1;d<=19;++d){for(let e=0;e<f;++e)r[e]=b[e]^d;y=new ARCFourCipher(r);w=y.encryptBlock(w)}for(d=0,f=w.length;d<f;++d)if(a[d]!==w[d])return null}else{y=new ARCFourCipher(b);w=y.encryptBlock(e);for(d=0,f=w.length;d<f;++d)if(a[d]!==w[d])return null}return b}const t=a.Name.get("Identity");function buildObjectKey(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];const a=new Uint8Array(r.length+9),i=r.length;let o;for(o=0;o<i;++o)a[o]=r[o];a[o++]=255&e;a[o++]=e>>8&255;a[o++]=e>>16&255;a[o++]=255&t;a[o++]=t>>8&255;if(n){a[o++]=115;a[o++]=65;a[o++]=108;a[o++]=84}const c=s(a,0,o);return c.subarray(0,Math.min(r.length+5,16))}function buildCipherConstructor(e,t,r,i,s){if(!(t instanceof a.Name))throw new n.FormatError("Invalid crypt filter name.");const o=e.get(t.name);let c;null!=o&&(c=o.get("CFM"));if(!c||"None"===c.name)return function cipherTransformFactoryBuildCipherConstructorNone(){return new NullCipher};if("V2"===c.name)return function cipherTransformFactoryBuildCipherConstructorV2(){return new ARCFourCipher(buildObjectKey(r,i,s,!1))};if("AESV2"===c.name)return function cipherTransformFactoryBuildCipherConstructorAESV2(){return new AES128Cipher(buildObjectKey(r,i,s,!0))};if("AESV3"===c.name)return function cipherTransformFactoryBuildCipherConstructorAESV3(){return new AES256Cipher(s)};throw new n.FormatError("Unknown crypto method")}return class CipherTransformFactory{constructor(r,i,o){const c=r.get("Filter");if(!(0,a.isName)(c,"Standard"))throw new n.FormatError("unknown encryption method");this.filterName=c.name;this.dict=r;const h=r.get("V");if(!Number.isInteger(h)||1!==h&&2!==h&&4!==h&&5!==h)throw new n.FormatError("unsupported encryption algorithm");this.algorithm=h;let u=r.get("Length");if(!u)if(h<=3)u=40;else{const e=r.get("CF"),t=r.get("StmF");if(e instanceof a.Dict&&t instanceof a.Name){e.suppressEncryption=!0;const r=e.get(t.name);u=r&&r.get("Length")||128;u<40&&(u<<=3)}}if(!Number.isInteger(u)||u<40||u%8!=0)throw new n.FormatError("invalid key length");const d=(0,n.stringToBytes)(r.get("O")).subarray(0,32),f=(0,n.stringToBytes)(r.get("U")).subarray(0,32),g=r.get("P"),p=r.get("R"),m=(4===h||5===h)&&!1!==r.get("EncryptMetadata");this.encryptMetadata=m;const b=(0,n.stringToBytes)(i);let y,w;if(o){if(6===p)try{o=(0,n.utf8StringToString)(o)}catch(e){(0,n.warn)("CipherTransformFactory: Unable to convert UTF8 encoded password.")}y=(0,n.stringToBytes)(o)}if(5!==h)w=prepareKeyData(b,y,d,f,g,p,u,m);else{const e=(0,n.stringToBytes)(r.get("O")).subarray(32,40),t=(0,n.stringToBytes)(r.get("O")).subarray(40,48),a=(0,n.stringToBytes)(r.get("U")).subarray(0,48),i=(0,n.stringToBytes)(r.get("U")).subarray(32,40),s=(0,n.stringToBytes)(r.get("U")).subarray(40,48),o=(0,n.stringToBytes)(r.get("OE")),c=(0,n.stringToBytes)(r.get("UE"));(0,n.stringToBytes)(r.get("Perms"));w=function createEncryptionKey20(e,t,r,n,a,i,s,o,c,h,u,d){if(t){const e=Math.min(127,t.length);t=t.subarray(0,e)}else t=[];let f;f=6===e?new l:new PDF17;return f.checkUserPassword(t,o,s)?f.getUserKey(t,c,u):t.length&&f.checkOwnerPassword(t,n,i,r)?f.getOwnerKey(t,a,i,h):null}(p,y,d,e,t,a,f,i,s,o,c)}if(!w&&!o)throw new n.PasswordException("No password given",n.PasswordResponses.NEED_PASSWORD);if(!w&&o){const t=function decodeUserPassword(t,r,n,a){const i=new Uint8Array(32);let o=0;const c=Math.min(32,t.length);for(;o<c;++o)i[o]=t[o];let l=0;for(;o<32;)i[o++]=e[l++];let h=s(i,0,o);const u=a>>3;if(n>=3)for(l=0;l<50;++l)h=s(h,0,h.length);let d,f;if(n>=3){f=r;const e=new Uint8Array(u);for(l=19;l>=0;l--){for(let t=0;t<u;++t)e[t]=h[t]^l;d=new ARCFourCipher(e);f=d.encryptBlock(f)}}else{d=new ARCFourCipher(h.subarray(0,u));f=d.encryptBlock(r)}return f}(y,d,p,u);w=prepareKeyData(b,t,d,f,g,p,u,m)}if(!w)throw new n.PasswordException("Incorrect Password",n.PasswordResponses.INCORRECT_PASSWORD);this.encryptionKey=w;if(h>=4){const e=r.get("CF");e instanceof a.Dict&&(e.suppressEncryption=!0);this.cf=e;this.stmf=r.get("StmF")||t;this.strf=r.get("StrF")||t;this.eff=r.get("EFF")||this.stmf}}createCipherTransform(e,t){if(4===this.algorithm||5===this.algorithm)return new CipherTransform(buildCipherConstructor(this.cf,this.stmf,e,t,this.encryptionKey),buildCipherConstructor(this.cf,this.strf,e,t,this.encryptionKey));const r=buildObjectKey(e,t,this.encryptionKey,!1),n=function buildCipherCipherConstructor(){return new ARCFourCipher(r)};return new CipherTransform(n,n)}}}();t.CipherTransformFactory=h},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.DecryptStream=void 0;var n=r(242);class DecryptStream extends n.DecodeStream{constructor(e,t,r){super(t);this.str=e;this.dict=e.dict;this.decrypt=r;this.nextChunk=null;this.initialized=!1}readBlock(){let e;if(this.initialized)e=this.nextChunk;else{e=this.str.getBytes(512);this.initialized=!0}if(!e||0===e.length){this.eof=!0;return}this.nextChunk=this.str.getBytes(512);const t=this.nextChunk&&this.nextChunk.length>0;e=(0,this.decrypt)(e,!t);let r=this.bufferLength;const n=e.length,a=this.ensureBuffer(r+n);for(let t=0;t<n;t++)a[r++]=e[t];this.bufferLength=r}}t.DecryptStream=DecryptStream},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.Catalog=void 0;r(112);r(232);r(146);r(148);r(149);r(212);r(2);r(159);var n=r(213),a=r(158),i=r(209),s=r(287),o=r(217),c=r(288),l=r(234),h=r(289),u=r(276),d=r(290),f=r(291);function fetchDestination(e){e instanceof i.Dict&&(e=e.get("D"));return Array.isArray(e)?e:null}class Catalog{constructor(e,t){this.pdfManager=e;this.xref=t;this._catDict=t.getCatalogObj();if(!(this._catDict instanceof i.Dict))throw new a.FormatError("Catalog object is not a dictionary.");this.toplevelPagesDict;this._actualNumPages=null;this.fontCache=new i.RefSetCache;this.builtInCMapCache=new Map;this.standardFontDataCache=new Map;this.globalImageCache=new u.GlobalImageCache;this.pageKidsCountCache=new i.RefSetCache;this.pageIndexCache=new i.RefSetCache;this.nonBlendModesSet=new i.RefSet}get version(){const e=this._catDict.get("Version");return(0,a.shadow)(this,"version",e instanceof i.Name?e.name:null)}get lang(){const e=this._catDict.get("Lang");return(0,a.shadow)(this,"lang","string"==typeof e?(0,a.stringToPDFString)(e):null)}get needsRendering(){const e=this._catDict.get("NeedsRendering");return(0,a.shadow)(this,"needsRendering","boolean"==typeof e&&e)}get collection(){let e=null;try{const t=this._catDict.get("Collection");t instanceof i.Dict&&t.size>0&&(e=t)}catch(e){if(e instanceof n.MissingDataException)throw e;(0,a.info)("Cannot fetch Collection entry; assuming no collection is present.")}return(0,a.shadow)(this,"collection",e)}get acroForm(){let e=null;try{const t=this._catDict.get("AcroForm");t instanceof i.Dict&&t.size>0&&(e=t)}catch(e){if(e instanceof n.MissingDataException)throw e;(0,a.info)("Cannot fetch AcroForm entry; assuming no forms are present.")}return(0,a.shadow)(this,"acroForm",e)}get acroFormRef(){const e=this._catDict.getRaw("AcroForm");return(0,a.shadow)(this,"acroFormRef",e instanceof i.Ref?e:null)}get metadata(){const e=this._catDict.getRaw("Metadata");if(!(e instanceof i.Ref))return(0,a.shadow)(this,"metadata",null);let t=null;try{const r=!(this.xref.encrypt&&this.xref.encrypt.encryptMetadata),n=this.xref.fetch(e,r);if(n instanceof o.BaseStream&&n.dict instanceof i.Dict){const e=n.dict.get("Type"),r=n.dict.get("Subtype");if((0,i.isName)(e,"Metadata")&&(0,i.isName)(r,"XML")){const e=(0,a.stringToUTF8String)(n.getString());e&&(t=new d.MetadataParser(e).serializable)}}}catch(e){if(e instanceof n.MissingDataException)throw e;(0,a.info)('Skipping invalid Metadata: "'.concat(e,'".'))}return(0,a.shadow)(this,"metadata",t)}get markInfo(){let e=null;try{e=this._readMarkInfo()}catch(e){if(e instanceof n.MissingDataException)throw e;(0,a.warn)("Unable to read mark info.")}return(0,a.shadow)(this,"markInfo",e)}_readMarkInfo(){const e=this._catDict.get("MarkInfo");if(!(e instanceof i.Dict))return null;const t={Marked:!1,UserProperties:!1,Suspects:!1};for(const r in t){const n=e.get(r);"boolean"==typeof n&&(t[r]=n)}return t}get structTreeRoot(){let e=null;try{e=this._readStructTreeRoot()}catch(e){if(e instanceof n.MissingDataException)throw e;(0,a.warn)("Unable read to structTreeRoot info.")}return(0,a.shadow)(this,"structTreeRoot",e)}_readStructTreeRoot(){const e=this._catDict.get("StructTreeRoot");if(!(e instanceof i.Dict))return null;const t=new f.StructTreeRoot(e);t.init();return t}get toplevelPagesDict(){const e=this._catDict.get("Pages");if(!(e instanceof i.Dict))throw new a.FormatError("Invalid top-level pages dictionary.");return(0,a.shadow)(this,"toplevelPagesDict",e)}get documentOutline(){let e=null;try{e=this._readDocumentOutline()}catch(e){if(e instanceof n.MissingDataException)throw e;(0,a.warn)("Unable to read document outline.")}return(0,a.shadow)(this,"documentOutline",e)}_readDocumentOutline(){let e=this._catDict.get("Outlines");if(!(e instanceof i.Dict))return null;e=e.getRaw("First");if(!(e instanceof i.Ref))return null;const t={items:[]},r=[{obj:e,parent:t}],n=new i.RefSet;n.put(e);const s=this.xref,o=new Uint8ClampedArray(3);for(;r.length>0;){const t=r.shift(),c=s.fetchIfRef(t.obj);if(null===c)continue;if(!c.has("Title"))throw new a.FormatError("Invalid outline item encountered.");const h={url:null,dest:null};Catalog.parseDestDictionary({destDict:c,resultObj:h,docBaseUrl:this.pdfManager.docBaseUrl});const u=c.get("Title"),d=c.get("F")||0,f=c.getArray("C"),g=c.get("Count");let p=o;!Array.isArray(f)||3!==f.length||0===f[0]&&0===f[1]&&0===f[2]||(p=l.ColorSpace.singletons.rgb.getRgb(f,0));const m={dest:h.dest,url:h.url,unsafeUrl:h.unsafeUrl,newWindow:h.newWindow,title:(0,a.stringToPDFString)(u),color:p,count:Number.isInteger(g)?g:void 0,bold:!!(2&d),italic:!!(1&d),items:[]};t.parent.items.push(m);e=c.getRaw("First");if(e instanceof i.Ref&&!n.has(e)){r.push({obj:e,parent:m});n.put(e)}e=c.getRaw("Next");if(e instanceof i.Ref&&!n.has(e)){r.push({obj:e,parent:t.parent});n.put(e)}}return t.items.length>0?t.items:null}get permissions(){let e=null;try{e=this._readPermissions()}catch(e){if(e instanceof n.MissingDataException)throw e;(0,a.warn)("Unable to read permissions.")}return(0,a.shadow)(this,"permissions",e)}_readPermissions(){const e=this.xref.trailer.get("Encrypt");if(!(e instanceof i.Dict))return null;let t=e.get("P");if("number"!=typeof t)return null;t+=2**32;const r=[];for(const e in a.PermissionFlag){const n=a.PermissionFlag[e];t&n&&r.push(n)}return r}get optionalContentConfig(){let e=null;try{const t=this._catDict.get("OCProperties");if(!t)return(0,a.shadow)(this,"optionalContentConfig",null);const r=t.get("D");if(!r)return(0,a.shadow)(this,"optionalContentConfig",null);const n=t.get("OCGs");if(!Array.isArray(n))return(0,a.shadow)(this,"optionalContentConfig",null);const s=[],o=[];for(const e of n){if(!(e instanceof i.Ref))continue;o.push(e);const t=this.xref.fetchIfRef(e);s.push({id:e.toString(),name:"string"==typeof t.get("Name")?(0,a.stringToPDFString)(t.get("Name")):null,intent:"string"==typeof t.get("Intent")?(0,a.stringToPDFString)(t.get("Intent")):null})}e=this._readOptionalContentConfig(r,o);e.groups=s}catch(e){if(e instanceof n.MissingDataException)throw e;(0,a.warn)("Unable to read optional content config: ".concat(e))}return(0,a.shadow)(this,"optionalContentConfig",e)}_readOptionalContentConfig(e,t){function parseOnOff(e){const r=[];if(Array.isArray(e))for(const n of e)n instanceof i.Ref&&t.includes(n)&&r.push(n.toString());return r}function parseOrder(e){let r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0;if(!Array.isArray(e))return null;const a=[];for(const s of e){if(s instanceof i.Ref&&t.includes(s)){n.put(s);a.push(s.toString());continue}const e=parseNestedOrder(s,r);e&&a.push(e)}if(r>0)return a;const s=[];for(const e of t)n.has(e)||s.push(e.toString());s.length&&a.push({name:null,order:s});return a}function parseNestedOrder(e,t){if(++t>s){(0,a.warn)("parseNestedOrder - reached MAX_NESTED_LEVELS.");return null}const n=r.fetchIfRef(e);if(!Array.isArray(n))return null;const i=r.fetchIfRef(n[0]);if("string"!=typeof i)return null;const o=parseOrder(n.slice(1),t);return o&&o.length?{name:(0,a.stringToPDFString)(i),order:o}:null}const r=this.xref,n=new i.RefSet,s=10;return{name:"string"==typeof e.get("Name")?(0,a.stringToPDFString)(e.get("Name")):null,creator:"string"==typeof e.get("Creator")?(0,a.stringToPDFString)(e.get("Creator")):null,baseState:e.get("BaseState")instanceof i.Name?e.get("BaseState").name:null,on:parseOnOff(e.get("ON")),off:parseOnOff(e.get("OFF")),order:parseOrder(e.get("Order")),groups:null}}setActualNumPages(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;this._actualNumPages=e}get hasActualNumPages(){return null!==this._actualNumPages}get _pagesCount(){const e=this.toplevelPagesDict.get("Count");if(!Number.isInteger(e))throw new a.FormatError("Page count in top-level pages dictionary is not an integer.");return(0,a.shadow)(this,"_pagesCount",e)}get numPages(){return this.hasActualNumPages?this._actualNumPages:this._pagesCount}get destinations(){const e=this._readDests(),t=Object.create(null);if(e instanceof s.NameTree)for(const[r,n]of e.getAll()){const e=fetchDestination(n);e&&(t[(0,a.stringToPDFString)(r)]=e)}else e instanceof i.Dict&&e.forEach((function(e,r){const n=fetchDestination(r);n&&(t[e]=n)}));return(0,a.shadow)(this,"destinations",t)}getDestination(e){const t=this._readDests();if(t instanceof s.NameTree){const r=fetchDestination(t.get(e));if(r)return r;const n=this.destinations[e];if(n){(0,a.warn)('Found "'.concat(e,'" at an incorrect position in the NameTree.'));return n}}else if(t instanceof i.Dict){const r=fetchDestination(t.get(e));if(r)return r}return null}_readDests(){const e=this._catDict.get("Names");return e&&e.has("Dests")?new s.NameTree(e.getRaw("Dests"),this.xref):this._catDict.has("Dests")?this._catDict.get("Dests"):void 0}get pageLabels(){let e=null;try{e=this._readPageLabels()}catch(e){if(e instanceof n.MissingDataException)throw e;(0,a.warn)("Unable to read page labels.")}return(0,a.shadow)(this,"pageLabels",e)}_readPageLabels(){const e=this._catDict.getRaw("PageLabels");if(!e)return null;const t=new Array(this.numPages);let r=null,o="";const c=new s.NumberTree(e,this.xref).getAll();let l="",h=1;for(let e=0,s=this.numPages;e<s;e++){const s=c.get(e);if(void 0!==s){if(!(s instanceof i.Dict))throw new a.FormatError("PageLabel is not a dictionary.");if(s.has("Type")&&!(0,i.isName)(s.get("Type"),"PageLabel"))throw new a.FormatError("Invalid type in PageLabel dictionary.");if(s.has("S")){const e=s.get("S");if(!(e instanceof i.Name))throw new a.FormatError("Invalid style in PageLabel dictionary.");r=e.name}else r=null;if(s.has("P")){const e=s.get("P");if("string"!=typeof e)throw new a.FormatError("Invalid prefix in PageLabel dictionary.");o=(0,a.stringToPDFString)(e)}else o="";if(s.has("St")){const e=s.get("St");if(!(Number.isInteger(e)&&e>=1))throw new a.FormatError("Invalid start in PageLabel dictionary.");h=e}else h=1}switch(r){case"D":l=h;break;case"R":case"r":l=(0,n.toRomanNumerals)(h,"r"===r);break;case"A":case"a":const e=26,t=65,i=97,s="a"===r?i:t,o=h-1;l=String.fromCharCode(s+o%e).repeat(Math.floor(o/e)+1);break;default:if(r)throw new a.FormatError('Invalid style "'.concat(r,'" in PageLabel dictionary.'));l=""}t[e]=o+l;h++}return t}get pageLayout(){const e=this._catDict.get("PageLayout");let t="";if(e instanceof i.Name)switch(e.name){case"SinglePage":case"OneColumn":case"TwoColumnLeft":case"TwoColumnRight":case"TwoPageLeft":case"TwoPageRight":t=e.name}return(0,a.shadow)(this,"pageLayout",t)}get pageMode(){const e=this._catDict.get("PageMode");let t="UseNone";if(e instanceof i.Name)switch(e.name){case"UseNone":case"UseOutlines":case"UseThumbs":case"FullScreen":case"UseOC":case"UseAttachments":t=e.name}return(0,a.shadow)(this,"pageMode",t)}get viewerPreferences(){const e=this._catDict.get("ViewerPreferences");if(!(e instanceof i.Dict))return(0,a.shadow)(this,"viewerPreferences",null);let t=null;for(const r of e.getKeys()){const n=e.get(r);let s;switch(r){case"HideToolbar":case"HideMenubar":case"HideWindowUI":case"FitWindow":case"CenterWindow":case"DisplayDocTitle":case"PickTrayByPDFSize":"boolean"==typeof n&&(s=n);break;case"NonFullScreenPageMode":if(n instanceof i.Name)switch(n.name){case"UseNone":case"UseOutlines":case"UseThumbs":case"UseOC":s=n.name;break;default:s="UseNone"}break;case"Direction":if(n instanceof i.Name)switch(n.name){case"L2R":case"R2L":s=n.name;break;default:s="L2R"}break;case"ViewArea":case"ViewClip":case"PrintArea":case"PrintClip":if(n instanceof i.Name)switch(n.name){case"MediaBox":case"CropBox":case"BleedBox":case"TrimBox":case"ArtBox":s=n.name;break;default:s="CropBox"}break;case"PrintScaling":if(n instanceof i.Name)switch(n.name){case"None":case"AppDefault":s=n.name;break;default:s="AppDefault"}break;case"Duplex":if(n instanceof i.Name)switch(n.name){case"Simplex":case"DuplexFlipShortEdge":case"DuplexFlipLongEdge":s=n.name;break;default:s="None"}break;case"PrintPageRange":if(Array.isArray(n)&&n.length%2==0){n.every(((e,t,r)=>Number.isInteger(e)&&e>0&&(0===t||e>=r[t-1])&&e<=this.numPages))&&(s=n)}break;case"NumCopies":Number.isInteger(n)&&n>0&&(s=n);break;default:(0,a.warn)("Ignoring non-standard key in ViewerPreferences: ".concat(r,"."));continue}if(void 0!==s){t||(t=Object.create(null));t[r]=s}else(0,a.warn)('Bad value, for key "'.concat(r,'", in ViewerPreferences: ').concat(n,"."))}return(0,a.shadow)(this,"viewerPreferences",t)}get openAction(){const e=this._catDict.get("OpenAction"),t=Object.create(null);if(e instanceof i.Dict){const r=new i.Dict(this.xref);r.set("A",e);const n={url:null,dest:null,action:null};Catalog.parseDestDictionary({destDict:r,resultObj:n});Array.isArray(n.dest)?t.dest=n.dest:n.action&&(t.action=n.action)}else Array.isArray(e)&&(t.dest=e);return(0,a.shadow)(this,"openAction",(0,a.objectSize)(t)>0?t:null)}get attachments(){const e=this._catDict.get("Names");let t=null;if(e instanceof i.Dict&&e.has("EmbeddedFiles")){const r=new s.NameTree(e.getRaw("EmbeddedFiles"),this.xref);for(const[e,n]of r.getAll()){const r=new h.FileSpec(n,this.xref);t||(t=Object.create(null));t[(0,a.stringToPDFString)(e)]=r.serializable}}return(0,a.shadow)(this,"attachments",t)}get xfaImages(){const e=this._catDict.get("Names");let t=null;if(e instanceof i.Dict&&e.has("XFAImages")){const r=new s.NameTree(e.getRaw("XFAImages"),this.xref);for(const[e,n]of r.getAll()){t||(t=new i.Dict(this.xref));t.set((0,a.stringToPDFString)(e),n)}}return(0,a.shadow)(this,"xfaImages",t)}_collectJavaScript(){const e=this._catDict.get("Names");let t=null;function appendIfJavaScriptDict(e,r){if(!(r instanceof i.Dict))return;if(!(0,i.isName)(r.get("S"),"JavaScript"))return;let n=r.get("JS");if(n instanceof o.BaseStream)n=n.getString();else if("string"!=typeof n)return;null===t&&(t=new Map);t.set(e,(0,a.stringToPDFString)(n))}if(e instanceof i.Dict&&e.has("JavaScript")){const t=new s.NameTree(e.getRaw("JavaScript"),this.xref);for(const[e,r]of t.getAll())appendIfJavaScriptDict((0,a.stringToPDFString)(e),r)}const r=this._catDict.get("OpenAction");r&&appendIfJavaScriptDict("OpenAction",r);return t}get javaScript(){const e=this._collectJavaScript();return(0,a.shadow)(this,"javaScript",e?[...e.values()]:null)}get jsActions(){const e=this._collectJavaScript();let t=(0,n.collectActions)(this.xref,this._catDict,a.DocumentActionEventType);if(e){t||(t=Object.create(null));for(const[r,n]of e)r in t?t[r].push(n):t[r]=[n]}return(0,a.shadow)(this,"jsActions",t)}async fontFallback(e,t){const r=await Promise.all(this.fontCache);for(const n of r)if(n.loadedName===e){n.fallback(t);return}}async cleanup(){let e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];(0,c.clearGlobalCaches)();this.globalImageCache.clear(e);this.pageKidsCountCache.clear();this.pageIndexCache.clear();this.nonBlendModesSet.clear();const t=await Promise.all(this.fontCache);for(const{dict:e}of t)delete e.cacheKey;this.fontCache.clear();this.builtInCMapCache.clear();this.standardFontDataCache.clear()}async getPageDict(e){const t=[this.toplevelPagesDict],r=new i.RefSet,n=this._catDict.getRaw("Pages");n instanceof i.Ref&&r.put(n);const s=this.xref,o=this.pageKidsCountCache,c=this.pageIndexCache;let l=0;for(;t.length;){const n=t.pop();if(n instanceof i.Ref){const h=o.get(n);if(h>=0&&l+h<=e){l+=h;continue}if(r.has(n))throw new a.FormatError("Pages tree contains circular reference.");r.put(n);const u=await s.fetchAsync(n);if(u instanceof i.Dict){let t=u.getRaw("Type");t instanceof i.Ref&&(t=await s.fetchAsync(t));if((0,i.isName)(t,"Page")||!u.has("Kids")){o.has(n)||o.put(n,1);c.has(n)||c.put(n,l);if(l===e)return[u,n];l++;continue}}t.push(u);continue}if(!(n instanceof i.Dict))throw new a.FormatError("Page dictionary kid reference points to wrong type of object.");const{objId:h}=n;let u=n.getRaw("Count");u instanceof i.Ref&&(u=await s.fetchAsync(u));if(Number.isInteger(u)&&u>=0){h&&!o.has(h)&&o.put(h,u);if(l+u<=e){l+=u;continue}}let d=n.getRaw("Kids");d instanceof i.Ref&&(d=await s.fetchAsync(d));if(!Array.isArray(d)){let t=n.getRaw("Type");t instanceof i.Ref&&(t=await s.fetchAsync(t));if((0,i.isName)(t,"Page")||!n.has("Kids")){if(l===e)return[n,null];l++;continue}throw new a.FormatError("Page dictionary kids object is not an array.")}for(let e=d.length-1;e>=0;e--)t.push(d[e])}throw new Error("Page index ".concat(e," not found."))}async getAllPageDicts(){let e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];const t=[{currentNode:this.toplevelPagesDict,posInKids:0}],r=new i.RefSet,s=this._catDict.getRaw("Pages");s instanceof i.Ref&&r.put(s);const o=new Map,c=this.xref,l=this.pageIndexCache;let h=0;function addPageDict(e,t){t&&!l.has(t)&&l.put(t,h);o.set(h++,[e,t])}function addPageError(t){if(t instanceof n.XRefEntryException&&!e)throw t;o.set(h++,[t,null])}for(;t.length>0;){const e=t.at(-1),{currentNode:n,posInKids:s}=e;let o=n.getRaw("Kids");if(o instanceof i.Ref)try{o=await c.fetchAsync(o)}catch(e){addPageError(e);break}if(!Array.isArray(o)){addPageError(new a.FormatError("Page dictionary kids object is not an array."));break}if(s>=o.length){t.pop();continue}const l=o[s];let h;if(l instanceof i.Ref){if(r.has(l)){addPageError(new a.FormatError("Pages tree contains circular reference."));break}r.put(l);try{h=await c.fetchAsync(l)}catch(e){addPageError(e);break}}else h=l;if(!(h instanceof i.Dict)){addPageError(new a.FormatError("Page dictionary kid reference points to wrong type of object."));break}let u=h.getRaw("Type");if(u instanceof i.Ref)try{u=await c.fetchAsync(u)}catch(e){addPageError(e);break}(0,i.isName)(u,"Page")||!h.has("Kids")?addPageDict(h,l instanceof i.Ref?l:null):t.push({currentNode:h,posInKids:0});e.posInKids++}return o}getPageIndex(e){const t=this.pageIndexCache.get(e);if(void 0!==t)return Promise.resolve(t);const r=this.xref;let n=0;const next=t=>function pagesBeforeRef(t){let n,s=0;return r.fetchAsync(t).then((function(r){if((0,i.isRefsEqual)(t,e)&&!(0,i.isDict)(r,"Page")&&!(r instanceof i.Dict&&!r.has("Type")&&r.has("Contents")))throw new a.FormatError("The reference does not point to a /Page dictionary.");if(!r)return null;if(!(r instanceof i.Dict))throw new a.FormatError("Node must be a dictionary.");n=r.getRaw("Parent");return r.getAsync("Parent")})).then((function(e){if(!e)return null;if(!(e instanceof i.Dict))throw new a.FormatError("Parent must be a dictionary.");return e.getAsync("Kids")})).then((function(e){if(!e)return null;const o=[];let c=!1;for(let n=0,l=e.length;n<l;n++){const l=e[n];if(!(l instanceof i.Ref))throw new a.FormatError("Kid must be a reference.");if((0,i.isRefsEqual)(l,t)){c=!0;break}o.push(r.fetchAsync(l).then((function(e){if(!(e instanceof i.Dict))throw new a.FormatError("Kid node must be a dictionary.");e.has("Count")?s+=e.get("Count"):s++})))}if(!c)throw new a.FormatError("Kid reference not found in parent's kids.");return Promise.all(o).then((function(){return[s,n]}))}))}(t).then((t=>{if(!t){this.pageIndexCache.put(e,n);return n}const[r,a]=t;n+=r;return next(a)}));return next(e)}get baseUrl(){const e=this._catDict.get("URI");if(e instanceof i.Dict){const t=e.get("Base");if("string"==typeof t){const e=(0,a.createValidAbsoluteUrl)(t,null,{tryConvertEncoding:!0});if(e)return(0,a.shadow)(this,"baseUrl",e.href)}}return(0,a.shadow)(this,"baseUrl",null)}static parseDestDictionary(e){const t=e.destDict;if(!(t instanceof i.Dict)){(0,a.warn)("parseDestDictionary: `destDict` must be a dictionary.");return}const r=e.resultObj;if("object"!=typeof r){(0,a.warn)("parseDestDictionary: `resultObj` must be an object.");return}const s=e.docBaseUrl||null;let c,l,h=t.get("A");if(!(h instanceof i.Dict))if(t.has("Dest"))h=t.get("Dest");else{h=t.get("AA");h instanceof i.Dict&&(h.has("D")?h=h.get("D"):h.has("U")&&(h=h.get("U")))}if(h instanceof i.Dict){const e=h.get("S");if(!(e instanceof i.Name)){(0,a.warn)("parseDestDictionary: Invalid type in Action dictionary.");return}const t=e.name;switch(t){case"ResetForm":const e=h.get("Flags"),s=0==(1&("number"==typeof e?e:0)),u=[],d=[];for(const e of h.get("Fields")||[])e instanceof i.Ref?d.push(e.toString()):"string"==typeof e&&u.push((0,a.stringToPDFString)(e));r.resetForm={fields:u,refs:d,include:s};break;case"URI":c=h.get("URI");c instanceof i.Name&&(c="/"+c.name);break;case"GoTo":l=h.get("D");break;case"Launch":case"GoToR":const f=h.get("F");f instanceof i.Dict?c=f.get("F")||null:"string"==typeof f&&(c=f);let g=h.get("D");if(g){g instanceof i.Name&&(g=g.name);if("string"==typeof c){const e=c.split("#")[0];"string"==typeof g?c=e+"#"+g:Array.isArray(g)&&(c=e+"#"+JSON.stringify(g))}}const p=h.get("NewWindow");"boolean"==typeof p&&(r.newWindow=p);break;case"Named":const m=h.get("N");m instanceof i.Name&&(r.action=m.name);break;case"JavaScript":const b=h.get("JS");let y;b instanceof o.BaseStream?y=b.getString():"string"==typeof b&&(y=b);const w=y&&(0,n.recoverJsURL)((0,a.stringToPDFString)(y));if(w){c=w.url;r.newWindow=w.newWindow;break}default:if("JavaScript"===t||"SubmitForm"===t)break;(0,a.warn)('parseDestDictionary - unsupported action: "'.concat(t,'".'))}}else t.has("Dest")&&(l=t.get("Dest"));if("string"==typeof c){const e=(0,a.createValidAbsoluteUrl)(c,s,{addDefaultProtocol:!0,tryConvertEncoding:!0});e&&(r.url=e.href);r.unsafeUrl=c}if(l){l instanceof i.Name&&(l=l.name);"string"==typeof l?r.dest=(0,a.stringToPDFString)(l):Array.isArray(l)&&(r.dest=l)}}}t.Catalog=Catalog},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.NumberTree=t.NameTree=void 0;r(112);var n=r(209),a=r(158);class NameOrNumberTree{constructor(e,t,r){this.constructor===NameOrNumberTree&&(0,a.unreachable)("Cannot initialize NameOrNumberTree.");this.root=e;this.xref=t;this._type=r}getAll(){const e=new Map;if(!this.root)return e;const t=this.xref,r=new n.RefSet;r.put(this.root);const i=[this.root];for(;i.length>0;){const s=t.fetchIfRef(i.shift());if(!(s instanceof n.Dict))continue;if(s.has("Kids")){const e=s.get("Kids");if(!Array.isArray(e))continue;for(const t of e){if(r.has(t))throw new a.FormatError('Duplicate entry in "'.concat(this._type,'" tree.'));i.push(t);r.put(t)}continue}const o=s.get(this._type);if(Array.isArray(o))for(let r=0,n=o.length;r<n;r+=2)e.set(t.fetchIfRef(o[r]),t.fetchIfRef(o[r+1]))}return e}get(e){if(!this.root)return null;const t=this.xref;let r=t.fetchIfRef(this.root),n=0;for(;r.has("Kids");){if(++n>10){(0,a.warn)('Search depth limit reached for "'.concat(this._type,'" tree.'));return null}const i=r.get("Kids");if(!Array.isArray(i))return null;let s=0,o=i.length-1;for(;s<=o;){const n=s+o>>1,a=t.fetchIfRef(i[n]),c=a.get("Limits");if(e<t.fetchIfRef(c[0]))o=n-1;else{if(!(e>t.fetchIfRef(c[1]))){r=a;break}s=n+1}}if(s>o)return null}const i=r.get(this._type);if(Array.isArray(i)){let r=0,n=i.length-2;for(;r<=n;){const a=r+n>>1,s=a+(1&a),o=t.fetchIfRef(i[s]);if(e<o)n=s-2;else{if(!(e>o))return t.fetchIfRef(i[s+1]);r=s+2}}}return null}}t.NameTree=class NameTree extends NameOrNumberTree{constructor(e,t){super(e,t,"Names")}};t.NumberTree=class NumberTree extends NameOrNumberTree{constructor(e,t){super(e,t,"Nums")}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.clearGlobalCaches=function clearGlobalCaches(){(0,n.clearPrimitiveCaches)();(0,a.clearUnicodeCaches)()};var n=r(209),a=r(230)},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.FileSpec=void 0;r(159);r(179);var n=r(158),a=r(217),i=r(209);function pickPlatformItem(e){return e.has("UF")?e.get("UF"):e.has("F")?e.get("F"):e.has("Unix")?e.get("Unix"):e.has("Mac")?e.get("Mac"):e.has("DOS")?e.get("DOS"):null}t.FileSpec=class FileSpec{constructor(e,t){if(e instanceof i.Dict){this.xref=t;this.root=e;e.has("FS")&&(this.fs=e.get("FS"));this.description=e.has("Desc")?(0,n.stringToPDFString)(e.get("Desc")):"";e.has("RF")&&(0,n.warn)("Related file specifications are not supported");this.contentAvailable=!0;if(!e.has("EF")){this.contentAvailable=!1;(0,n.warn)("Non-embedded file specifications are not supported")}}}get filename(){if(!this._filename&&this.root){const e=pickPlatformItem(this.root)||"unnamed";this._filename=(0,n.stringToPDFString)(e).replace(/\\\\/g,"\\").replace(/\\\//g,"/").replace(/\\/g,"/")}return this._filename}get content(){if(!this.contentAvailable)return null;!this.contentRef&&this.root&&(this.contentRef=pickPlatformItem(this.root.get("EF")));let e=null;if(this.contentRef){const t=this.xref.fetchIfRef(this.contentRef);t instanceof a.BaseStream?e=t.getBytes():(0,n.warn)("Embedded file specification points to non-existing/invalid content")}else(0,n.warn)("Embedded file specification does not have a content");return e}get serializable(){return{filename:this.filename,content:this.content}}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.MetadataParser=void 0;r(112);r(159);r(179);var n=r(283);t.MetadataParser=class MetadataParser{constructor(e){e=this._repair(e);const t=new n.SimpleXMLParser({lowerCaseName:!0}).parseFromString(e);this._metadataMap=new Map;this._data=e;t&&this._parse(t)}_repair(e){return e.replace(/^[^<]+/,"").replace(/>\\376\\377([^<]+)/g,(function(e,t){const r=t.replace(/\\([0-3])([0-7])([0-7])/g,(function(e,t,r,n){return String.fromCharCode(64*t+8*r+1*n)})).replace(/&(amp|apos|gt|lt|quot);/g,(function(e,t){switch(t){case"amp":return"&";case"apos":return"'";case"gt":return">";case"lt":return"<";case"quot":return'"'}throw new Error("_repair: ".concat(t," isn't defined."))})),n=[];for(let e=0,t=r.length;e<t;e+=2){const t=256*r.charCodeAt(e)+r.charCodeAt(e+1);t>=32&&t<127&&60!==t&&62!==t&&38!==t?n.push(String.fromCharCode(t)):n.push("&#x"+(65536+t).toString(16).substring(1)+";")}return">"+n.join("")}))}_getSequence(e){const t=e.nodeName;return"rdf:bag"!==t&&"rdf:seq"!==t&&"rdf:alt"!==t?null:e.childNodes.filter((e=>"rdf:li"===e.nodeName))}_parseArray(e){if(!e.hasChildNodes())return;const[t]=e.childNodes,r=this._getSequence(t)||[];this._metadataMap.set(e.nodeName,r.map((e=>e.textContent.trim())))}_parse(e){let t=e.documentElement;if("rdf:rdf"!==t.nodeName){t=t.firstChild;for(;t&&"rdf:rdf"!==t.nodeName;)t=t.nextSibling}if(t&&"rdf:rdf"===t.nodeName&&t.hasChildNodes())for(const e of t.childNodes)if("rdf:description"===e.nodeName)for(const t of e.childNodes){const e=t.nodeName;switch(e){case"#text":continue;case"dc:creator":case"dc:subject":this._parseArray(t);continue}this._metadataMap.set(e,t.textContent.trim())}}get serializable(){return{parsedData:this._metadataMap,rawData:this._data}}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.StructTreeRoot=t.StructTreePage=void 0;r(112);var n=r(209),a=r(158),i=r(287);const s="PAGE_CONTENT",o="STREAM_CONTENT",c="OBJECT",l="ELEMENT";t.StructTreeRoot=class StructTreeRoot{constructor(e){this.dict=e;this.roleMap=new Map}init(){this.readRoleMap()}readRoleMap(){const e=this.dict.get("RoleMap");e instanceof n.Dict&&e.forEach(((e,t)=>{t instanceof n.Name&&this.roleMap.set(e,t.name)}))}};class StructElementNode{constructor(e,t){this.tree=e;this.dict=t;this.kids=[];this.parseKids()}get role(){const e=this.dict.get("S"),t=e instanceof n.Name?e.name:"",{root:r}=this.tree;return r.roleMap.has(t)?r.roleMap.get(t):t}parseKids(){let e=null;const t=this.dict.getRaw("Pg");t instanceof n.Ref&&(e=t.toString());const r=this.dict.get("K");if(Array.isArray(r))for(const t of r){const r=this.parseKid(e,t);r&&this.kids.push(r)}else{const t=this.parseKid(e,r);t&&this.kids.push(t)}}parseKid(e,t){if(Number.isInteger(t))return this.tree.pageDict.objId!==e?null:new StructElement({type:s,mcid:t,pageObjId:e});let r=null;t instanceof n.Ref?r=this.dict.xref.fetch(t):t instanceof n.Dict&&(r=t);if(!r)return null;const a=r.getRaw("Pg");a instanceof n.Ref&&(e=a.toString());const i=r.get("Type")instanceof n.Name?r.get("Type").name:null;return"MCR"===i?this.tree.pageDict.objId!==e?null:new StructElement({type:o,refObjId:r.getRaw("Stm")instanceof n.Ref?r.getRaw("Stm").toString():null,pageObjId:e,mcid:r.get("MCID")}):"OBJR"===i?this.tree.pageDict.objId!==e?null:new StructElement({type:c,refObjId:r.getRaw("Obj")instanceof n.Ref?r.getRaw("Obj").toString():null,pageObjId:e}):new StructElement({type:l,dict:r})}}class StructElement{constructor(e){let{type:t,dict:r=null,mcid:n=null,pageObjId:a=null,refObjId:i=null}=e;this.type=t;this.dict=r;this.mcid=n;this.pageObjId=a;this.refObjId=i;this.parentNode=null}}t.StructTreePage=class StructTreePage{constructor(e,t){this.root=e;this.rootDict=e?e.dict:null;this.pageDict=t;this.nodes=[]}parse(){if(!this.root||!this.rootDict)return;const e=this.rootDict.get("ParentTree");if(!e)return;const t=this.pageDict.get("StructParents");if(!Number.isInteger(t))return;const r=new i.NumberTree(e,this.rootDict.xref).get(t);if(!Array.isArray(r))return;const a=new Map;for(const e of r)e instanceof n.Ref&&this.addNode(this.rootDict.xref.fetch(e),a)}addNode(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:0;if(r>40){(0,a.warn)("StructTree MAX_DEPTH reached.");return null}if(t.has(e))return t.get(e);const i=new StructElementNode(this,e);t.set(e,i);const s=e.get("P");if(!s||(0,n.isName)(s.get("Type"),"StructTreeRoot")){this.addTopLevelNode(e,i)||t.delete(e);return i}const o=this.addNode(s,t,r+1);if(!o)return i;let c=!1;for(const t of o.kids)if(t.type===l&&t.dict===e){t.parentNode=i;c=!0}c||t.delete(e);return i}addTopLevelNode(e,t){const r=this.rootDict.get("K");if(!r)return!1;if(r instanceof n.Dict){if(r.objId!==e.objId)return!1;this.nodes[0]=t;return!0}if(!Array.isArray(r))return!0;let a=!1;for(let n=0;n<r.length;n++){const i=r[n];if(i&&i.toString()===e.objId){this.nodes[n]=t;a=!0}}return a}get serializable(){function nodeToSerializable(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:0;if(r>40){(0,a.warn)("StructTree too deep to be fully serialized.");return}const n=Object.create(null);n.role=e.role;n.children=[];t.children.push(n);const i=e.dict.get("Alt");"string"==typeof i&&(n.alt=(0,a.stringToPDFString)(i));const h=e.dict.get("Lang");"string"==typeof h&&(n.lang=(0,a.stringToPDFString)(h));for(const t of e.kids){const e=t.type===l?t.parentNode:null;e?nodeToSerializable(e,n,r+1):t.type===s||t.type===o?n.children.push({type:"content",id:"page".concat(t.pageObjId,"_mcid").concat(t.mcid)}):t.type===c&&n.children.push({type:"object",id:t.refObjId})}}const e=Object.create(null);e.children=[];e.role="Root";for(const t of this.nodes)t&&nodeToSerializable(t,e);return e}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.ObjectLoader=void 0;r(112);r(2);var n=r(209),a=r(217),i=r(213),s=r(158);function addChildren(e,t){if(e instanceof n.Dict)e=e.getRawValues();else if(e instanceof a.BaseStream)e=e.dict.getRawValues();else if(!Array.isArray(e))return;for(const i of e)((r=i)instanceof n.Ref||r instanceof n.Dict||r instanceof a.BaseStream||Array.isArray(r))&&t.push(i);var r}t.ObjectLoader=class ObjectLoader{constructor(e,t,r){this.dict=e;this.keys=t;this.xref=r;this.refSet=null}async load(){if(this.xref.stream.isDataLoaded)return;const{keys:e,dict:t}=this;this.refSet=new n.RefSet;const r=[];for(let n=0,a=e.length;n<a;n++){const a=t.getRaw(e[n]);void 0!==a&&r.push(a)}return this._walk(r)}async _walk(e){const t=[],r=[];for(;e.length;){let o=e.pop();if(o instanceof n.Ref){if(this.refSet.has(o))continue;try{this.refSet.put(o);o=this.xref.fetch(o)}catch(e){if(!(e instanceof i.MissingDataException)){(0,s.warn)('ObjectLoader._walk - requesting all data: "'.concat(e,'".'));this.refSet=null;const{manager:t}=this.xref.stream;return t.requestAllChunks()}t.push(o);r.push({begin:e.begin,end:e.end})}}if(o instanceof a.BaseStream){const e=o.getBaseStreams();if(e){let n=!1;for(const t of e)if(!t.isDataLoaded){n=!0;r.push({begin:t.start,end:t.end})}n&&t.push(o)}}addChildren(o,e)}if(r.length){await this.xref.stream.manager.requestRanges(r);for(const e of t)e instanceof n.Ref&&this.refSet.remove(e);return this._walk(t)}this.refSet=null}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.XFAFactory=void 0;r(2);r(112);r(212);var n=r(294),a=r(299),i=r(305),s=r(303),o=r(295),c=r(158),l=r(306),h=r(316);class XFAFactory{constructor(e){try{this.root=(new l.XFAParser).parse(XFAFactory._createDocument(e));const t=new a.Binder(this.root);this.form=t.bind();this.dataHandler=new i.DataHandler(this.root,t.getData());this.form[n.$globalData].template=this.form}catch(e){(0,c.warn)("XFA - an error occurred during parsing and binding: ".concat(e))}}isValid(){return this.root&&this.form}_createPagesHelper(){const e=this.form[n.$toPages]();return new Promise(((t,r)=>{const nextIteration=()=>{try{const r=e.next();r.done?t(r.value):setTimeout(nextIteration,0)}catch(e){r(e)}};setTimeout(nextIteration,0)}))}async _createPages(){try{this.pages=await this._createPagesHelper();this.dims=this.pages.children.map((e=>{const{width:t,height:r}=e.attributes.style;return[0,0,parseInt(t),parseInt(r)]}))}catch(e){(0,c.warn)("XFA - an error occurred during layout: ".concat(e))}}getBoundingBox(e){return this.dims[e]}async getNumPages(){this.pages||await this._createPages();return this.dims.length}setImages(e){this.form[n.$globalData].images=e}setFonts(e){this.form[n.$globalData].fontFinder=new s.FontFinder(e);const t=[];for(let e of this.form[n.$globalData].usedTypefaces){e=(0,o.stripQuotes)(e);this.form[n.$globalData].fontFinder.find(e)||t.push(e)}return t.length>0?t:null}appendFonts(e,t){this.form[n.$globalData].fontFinder.add(e,t)}async getPages(){this.pages||await this._createPages();const e=this.pages;this.pages=null;return e}serializeData(e){return this.dataHandler.serialize(e)}static _createDocument(e){return e["/xdp:xdp"]?Object.values(e).join(""):e["xdp:xdp"]}static getRichTextAsHtml(e){if(!e||"string"!=typeof e)return null;try{let t=new l.XFAParser(h.XhtmlNamespace,!0).parse(e);if(!["body","xhtml"].includes(t[n.$nodeName])){const e=h.XhtmlNamespace.body({});e[n.$appendChild](t);t=e}const r=t[n.$toHTML]();if(!r.success)return null;const{html:a}=r,{attributes:i}=a;if(i){i.class&&(i.class=i.class.filter((e=>!e.startsWith("xfa"))));i.dir="auto"}return{html:a,str:t[n.$text]()}}catch(e){(0,c.warn)("XFA - an error occurred during parsing of rich text: ".concat(e))}return null}}t.XFAFactory=XFAFactory},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.XmlObject=t.XFAObjectArray=t.XFAObject=t.XFAAttribute=t.StringObject=t.OptionObject=t.Option10=t.Option01=t.IntegerObject=t.ContentObject=t.$uid=t.$toStyle=t.$toString=t.$toPages=t.$toHTML=t.$text=t.$tabIndex=t.$setValue=t.$setSetAttributes=t.$setId=t.$searchNode=t.$root=t.$resolvePrototypes=t.$removeChild=t.$pushPara=t.$pushGlyphs=t.$popPara=t.$onText=t.$onChildCheck=t.$onChild=t.$nsAttributes=t.$nodeName=t.$namespaceId=t.$isUsable=t.$isTransparent=t.$isThereMoreWidth=t.$isSplittable=t.$isNsAgnostic=t.$isDescendent=t.$isDataValue=t.$isCDATAXml=t.$isBindable=t.$insertAt=t.$indexOf=t.$ids=t.$hasSettableValue=t.$globalData=t.$getTemplateRoot=t.$getSubformParent=t.$getRealChildrenByNameIt=t.$getParent=t.$getNextPage=t.$getExtra=t.$getDataValue=t.$getContainedChildren=t.$getChildrenByNameIt=t.$getChildrenByName=t.$getChildrenByClass=t.$getChildren=t.$getAvailableSpace=t.$getAttributes=t.$getAttributeIt=t.$flushHTML=t.$finalize=t.$extra=t.$dump=t.$data=t.$content=t.$consumed=t.$clone=t.$cleanup=t.$cleanPage=t.$clean=t.$childrenToHTML=t.$appendChild=t.$addHTML=t.$acceptWhitespace=void 0;r(112);r(212);var n=r(295),a=r(158),i=r(213),s=r(296),o=r(297);const c=Symbol();t.$acceptWhitespace=c;const l=Symbol();t.$addHTML=l;const h=Symbol();t.$appendChild=h;const u=Symbol();t.$childrenToHTML=u;const d=Symbol();t.$clean=d;const f=Symbol();t.$cleanPage=f;const g=Symbol();t.$cleanup=g;const p=Symbol();t.$clone=p;const m=Symbol();t.$consumed=m;const b=Symbol("content");t.$content=b;const y=Symbol("data");t.$data=y;const w=Symbol();t.$dump=w;const S=Symbol("extra");t.$extra=S;const x=Symbol();t.$finalize=x;const v=Symbol();t.$flushHTML=v;const k=Symbol();t.$getAttributeIt=k;const C=Symbol();t.$getAttributes=C;const O=Symbol();t.$getAvailableSpace=O;const T=Symbol();t.$getChildrenByClass=T;const M=Symbol();t.$getChildrenByName=M;const E=Symbol();t.$getChildrenByNameIt=E;const D=Symbol();t.$getDataValue=D;const N=Symbol();t.$getExtra=N;const R=Symbol();t.$getRealChildrenByNameIt=R;const L=Symbol();t.$getChildren=L;const j=Symbol();t.$getContainedChildren=j;const _=Symbol();t.$getNextPage=_;const U=Symbol();t.$getSubformParent=U;const $=Symbol();t.$getParent=$;const X=Symbol();t.$getTemplateRoot=X;const H=Symbol();t.$globalData=H;const q=Symbol();t.$hasSettableValue=q;const W=Symbol();t.$ids=W;const z=Symbol();t.$indexOf=z;const G=Symbol();t.$insertAt=G;const V=Symbol();t.$isCDATAXml=V;const K=Symbol();t.$isBindable=K;const Y=Symbol();t.$isDataValue=Y;const J=Symbol();t.$isDescendent=J;const Z=Symbol();t.$isNsAgnostic=Z;const Q=Symbol();t.$isSplittable=Q;const ee=Symbol();t.$isThereMoreWidth=ee;const te=Symbol();t.$isTransparent=te;const re=Symbol();t.$isUsable=re;const ne=Symbol(),ae=Symbol("namespaceId");t.$namespaceId=ae;const ie=Symbol("nodeName");t.$nodeName=ie;const se=Symbol();t.$nsAttributes=se;const oe=Symbol();t.$onChild=oe;const ce=Symbol();t.$onChildCheck=ce;const le=Symbol();t.$onText=le;const he=Symbol();t.$pushGlyphs=he;const ue=Symbol();t.$popPara=ue;const de=Symbol();t.$pushPara=de;const fe=Symbol();t.$removeChild=fe;const ge=Symbol("root");t.$root=ge;const pe=Symbol();t.$resolvePrototypes=pe;const me=Symbol();t.$searchNode=me;const be=Symbol();t.$setId=be;const ye=Symbol();t.$setSetAttributes=ye;const we=Symbol();t.$setValue=we;const Se=Symbol();t.$tabIndex=Se;const xe=Symbol();t.$text=xe;const ve=Symbol();t.$toPages=ve;const Ae=Symbol();t.$toHTML=Ae;const ke=Symbol();t.$toString=ke;const Ce=Symbol();t.$toStyle=Ce;const Fe=Symbol("uid");t.$uid=Fe;const Oe=Symbol(),Te=Symbol(),Ie=Symbol(),Pe=Symbol("_children"),Me=Symbol(),Ee=Symbol(),De=Symbol(),Be=Symbol(),Ne=Symbol(),Re=Symbol(),Le=Symbol(),je=Symbol(),_e=Symbol(),Ue=Symbol("parent"),$e=Symbol(),Xe=Symbol(),He=Symbol();let qe=0;const We=s.NamespaceIds.datasets.id;class XFAObject{constructor(e,t){let r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];this[ae]=e;this[ie]=t;this[Le]=r;this[Ue]=null;this[Pe]=[];this[Fe]="".concat(t).concat(qe++);this[H]=null}[oe](e){if(!this[Le]||!this[ce](e))return!1;const t=e[ie],r=this[t];if(!(r instanceof XFAObjectArray)){null!==r&&this[fe](r);this[t]=e;this[h](e);return!0}if(r.push(e)){this[h](e);return!0}let n="";this.id?n=" (id: ".concat(this.id,")"):this.name&&(n=" (name: ".concat(this.name," ").concat(this.h.value,")"));(0,a.warn)('XFA - node "'.concat(this[ie],'"').concat(n,' has already enough "').concat(t,'"!'));return!1}[ce](e){return this.hasOwnProperty(e[ie])&&e[ae]===this[ae]}[Z](){return!1}[c](){return!1}[V](){return!1}[K](){return!1}[ue](){this.para&&this[X]()[S].paraStack.pop()}[de](){this[X]()[S].paraStack.push(this.para)}[be](e){this.id&&this[ae]===s.NamespaceIds.template.id&&e.set(this.id,this)}[X](){return this[H].template}[Q](){return!1}[ee](){return!1}[h](e){e[Ue]=this;this[Pe].push(e);!e[H]&&this[H]&&(e[H]=this[H])}[fe](e){const t=this[Pe].indexOf(e);this[Pe].splice(t,1)}[q](){return this.hasOwnProperty("value")}[we](e){}[le](e){}[x](){}[d](e){delete this[Le];if(this[g]){e.clean(this[g]);delete this[g]}}[z](e){return this[Pe].indexOf(e)}[G](e,t){t[Ue]=this;this[Pe].splice(e,0,t);!t[H]&&this[H]&&(t[H]=this[H])}[te](){return!this.name}[ne](){return""}[xe](){return 0===this[Pe].length?this[b]:this[Pe].map((e=>e[xe]())).join("")}get[Ie](){const e=Object.getPrototypeOf(this);if(!e._attributes){const t=e._attributes=new Set;for(const e of Object.getOwnPropertyNames(this)){if(null===this[e]||this[e]instanceof XFAObject||this[e]instanceof XFAObjectArray)break;t.add(e)}}return(0,a.shadow)(this,Ie,e._attributes)}[J](e){let t=this;for(;t;){if(t===e)return!0;t=t[$]()}return!1}[$](){return this[Ue]}[U](){return this[$]()}[L](){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return e?this[e]:this[Pe]}[w](){const e=Object.create(null);this[b]&&(e.$content=this[b]);for(const t of Object.getOwnPropertyNames(this)){const r=this[t];null!==r&&(r instanceof XFAObject?e[t]=r[w]():r instanceof XFAObjectArray?r.isEmpty()||(e[t]=r.dump()):e[t]=r)}return e}[Ce](){return null}[Ae](){return n.HTMLResult.EMPTY}*[j](){for(const e of this[L]())yield e}*[Be](e,t){for(const r of this[j]())if(!e||t===e.has(r[ie])){const e=this[O](),t=r[Ae](e);t.success||(this[S].failingNode=r);yield t}}[v](){return null}[l](e,t){this[S].children.push(e)}[O](){}[u](e){let{filter:t=null,include:r=!0}=e;if(this[S].generator){const e=this[O](),t=this[S].failingNode[Ae](e);if(!t.success)return t;t.html&&this[l](t.html,t.bbox);delete this[S].failingNode}else this[S].generator=this[Be](t,r);for(;;){const e=this[S].generator.next();if(e.done)break;const t=e.value;if(!t.success)return t;t.html&&this[l](t.html,t.bbox)}this[S].generator=null;return n.HTMLResult.EMPTY}[ye](e){this[Xe]=new Set(Object.keys(e))}[Re](e){const t=this[Ie],r=this[Xe];return[...e].filter((e=>t.has(e)&&!r.has(e)))}[pe](e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:new Set;for(const r of this[Pe])r[$e](e,t)}[$e](e,t){const r=this[Ne](e,t);r?this[Oe](r,e,t):this[pe](e,t)}[Ne](e,t){const{use:r,usehref:n}=this;if(!r&&!n)return null;let i=null,s=null,c=null,l=r;if(n){l=n;n.startsWith("#som(")&&n.endsWith(")")?s=n.slice("#som(".length,n.length-1):n.startsWith(".#som(")&&n.endsWith(")")?s=n.slice(".#som(".length,n.length-1):n.startsWith("#")?c=n.slice(1):n.startsWith(".#")&&(c=n.slice(2))}else r.startsWith("#")?c=r.slice(1):s=r;this.use=this.usehref="";if(c)i=e.get(c);else{i=(0,o.searchNode)(e.get(ge),this,s,!0,!1);i&&(i=i[0])}if(!i){(0,a.warn)("XFA - Invalid prototype reference: ".concat(l,"."));return null}if(i[ie]!==this[ie]){(0,a.warn)("XFA - Incompatible prototype: ".concat(i[ie]," !== ").concat(this[ie],"."));return null}if(t.has(i)){(0,a.warn)("XFA - Cycle detected in prototypes use.");return null}t.add(i);const h=i[Ne](e,t);h&&i[Oe](h,e,t);i[pe](e,t);t.delete(i);return i}[Oe](e,t,r){if(r.has(e)){(0,a.warn)("XFA - Cycle detected in prototypes use.");return}!this[b]&&e[b]&&(this[b]=e[b]);new Set(r).add(e);for(const t of this[Re](e[Xe])){this[t]=e[t];this[Xe]&&this[Xe].add(t)}for(const n of Object.getOwnPropertyNames(this)){if(this[Ie].has(n))continue;const a=this[n],i=e[n];if(a instanceof XFAObjectArray){for(const e of a[Pe])e[$e](t,r);for(let n=a[Pe].length,s=i[Pe].length;n<s;n++){const i=e[Pe][n][p]();if(!a.push(i))break;i[Ue]=this;this[Pe].push(i);i[$e](t,r)}}else if(null===a){if(null!==i){const e=i[p]();e[Ue]=this;this[n]=e;this[Pe].push(e);e[$e](t,r)}}else{a[pe](t,r);i&&a[Oe](i,t,r)}}}static[Me](e){return Array.isArray(e)?e.map((e=>XFAObject[Me](e))):"object"==typeof e&&null!==e?Object.assign({},e):e}[p](){const e=Object.create(Object.getPrototypeOf(this));for(const t of Object.getOwnPropertySymbols(this))try{e[t]=this[t]}catch(r){(0,a.shadow)(e,t,this[t])}e[Fe]="".concat(e[ie]).concat(qe++);e[Pe]=[];for(const t of Object.getOwnPropertyNames(this)){if(this[Ie].has(t)){e[t]=XFAObject[Me](this[t]);continue}const r=this[t];e[t]=r instanceof XFAObjectArray?new XFAObjectArray(r[je]):null}for(const t of this[Pe]){const r=t[ie],n=t[p]();e[Pe].push(n);n[Ue]=e;null===e[r]?e[r]=n:e[r][Pe].push(n)}return e}[L](){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return e?this[Pe].filter((t=>t[ie]===e)):this[Pe]}[T](e){return this[e]}[M](e,t){let r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];return Array.from(this[E](e,t,r))}*[E](e,t){let r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if("parent"!==e){for(const r of this[Pe]){r[ie]===e&&(yield r);r.name===e&&(yield r);(t||r[te]())&&(yield*r[E](e,t,!1))}r&&this[Ie].has(e)&&(yield new XFAAttribute(this,e,this[e]))}else yield this[Ue]}}t.XFAObject=XFAObject;class XFAObjectArray{constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1/0;this[je]=e;this[Pe]=[]}push(e){if(this[Pe].length<=this[je]){this[Pe].push(e);return!0}(0,a.warn)('XFA - node "'.concat(e[ie],'" accepts no more than ').concat(this[je]," children"));return!1}isEmpty(){return 0===this[Pe].length}dump(){return 1===this[Pe].length?this[Pe][0][w]():this[Pe].map((e=>e[w]()))}[p](){const e=new XFAObjectArray(this[je]);e[Pe]=this[Pe].map((e=>e[p]()));return e}get children(){return this[Pe]}clear(){this[Pe].length=0}}t.XFAObjectArray=XFAObjectArray;class XFAAttribute{constructor(e,t,r){this[Ue]=e;this[ie]=t;this[b]=r;this[m]=!1;this[Fe]="attribute".concat(qe++)}[$](){return this[Ue]}[Y](){return!0}[D](){return this[b].trim()}[we](e){e=e.value||"";this[b]=e.toString()}[xe](){return this[b]}[J](e){return this[Ue]===e||this[Ue][J](e)}}t.XFAAttribute=XFAAttribute;class XmlObject extends XFAObject{constructor(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};super(e,t);this[b]="";this[Ee]=null;if("#text"!==t){const e=new Map;this[Te]=e;for(const[t,n]of Object.entries(r))e.set(t,new XFAAttribute(this,t,n));if(r.hasOwnProperty(se)){const e=r[se].xfa.dataNode;void 0!==e&&("dataGroup"===e?this[Ee]=!1:"dataValue"===e&&(this[Ee]=!0))}}this[m]=!1}[ke](e){const t=this[ie];if("#text"===t){e.push((0,i.encodeToXmlString)(this[b]));return}const r=(0,a.utf8StringToString)(t),n=this[ae]===We?"xfa:":"";e.push("<".concat(n).concat(r));for(const[t,r]of this[Te].entries()){const n=(0,a.utf8StringToString)(t);e.push(" ".concat(n,'="').concat((0,i.encodeToXmlString)(r[b]),'"'))}null!==this[Ee]&&(this[Ee]?e.push(' xfa:dataNode="dataValue"'):e.push(' xfa:dataNode="dataGroup"'));if(this[b]||0!==this[Pe].length){e.push(">");if(this[b])"string"==typeof this[b]?e.push((0,i.encodeToXmlString)(this[b])):this[b][ke](e);else for(const t of this[Pe])t[ke](e);e.push("</".concat(n).concat(r,">"))}else e.push("/>")}[oe](e){if(this[b]){const e=new XmlObject(this[ae],"#text");this[h](e);e[b]=this[b];this[b]=""}this[h](e);return!0}[le](e){this[b]+=e}[x](){if(this[b]&&this[Pe].length>0){const e=new XmlObject(this[ae],"#text");this[h](e);e[b]=this[b];delete this[b]}}[Ae](){return"#text"===this[ie]?n.HTMLResult.success({name:"#text",value:this[b]}):n.HTMLResult.EMPTY}[L](){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;return e?this[Pe].filter((t=>t[ie]===e)):this[Pe]}[C](){return this[Te]}[T](e){const t=this[Te].get(e);return void 0!==t?t:this[L](e)}*[E](e,t){const r=this[Te].get(e);r&&(yield r);for(const r of this[Pe]){r[ie]===e&&(yield r);t&&(yield*r[E](e,t))}}*[k](e,t){const r=this[Te].get(e);!r||t&&r[m]||(yield r);for(const r of this[Pe])yield*r[k](e,t)}*[R](e,t,r){for(const n of this[Pe]){n[ie]!==e||r&&n[m]||(yield n);t&&(yield*n[R](e,t,r))}}[Y](){return null===this[Ee]?0===this[Pe].length||this[Pe][0][ae]===s.NamespaceIds.xhtml.id:this[Ee]}[D](){return null===this[Ee]?0===this[Pe].length?this[b].trim():this[Pe][0][ae]===s.NamespaceIds.xhtml.id?this[Pe][0][xe]().trim():null:this[b].trim()}[we](e){e=e.value||"";this[b]=e.toString()}[w](){let e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];const t=Object.create(null);e&&(t.$ns=this[ae]);this[b]&&(t.$content=this[b]);t.$name=this[ie];t.children=[];for(const r of this[Pe])t.children.push(r[w](e));t.attributes=Object.create(null);for(const[e,r]of this[Te])t.attributes[e]=r[b];return t}}t.XmlObject=XmlObject;class ContentObject extends XFAObject{constructor(e,t){super(e,t);this[b]=""}[le](e){this[b]+=e}[x](){}}t.ContentObject=ContentObject;t.OptionObject=class OptionObject extends ContentObject{constructor(e,t,r){super(e,t);this[_e]=r}[x](){this[b]=(0,n.getKeyword)({data:this[b],defaultValue:this[_e][0],validate:e=>this[_e].includes(e)})}[d](e){super[d](e);delete this[_e]}};t.StringObject=class StringObject extends ContentObject{[x](){this[b]=this[b].trim()}};class IntegerObject extends ContentObject{constructor(e,t,r,n){super(e,t);this[De]=r;this[He]=n}[x](){this[b]=(0,n.getInteger)({data:this[b],defaultValue:this[De],validate:this[He]})}[d](e){super[d](e);delete this[De];delete this[He]}}t.IntegerObject=IntegerObject;t.Option01=class Option01 extends IntegerObject{constructor(e,t){super(e,t,0,(e=>1===e))}};t.Option10=class Option10 extends IntegerObject{constructor(e,t){super(e,t,1,(e=>0===e))}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.HTMLResult=void 0;t.getBBox=function getBBox(e){const t=-1;if(!e)return{x:t,y:t,width:t,height:t};const r=e.trim().split(/\s*,\s*/).map((e=>getMeasurement(e,"-1")));if(r.length<4||r[2]<0||r[3]<0)return{x:t,y:t,width:t,height:t};const[n,a,i,s]=r;return{x:n,y:a,width:i,height:s}};t.getColor=function getColor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[0,0,0],[r,n,a]=t;if(!e)return{r:r,g:n,b:a};const i=e.trim().split(/\s*,\s*/).map((e=>Math.min(Math.max(0,parseInt(e.trim(),10)),255))).map((e=>isNaN(e)?0:e));if(i.length<3)return{r:r,g:n,b:a};[r,n,a]=i;return{r:r,g:n,b:a}};t.getFloat=function getFloat(e){let{data:t,defaultValue:r,validate:n}=e;if(!t)return r;t=t.trim();const a=parseFloat(t);if(!isNaN(a)&&n(a))return a;return r};t.getInteger=function getInteger(e){let{data:t,defaultValue:r,validate:n}=e;if(!t)return r;t=t.trim();const a=parseInt(t,10);if(!isNaN(a)&&n(a))return a;return r};t.getKeyword=getKeyword;t.getMeasurement=getMeasurement;t.getRatio=function getRatio(e){if(!e)return{num:1,den:1};const t=e.trim().split(/\s*:\s*/).map((e=>parseFloat(e))).filter((e=>!isNaN(e)));1===t.length&&t.push(1);if(0===t.length)return{num:1,den:1};const[r,n]=t;return{num:r,den:n}};t.getRelevant=function getRelevant(e){if(!e)return[];return e.trim().split(/\s+/).map((e=>({excluded:"-"===e[0],viewname:e.substring(1)})))};t.getStringOption=function getStringOption(e,t){return getKeyword({data:e,defaultValue:t[0],validate:e=>t.includes(e)})};t.stripQuotes=function stripQuotes(e){if(e.startsWith("'")||e.startsWith('"'))return e.slice(1,e.length-1);return e};r(212);r(159);r(112);var n=r(158);const a={pt:e=>e,cm:e=>e/2.54*72,mm:e=>e/25.4*72,in:e=>72*e,px:e=>e},i=/([+-]?\d+\.?\d*)(.*)/;function getKeyword(e){let{data:t,defaultValue:r,validate:n}=e;if(!t)return r;t=t.trim();return n(t)?t:r}function getMeasurement(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"0";t=t||"0";if(!e)return getMeasurement(t);const r=e.trim().match(i);if(!r)return getMeasurement(t);const[,n,s]=r,o=parseFloat(n);if(isNaN(o))return getMeasurement(t);if(0===o)return 0;const c=a[s];return c?c(o):o}class HTMLResult{static get FAILURE(){return(0,n.shadow)(this,"FAILURE",new HTMLResult(!1,null,null,null))}static get EMPTY(){return(0,n.shadow)(this,"EMPTY",new HTMLResult(!0,null,null,null))}constructor(e,t,r,n){this.success=e;this.html=t;this.bbox=r;this.breakNode=n}isBreak(){return!!this.breakNode}static breakNode(e){return new HTMLResult(!1,null,null,e)}static success(e){return new HTMLResult(!0,e,arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,null)}}t.HTMLResult=HTMLResult},(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.NamespaceIds=t.$buildXFAObject=void 0;const r=Symbol();t.$buildXFAObject=r;t.NamespaceIds={config:{id:0,check:e=>e.startsWith("http://www.xfa.org/schema/xci/")},connectionSet:{id:1,check:e=>e.startsWith("http://www.xfa.org/schema/xfa-connection-set/")},datasets:{id:2,check:e=>e.startsWith("http://www.xfa.org/schema/xfa-data/")},form:{id:3,check:e=>e.startsWith("http://www.xfa.org/schema/xfa-form/")},localeSet:{id:4,check:e=>e.startsWith("http://www.xfa.org/schema/xfa-locale-set/")},pdf:{id:5,check:e=>"http://ns.adobe.com/xdp/pdf/"===e},signature:{id:6,check:e=>"http://www.w3.org/2000/09/xmldsig#"===e},sourceSet:{id:7,check:e=>e.startsWith("http://www.xfa.org/schema/xfa-source-set/")},stylesheet:{id:8,check:e=>"http://www.w3.org/1999/XSL/Transform"===e},template:{id:9,check:e=>e.startsWith("http://www.xfa.org/schema/xfa-template/")},xdc:{id:10,check:e=>e.startsWith("http://www.xfa.org/schema/xdc/")},xdp:{id:11,check:e=>"http://ns.adobe.com/xdp/"===e},xfdf:{id:12,check:e=>"http://ns.adobe.com/xfdf/"===e},xhtml:{id:13,check:e=>"http://www.w3.org/1999/xhtml"===e},xmpmeta:{id:14,check:e=>"http://ns.adobe.com/xmpmeta/"===e}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.createDataNode=function createDataNode(e,t,r){const a=parseExpression(r);if(!a)return null;if(a.some((e=>e.operator===l)))return null;const s=f.get(a[0].name);let o=0;if(s){e=s(e,t);o=1}else e=t||e;for(let t=a.length;o<t;o++){const{name:t,operator:r,index:s}=a[o];if(!isFinite(s)){a[o].index=0;return createNodes(e,a.slice(o))}let u;switch(r){case c:u=e[n.$getChildrenByName](t,!1);break;case l:u=e[n.$getChildrenByName](t,!0);break;case h:u=e[n.$getChildrenByClass](t);u=u instanceof n.XFAObjectArray?u.children:[u]}if(0===u.length)return createNodes(e,a.slice(o));if(!(s<u.length)){a[o].index=s-u.length;return createNodes(e,a.slice(o))}{const t=u[s];if(!(t instanceof n.XFAObject)){(0,i.warn)("XFA - Cannot create a node.");return null}e=t}}return null};t.searchNode=function searchNode(e,t,r){let a=!(arguments.length>3&&void 0!==arguments[3])||arguments[3],i=!(arguments.length>4&&void 0!==arguments[4])||arguments[4];const s=parseExpression(r,a);if(!s)return null;const o=f.get(s[0].name);let u,d=0;if(o){u=!0;e=[o(e,t)];d=1}else{u=null===t;e=[t||e]}for(let r=s.length;d<r;d++){const{name:r,cacheName:a,operator:o,index:f}=s[d],p=[];for(const t of e){if(!(t instanceof n.XFAObject))continue;let e,s;if(i){s=g.get(t);if(!s){s=new Map;g.set(t,s)}e=s.get(a)}if(!e){switch(o){case c:e=t[n.$getChildrenByName](r,!1);break;case l:e=t[n.$getChildrenByName](r,!0);break;case h:e=t[n.$getChildrenByClass](r);e=e instanceof n.XFAObjectArray?e.children:[e]}i&&s.set(a,e)}e.length>0&&p.push(e)}if(0!==p.length||u||0!==d)e=isFinite(f)?p.filter((e=>f<e.length)).map((e=>e[f])):p.flat();else{const r=t[n.$getParent]();if(!(t=r))return null;d=-1;e=[t]}}if(0===e.length)return null;return e};r(112);r(159);r(298);var n=r(294),a=r(296),i=r(158);const s=/^[^.[]+/,o=/^[^\]]+/,c=0,l=1,h=2,u=3,d=4,f=new Map([["$data",(e,t)=>e.datasets?e.datasets.data:e],["$record",(e,t)=>(e.datasets?e.datasets.data:e)[n.$getChildren]()[0]],["$template",(e,t)=>e.template],["$connectionSet",(e,t)=>e.connectionSet],["$form",(e,t)=>e.form],["$layout",(e,t)=>e.layout],["$host",(e,t)=>e.host],["$dataWindow",(e,t)=>e.dataWindow],["$event",(e,t)=>e.event],["!",(e,t)=>e.datasets],["$xfa",(e,t)=>e],["xfa",(e,t)=>e],["$",(e,t)=>t]]),g=new WeakMap,p=a.NamespaceIds.datasets.id;function parseIndex(e){return"*"===(e=e.trim())?1/0:parseInt(e,10)||0}function parseExpression(e,t){let r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n=e.match(s);if(!n)return null;let[a]=n;const f=[{name:a,cacheName:"."+a,index:0,js:null,formCalc:null,operator:c}];let g=a.length;for(;g<e.length;){const p=g;if("["===e.charAt(g++)){n=e.slice(g).match(o);if(!n){(0,i.warn)("XFA - Invalid index in SOM expression");return null}f.at(-1).index=parseIndex(n[0]);g+=n[0].length+1;continue}let m;switch(e.charAt(g)){case".":if(!t)return null;g++;m=l;break;case"#":g++;m=h;break;case"[":if(r){(0,i.warn)("XFA - SOM expression contains a FormCalc subexpression which is not supported for now.");return null}m=u;break;case"(":if(r){(0,i.warn)("XFA - SOM expression contains a JavaScript subexpression which is not supported for now.");return null}m=d;break;default:m=c}n=e.slice(g).match(s);if(!n)break;[a]=n;g+=a.length;f.push({name:a,cacheName:e.slice(p,g),operator:m,index:0,js:null,formCalc:null})}return f}function createNodes(e,t){let r=null;for(const{name:a,index:i}of t){for(let t=0,s=isFinite(i)?i:0;t<=s;t++){const t=e[n.$namespaceId]===p?-1:e[n.$namespaceId];r=new n.XmlObject(t,a);e[n.$appendChild](r)}e=r}return r}},(e,t,r)=>{r(116)("flat")},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.Binder=void 0;r(112);r(159);var n=r(294),a=r(300),i=r(297),s=r(296),o=r(158);const c=s.NamespaceIds.datasets.id;function createText(e){const t=new a.Text({});t[n.$content]=e;return t}t.Binder=class Binder{constructor(e){this.root=e;this.datasets=e.datasets;e.datasets&&e.datasets.data?this.data=e.datasets.data:this.data=new n.XmlObject(s.NamespaceIds.datasets.id,"data");this.emptyMerge=0===this.data[n.$getChildren]().length;this.root.form=this.form=e.template[n.$clone]()}_isConsumeData(){return!this.emptyMerge&&this._mergeMode}_isMatchTemplate(){return!this._isConsumeData()}bind(){this._bindElement(this.form,this.data);return this.form}getData(){return this.data}_bindValue(e,t,r){e[n.$data]=t;if(e[n.$hasSettableValue]())if(t[n.$isDataValue]()){const r=t[n.$getDataValue]();e[n.$setValue](createText(r))}else if(e instanceof a.Field&&e.ui&&e.ui.choiceList&&"multiSelect"===e.ui.choiceList.open){const r=t[n.$getChildren]().map((e=>e[n.$content].trim())).join("\n");e[n.$setValue](createText(r))}else this._isConsumeData()&&(0,o.warn)("XFA - Nodes haven't the same type.");else!t[n.$isDataValue]()||this._isMatchTemplate()?this._bindElement(e,t):(0,o.warn)("XFA - Nodes haven't the same type.")}_findDataByNameToConsume(e,t,r,a){if(!e)return null;let i,o;for(let a=0;a<3;a++){i=r[n.$getRealChildrenByNameIt](e,!1,!0);for(;;){o=i.next().value;if(!o)break;if(t===o[n.$isDataValue]())return o}if(r[n.$namespaceId]===s.NamespaceIds.datasets.id&&"data"===r[n.$nodeName])break;r=r[n.$getParent]()}if(!a)return null;i=this.data[n.$getRealChildrenByNameIt](e,!0,!1);o=i.next().value;if(o)return o;i=this.data[n.$getAttributeIt](e,!0);o=i.next().value;return o&&o[n.$isDataValue]()?o:null}_setProperties(e,t){if(e.hasOwnProperty("setProperty"))for(const{ref:r,target:s,connection:c}of e.setProperty.children){if(c)continue;if(!r)continue;const l=(0,i.searchNode)(this.root,t,r,!1,!1);if(!l){(0,o.warn)("XFA - Invalid reference: ".concat(r,"."));continue}const[h]=l;if(!h[n.$isDescendent](this.data)){(0,o.warn)("XFA - Invalid node: must be a data node.");continue}const u=(0,i.searchNode)(this.root,e,s,!1,!1);if(!u){(0,o.warn)("XFA - Invalid target: ".concat(s,"."));continue}const[d]=u;if(!d[n.$isDescendent](e)){(0,o.warn)("XFA - Invalid target: must be a property or subproperty.");continue}const f=d[n.$getParent]();if(d instanceof a.SetProperty||f instanceof a.SetProperty){(0,o.warn)("XFA - Invalid target: cannot be a setProperty or one of its properties.");continue}if(d instanceof a.BindItems||f instanceof a.BindItems){(0,o.warn)("XFA - Invalid target: cannot be a bindItems or one of its properties.");continue}const g=h[n.$text](),p=d[n.$nodeName];if(d instanceof n.XFAAttribute){const e=Object.create(null);e[p]=g;const t=Reflect.construct(Object.getPrototypeOf(f).constructor,[e]);f[p]=t[p]}else if(d.hasOwnProperty(n.$content)){d[n.$data]=h;d[n.$content]=g;d[n.$finalize]()}else(0,o.warn)("XFA - Invalid node to use in setProperty")}}_bindItems(e,t){if(!e.hasOwnProperty("items")||!e.hasOwnProperty("bindItems")||e.bindItems.isEmpty())return;for(const t of e.items.children)e[n.$removeChild](t);e.items.clear();const r=new a.Items({}),s=new a.Items({});e[n.$appendChild](r);e.items.push(r);e[n.$appendChild](s);e.items.push(s);for(const{ref:a,labelRef:c,valueRef:l,connection:h}of e.bindItems.children){if(h)continue;if(!a)continue;const e=(0,i.searchNode)(this.root,t,a,!1,!1);if(e)for(const t of e){if(!t[n.$isDescendent](this.datasets)){(0,o.warn)("XFA - Invalid ref (".concat(a,"): must be a datasets child."));continue}const e=(0,i.searchNode)(this.root,t,c,!0,!1);if(!e){(0,o.warn)("XFA - Invalid label: ".concat(c,"."));continue}const[h]=e;if(!h[n.$isDescendent](this.datasets)){(0,o.warn)("XFA - Invalid label: must be a datasets child.");continue}const u=(0,i.searchNode)(this.root,t,l,!0,!1);if(!u){(0,o.warn)("XFA - Invalid value: ".concat(l,"."));continue}const[d]=u;if(!d[n.$isDescendent](this.datasets)){(0,o.warn)("XFA - Invalid value: must be a datasets child.");continue}const f=createText(h[n.$text]()),g=createText(d[n.$text]());r[n.$appendChild](f);r.text.push(f);s[n.$appendChild](g);s.text.push(g)}else(0,o.warn)("XFA - Invalid reference: ".concat(a,"."))}}_bindOccurrences(e,t,r){let a;if(t.length>1){a=e[n.$clone]();a[n.$removeChild](a.occur);a.occur=null}this._bindValue(e,t[0],r);this._setProperties(e,t[0]);this._bindItems(e,t[0]);if(1===t.length)return;const i=e[n.$getParent](),s=e[n.$nodeName],o=i[n.$indexOf](e);for(let e=1,c=t.length;e<c;e++){const c=t[e],l=a[n.$clone]();i[s].push(l);i[n.$insertAt](o+e,l);this._bindValue(l,c,r);this._setProperties(l,c);this._bindItems(l,c)}}_createOccurrences(e){if(!this.emptyMerge)return;const{occur:t}=e;if(!t||t.initial<=1)return;const r=e[n.$getParent](),a=e[n.$nodeName];if(!(r[a]instanceof n.XFAObjectArray))return;let i;i=e.name?r[a].children.filter((t=>t.name===e.name)).length:r[a].children.length;const s=r[n.$indexOf](e)+1,o=t.initial-i;if(o){const t=e[n.$clone]();t[n.$removeChild](t.occur);t.occur=null;r[a].push(t);r[n.$insertAt](s,t);for(let e=1;e<o;e++){const i=t[n.$clone]();r[a].push(i);r[n.$insertAt](s+e,i)}}}_getOccurInfo(e){const{name:t,occur:r}=e;if(!r||!t)return[1,1];const n=-1===r.max?1/0:r.max;return[r.min,n]}_setAndBind(e,t){this._setProperties(e,t);this._bindItems(e,t);this._bindElement(e,t)}_bindElement(e,t){const r=[];this._createOccurrences(e);for(const a of e[n.$getChildren]()){if(a[n.$data])continue;if(void 0===this._mergeMode&&"subform"===a[n.$nodeName]){this._mergeMode="consumeData"===a.mergeMode;const e=t[n.$getChildren]();if(e.length>0)this._bindOccurrences(a,[e[0]],null);else if(this.emptyMerge){const e=t[n.$namespaceId]===c?-1:t[n.$namespaceId],r=a[n.$data]=new n.XmlObject(e,a.name||"root");t[n.$appendChild](r);this._bindElement(a,r)}continue}if(!a[n.$isBindable]())continue;let e=!1,s=null,l=null,h=null;if(a.bind){switch(a.bind.match){case"none":this._setAndBind(a,t);continue;case"global":e=!0;break;case"dataRef":if(!a.bind.ref){(0,o.warn)("XFA - ref is empty in node ".concat(a[n.$nodeName],"."));this._setAndBind(a,t);continue}l=a.bind.ref}a.bind.picture&&(s=a.bind.picture[n.$content])}const[u,d]=this._getOccurInfo(a);if(l){h=(0,i.searchNode)(this.root,t,l,!0,!1);if(null===h){h=(0,i.createDataNode)(this.data,t,l);if(!h)continue;this._isConsumeData()&&(h[n.$consumed]=!0);this._setAndBind(a,h);continue}this._isConsumeData()&&(h=h.filter((e=>!e[n.$consumed])));h.length>d?h=h.slice(0,d):0===h.length&&(h=null);h&&this._isConsumeData()&&h.forEach((e=>{e[n.$consumed]=!0}))}else{if(!a.name){this._setAndBind(a,t);continue}if(this._isConsumeData()){const r=[];for(;r.length<d;){const i=this._findDataByNameToConsume(a.name,a[n.$hasSettableValue](),t,e);if(!i)break;i[n.$consumed]=!0;r.push(i)}h=r.length>0?r:null}else{h=t[n.$getRealChildrenByNameIt](a.name,!1,this.emptyMerge).next().value;if(!h){if(0===u){r.push(a);continue}const e=t[n.$namespaceId]===c?-1:t[n.$namespaceId];h=a[n.$data]=new n.XmlObject(e,a.name);this.emptyMerge&&(h[n.$consumed]=!0);t[n.$appendChild](h);this._setAndBind(a,h);continue}this.emptyMerge&&(h[n.$consumed]=!0);h=[h]}}h?this._bindOccurrences(a,h,s):u>0?this._setAndBind(a,t):r.push(a)}r.forEach((e=>e[n.$getParent]()[n.$removeChild](e)))}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.Value=t.Text=t.TemplateNamespace=t.Template=t.SetProperty=t.Items=t.Field=t.BindItems=void 0;r(112);r(159);r(212);r(166);r(177);r(179);r(155);var n=r(294),a=r(296),i=r(301),s=r(302),o=r(295),c=r(158),l=r(303),h=r(213),u=r(297);const d=a.NamespaceIds.template.id,f="http://www.w3.org/2000/svg",g=/^H(\d+)$/,p=new Set(["image/gif","image/jpeg","image/jpg","image/pjpeg","image/png","image/apng","image/x-png","image/bmp","image/x-ms-bmp","image/tiff","image/tif","application/octet-stream"]),m=[[[66,77],"image/bmp"],[[255,216,255],"image/jpeg"],[[73,73,42,0],"image/tiff"],[[77,77,0,42],"image/tiff"],[[71,73,70,56,57,97],"image/gif"],[[137,80,78,71,13,10,26,10],"image/png"]];function getBorderDims(e){if(!e||!e.border)return{w:0,h:0};const t=e.border[n.$getExtra]();return t?{w:t.widths[0]+t.widths[2]+t.insets[0]+t.insets[2],h:t.widths[1]+t.widths[3]+t.insets[1]+t.insets[3]}:{w:0,h:0}}function hasMargin(e){return e.margin&&(e.margin.topInset||e.margin.rightInset||e.margin.bottomInset||e.margin.leftInset)}function _setValue(e,t){if(!e.value){const t=new Value({});e[n.$appendChild](t);e.value=t}e.value[n.$setValue](t)}function*getContainedChildren(e){for(const t of e[n.$getChildren]())t instanceof SubformSet?yield*t[n.$getContainedChildren]():yield t}function isRequired(e){return e.validate&&"error"===e.validate.nullTest}function setTabIndex(e){for(;e;){if(!e.traversal){e[n.$tabIndex]=e[n.$getParent]()[n.$tabIndex];return}if(e[n.$tabIndex])return;let t=null;for(const r of e.traversal[n.$getChildren]())if("next"===r.operation){t=r;break}if(!t||!t.ref){e[n.$tabIndex]=e[n.$getParent]()[n.$tabIndex];return}const r=e[n.$getTemplateRoot]();e[n.$tabIndex]=++r[n.$tabIndex];const a=r[n.$searchNode](t.ref,e);if(!a)return;e=a[0]}}function applyAssist(e,t){const r=e.assist;if(r){const e=r[n.$toHTML]();e&&(t.title=e);const a=r.role.match(g);if(a){const e="heading",r=a[1];t.role=e;t["aria-level"]=r}}if("table"===e.layout)t.role="table";else if("row"===e.layout)t.role="row";else{const r=e[n.$getParent]();"row"===r.layout&&(r.assist&&"TH"===r.assist.role?t.role="columnheader":t.role="cell")}}function ariaLabel(e){if(!e.assist)return null;const t=e.assist;return t.speak&&""!==t.speak[n.$content]?t.speak[n.$content]:t.toolTip?t.toolTip[n.$content]:null}function valueToHtml(e){return o.HTMLResult.success({name:"div",attributes:{class:["xfaRich"],style:Object.create(null)},children:[{name:"span",attributes:{style:Object.create(null)},value:e}]})}function setFirstUnsplittable(e){const t=e[n.$getTemplateRoot]();if(null===t[n.$extra].firstUnsplittable){t[n.$extra].firstUnsplittable=e;t[n.$extra].noLayoutFailure=!0}}function unsetFirstUnsplittable(e){const t=e[n.$getTemplateRoot]();t[n.$extra].firstUnsplittable===e&&(t[n.$extra].noLayoutFailure=!1)}function handleBreak(e){if(e[n.$extra])return!1;e[n.$extra]=Object.create(null);if("auto"===e.targetType)return!1;const t=e[n.$getTemplateRoot]();let r=null;if(e.target){r=t[n.$searchNode](e.target,e[n.$getParent]());if(!r)return!1;r=r[0]}const{currentPageArea:a,currentContentArea:i}=t[n.$extra];if("pageArea"===e.targetType){r instanceof PageArea||(r=null);if(e.startNew){e[n.$extra].target=r||a;return!0}if(r&&r!==a){e[n.$extra].target=r;return!0}return!1}r instanceof ContentArea||(r=null);const s=r&&r[n.$getParent]();let o,c=s;if(e.startNew)if(r){const e=s.contentArea.children,t=e.indexOf(i),n=e.indexOf(r);-1!==t&&t<n&&(c=null);o=n-1}else o=a.contentArea.children.indexOf(i);else{if(!r||r===i)return!1;o=s.contentArea.children.indexOf(r)-1;c=s===a?null:s}e[n.$extra].target=c;e[n.$extra].index=o;return!0}function handleOverflow(e,t,r){const a=e[n.$getTemplateRoot](),i=a[n.$extra].noLayoutFailure,s=t[n.$getSubformParent];t[n.$getSubformParent]=()=>e;a[n.$extra].noLayoutFailure=!0;const o=t[n.$toHTML](r);e[n.$addHTML](o.html,o.bbox);a[n.$extra].noLayoutFailure=i;t[n.$getSubformParent]=s}class AppearanceFilter extends n.StringObject{constructor(e){super(d,"appearanceFilter");this.id=e.id||"";this.type=(0,o.getStringOption)(e.type,["optional","required"]);this.use=e.use||"";this.usehref=e.usehref||""}}class Arc extends n.XFAObject{constructor(e){super(d,"arc",!0);this.circular=(0,o.getInteger)({data:e.circular,defaultValue:0,validate:e=>1===e});this.hand=(0,o.getStringOption)(e.hand,["even","left","right"]);this.id=e.id||"";this.startAngle=(0,o.getFloat)({data:e.startAngle,defaultValue:0,validate:e=>!0});this.sweepAngle=(0,o.getFloat)({data:e.sweepAngle,defaultValue:360,validate:e=>!0});this.use=e.use||"";this.usehref=e.usehref||"";this.edge=null;this.fill=null}[n.$toHTML](){const e=this.edge?this.edge:new Edge({}),t=e[n.$toStyle](),r=Object.create(null);this.fill&&"visible"===this.fill.presence?Object.assign(r,this.fill[n.$toStyle]()):r.fill="transparent";r.strokeWidth=(0,s.measureToString)("visible"===e.presence?e.thickness:0);r.stroke=t.color;let a;const i={xmlns:f,style:{width:"100%",height:"100%",overflow:"visible"}};if(360===this.sweepAngle)a={name:"ellipse",attributes:{xmlns:f,cx:"50%",cy:"50%",rx:"50%",ry:"50%",style:r}};else{const e=this.startAngle*Math.PI/180,t=this.sweepAngle*Math.PI/180,n=this.sweepAngle>180?1:0,[s,o,c,l]=[50*(1+Math.cos(e)),50*(1-Math.sin(e)),50*(1+Math.cos(e+t)),50*(1-Math.sin(e+t))];a={name:"path",attributes:{xmlns:f,d:"M ".concat(s," ").concat(o," A 50 50 0 ").concat(n," 0 ").concat(c," ").concat(l),vectorEffect:"non-scaling-stroke",style:r}};Object.assign(i,{viewBox:"0 0 100 100",preserveAspectRatio:"none"})}const c={name:"svg",children:[a],attributes:i};if(hasMargin(this[n.$getParent]()[n.$getParent]()))return o.HTMLResult.success({name:"div",attributes:{style:{display:"inline",width:"100%",height:"100%"}},children:[c]});c.attributes.style.position="absolute";return o.HTMLResult.success(c)}}class Area extends n.XFAObject{constructor(e){super(d,"area",!0);this.colSpan=(0,o.getInteger)({data:e.colSpan,defaultValue:1,validate:e=>e>=1||-1===e});this.id=e.id||"";this.name=e.name||"";this.relevant=(0,o.getRelevant)(e.relevant);this.use=e.use||"";this.usehref=e.usehref||"";this.x=(0,o.getMeasurement)(e.x,"0pt");this.y=(0,o.getMeasurement)(e.y,"0pt");this.desc=null;this.extras=null;this.area=new n.XFAObjectArray;this.draw=new n.XFAObjectArray;this.exObject=new n.XFAObjectArray;this.exclGroup=new n.XFAObjectArray;this.field=new n.XFAObjectArray;this.subform=new n.XFAObjectArray;this.subformSet=new n.XFAObjectArray}*[n.$getContainedChildren](){yield*getContainedChildren(this)}[n.$isTransparent](){return!0}[n.$isBindable](){return!0}[n.$addHTML](e,t){const[r,a,i,s]=t;this[n.$extra].width=Math.max(this[n.$extra].width,r+i);this[n.$extra].height=Math.max(this[n.$extra].height,a+s);this[n.$extra].children.push(e)}[n.$getAvailableSpace](){return this[n.$extra].availableSpace}[n.$toHTML](e){const t=(0,s.toStyle)(this,"position"),r={style:t,id:this[n.$uid],class:["xfaArea"]};(0,s.isPrintOnly)(this)&&r.class.push("xfaPrintOnly");this.name&&(r.xfaName=this.name);const a=[];this[n.$extra]={children:a,width:0,height:0,availableSpace:e};const i=this[n.$childrenToHTML]({filter:new Set(["area","draw","field","exclGroup","subform","subformSet"]),include:!0});if(!i.success){if(i.isBreak())return i;delete this[n.$extra];return o.HTMLResult.FAILURE}t.width=(0,s.measureToString)(this[n.$extra].width);t.height=(0,s.measureToString)(this[n.$extra].height);const c={name:"div",attributes:r,children:a},l=[this.x,this.y,this[n.$extra].width,this[n.$extra].height];delete this[n.$extra];return o.HTMLResult.success(c,l)}}class Assist extends n.XFAObject{constructor(e){super(d,"assist",!0);this.id=e.id||"";this.role=e.role||"";this.use=e.use||"";this.usehref=e.usehref||"";this.speak=null;this.toolTip=null}[n.$toHTML](){return this.toolTip&&this.toolTip[n.$content]?this.toolTip[n.$content]:null}}class Barcode extends n.XFAObject{constructor(e){super(d,"barcode",!0);this.charEncoding=(0,o.getKeyword)({data:e.charEncoding?e.charEncoding.toLowerCase():"",defaultValue:"",validate:e=>["utf-8","big-five","fontspecific","gbk","gb-18030","gb-2312","ksc-5601","none","shift-jis","ucs-2","utf-16"].includes(e)||e.match(/iso-8859-\d{2}/)});this.checksum=(0,o.getStringOption)(e.checksum,["none","1mod10","1mod10_1mod11","2mod10","auto"]);this.dataColumnCount=(0,o.getInteger)({data:e.dataColumnCount,defaultValue:-1,validate:e=>e>=0});this.dataLength=(0,o.getInteger)({data:e.dataLength,defaultValue:-1,validate:e=>e>=0});this.dataPrep=(0,o.getStringOption)(e.dataPrep,["none","flateCompress"]);this.dataRowCount=(0,o.getInteger)({data:e.dataRowCount,defaultValue:-1,validate:e=>e>=0});this.endChar=e.endChar||"";this.errorCorrectionLevel=(0,o.getInteger)({data:e.errorCorrectionLevel,defaultValue:-1,validate:e=>e>=0&&e<=8});this.id=e.id||"";this.moduleHeight=(0,o.getMeasurement)(e.moduleHeight,"5mm");this.moduleWidth=(0,o.getMeasurement)(e.moduleWidth,"0.25mm");this.printCheckDigit=(0,o.getInteger)({data:e.printCheckDigit,defaultValue:0,validate:e=>1===e});this.rowColumnRatio=(0,o.getRatio)(e.rowColumnRatio);this.startChar=e.startChar||"";this.textLocation=(0,o.getStringOption)(e.textLocation,["below","above","aboveEmbedded","belowEmbedded","none"]);this.truncate=(0,o.getInteger)({data:e.truncate,defaultValue:0,validate:e=>1===e});this.type=(0,o.getStringOption)(e.type?e.type.toLowerCase():"",["aztec","codabar","code2of5industrial","code2of5interleaved","code2of5matrix","code2of5standard","code3of9","code3of9extended","code11","code49","code93","code128","code128a","code128b","code128c","code128sscc","datamatrix","ean8","ean8add2","ean8add5","ean13","ean13add2","ean13add5","ean13pwcd","fim","logmars","maxicode","msi","pdf417","pdf417macro","plessey","postauscust2","postauscust3","postausreplypaid","postausstandard","postukrm4scc","postusdpbc","postusimb","postusstandard","postus5zip","qrcode","rfid","rss14","rss14expanded","rss14limited","rss14stacked","rss14stackedomni","rss14truncated","telepen","ucc128","ucc128random","ucc128sscc","upca","upcaadd2","upcaadd5","upcapwcd","upce","upceadd2","upceadd5","upcean2","upcean5","upsmaxicode"]);this.upsMode=(0,o.getStringOption)(e.upsMode,["usCarrier","internationalCarrier","secureSymbol","standardSymbol"]);this.use=e.use||"";this.usehref=e.usehref||"";this.wideNarrowRatio=(0,o.getRatio)(e.wideNarrowRatio);this.encrypt=null;this.extras=null}}class Bind extends n.XFAObject{constructor(e){super(d,"bind",!0);this.match=(0,o.getStringOption)(e.match,["once","dataRef","global","none"]);this.ref=e.ref||"";this.picture=null}}class BindItems extends n.XFAObject{constructor(e){super(d,"bindItems");this.connection=e.connection||"";this.labelRef=e.labelRef||"";this.ref=e.ref||"";this.valueRef=e.valueRef||""}}t.BindItems=BindItems;class Bookend extends n.XFAObject{constructor(e){super(d,"bookend");this.id=e.id||"";this.leader=e.leader||"";this.trailer=e.trailer||"";this.use=e.use||"";this.usehref=e.usehref||""}}class BooleanElement extends n.Option01{constructor(e){super(d,"boolean");this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||""}[n.$toHTML](e){return valueToHtml(1===this[n.$content]?"1":"0")}}class Border extends n.XFAObject{constructor(e){super(d,"border",!0);this.break=(0,o.getStringOption)(e.break,["close","open"]);this.hand=(0,o.getStringOption)(e.hand,["even","left","right"]);this.id=e.id||"";this.presence=(0,o.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]);this.relevant=(0,o.getRelevant)(e.relevant);this.use=e.use||"";this.usehref=e.usehref||"";this.corner=new n.XFAObjectArray(4);this.edge=new n.XFAObjectArray(4);this.extras=null;this.fill=null;this.margin=null}[n.$getExtra](){if(!this[n.$extra]){const e=this.edge.children.slice();if(e.length<4){const t=e.at(-1)||new Edge({});for(let r=e.length;r<4;r++)e.push(t)}const t=e.map((e=>e.thickness)),r=[0,0,0,0];if(this.margin){r[0]=this.margin.topInset;r[1]=this.margin.rightInset;r[2]=this.margin.bottomInset;r[3]=this.margin.leftInset}this[n.$extra]={widths:t,insets:r,edges:e}}return this[n.$extra]}[n.$toStyle](){const{edges:e}=this[n.$getExtra](),t=e.map((e=>{const t=e[n.$toStyle]();t.color=t.color||"#000000";return t})),r=Object.create(null);this.margin&&Object.assign(r,this.margin[n.$toStyle]());this.fill&&"visible"===this.fill.presence&&Object.assign(r,this.fill[n.$toStyle]());if(this.corner.children.some((e=>0!==e.radius))){const e=this.corner.children.map((e=>e[n.$toStyle]()));if(2===e.length||3===e.length){const t=e.at(-1);for(let r=e.length;r<4;r++)e.push(t)}r.borderRadius=e.map((e=>e.radius)).join(" ")}switch(this.presence){case"invisible":case"hidden":r.borderStyle="";break;case"inactive":r.borderStyle="none";break;default:r.borderStyle=t.map((e=>e.style)).join(" ")}r.borderWidth=t.map((e=>e.width)).join(" ");r.borderColor=t.map((e=>e.color)).join(" ");return r}}class Break extends n.XFAObject{constructor(e){super(d,"break",!0);this.after=(0,o.getStringOption)(e.after,["auto","contentArea","pageArea","pageEven","pageOdd"]);this.afterTarget=e.afterTarget||"";this.before=(0,o.getStringOption)(e.before,["auto","contentArea","pageArea","pageEven","pageOdd"]);this.beforeTarget=e.beforeTarget||"";this.bookendLeader=e.bookendLeader||"";this.bookendTrailer=e.bookendTrailer||"";this.id=e.id||"";this.overflowLeader=e.overflowLeader||"";this.overflowTarget=e.overflowTarget||"";this.overflowTrailer=e.overflowTrailer||"";this.startNew=(0,o.getInteger)({data:e.startNew,defaultValue:0,validate:e=>1===e});this.use=e.use||"";this.usehref=e.usehref||"";this.extras=null}}class BreakAfter extends n.XFAObject{constructor(e){super(d,"breakAfter",!0);this.id=e.id||"";this.leader=e.leader||"";this.startNew=(0,o.getInteger)({data:e.startNew,defaultValue:0,validate:e=>1===e});this.target=e.target||"";this.targetType=(0,o.getStringOption)(e.targetType,["auto","contentArea","pageArea"]);this.trailer=e.trailer||"";this.use=e.use||"";this.usehref=e.usehref||"";this.script=null}}class BreakBefore extends n.XFAObject{constructor(e){super(d,"breakBefore",!0);this.id=e.id||"";this.leader=e.leader||"";this.startNew=(0,o.getInteger)({data:e.startNew,defaultValue:0,validate:e=>1===e});this.target=e.target||"";this.targetType=(0,o.getStringOption)(e.targetType,["auto","contentArea","pageArea"]);this.trailer=e.trailer||"";this.use=e.use||"";this.usehref=e.usehref||"";this.script=null}[n.$toHTML](e){this[n.$extra]={};return o.HTMLResult.FAILURE}}class Button extends n.XFAObject{constructor(e){super(d,"button",!0);this.highlight=(0,o.getStringOption)(e.highlight,["inverted","none","outline","push"]);this.id=e.id||"";this.use=e.use||"";this.usehref=e.usehref||"";this.extras=null}[n.$toHTML](e){const t=this[n.$getParent]()[n.$getParent](),r={name:"button",attributes:{id:this[n.$uid],class:["xfaButton"],style:{}},children:[]};for(const e of t.event.children){if("click"!==e.activity||!e.script)continue;const t=(0,h.recoverJsURL)(e.script[n.$content]);if(!t)continue;const a=(0,s.fixURL)(t.url);a&&r.children.push({name:"a",attributes:{id:"link"+this[n.$uid],href:a,newWindow:t.newWindow,class:["xfaLink"],style:{}},children:[]})}return o.HTMLResult.success(r)}}class Calculate extends n.XFAObject{constructor(e){super(d,"calculate",!0);this.id=e.id||"";this.override=(0,o.getStringOption)(e.override,["disabled","error","ignore","warning"]);this.use=e.use||"";this.usehref=e.usehref||"";this.extras=null;this.message=null;this.script=null}}class Caption extends n.XFAObject{constructor(e){super(d,"caption",!0);this.id=e.id||"";this.placement=(0,o.getStringOption)(e.placement,["left","bottom","inline","right","top"]);this.presence=(0,o.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]);this.reserve=Math.ceil((0,o.getMeasurement)(e.reserve));this.use=e.use||"";this.usehref=e.usehref||"";this.extras=null;this.font=null;this.margin=null;this.para=null;this.value=null}[n.$setValue](e){_setValue(this,e)}[n.$getExtra](e){if(!this[n.$extra]){let{width:t,height:r}=e;switch(this.placement){case"left":case"right":case"inline":t=this.reserve<=0?t:this.reserve;break;case"top":case"bottom":r=this.reserve<=0?r:this.reserve}this[n.$extra]=(0,s.layoutNode)(this,{width:t,height:r})}return this[n.$extra]}[n.$toHTML](e){if(!this.value)return o.HTMLResult.EMPTY;this[n.$pushPara]();const t=this.value[n.$toHTML](e).html;if(!t){this[n.$popPara]();return o.HTMLResult.EMPTY}const r=this.reserve;if(this.reserve<=0){const{w:t,h:r}=this[n.$getExtra](e);switch(this.placement){case"left":case"right":case"inline":this.reserve=t;break;case"top":case"bottom":this.reserve=r}}const a=[];"string"==typeof t?a.push({name:"#text",value:t}):a.push(t);const i=(0,s.toStyle)(this,"font","margin","visibility");switch(this.placement){case"left":case"right":this.reserve>0&&(i.width=(0,s.measureToString)(this.reserve));break;case"top":case"bottom":this.reserve>0&&(i.height=(0,s.measureToString)(this.reserve))}(0,s.setPara)(this,null,t);this[n.$popPara]();this.reserve=r;return o.HTMLResult.success({name:"div",attributes:{style:i,class:["xfaCaption"]},children:a})}}class Certificate extends n.StringObject{constructor(e){super(d,"certificate");this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||""}}class Certificates extends n.XFAObject{constructor(e){super(d,"certificates",!0);this.credentialServerPolicy=(0,o.getStringOption)(e.credentialServerPolicy,["optional","required"]);this.id=e.id||"";this.url=e.url||"";this.urlPolicy=e.urlPolicy||"";this.use=e.use||"";this.usehref=e.usehref||"";this.encryption=null;this.issuers=null;this.keyUsage=null;this.oids=null;this.signing=null;this.subjectDNs=null}}class CheckButton extends n.XFAObject{constructor(e){super(d,"checkButton",!0);this.id=e.id||"";this.mark=(0,o.getStringOption)(e.mark,["default","check","circle","cross","diamond","square","star"]);this.shape=(0,o.getStringOption)(e.shape,["square","round"]);this.size=(0,o.getMeasurement)(e.size,"10pt");this.use=e.use||"";this.usehref=e.usehref||"";this.border=null;this.extras=null;this.margin=null}[n.$toHTML](e){const t=(0,s.toStyle)("margin"),r=(0,s.measureToString)(this.size);t.width=t.height=r;let a,i,c;const l=this[n.$getParent]()[n.$getParent](),h=l.items.children.length&&l.items.children[0][n.$toHTML]().html||[],u={on:(void 0!==h[0]?h[0]:"on").toString(),off:(void 0!==h[1]?h[1]:"off").toString()},d=(l.value&&l.value[n.$text]()||"off")===u.on||void 0,f=l[n.$getSubformParent](),g=l[n.$uid];let p;if(f instanceof ExclGroup){c=f[n.$uid];a="radio";i="xfaRadio";p=f[n.$data]&&f[n.$data][n.$uid]||f[n.$uid]}else{a="checkbox";i="xfaCheckbox";p=l[n.$data]&&l[n.$data][n.$uid]||l[n.$uid]}const m={name:"input",attributes:{class:[i],style:t,fieldId:g,dataId:p,type:a,checked:d,xfaOn:u.on,xfaOff:u.off,"aria-label":ariaLabel(l),"aria-required":!1}};c&&(m.attributes.name=c);if(isRequired(l)){m.attributes["aria-required"]=!0;m.attributes.required=!0}return o.HTMLResult.success({name:"label",attributes:{class:["xfaLabel"]},children:[m]})}}class ChoiceList extends n.XFAObject{constructor(e){super(d,"choiceList",!0);this.commitOn=(0,o.getStringOption)(e.commitOn,["select","exit"]);this.id=e.id||"";this.open=(0,o.getStringOption)(e.open,["userControl","always","multiSelect","onEntry"]);this.textEntry=(0,o.getInteger)({data:e.textEntry,defaultValue:0,validate:e=>1===e});this.use=e.use||"";this.usehref=e.usehref||"";this.border=null;this.extras=null;this.margin=null}[n.$toHTML](e){const t=(0,s.toStyle)(this,"border","margin"),r=this[n.$getParent]()[n.$getParent](),a=r.font&&r.font.size||10,i={fontSize:"calc(".concat(a,"px * var(--zoom-factor))")},c=[];if(r.items.children.length>0){const e=r.items;let t=0,a=0;if(2===e.children.length){t=e.children[0].save;a=1-t}const s=e.children[t][n.$toHTML]().html,o=e.children[a][n.$toHTML]().html;let l=!1;const h=r.value&&r.value[n.$text]()||"";for(let e=0,t=s.length;e<t;e++){const t={name:"option",attributes:{value:o[e]||s[e],style:i},value:s[e]};o[e]===h&&(t.attributes.selected=l=!0);c.push(t)}l||c.splice(0,0,{name:"option",attributes:{hidden:!0,selected:!0},value:" "})}const l={class:["xfaSelect"],fieldId:r[n.$uid],dataId:r[n.$data]&&r[n.$data][n.$uid]||r[n.$uid],style:t,"aria-label":ariaLabel(r),"aria-required":!1};if(isRequired(r)){l["aria-required"]=!0;l.required=!0}"multiSelect"===this.open&&(l.multiple=!0);return o.HTMLResult.success({name:"label",attributes:{class:["xfaLabel"]},children:[{name:"select",children:c,attributes:l}]})}}class Color extends n.XFAObject{constructor(e){super(d,"color",!0);this.cSpace=(0,o.getStringOption)(e.cSpace,["SRGB"]);this.id=e.id||"";this.use=e.use||"";this.usehref=e.usehref||"";this.value=e.value?(0,o.getColor)(e.value):"";this.extras=null}[n.$hasSettableValue](){return!1}[n.$toStyle](){return this.value?c.Util.makeHexColor(this.value.r,this.value.g,this.value.b):null}}class Comb extends n.XFAObject{constructor(e){super(d,"comb");this.id=e.id||"";this.numberOfCells=(0,o.getInteger)({data:e.numberOfCells,defaultValue:0,validate:e=>e>=0});this.use=e.use||"";this.usehref=e.usehref||""}}class Connect extends n.XFAObject{constructor(e){super(d,"connect",!0);this.connection=e.connection||"";this.id=e.id||"";this.ref=e.ref||"";this.usage=(0,o.getStringOption)(e.usage,["exportAndImport","exportOnly","importOnly"]);this.use=e.use||"";this.usehref=e.usehref||"";this.picture=null}}class ContentArea extends n.XFAObject{constructor(e){super(d,"contentArea",!0);this.h=(0,o.getMeasurement)(e.h);this.id=e.id||"";this.name=e.name||"";this.relevant=(0,o.getRelevant)(e.relevant);this.use=e.use||"";this.usehref=e.usehref||"";this.w=(0,o.getMeasurement)(e.w);this.x=(0,o.getMeasurement)(e.x,"0pt");this.y=(0,o.getMeasurement)(e.y,"0pt");this.desc=null;this.extras=null}[n.$toHTML](e){const t={left:(0,s.measureToString)(this.x),top:(0,s.measureToString)(this.y),width:(0,s.measureToString)(this.w),height:(0,s.measureToString)(this.h)},r=["xfaContentarea"];(0,s.isPrintOnly)(this)&&r.push("xfaPrintOnly");return o.HTMLResult.success({name:"div",children:[],attributes:{style:t,class:r,id:this[n.$uid]}})}}class Corner extends n.XFAObject{constructor(e){super(d,"corner",!0);this.id=e.id||"";this.inverted=(0,o.getInteger)({data:e.inverted,defaultValue:0,validate:e=>1===e});this.join=(0,o.getStringOption)(e.join,["square","round"]);this.presence=(0,o.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]);this.radius=(0,o.getMeasurement)(e.radius);this.stroke=(0,o.getStringOption)(e.stroke,["solid","dashDot","dashDotDot","dashed","dotted","embossed","etched","lowered","raised"]);this.thickness=(0,o.getMeasurement)(e.thickness,"0.5pt");this.use=e.use||"";this.usehref=e.usehref||"";this.color=null;this.extras=null}[n.$toStyle](){const e=(0,s.toStyle)(this,"visibility");e.radius=(0,s.measureToString)("square"===this.join?0:this.radius);return e}}class DateElement extends n.ContentObject{constructor(e){super(d,"date");this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||""}[n.$finalize](){const e=this[n.$content].trim();this[n.$content]=e?new Date(e):null}[n.$toHTML](e){return valueToHtml(this[n.$content]?this[n.$content].toString():"")}}class DateTime extends n.ContentObject{constructor(e){super(d,"dateTime");this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||""}[n.$finalize](){const e=this[n.$content].trim();this[n.$content]=e?new Date(e):null}[n.$toHTML](e){return valueToHtml(this[n.$content]?this[n.$content].toString():"")}}class DateTimeEdit extends n.XFAObject{constructor(e){super(d,"dateTimeEdit",!0);this.hScrollPolicy=(0,o.getStringOption)(e.hScrollPolicy,["auto","off","on"]);this.id=e.id||"";this.picker=(0,o.getStringOption)(e.picker,["host","none"]);this.use=e.use||"";this.usehref=e.usehref||"";this.border=null;this.comb=null;this.extras=null;this.margin=null}[n.$toHTML](e){const t=(0,s.toStyle)(this,"border","font","margin"),r=this[n.$getParent]()[n.$getParent](),a={name:"input",attributes:{type:"text",fieldId:r[n.$uid],dataId:r[n.$data]&&r[n.$data][n.$uid]||r[n.$uid],class:["xfaTextfield"],style:t,"aria-label":ariaLabel(r),"aria-required":!1}};if(isRequired(r)){a.attributes["aria-required"]=!0;a.attributes.required=!0}return o.HTMLResult.success({name:"label",attributes:{class:["xfaLabel"]},children:[a]})}}class Decimal extends n.ContentObject{constructor(e){super(d,"decimal");this.fracDigits=(0,o.getInteger)({data:e.fracDigits,defaultValue:2,validate:e=>!0});this.id=e.id||"";this.leadDigits=(0,o.getInteger)({data:e.leadDigits,defaultValue:-1,validate:e=>!0});this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||""}[n.$finalize](){const e=parseFloat(this[n.$content].trim());this[n.$content]=isNaN(e)?null:e}[n.$toHTML](e){return valueToHtml(null!==this[n.$content]?this[n.$content].toString():"")}}class DefaultUi extends n.XFAObject{constructor(e){super(d,"defaultUi",!0);this.id=e.id||"";this.use=e.use||"";this.usehref=e.usehref||"";this.extras=null}}class Desc extends n.XFAObject{constructor(e){super(d,"desc",!0);this.id=e.id||"";this.use=e.use||"";this.usehref=e.usehref||"";this.boolean=new n.XFAObjectArray;this.date=new n.XFAObjectArray;this.dateTime=new n.XFAObjectArray;this.decimal=new n.XFAObjectArray;this.exData=new n.XFAObjectArray;this.float=new n.XFAObjectArray;this.image=new n.XFAObjectArray;this.integer=new n.XFAObjectArray;this.text=new n.XFAObjectArray;this.time=new n.XFAObjectArray}}class DigestMethod extends n.OptionObject{constructor(e){super(d,"digestMethod",["","SHA1","SHA256","SHA512","RIPEMD160"]);this.id=e.id||"";this.use=e.use||"";this.usehref=e.usehref||""}}class DigestMethods extends n.XFAObject{constructor(e){super(d,"digestMethods",!0);this.id=e.id||"";this.type=(0,o.getStringOption)(e.type,["optional","required"]);this.use=e.use||"";this.usehref=e.usehref||"";this.digestMethod=new n.XFAObjectArray}}class Draw extends n.XFAObject{constructor(e){super(d,"draw",!0);this.anchorType=(0,o.getStringOption)(e.anchorType,["topLeft","bottomCenter","bottomLeft","bottomRight","middleCenter","middleLeft","middleRight","topCenter","topRight"]);this.colSpan=(0,o.getInteger)({data:e.colSpan,defaultValue:1,validate:e=>e>=1||-1===e});this.h=e.h?(0,o.getMeasurement)(e.h):"";this.hAlign=(0,o.getStringOption)(e.hAlign,["left","center","justify","justifyAll","radix","right"]);this.id=e.id||"";this.locale=e.locale||"";this.maxH=(0,o.getMeasurement)(e.maxH,"0pt");this.maxW=(0,o.getMeasurement)(e.maxW,"0pt");this.minH=(0,o.getMeasurement)(e.minH,"0pt");this.minW=(0,o.getMeasurement)(e.minW,"0pt");this.name=e.name||"";this.presence=(0,o.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]);this.relevant=(0,o.getRelevant)(e.relevant);this.rotate=(0,o.getInteger)({data:e.rotate,defaultValue:0,validate:e=>e%90==0});this.use=e.use||"";this.usehref=e.usehref||"";this.w=e.w?(0,o.getMeasurement)(e.w):"";this.x=(0,o.getMeasurement)(e.x,"0pt");this.y=(0,o.getMeasurement)(e.y,"0pt");this.assist=null;this.border=null;this.caption=null;this.desc=null;this.extras=null;this.font=null;this.keep=null;this.margin=null;this.para=null;this.traversal=null;this.ui=null;this.value=null;this.setProperty=new n.XFAObjectArray}[n.$setValue](e){_setValue(this,e)}[n.$toHTML](e){setTabIndex(this);if("hidden"===this.presence||"inactive"===this.presence)return o.HTMLResult.EMPTY;(0,s.fixDimensions)(this);this[n.$pushPara]();const t=this.w,r=this.h,{w:a,h:c,isBroken:l}=(0,s.layoutNode)(this,e);if(a&&""===this.w){if(l&&this[n.$getSubformParent]()[n.$isThereMoreWidth]()){this[n.$popPara]();return o.HTMLResult.FAILURE}this.w=a}c&&""===this.h&&(this.h=c);setFirstUnsplittable(this);if(!(0,i.checkDimensions)(this,e)){this.w=t;this.h=r;this[n.$popPara]();return o.HTMLResult.FAILURE}unsetFirstUnsplittable(this);const h=(0,s.toStyle)(this,"font","hAlign","dimensions","position","presence","rotate","anchorType","border","margin");(0,s.setMinMaxDimensions)(this,h);if(h.margin){h.padding=h.margin;delete h.margin}const u=["xfaDraw"];this.font&&u.push("xfaFont");(0,s.isPrintOnly)(this)&&u.push("xfaPrintOnly");const d={style:h,id:this[n.$uid],class:u};this.name&&(d.xfaName=this.name);const f={name:"div",attributes:d,children:[]};applyAssist(this,d);const g=(0,s.computeBbox)(this,f,e),p=this.value?this.value[n.$toHTML](e).html:null;if(null===p){this.w=t;this.h=r;this[n.$popPara]();return o.HTMLResult.success((0,s.createWrapper)(this,f),g)}f.children.push(p);(0,s.setPara)(this,h,p);this.w=t;this.h=r;this[n.$popPara]();return o.HTMLResult.success((0,s.createWrapper)(this,f),g)}}class Edge extends n.XFAObject{constructor(e){super(d,"edge",!0);this.cap=(0,o.getStringOption)(e.cap,["square","butt","round"]);this.id=e.id||"";this.presence=(0,o.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]);this.stroke=(0,o.getStringOption)(e.stroke,["solid","dashDot","dashDotDot","dashed","dotted","embossed","etched","lowered","raised"]);this.thickness=(0,o.getMeasurement)(e.thickness,"0.5pt");this.use=e.use||"";this.usehref=e.usehref||"";this.color=null;this.extras=null}[n.$toStyle](){const e=(0,s.toStyle)(this,"visibility");Object.assign(e,{linecap:this.cap,width:(0,s.measureToString)(this.thickness),color:this.color?this.color[n.$toStyle]():"#000000",style:""});if("visible"!==this.presence)e.style="none";else switch(this.stroke){case"solid":e.style="solid";break;case"dashDot":case"dashDotDot":case"dashed":e.style="dashed";break;case"dotted":e.style="dotted";break;case"embossed":e.style="ridge";break;case"etched":e.style="groove";break;case"lowered":e.style="inset";break;case"raised":e.style="outset"}return e}}class Encoding extends n.OptionObject{constructor(e){super(d,"encoding",["adbe.x509.rsa_sha1","adbe.pkcs7.detached","adbe.pkcs7.sha1"]);this.id=e.id||"";this.use=e.use||"";this.usehref=e.usehref||""}}class Encodings extends n.XFAObject{constructor(e){super(d,"encodings",!0);this.id=e.id||"";this.type=(0,o.getStringOption)(e.type,["optional","required"]);this.use=e.use||"";this.usehref=e.usehref||"";this.encoding=new n.XFAObjectArray}}class Encrypt extends n.XFAObject{constructor(e){super(d,"encrypt",!0);this.id=e.id||"";this.use=e.use||"";this.usehref=e.usehref||"";this.certificate=null}}class EncryptData extends n.XFAObject{constructor(e){super(d,"encryptData",!0);this.id=e.id||"";this.operation=(0,o.getStringOption)(e.operation,["encrypt","decrypt"]);this.target=e.target||"";this.use=e.use||"";this.usehref=e.usehref||"";this.filter=null;this.manifest=null}}class Encryption extends n.XFAObject{constructor(e){super(d,"encryption",!0);this.id=e.id||"";this.type=(0,o.getStringOption)(e.type,["optional","required"]);this.use=e.use||"";this.usehref=e.usehref||"";this.certificate=new n.XFAObjectArray}}class EncryptionMethod extends n.OptionObject{constructor(e){super(d,"encryptionMethod",["","AES256-CBC","TRIPLEDES-CBC","AES128-CBC","AES192-CBC"]);this.id=e.id||"";this.use=e.use||"";this.usehref=e.usehref||""}}class EncryptionMethods extends n.XFAObject{constructor(e){super(d,"encryptionMethods",!0);this.id=e.id||"";this.type=(0,o.getStringOption)(e.type,["optional","required"]);this.use=e.use||"";this.usehref=e.usehref||"";this.encryptionMethod=new n.XFAObjectArray}}class Event extends n.XFAObject{constructor(e){super(d,"event",!0);this.activity=(0,o.getStringOption)(e.activity,["click","change","docClose","docReady","enter","exit","full","indexChange","initialize","mouseDown","mouseEnter","mouseExit","mouseUp","postExecute","postOpen","postPrint","postSave","postSign","postSubmit","preExecute","preOpen","prePrint","preSave","preSign","preSubmit","ready","validationState"]);this.id=e.id||"";this.listen=(0,o.getStringOption)(e.listen,["refOnly","refAndDescendents"]);this.name=e.name||"";this.ref=e.ref||"";this.use=e.use||"";this.usehref=e.usehref||"";this.extras=null;this.encryptData=null;this.execute=null;this.script=null;this.signData=null;this.submit=null}}class ExData extends n.ContentObject{constructor(e){super(d,"exData");this.contentType=e.contentType||"";this.href=e.href||"";this.id=e.id||"";this.maxLength=(0,o.getInteger)({data:e.maxLength,defaultValue:-1,validate:e=>e>=-1});this.name=e.name||"";this.rid=e.rid||"";this.transferEncoding=(0,o.getStringOption)(e.transferEncoding,["none","base64","package"]);this.use=e.use||"";this.usehref=e.usehref||""}[n.$isCDATAXml](){return"text/html"===this.contentType}[n.$onChild](e){if("text/html"===this.contentType&&e[n.$namespaceId]===a.NamespaceIds.xhtml.id){this[n.$content]=e;return!0}if("text/xml"===this.contentType){this[n.$content]=e;return!0}return!1}[n.$toHTML](e){return"text/html"===this.contentType&&this[n.$content]?this[n.$content][n.$toHTML](e):o.HTMLResult.EMPTY}}class ExObject extends n.XFAObject{constructor(e){super(d,"exObject",!0);this.archive=e.archive||"";this.classId=e.classId||"";this.codeBase=e.codeBase||"";this.codeType=e.codeType||"";this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||"";this.extras=null;this.boolean=new n.XFAObjectArray;this.date=new n.XFAObjectArray;this.dateTime=new n.XFAObjectArray;this.decimal=new n.XFAObjectArray;this.exData=new n.XFAObjectArray;this.exObject=new n.XFAObjectArray;this.float=new n.XFAObjectArray;this.image=new n.XFAObjectArray;this.integer=new n.XFAObjectArray;this.text=new n.XFAObjectArray;this.time=new n.XFAObjectArray}}class ExclGroup extends n.XFAObject{constructor(e){super(d,"exclGroup",!0);this.access=(0,o.getStringOption)(e.access,["open","nonInteractive","protected","readOnly"]);this.accessKey=e.accessKey||"";this.anchorType=(0,o.getStringOption)(e.anchorType,["topLeft","bottomCenter","bottomLeft","bottomRight","middleCenter","middleLeft","middleRight","topCenter","topRight"]);this.colSpan=(0,o.getInteger)({data:e.colSpan,defaultValue:1,validate:e=>e>=1||-1===e});this.h=e.h?(0,o.getMeasurement)(e.h):"";this.hAlign=(0,o.getStringOption)(e.hAlign,["left","center","justify","justifyAll","radix","right"]);this.id=e.id||"";this.layout=(0,o.getStringOption)(e.layout,["position","lr-tb","rl-row","rl-tb","row","table","tb"]);this.maxH=(0,o.getMeasurement)(e.maxH,"0pt");this.maxW=(0,o.getMeasurement)(e.maxW,"0pt");this.minH=(0,o.getMeasurement)(e.minH,"0pt");this.minW=(0,o.getMeasurement)(e.minW,"0pt");this.name=e.name||"";this.presence=(0,o.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]);this.relevant=(0,o.getRelevant)(e.relevant);this.use=e.use||"";this.usehref=e.usehref||"";this.w=e.w?(0,o.getMeasurement)(e.w):"";this.x=(0,o.getMeasurement)(e.x,"0pt");this.y=(0,o.getMeasurement)(e.y,"0pt");this.assist=null;this.bind=null;this.border=null;this.calculate=null;this.caption=null;this.desc=null;this.extras=null;this.margin=null;this.para=null;this.traversal=null;this.validate=null;this.connect=new n.XFAObjectArray;this.event=new n.XFAObjectArray;this.field=new n.XFAObjectArray;this.setProperty=new n.XFAObjectArray}[n.$isBindable](){return!0}[n.$hasSettableValue](){return!0}[n.$setValue](e){for(const t of this.field.children){if(!t.value){const e=new Value({});t[n.$appendChild](e);t.value=e}t.value[n.$setValue](e)}}[n.$isThereMoreWidth](){return this.layout.endsWith("-tb")&&0===this[n.$extra].attempt&&this[n.$extra].numberInLine>0||this[n.$getParent]()[n.$isThereMoreWidth]()}[n.$isSplittable](){const e=this[n.$getSubformParent]();if(!e[n.$isSplittable]())return!1;if(void 0!==this[n.$extra]._isSplittable)return this[n.$extra]._isSplittable;if("position"===this.layout||this.layout.includes("row")){this[n.$extra]._isSplittable=!1;return!1}if(e.layout&&e.layout.endsWith("-tb")&&0!==e[n.$extra].numberInLine)return!1;this[n.$extra]._isSplittable=!0;return!0}[n.$flushHTML](){return(0,i.flushHTML)(this)}[n.$addHTML](e,t){(0,i.addHTML)(this,e,t)}[n.$getAvailableSpace](){return(0,i.getAvailableSpace)(this)}[n.$toHTML](e){setTabIndex(this);if("hidden"===this.presence||"inactive"===this.presence||0===this.h||0===this.w)return o.HTMLResult.EMPTY;(0,s.fixDimensions)(this);const t=[],r={id:this[n.$uid],class:[]};(0,s.setAccess)(this,r.class);this[n.$extra]||(this[n.$extra]=Object.create(null));Object.assign(this[n.$extra],{children:t,attributes:r,attempt:0,line:null,numberInLine:0,availableSpace:{width:Math.min(this.w||1/0,e.width),height:Math.min(this.h||1/0,e.height)},width:0,height:0,prevHeight:0,currentWidth:0});const a=this[n.$isSplittable]();a||setFirstUnsplittable(this);if(!(0,i.checkDimensions)(this,e))return o.HTMLResult.FAILURE;const c=new Set(["field"]);if(this.layout.includes("row")){const e=this[n.$getSubformParent]().columnWidths;if(Array.isArray(e)&&e.length>0){this[n.$extra].columnWidths=e;this[n.$extra].currentColumn=0}}const l=(0,s.toStyle)(this,"anchorType","dimensions","position","presence","border","margin","hAlign"),h=["xfaExclgroup"],u=(0,s.layoutClass)(this);u&&h.push(u);(0,s.isPrintOnly)(this)&&h.push("xfaPrintOnly");r.style=l;r.class=h;this.name&&(r.xfaName=this.name);this[n.$pushPara]();const d="lr-tb"===this.layout||"rl-tb"===this.layout,f=d?2:1;for(;this[n.$extra].attempt<f;this[n.$extra].attempt++){d&&1===this[n.$extra].attempt&&(this[n.$extra].numberInLine=0);const e=this[n.$childrenToHTML]({filter:c,include:!0});if(e.success)break;if(e.isBreak()){this[n.$popPara]();return e}if(d&&0===this[n.$extra].attempt&&0===this[n.$extra].numberInLine&&!this[n.$getTemplateRoot]()[n.$extra].noLayoutFailure){this[n.$extra].attempt=f;break}}this[n.$popPara]();a||unsetFirstUnsplittable(this);if(this[n.$extra].attempt===f){a||delete this[n.$extra];return o.HTMLResult.FAILURE}let g=0,p=0;if(this.margin){g=this.margin.leftInset+this.margin.rightInset;p=this.margin.topInset+this.margin.bottomInset}const m=Math.max(this[n.$extra].width+g,this.w||0),b=Math.max(this[n.$extra].height+p,this.h||0),y=[this.x,this.y,m,b];""===this.w&&(l.width=(0,s.measureToString)(m));""===this.h&&(l.height=(0,s.measureToString)(b));const w={name:"div",attributes:r,children:t};applyAssist(this,r);delete this[n.$extra];return o.HTMLResult.success((0,s.createWrapper)(this,w),y)}}class Execute extends n.XFAObject{constructor(e){super(d,"execute");this.connection=e.connection||"";this.executeType=(0,o.getStringOption)(e.executeType,["import","remerge"]);this.id=e.id||"";this.runAt=(0,o.getStringOption)(e.runAt,["client","both","server"]);this.use=e.use||"";this.usehref=e.usehref||""}}class Extras extends n.XFAObject{constructor(e){super(d,"extras",!0);this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||"";this.boolean=new n.XFAObjectArray;this.date=new n.XFAObjectArray;this.dateTime=new n.XFAObjectArray;this.decimal=new n.XFAObjectArray;this.exData=new n.XFAObjectArray;this.extras=new n.XFAObjectArray;this.float=new n.XFAObjectArray;this.image=new n.XFAObjectArray;this.integer=new n.XFAObjectArray;this.text=new n.XFAObjectArray;this.time=new n.XFAObjectArray}}class Field extends n.XFAObject{constructor(e){super(d,"field",!0);this.access=(0,o.getStringOption)(e.access,["open","nonInteractive","protected","readOnly"]);this.accessKey=e.accessKey||"";this.anchorType=(0,o.getStringOption)(e.anchorType,["topLeft","bottomCenter","bottomLeft","bottomRight","middleCenter","middleLeft","middleRight","topCenter","topRight"]);this.colSpan=(0,o.getInteger)({data:e.colSpan,defaultValue:1,validate:e=>e>=1||-1===e});this.h=e.h?(0,o.getMeasurement)(e.h):"";this.hAlign=(0,o.getStringOption)(e.hAlign,["left","center","justify","justifyAll","radix","right"]);this.id=e.id||"";this.locale=e.locale||"";this.maxH=(0,o.getMeasurement)(e.maxH,"0pt");this.maxW=(0,o.getMeasurement)(e.maxW,"0pt");this.minH=(0,o.getMeasurement)(e.minH,"0pt");this.minW=(0,o.getMeasurement)(e.minW,"0pt");this.name=e.name||"";this.presence=(0,o.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]);this.relevant=(0,o.getRelevant)(e.relevant);this.rotate=(0,o.getInteger)({data:e.rotate,defaultValue:0,validate:e=>e%90==0});this.use=e.use||"";this.usehref=e.usehref||"";this.w=e.w?(0,o.getMeasurement)(e.w):"";this.x=(0,o.getMeasurement)(e.x,"0pt");this.y=(0,o.getMeasurement)(e.y,"0pt");this.assist=null;this.bind=null;this.border=null;this.calculate=null;this.caption=null;this.desc=null;this.extras=null;this.font=null;this.format=null;this.items=new n.XFAObjectArray(2);this.keep=null;this.margin=null;this.para=null;this.traversal=null;this.ui=null;this.validate=null;this.value=null;this.bindItems=new n.XFAObjectArray;this.connect=new n.XFAObjectArray;this.event=new n.XFAObjectArray;this.setProperty=new n.XFAObjectArray}[n.$isBindable](){return!0}[n.$setValue](e){_setValue(this,e)}[n.$toHTML](e){setTabIndex(this);if(!this.ui){this.ui=new Ui({});this.ui[n.$globalData]=this[n.$globalData];this[n.$appendChild](this.ui);let e;switch(this.items.children.length){case 0:e=new TextEdit({});this.ui.textEdit=e;break;case 1:e=new CheckButton({});this.ui.checkButton=e;break;case 2:e=new ChoiceList({});this.ui.choiceList=e}this.ui[n.$appendChild](e)}if(!this.ui||"hidden"===this.presence||"inactive"===this.presence||0===this.h||0===this.w)return o.HTMLResult.EMPTY;this.caption&&delete this.caption[n.$extra];this[n.$pushPara]();const t=this.caption?this.caption[n.$toHTML](e).html:null,r=this.w,a=this.h;let c=0,h=0;if(this.margin){c=this.margin.leftInset+this.margin.rightInset;h=this.margin.topInset+this.margin.bottomInset}let u=null;if(""===this.w||""===this.h){let t=null,r=null,a=0,i=0;if(this.ui.checkButton)a=i=this.ui.checkButton.size;else{const{w:t,h:r}=(0,s.layoutNode)(this,e);if(null!==t){a=t;i=r}else i=(0,l.getMetrics)(this.font,!0).lineNoGap}u=getBorderDims(this.ui[n.$getExtra]());a+=u.w;i+=u.h;if(this.caption){const{w:s,h:c,isBroken:l}=this.caption[n.$getExtra](e);if(l&&this[n.$getSubformParent]()[n.$isThereMoreWidth]()){this[n.$popPara]();return o.HTMLResult.FAILURE}t=s;r=c;switch(this.caption.placement){case"left":case"right":case"inline":t+=a;break;case"top":case"bottom":r+=i}}else{t=a;r=i}if(t&&""===this.w){t+=c;this.w=Math.min(this.maxW<=0?1/0:this.maxW,this.minW+1<t?t:this.minW)}if(r&&""===this.h){r+=h;this.h=Math.min(this.maxH<=0?1/0:this.maxH,this.minH+1<r?r:this.minH)}}this[n.$popPara]();(0,s.fixDimensions)(this);setFirstUnsplittable(this);if(!(0,i.checkDimensions)(this,e)){this.w=r;this.h=a;this[n.$popPara]();return o.HTMLResult.FAILURE}unsetFirstUnsplittable(this);const d=(0,s.toStyle)(this,"font","dimensions","position","rotate","anchorType","presence","margin","hAlign");(0,s.setMinMaxDimensions)(this,d);const f=["xfaField"];this.font&&f.push("xfaFont");(0,s.isPrintOnly)(this)&&f.push("xfaPrintOnly");const g={style:d,id:this[n.$uid],class:f};if(d.margin){d.padding=d.margin;delete d.margin}(0,s.setAccess)(this,f);this.name&&(g.xfaName=this.name);const p=[],m={name:"div",attributes:g,children:p};applyAssist(this,g);const b=this.border?this.border[n.$toStyle]():null,y=(0,s.computeBbox)(this,m,e),w=this.ui[n.$toHTML]().html;if(!w){Object.assign(d,b);return o.HTMLResult.success((0,s.createWrapper)(this,m),y)}this[n.$tabIndex]&&(w.children&&w.children[0]?w.children[0].attributes.tabindex=this[n.$tabIndex]:w.attributes.tabindex=this[n.$tabIndex]);w.attributes.style||(w.attributes.style=Object.create(null));let S=null;if(this.ui.button){1===w.children.length&&([S]=w.children.splice(0,1));Object.assign(w.attributes.style,b)}else Object.assign(d,b);p.push(w);if(this.value)if(this.ui.imageEdit)w.children.push(this.value[n.$toHTML]().html);else if(!this.ui.button){let e="";if(this.value.exData)e=this.value.exData[n.$text]();else if(this.value.text)e=this.value.text[n.$getExtra]();else{const t=this.value[n.$toHTML]().html;null!==t&&(e=t.children[0].value)}this.ui.textEdit&&this.value.text&&this.value.text.maxChars&&(w.children[0].attributes.maxLength=this.value.text.maxChars);if(e){if(this.ui.numericEdit){e=parseFloat(e);e=isNaN(e)?"":e.toString()}"textarea"===w.children[0].name?w.children[0].attributes.textContent=e:w.children[0].attributes.value=e}}if(!this.ui.imageEdit&&w.children&&w.children[0]&&this.h){u=u||getBorderDims(this.ui[n.$getExtra]());let t=0;if(this.caption&&["top","bottom"].includes(this.caption.placement)){t=this.caption.reserve;t<=0&&(t=this.caption[n.$getExtra](e).h);const r=this.h-t-h-u.h;w.children[0].attributes.style.height=(0,s.measureToString)(r)}else w.children[0].attributes.style.height="100%"}S&&w.children.push(S);if(!t){w.attributes.class&&w.attributes.class.push("xfaLeft");this.w=r;this.h=a;return o.HTMLResult.success((0,s.createWrapper)(this,m),y)}if(this.ui.button){d.padding&&delete d.padding;"div"===t.name&&(t.name="span");w.children.push(t);return o.HTMLResult.success(m,y)}this.ui.checkButton&&(t.attributes.class[0]="xfaCaptionForCheckButton");w.attributes.class||(w.attributes.class=[]);w.children.splice(0,0,t);switch(this.caption.placement){case"left":case"inline":w.attributes.class.push("xfaLeft");break;case"right":w.attributes.class.push("xfaRight");break;case"top":w.attributes.class.push("xfaTop");break;case"bottom":w.attributes.class.push("xfaBottom")}this.w=r;this.h=a;return o.HTMLResult.success((0,s.createWrapper)(this,m),y)}}t.Field=Field;class Fill extends n.XFAObject{constructor(e){super(d,"fill",!0);this.id=e.id||"";this.presence=(0,o.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]);this.use=e.use||"";this.usehref=e.usehref||"";this.color=null;this.extras=null;this.linear=null;this.pattern=null;this.radial=null;this.solid=null;this.stipple=null}[n.$toStyle](){const e=this[n.$getParent](),t=e[n.$getParent]()[n.$getParent](),r=Object.create(null);let a="color",i=a;if(e instanceof Border){a="background-color";i="background";t instanceof Ui&&(r.backgroundColor="white")}if(e instanceof Rectangle||e instanceof Arc){a=i="fill";r.fill="white"}for(const e of Object.getOwnPropertyNames(this)){if("extras"===e||"color"===e)continue;const t=this[e];if(!(t instanceof n.XFAObject))continue;const s=t[n.$toStyle](this.color);s&&(r[s.startsWith("#")?a:i]=s);return r}if(this.color&&this.color.value){const e=this.color[n.$toStyle]();r[e.startsWith("#")?a:i]=e}return r}}class Filter extends n.XFAObject{constructor(e){super(d,"filter",!0);this.addRevocationInfo=(0,o.getStringOption)(e.addRevocationInfo,["","required","optional","none"]);this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||"";this.version=(0,o.getInteger)({data:this.version,defaultValue:5,validate:e=>e>=1&&e<=5});this.appearanceFilter=null;this.certificates=null;this.digestMethods=null;this.encodings=null;this.encryptionMethods=null;this.handler=null;this.lockDocument=null;this.mdp=null;this.reasons=null;this.timeStamp=null}}class Float extends n.ContentObject{constructor(e){super(d,"float");this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||""}[n.$finalize](){const e=parseFloat(this[n.$content].trim());this[n.$content]=isNaN(e)?null:e}[n.$toHTML](e){return valueToHtml(null!==this[n.$content]?this[n.$content].toString():"")}}class Font extends n.XFAObject{constructor(e){super(d,"font",!0);this.baselineShift=(0,o.getMeasurement)(e.baselineShift);this.fontHorizontalScale=(0,o.getFloat)({data:e.fontHorizontalScale,defaultValue:100,validate:e=>e>=0});this.fontVerticalScale=(0,o.getFloat)({data:e.fontVerticalScale,defaultValue:100,validate:e=>e>=0});this.id=e.id||"";this.kerningMode=(0,o.getStringOption)(e.kerningMode,["none","pair"]);this.letterSpacing=(0,o.getMeasurement)(e.letterSpacing,"0");this.lineThrough=(0,o.getInteger)({data:e.lineThrough,defaultValue:0,validate:e=>1===e||2===e});this.lineThroughPeriod=(0,o.getStringOption)(e.lineThroughPeriod,["all","word"]);this.overline=(0,o.getInteger)({data:e.overline,defaultValue:0,validate:e=>1===e||2===e});this.overlinePeriod=(0,o.getStringOption)(e.overlinePeriod,["all","word"]);this.posture=(0,o.getStringOption)(e.posture,["normal","italic"]);this.size=(0,o.getMeasurement)(e.size,"10pt");this.typeface=e.typeface||"Courier";this.underline=(0,o.getInteger)({data:e.underline,defaultValue:0,validate:e=>1===e||2===e});this.underlinePeriod=(0,o.getStringOption)(e.underlinePeriod,["all","word"]);this.use=e.use||"";this.usehref=e.usehref||"";this.weight=(0,o.getStringOption)(e.weight,["normal","bold"]);this.extras=null;this.fill=null}[n.$clean](e){super[n.$clean](e);this[n.$globalData].usedTypefaces.add(this.typeface)}[n.$toStyle](){const e=(0,s.toStyle)(this,"fill"),t=e.color;if(t)if("#000000"===t)delete e.color;else if(!t.startsWith("#")){e.background=t;e.backgroundClip="text";e.color="transparent"}this.baselineShift&&(e.verticalAlign=(0,s.measureToString)(this.baselineShift));e.fontKerning="none"===this.kerningMode?"none":"normal";e.letterSpacing=(0,s.measureToString)(this.letterSpacing);if(0!==this.lineThrough){e.textDecoration="line-through";2===this.lineThrough&&(e.textDecorationStyle="double")}if(0!==this.overline){e.textDecoration="overline";2===this.overline&&(e.textDecorationStyle="double")}e.fontStyle=this.posture;e.fontSize=(0,s.measureToString)(.99*this.size);(0,s.setFontFamily)(this,this,this[n.$globalData].fontFinder,e);if(0!==this.underline){e.textDecoration="underline";2===this.underline&&(e.textDecorationStyle="double")}e.fontWeight=this.weight;return e}}class Format extends n.XFAObject{constructor(e){super(d,"format",!0);this.id=e.id||"";this.use=e.use||"";this.usehref=e.usehref||"";this.extras=null;this.picture=null}}class Handler extends n.StringObject{constructor(e){super(d,"handler");this.id=e.id||"";this.type=(0,o.getStringOption)(e.type,["optional","required"]);this.use=e.use||"";this.usehref=e.usehref||""}}class Hyphenation extends n.XFAObject{constructor(e){super(d,"hyphenation");this.excludeAllCaps=(0,o.getInteger)({data:e.excludeAllCaps,defaultValue:0,validate:e=>1===e});this.excludeInitialCap=(0,o.getInteger)({data:e.excludeInitialCap,defaultValue:0,validate:e=>1===e});this.hyphenate=(0,o.getInteger)({data:e.hyphenate,defaultValue:0,validate:e=>1===e});this.id=e.id||"";this.pushCharacterCount=(0,o.getInteger)({data:e.pushCharacterCount,defaultValue:3,validate:e=>e>=0});this.remainCharacterCount=(0,o.getInteger)({data:e.remainCharacterCount,defaultValue:3,validate:e=>e>=0});this.use=e.use||"";this.usehref=e.usehref||"";this.wordCharacterCount=(0,o.getInteger)({data:e.wordCharacterCount,defaultValue:7,validate:e=>e>=0})}}class Image extends n.StringObject{constructor(e){super(d,"image");this.aspect=(0,o.getStringOption)(e.aspect,["fit","actual","height","none","width"]);this.contentType=e.contentType||"";this.href=e.href||"";this.id=e.id||"";this.name=e.name||"";this.transferEncoding=(0,o.getStringOption)(e.transferEncoding,["base64","none","package"]);this.use=e.use||"";this.usehref=e.usehref||""}[n.$toHTML](){if(this.contentType&&!p.has(this.contentType.toLowerCase()))return o.HTMLResult.EMPTY;let e=this[n.$globalData].images&&this[n.$globalData].images.get(this.href);if(!e&&(this.href||!this[n.$content]))return o.HTMLResult.EMPTY;e||"base64"!==this.transferEncoding||(e=(0,c.stringToBytes)(atob(this[n.$content])));if(!e)return o.HTMLResult.EMPTY;if(!this.contentType){for(const[t,r]of m)if(e.length>t.length&&t.every(((t,r)=>t===e[r]))){this.contentType=r;break}if(!this.contentType)return o.HTMLResult.EMPTY}const t=new Blob([e],{type:this.contentType});let r;switch(this.aspect){case"fit":case"actual":break;case"height":r={height:"100%",objectFit:"fill"};break;case"none":r={width:"100%",height:"100%",objectFit:"fill"};break;case"width":r={width:"100%",objectFit:"fill"}}const a=this[n.$getParent]();return o.HTMLResult.success({name:"img",attributes:{class:["xfaImage"],style:r,src:URL.createObjectURL(t),alt:a?ariaLabel(a[n.$getParent]()):null}})}}class ImageEdit extends n.XFAObject{constructor(e){super(d,"imageEdit",!0);this.data=(0,o.getStringOption)(e.data,["link","embed"]);this.id=e.id||"";this.use=e.use||"";this.usehref=e.usehref||"";this.border=null;this.extras=null;this.margin=null}[n.$toHTML](e){return"embed"===this.data?o.HTMLResult.success({name:"div",children:[],attributes:{}}):o.HTMLResult.EMPTY}}class Integer extends n.ContentObject{constructor(e){super(d,"integer");this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||""}[n.$finalize](){const e=parseInt(this[n.$content].trim(),10);this[n.$content]=isNaN(e)?null:e}[n.$toHTML](e){return valueToHtml(null!==this[n.$content]?this[n.$content].toString():"")}}class Issuers extends n.XFAObject{constructor(e){super(d,"issuers",!0);this.id=e.id||"";this.type=(0,o.getStringOption)(e.type,["optional","required"]);this.use=e.use||"";this.usehref=e.usehref||"";this.certificate=new n.XFAObjectArray}}class Items extends n.XFAObject{constructor(e){super(d,"items",!0);this.id=e.id||"";this.name=e.name||"";this.presence=(0,o.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]);this.ref=e.ref||"";this.save=(0,o.getInteger)({data:e.save,defaultValue:0,validate:e=>1===e});this.use=e.use||"";this.usehref=e.usehref||"";this.boolean=new n.XFAObjectArray;this.date=new n.XFAObjectArray;this.dateTime=new n.XFAObjectArray;this.decimal=new n.XFAObjectArray;this.exData=new n.XFAObjectArray;this.float=new n.XFAObjectArray;this.image=new n.XFAObjectArray;this.integer=new n.XFAObjectArray;this.text=new n.XFAObjectArray;this.time=new n.XFAObjectArray}[n.$toHTML](){const e=[];for(const t of this[n.$getChildren]())e.push(t[n.$text]());return o.HTMLResult.success(e)}}t.Items=Items;class Keep extends n.XFAObject{constructor(e){super(d,"keep",!0);this.id=e.id||"";const t=["none","contentArea","pageArea"];this.intact=(0,o.getStringOption)(e.intact,t);this.next=(0,o.getStringOption)(e.next,t);this.previous=(0,o.getStringOption)(e.previous,t);this.use=e.use||"";this.usehref=e.usehref||"";this.extras=null}}class KeyUsage extends n.XFAObject{constructor(e){super(d,"keyUsage");const t=["","yes","no"];this.crlSign=(0,o.getStringOption)(e.crlSign,t);this.dataEncipherment=(0,o.getStringOption)(e.dataEncipherment,t);this.decipherOnly=(0,o.getStringOption)(e.decipherOnly,t);this.digitalSignature=(0,o.getStringOption)(e.digitalSignature,t);this.encipherOnly=(0,o.getStringOption)(e.encipherOnly,t);this.id=e.id||"";this.keyAgreement=(0,o.getStringOption)(e.keyAgreement,t);this.keyCertSign=(0,o.getStringOption)(e.keyCertSign,t);this.keyEncipherment=(0,o.getStringOption)(e.keyEncipherment,t);this.nonRepudiation=(0,o.getStringOption)(e.nonRepudiation,t);this.type=(0,o.getStringOption)(e.type,["optional","required"]);this.use=e.use||"";this.usehref=e.usehref||""}}class Line extends n.XFAObject{constructor(e){super(d,"line",!0);this.hand=(0,o.getStringOption)(e.hand,["even","left","right"]);this.id=e.id||"";this.slope=(0,o.getStringOption)(e.slope,["\\","/"]);this.use=e.use||"";this.usehref=e.usehref||"";this.edge=null}[n.$toHTML](){const e=this[n.$getParent]()[n.$getParent](),t=this.edge?this.edge:new Edge({}),r=t[n.$toStyle](),a=Object.create(null),i="visible"===t.presence?t.thickness:0;a.strokeWidth=(0,s.measureToString)(i);a.stroke=r.color;let c,l,h,u,d="100%",g="100%";if(e.w<=i){[c,l,h,u]=["50%",0,"50%","100%"];d=a.strokeWidth}else if(e.h<=i){[c,l,h,u]=[0,"50%","100%","50%"];g=a.strokeWidth}else"\\"===this.slope?[c,l,h,u]=[0,0,"100%","100%"]:[c,l,h,u]=[0,"100%","100%",0];const p={name:"svg",children:[{name:"line",attributes:{xmlns:f,x1:c,y1:l,x2:h,y2:u,style:a}}],attributes:{xmlns:f,width:d,height:g,style:{overflow:"visible"}}};if(hasMargin(e))return o.HTMLResult.success({name:"div",attributes:{style:{display:"inline",width:"100%",height:"100%"}},children:[p]});p.attributes.style.position="absolute";return o.HTMLResult.success(p)}}class Linear extends n.XFAObject{constructor(e){super(d,"linear",!0);this.id=e.id||"";this.type=(0,o.getStringOption)(e.type,["toRight","toBottom","toLeft","toTop"]);this.use=e.use||"";this.usehref=e.usehref||"";this.color=null;this.extras=null}[n.$toStyle](e){e=e?e[n.$toStyle]():"#FFFFFF";const t=this.type.replace(/([RBLT])/," $1").toLowerCase(),r=this.color?this.color[n.$toStyle]():"#000000";return"linear-gradient(".concat(t,", ").concat(e,", ").concat(r,")")}}class LockDocument extends n.ContentObject{constructor(e){super(d,"lockDocument");this.id=e.id||"";this.type=(0,o.getStringOption)(e.type,["optional","required"]);this.use=e.use||"";this.usehref=e.usehref||""}[n.$finalize](){this[n.$content]=(0,o.getStringOption)(this[n.$content],["auto","0","1"])}}class Manifest extends n.XFAObject{constructor(e){super(d,"manifest",!0);this.action=(0,o.getStringOption)(e.action,["include","all","exclude"]);this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||"";this.extras=null;this.ref=new n.XFAObjectArray}}class Margin extends n.XFAObject{constructor(e){super(d,"margin",!0);this.bottomInset=(0,o.getMeasurement)(e.bottomInset,"0");this.id=e.id||"";this.leftInset=(0,o.getMeasurement)(e.leftInset,"0");this.rightInset=(0,o.getMeasurement)(e.rightInset,"0");this.topInset=(0,o.getMeasurement)(e.topInset,"0");this.use=e.use||"";this.usehref=e.usehref||"";this.extras=null}[n.$toStyle](){return{margin:(0,s.measureToString)(this.topInset)+" "+(0,s.measureToString)(this.rightInset)+" "+(0,s.measureToString)(this.bottomInset)+" "+(0,s.measureToString)(this.leftInset)}}}class Mdp extends n.XFAObject{constructor(e){super(d,"mdp");this.id=e.id||"";this.permissions=(0,o.getInteger)({data:e.permissions,defaultValue:2,validate:e=>1===e||3===e});this.signatureType=(0,o.getStringOption)(e.signatureType,["filler","author"]);this.use=e.use||"";this.usehref=e.usehref||""}}class Medium extends n.XFAObject{constructor(e){super(d,"medium");this.id=e.id||"";this.imagingBBox=(0,o.getBBox)(e.imagingBBox);this.long=(0,o.getMeasurement)(e.long);this.orientation=(0,o.getStringOption)(e.orientation,["portrait","landscape"]);this.short=(0,o.getMeasurement)(e.short);this.stock=e.stock||"";this.trayIn=(0,o.getStringOption)(e.trayIn,["auto","delegate","pageFront"]);this.trayOut=(0,o.getStringOption)(e.trayOut,["auto","delegate"]);this.use=e.use||"";this.usehref=e.usehref||""}}class Message extends n.XFAObject{constructor(e){super(d,"message",!0);this.id=e.id||"";this.use=e.use||"";this.usehref=e.usehref||"";this.text=new n.XFAObjectArray}}class NumericEdit extends n.XFAObject{constructor(e){super(d,"numericEdit",!0);this.hScrollPolicy=(0,o.getStringOption)(e.hScrollPolicy,["auto","off","on"]);this.id=e.id||"";this.use=e.use||"";this.usehref=e.usehref||"";this.border=null;this.comb=null;this.extras=null;this.margin=null}[n.$toHTML](e){const t=(0,s.toStyle)(this,"border","font","margin"),r=this[n.$getParent]()[n.$getParent](),a={name:"input",attributes:{type:"text",fieldId:r[n.$uid],dataId:r[n.$data]&&r[n.$data][n.$uid]||r[n.$uid],class:["xfaTextfield"],style:t,"aria-label":ariaLabel(r),"aria-required":!1}};if(isRequired(r)){a.attributes["aria-required"]=!0;a.attributes.required=!0}return o.HTMLResult.success({name:"label",attributes:{class:["xfaLabel"]},children:[a]})}}class Occur extends n.XFAObject{constructor(e){super(d,"occur",!0);this.id=e.id||"";this.initial=""!==e.initial?(0,o.getInteger)({data:e.initial,defaultValue:"",validate:e=>!0}):"";this.max=""!==e.max?(0,o.getInteger)({data:e.max,defaultValue:1,validate:e=>!0}):"";this.min=""!==e.min?(0,o.getInteger)({data:e.min,defaultValue:1,validate:e=>!0}):"";this.use=e.use||"";this.usehref=e.usehref||"";this.extras=null}[n.$clean](){const e=this[n.$getParent](),t=this.min;""===this.min&&(this.min=e instanceof PageArea||e instanceof PageSet?0:1);""===this.max&&(this.max=""===t?e instanceof PageArea||e instanceof PageSet?-1:1:this.min);-1!==this.max&&this.max<this.min&&(this.max=this.min);""===this.initial&&(this.initial=e instanceof Template?1:this.min)}}class Oid extends n.StringObject{constructor(e){super(d,"oid");this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||""}}class Oids extends n.XFAObject{constructor(e){super(d,"oids",!0);this.id=e.id||"";this.type=(0,o.getStringOption)(e.type,["optional","required"]);this.use=e.use||"";this.usehref=e.usehref||"";this.oid=new n.XFAObjectArray}}class Overflow extends n.XFAObject{constructor(e){super(d,"overflow");this.id=e.id||"";this.leader=e.leader||"";this.target=e.target||"";this.trailer=e.trailer||"";this.use=e.use||"";this.usehref=e.usehref||""}[n.$getExtra](){if(!this[n.$extra]){const e=this[n.$getParent](),t=this[n.$getTemplateRoot](),r=t[n.$searchNode](this.target,e),a=t[n.$searchNode](this.leader,e),i=t[n.$searchNode](this.trailer,e);this[n.$extra]={target:r&&r[0]||null,leader:a&&a[0]||null,trailer:i&&i[0]||null,addLeader:!1,addTrailer:!1}}return this[n.$extra]}}class PageArea extends n.XFAObject{constructor(e){super(d,"pageArea",!0);this.blankOrNotBlank=(0,o.getStringOption)(e.blankOrNotBlank,["any","blank","notBlank"]);this.id=e.id||"";this.initialNumber=(0,o.getInteger)({data:e.initialNumber,defaultValue:1,validate:e=>!0});this.name=e.name||"";this.numbered=(0,o.getInteger)({data:e.numbered,defaultValue:1,validate:e=>!0});this.oddOrEven=(0,o.getStringOption)(e.oddOrEven,["any","even","odd"]);this.pagePosition=(0,o.getStringOption)(e.pagePosition,["any","first","last","only","rest"]);this.relevant=(0,o.getRelevant)(e.relevant);this.use=e.use||"";this.usehref=e.usehref||"";this.desc=null;this.extras=null;this.medium=null;this.occur=null;this.area=new n.XFAObjectArray;this.contentArea=new n.XFAObjectArray;this.draw=new n.XFAObjectArray;this.exclGroup=new n.XFAObjectArray;this.field=new n.XFAObjectArray;this.subform=new n.XFAObjectArray}[n.$isUsable](){if(!this[n.$extra]){this[n.$extra]={numberOfUse:0};return!0}return!this.occur||-1===this.occur.max||this[n.$extra].numberOfUse<this.occur.max}[n.$cleanPage](){delete this[n.$extra]}[n.$getNextPage](){this[n.$extra]||(this[n.$extra]={numberOfUse:0});const e=this[n.$getParent]();if("orderedOccurrence"===e.relation&&this[n.$isUsable]()){this[n.$extra].numberOfUse+=1;return this}return e[n.$getNextPage]()}[n.$getAvailableSpace](){return this[n.$extra].space||{width:0,height:0}}[n.$toHTML](){this[n.$extra]||(this[n.$extra]={numberOfUse:1});const e=[];this[n.$extra].children=e;const t=Object.create(null);if(this.medium&&this.medium.short&&this.medium.long){t.width=(0,s.measureToString)(this.medium.short);t.height=(0,s.measureToString)(this.medium.long);this[n.$extra].space={width:this.medium.short,height:this.medium.long};if("landscape"===this.medium.orientation){const e=t.width;t.width=t.height;t.height=e;this[n.$extra].space={width:this.medium.long,height:this.medium.short}}}else(0,c.warn)("XFA - No medium specified in pageArea: please file a bug.");this[n.$childrenToHTML]({filter:new Set(["area","draw","field","subform"]),include:!0});this[n.$childrenToHTML]({filter:new Set(["contentArea"]),include:!0});return o.HTMLResult.success({name:"div",children:e,attributes:{class:["xfaPage"],id:this[n.$uid],style:t,xfaName:this.name}})}}class PageSet extends n.XFAObject{constructor(e){super(d,"pageSet",!0);this.duplexImposition=(0,o.getStringOption)(e.duplexImposition,["longEdge","shortEdge"]);this.id=e.id||"";this.name=e.name||"";this.relation=(0,o.getStringOption)(e.relation,["orderedOccurrence","duplexPaginated","simplexPaginated"]);this.relevant=(0,o.getRelevant)(e.relevant);this.use=e.use||"";this.usehref=e.usehref||"";this.extras=null;this.occur=null;this.pageArea=new n.XFAObjectArray;this.pageSet=new n.XFAObjectArray}[n.$cleanPage](){for(const e of this.pageArea.children)e[n.$cleanPage]();for(const e of this.pageSet.children)e[n.$cleanPage]()}[n.$isUsable](){return!this.occur||-1===this.occur.max||this[n.$extra].numberOfUse<this.occur.max}[n.$getNextPage](){this[n.$extra]||(this[n.$extra]={numberOfUse:1,pageIndex:-1,pageSetIndex:-1});if("orderedOccurrence"===this.relation){if(this[n.$extra].pageIndex+1<this.pageArea.children.length){this[n.$extra].pageIndex+=1;return this.pageArea.children[this[n.$extra].pageIndex][n.$getNextPage]()}if(this[n.$extra].pageSetIndex+1<this.pageSet.children.length){this[n.$extra].pageSetIndex+=1;return this.pageSet.children[this[n.$extra].pageSetIndex][n.$getNextPage]()}if(this[n.$isUsable]()){this[n.$extra].numberOfUse+=1;this[n.$extra].pageIndex=-1;this[n.$extra].pageSetIndex=-1;return this[n.$getNextPage]()}const e=this[n.$getParent]();if(e instanceof PageSet)return e[n.$getNextPage]();this[n.$cleanPage]();return this[n.$getNextPage]()}const e=this[n.$getTemplateRoot]()[n.$extra].pageNumber,t=e%2==0?"even":"odd",r=0===e?"first":"rest";let a=this.pageArea.children.find((e=>e.oddOrEven===t&&e.pagePosition===r));if(a)return a;a=this.pageArea.children.find((e=>"any"===e.oddOrEven&&e.pagePosition===r));if(a)return a;a=this.pageArea.children.find((e=>"any"===e.oddOrEven&&"any"===e.pagePosition));return a||this.pageArea.children[0]}}class Para extends n.XFAObject{constructor(e){super(d,"para",!0);this.hAlign=(0,o.getStringOption)(e.hAlign,["left","center","justify","justifyAll","radix","right"]);this.id=e.id||"";this.lineHeight=e.lineHeight?(0,o.getMeasurement)(e.lineHeight,"0pt"):"";this.marginLeft=e.marginLeft?(0,o.getMeasurement)(e.marginLeft,"0pt"):"";this.marginRight=e.marginRight?(0,o.getMeasurement)(e.marginRight,"0pt"):"";this.orphans=(0,o.getInteger)({data:e.orphans,defaultValue:0,validate:e=>e>=0});this.preserve=e.preserve||"";this.radixOffset=e.radixOffset?(0,o.getMeasurement)(e.radixOffset,"0pt"):"";this.spaceAbove=e.spaceAbove?(0,o.getMeasurement)(e.spaceAbove,"0pt"):"";this.spaceBelow=e.spaceBelow?(0,o.getMeasurement)(e.spaceBelow,"0pt"):"";this.tabDefault=e.tabDefault?(0,o.getMeasurement)(this.tabDefault):"";this.tabStops=(e.tabStops||"").trim().split(/\s+/).map(((e,t)=>t%2==1?(0,o.getMeasurement)(e):e));this.textIndent=e.textIndent?(0,o.getMeasurement)(e.textIndent,"0pt"):"";this.use=e.use||"";this.usehref=e.usehref||"";this.vAlign=(0,o.getStringOption)(e.vAlign,["top","bottom","middle"]);this.widows=(0,o.getInteger)({data:e.widows,defaultValue:0,validate:e=>e>=0});this.hyphenation=null}[n.$toStyle](){const e=(0,s.toStyle)(this,"hAlign");""!==this.marginLeft&&(e.paddingLeft=(0,s.measureToString)(this.marginLeft));""!==this.marginRight&&(e.paddingight=(0,s.measureToString)(this.marginRight));""!==this.spaceAbove&&(e.paddingTop=(0,s.measureToString)(this.spaceAbove));""!==this.spaceBelow&&(e.paddingBottom=(0,s.measureToString)(this.spaceBelow));if(""!==this.textIndent){e.textIndent=(0,s.measureToString)(this.textIndent);(0,s.fixTextIndent)(e)}this.lineHeight>0&&(e.lineHeight=(0,s.measureToString)(this.lineHeight));""!==this.tabDefault&&(e.tabSize=(0,s.measureToString)(this.tabDefault));this.tabStops.length;this.hyphenatation&&Object.assign(e,this.hyphenatation[n.$toStyle]());return e}}class PasswordEdit extends n.XFAObject{constructor(e){super(d,"passwordEdit",!0);this.hScrollPolicy=(0,o.getStringOption)(e.hScrollPolicy,["auto","off","on"]);this.id=e.id||"";this.passwordChar=e.passwordChar||"*";this.use=e.use||"";this.usehref=e.usehref||"";this.border=null;this.extras=null;this.margin=null}}class Pattern extends n.XFAObject{constructor(e){super(d,"pattern",!0);this.id=e.id||"";this.type=(0,o.getStringOption)(e.type,["crossHatch","crossDiagonal","diagonalLeft","diagonalRight","horizontal","vertical"]);this.use=e.use||"";this.usehref=e.usehref||"";this.color=null;this.extras=null}[n.$toStyle](e){e=e?e[n.$toStyle]():"#FFFFFF";const t=this.color?this.color[n.$toStyle]():"#000000",r="repeating-linear-gradient",a="".concat(e,",").concat(e," ").concat(5,"px,").concat(t," ").concat(5,"px,").concat(t," ").concat(10,"px");switch(this.type){case"crossHatch":return"".concat(r,"(to top,").concat(a,") ").concat(r,"(to right,").concat(a,")");case"crossDiagonal":return"".concat(r,"(45deg,").concat(a,") ").concat(r,"(-45deg,").concat(a,")");case"diagonalLeft":return"".concat(r,"(45deg,").concat(a,")");case"diagonalRight":return"".concat(r,"(-45deg,").concat(a,")");case"horizontal":return"".concat(r,"(to top,").concat(a,")");case"vertical":return"".concat(r,"(to right,").concat(a,")")}return""}}class Picture extends n.StringObject{constructor(e){super(d,"picture");this.id=e.id||"";this.use=e.use||"";this.usehref=e.usehref||""}}class Proto extends n.XFAObject{constructor(e){super(d,"proto",!0);this.appearanceFilter=new n.XFAObjectArray;this.arc=new n.XFAObjectArray;this.area=new n.XFAObjectArray;this.assist=new n.XFAObjectArray;this.barcode=new n.XFAObjectArray;this.bindItems=new n.XFAObjectArray;this.bookend=new n.XFAObjectArray;this.boolean=new n.XFAObjectArray;this.border=new n.XFAObjectArray;this.break=new n.XFAObjectArray;this.breakAfter=new n.XFAObjectArray;this.breakBefore=new n.XFAObjectArray;this.button=new n.XFAObjectArray;this.calculate=new n.XFAObjectArray;this.caption=new n.XFAObjectArray;this.certificate=new n.XFAObjectArray;this.certificates=new n.XFAObjectArray;this.checkButton=new n.XFAObjectArray;this.choiceList=new n.XFAObjectArray;this.color=new n.XFAObjectArray;this.comb=new n.XFAObjectArray;this.connect=new n.XFAObjectArray;this.contentArea=new n.XFAObjectArray;this.corner=new n.XFAObjectArray;this.date=new n.XFAObjectArray;this.dateTime=new n.XFAObjectArray;this.dateTimeEdit=new n.XFAObjectArray;this.decimal=new n.XFAObjectArray;this.defaultUi=new n.XFAObjectArray;this.desc=new n.XFAObjectArray;this.digestMethod=new n.XFAObjectArray;this.digestMethods=new n.XFAObjectArray;this.draw=new n.XFAObjectArray;this.edge=new n.XFAObjectArray;this.encoding=new n.XFAObjectArray;this.encodings=new n.XFAObjectArray;this.encrypt=new n.XFAObjectArray;this.encryptData=new n.XFAObjectArray;this.encryption=new n.XFAObjectArray;this.encryptionMethod=new n.XFAObjectArray;this.encryptionMethods=new n.XFAObjectArray;this.event=new n.XFAObjectArray;this.exData=new n.XFAObjectArray;this.exObject=new n.XFAObjectArray;this.exclGroup=new n.XFAObjectArray;this.execute=new n.XFAObjectArray;this.extras=new n.XFAObjectArray;this.field=new n.XFAObjectArray;this.fill=new n.XFAObjectArray;this.filter=new n.XFAObjectArray;this.float=new n.XFAObjectArray;this.font=new n.XFAObjectArray;this.format=new n.XFAObjectArray;this.handler=new n.XFAObjectArray;this.hyphenation=new n.XFAObjectArray;this.image=new n.XFAObjectArray;this.imageEdit=new n.XFAObjectArray;this.integer=new n.XFAObjectArray;this.issuers=new n.XFAObjectArray;this.items=new n.XFAObjectArray;this.keep=new n.XFAObjectArray;this.keyUsage=new n.XFAObjectArray;this.line=new n.XFAObjectArray;this.linear=new n.XFAObjectArray;this.lockDocument=new n.XFAObjectArray;this.manifest=new n.XFAObjectArray;this.margin=new n.XFAObjectArray;this.mdp=new n.XFAObjectArray;this.medium=new n.XFAObjectArray;this.message=new n.XFAObjectArray;this.numericEdit=new n.XFAObjectArray;this.occur=new n.XFAObjectArray;this.oid=new n.XFAObjectArray;this.oids=new n.XFAObjectArray;this.overflow=new n.XFAObjectArray;this.pageArea=new n.XFAObjectArray;this.pageSet=new n.XFAObjectArray;this.para=new n.XFAObjectArray;this.passwordEdit=new n.XFAObjectArray;this.pattern=new n.XFAObjectArray;this.picture=new n.XFAObjectArray;this.radial=new n.XFAObjectArray;this.reason=new n.XFAObjectArray;this.reasons=new n.XFAObjectArray;this.rectangle=new n.XFAObjectArray;this.ref=new n.XFAObjectArray;this.script=new n.XFAObjectArray;this.setProperty=new n.XFAObjectArray;this.signData=new n.XFAObjectArray;this.signature=new n.XFAObjectArray;this.signing=new n.XFAObjectArray;this.solid=new n.XFAObjectArray;this.speak=new n.XFAObjectArray;this.stipple=new n.XFAObjectArray;this.subform=new n.XFAObjectArray;this.subformSet=new n.XFAObjectArray;this.subjectDN=new n.XFAObjectArray;this.subjectDNs=new n.XFAObjectArray;this.submit=new n.XFAObjectArray;this.text=new n.XFAObjectArray;this.textEdit=new n.XFAObjectArray;this.time=new n.XFAObjectArray;this.timeStamp=new n.XFAObjectArray;this.toolTip=new n.XFAObjectArray;this.traversal=new n.XFAObjectArray;this.traverse=new n.XFAObjectArray;this.ui=new n.XFAObjectArray;this.validate=new n.XFAObjectArray;this.value=new n.XFAObjectArray;this.variables=new n.XFAObjectArray}}class Radial extends n.XFAObject{constructor(e){super(d,"radial",!0);this.id=e.id||"";this.type=(0,o.getStringOption)(e.type,["toEdge","toCenter"]);this.use=e.use||"";this.usehref=e.usehref||"";this.color=null;this.extras=null}[n.$toStyle](e){e=e?e[n.$toStyle]():"#FFFFFF";const t=this.color?this.color[n.$toStyle]():"#000000",r="toEdge"===this.type?"".concat(e,",").concat(t):"".concat(t,",").concat(e);return"radial-gradient(circle at center, ".concat(r,")")}}class Reason extends n.StringObject{constructor(e){super(d,"reason");this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||""}}class Reasons extends n.XFAObject{constructor(e){super(d,"reasons",!0);this.id=e.id||"";this.type=(0,o.getStringOption)(e.type,["optional","required"]);this.use=e.use||"";this.usehref=e.usehref||"";this.reason=new n.XFAObjectArray}}class Rectangle extends n.XFAObject{constructor(e){super(d,"rectangle",!0);this.hand=(0,o.getStringOption)(e.hand,["even","left","right"]);this.id=e.id||"";this.use=e.use||"";this.usehref=e.usehref||"";this.corner=new n.XFAObjectArray(4);this.edge=new n.XFAObjectArray(4);this.fill=null}[n.$toHTML](){const e=this.edge.children.length?this.edge.children[0]:new Edge({}),t=e[n.$toStyle](),r=Object.create(null);this.fill&&"visible"===this.fill.presence?Object.assign(r,this.fill[n.$toStyle]()):r.fill="transparent";r.strokeWidth=(0,s.measureToString)("visible"===e.presence?e.thickness:0);r.stroke=t.color;const a=(this.corner.children.length?this.corner.children[0]:new Corner({}))[n.$toStyle](),i={name:"svg",children:[{name:"rect",attributes:{xmlns:f,width:"100%",height:"100%",x:0,y:0,rx:a.radius,ry:a.radius,style:r}}],attributes:{xmlns:f,style:{overflow:"visible"},width:"100%",height:"100%"}};if(hasMargin(this[n.$getParent]()[n.$getParent]()))return o.HTMLResult.success({name:"div",attributes:{style:{display:"inline",width:"100%",height:"100%"}},children:[i]});i.attributes.style.position="absolute";return o.HTMLResult.success(i)}}class RefElement extends n.StringObject{constructor(e){super(d,"ref");this.id=e.id||"";this.use=e.use||"";this.usehref=e.usehref||""}}class Script extends n.StringObject{constructor(e){super(d,"script");this.binding=e.binding||"";this.contentType=e.contentType||"";this.id=e.id||"";this.name=e.name||"";this.runAt=(0,o.getStringOption)(e.runAt,["client","both","server"]);this.use=e.use||"";this.usehref=e.usehref||""}}class SetProperty extends n.XFAObject{constructor(e){super(d,"setProperty");this.connection=e.connection||"";this.ref=e.ref||"";this.target=e.target||""}}t.SetProperty=SetProperty;class SignData extends n.XFAObject{constructor(e){super(d,"signData",!0);this.id=e.id||"";this.operation=(0,o.getStringOption)(e.operation,["sign","clear","verify"]);this.ref=e.ref||"";this.target=e.target||"";this.use=e.use||"";this.usehref=e.usehref||"";this.filter=null;this.manifest=null}}class Signature extends n.XFAObject{constructor(e){super(d,"signature",!0);this.id=e.id||"";this.type=(0,o.getStringOption)(e.type,["PDF1.3","PDF1.6"]);this.use=e.use||"";this.usehref=e.usehref||"";this.border=null;this.extras=null;this.filter=null;this.manifest=null;this.margin=null}}class Signing extends n.XFAObject{constructor(e){super(d,"signing",!0);this.id=e.id||"";this.type=(0,o.getStringOption)(e.type,["optional","required"]);this.use=e.use||"";this.usehref=e.usehref||"";this.certificate=new n.XFAObjectArray}}class Solid extends n.XFAObject{constructor(e){super(d,"solid",!0);this.id=e.id||"";this.use=e.use||"";this.usehref=e.usehref||"";this.extras=null}[n.$toStyle](e){return e?e[n.$toStyle]():"#FFFFFF"}}class Speak extends n.StringObject{constructor(e){super(d,"speak");this.disable=(0,o.getInteger)({data:e.disable,defaultValue:0,validate:e=>1===e});this.id=e.id||"";this.priority=(0,o.getStringOption)(e.priority,["custom","caption","name","toolTip"]);this.rid=e.rid||"";this.use=e.use||"";this.usehref=e.usehref||""}}class Stipple extends n.XFAObject{constructor(e){super(d,"stipple",!0);this.id=e.id||"";this.rate=(0,o.getInteger)({data:e.rate,defaultValue:50,validate:e=>e>=0&&e<=100});this.use=e.use||"";this.usehref=e.usehref||"";this.color=null;this.extras=null}[n.$toStyle](e){const t=this.rate/100;return c.Util.makeHexColor(Math.round(e.value.r*(1-t)+this.value.r*t),Math.round(e.value.g*(1-t)+this.value.g*t),Math.round(e.value.b*(1-t)+this.value.b*t))}}class Subform extends n.XFAObject{constructor(e){super(d,"subform",!0);this.access=(0,o.getStringOption)(e.access,["open","nonInteractive","protected","readOnly"]);this.allowMacro=(0,o.getInteger)({data:e.allowMacro,defaultValue:0,validate:e=>1===e});this.anchorType=(0,o.getStringOption)(e.anchorType,["topLeft","bottomCenter","bottomLeft","bottomRight","middleCenter","middleLeft","middleRight","topCenter","topRight"]);this.colSpan=(0,o.getInteger)({data:e.colSpan,defaultValue:1,validate:e=>e>=1||-1===e});this.columnWidths=(e.columnWidths||"").trim().split(/\s+/).map((e=>"-1"===e?-1:(0,o.getMeasurement)(e)));this.h=e.h?(0,o.getMeasurement)(e.h):"";this.hAlign=(0,o.getStringOption)(e.hAlign,["left","center","justify","justifyAll","radix","right"]);this.id=e.id||"";this.layout=(0,o.getStringOption)(e.layout,["position","lr-tb","rl-row","rl-tb","row","table","tb"]);this.locale=e.locale||"";this.maxH=(0,o.getMeasurement)(e.maxH,"0pt");this.maxW=(0,o.getMeasurement)(e.maxW,"0pt");this.mergeMode=(0,o.getStringOption)(e.mergeMode,["consumeData","matchTemplate"]);this.minH=(0,o.getMeasurement)(e.minH,"0pt");this.minW=(0,o.getMeasurement)(e.minW,"0pt");this.name=e.name||"";this.presence=(0,o.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]);this.relevant=(0,o.getRelevant)(e.relevant);this.restoreState=(0,o.getStringOption)(e.restoreState,["manual","auto"]);this.scope=(0,o.getStringOption)(e.scope,["name","none"]);this.use=e.use||"";this.usehref=e.usehref||"";this.w=e.w?(0,o.getMeasurement)(e.w):"";this.x=(0,o.getMeasurement)(e.x,"0pt");this.y=(0,o.getMeasurement)(e.y,"0pt");this.assist=null;this.bind=null;this.bookend=null;this.border=null;this.break=null;this.calculate=null;this.desc=null;this.extras=null;this.keep=null;this.margin=null;this.occur=null;this.overflow=null;this.pageSet=null;this.para=null;this.traversal=null;this.validate=null;this.variables=null;this.area=new n.XFAObjectArray;this.breakAfter=new n.XFAObjectArray;this.breakBefore=new n.XFAObjectArray;this.connect=new n.XFAObjectArray;this.draw=new n.XFAObjectArray;this.event=new n.XFAObjectArray;this.exObject=new n.XFAObjectArray;this.exclGroup=new n.XFAObjectArray;this.field=new n.XFAObjectArray;this.proto=new n.XFAObjectArray;this.setProperty=new n.XFAObjectArray;this.subform=new n.XFAObjectArray;this.subformSet=new n.XFAObjectArray}[n.$getSubformParent](){const e=this[n.$getParent]();return e instanceof SubformSet?e[n.$getSubformParent]():e}[n.$isBindable](){return!0}[n.$isThereMoreWidth](){return this.layout.endsWith("-tb")&&0===this[n.$extra].attempt&&this[n.$extra].numberInLine>0||this[n.$getParent]()[n.$isThereMoreWidth]()}*[n.$getContainedChildren](){yield*getContainedChildren(this)}[n.$flushHTML](){return(0,i.flushHTML)(this)}[n.$addHTML](e,t){(0,i.addHTML)(this,e,t)}[n.$getAvailableSpace](){return(0,i.getAvailableSpace)(this)}[n.$isSplittable](){const e=this[n.$getSubformParent]();if(!e[n.$isSplittable]())return!1;if(void 0!==this[n.$extra]._isSplittable)return this[n.$extra]._isSplittable;if("position"===this.layout||this.layout.includes("row")){this[n.$extra]._isSplittable=!1;return!1}if(this.keep&&"none"!==this.keep.intact){this[n.$extra]._isSplittable=!1;return!1}if(e.layout&&e.layout.endsWith("-tb")&&0!==e[n.$extra].numberInLine)return!1;this[n.$extra]._isSplittable=!0;return!0}[n.$toHTML](e){setTabIndex(this);if(this.break){if("auto"!==this.break.after||""!==this.break.afterTarget){const e=new BreakAfter({targetType:this.break.after,target:this.break.afterTarget,startNew:this.break.startNew.toString()});e[n.$globalData]=this[n.$globalData];this[n.$appendChild](e);this.breakAfter.push(e)}if("auto"!==this.break.before||""!==this.break.beforeTarget){const e=new BreakBefore({targetType:this.break.before,target:this.break.beforeTarget,startNew:this.break.startNew.toString()});e[n.$globalData]=this[n.$globalData];this[n.$appendChild](e);this.breakBefore.push(e)}if(""!==this.break.overflowTarget){const e=new Overflow({target:this.break.overflowTarget,leader:this.break.overflowLeader,trailer:this.break.overflowTrailer});e[n.$globalData]=this[n.$globalData];this[n.$appendChild](e);this.overflow.push(e)}this[n.$removeChild](this.break);this.break=null}if("hidden"===this.presence||"inactive"===this.presence)return o.HTMLResult.EMPTY;(this.breakBefore.children.length>1||this.breakAfter.children.length>1)&&(0,c.warn)("XFA - Several breakBefore or breakAfter in subforms: please file a bug.");if(this.breakBefore.children.length>=1){const e=this.breakBefore.children[0];if(handleBreak(e))return o.HTMLResult.breakNode(e)}if(this[n.$extra]&&this[n.$extra].afterBreakAfter)return o.HTMLResult.EMPTY;(0,s.fixDimensions)(this);const t=[],r={id:this[n.$uid],class:[]};(0,s.setAccess)(this,r.class);this[n.$extra]||(this[n.$extra]=Object.create(null));Object.assign(this[n.$extra],{children:t,line:null,attributes:r,attempt:0,numberInLine:0,availableSpace:{width:Math.min(this.w||1/0,e.width),height:Math.min(this.h||1/0,e.height)},width:0,height:0,prevHeight:0,currentWidth:0});const a=this[n.$getTemplateRoot](),l=a[n.$extra].noLayoutFailure,h=this[n.$isSplittable]();h||setFirstUnsplittable(this);if(!(0,i.checkDimensions)(this,e))return o.HTMLResult.FAILURE;const u=new Set(["area","draw","exclGroup","field","subform","subformSet"]);if(this.layout.includes("row")){const e=this[n.$getSubformParent]().columnWidths;if(Array.isArray(e)&&e.length>0){this[n.$extra].columnWidths=e;this[n.$extra].currentColumn=0}}const d=(0,s.toStyle)(this,"anchorType","dimensions","position","presence","border","margin","hAlign"),f=["xfaSubform"],g=(0,s.layoutClass)(this);g&&f.push(g);r.style=d;r.class=f;this.name&&(r.xfaName=this.name);if(this.overflow){const t=this.overflow[n.$getExtra]();if(t.addLeader){t.addLeader=!1;handleOverflow(this,t.leader,e)}}this[n.$pushPara]();const p="lr-tb"===this.layout||"rl-tb"===this.layout,m=p?2:1;for(;this[n.$extra].attempt<m;this[n.$extra].attempt++){p&&1===this[n.$extra].attempt&&(this[n.$extra].numberInLine=0);const e=this[n.$childrenToHTML]({filter:u,include:!0});if(e.success)break;if(e.isBreak()){this[n.$popPara]();return e}if(p&&0===this[n.$extra].attempt&&0===this[n.$extra].numberInLine&&!a[n.$extra].noLayoutFailure){this[n.$extra].attempt=m;break}}this[n.$popPara]();h||unsetFirstUnsplittable(this);a[n.$extra].noLayoutFailure=l;if(this[n.$extra].attempt===m){this.overflow&&(this[n.$getTemplateRoot]()[n.$extra].overflowNode=this.overflow);h||delete this[n.$extra];return o.HTMLResult.FAILURE}if(this.overflow){const t=this.overflow[n.$getExtra]();if(t.addTrailer){t.addTrailer=!1;handleOverflow(this,t.trailer,e)}}let b=0,y=0;if(this.margin){b=this.margin.leftInset+this.margin.rightInset;y=this.margin.topInset+this.margin.bottomInset}const w=Math.max(this[n.$extra].width+b,this.w||0),S=Math.max(this[n.$extra].height+y,this.h||0),x=[this.x,this.y,w,S];""===this.w&&(d.width=(0,s.measureToString)(w));""===this.h&&(d.height=(0,s.measureToString)(S));if(("0px"===d.width||"0px"===d.height)&&0===t.length)return o.HTMLResult.EMPTY;const v={name:"div",attributes:r,children:t};applyAssist(this,r);const k=o.HTMLResult.success((0,s.createWrapper)(this,v),x);if(this.breakAfter.children.length>=1){const e=this.breakAfter.children[0];if(handleBreak(e)){this[n.$extra].afterBreakAfter=k;return o.HTMLResult.breakNode(e)}}delete this[n.$extra];return k}}class SubformSet extends n.XFAObject{constructor(e){super(d,"subformSet",!0);this.id=e.id||"";this.name=e.name||"";this.relation=(0,o.getStringOption)(e.relation,["ordered","choice","unordered"]);this.relevant=(0,o.getRelevant)(e.relevant);this.use=e.use||"";this.usehref=e.usehref||"";this.bookend=null;this.break=null;this.desc=null;this.extras=null;this.occur=null;this.overflow=null;this.breakAfter=new n.XFAObjectArray;this.breakBefore=new n.XFAObjectArray;this.subform=new n.XFAObjectArray;this.subformSet=new n.XFAObjectArray}*[n.$getContainedChildren](){yield*getContainedChildren(this)}[n.$getSubformParent](){let e=this[n.$getParent]();for(;!(e instanceof Subform);)e=e[n.$getParent]();return e}[n.$isBindable](){return!0}}class SubjectDN extends n.ContentObject{constructor(e){super(d,"subjectDN");this.delimiter=e.delimiter||",";this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||""}[n.$finalize](){this[n.$content]=new Map(this[n.$content].split(this.delimiter).map((e=>{(e=e.split("=",2))[0]=e[0].trim();return e})))}}class SubjectDNs extends n.XFAObject{constructor(e){super(d,"subjectDNs",!0);this.id=e.id||"";this.type=(0,o.getStringOption)(e.type,["optional","required"]);this.use=e.use||"";this.usehref=e.usehref||"";this.subjectDN=new n.XFAObjectArray}}class Submit extends n.XFAObject{constructor(e){super(d,"submit",!0);this.embedPDF=(0,o.getInteger)({data:e.embedPDF,defaultValue:0,validate:e=>1===e});this.format=(0,o.getStringOption)(e.format,["xdp","formdata","pdf","urlencoded","xfd","xml"]);this.id=e.id||"";this.target=e.target||"";this.textEncoding=(0,o.getKeyword)({data:e.textEncoding?e.textEncoding.toLowerCase():"",defaultValue:"",validate:e=>["utf-8","big-five","fontspecific","gbk","gb-18030","gb-2312","ksc-5601","none","shift-jis","ucs-2","utf-16"].includes(e)||e.match(/iso-8859-\d{2}/)});this.use=e.use||"";this.usehref=e.usehref||"";this.xdpContent=e.xdpContent||"";this.encrypt=null;this.encryptData=new n.XFAObjectArray;this.signData=new n.XFAObjectArray}}class Template extends n.XFAObject{constructor(e){super(d,"template",!0);this.baseProfile=(0,o.getStringOption)(e.baseProfile,["full","interactiveForms"]);this.extras=null;this.subform=new n.XFAObjectArray}[n.$finalize](){0===this.subform.children.length&&(0,c.warn)("XFA - No subforms in template node.");this.subform.children.length>=2&&(0,c.warn)("XFA - Several subforms in template node: please file a bug.");this[n.$tabIndex]=5e3}[n.$isSplittable](){return!0}[n.$searchNode](e,t){return e.startsWith("#")?[this[n.$ids].get(e.slice(1))]:(0,u.searchNode)(this,t,e,!0,!0)}*[n.$toPages](){if(!this.subform.children.length)return o.HTMLResult.success({name:"div",children:[]});this[n.$extra]={overflowNode:null,firstUnsplittable:null,currentContentArea:null,currentPageArea:null,noLayoutFailure:!1,pageNumber:1,pagePosition:"first",oddOrEven:"odd",blankOrNotBlank:"nonBlank",paraStack:[]};const e=this.subform.children[0];e.pageSet[n.$cleanPage]();const t=e.pageSet.pageArea.children,r={name:"div",children:[]};let a=null,i=null,s=null;if(e.breakBefore.children.length>=1){i=e.breakBefore.children[0];s=i.target}else if(e.subform.children.length>=1&&e.subform.children[0].breakBefore.children.length>=1){i=e.subform.children[0].breakBefore.children[0];s=i.target}else if(e.break&&e.break.beforeTarget){i=e.break;s=i.beforeTarget}else if(e.subform.children.length>=1&&e.subform.children[0].break&&e.subform.children[0].break.beforeTarget){i=e.subform.children[0].break;s=i.beforeTarget}if(i){const e=this[n.$searchNode](s,i[n.$getParent]());if(e instanceof PageArea){a=e;i[n.$extra]={}}}a||(a=t[0]);a[n.$extra]={numberOfUse:1};const l=a[n.$getParent]();l[n.$extra]={numberOfUse:1,pageIndex:l.pageArea.children.indexOf(a),pageSetIndex:0};let h,u=null,d=null,f=!0,g=0,p=0;for(;;){if(f)g=0;else{r.children.pop();if(3==++g){(0,c.warn)("XFA - Something goes wrong: please file a bug.");return r}}h=null;this[n.$extra].currentPageArea=a;const t=a[n.$toHTML]().html;r.children.push(t);if(u){this[n.$extra].noLayoutFailure=!0;t.children.push(u[n.$toHTML](a[n.$extra].space).html);u=null}if(d){this[n.$extra].noLayoutFailure=!0;t.children.push(d[n.$toHTML](a[n.$extra].space).html);d=null}const i=a.contentArea.children,s=t.children.filter((e=>e.attributes.class.includes("xfaContentarea")));f=!1;this[n.$extra].firstUnsplittable=null;this[n.$extra].noLayoutFailure=!1;const flush=t=>{const r=e[n.$flushHTML]();if(r){f=f||r.children&&0!==r.children.length;s[t].children.push(r)}};for(let t=p,a=i.length;t<a;t++){const a=this[n.$extra].currentContentArea=i[t],o={width:a.w,height:a.h};p=0;if(u){s[t].children.push(u[n.$toHTML](o).html);u=null}if(d){s[t].children.push(d[n.$toHTML](o).html);d=null}const c=e[n.$toHTML](o);if(c.success){if(c.html){f=f||c.html.children&&0!==c.html.children.length;s[t].children.push(c.html)}else!f&&r.children.length>1&&r.children.pop();return r}if(c.isBreak()){const e=c.breakNode;flush(t);if("auto"===e.targetType)continue;if(e.leader){u=this[n.$searchNode](e.leader,e[n.$getParent]());u=u?u[0]:null}if(e.trailer){d=this[n.$searchNode](e.trailer,e[n.$getParent]());d=d?d[0]:null}if("pageArea"===e.targetType){h=e[n.$extra].target;t=1/0}else if(e[n.$extra].target){h=e[n.$extra].target;p=e[n.$extra].index+1;t=1/0}else t=e[n.$extra].index}else if(this[n.$extra].overflowNode){const e=this[n.$extra].overflowNode;this[n.$extra].overflowNode=null;const r=e[n.$getExtra](),a=r.target;r.addLeader=null!==r.leader;r.addTrailer=null!==r.trailer;flush(t);const s=t;t=1/0;if(a instanceof PageArea)h=a;else if(a instanceof ContentArea){const e=i.findIndex((e=>e===a));if(-1!==e)e>s?t=e-1:p=e;else{h=a[n.$getParent]();p=h.contentArea.children.findIndex((e=>e===a))}}}else flush(t)}this[n.$extra].pageNumber+=1;h&&(h[n.$isUsable]()?h[n.$extra].numberOfUse+=1:h=null);a=h||a[n.$getNextPage]();yield null}}}t.Template=Template;class Text extends n.ContentObject{constructor(e){super(d,"text");this.id=e.id||"";this.maxChars=(0,o.getInteger)({data:e.maxChars,defaultValue:0,validate:e=>e>=0});this.name=e.name||"";this.rid=e.rid||"";this.use=e.use||"";this.usehref=e.usehref||""}[n.$acceptWhitespace](){return!0}[n.$onChild](e){if(e[n.$namespaceId]===a.NamespaceIds.xhtml.id){this[n.$content]=e;return!0}(0,c.warn)("XFA - Invalid content in Text: ".concat(e[n.$nodeName],"."));return!1}[n.$onText](e){this[n.$content]instanceof n.XFAObject||super[n.$onText](e)}[n.$finalize](){"string"==typeof this[n.$content]&&(this[n.$content]=this[n.$content].replace(/\r\n/g,"\n"))}[n.$getExtra](){return"string"==typeof this[n.$content]?this[n.$content].split(/[\u2029\u2028\n]/).reduce(((e,t)=>{t&&e.push(t);return e}),[]).join("\n"):this[n.$content][n.$text]()}[n.$toHTML](e){if("string"==typeof this[n.$content]){const e=valueToHtml(this[n.$content]).html;if(this[n.$content].includes("\u2029")){e.name="div";e.children=[];this[n.$content].split("\u2029").map((e=>e.split(/[\u2028\n]/).reduce(((e,t)=>{e.push({name:"span",value:t},{name:"br"});return e}),[]))).forEach((t=>{e.children.push({name:"p",children:t})}))}else if(/[\u2028\n]/.test(this[n.$content])){e.name="div";e.children=[];this[n.$content].split(/[\u2028\n]/).forEach((t=>{e.children.push({name:"span",value:t},{name:"br"})}))}return o.HTMLResult.success(e)}return this[n.$content][n.$toHTML](e)}}t.Text=Text;class TextEdit extends n.XFAObject{constructor(e){super(d,"textEdit",!0);this.allowRichText=(0,o.getInteger)({data:e.allowRichText,defaultValue:0,validate:e=>1===e});this.hScrollPolicy=(0,o.getStringOption)(e.hScrollPolicy,["auto","off","on"]);this.id=e.id||"";this.multiLine=(0,o.getInteger)({data:e.multiLine,defaultValue:"",validate:e=>0===e||1===e});this.use=e.use||"";this.usehref=e.usehref||"";this.vScrollPolicy=(0,o.getStringOption)(e.vScrollPolicy,["auto","off","on"]);this.border=null;this.comb=null;this.extras=null;this.margin=null}[n.$toHTML](e){const t=(0,s.toStyle)(this,"border","font","margin");let r;const a=this[n.$getParent]()[n.$getParent]();""===this.multiLine&&(this.multiLine=a instanceof Draw?1:0);r=1===this.multiLine?{name:"textarea",attributes:{dataId:a[n.$data]&&a[n.$data][n.$uid]||a[n.$uid],fieldId:a[n.$uid],class:["xfaTextfield"],style:t,"aria-label":ariaLabel(a),"aria-required":!1}}:{name:"input",attributes:{type:"text",dataId:a[n.$data]&&a[n.$data][n.$uid]||a[n.$uid],fieldId:a[n.$uid],class:["xfaTextfield"],style:t,"aria-label":ariaLabel(a),"aria-required":!1}};if(isRequired(a)){r.attributes["aria-required"]=!0;r.attributes.required=!0}return o.HTMLResult.success({name:"label",attributes:{class:["xfaLabel"]},children:[r]})}}class Time extends n.StringObject{constructor(e){super(d,"time");this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||""}[n.$finalize](){const e=this[n.$content].trim();this[n.$content]=e?new Date(e):null}[n.$toHTML](e){return valueToHtml(this[n.$content]?this[n.$content].toString():"")}}class TimeStamp extends n.XFAObject{constructor(e){super(d,"timeStamp");this.id=e.id||"";this.server=e.server||"";this.type=(0,o.getStringOption)(e.type,["optional","required"]);this.use=e.use||"";this.usehref=e.usehref||""}}class ToolTip extends n.StringObject{constructor(e){super(d,"toolTip");this.id=e.id||"";this.rid=e.rid||"";this.use=e.use||"";this.usehref=e.usehref||""}}class Traversal extends n.XFAObject{constructor(e){super(d,"traversal",!0);this.id=e.id||"";this.use=e.use||"";this.usehref=e.usehref||"";this.extras=null;this.traverse=new n.XFAObjectArray}}class Traverse extends n.XFAObject{constructor(e){super(d,"traverse",!0);this.id=e.id||"";this.operation=(0,o.getStringOption)(e.operation,["next","back","down","first","left","right","up"]);this.ref=e.ref||"";this.use=e.use||"";this.usehref=e.usehref||"";this.extras=null;this.script=null}get name(){return this.operation}[n.$isTransparent](){return!1}}class Ui extends n.XFAObject{constructor(e){super(d,"ui",!0);this.id=e.id||"";this.use=e.use||"";this.usehref=e.usehref||"";this.extras=null;this.picture=null;this.barcode=null;this.button=null;this.checkButton=null;this.choiceList=null;this.dateTimeEdit=null;this.defaultUi=null;this.imageEdit=null;this.numericEdit=null;this.passwordEdit=null;this.signature=null;this.textEdit=null}[n.$getExtra](){if(void 0===this[n.$extra]){for(const e of Object.getOwnPropertyNames(this)){if("extras"===e||"picture"===e)continue;const t=this[e];if(t instanceof n.XFAObject){this[n.$extra]=t;return t}}this[n.$extra]=null}return this[n.$extra]}[n.$toHTML](e){const t=this[n.$getExtra]();return t?t[n.$toHTML](e):o.HTMLResult.EMPTY}}class Validate extends n.XFAObject{constructor(e){super(d,"validate",!0);this.formatTest=(0,o.getStringOption)(e.formatTest,["warning","disabled","error"]);this.id=e.id||"";this.nullTest=(0,o.getStringOption)(e.nullTest,["disabled","error","warning"]);this.scriptTest=(0,o.getStringOption)(e.scriptTest,["error","disabled","warning"]);this.use=e.use||"";this.usehref=e.usehref||"";this.extras=null;this.message=null;this.picture=null;this.script=null}}class Value extends n.XFAObject{constructor(e){super(d,"value",!0);this.id=e.id||"";this.override=(0,o.getInteger)({data:e.override,defaultValue:0,validate:e=>1===e});this.relevant=(0,o.getRelevant)(e.relevant);this.use=e.use||"";this.usehref=e.usehref||"";this.arc=null;this.boolean=null;this.date=null;this.dateTime=null;this.decimal=null;this.exData=null;this.float=null;this.image=null;this.integer=null;this.line=null;this.rectangle=null;this.text=null;this.time=null}[n.$setValue](e){const t=this[n.$getParent]();if(t instanceof Field&&t.ui&&t.ui.imageEdit){if(!this.image){this.image=new Image({});this[n.$appendChild](this.image)}this.image[n.$content]=e[n.$content];return}const r=e[n.$nodeName];if(null===this[r]){for(const e of Object.getOwnPropertyNames(this)){const t=this[e];if(t instanceof n.XFAObject){this[e]=null;this[n.$removeChild](t)}}this[e[n.$nodeName]]=e;this[n.$appendChild](e)}else this[r][n.$content]=e[n.$content]}[n.$text](){if(this.exData)return"string"==typeof this.exData[n.$content]?this.exData[n.$content].trim():this.exData[n.$content][n.$text]().trim();for(const e of Object.getOwnPropertyNames(this)){if("image"===e)continue;const t=this[e];if(t instanceof n.XFAObject)return(t[n.$content]||"").toString().trim()}return null}[n.$toHTML](e){for(const t of Object.getOwnPropertyNames(this)){const r=this[t];if(r instanceof n.XFAObject)return r[n.$toHTML](e)}return o.HTMLResult.EMPTY}}t.Value=Value;class Variables extends n.XFAObject{constructor(e){super(d,"variables",!0);this.id=e.id||"";this.use=e.use||"";this.usehref=e.usehref||"";this.boolean=new n.XFAObjectArray;this.date=new n.XFAObjectArray;this.dateTime=new n.XFAObjectArray;this.decimal=new n.XFAObjectArray;this.exData=new n.XFAObjectArray;this.float=new n.XFAObjectArray;this.image=new n.XFAObjectArray;this.integer=new n.XFAObjectArray;this.manifest=new n.XFAObjectArray;this.script=new n.XFAObjectArray;this.text=new n.XFAObjectArray;this.time=new n.XFAObjectArray}[n.$isTransparent](){return!0}}class TemplateNamespace{static[a.$buildXFAObject](e,t){if(TemplateNamespace.hasOwnProperty(e)){const r=TemplateNamespace[e](t);r[n.$setSetAttributes](t);return r}}static appearanceFilter(e){return new AppearanceFilter(e)}static arc(e){return new Arc(e)}static area(e){return new Area(e)}static assist(e){return new Assist(e)}static barcode(e){return new Barcode(e)}static bind(e){return new Bind(e)}static bindItems(e){return new BindItems(e)}static bookend(e){return new Bookend(e)}static boolean(e){return new BooleanElement(e)}static border(e){return new Border(e)}static break(e){return new Break(e)}static breakAfter(e){return new BreakAfter(e)}static breakBefore(e){return new BreakBefore(e)}static button(e){return new Button(e)}static calculate(e){return new Calculate(e)}static caption(e){return new Caption(e)}static certificate(e){return new Certificate(e)}static certificates(e){return new Certificates(e)}static checkButton(e){return new CheckButton(e)}static choiceList(e){return new ChoiceList(e)}static color(e){return new Color(e)}static comb(e){return new Comb(e)}static connect(e){return new Connect(e)}static contentArea(e){return new ContentArea(e)}static corner(e){return new Corner(e)}static date(e){return new DateElement(e)}static dateTime(e){return new DateTime(e)}static dateTimeEdit(e){return new DateTimeEdit(e)}static decimal(e){return new Decimal(e)}static defaultUi(e){return new DefaultUi(e)}static desc(e){return new Desc(e)}static digestMethod(e){return new DigestMethod(e)}static digestMethods(e){return new DigestMethods(e)}static draw(e){return new Draw(e)}static edge(e){return new Edge(e)}static encoding(e){return new Encoding(e)}static encodings(e){return new Encodings(e)}static encrypt(e){return new Encrypt(e)}static encryptData(e){return new EncryptData(e)}static encryption(e){return new Encryption(e)}static encryptionMethod(e){return new EncryptionMethod(e)}static encryptionMethods(e){return new EncryptionMethods(e)}static event(e){return new Event(e)}static exData(e){return new ExData(e)}static exObject(e){return new ExObject(e)}static exclGroup(e){return new ExclGroup(e)}static execute(e){return new Execute(e)}static extras(e){return new Extras(e)}static field(e){return new Field(e)}static fill(e){return new Fill(e)}static filter(e){return new Filter(e)}static float(e){return new Float(e)}static font(e){return new Font(e)}static format(e){return new Format(e)}static handler(e){return new Handler(e)}static hyphenation(e){return new Hyphenation(e)}static image(e){return new Image(e)}static imageEdit(e){return new ImageEdit(e)}static integer(e){return new Integer(e)}static issuers(e){return new Issuers(e)}static items(e){return new Items(e)}static keep(e){return new Keep(e)}static keyUsage(e){return new KeyUsage(e)}static line(e){return new Line(e)}static linear(e){return new Linear(e)}static lockDocument(e){return new LockDocument(e)}static manifest(e){return new Manifest(e)}static margin(e){return new Margin(e)}static mdp(e){return new Mdp(e)}static medium(e){return new Medium(e)}static message(e){return new Message(e)}static numericEdit(e){return new NumericEdit(e)}static occur(e){return new Occur(e)}static oid(e){return new Oid(e)}static oids(e){return new Oids(e)}static overflow(e){return new Overflow(e)}static pageArea(e){return new PageArea(e)}static pageSet(e){return new PageSet(e)}static para(e){return new Para(e)}static passwordEdit(e){return new PasswordEdit(e)}static pattern(e){return new Pattern(e)}static picture(e){return new Picture(e)}static proto(e){return new Proto(e)}static radial(e){return new Radial(e)}static reason(e){return new Reason(e)}static reasons(e){return new Reasons(e)}static rectangle(e){return new Rectangle(e)}static ref(e){return new RefElement(e)}static script(e){return new Script(e)}static setProperty(e){return new SetProperty(e)}static signData(e){return new SignData(e)}static signature(e){return new Signature(e)}static signing(e){return new Signing(e)}static solid(e){return new Solid(e)}static speak(e){return new Speak(e)}static stipple(e){return new Stipple(e)}static subform(e){return new Subform(e)}static subformSet(e){return new SubformSet(e)}static subjectDN(e){return new SubjectDN(e)}static subjectDNs(e){return new SubjectDNs(e)}static submit(e){return new Submit(e)}static template(e){return new Template(e)}static text(e){return new Text(e)}static textEdit(e){return new TextEdit(e)}static time(e){return new Time(e)}static timeStamp(e){return new TimeStamp(e)}static toolTip(e){return new ToolTip(e)}static traversal(e){return new Traversal(e)}static traverse(e){return new Traverse(e)}static ui(e){return new Ui(e)}static validate(e){return new Validate(e)}static value(e){return new Value(e)}static variables(e){return new Variables(e)}}t.TemplateNamespace=TemplateNamespace},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.addHTML=function addHTML(e,t,r){const i=e[n.$extra],s=i.availableSpace,[o,c,l,h]=r;switch(e.layout){case"position":i.width=Math.max(i.width,o+l);i.height=Math.max(i.height,c+h);i.children.push(t);break;case"lr-tb":case"rl-tb":if(!i.line||1===i.attempt){i.line=createLine(e,[]);i.children.push(i.line);i.numberInLine=0}i.numberInLine+=1;i.line.children.push(t);if(0===i.attempt){i.currentWidth+=l;i.height=Math.max(i.height,i.prevHeight+h)}else{i.currentWidth=l;i.prevHeight=i.height;i.height+=h;i.attempt=0}i.width=Math.max(i.width,i.currentWidth);break;case"rl-row":case"row":{i.children.push(t);i.width+=l;i.height=Math.max(i.height,h);const e=(0,a.measureToString)(i.height);for(const t of i.children)t.attributes.style.height=e;break}case"table":case"tb":i.width=Math.min(s.width,Math.max(i.width,l));i.height+=h;i.children.push(t)}};t.checkDimensions=function checkDimensions(e,t){if(null===e[n.$getTemplateRoot]()[n.$extra].firstUnsplittable)return!0;if(0===e.w||0===e.h)return!0;const r=e[n.$getSubformParent](),a=r[n.$extra]&&r[n.$extra].attempt||0,[,i,s,o]=function getTransformedBBox(e){let t,r,n=""===e.w?NaN:e.w,a=""===e.h?NaN:e.h,[i,s]=[0,0];switch(e.anchorType||""){case"bottomCenter":[i,s]=[n/2,a];break;case"bottomLeft":[i,s]=[0,a];break;case"bottomRight":[i,s]=[n,a];break;case"middleCenter":[i,s]=[n/2,a/2];break;case"middleLeft":[i,s]=[0,a/2];break;case"middleRight":[i,s]=[n,a/2];break;case"topCenter":[i,s]=[n/2,0];break;case"topRight":[i,s]=[n,0]}switch(e.rotate||0){case 0:[t,r]=[-i,-s];break;case 90:[t,r]=[-s,i];[n,a]=[a,-n];break;case 180:[t,r]=[i,s];[n,a]=[-n,-a];break;case 270:[t,r]=[s,-i];[n,a]=[-a,n]}return[e.x+t+Math.min(0,n),e.y+r+Math.min(0,a),Math.abs(n),Math.abs(a)]}(e);switch(r.layout){case"lr-tb":case"rl-tb":return 0===a?e[n.$getTemplateRoot]()[n.$extra].noLayoutFailure?""!==e.w?Math.round(s-t.width)<=2:t.width>2:!(""!==e.h&&Math.round(o-t.height)>2)&&(""!==e.w?Math.round(s-t.width)<=2||0===r[n.$extra].numberInLine&&t.height>2:t.width>2):!!e[n.$getTemplateRoot]()[n.$extra].noLayoutFailure||!(""!==e.h&&Math.round(o-t.height)>2)&&((""===e.w||Math.round(s-t.width)<=2||!r[n.$isThereMoreWidth]())&&t.height>2);case"table":case"tb":return!!e[n.$getTemplateRoot]()[n.$extra].noLayoutFailure||(""===e.h||e[n.$isSplittable]()?(""===e.w||Math.round(s-t.width)<=2||!r[n.$isThereMoreWidth]())&&t.height>2:Math.round(o-t.height)<=2);case"position":if(e[n.$getTemplateRoot]()[n.$extra].noLayoutFailure)return!0;if(""===e.h||Math.round(o+i-t.height)<=2)return!0;const c=e[n.$getTemplateRoot]()[n.$extra].currentContentArea;return o+i>c.h;case"rl-row":case"row":return!!e[n.$getTemplateRoot]()[n.$extra].noLayoutFailure||(""===e.h||Math.round(o-t.height)<=2);default:return!0}};t.flushHTML=function flushHTML(e){if(!e[n.$extra])return null;const t={name:"div",attributes:e[n.$extra].attributes,children:e[n.$extra].children};if(e[n.$extra].failingNode){const r=e[n.$extra].failingNode[n.$flushHTML]();r&&(e.layout.endsWith("-tb")?t.children.push(createLine(e,[r])):t.children.push(r))}if(0===t.children.length)return null;return t};t.getAvailableSpace=function getAvailableSpace(e){const t=e[n.$extra].availableSpace,r=e.margin?e.margin.topInset+e.margin.bottomInset:0,a=e.margin?e.margin.leftInset+e.margin.rightInset:0;switch(e.layout){case"lr-tb":case"rl-tb":return 0===e[n.$extra].attempt?{width:t.width-a-e[n.$extra].currentWidth,height:t.height-r-e[n.$extra].prevHeight}:{width:t.width-a,height:t.height-r-e[n.$extra].height};case"rl-row":case"row":return{width:e[n.$extra].columnWidths.slice(e[n.$extra].currentColumn).reduce(((e,t)=>e+t)),height:t.height-a};case"table":case"tb":return{width:t.width-a,height:t.height-r-e[n.$extra].height};default:return t}};r(112);r(155);var n=r(294),a=r(302);function createLine(e,t){return{name:"div",attributes:{class:["lr-tb"===e.layout?"xfaLr":"xfaRl"]},children:t}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.computeBbox=function computeBbox(e,t,r){let a;if(""!==e.w&&""!==e.h)a=[e.x,e.y,e.w,e.h];else{if(!r)return null;let i=e.w;if(""===i){if(0===e.maxW){const t=e[n.$getSubformParent]();i="position"===t.layout&&""!==t.w?0:e.minW}else i=Math.min(e.maxW,r.width);t.attributes.style.width=measureToString(i)}let s=e.h;if(""===s){if(0===e.maxH){const t=e[n.$getSubformParent]();s="position"===t.layout&&""!==t.h?0:e.minH}else s=Math.min(e.maxH,r.height);t.attributes.style.height=measureToString(s)}a=[e.x,e.y,i,s]}return a};t.createWrapper=function createWrapper(e,t){const{attributes:r}=t,{style:a}=r,i={name:"div",attributes:{class:["xfaWrapper"],style:Object.create(null)},children:[]};r.class.push("xfaWrapped");if(e.border){const{widths:r,insets:s}=e.border[n.$extra];let o,c,l=s[0],h=s[3];const u=s[0]+s[2],d=s[1]+s[3];switch(e.border.hand){case"even":l-=r[0]/2;h-=r[3]/2;o="calc(100% + ".concat((r[1]+r[3])/2-d,"px)");c="calc(100% + ".concat((r[0]+r[2])/2-u,"px)");break;case"left":l-=r[0];h-=r[3];o="calc(100% + ".concat(r[1]+r[3]-d,"px)");c="calc(100% + ".concat(r[0]+r[2]-u,"px)");break;case"right":o=d?"calc(100% - ".concat(d,"px)"):"100%";c=u?"calc(100% - ".concat(u,"px)"):"100%"}const f=["xfaBorder"];isPrintOnly(e.border)&&f.push("xfaPrintOnly");const g={name:"div",attributes:{class:f,style:{top:"".concat(l,"px"),left:"".concat(h,"px"),width:o,height:c}},children:[]};for(const e of["border","borderWidth","borderColor","borderRadius","borderStyle"])if(void 0!==a[e]){g.attributes.style[e]=a[e];delete a[e]}i.children.push(g,t)}else i.children.push(t);for(const e of["background","backgroundClip","top","left","width","height","minWidth","minHeight","maxWidth","maxHeight","transform","transformOrigin","visibility"])if(void 0!==a[e]){i.attributes.style[e]=a[e];delete a[e]}"absolute"===a.position?i.attributes.style.position="absolute":i.attributes.style.position="relative";delete a.position;if(a.alignSelf){i.attributes.style.alignSelf=a.alignSelf;delete a.alignSelf}return i};t.fixDimensions=function fixDimensions(e){const t=e[n.$getSubformParent]();if(t.layout&&t.layout.includes("row")){const r=t[n.$extra],a=e.colSpan;let i;i=-1===a?r.columnWidths.slice(r.currentColumn).reduce(((e,t)=>e+t),0):r.columnWidths.slice(r.currentColumn,r.currentColumn+a).reduce(((e,t)=>e+t),0);isNaN(i)||(e.w=i)}t.layout&&"position"!==t.layout&&(e.x=e.y=0);"table"===e.layout&&""===e.w&&Array.isArray(e.columnWidths)&&(e.w=e.columnWidths.reduce(((e,t)=>e+t),0))};t.fixTextIndent=function fixTextIndent(e){const t=(0,i.getMeasurement)(e.textIndent,"0px");if(t>=0)return;const r="padding"+("left"==("right"===e.textAlign?"right":"left")?"Left":"Right"),n=(0,i.getMeasurement)(e[r],"0px");e[r]="".concat(n-t,"px")};t.fixURL=function fixURL(e){const t=(0,a.createValidAbsoluteUrl)(e,null,{addDefaultProtocol:!0,tryConvertEncoding:!0});return t?t.href:null};t.isPrintOnly=isPrintOnly;t.layoutClass=function layoutClass(e){switch(e.layout){case"position":default:return"xfaPosition";case"lr-tb":return"xfaLrTb";case"rl-row":return"xfaRlRow";case"rl-tb":return"xfaRlTb";case"row":return"xfaRow";case"table":return"xfaTable";case"tb":return"xfaTb"}};t.layoutNode=function layoutNode(e,t){let r=null,a=null,i=!1;if((!e.w||!e.h)&&e.value){let s=0,o=0;if(e.margin){s=e.margin.leftInset+e.margin.rightInset;o=e.margin.topInset+e.margin.bottomInset}let c=null,l=null;if(e.para){l=Object.create(null);c=""===e.para.lineHeight?null:e.para.lineHeight;l.top=""===e.para.spaceAbove?0:e.para.spaceAbove;l.bottom=""===e.para.spaceBelow?0:e.para.spaceBelow;l.left=""===e.para.marginLeft?0:e.para.marginLeft;l.right=""===e.para.marginRight?0:e.para.marginRight}let h=e.font;if(!h){const t=e[n.$getTemplateRoot]();let r=e[n.$getParent]();for(;r&&r!==t;){if(r.font){h=r.font;break}r=r[n.$getParent]()}}const u=(e.w?e.w:t.width)-s,d=e[n.$globalData].fontFinder;if(e.value.exData&&e.value.exData[n.$content]&&"text/html"===e.value.exData.contentType){const t=layoutText(e.value.exData[n.$content],h,l,c,d,u);a=t.width;r=t.height;i=t.isBroken}else{const t=e.value[n.$text]();if(t){const e=layoutText(t,h,l,c,d,u);a=e.width;r=e.height;i=e.isBroken}}null===a||e.w||(a+=s);null===r||e.h||(r+=o)}return{w:a,h:r,isBroken:i}};t.measureToString=measureToString;t.setAccess=function setAccess(e,t){switch(e.access){case"nonInteractive":t.push("xfaNonInteractive");break;case"readOnly":t.push("xfaReadOnly");break;case"protected":t.push("xfaDisabled")}};t.setFontFamily=function setFontFamily(e,t,r,n){if(!r){delete n.fontFamily;return}const a=(0,i.stripQuotes)(e.typeface);n.fontFamily='"'.concat(a,'"');const o=r.find(a);if(o){const{fontFamily:r}=o.regular.cssFontInfo;r!==a&&(n.fontFamily='"'.concat(r,'"'));const i=getCurrentPara(t);if(i&&""!==i.lineHeight)return;if(n.lineHeight)return;const c=(0,s.selectFont)(e,o);c&&(n.lineHeight=Math.max(1.2,c.lineHeight))}};t.setMinMaxDimensions=function setMinMaxDimensions(e,t){if("position"===e[n.$getSubformParent]().layout){e.minW>0&&(t.minWidth=measureToString(e.minW));e.maxW>0&&(t.maxWidth=measureToString(e.maxW));e.minH>0&&(t.minHeight=measureToString(e.minH));e.maxH>0&&(t.maxHeight=measureToString(e.maxH))}};t.setPara=function setPara(e,t,r){if(r.attributes.class&&r.attributes.class.includes("xfaRich")){if(t){""===e.h&&(t.height="auto");""===e.w&&(t.width="auto")}const a=getCurrentPara(e);if(a){const e=r.attributes.style;e.display="flex";e.flexDirection="column";switch(a.vAlign){case"top":e.justifyContent="start";break;case"bottom":e.justifyContent="end";break;case"middle":e.justifyContent="center"}const t=a[n.$toStyle]();for(const[r,n]of Object.entries(t))r in e||(e[r]=n)}}};t.toStyle=function toStyle(e){const t=Object.create(null);for(var r=arguments.length,i=new Array(r>1?r-1:0),s=1;s<r;s++)i[s-1]=arguments[s];for(const r of i){const i=e[r];if(null!==i)if(c.hasOwnProperty(r))c[r](e,t);else if(i instanceof n.XFAObject){const e=i[n.$toStyle]();e?Object.assign(t,e):(0,a.warn)("(DEBUG) - XFA - style for ".concat(r," not implemented yet"))}}return t};r(212);r(155);r(112);var n=r(294),a=r(158),i=r(295),s=r(303),o=r(304);function measureToString(e){return"string"==typeof e?"0px":Number.isInteger(e)?"".concat(e,"px"):"".concat(e.toFixed(2),"px")}const c={anchorType(e,t){const r=e[n.$getSubformParent]();if(r&&(!r.layout||"position"===r.layout)){"transform"in t||(t.transform="");switch(e.anchorType){case"bottomCenter":t.transform+="translate(-50%, -100%)";break;case"bottomLeft":t.transform+="translate(0,-100%)";break;case"bottomRight":t.transform+="translate(-100%,-100%)";break;case"middleCenter":t.transform+="translate(-50%,-50%)";break;case"middleLeft":t.transform+="translate(0,-50%)";break;case"middleRight":t.transform+="translate(-100%,-50%)";break;case"topCenter":t.transform+="translate(-50%,0)";break;case"topRight":t.transform+="translate(-100%,0)"}}},dimensions(e,t){const r=e[n.$getSubformParent]();let a=e.w;const i=e.h;if(r.layout&&r.layout.includes("row")){const t=r[n.$extra],i=e.colSpan;let s;if(-1===i){s=t.columnWidths.slice(t.currentColumn).reduce(((e,t)=>e+t),0);t.currentColumn=0}else{s=t.columnWidths.slice(t.currentColumn,t.currentColumn+i).reduce(((e,t)=>e+t),0);t.currentColumn=(t.currentColumn+e.colSpan)%t.columnWidths.length}isNaN(s)||(a=e.w=s)}t.width=""!==a?measureToString(a):"auto";t.height=""!==i?measureToString(i):"auto"},position(e,t){const r=e[n.$getSubformParent]();if(!r||!r.layout||"position"===r.layout){t.position="absolute";t.left=measureToString(e.x);t.top=measureToString(e.y)}},rotate(e,t){if(e.rotate){"transform"in t||(t.transform="");t.transform+="rotate(-".concat(e.rotate,"deg)");t.transformOrigin="top left"}},presence(e,t){switch(e.presence){case"invisible":t.visibility="hidden";break;case"hidden":case"inactive":t.display="none"}},hAlign(e,t){if("para"===e[n.$nodeName])switch(e.hAlign){case"justifyAll":t.textAlign="justify-all";break;case"radix":t.textAlign="left";break;default:t.textAlign=e.hAlign}else switch(e.hAlign){case"left":t.alignSelf="start";break;case"center":t.alignSelf="center";break;case"right":t.alignSelf="end"}},margin(e,t){e.margin&&(t.margin=e.margin[n.$toStyle]().margin)}};function layoutText(e,t,r,a,i,s){const c=new o.TextMeasure(t,r,a,i);"string"==typeof e?c.addString(e):e[n.$pushGlyphs](c);return c.compute(s)}function isPrintOnly(e){return e.relevant.length>0&&!e.relevant[0].excluded&&"print"===e.relevant[0].viewname}function getCurrentPara(e){const t=e[n.$getTemplateRoot]()[n.$extra].paraStack;return t.length?t.at(-1):null}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.FontFinder=void 0;t.getMetrics=function getMetrics(e){let t=arguments.length>1&&void 0!==arguments[1]&&arguments[1],r=null;if(e){const t=(0,a.stripQuotes)(e.typeface),i=e[n.$globalData].fontFinder.find(t);r=selectFont(e,i)}if(!r)return{lineHeight:12,lineGap:2,lineNoGap:10};const i=e.size||10,s=r.lineHeight?Math.max(t?0:1.2,r.lineHeight):1.2,o=void 0===r.lineGap?.2:r.lineGap;return{lineHeight:s*i,lineGap:o*i,lineNoGap:Math.max(1,s-o)*i}};t.selectFont=selectFont;r(112);r(212);r(159);r(179);var n=r(294),a=r(295),i=r(158);t.FontFinder=class FontFinder{constructor(e){this.fonts=new Map;this.cache=new Map;this.warned=new Set;this.defaultFont=null;this.add(e)}add(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;for(const t of e)this.addPdfFont(t);for(const e of this.fonts.values())e.regular||(e.regular=e.italic||e.bold||e.bolditalic);if(!t||0===t.size)return;const r=this.fonts.get("PdfJS-Fallback-PdfJS-XFA");for(const e of t)this.fonts.set(e,r)}addPdfFont(e){const t=e.cssFontInfo,r=t.fontFamily;let n=this.fonts.get(r);if(!n){n=Object.create(null);this.fonts.set(r,n);this.defaultFont||(this.defaultFont=n)}let a="";const i=parseFloat(t.fontWeight);0!==parseFloat(t.italicAngle)?a=i>=700?"bolditalic":"italic":i>=700&&(a="bold");if(!a){(e.name.includes("Bold")||e.psName&&e.psName.includes("Bold"))&&(a="bold");(e.name.includes("Italic")||e.name.endsWith("It")||e.psName&&(e.psName.includes("Italic")||e.psName.endsWith("It")))&&(a+="italic")}a||(a="regular");n[a]=e}getDefault(){return this.defaultFont}find(e){let t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=this.fonts.get(e)||this.cache.get(e);if(r)return r;const n=/,|-|_| |bolditalic|bold|italic|regular|it/gi;let a=e.replace(n,"");r=this.fonts.get(a);if(r){this.cache.set(e,r);return r}a=a.toLowerCase();const s=[];for(const[e,t]of this.fonts.entries())e.replace(n,"").toLowerCase().startsWith(a)&&s.push(t);if(0===s.length)for(const[,e]of this.fonts.entries())e.regular.name&&e.regular.name.replace(n,"").toLowerCase().startsWith(a)&&s.push(e);if(0===s.length){a=a.replace(/psmt|mt/gi,"");for(const[e,t]of this.fonts.entries())e.replace(n,"").toLowerCase().startsWith(a)&&s.push(t)}if(0===s.length)for(const e of this.fonts.values())e.regular.name&&e.regular.name.replace(n,"").toLowerCase().startsWith(a)&&s.push(e);if(s.length>=1){1!==s.length&&t&&(0,i.warn)("XFA - Too many choices to guess the correct font: ".concat(e));this.cache.set(e,s[0]);return s[0]}if(t&&!this.warned.has(e)){this.warned.add(e);(0,i.warn)("XFA - Cannot find the font: ".concat(e))}return null}};function selectFont(e,t){return"italic"===e.posture?"bold"===e.weight?t.bolditalic:t.italic:"bold"===e.weight?t.bold:t.regular}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.TextMeasure=void 0;r(112);r(159);var n=r(303);class FontInfo{constructor(e,t,r,a){this.lineHeight=r;this.paraMargin=t||{top:0,bottom:0,left:0,right:0};if(!e){[this.pdfFont,this.xfaFont]=this.defaultFont(a);return}this.xfaFont={typeface:e.typeface,posture:e.posture,weight:e.weight,size:e.size,letterSpacing:e.letterSpacing};const i=a.find(e.typeface);if(i){this.pdfFont=(0,n.selectFont)(e,i);this.pdfFont||([this.pdfFont,this.xfaFont]=this.defaultFont(a))}else[this.pdfFont,this.xfaFont]=this.defaultFont(a)}defaultFont(e){const t=e.find("Helvetica",!1)||e.find("Myriad Pro",!1)||e.find("Arial",!1)||e.getDefault();if(t&&t.regular){const e=t.regular;return[e,{typeface:e.cssFontInfo.fontFamily,posture:"normal",weight:"normal",size:10,letterSpacing:0}]}return[null,{typeface:"Courier",posture:"normal",weight:"normal",size:10,letterSpacing:0}]}}class FontSelector{constructor(e,t,r,n){this.fontFinder=n;this.stack=[new FontInfo(e,t,r,n)]}pushData(e,t,r){const n=this.stack.at(-1);for(const t of["typeface","posture","weight","size","letterSpacing"])e[t]||(e[t]=n.xfaFont[t]);for(const e of["top","bottom","left","right"])isNaN(t[e])&&(t[e]=n.paraMargin[e]);const a=new FontInfo(e,t,r||n.lineHeight,this.fontFinder);a.pdfFont||(a.pdfFont=n.pdfFont);this.stack.push(a)}popFont(){this.stack.pop()}topFont(){return this.stack.at(-1)}}t.TextMeasure=class TextMeasure{constructor(e,t,r,n){this.glyphs=[];this.fontSelector=new FontSelector(e,t,r,n);this.extraHeight=0}pushData(e,t,r){this.fontSelector.pushData(e,t,r)}popFont(e){return this.fontSelector.popFont()}addPara(){const e=this.fontSelector.topFont();this.extraHeight+=e.paraMargin.top+e.paraMargin.bottom}addString(e){if(!e)return;const t=this.fontSelector.topFont(),r=t.xfaFont.size;if(t.pdfFont){const n=t.xfaFont.letterSpacing,a=t.pdfFont,i=a.lineHeight||1.2,s=t.lineHeight||Math.max(1.2,i)*r,o=i-(void 0===a.lineGap?.2:a.lineGap),c=Math.max(1,o)*r,l=r/1e3,h=a.defaultWidth||a.charsToGlyphs(" ")[0].width;for(const t of e.split(/[\u2029\n]/)){const e=a.encodeString(t).join(""),r=a.charsToGlyphs(e);for(const e of r){const t=e.width||h;this.glyphs.push([t*l+n,s,c,e.unicode,!1])}this.glyphs.push([0,0,0,"\n",!0])}this.glyphs.pop()}else{for(const t of e.split(/[\u2029\n]/)){for(const e of t.split(""))this.glyphs.push([r,1.2*r,r,e,!1]);this.glyphs.push([0,0,0,"\n",!0])}this.glyphs.pop()}}compute(e){let t=-1,r=0,n=0,a=0,i=0,s=0,o=!1,c=!0;for(let l=0,h=this.glyphs.length;l<h;l++){const[h,u,d,f,g]=this.glyphs[l],p=" "===f,m=c?d:u;if(g){n=Math.max(n,i);i=0;a+=s;s=m;t=-1;r=0;c=!1}else if(p)if(i+h>e){n=Math.max(n,i);i=0;a+=s;s=m;t=-1;r=0;o=!0;c=!1}else{s=Math.max(m,s);r=i;i+=h;t=l}else if(i+h>e){a+=s;s=m;if(-1!==t){l=t;n=Math.max(n,r);i=0;t=-1;r=0}else{n=Math.max(n,i);i=h}o=!0;c=!1}else{i+=h;s=Math.max(m,s)}}n=Math.max(n,i);a+=s+this.extraHeight;return{width:1.02*n,height:a,isBroken:o}}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.DataHandler=void 0;r(112);var n=r(294);t.DataHandler=class DataHandler{constructor(e,t){this.data=t;this.dataset=e.datasets||null}serialize(e){const t=[[-1,this.data[n.$getChildren]()]];for(;t.length>0;){const r=t.at(-1),[a,i]=r;if(a+1===i.length){t.pop();continue}const s=i[++r[0]],o=e.get(s[n.$uid]);if(o)s[n.$setValue](o);else{const t=s[n.$getAttributes]();for(const r of t.values()){const t=e.get(r[n.$uid]);if(t){r[n.$setValue](t);break}}}const c=s[n.$getChildren]();c.length>0&&t.push([-1,c])}const r=['<xfa:datasets xmlns:xfa="http://www.xfa.org/schema/xfa-data/1.0/">'];if(this.dataset)for(const e of this.dataset[n.$getChildren]())"data"!==e[n.$nodeName]&&e[n.$toString](r);this.data[n.$toString](r);r.push("</xfa:datasets>");return r.join("")}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.XFAParser=void 0;r(112);r(159);r(179);var n=r(294),a=r(283),i=r(307),s=r(158);class XFAParser extends a.XMLParserBase{constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null,t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];super();this._builder=new i.Builder(e);this._stack=[];this._globalData={usedTypefaces:new Set};this._ids=new Map;this._current=this._builder.buildRoot(this._ids);this._errorCode=a.XMLParserErrorCode.NoError;this._whiteRegex=/^\s+$/;this._nbsps=/\xa0+/g;this._richText=t}parse(e){this.parseXml(e);if(this._errorCode===a.XMLParserErrorCode.NoError){this._current[n.$finalize]();return this._current.element}}onText(e){e=e.replace(this._nbsps,(e=>e.slice(1)+" "));this._richText||this._current[n.$acceptWhitespace]()?this._current[n.$onText](e,this._richText):this._whiteRegex.test(e)||this._current[n.$onText](e.trim())}onCdata(e){this._current[n.$onText](e)}_mkAttributes(e,t){let r=null,a=null;const i=Object.create({});for(const{name:o,value:c}of e)if("xmlns"===o)r?(0,s.warn)("XFA - multiple namespace definition in <".concat(t,">")):r=c;else if(o.startsWith("xmlns:")){const e=o.substring("xmlns:".length);a||(a=[]);a.push({prefix:e,value:c})}else{const e=o.indexOf(":");if(-1===e)i[o]=c;else{let t=i[n.$nsAttributes];t||(t=i[n.$nsAttributes]=Object.create(null));const[r,a]=[o.slice(0,e),o.slice(e+1)];let s=t[r];s||(s=t[r]=Object.create(null));s[a]=c}}return[r,a,i]}_getNameAndPrefix(e,t){const r=e.indexOf(":");return-1===r?[e,null]:[e.substring(r+1),t?"":e.substring(0,r)]}onBeginElement(e,t,r){const[a,i,s]=this._mkAttributes(t,e),[o,c]=this._getNameAndPrefix(e,this._builder.isNsAgnostic()),l=this._builder.build({nsPrefix:c,name:o,attributes:s,namespace:a,prefixes:i});l[n.$globalData]=this._globalData;if(r){l[n.$finalize]();this._current[n.$onChild](l)&&l[n.$setId](this._ids);l[n.$clean](this._builder)}else{this._stack.push(this._current);this._current=l}}onEndElement(e){const t=this._current;if(t[n.$isCDATAXml]()&&"string"==typeof t[n.$content]){const e=new XFAParser;e._globalData=this._globalData;const r=e.parse(t[n.$content]);t[n.$content]=null;t[n.$onChild](r)}t[n.$finalize]();this._current=this._stack.pop();this._current[n.$onChild](t)&&t[n.$setId](this._ids);t[n.$clean](this._builder)}onError(e){this._errorCode=e}}t.XFAParser=XFAParser},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.Builder=void 0;r(112);var n=r(296),a=r(294),i=r(308),s=r(300),o=r(319),c=r(158);class Root extends a.XFAObject{constructor(e){super(-1,"root",Object.create(null));this.element=null;this[a.$ids]=e}[a.$onChild](e){this.element=e;return!0}[a.$finalize](){super[a.$finalize]();if(this.element.template instanceof s.Template){this[a.$ids].set(a.$root,this.element);this.element.template[a.$resolvePrototypes](this[a.$ids]);this.element.template[a.$ids]=this[a.$ids]}}}class Empty extends a.XFAObject{constructor(){super(-1,"",Object.create(null))}[a.$onChild](e){return!1}}t.Builder=class Builder{constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;this._namespaceStack=[];this._nsAgnosticLevel=0;this._namespacePrefixes=new Map;this._namespaces=new Map;this._nextNsId=Math.max(...Object.values(n.NamespaceIds).map((e=>{let{id:t}=e;return t})));this._currentNamespace=e||new o.UnknownNamespace(++this._nextNsId)}buildRoot(e){return new Root(e)}build(e){let{nsPrefix:t,name:r,attributes:s,namespace:o,prefixes:c}=e;const l=null!==o;if(l){this._namespaceStack.push(this._currentNamespace);this._currentNamespace=this._searchNamespace(o)}c&&this._addNamespacePrefix(c);if(s.hasOwnProperty(a.$nsAttributes)){const e=i.NamespaceSetUp.datasets,t=s[a.$nsAttributes];let r=null;for(const[n,a]of Object.entries(t)){if(this._getNamespaceToUse(n)===e){r={xfa:a};break}}r?s[a.$nsAttributes]=r:delete s[a.$nsAttributes]}const h=this._getNamespaceToUse(t),u=h&&h[n.$buildXFAObject](r,s)||new Empty;u[a.$isNsAgnostic]()&&this._nsAgnosticLevel++;(l||c||u[a.$isNsAgnostic]())&&(u[a.$cleanup]={hasNamespace:l,prefixes:c,nsAgnostic:u[a.$isNsAgnostic]()});return u}isNsAgnostic(){return this._nsAgnosticLevel>0}_searchNamespace(e){let t=this._namespaces.get(e);if(t)return t;for(const[r,{check:a}]of Object.entries(n.NamespaceIds))if(a(e)){t=i.NamespaceSetUp[r];if(t){this._namespaces.set(e,t);return t}break}t=new o.UnknownNamespace(++this._nextNsId);this._namespaces.set(e,t);return t}_addNamespacePrefix(e){for(const{prefix:t,value:r}of e){const e=this._searchNamespace(r);let n=this._namespacePrefixes.get(t);if(!n){n=[];this._namespacePrefixes.set(t,n)}n.push(e)}}_getNamespaceToUse(e){if(!e)return this._currentNamespace;const t=this._namespacePrefixes.get(e);if(t&&t.length>0)return t.at(-1);(0,c.warn)("Unknown namespace prefix: ".concat(e,"."));return null}clean(e){const{hasNamespace:t,prefixes:r,nsAgnostic:n}=e;t&&(this._currentNamespace=this._namespaceStack.pop());r&&r.forEach((e=>{let{prefix:t}=e;this._namespacePrefixes.get(t).pop()}));n&&this._nsAgnosticLevel--}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.NamespaceSetUp=void 0;var n=r(309),a=r(310),i=r(311),s=r(312),o=r(313),c=r(314),l=r(300),h=r(315),u=r(316);const d={config:n.ConfigNamespace,connection:a.ConnectionSetNamespace,datasets:i.DatasetsNamespace,localeSet:s.LocaleSetNamespace,signature:o.SignatureNamespace,stylesheet:c.StylesheetNamespace,template:l.TemplateNamespace,xdp:h.XdpNamespace,xhtml:u.XhtmlNamespace};t.NamespaceSetUp=d},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.ConfigNamespace=void 0;r(112);r(159);r(212);r(214);var n=r(296),a=r(294),i=r(295),s=r(158);const o=n.NamespaceIds.config.id;class Acrobat extends a.XFAObject{constructor(e){super(o,"acrobat",!0);this.acrobat7=null;this.autoSave=null;this.common=null;this.validate=null;this.validateApprovalSignatures=null;this.submitUrl=new a.XFAObjectArray}}class Acrobat7 extends a.XFAObject{constructor(e){super(o,"acrobat7",!0);this.dynamicRender=null}}class ADBE_JSConsole extends a.OptionObject{constructor(e){super(o,"ADBE_JSConsole",["delegate","Enable","Disable"])}}class ADBE_JSDebugger extends a.OptionObject{constructor(e){super(o,"ADBE_JSDebugger",["delegate","Enable","Disable"])}}class AddSilentPrint extends a.Option01{constructor(e){super(o,"addSilentPrint")}}class AddViewerPreferences extends a.Option01{constructor(e){super(o,"addViewerPreferences")}}class AdjustData extends a.Option10{constructor(e){super(o,"adjustData")}}class AdobeExtensionLevel extends a.IntegerObject{constructor(e){super(o,"adobeExtensionLevel",0,(e=>e>=1&&e<=8))}}class Agent extends a.XFAObject{constructor(e){super(o,"agent",!0);this.name=e.name?e.name.trim():"";this.common=new a.XFAObjectArray}}class AlwaysEmbed extends a.ContentObject{constructor(e){super(o,"alwaysEmbed")}}class Amd extends a.StringObject{constructor(e){super(o,"amd")}}class Area extends a.XFAObject{constructor(e){super(o,"area");this.level=(0,i.getInteger)({data:e.level,defaultValue:0,validate:e=>e>=1&&e<=3});this.name=(0,i.getStringOption)(e.name,["","barcode","coreinit","deviceDriver","font","general","layout","merge","script","signature","sourceSet","templateCache"])}}class Attributes extends a.OptionObject{constructor(e){super(o,"attributes",["preserve","delegate","ignore"])}}class AutoSave extends a.OptionObject{constructor(e){super(o,"autoSave",["disabled","enabled"])}}class Base extends a.StringObject{constructor(e){super(o,"base")}}class BatchOutput extends a.XFAObject{constructor(e){super(o,"batchOutput");this.format=(0,i.getStringOption)(e.format,["none","concat","zip","zipCompress"])}}class BehaviorOverride extends a.ContentObject{constructor(e){super(o,"behaviorOverride")}[a.$finalize](){this[a.$content]=new Map(this[a.$content].trim().split(/\s+/).filter((e=>e.includes(":"))).map((e=>e.split(":",2))))}}class Cache extends a.XFAObject{constructor(e){super(o,"cache",!0);this.templateCache=null}}class Change extends a.Option01{constructor(e){super(o,"change")}}class Common extends a.XFAObject{constructor(e){super(o,"common",!0);this.data=null;this.locale=null;this.localeSet=null;this.messaging=null;this.suppressBanner=null;this.template=null;this.validationMessaging=null;this.versionControl=null;this.log=new a.XFAObjectArray}}class Compress extends a.XFAObject{constructor(e){super(o,"compress");this.scope=(0,i.getStringOption)(e.scope,["imageOnly","document"])}}class CompressLogicalStructure extends a.Option01{constructor(e){super(o,"compressLogicalStructure")}}class CompressObjectStream extends a.Option10{constructor(e){super(o,"compressObjectStream")}}class Compression extends a.XFAObject{constructor(e){super(o,"compression",!0);this.compressLogicalStructure=null;this.compressObjectStream=null;this.level=null;this.type=null}}class Config extends a.XFAObject{constructor(e){super(o,"config",!0);this.acrobat=null;this.present=null;this.trace=null;this.agent=new a.XFAObjectArray}}class Conformance extends a.OptionObject{constructor(e){super(o,"conformance",["A","B"])}}class ContentCopy extends a.Option01{constructor(e){super(o,"contentCopy")}}class Copies extends a.IntegerObject{constructor(e){super(o,"copies",1,(e=>e>=1))}}class Creator extends a.StringObject{constructor(e){super(o,"creator")}}class CurrentPage extends a.IntegerObject{constructor(e){super(o,"currentPage",0,(e=>e>=0))}}class Data extends a.XFAObject{constructor(e){super(o,"data",!0);this.adjustData=null;this.attributes=null;this.incrementalLoad=null;this.outputXSL=null;this.range=null;this.record=null;this.startNode=null;this.uri=null;this.window=null;this.xsl=null;this.excludeNS=new a.XFAObjectArray;this.transform=new a.XFAObjectArray}}class Debug extends a.XFAObject{constructor(e){super(o,"debug",!0);this.uri=null}}class DefaultTypeface extends a.ContentObject{constructor(e){super(o,"defaultTypeface");this.writingScript=(0,i.getStringOption)(e.writingScript,["*","Arabic","Cyrillic","EastEuropeanRoman","Greek","Hebrew","Japanese","Korean","Roman","SimplifiedChinese","Thai","TraditionalChinese","Vietnamese"])}}class Destination extends a.OptionObject{constructor(e){super(o,"destination",["pdf","pcl","ps","webClient","zpl"])}}class DocumentAssembly extends a.Option01{constructor(e){super(o,"documentAssembly")}}class Driver extends a.XFAObject{constructor(e){super(o,"driver",!0);this.name=e.name?e.name.trim():"";this.fontInfo=null;this.xdc=null}}class DuplexOption extends a.OptionObject{constructor(e){super(o,"duplexOption",["simplex","duplexFlipLongEdge","duplexFlipShortEdge"])}}class DynamicRender extends a.OptionObject{constructor(e){super(o,"dynamicRender",["forbidden","required"])}}class Embed extends a.Option01{constructor(e){super(o,"embed")}}class Encrypt extends a.Option01{constructor(e){super(o,"encrypt")}}class Encryption extends a.XFAObject{constructor(e){super(o,"encryption",!0);this.encrypt=null;this.encryptionLevel=null;this.permissions=null}}class EncryptionLevel extends a.OptionObject{constructor(e){super(o,"encryptionLevel",["40bit","128bit"])}}class Enforce extends a.StringObject{constructor(e){super(o,"enforce")}}class Equate extends a.XFAObject{constructor(e){super(o,"equate");this.force=(0,i.getInteger)({data:e.force,defaultValue:1,validate:e=>0===e});this.from=e.from||"";this.to=e.to||""}}class EquateRange extends a.XFAObject{constructor(e){super(o,"equateRange");this.from=e.from||"";this.to=e.to||"";this._unicodeRange=e.unicodeRange||""}get unicodeRange(){const e=[],t=/U\+([0-9a-fA-F]+)/,r=this._unicodeRange;for(let n of r.split(",").map((e=>e.trim())).filter((e=>!!e))){n=n.split("-",2).map((e=>{const r=e.match(t);return r?parseInt(r[1],16):0}));1===n.length&&n.push(n[0]);e.push(n)}return(0,s.shadow)(this,"unicodeRange",e)}}class Exclude extends a.ContentObject{constructor(e){super(o,"exclude")}[a.$finalize](){this[a.$content]=this[a.$content].trim().split(/\s+/).filter((e=>e&&["calculate","close","enter","exit","initialize","ready","validate"].includes(e)))}}class ExcludeNS extends a.StringObject{constructor(e){super(o,"excludeNS")}}class FlipLabel extends a.OptionObject{constructor(e){super(o,"flipLabel",["usePrinterSetting","on","off"])}}class FontInfo extends a.XFAObject{constructor(e){super(o,"fontInfo",!0);this.embed=null;this.map=null;this.subsetBelow=null;this.alwaysEmbed=new a.XFAObjectArray;this.defaultTypeface=new a.XFAObjectArray;this.neverEmbed=new a.XFAObjectArray}}class FormFieldFilling extends a.Option01{constructor(e){super(o,"formFieldFilling")}}class GroupParent extends a.StringObject{constructor(e){super(o,"groupParent")}}class IfEmpty extends a.OptionObject{constructor(e){super(o,"ifEmpty",["dataValue","dataGroup","ignore","remove"])}}class IncludeXDPContent extends a.StringObject{constructor(e){super(o,"includeXDPContent")}}class IncrementalLoad extends a.OptionObject{constructor(e){super(o,"incrementalLoad",["none","forwardOnly"])}}class IncrementalMerge extends a.Option01{constructor(e){super(o,"incrementalMerge")}}class Interactive extends a.Option01{constructor(e){super(o,"interactive")}}class Jog extends a.OptionObject{constructor(e){super(o,"jog",["usePrinterSetting","none","pageSet"])}}class LabelPrinter extends a.XFAObject{constructor(e){super(o,"labelPrinter",!0);this.name=(0,i.getStringOption)(e.name,["zpl","dpl","ipl","tcpl"]);this.batchOutput=null;this.flipLabel=null;this.fontInfo=null;this.xdc=null}}class Layout extends a.OptionObject{constructor(e){super(o,"layout",["paginate","panel"])}}class Level extends a.IntegerObject{constructor(e){super(o,"level",0,(e=>e>0))}}class Linearized extends a.Option01{constructor(e){super(o,"linearized")}}class Locale extends a.StringObject{constructor(e){super(o,"locale")}}class LocaleSet extends a.StringObject{constructor(e){super(o,"localeSet")}}class Log extends a.XFAObject{constructor(e){super(o,"log",!0);this.mode=null;this.threshold=null;this.to=null;this.uri=null}}class MapElement extends a.XFAObject{constructor(e){super(o,"map",!0);this.equate=new a.XFAObjectArray;this.equateRange=new a.XFAObjectArray}}class MediumInfo extends a.XFAObject{constructor(e){super(o,"mediumInfo",!0);this.map=null}}class Message extends a.XFAObject{constructor(e){super(o,"message",!0);this.msgId=null;this.severity=null}}class Messaging extends a.XFAObject{constructor(e){super(o,"messaging",!0);this.message=new a.XFAObjectArray}}class Mode extends a.OptionObject{constructor(e){super(o,"mode",["append","overwrite"])}}class ModifyAnnots extends a.Option01{constructor(e){super(o,"modifyAnnots")}}class MsgId extends a.IntegerObject{constructor(e){super(o,"msgId",1,(e=>e>=1))}}class NameAttr extends a.StringObject{constructor(e){super(o,"nameAttr")}}class NeverEmbed extends a.ContentObject{constructor(e){super(o,"neverEmbed")}}class NumberOfCopies extends a.IntegerObject{constructor(e){super(o,"numberOfCopies",null,(e=>e>=2&&e<=5))}}class OpenAction extends a.XFAObject{constructor(e){super(o,"openAction",!0);this.destination=null}}class Output extends a.XFAObject{constructor(e){super(o,"output",!0);this.to=null;this.type=null;this.uri=null}}class OutputBin extends a.StringObject{constructor(e){super(o,"outputBin")}}class OutputXSL extends a.XFAObject{constructor(e){super(o,"outputXSL",!0);this.uri=null}}class Overprint extends a.OptionObject{constructor(e){super(o,"overprint",["none","both","draw","field"])}}class Packets extends a.StringObject{constructor(e){super(o,"packets")}[a.$finalize](){"*"!==this[a.$content]&&(this[a.$content]=this[a.$content].trim().split(/\s+/).filter((e=>["config","datasets","template","xfdf","xslt"].includes(e))))}}class PageOffset extends a.XFAObject{constructor(e){super(o,"pageOffset");this.x=(0,i.getInteger)({data:e.x,defaultValue:"useXDCSetting",validate:e=>!0});this.y=(0,i.getInteger)({data:e.y,defaultValue:"useXDCSetting",validate:e=>!0})}}class PageRange extends a.StringObject{constructor(e){super(o,"pageRange")}[a.$finalize](){const e=this[a.$content].trim().split(/\s+/).map((e=>parseInt(e,10))),t=[];for(let r=0,n=e.length;r<n;r+=2)t.push(e.slice(r,r+2));this[a.$content]=t}}class Pagination extends a.OptionObject{constructor(e){super(o,"pagination",["simplex","duplexShortEdge","duplexLongEdge"])}}class PaginationOverride extends a.OptionObject{constructor(e){super(o,"paginationOverride",["none","forceDuplex","forceDuplexLongEdge","forceDuplexShortEdge","forceSimplex"])}}class Part extends a.IntegerObject{constructor(e){super(o,"part",1,(e=>!1))}}class Pcl extends a.XFAObject{constructor(e){super(o,"pcl",!0);this.name=e.name||"";this.batchOutput=null;this.fontInfo=null;this.jog=null;this.mediumInfo=null;this.outputBin=null;this.pageOffset=null;this.staple=null;this.xdc=null}}class Pdf extends a.XFAObject{constructor(e){super(o,"pdf",!0);this.name=e.name||"";this.adobeExtensionLevel=null;this.batchOutput=null;this.compression=null;this.creator=null;this.encryption=null;this.fontInfo=null;this.interactive=null;this.linearized=null;this.openAction=null;this.pdfa=null;this.producer=null;this.renderPolicy=null;this.scriptModel=null;this.silentPrint=null;this.submitFormat=null;this.tagged=null;this.version=null;this.viewerPreferences=null;this.xdc=null}}class Pdfa extends a.XFAObject{constructor(e){super(o,"pdfa",!0);this.amd=null;this.conformance=null;this.includeXDPContent=null;this.part=null}}class Permissions extends a.XFAObject{constructor(e){super(o,"permissions",!0);this.accessibleContent=null;this.change=null;this.contentCopy=null;this.documentAssembly=null;this.formFieldFilling=null;this.modifyAnnots=null;this.plaintextMetadata=null;this.print=null;this.printHighQuality=null}}class PickTrayByPDFSize extends a.Option01{constructor(e){super(o,"pickTrayByPDFSize")}}class Picture extends a.StringObject{constructor(e){super(o,"picture")}}class PlaintextMetadata extends a.Option01{constructor(e){super(o,"plaintextMetadata")}}class Presence extends a.OptionObject{constructor(e){super(o,"presence",["preserve","dissolve","dissolveStructure","ignore","remove"])}}class Present extends a.XFAObject{constructor(e){super(o,"present",!0);this.behaviorOverride=null;this.cache=null;this.common=null;this.copies=null;this.destination=null;this.incrementalMerge=null;this.layout=null;this.output=null;this.overprint=null;this.pagination=null;this.paginationOverride=null;this.script=null;this.validate=null;this.xdp=null;this.driver=new a.XFAObjectArray;this.labelPrinter=new a.XFAObjectArray;this.pcl=new a.XFAObjectArray;this.pdf=new a.XFAObjectArray;this.ps=new a.XFAObjectArray;this.submitUrl=new a.XFAObjectArray;this.webClient=new a.XFAObjectArray;this.zpl=new a.XFAObjectArray}}class Print extends a.Option01{constructor(e){super(o,"print")}}class PrintHighQuality extends a.Option01{constructor(e){super(o,"printHighQuality")}}class PrintScaling extends a.OptionObject{constructor(e){super(o,"printScaling",["appdefault","noScaling"])}}class PrinterName extends a.StringObject{constructor(e){super(o,"printerName")}}class Producer extends a.StringObject{constructor(e){super(o,"producer")}}class Ps extends a.XFAObject{constructor(e){super(o,"ps",!0);this.name=e.name||"";this.batchOutput=null;this.fontInfo=null;this.jog=null;this.mediumInfo=null;this.outputBin=null;this.staple=null;this.xdc=null}}class Range extends a.ContentObject{constructor(e){super(o,"range")}[a.$finalize](){this[a.$content]=this[a.$content].trim().split(/\s*,\s*/,2).map((e=>e.split("-").map((e=>parseInt(e.trim(),10))))).filter((e=>e.every((e=>!isNaN(e))))).map((e=>{1===e.length&&e.push(e[0]);return e}))}}class Record extends a.ContentObject{constructor(e){super(o,"record")}[a.$finalize](){this[a.$content]=this[a.$content].trim();const e=parseInt(this[a.$content],10);!isNaN(e)&&e>=0&&(this[a.$content]=e)}}class Relevant extends a.ContentObject{constructor(e){super(o,"relevant")}[a.$finalize](){this[a.$content]=this[a.$content].trim().split(/\s+/)}}class Rename extends a.ContentObject{constructor(e){super(o,"rename")}[a.$finalize](){this[a.$content]=this[a.$content].trim();(this[a.$content].toLowerCase().startsWith("xml")||this[a.$content].match(new RegExp("[\\p{L}_][\\p{L}\\d._\\p{M}-]*","u")))&&(0,s.warn)("XFA - Rename: invalid XFA name")}}class RenderPolicy extends a.OptionObject{constructor(e){super(o,"renderPolicy",["server","client"])}}class RunScripts extends a.OptionObject{constructor(e){super(o,"runScripts",["both","client","none","server"])}}class Script extends a.XFAObject{constructor(e){super(o,"script",!0);this.currentPage=null;this.exclude=null;this.runScripts=null}}class ScriptModel extends a.OptionObject{constructor(e){super(o,"scriptModel",["XFA","none"])}}class Severity extends a.OptionObject{constructor(e){super(o,"severity",["ignore","error","information","trace","warning"])}}class SilentPrint extends a.XFAObject{constructor(e){super(o,"silentPrint",!0);this.addSilentPrint=null;this.printerName=null}}class Staple extends a.XFAObject{constructor(e){super(o,"staple");this.mode=(0,i.getStringOption)(e.mode,["usePrinterSetting","on","off"])}}class StartNode extends a.StringObject{constructor(e){super(o,"startNode")}}class StartPage extends a.IntegerObject{constructor(e){super(o,"startPage",0,(e=>!0))}}class SubmitFormat extends a.OptionObject{constructor(e){super(o,"submitFormat",["html","delegate","fdf","xml","pdf"])}}class SubmitUrl extends a.StringObject{constructor(e){super(o,"submitUrl")}}class SubsetBelow extends a.IntegerObject{constructor(e){super(o,"subsetBelow",100,(e=>e>=0&&e<=100))}}class SuppressBanner extends a.Option01{constructor(e){super(o,"suppressBanner")}}class Tagged extends a.Option01{constructor(e){super(o,"tagged")}}class Template extends a.XFAObject{constructor(e){super(o,"template",!0);this.base=null;this.relevant=null;this.startPage=null;this.uri=null;this.xsl=null}}class Threshold extends a.OptionObject{constructor(e){super(o,"threshold",["trace","error","information","warning"])}}class To extends a.OptionObject{constructor(e){super(o,"to",["null","memory","stderr","stdout","system","uri"])}}class TemplateCache extends a.XFAObject{constructor(e){super(o,"templateCache");this.maxEntries=(0,i.getInteger)({data:e.maxEntries,defaultValue:5,validate:e=>e>=0})}}class Trace extends a.XFAObject{constructor(e){super(o,"trace",!0);this.area=new a.XFAObjectArray}}class Transform extends a.XFAObject{constructor(e){super(o,"transform",!0);this.groupParent=null;this.ifEmpty=null;this.nameAttr=null;this.picture=null;this.presence=null;this.rename=null;this.whitespace=null}}class Type extends a.OptionObject{constructor(e){super(o,"type",["none","ascii85","asciiHex","ccittfax","flate","lzw","runLength","native","xdp","mergedXDP"])}}class Uri extends a.StringObject{constructor(e){super(o,"uri")}}class Validate extends a.OptionObject{constructor(e){super(o,"validate",["preSubmit","prePrint","preExecute","preSave"])}}class ValidateApprovalSignatures extends a.ContentObject{constructor(e){super(o,"validateApprovalSignatures")}[a.$finalize](){this[a.$content]=this[a.$content].trim().split(/\s+/).filter((e=>["docReady","postSign"].includes(e)))}}class ValidationMessaging extends a.OptionObject{constructor(e){super(o,"validationMessaging",["allMessagesIndividually","allMessagesTogether","firstMessageOnly","noMessages"])}}class Version extends a.OptionObject{constructor(e){super(o,"version",["1.7","1.6","1.5","1.4","1.3","1.2"])}}class VersionControl extends a.XFAObject{constructor(e){super(o,"VersionControl");this.outputBelow=(0,i.getStringOption)(e.outputBelow,["warn","error","update"]);this.sourceAbove=(0,i.getStringOption)(e.sourceAbove,["warn","error"]);this.sourceBelow=(0,i.getStringOption)(e.sourceBelow,["update","maintain"])}}class ViewerPreferences extends a.XFAObject{constructor(e){super(o,"viewerPreferences",!0);this.ADBE_JSConsole=null;this.ADBE_JSDebugger=null;this.addViewerPreferences=null;this.duplexOption=null;this.enforce=null;this.numberOfCopies=null;this.pageRange=null;this.pickTrayByPDFSize=null;this.printScaling=null}}class WebClient extends a.XFAObject{constructor(e){super(o,"webClient",!0);this.name=e.name?e.name.trim():"";this.fontInfo=null;this.xdc=null}}class Whitespace extends a.OptionObject{constructor(e){super(o,"whitespace",["preserve","ltrim","normalize","rtrim","trim"])}}class Window extends a.ContentObject{constructor(e){super(o,"window")}[a.$finalize](){const e=this[a.$content].trim().split(/\s*,\s*/,2).map((e=>parseInt(e,10)));if(e.some((e=>isNaN(e))))this[a.$content]=[0,0];else{1===e.length&&e.push(e[0]);this[a.$content]=e}}}class Xdc extends a.XFAObject{constructor(e){super(o,"xdc",!0);this.uri=new a.XFAObjectArray;this.xsl=new a.XFAObjectArray}}class Xdp extends a.XFAObject{constructor(e){super(o,"xdp",!0);this.packets=null}}class Xsl extends a.XFAObject{constructor(e){super(o,"xsl",!0);this.debug=null;this.uri=null}}class Zpl extends a.XFAObject{constructor(e){super(o,"zpl",!0);this.name=e.name?e.name.trim():"";this.batchOutput=null;this.flipLabel=null;this.fontInfo=null;this.xdc=null}}class ConfigNamespace{static[n.$buildXFAObject](e,t){if(ConfigNamespace.hasOwnProperty(e))return ConfigNamespace[e](t)}static acrobat(e){return new Acrobat(e)}static acrobat7(e){return new Acrobat7(e)}static ADBE_JSConsole(e){return new ADBE_JSConsole(e)}static ADBE_JSDebugger(e){return new ADBE_JSDebugger(e)}static addSilentPrint(e){return new AddSilentPrint(e)}static addViewerPreferences(e){return new AddViewerPreferences(e)}static adjustData(e){return new AdjustData(e)}static adobeExtensionLevel(e){return new AdobeExtensionLevel(e)}static agent(e){return new Agent(e)}static alwaysEmbed(e){return new AlwaysEmbed(e)}static amd(e){return new Amd(e)}static area(e){return new Area(e)}static attributes(e){return new Attributes(e)}static autoSave(e){return new AutoSave(e)}static base(e){return new Base(e)}static batchOutput(e){return new BatchOutput(e)}static behaviorOverride(e){return new BehaviorOverride(e)}static cache(e){return new Cache(e)}static change(e){return new Change(e)}static common(e){return new Common(e)}static compress(e){return new Compress(e)}static compressLogicalStructure(e){return new CompressLogicalStructure(e)}static compressObjectStream(e){return new CompressObjectStream(e)}static compression(e){return new Compression(e)}static config(e){return new Config(e)}static conformance(e){return new Conformance(e)}static contentCopy(e){return new ContentCopy(e)}static copies(e){return new Copies(e)}static creator(e){return new Creator(e)}static currentPage(e){return new CurrentPage(e)}static data(e){return new Data(e)}static debug(e){return new Debug(e)}static defaultTypeface(e){return new DefaultTypeface(e)}static destination(e){return new Destination(e)}static documentAssembly(e){return new DocumentAssembly(e)}static driver(e){return new Driver(e)}static duplexOption(e){return new DuplexOption(e)}static dynamicRender(e){return new DynamicRender(e)}static embed(e){return new Embed(e)}static encrypt(e){return new Encrypt(e)}static encryption(e){return new Encryption(e)}static encryptionLevel(e){return new EncryptionLevel(e)}static enforce(e){return new Enforce(e)}static equate(e){return new Equate(e)}static equateRange(e){return new EquateRange(e)}static exclude(e){return new Exclude(e)}static excludeNS(e){return new ExcludeNS(e)}static flipLabel(e){return new FlipLabel(e)}static fontInfo(e){return new FontInfo(e)}static formFieldFilling(e){return new FormFieldFilling(e)}static groupParent(e){return new GroupParent(e)}static ifEmpty(e){return new IfEmpty(e)}static includeXDPContent(e){return new IncludeXDPContent(e)}static incrementalLoad(e){return new IncrementalLoad(e)}static incrementalMerge(e){return new IncrementalMerge(e)}static interactive(e){return new Interactive(e)}static jog(e){return new Jog(e)}static labelPrinter(e){return new LabelPrinter(e)}static layout(e){return new Layout(e)}static level(e){return new Level(e)}static linearized(e){return new Linearized(e)}static locale(e){return new Locale(e)}static localeSet(e){return new LocaleSet(e)}static log(e){return new Log(e)}static map(e){return new MapElement(e)}static mediumInfo(e){return new MediumInfo(e)}static message(e){return new Message(e)}static messaging(e){return new Messaging(e)}static mode(e){return new Mode(e)}static modifyAnnots(e){return new ModifyAnnots(e)}static msgId(e){return new MsgId(e)}static nameAttr(e){return new NameAttr(e)}static neverEmbed(e){return new NeverEmbed(e)}static numberOfCopies(e){return new NumberOfCopies(e)}static openAction(e){return new OpenAction(e)}static output(e){return new Output(e)}static outputBin(e){return new OutputBin(e)}static outputXSL(e){return new OutputXSL(e)}static overprint(e){return new Overprint(e)}static packets(e){return new Packets(e)}static pageOffset(e){return new PageOffset(e)}static pageRange(e){return new PageRange(e)}static pagination(e){return new Pagination(e)}static paginationOverride(e){return new PaginationOverride(e)}static part(e){return new Part(e)}static pcl(e){return new Pcl(e)}static pdf(e){return new Pdf(e)}static pdfa(e){return new Pdfa(e)}static permissions(e){return new Permissions(e)}static pickTrayByPDFSize(e){return new PickTrayByPDFSize(e)}static picture(e){return new Picture(e)}static plaintextMetadata(e){return new PlaintextMetadata(e)}static presence(e){return new Presence(e)}static present(e){return new Present(e)}static print(e){return new Print(e)}static printHighQuality(e){return new PrintHighQuality(e)}static printScaling(e){return new PrintScaling(e)}static printerName(e){return new PrinterName(e)}static producer(e){return new Producer(e)}static ps(e){return new Ps(e)}static range(e){return new Range(e)}static record(e){return new Record(e)}static relevant(e){return new Relevant(e)}static rename(e){return new Rename(e)}static renderPolicy(e){return new RenderPolicy(e)}static runScripts(e){return new RunScripts(e)}static script(e){return new Script(e)}static scriptModel(e){return new ScriptModel(e)}static severity(e){return new Severity(e)}static silentPrint(e){return new SilentPrint(e)}static staple(e){return new Staple(e)}static startNode(e){return new StartNode(e)}static startPage(e){return new StartPage(e)}static submitFormat(e){return new SubmitFormat(e)}static submitUrl(e){return new SubmitUrl(e)}static subsetBelow(e){return new SubsetBelow(e)}static suppressBanner(e){return new SuppressBanner(e)}static tagged(e){return new Tagged(e)}static template(e){return new Template(e)}static templateCache(e){return new TemplateCache(e)}static threshold(e){return new Threshold(e)}static to(e){return new To(e)}static trace(e){return new Trace(e)}static transform(e){return new Transform(e)}static type(e){return new Type(e)}static uri(e){return new Uri(e)}static validate(e){return new Validate(e)}static validateApprovalSignatures(e){return new ValidateApprovalSignatures(e)}static validationMessaging(e){return new ValidationMessaging(e)}static version(e){return new Version(e)}static versionControl(e){return new VersionControl(e)}static viewerPreferences(e){return new ViewerPreferences(e)}static webClient(e){return new WebClient(e)}static whitespace(e){return new Whitespace(e)}static window(e){return new Window(e)}static xdc(e){return new Xdc(e)}static xdp(e){return new Xdp(e)}static xsl(e){return new Xsl(e)}static zpl(e){return new Zpl(e)}}t.ConfigNamespace=ConfigNamespace},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.ConnectionSetNamespace=void 0;var n=r(296),a=r(294);const i=n.NamespaceIds.connectionSet.id;class ConnectionSet extends a.XFAObject{constructor(e){super(i,"connectionSet",!0);this.wsdlConnection=new a.XFAObjectArray;this.xmlConnection=new a.XFAObjectArray;this.xsdConnection=new a.XFAObjectArray}}class EffectiveInputPolicy extends a.XFAObject{constructor(e){super(i,"effectiveInputPolicy");this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||""}}class EffectiveOutputPolicy extends a.XFAObject{constructor(e){super(i,"effectiveOutputPolicy");this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||""}}class Operation extends a.StringObject{constructor(e){super(i,"operation");this.id=e.id||"";this.input=e.input||"";this.name=e.name||"";this.output=e.output||"";this.use=e.use||"";this.usehref=e.usehref||""}}class RootElement extends a.StringObject{constructor(e){super(i,"rootElement");this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||""}}class SoapAction extends a.StringObject{constructor(e){super(i,"soapAction");this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||""}}class SoapAddress extends a.StringObject{constructor(e){super(i,"soapAddress");this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||""}}class Uri extends a.StringObject{constructor(e){super(i,"uri");this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||""}}class WsdlAddress extends a.StringObject{constructor(e){super(i,"wsdlAddress");this.id=e.id||"";this.name=e.name||"";this.use=e.use||"";this.usehref=e.usehref||""}}class WsdlConnection extends a.XFAObject{constructor(e){super(i,"wsdlConnection",!0);this.dataDescription=e.dataDescription||"";this.name=e.name||"";this.effectiveInputPolicy=null;this.effectiveOutputPolicy=null;this.operation=null;this.soapAction=null;this.soapAddress=null;this.wsdlAddress=null}}class XmlConnection extends a.XFAObject{constructor(e){super(i,"xmlConnection",!0);this.dataDescription=e.dataDescription||"";this.name=e.name||"";this.uri=null}}class XsdConnection extends a.XFAObject{constructor(e){super(i,"xsdConnection",!0);this.dataDescription=e.dataDescription||"";this.name=e.name||"";this.rootElement=null;this.uri=null}}class ConnectionSetNamespace{static[n.$buildXFAObject](e,t){if(ConnectionSetNamespace.hasOwnProperty(e))return ConnectionSetNamespace[e](t)}static connectionSet(e){return new ConnectionSet(e)}static effectiveInputPolicy(e){return new EffectiveInputPolicy(e)}static effectiveOutputPolicy(e){return new EffectiveOutputPolicy(e)}static operation(e){return new Operation(e)}static rootElement(e){return new RootElement(e)}static soapAction(e){return new SoapAction(e)}static soapAddress(e){return new SoapAddress(e)}static uri(e){return new Uri(e)}static wsdlAddress(e){return new WsdlAddress(e)}static wsdlConnection(e){return new WsdlConnection(e)}static xmlConnection(e){return new XmlConnection(e)}static xsdConnection(e){return new XsdConnection(e)}}t.ConnectionSetNamespace=ConnectionSetNamespace},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.DatasetsNamespace=void 0;var n=r(294),a=r(296);const i=a.NamespaceIds.datasets.id;class Data extends n.XmlObject{constructor(e){super(i,"data",e)}[n.$isNsAgnostic](){return!0}}class Datasets extends n.XFAObject{constructor(e){super(i,"datasets",!0);this.data=null;this.Signature=null}[n.$onChild](e){const t=e[n.$nodeName];("data"===t&&e[n.$namespaceId]===i||"Signature"===t&&e[n.$namespaceId]===a.NamespaceIds.signature.id)&&(this[t]=e);this[n.$appendChild](e)}}class DatasetsNamespace{static[a.$buildXFAObject](e,t){if(DatasetsNamespace.hasOwnProperty(e))return DatasetsNamespace[e](t)}static datasets(e){return new Datasets(e)}static data(e){return new Data(e)}}t.DatasetsNamespace=DatasetsNamespace},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.LocaleSetNamespace=void 0;var n=r(296),a=r(294),i=r(295);const s=n.NamespaceIds.localeSet.id;class CalendarSymbols extends a.XFAObject{constructor(e){super(s,"calendarSymbols",!0);this.name="gregorian";this.dayNames=new a.XFAObjectArray(2);this.eraNames=null;this.meridiemNames=null;this.monthNames=new a.XFAObjectArray(2)}}class CurrencySymbol extends a.StringObject{constructor(e){super(s,"currencySymbol");this.name=(0,i.getStringOption)(e.name,["symbol","isoname","decimal"])}}class CurrencySymbols extends a.XFAObject{constructor(e){super(s,"currencySymbols",!0);this.currencySymbol=new a.XFAObjectArray(3)}}class DatePattern extends a.StringObject{constructor(e){super(s,"datePattern");this.name=(0,i.getStringOption)(e.name,["full","long","med","short"])}}class DatePatterns extends a.XFAObject{constructor(e){super(s,"datePatterns",!0);this.datePattern=new a.XFAObjectArray(4)}}class DateTimeSymbols extends a.ContentObject{constructor(e){super(s,"dateTimeSymbols")}}class Day extends a.StringObject{constructor(e){super(s,"day")}}class DayNames extends a.XFAObject{constructor(e){super(s,"dayNames",!0);this.abbr=(0,i.getInteger)({data:e.abbr,defaultValue:0,validate:e=>1===e});this.day=new a.XFAObjectArray(7)}}class Era extends a.StringObject{constructor(e){super(s,"era")}}class EraNames extends a.XFAObject{constructor(e){super(s,"eraNames",!0);this.era=new a.XFAObjectArray(2)}}class Locale extends a.XFAObject{constructor(e){super(s,"locale",!0);this.desc=e.desc||"";this.name="isoname";this.calendarSymbols=null;this.currencySymbols=null;this.datePatterns=null;this.dateTimeSymbols=null;this.numberPatterns=null;this.numberSymbols=null;this.timePatterns=null;this.typeFaces=null}}class LocaleSet extends a.XFAObject{constructor(e){super(s,"localeSet",!0);this.locale=new a.XFAObjectArray}}class Meridiem extends a.StringObject{constructor(e){super(s,"meridiem")}}class MeridiemNames extends a.XFAObject{constructor(e){super(s,"meridiemNames",!0);this.meridiem=new a.XFAObjectArray(2)}}class Month extends a.StringObject{constructor(e){super(s,"month")}}class MonthNames extends a.XFAObject{constructor(e){super(s,"monthNames",!0);this.abbr=(0,i.getInteger)({data:e.abbr,defaultValue:0,validate:e=>1===e});this.month=new a.XFAObjectArray(12)}}class NumberPattern extends a.StringObject{constructor(e){super(s,"numberPattern");this.name=(0,i.getStringOption)(e.name,["full","long","med","short"])}}class NumberPatterns extends a.XFAObject{constructor(e){super(s,"numberPatterns",!0);this.numberPattern=new a.XFAObjectArray(4)}}class NumberSymbol extends a.StringObject{constructor(e){super(s,"numberSymbol");this.name=(0,i.getStringOption)(e.name,["decimal","grouping","percent","minus","zero"])}}class NumberSymbols extends a.XFAObject{constructor(e){super(s,"numberSymbols",!0);this.numberSymbol=new a.XFAObjectArray(5)}}class TimePattern extends a.StringObject{constructor(e){super(s,"timePattern");this.name=(0,i.getStringOption)(e.name,["full","long","med","short"])}}class TimePatterns extends a.XFAObject{constructor(e){super(s,"timePatterns",!0);this.timePattern=new a.XFAObjectArray(4)}}class TypeFace extends a.XFAObject{constructor(e){super(s,"typeFace",!0);this.name=""|e.name}}class TypeFaces extends a.XFAObject{constructor(e){super(s,"typeFaces",!0);this.typeFace=new a.XFAObjectArray}}class LocaleSetNamespace{static[n.$buildXFAObject](e,t){if(LocaleSetNamespace.hasOwnProperty(e))return LocaleSetNamespace[e](t)}static calendarSymbols(e){return new CalendarSymbols(e)}static currencySymbol(e){return new CurrencySymbol(e)}static currencySymbols(e){return new CurrencySymbols(e)}static datePattern(e){return new DatePattern(e)}static datePatterns(e){return new DatePatterns(e)}static dateTimeSymbols(e){return new DateTimeSymbols(e)}static day(e){return new Day(e)}static dayNames(e){return new DayNames(e)}static era(e){return new Era(e)}static eraNames(e){return new EraNames(e)}static locale(e){return new Locale(e)}static localeSet(e){return new LocaleSet(e)}static meridiem(e){return new Meridiem(e)}static meridiemNames(e){return new MeridiemNames(e)}static month(e){return new Month(e)}static monthNames(e){return new MonthNames(e)}static numberPattern(e){return new NumberPattern(e)}static numberPatterns(e){return new NumberPatterns(e)}static numberSymbol(e){return new NumberSymbol(e)}static numberSymbols(e){return new NumberSymbols(e)}static timePattern(e){return new TimePattern(e)}static timePatterns(e){return new TimePatterns(e)}static typeFace(e){return new TypeFace(e)}static typeFaces(e){return new TypeFaces(e)}}t.LocaleSetNamespace=LocaleSetNamespace},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.SignatureNamespace=void 0;var n=r(296),a=r(294);const i=n.NamespaceIds.signature.id;class Signature extends a.XFAObject{constructor(e){super(i,"signature",!0)}}class SignatureNamespace{static[n.$buildXFAObject](e,t){if(SignatureNamespace.hasOwnProperty(e))return SignatureNamespace[e](t)}static signature(e){return new Signature(e)}}t.SignatureNamespace=SignatureNamespace},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.StylesheetNamespace=void 0;var n=r(296),a=r(294);const i=n.NamespaceIds.stylesheet.id;class Stylesheet extends a.XFAObject{constructor(e){super(i,"stylesheet",!0)}}class StylesheetNamespace{static[n.$buildXFAObject](e,t){if(StylesheetNamespace.hasOwnProperty(e))return StylesheetNamespace[e](t)}static stylesheet(e){return new Stylesheet(e)}}t.StylesheetNamespace=StylesheetNamespace},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.XdpNamespace=void 0;var n=r(296),a=r(294);const i=n.NamespaceIds.xdp.id;class Xdp extends a.XFAObject{constructor(e){super(i,"xdp",!0);this.uuid=e.uuid||"";this.timeStamp=e.timeStamp||"";this.config=null;this.connectionSet=null;this.datasets=null;this.localeSet=null;this.stylesheet=new a.XFAObjectArray;this.template=null}[a.$onChildCheck](e){const t=n.NamespaceIds[e[a.$nodeName]];return t&&e[a.$namespaceId]===t.id}}class XdpNamespace{static[n.$buildXFAObject](e,t){if(XdpNamespace.hasOwnProperty(e))return XdpNamespace[e](t)}static xdp(e){return new Xdp(e)}}t.XdpNamespace=XdpNamespace},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.XhtmlNamespace=void 0;r(112);r(159);r(179);r(317);r(212);var n=r(294),a=r(296),i=r(302),s=r(295);const o=a.NamespaceIds.xhtml.id,c=Symbol(),l=new Set(["color","font","font-family","font-size","font-stretch","font-style","font-weight","margin","margin-bottom","margin-left","margin-right","margin-top","letter-spacing","line-height","orphans","page-break-after","page-break-before","page-break-inside","tab-interval","tab-stop","text-align","text-decoration","text-indent","vertical-align","widows","kerning-mode","xfa-font-horizontal-scale","xfa-font-vertical-scale","xfa-spacerun","xfa-tab-stops"]),h=new Map([["page-break-after","breakAfter"],["page-break-before","breakBefore"],["page-break-inside","breakInside"],["kerning-mode",e=>"none"===e?"none":"normal"],["xfa-font-horizontal-scale",e=>"scaleX(".concat(Math.max(0,Math.min(parseInt(e)/100)).toFixed(2),")")],["xfa-font-vertical-scale",e=>"scaleY(".concat(Math.max(0,Math.min(parseInt(e)/100)).toFixed(2),")")],["xfa-spacerun",""],["xfa-tab-stops",""],["font-size",(e,t)=>{e=t.fontSize=(0,s.getMeasurement)(e);return(0,i.measureToString)(.99*e)}],["letter-spacing",e=>(0,i.measureToString)((0,s.getMeasurement)(e))],["line-height",e=>(0,i.measureToString)((0,s.getMeasurement)(e))],["margin",e=>(0,i.measureToString)((0,s.getMeasurement)(e))],["margin-bottom",e=>(0,i.measureToString)((0,s.getMeasurement)(e))],["margin-left",e=>(0,i.measureToString)((0,s.getMeasurement)(e))],["margin-right",e=>(0,i.measureToString)((0,s.getMeasurement)(e))],["margin-top",e=>(0,i.measureToString)((0,s.getMeasurement)(e))],["text-indent",e=>(0,i.measureToString)((0,s.getMeasurement)(e))],["font-family",e=>e],["vertical-align",e=>(0,i.measureToString)((0,s.getMeasurement)(e))]]),u=/\s+/g,d=/[\r\n]+/g,f=/\r\n?/g;function mapStyle(e,t,r){const a=Object.create(null);if(!e)return a;const o=Object.create(null);for(const[t,r]of e.split(";").map((e=>e.split(":",2)))){const e=h.get(t);if(""===e)continue;let n=r;e&&(n="string"==typeof e?e:e(r,o));t.endsWith("scale")?a.transform?a.transform="".concat(a[t]," ").concat(n):a.transform=n:a[t.replaceAll(/-([a-zA-Z])/g,((e,t)=>t.toUpperCase()))]=n}a.fontFamily&&(0,i.setFontFamily)({typeface:a.fontFamily,weight:a.fontWeight||"normal",posture:a.fontStyle||"normal",size:o.fontSize||0},t,t[n.$globalData].fontFinder,a);if(r&&a.verticalAlign&&"0px"!==a.verticalAlign&&a.fontSize){const e=.583,t=.333,r=(0,s.getMeasurement)(a.fontSize);a.fontSize=(0,i.measureToString)(r*e);a.verticalAlign=(0,i.measureToString)(Math.sign((0,s.getMeasurement)(a.verticalAlign))*r*t)}(0,i.fixTextIndent)(a);return a}const g=new Set(["body","html"]);class XhtmlObject extends n.XmlObject{constructor(e,t){super(o,t);this[c]=!1;this.style=e.style||""}[n.$clean](e){super[n.$clean](e);this.style=function checkStyle(e){return e.style?e.style.trim().split(/\s*;\s*/).filter((e=>!!e)).map((e=>e.split(/\s*:\s*/,2))).filter((t=>{let[r,a]=t;"font-family"===r&&e[n.$globalData].usedTypefaces.add(a);return l.has(r)})).map((e=>e.join(":"))).join(";"):""}(this)}[n.$acceptWhitespace](){return!g.has(this[n.$nodeName])}[n.$onText](e){if(arguments.length>1&&void 0!==arguments[1]&&arguments[1])this[c]=!0;else{e=e.replace(d,"");this.style.includes("xfa-spacerun:yes")||(e=e.replace(u," "))}e&&(this[n.$content]+=e)}[n.$pushGlyphs](e){let t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];const r=Object.create(null),a={top:NaN,bottom:NaN,left:NaN,right:NaN};let i=null;for(const[e,t]of this.style.split(";").map((e=>e.split(":",2))))switch(e){case"font-family":r.typeface=(0,s.stripQuotes)(t);break;case"font-size":r.size=(0,s.getMeasurement)(t);break;case"font-weight":r.weight=t;break;case"font-style":r.posture=t;break;case"letter-spacing":r.letterSpacing=(0,s.getMeasurement)(t);break;case"margin":const e=t.split(/ \t/).map((e=>(0,s.getMeasurement)(e)));switch(e.length){case 1:a.top=a.bottom=a.left=a.right=e[0];break;case 2:a.top=a.bottom=e[0];a.left=a.right=e[1];break;case 3:a.top=e[0];a.bottom=e[2];a.left=a.right=e[1];break;case 4:a.top=e[0];a.left=e[1];a.bottom=e[2];a.right=e[3]}break;case"margin-top":a.top=(0,s.getMeasurement)(t);break;case"margin-bottom":a.bottom=(0,s.getMeasurement)(t);break;case"margin-left":a.left=(0,s.getMeasurement)(t);break;case"margin-right":a.right=(0,s.getMeasurement)(t);break;case"line-height":i=(0,s.getMeasurement)(t)}e.pushData(r,a,i);if(this[n.$content])e.addString(this[n.$content]);else for(const t of this[n.$getChildren]())"#text"!==t[n.$nodeName]?t[n.$pushGlyphs](e):e.addString(t[n.$content]);t&&e.popFont()}[n.$toHTML](e){const t=[];this[n.$extra]={children:t};this[n.$childrenToHTML]({});if(0===t.length&&!this[n.$content])return s.HTMLResult.EMPTY;let r;r=this[c]?this[n.$content]?this[n.$content].replace(f,"\n"):void 0:this[n.$content]||void 0;return s.HTMLResult.success({name:this[n.$nodeName],attributes:{href:this.href,style:mapStyle(this.style,this,this[c])},children:t,value:r})}}class A extends XhtmlObject{constructor(e){super(e,"a");this.href=(0,i.fixURL)(e.href)||""}}class B extends XhtmlObject{constructor(e){super(e,"b")}[n.$pushGlyphs](e){e.pushFont({weight:"bold"});super[n.$pushGlyphs](e);e.popFont()}}class Body extends XhtmlObject{constructor(e){super(e,"body")}[n.$toHTML](e){const t=super[n.$toHTML](e),{html:r}=t;if(!r)return s.HTMLResult.EMPTY;r.name="div";r.attributes.class=["xfaRich"];return t}}class Br extends XhtmlObject{constructor(e){super(e,"br")}[n.$text](){return"\n"}[n.$pushGlyphs](e){e.addString("\n")}[n.$toHTML](e){return s.HTMLResult.success({name:"br"})}}class Html extends XhtmlObject{constructor(e){super(e,"html")}[n.$toHTML](e){const t=[];this[n.$extra]={children:t};this[n.$childrenToHTML]({});if(0===t.length)return s.HTMLResult.success({name:"div",attributes:{class:["xfaRich"],style:{}},value:this[n.$content]||""});if(1===t.length){const e=t[0];if(e.attributes&&e.attributes.class.includes("xfaRich"))return s.HTMLResult.success(e)}return s.HTMLResult.success({name:"div",attributes:{class:["xfaRich"],style:{}},children:t})}}class I extends XhtmlObject{constructor(e){super(e,"i")}[n.$pushGlyphs](e){e.pushFont({posture:"italic"});super[n.$pushGlyphs](e);e.popFont()}}class Li extends XhtmlObject{constructor(e){super(e,"li")}}class Ol extends XhtmlObject{constructor(e){super(e,"ol")}}class P extends XhtmlObject{constructor(e){super(e,"p")}[n.$pushGlyphs](e){super[n.$pushGlyphs](e,!1);e.addString("\n");e.addPara();e.popFont()}[n.$text](){return this[n.$getParent]()[n.$getChildren]().at(-1)===this?super[n.$text]():super[n.$text]()+"\n"}}class Span extends XhtmlObject{constructor(e){super(e,"span")}}class Sub extends XhtmlObject{constructor(e){super(e,"sub")}}class Sup extends XhtmlObject{constructor(e){super(e,"sup")}}class Ul extends XhtmlObject{constructor(e){super(e,"ul")}}class XhtmlNamespace{static[a.$buildXFAObject](e,t){if(XhtmlNamespace.hasOwnProperty(e))return XhtmlNamespace[e](t)}static a(e){return new A(e)}static b(e){return new B(e)}static body(e){return new Body(e)}static br(e){return new Br(e)}static html(e){return new Html(e)}static i(e){return new I(e)}static li(e){return new Li(e)}static ol(e){return new Ol(e)}static p(e){return new P(e)}static span(e){return new Span(e)}static sub(e){return new Sub(e)}static sup(e){return new Sup(e)}static ul(e){return new Ul(e)}}t.XhtmlNamespace=XhtmlNamespace},(e,t,r)=>{r(318)},(e,t,r)=>{"use strict";var n=r(4),a=r(9),i=r(15),s=r(17),o=r(21),c=r(215),l=r(161),h=r(29),u=r(205),d=r(182),f=r(33),g=r(35),p=f("replace"),m=TypeError,b=i("".indexOf),y=i("".replace),w=i("".slice),S=Math.max,stringIndexOf=function(e,t,r){return r>e.length?-1:""===t?r:b(e,t,r)};n({target:"String",proto:!0},{replaceAll:function replaceAll(e,t){var r,n,i,f,x,v,k,C,O,T=s(this),M=0,E=0,D="";if(null!=e){if(r=c(e)){n=l(s(u(e)));if(!~b(n,"g"))throw m("`.replaceAll` does not allow non-global regexes")}if(i=h(e,p))return a(i,e,T,t);if(g&&r)return y(l(T),e,t)}f=l(T);x=l(e);(v=o(t))||(t=l(t));k=x.length;C=S(1,k);M=stringIndexOf(f,x,0);for(;-1!==M;){O=v?l(t(x,M,f)):d(x,f,M,[],void 0,t);D+=w(f,E,M)+O;E=M+k;M=stringIndexOf(f,x,M+C)}E<f.length&&(D+=w(f,E));return D}})},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.UnknownNamespace=void 0;var n=r(296),a=r(294);class UnknownNamespace{constructor(e){this.namespaceId=e}[n.$buildXFAObject](e,t){return new a.XmlObject(this.namespaceId,e,t)}}t.UnknownNamespace=UnknownNamespace},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.DatasetReader=void 0;var n=r(158),a=r(213),i=r(283);function decodeString(e){try{return(0,n.stringToUTF8String)(e)}catch(t){(0,n.warn)('UTF-8 decoding failed: "'.concat(t,'".'));return e}}class DatasetXMLParser extends i.SimpleXMLParser{constructor(e){super(e);this.node=null}onEndElement(e){const t=super.onEndElement(e);if(t&&"xfa:datasets"===e){this.node=t;throw new Error("Aborting DatasetXMLParser.")}}}t.DatasetReader=class DatasetReader{constructor(e){if(e.datasets)this.node=new i.SimpleXMLParser({hasAttributes:!0}).parseFromString(e.datasets).documentElement;else{const t=new DatasetXMLParser({hasAttributes:!0});try{t.parseFromString(e["xdp:xdp"])}catch(e){}this.node=t.node}}getValue(e){if(!this.node||!e)return"";const t=this.node.searchNode((0,a.parseXFAPath)(e),0);if(!t)return"";const r=t.firstChild;return r&&"value"===r.nodeName?t.children.map((e=>decodeString(e.textContent))):decodeString(t.textContent)}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.XRef=void 0;r(112);r(125);r(146);r(148);r(149);r(159);r(2);var n=r(158),a=r(209),i=r(213),s=r(240),o=r(217),c=r(284);t.XRef=class XRef{constructor(e,t){this.stream=e;this.pdfManager=t;this.entries=[];this.xrefstms=Object.create(null);this._cacheMap=new Map;this._pendingRefs=new a.RefSet;this.stats=new i.DocStats(t.msgHandler);this._newRefNum=null}getNewRef(){null===this._newRefNum&&(this._newRefNum=this.entries.length||1);return a.Ref.get(this._newRefNum++,0)}resetNewRef(){this._newRefNum=null}setStartXRef(e){this.startXRefQueue=[e]}parse(){let e,t,r,s=arguments.length>0&&void 0!==arguments[0]&&arguments[0];if(s){(0,n.warn)("Indexing all PDF objects");e=this.indexObjects()}else e=this.readXRef();e.assignXref(this);this.trailer=e;try{t=e.get("Encrypt")}catch(e){if(e instanceof i.MissingDataException)throw e;(0,n.warn)('XRef.parse - Invalid "Encrypt" reference: "'.concat(e,'".'))}if(t instanceof a.Dict){const r=e.get("ID"),n=r&&r.length?r[0]:"";t.suppressEncryption=!0;this.encrypt=new c.CipherTransformFactory(t,n,this.pdfManager.password)}try{r=e.get("Root")}catch(e){if(e instanceof i.MissingDataException)throw e;(0,n.warn)('XRef.parse - Invalid "Root" reference: "'.concat(e,'".'))}if(r instanceof a.Dict)try{if(r.get("Pages")instanceof a.Dict){this.root=r;return}}catch(e){if(e instanceof i.MissingDataException)throw e;(0,n.warn)('XRef.parse - Invalid "Pages" reference: "'.concat(e,'".'))}if(!s)throw new i.XRefParseException;throw new n.InvalidPDFException("Invalid Root reference.")}processXRefTable(e){"tableState"in this||(this.tableState={entryNum:0,streamPos:e.lexer.stream.pos,parserBuf1:e.buf1,parserBuf2:e.buf2});const t=this.readXRefTable(e);if(!(0,a.isCmd)(t,"trailer"))throw new n.FormatError("Invalid XRef table: could not find trailer dictionary");let r=e.getObj();r instanceof a.Dict||!r.dict||(r=r.dict);if(!(r instanceof a.Dict))throw new n.FormatError("Invalid XRef table: could not parse trailer dictionary");delete this.tableState;return r}readXRefTable(e){const t=e.lexer.stream,r=this.tableState;t.pos=r.streamPos;e.buf1=r.parserBuf1;e.buf2=r.parserBuf2;let i;for(;;){if(!("firstEntryNum"in r)||!("entryCount"in r)){if((0,a.isCmd)(i=e.getObj(),"trailer"))break;r.firstEntryNum=i;r.entryCount=e.getObj()}let s=r.firstEntryNum;const o=r.entryCount;if(!Number.isInteger(s)||!Number.isInteger(o))throw new n.FormatError("Invalid XRef table: wrong types in subsection header");for(let i=r.entryNum;i<o;i++){r.streamPos=t.pos;r.entryNum=i;r.parserBuf1=e.buf1;r.parserBuf2=e.buf2;const c={};c.offset=e.getObj();c.gen=e.getObj();const l=e.getObj();if(l instanceof a.Cmd)switch(l.cmd){case"f":c.free=!0;break;case"n":c.uncompressed=!0}if(!Number.isInteger(c.offset)||!Number.isInteger(c.gen)||!c.free&&!c.uncompressed)throw new n.FormatError("Invalid entry in XRef subsection: ".concat(s,", ").concat(o));0===i&&c.free&&1===s&&(s=0);this.entries[i+s]||(this.entries[i+s]=c)}r.entryNum=0;r.streamPos=t.pos;r.parserBuf1=e.buf1;r.parserBuf2=e.buf2;delete r.firstEntryNum;delete r.entryCount}if(this.entries[0]&&!this.entries[0].free)throw new n.FormatError("Invalid XRef table: unexpected first object");return i}processXRefStream(e){if(!("streamState"in this)){const t=e.dict,r=t.get("W");let n=t.get("Index");n||(n=[0,t.get("Size")]);this.streamState={entryRanges:n,byteWidths:r,entryNum:0,streamPos:e.pos}}this.readXRefStream(e);delete this.streamState;return e.dict}readXRefStream(e){const t=this.streamState;e.pos=t.streamPos;const[r,a,i]=t.byteWidths,s=t.entryRanges;for(;s.length>0;){const[o,c]=s;if(!Number.isInteger(o)||!Number.isInteger(c))throw new n.FormatError("Invalid XRef range fields: ".concat(o,", ").concat(c));if(!Number.isInteger(r)||!Number.isInteger(a)||!Number.isInteger(i))throw new n.FormatError("Invalid XRef entry fields length: ".concat(o,", ").concat(c));for(let s=t.entryNum;s<c;++s){t.entryNum=s;t.streamPos=e.pos;let c=0,l=0,h=0;for(let t=0;t<r;++t){const t=e.getByte();if(-1===t)throw new n.FormatError("Invalid XRef byteWidths 'type'.");c=c<<8|t}0===r&&(c=1);for(let t=0;t<a;++t){const t=e.getByte();if(-1===t)throw new n.FormatError("Invalid XRef byteWidths 'offset'.");l=l<<8|t}for(let t=0;t<i;++t){const t=e.getByte();if(-1===t)throw new n.FormatError("Invalid XRef byteWidths 'generation'.");h=h<<8|t}const u={};u.offset=l;u.gen=h;switch(c){case 0:u.free=!0;break;case 1:u.uncompressed=!0;break;case 2:break;default:throw new n.FormatError("Invalid XRef entry type: ".concat(c))}this.entries[o+s]||(this.entries[o+s]=u)}t.entryNum=0;t.streamPos=e.pos;s.splice(0,2)}}indexObjects(){function readToken(e,t){let r="",n=e[t];for(;10!==n&&13!==n&&60!==n&&!(++t>=e.length);){r+=String.fromCharCode(n);n=e[t]}return r}function skipUntil(e,t,r){const n=r.length,a=e.length;let i=0;for(;t<a;){let a=0;for(;a<n&&e[t+a]===r[a];)++a;if(a>=n)break;t++;i++}return i}const e=/^(\d+)\s+(\d+)\s+obj\b/,t=/\bendobj[\b\s]$/,r=/\s+(\d+\s+\d+\s+obj[\b\s<])$/,o=new Uint8Array([116,114,97,105,108,101,114]),c=new Uint8Array([115,116,97,114,116,120,114,101,102]),l=new Uint8Array([111,98,106]),h=new Uint8Array([47,88,82,101,102]);this.entries.length=0;this._cacheMap.clear();const u=this.stream;u.pos=0;const d=u.getBytes(),f=d.length;let g=u.start;const p=[],m=[];for(;g<f;){let a=d[g];if(9===a||10===a||13===a||32===a){++g;continue}if(37===a){do{++g;if(g>=f)break;a=d[g]}while(10!==a&&13!==a);continue}const b=readToken(d,g);let y;if(b.startsWith("xref")&&(4===b.length||/\s/.test(b[4]))){g+=skipUntil(d,g,o);p.push(g);g+=skipUntil(d,g,c)}else if(y=e.exec(b)){const e=0|y[1],a=0|y[2];let o,c=g+b.length,f=!1;if(this.entries[e]){if(this.entries[e].gen===a)try{new s.Parser({lexer:new s.Lexer(u.makeSubStream(c))}).getObj();f=!0}catch(e){e instanceof i.ParserEOFException?(0,n.warn)("indexObjects -- checking object (".concat(b,'): "').concat(e,'".')):f=!0}}else f=!0;f&&(this.entries[e]={offset:g-u.start,gen:a,uncompressed:!0});for(;c<d.length;){const e=c+skipUntil(d,c,l)+4;o=e-g;const a=Math.max(e-25,c),i=(0,n.bytesToString)(d.subarray(a,e));if(t.test(i))break;{const e=r.exec(i);if(e&&e[1]){(0,n.warn)('indexObjects: Found new "obj" inside of another "obj", caused by missing "endobj" -- trying to recover.');o-=e[1].length;break}}c=e}const p=d.subarray(g,g+o),w=skipUntil(p,0,h);if(w<o&&p[w+5]<64){m.push(g-u.start);this.xrefstms[g-u.start]=1}g+=o}else if(b.startsWith("trailer")&&(7===b.length||/\s/.test(b[7]))){p.push(g);g+=skipUntil(d,g,c)}else g+=b.length+1}for(let e=0,t=m.length;e<t;++e){this.startXRefQueue.push(m[e]);this.readXRef(!0)}let b;for(let e=0,t=p.length;e<t;++e){u.pos=p[e];const t=new s.Parser({lexer:new s.Lexer(u),xref:this,allowStreams:!0,recoveryMode:!0}),r=t.getObj();if(!(0,a.isCmd)(r,"trailer"))continue;const n=t.getObj();if(n instanceof a.Dict){try{const e=n.get("Root");if(!(e instanceof a.Dict))continue;const t=e.get("Pages");if(!(t instanceof a.Dict))continue;const r=t.get("Count");if(!Number.isInteger(r))continue}catch(e){continue}if(n.has("ID"))return n;b=n}}if(b)return b;if(this.topDict)return this.topDict;throw new n.InvalidPDFException("Invalid PDF structure.")}readXRef(){let e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];const t=this.stream,r=new Set;try{for(;this.startXRefQueue.length;){const e=this.startXRefQueue[0];if(r.has(e)){(0,n.warn)("readXRef - skipping XRef table since it was already parsed.");this.startXRefQueue.shift();continue}r.add(e);t.pos=e+t.start;const i=new s.Parser({lexer:new s.Lexer(t),xref:this,allowStreams:!0});let c,l=i.getObj();if((0,a.isCmd)(l,"xref")){c=this.processXRefTable(i);this.topDict||(this.topDict=c);l=c.get("XRefStm");if(Number.isInteger(l)){const e=l;if(!(e in this.xrefstms)){this.xrefstms[e]=1;this.startXRefQueue.push(e)}}}else{if(!Number.isInteger(l))throw new n.FormatError("Invalid XRef stream header");if(!(Number.isInteger(i.getObj())&&(0,a.isCmd)(i.getObj(),"obj")&&(l=i.getObj())instanceof o.BaseStream))throw new n.FormatError("Invalid XRef stream");c=this.processXRefStream(l);this.topDict||(this.topDict=c);if(!c)throw new n.FormatError("Failed to read XRef stream")}l=c.get("Prev");Number.isInteger(l)?this.startXRefQueue.push(l):l instanceof a.Ref&&this.startXRefQueue.push(l.num);this.startXRefQueue.shift()}return this.topDict}catch(e){if(e instanceof i.MissingDataException)throw e;(0,n.info)("(while reading XRef): "+e);this.startXRefQueue.shift()}if(!e)throw new i.XRefParseException}getEntry(e){const t=this.entries[e];return t&&!t.free&&t.offset?t:null}fetchIfRef(e){let t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];return e instanceof a.Ref?this.fetch(e,t):e}fetch(e){let t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(!(e instanceof a.Ref))throw new Error("ref object is not a reference");const r=e.num,i=this._cacheMap.get(r);if(void 0!==i){i instanceof a.Dict&&!i.objId&&(i.objId=e.toString());return i}let s=this.getEntry(r);if(null===s){this._cacheMap.set(r,s);return s}if(this._pendingRefs.has(e)){this._pendingRefs.remove(e);(0,n.warn)("Ignoring circular reference: ".concat(e,"."));return a.CIRCULAR_REF}this._pendingRefs.put(e);try{s=s.uncompressed?this.fetchUncompressed(e,s,t):this.fetchCompressed(e,s,t);this._pendingRefs.remove(e)}catch(t){this._pendingRefs.remove(e);throw t}s instanceof a.Dict?s.objId=e.toString():s instanceof o.BaseStream&&(s.dict.objId=e.toString());return s}fetchUncompressed(e,t){let r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];const n=e.gen;let c=e.num;if(t.gen!==n)throw new i.XRefEntryException("Inconsistent generation in XRef: ".concat(e));const l=this.stream.makeSubStream(t.offset+this.stream.start),h=new s.Parser({lexer:new s.Lexer(l),xref:this,allowStreams:!0}),u=h.getObj(),d=h.getObj(),f=h.getObj();if(u!==c||d!==n||!(f instanceof a.Cmd))throw new i.XRefEntryException("Bad (uncompressed) XRef entry: ".concat(e));if("obj"!==f.cmd){if(f.cmd.startsWith("obj")){c=parseInt(f.cmd.substring(3),10);if(!Number.isNaN(c))return c}throw new i.XRefEntryException("Bad (uncompressed) XRef entry: ".concat(e))}(t=this.encrypt&&!r?h.getObj(this.encrypt.createCipherTransform(c,n)):h.getObj())instanceof o.BaseStream||this._cacheMap.set(c,t);return t}fetchCompressed(e,t){const r=t.offset,c=this.fetch(a.Ref.get(r,0));if(!(c instanceof o.BaseStream))throw new n.FormatError("bad ObjStm stream");const l=c.dict.get("First"),h=c.dict.get("N");if(!Number.isInteger(l)||!Number.isInteger(h))throw new n.FormatError("invalid first and n parameters for ObjStm stream");let u=new s.Parser({lexer:new s.Lexer(c),xref:this,allowStreams:!0});const d=new Array(h),f=new Array(h);for(let e=0;e<h;++e){const t=u.getObj();if(!Number.isInteger(t))throw new n.FormatError("invalid object number in the ObjStm stream: ".concat(t));const r=u.getObj();if(!Number.isInteger(r))throw new n.FormatError("invalid object offset in the ObjStm stream: ".concat(r));d[e]=t;f[e]=r}const g=(c.start||0)+l,p=new Array(h);for(let e=0;e<h;++e){const t=e<h-1?f[e+1]-f[e]:void 0;if(t<0)throw new n.FormatError("Invalid offset in the ObjStm stream.");u=new s.Parser({lexer:new s.Lexer(c.makeSubStream(g+f[e],t,c.dict)),xref:this,allowStreams:!0});const a=u.getObj();p[e]=a;if(a instanceof o.BaseStream)continue;const i=d[e],l=this.entries[i];l&&l.offset===r&&l.gen===e&&this._cacheMap.set(i,a)}if(void 0===(t=p[t.gen]))throw new i.XRefEntryException("Bad (compressed) XRef entry: ".concat(e));return t}async fetchIfRefAsync(e,t){return e instanceof a.Ref?this.fetchAsync(e,t):e}async fetchAsync(e,t){try{return this.fetch(e,t)}catch(r){if(!(r instanceof i.MissingDataException))throw r;await this.pdfManager.requestRange(r.begin,r.end);return this.fetchAsync(e,t)}}getCatalogObj(){return this.root}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.MessageHandler=void 0;r(2);r(110);r(112);var n=r(158);const a=1,i=2,s=1,o=2,c=3,l=4,h=5,u=6,d=7,f=8;function wrapReason(e){e instanceof Error||"object"==typeof e&&null!==e||(0,n.unreachable)('wrapReason: Expected "reason" to be a (possibly cloned) Error.');switch(e.name){case"AbortException":return new n.AbortException(e.message);case"MissingPDFException":return new n.MissingPDFException(e.message);case"PasswordException":return new n.PasswordException(e.message,e.code);case"UnexpectedResponseException":return new n.UnexpectedResponseException(e.message,e.status);case"UnknownErrorException":return new n.UnknownErrorException(e.message,e.details);default:return new n.UnknownErrorException(e.message,e.toString())}}t.MessageHandler=class MessageHandler{constructor(e,t,r){this.sourceName=e;this.targetName=t;this.comObj=r;this.callbackId=1;this.streamId=1;this.streamSinks=Object.create(null);this.streamControllers=Object.create(null);this.callbackCapabilities=Object.create(null);this.actionHandler=Object.create(null);this._onComObjOnMessage=e=>{const t=e.data;if(t.targetName!==this.sourceName)return;if(t.stream){this._processStreamMessage(t);return}if(t.callback){const e=t.callbackId,r=this.callbackCapabilities[e];if(!r)throw new Error("Cannot resolve callback ".concat(e));delete this.callbackCapabilities[e];if(t.callback===a)r.resolve(t.data);else{if(t.callback!==i)throw new Error("Unexpected callback case");r.reject(wrapReason(t.reason))}return}const n=this.actionHandler[t.action];if(!n)throw new Error("Unknown action from worker: ".concat(t.action));if(t.callbackId){const e=this.sourceName,s=t.sourceName;new Promise((function(e){e(n(t.data))})).then((function(n){r.postMessage({sourceName:e,targetName:s,callback:a,callbackId:t.callbackId,data:n})}),(function(n){r.postMessage({sourceName:e,targetName:s,callback:i,callbackId:t.callbackId,reason:wrapReason(n)})}))}else t.streamId?this._createStreamSink(t):n(t.data)};r.addEventListener("message",this._onComObjOnMessage)}on(e,t){const r=this.actionHandler;if(r[e])throw new Error('There is already an actionName called "'.concat(e,'"'));r[e]=t}send(e,t,r){this.comObj.postMessage({sourceName:this.sourceName,targetName:this.targetName,action:e,data:t},r)}sendWithPromise(e,t,r){const a=this.callbackId++,i=(0,n.createPromiseCapability)();this.callbackCapabilities[a]=i;try{this.comObj.postMessage({sourceName:this.sourceName,targetName:this.targetName,action:e,callbackId:a,data:t},r)}catch(e){i.reject(e)}return i.promise}sendWithStream(e,t,r,a){const i=this.streamId++,o=this.sourceName,c=this.targetName,l=this.comObj;return new ReadableStream({start:r=>{const s=(0,n.createPromiseCapability)();this.streamControllers[i]={controller:r,startCall:s,pullCall:null,cancelCall:null,isClosed:!1};l.postMessage({sourceName:o,targetName:c,action:e,streamId:i,data:t,desiredSize:r.desiredSize},a);return s.promise},pull:e=>{const t=(0,n.createPromiseCapability)();this.streamControllers[i].pullCall=t;l.postMessage({sourceName:o,targetName:c,stream:u,streamId:i,desiredSize:e.desiredSize});return t.promise},cancel:e=>{(0,n.assert)(e instanceof Error,"cancel must have a valid reason");const t=(0,n.createPromiseCapability)();this.streamControllers[i].cancelCall=t;this.streamControllers[i].isClosed=!0;l.postMessage({sourceName:o,targetName:c,stream:s,streamId:i,reason:wrapReason(e)});return t.promise}},r)}_createStreamSink(e){const t=e.streamId,r=this.sourceName,a=e.sourceName,i=this.comObj,s=this,o=this.actionHandler[e.action],u={enqueue(e){let s=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,o=arguments.length>2?arguments[2]:void 0;if(this.isCancelled)return;const c=this.desiredSize;this.desiredSize-=s;if(c>0&&this.desiredSize<=0){this.sinkCapability=(0,n.createPromiseCapability)();this.ready=this.sinkCapability.promise}i.postMessage({sourceName:r,targetName:a,stream:l,streamId:t,chunk:e},o)},close(){if(!this.isCancelled){this.isCancelled=!0;i.postMessage({sourceName:r,targetName:a,stream:c,streamId:t});delete s.streamSinks[t]}},error(e){(0,n.assert)(e instanceof Error,"error must have a valid reason");if(!this.isCancelled){this.isCancelled=!0;i.postMessage({sourceName:r,targetName:a,stream:h,streamId:t,reason:wrapReason(e)})}},sinkCapability:(0,n.createPromiseCapability)(),onPull:null,onCancel:null,isCancelled:!1,desiredSize:e.desiredSize,ready:null};u.sinkCapability.resolve();u.ready=u.sinkCapability.promise;this.streamSinks[t]=u;new Promise((function(t){t(o(e.data,u))})).then((function(){i.postMessage({sourceName:r,targetName:a,stream:f,streamId:t,success:!0})}),(function(e){i.postMessage({sourceName:r,targetName:a,stream:f,streamId:t,reason:wrapReason(e)})}))}_processStreamMessage(e){const t=e.streamId,r=this.sourceName,a=e.sourceName,i=this.comObj,g=this.streamControllers[t],p=this.streamSinks[t];switch(e.stream){case f:e.success?g.startCall.resolve():g.startCall.reject(wrapReason(e.reason));break;case d:e.success?g.pullCall.resolve():g.pullCall.reject(wrapReason(e.reason));break;case u:if(!p){i.postMessage({sourceName:r,targetName:a,stream:d,streamId:t,success:!0});break}p.desiredSize<=0&&e.desiredSize>0&&p.sinkCapability.resolve();p.desiredSize=e.desiredSize;new Promise((function(e){e(p.onPull&&p.onPull())})).then((function(){i.postMessage({sourceName:r,targetName:a,stream:d,streamId:t,success:!0})}),(function(e){i.postMessage({sourceName:r,targetName:a,stream:d,streamId:t,reason:wrapReason(e)})}));break;case l:(0,n.assert)(g,"enqueue should have stream controller");if(g.isClosed)break;g.controller.enqueue(e.chunk);break;case c:(0,n.assert)(g,"close should have stream controller");if(g.isClosed)break;g.isClosed=!0;g.controller.close();this._deleteStreamController(g,t);break;case h:(0,n.assert)(g,"error should have stream controller");g.controller.error(wrapReason(e.reason));this._deleteStreamController(g,t);break;case o:e.success?g.cancelCall.resolve():g.cancelCall.reject(wrapReason(e.reason));this._deleteStreamController(g,t);break;case s:if(!p)break;new Promise((function(t){t(p.onCancel&&p.onCancel(wrapReason(e.reason)))})).then((function(){i.postMessage({sourceName:r,targetName:a,stream:o,streamId:t,success:!0})}),(function(e){i.postMessage({sourceName:r,targetName:a,stream:o,streamId:t,reason:wrapReason(e)})}));p.sinkCapability.reject(wrapReason(e.reason));p.isCancelled=!0;delete this.streamSinks[t];break;default:throw new Error("Unexpected stream case")}}async _deleteStreamController(e,t){await Promise.allSettled([e.startCall&&e.startCall.promise,e.pullCall&&e.pullCall.promise,e.cancelCall&&e.cancelCall.promise]);delete this.streamControllers[t]}destroy(){this.comObj.removeEventListener("message",this._onComObjOnMessage)}}},(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.PDFWorkerStream=void 0;r(112);r(2);var n=r(158);t.PDFWorkerStream=class PDFWorkerStream{constructor(e){this._msgHandler=e;this._contentLength=null;this._fullRequestReader=null;this._rangeRequestReaders=[]}getFullReader(){(0,n.assert)(!this._fullRequestReader,"PDFWorkerStream.getFullReader can only be called once.");this._fullRequestReader=new PDFWorkerStreamReader(this._msgHandler);return this._fullRequestReader}getRangeReader(e,t){const r=new PDFWorkerStreamRangeReader(e,t,this._msgHandler);this._rangeRequestReaders.push(r);return r}cancelAllRequests(e){this._fullRequestReader&&this._fullRequestReader.cancel(e);for(const t of this._rangeRequestReaders.slice(0))t.cancel(e)}};class PDFWorkerStreamReader{constructor(e){this._msgHandler=e;this.onProgress=null;this._contentLength=null;this._isRangeSupported=!1;this._isStreamingSupported=!1;const t=this._msgHandler.sendWithStream("GetReader");this._reader=t.getReader();this._headersReady=this._msgHandler.sendWithPromise("ReaderHeadersReady").then((e=>{this._isStreamingSupported=e.isStreamingSupported;this._isRangeSupported=e.isRangeSupported;this._contentLength=e.contentLength}))}get headersReady(){return this._headersReady}get contentLength(){return this._contentLength}get isStreamingSupported(){return this._isStreamingSupported}get isRangeSupported(){return this._isRangeSupported}async read(){const{value:e,done:t}=await this._reader.read();return t?{value:void 0,done:!0}:{value:e.buffer,done:!1}}cancel(e){this._reader.cancel(e)}}class PDFWorkerStreamRangeReader{constructor(e,t,r){this._msgHandler=r;this.onProgress=null;const n=this._msgHandler.sendWithStream("GetRangeReader",{begin:e,end:t});this._reader=n.getReader()}get isStreamingSupported(){return!1}async read(){const{value:e,done:t}=await this._reader.read();return t?{value:void 0,done:!0}:{value:e.buffer,done:!1}}cancel(e){this._reader.cancel(e)}}}],t={};function __w_pdfjs_require__(r){var n=t[r];if(void 0!==n)return n.exports;var a=t[r]={exports:{}};e[r](a,a.exports,__w_pdfjs_require__);return a.exports}__w_pdfjs_require__.d=(e,t)=>{for(var r in t)__w_pdfjs_require__.o(t,r)&&!__w_pdfjs_require__.o(e,r)&&Object.defineProperty(e,r,{enumerable:!0,get:t[r]})};__w_pdfjs_require__.o=(e,t)=>Object.prototype.hasOwnProperty.call(e,t);__w_pdfjs_require__.r=e=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"});Object.defineProperty(e,"__esModule",{value:!0})};var r={};(()=>{"use strict";var e=r;Object.defineProperty(e,"__esModule",{value:!0});Object.defineProperty(e,"WorkerMessageHandler",{enumerable:!0,get:function(){return t.WorkerMessageHandler}});var t=__w_pdfjs_require__(1)})();return r})()));